#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 2841
#define SYMBOL_COUNT 308
#define ALIAS_COUNT 8
#define TOKEN_COUNT 142
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 38
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  sym_jsx_text = 48,
  sym_jsx_identifier = 49,
  anon_sym_DOT = 50,
  anon_sym_class = 51,
  anon_sym_async = 52,
  anon_sym_function = 53,
  anon_sym_EQ_GT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_QMARK = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_GT_GT = 72,
  anon_sym_GT_GT_GT = 73,
  anon_sym_LT_LT = 74,
  anon_sym_AMP = 75,
  anon_sym_CARET = 76,
  anon_sym_PIPE = 77,
  anon_sym_PLUS = 78,
  anon_sym_DASH = 79,
  anon_sym_PERCENT = 80,
  anon_sym_STAR_STAR = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_EQ_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_BANG_EQ = 85,
  anon_sym_BANG_EQ_EQ = 86,
  anon_sym_GT_EQ = 87,
  anon_sym_instanceof = 88,
  anon_sym_BANG = 89,
  anon_sym_TILDE = 90,
  anon_sym_void = 91,
  anon_sym_delete = 92,
  anon_sym_PLUS_PLUS = 93,
  anon_sym_DASH_DASH = 94,
  anon_sym_DQUOTE = 95,
  aux_sym_string_token1 = 96,
  anon_sym_SQUOTE = 97,
  aux_sym_string_token2 = 98,
  sym_escape_sequence = 99,
  sym_comment = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_DOLLAR_LBRACE = 102,
  anon_sym_SLASH2 = 103,
  sym_regex_pattern = 104,
  sym_regex_flags = 105,
  sym_number = 106,
  anon_sym_target = 107,
  sym_this = 108,
  sym_super = 109,
  sym_true = 110,
  sym_false = 111,
  sym_null = 112,
  sym_undefined = 113,
  anon_sym_AT = 114,
  anon_sym_static = 115,
  anon_sym_abstract = 116,
  anon_sym_get = 117,
  anon_sym_set = 118,
  anon_sym_declare = 119,
  anon_sym_public = 120,
  anon_sym_private = 121,
  anon_sym_protected = 122,
  anon_sym_module = 123,
  anon_sym_any = 124,
  anon_sym_number = 125,
  anon_sym_boolean = 126,
  anon_sym_string = 127,
  anon_sym_symbol = 128,
  anon_sym_require = 129,
  anon_sym_implements = 130,
  anon_sym_global = 131,
  anon_sym_interface = 132,
  anon_sym_extends = 133,
  anon_sym_enum = 134,
  sym_readonly = 135,
  anon_sym_is = 136,
  anon_sym_keyof = 137,
  anon_sym_LBRACE_PIPE = 138,
  anon_sym_PIPE_RBRACE = 139,
  sym__automatic_semicolon = 140,
  sym__template_chars = 141,
  sym_program = 142,
  sym_export_statement = 143,
  sym_export_clause = 144,
  sym__import_export_specifier = 145,
  sym__declaration = 146,
  sym_import = 147,
  sym_import_statement = 148,
  sym_import_clause = 149,
  sym__from_clause = 150,
  sym_namespace_import = 151,
  sym_named_imports = 152,
  sym_expression_statement = 153,
  sym_variable_declaration = 154,
  sym_lexical_declaration = 155,
  sym_variable_declarator = 156,
  sym_statement_block = 157,
  sym_if_statement = 158,
  sym_switch_statement = 159,
  sym_for_statement = 160,
  sym_for_in_statement = 161,
  sym__for_header = 162,
  sym_while_statement = 163,
  sym_do_statement = 164,
  sym_try_statement = 165,
  sym_with_statement = 166,
  sym_break_statement = 167,
  sym_continue_statement = 168,
  sym_debugger_statement = 169,
  sym_return_statement = 170,
  sym_throw_statement = 171,
  sym_empty_statement = 172,
  sym_labeled_statement = 173,
  sym_switch_body = 174,
  sym_switch_case = 175,
  sym_switch_default = 176,
  sym_catch_clause = 177,
  sym_finally_clause = 178,
  sym_parenthesized_expression = 179,
  sym__expression = 180,
  sym_yield_expression = 181,
  sym_object = 182,
  sym_assignment_pattern = 183,
  sym_array = 184,
  sym_jsx_element = 185,
  sym_jsx_fragment = 186,
  sym_jsx_expression = 187,
  sym_jsx_opening_element = 188,
  sym_nested_identifier = 189,
  sym_jsx_namespace_name = 190,
  sym_jsx_closing_element = 191,
  sym_jsx_self_closing_element = 192,
  sym_jsx_attribute = 193,
  sym_class = 194,
  sym_class_declaration = 195,
  sym_class_heritage = 196,
  sym_function = 197,
  sym_function_declaration = 198,
  sym_generator_function = 199,
  sym_generator_function_declaration = 200,
  sym_arrow_function = 201,
  sym__call_signature = 202,
  sym_call_expression = 203,
  sym_new_expression = 204,
  sym_await_expression = 205,
  sym_member_expression = 206,
  sym_subscript_expression = 207,
  sym_assignment_expression = 208,
  sym_augmented_assignment_expression = 209,
  sym__initializer = 210,
  sym_spread_element = 211,
  sym_ternary_expression = 212,
  sym_binary_expression = 213,
  sym_unary_expression = 214,
  sym_update_expression = 215,
  sym_sequence_expression = 216,
  sym_string = 217,
  sym_template_string = 218,
  sym_template_substitution = 219,
  sym_regex = 220,
  sym_meta_property = 221,
  sym_arguments = 222,
  sym_decorator = 223,
  sym_decorator_member_expression = 224,
  sym_decorator_call_expression = 225,
  sym_class_body = 226,
  sym_public_field_definition = 227,
  sym_formal_parameters = 228,
  sym_rest_parameter = 229,
  sym_method_definition = 230,
  sym_pair = 231,
  sym__property_name = 232,
  sym_computed_property_name = 233,
  sym_non_null_expression = 234,
  sym_method_signature = 235,
  sym_abstract_method_signature = 236,
  sym_function_signature = 237,
  sym_as_expression = 238,
  sym_import_require_clause = 239,
  sym_implements_clause = 240,
  sym_ambient_declaration = 241,
  sym_abstract_class_declaration = 242,
  sym_module = 243,
  sym_internal_module = 244,
  sym__module = 245,
  sym_import_alias = 246,
  sym_nested_type_identifier = 247,
  sym_interface_declaration = 248,
  sym_extends_clause = 249,
  sym_enum_declaration = 250,
  sym_enum_body = 251,
  sym_enum_assignment = 252,
  sym_type_alias_declaration = 253,
  sym_accessibility_modifier = 254,
  sym_required_parameter = 255,
  sym_optional_parameter = 256,
  sym__parameter_name = 257,
  sym_type_annotation = 258,
  sym__type = 259,
  sym_constructor_type = 260,
  sym__primary_type = 261,
  sym_generic_type = 262,
  sym_type_predicate = 263,
  sym_type_query = 264,
  sym_index_type_query = 265,
  sym_lookup_type = 266,
  sym_mapped_type_clause = 267,
  sym_literal_type = 268,
  sym__number = 269,
  sym_existential_type = 270,
  sym_flow_maybe_type = 271,
  sym_parenthesized_type = 272,
  sym_predefined_type = 273,
  sym_type_arguments = 274,
  sym_object_type = 275,
  sym_property_signature = 276,
  sym_type_parameters = 277,
  sym_type_parameter = 278,
  sym_default_type = 279,
  sym_constraint = 280,
  sym_construct_signature = 281,
  sym_index_signature = 282,
  sym_array_type = 283,
  sym_tuple_type = 284,
  sym_union_type = 285,
  sym_intersection_type = 286,
  sym_function_type = 287,
  aux_sym_program_repeat1 = 288,
  aux_sym_export_statement_repeat1 = 289,
  aux_sym_export_clause_repeat1 = 290,
  aux_sym_named_imports_repeat1 = 291,
  aux_sym_variable_declaration_repeat1 = 292,
  aux_sym_switch_body_repeat1 = 293,
  aux_sym_object_repeat1 = 294,
  aux_sym_array_repeat1 = 295,
  aux_sym_jsx_element_repeat1 = 296,
  aux_sym_jsx_opening_element_repeat1 = 297,
  aux_sym_string_repeat1 = 298,
  aux_sym_string_repeat2 = 299,
  aux_sym_template_string_repeat1 = 300,
  aux_sym_class_body_repeat1 = 301,
  aux_sym_formal_parameters_repeat1 = 302,
  aux_sym_implements_clause_repeat1 = 303,
  aux_sym_extends_clause_repeat1 = 304,
  aux_sym_enum_body_repeat1 = 305,
  aux_sym_object_type_repeat1 = 306,
  aux_sym_type_parameters_repeat1 = 307,
  alias_sym_type_identifier = 308,
  alias_sym_array_pattern = 309,
  alias_sym_shorthand_property_identifier = 310,
  alias_sym_property_identifier = 311,
  alias_sym_object_pattern = 312,
  alias_sym_import_specifier = 313,
  alias_sym_export_specifier = 314,
  alias_sym_statement_identifier = 315,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_module = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_source = 34,
  field_type = 35,
  field_type_arguments = 36,
  field_type_parameters = 37,
  field_value = 38,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 2},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 4, .length = 1},
  [8] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 2},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 1},
  [16] = {.index = 10, .length = 1},
  [17] = {.index = 10, .length = 1},
  [18] = {.index = 11, .length = 1},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 2},
  [26] = {.index = 26, .length = 1},
  [27] = {.index = 27, .length = 2},
  [28] = {.index = 22, .length = 2},
  [29] = {.index = 24, .length = 2},
  [30] = {.index = 27, .length = 2},
  [31] = {.index = 5, .length = 2},
  [32] = {.index = 29, .length = 1},
  [33] = {.index = 30, .length = 2},
  [34] = {.index = 32, .length = 2},
  [35] = {.index = 30, .length = 2},
  [36] = {.index = 32, .length = 2},
  [37] = {.index = 30, .length = 2},
  [38] = {.index = 32, .length = 2},
  [39] = {.index = 34, .length = 3},
  [40] = {.index = 37, .length = 2},
  [41] = {.index = 37, .length = 2},
  [42] = {.index = 39, .length = 2},
  [43] = {.index = 41, .length = 2},
  [44] = {.index = 43, .length = 3},
  [46] = {.index = 46, .length = 1},
  [47] = {.index = 47, .length = 2},
  [49] = {.index = 49, .length = 2},
  [52] = {.index = 51, .length = 1},
  [53] = {.index = 52, .length = 2},
  [54] = {.index = 54, .length = 2},
  [55] = {.index = 56, .length = 2},
  [56] = {.index = 58, .length = 1},
  [57] = {.index = 59, .length = 1},
  [58] = {.index = 60, .length = 1},
  [59] = {.index = 61, .length = 4},
  [60] = {.index = 65, .length = 2},
  [61] = {.index = 65, .length = 2},
  [62] = {.index = 67, .length = 2},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 24, .length = 2},
  [65] = {.index = 72, .length = 2},
  [66] = {.index = 74, .length = 4},
  [67] = {.index = 78, .length = 3},
  [68] = {.index = 24, .length = 2},
  [69] = {.index = 81, .length = 2},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 3},
  [72] = {.index = 87, .length = 2},
  [73] = {.index = 84, .length = 3},
  [74] = {.index = 84, .length = 3},
  [75] = {.index = 89, .length = 2},
  [76] = {.index = 91, .length = 2},
  [77] = {.index = 93, .length = 3},
  [78] = {.index = 87, .length = 2},
  [79] = {.index = 96, .length = 2},
  [80] = {.index = 98, .length = 1},
  [81] = {.index = 99, .length = 3},
  [82] = {.index = 102, .length = 4},
  [83] = {.index = 106, .length = 2},
  [84] = {.index = 24, .length = 2},
  [85] = {.index = 108, .length = 2},
  [86] = {.index = 110, .length = 5},
  [87] = {.index = 115, .length = 1},
  [91] = {.index = 116, .length = 2},
  [92] = {.index = 116, .length = 2},
  [93] = {.index = 118, .length = 4},
  [94] = {.index = 122, .length = 4},
  [95] = {.index = 126, .length = 3},
  [96] = {.index = 129, .length = 2},
  [97] = {.index = 131, .length = 2},
  [98] = {.index = 133, .length = 2},
  [99] = {.index = 135, .length = 2},
  [100] = {.index = 137, .length = 4},
  [101] = {.index = 141, .length = 5},
  [102] = {.index = 146, .length = 1},
  [103] = {.index = 96, .length = 2},
  [104] = {.index = 147, .length = 1},
  [105] = {.index = 148, .length = 3},
  [106] = {.index = 151, .length = 2},
  [107] = {.index = 153, .length = 3},
  [108] = {.index = 156, .length = 2},
  [109] = {.index = 158, .length = 3},
  [110] = {.index = 161, .length = 3},
  [111] = {.index = 164, .length = 2},
  [112] = {.index = 166, .length = 3},
  [113] = {.index = 169, .length = 2},
  [114] = {.index = 171, .length = 1},
  [115] = {.index = 172, .length = 2},
  [116] = {.index = 174, .length = 1},
  [117] = {.index = 175, .length = 2},
  [118] = {.index = 177, .length = 2},
  [119] = {.index = 179, .length = 4},
  [120] = {.index = 183, .length = 2},
  [121] = {.index = 185, .length = 2},
  [122] = {.index = 187, .length = 5},
  [123] = {.index = 192, .length = 1},
  [124] = {.index = 193, .length = 1},
  [125] = {.index = 194, .length = 1},
  [126] = {.index = 195, .length = 4},
  [127] = {.index = 199, .length = 5},
  [128] = {.index = 204, .length = 4},
  [129] = {.index = 208, .length = 3},
  [130] = {.index = 211, .length = 2},
  [131] = {.index = 213, .length = 3},
  [132] = {.index = 216, .length = 2},
  [133] = {.index = 218, .length = 3},
  [134] = {.index = 221, .length = 4},
  [135] = {.index = 225, .length = 3},
  [136] = {.index = 228, .length = 6},
  [137] = {.index = 234, .length = 3},
  [138] = {.index = 237, .length = 3},
  [139] = {.index = 240, .length = 2},
  [140] = {.index = 242, .length = 2},
  [141] = {.index = 242, .length = 2},
  [142] = {.index = 244, .length = 3},
  [143] = {.index = 242, .length = 2},
  [144] = {.index = 242, .length = 2},
  [145] = {.index = 247, .length = 4},
  [146] = {.index = 251, .length = 2},
  [147] = {.index = 253, .length = 2},
  [148] = {.index = 255, .length = 2},
  [149] = {.index = 257, .length = 2},
  [150] = {.index = 259, .length = 3},
  [151] = {.index = 262, .length = 1},
  [152] = {.index = 263, .length = 3},
  [154] = {.index = 266, .length = 5},
  [155] = {.index = 271, .length = 2},
  [156] = {.index = 273, .length = 5},
  [157] = {.index = 278, .length = 4},
  [158] = {.index = 282, .length = 2},
  [159] = {.index = 282, .length = 2},
  [160] = {.index = 282, .length = 2},
  [161] = {.index = 282, .length = 2},
  [162] = {.index = 284, .length = 4},
  [163] = {.index = 288, .length = 4},
  [164] = {.index = 292, .length = 2},
  [165] = {.index = 294, .length = 2},
  [166] = {.index = 296, .length = 3},
  [167] = {.index = 299, .length = 3},
  [168] = {.index = 302, .length = 4},
  [169] = {.index = 306, .length = 2},
  [170] = {.index = 308, .length = 2},
  [171] = {.index = 310, .length = 5},
  [172] = {.index = 315, .length = 2},
  [173] = {.index = 315, .length = 2},
  [174] = {.index = 315, .length = 2},
  [175] = {.index = 317, .length = 3},
  [176] = {.index = 320, .length = 3},
  [177] = {.index = 323, .length = 4},
  [178] = {.index = 327, .length = 4},
  [179] = {.index = 331, .length = 2},
  [180] = {.index = 333, .length = 2},
  [181] = {.index = 335, .length = 3},
  [182] = {.index = 338, .length = 5},
  [183] = {.index = 343, .length = 5},
  [184] = {.index = 348, .length = 4},
  [185] = {.index = 352, .length = 4},
  [186] = {.index = 356, .length = 3},
  [187] = {.index = 359, .length = 5},
  [188] = {.index = 364, .length = 5},
  [189] = {.index = 369, .length = 4},
  [190] = {.index = 373, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_parameters, 0},
  [1] =
    {field_decorator, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_name, 0},
  [5] =
    {field_arguments, 1},
    {field_function, 0},
  [7] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [9] =
    {field_body, 1},
  [10] =
    {field_constructor, 1},
  [11] =
    {field_declaration, 1},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_parameters, 0},
    {field_return_type, 1},
  [20] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [22] =
    {field_body, 2},
    {field_parameter, 0},
  [24] =
    {field_left, 0},
    {field_right, 2},
  [26] =
    {field_label, 0},
  [27] =
    {field_object, 0},
    {field_property, 2},
  [29] =
    {field_label, 1},
  [30] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [32] =
    {field_name, 0},
    {field_type, 1},
  [34] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [37] =
    {field_body, 2},
    {field_name, 1},
  [39] =
    {field_condition, 1},
    {field_consequence, 2},
  [41] =
    {field_body, 1},
    {field_name, 0},
  [43] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [46] =
    {field_body, 2},
  [47] =
    {field_body, 2},
    {field_type_parameters, 1},
  [49] =
    {field_body, 2},
    {field_value, 1},
  [51] =
    {field_value, 1, .inherited = true},
  [52] =
    {field_body, 2},
    {field_condition, 1},
  [54] =
    {field_body, 1},
    {field_handler, 2},
  [56] =
    {field_body, 1},
    {field_finalizer, 2},
  [58] =
    {field_name, 1},
  [59] =
    {field_attribute, 0},
  [60] =
    {field_pattern, 1},
  [61] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [65] =
    {field_arguments, 2},
    {field_constructor, 1},
  [67] =
    {field_body, 2},
    {field_object, 1},
  [69] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [72] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [74] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [78] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [81] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [83] =
    {field_value, 1},
  [84] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [87] =
    {field_body, 3},
    {field_name, 2},
  [89] =
    {field_index, 2},
    {field_object, 0},
  [91] =
    {field_body, 3},
    {field_name, 1},
  [93] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [96] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [98] =
    {field_source, 1},
  [99] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [102] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [106] =
    {field_body, 3},
    {field_type_parameters, 1},
  [108] =
    {field_key, 0},
    {field_value, 2},
  [110] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [115] =
    {field_value, 2, .inherited = true},
  [116] =
    {field_body, 3},
    {field_parameter, 1},
  [118] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [122] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [126] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [129] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [131] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [133] =
    {field_name, 1},
    {field_type_arguments, 2},
  [135] =
    {field_flags, 3},
    {field_pattern, 1},
  [137] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [141] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [146] =
    {field_source, 2, .inherited = true},
  [147] =
    {field_value, 2},
  [148] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [151] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [153] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [156] =
    {field_module, 0},
    {field_name, 2},
  [158] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [161] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [164] =
    {field_body, 4},
    {field_name, 2},
  [166] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [169] =
    {field_name, 1},
    {field_value, 3},
  [171] =
    {field_source, 3, .inherited = true},
  [172] =
    {field_alias, 2},
    {field_name, 0},
  [174] =
    {field_name, 2},
  [175] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [177] =
    {field_name, 1},
    {field_type, 2},
  [179] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [183] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [185] =
    {field_name, 0},
    {field_type, 2},
  [187] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [192] =
    {field_decorator, 1, .inherited = true},
  [193] =
    {field_decorator, 2, .inherited = true},
  [194] =
    {field_value, 3, .inherited = true},
  [195] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [199] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [204] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [208] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [211] =
    {field_body, 1},
    {field_condition, 3},
  [213] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [216] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [218] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [221] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [225] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [228] =
    {field_parameters, 0, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [234] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [237] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [240] =
    {field_alias, 3},
    {field_name, 1},
  [242] =
    {field_left, 1},
    {field_right, 3},
  [244] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [247] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [251] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [253] =
    {field_name, 2},
    {field_type, 3},
  [255] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [257] =
    {field_name, 1},
    {field_type, 3},
  [259] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [262] =
    {field_name, 3},
  [263] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [266] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [271] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [273] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [278] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [282] =
    {field_left, 2},
    {field_right, 4},
  [284] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [288] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [292] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [294] =
    {field_name, 2},
    {field_type, 4},
  [296] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [299] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [302] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [306] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [308] =
    {field_name, 3},
    {field_type, 4},
  [310] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [315] =
    {field_body, 4},
    {field_parameter, 2},
  [317] =
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [320] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [323] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [327] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [331] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [333] =
    {field_name, 3},
    {field_type, 5},
  [335] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [338] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [343] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [348] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [352] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [356] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [359] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [364] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [369] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [373] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[191][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_identifier,
  },
  [4] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_object_pattern,
  },
  [8] = {
    [0] = alias_sym_array_pattern,
  },
  [12] = {
    [0] = alias_sym_property_identifier,
  },
  [13] = {
    [0] = alias_sym_object_pattern,
  },
  [14] = {
    [0] = alias_sym_array_pattern,
  },
  [15] = {
    [0] = alias_sym_type_identifier,
  },
  [17] = {
    [1] = sym_identifier,
  },
  [26] = {
    [0] = alias_sym_statement_identifier,
  },
  [27] = {
    [2] = alias_sym_property_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [0] = sym_identifier,
  },
  [30] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [31] = {
    [0] = sym_identifier,
  },
  [32] = {
    [1] = alias_sym_statement_identifier,
  },
  [35] = {
    [0] = alias_sym_object_pattern,
  },
  [36] = {
    [0] = alias_sym_object_pattern,
  },
  [37] = {
    [0] = alias_sym_array_pattern,
  },
  [38] = {
    [0] = alias_sym_array_pattern,
  },
  [40] = {
    [1] = alias_sym_type_identifier,
  },
  [45] = {
    [1] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [50] = {
    [1] = alias_sym_object_pattern,
  },
  [51] = {
    [1] = alias_sym_array_pattern,
  },
  [61] = {
    [1] = sym_identifier,
  },
  [64] = {
    [0] = alias_sym_array_pattern,
  },
  [68] = {
    [0] = alias_sym_object_pattern,
  },
  [73] = {
    [0] = alias_sym_object_pattern,
  },
  [74] = {
    [0] = alias_sym_array_pattern,
  },
  [76] = {
    [1] = alias_sym_type_identifier,
  },
  [77] = {
    [1] = alias_sym_type_identifier,
  },
  [78] = {
    [2] = alias_sym_type_identifier,
  },
  [79] = {
    [1] = alias_sym_import_specifier,
  },
  [84] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [88] = {
    [2] = sym_identifier,
  },
  [89] = {
    [2] = alias_sym_object_pattern,
  },
  [90] = {
    [2] = alias_sym_array_pattern,
  },
  [92] = {
    [1] = sym_identifier,
  },
  [103] = {
    [1] = alias_sym_export_specifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [108] = {
    [2] = alias_sym_type_identifier,
  },
  [109] = {
    [1] = alias_sym_type_identifier,
  },
  [111] = {
    [2] = alias_sym_type_identifier,
  },
  [112] = {
    [2] = alias_sym_type_identifier,
  },
  [113] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [138] = {
    [1] = alias_sym_type_identifier,
  },
  [141] = {
    [1] = sym_identifier,
  },
  [143] = {
    [1] = alias_sym_object_pattern,
  },
  [144] = {
    [1] = alias_sym_array_pattern,
  },
  [153] = {
    [3] = alias_sym_property_identifier,
  },
  [157] = {
    [2] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = sym_identifier,
  },
  [160] = {
    [2] = alias_sym_object_pattern,
  },
  [161] = {
    [2] = alias_sym_array_pattern,
  },
  [173] = {
    [2] = alias_sym_object_pattern,
  },
  [174] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0) ADVANCE(59);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(12);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(77);
      if (lookahead == '=') ADVANCE(64);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 1:
      if (lookahead == 0) ADVANCE(59);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(12);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(77);
      if (lookahead == '=') ADVANCE(64);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 2:
      if (lookahead == 0) ADVANCE(59);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(78);
      if (lookahead == '=') ADVANCE(64);
      if (lookahead == '>') ADVANCE(81);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(188);
      END_STATE();
    case 3:
      if (lookahead == 0) ADVANCE(59);
      if (lookahead == '!') ADVANCE(142);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(12);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(65);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          (lookahead < '%' || '^' < lookahead)) ADVANCE(188);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(14)
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(152);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(148);
      if (lookahead == '\r') ADVANCE(162);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(159);
      if (lookahead != 0) ADVANCE(160);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(155);
      if (lookahead == '\r') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(173);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(83);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(77);
      if (lookahead == '=') ADVANCE(64);
      if (lookahead == '>') ADVANCE(80);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(188);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(78);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(81);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(78);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(81);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(60);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '0') ADVANCE(177);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(188);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '$') ADVANCE(30);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 16:
      if (lookahead == '$') ADVANCE(30);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '`') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(169);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(106);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 26:
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == 'u') ADVANCE(31);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 28:
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 30:
      if (lookahead == '{') ADVANCE(171);
      END_STATE();
    case 31:
      if (lookahead == '{') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 38:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(179);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(188);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 58:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(135);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(134);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(190);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(169);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(20);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(20);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(113);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(108);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(145);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(145);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(146);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(151);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(158);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(148);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(155);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(161);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(165);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(169);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(28);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(185);
      if (lookahead == '0') ADVANCE(182);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(39);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(46);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(185);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(176);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '{') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 3},
  [2] = {.lex_state = 9, .external_lex_state = 2},
  [3] = {.lex_state = 15, .external_lex_state = 3},
  [4] = {.lex_state = 0, .external_lex_state = 2},
  [5] = {.lex_state = 9, .external_lex_state = 2},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 9, .external_lex_state = 2},
  [9] = {.lex_state = 3, .external_lex_state = 2},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 2, .external_lex_state = 2},
  [12] = {.lex_state = 3, .external_lex_state = 2},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3, .external_lex_state = 2},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 2, .external_lex_state = 2},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 9, .external_lex_state = 2},
  [23] = {.lex_state = 2, .external_lex_state = 2},
  [24] = {.lex_state = 9, .external_lex_state = 2},
  [25] = {.lex_state = 4},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 9, .external_lex_state = 2},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 9, .external_lex_state = 2},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 3},
  [36] = {.lex_state = 9, .external_lex_state = 2},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 6},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 8},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 3},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 9, .external_lex_state = 2},
  [48] = {.lex_state = 3},
  [49] = {.lex_state = 0},
  [50] = {.lex_state = 3},
  [51] = {.lex_state = 2, .external_lex_state = 2},
  [52] = {.lex_state = 2, .external_lex_state = 2},
  [53] = {.lex_state = 9, .external_lex_state = 2},
  [54] = {.lex_state = 2, .external_lex_state = 2},
  [55] = {.lex_state = 24},
  [56] = {.lex_state = 2, .external_lex_state = 2},
  [57] = {.lex_state = 0, .external_lex_state = 2},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 3},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 2, .external_lex_state = 2},
  [65] = {.lex_state = 3},
  [66] = {.lex_state = 3},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 3},
  [72] = {.lex_state = 2, .external_lex_state = 2},
  [73] = {.lex_state = 15, .external_lex_state = 3},
  [74] = {.lex_state = 3},
  [75] = {.lex_state = 3},
  [76] = {.lex_state = 3},
  [77] = {.lex_state = 3},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 3},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 3},
  [82] = {.lex_state = 9, .external_lex_state = 2},
  [83] = {.lex_state = 9, .external_lex_state = 2},
  [84] = {.lex_state = 3},
  [85] = {.lex_state = 3},
  [86] = {.lex_state = 9, .external_lex_state = 2},
  [87] = {.lex_state = 9, .external_lex_state = 2},
  [88] = {.lex_state = 3},
  [89] = {.lex_state = 2, .external_lex_state = 2},
  [90] = {.lex_state = 9, .external_lex_state = 2},
  [91] = {.lex_state = 2, .external_lex_state = 2},
  [92] = {.lex_state = 3},
  [93] = {.lex_state = 2, .external_lex_state = 2},
  [94] = {.lex_state = 3},
  [95] = {.lex_state = 0, .external_lex_state = 2},
  [96] = {.lex_state = 0, .external_lex_state = 2},
  [97] = {.lex_state = 3},
  [98] = {.lex_state = 0, .external_lex_state = 2},
  [99] = {.lex_state = 0, .external_lex_state = 2},
  [100] = {.lex_state = 0, .external_lex_state = 2},
  [101] = {.lex_state = 3},
  [102] = {.lex_state = 13},
  [103] = {.lex_state = 3},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 2, .external_lex_state = 2},
  [106] = {.lex_state = 3},
  [107] = {.lex_state = 0, .external_lex_state = 2},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 3},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 3},
  [112] = {.lex_state = 0, .external_lex_state = 2},
  [113] = {.lex_state = 2, .external_lex_state = 2},
  [114] = {.lex_state = 3},
  [115] = {.lex_state = 3},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 2, .external_lex_state = 2},
  [118] = {.lex_state = 0, .external_lex_state = 2},
  [119] = {.lex_state = 2, .external_lex_state = 2},
  [120] = {.lex_state = 3},
  [121] = {.lex_state = 3},
  [122] = {.lex_state = 3},
  [123] = {.lex_state = 3},
  [124] = {.lex_state = 3},
  [125] = {.lex_state = 3},
  [126] = {.lex_state = 3},
  [127] = {.lex_state = 0, .external_lex_state = 2},
  [128] = {.lex_state = 3},
  [129] = {.lex_state = 2, .external_lex_state = 2},
  [130] = {.lex_state = 2, .external_lex_state = 2},
  [131] = {.lex_state = 2, .external_lex_state = 2},
  [132] = {.lex_state = 2, .external_lex_state = 2},
  [133] = {.lex_state = 4},
  [134] = {.lex_state = 2, .external_lex_state = 2},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 0},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 2, .external_lex_state = 2},
  [141] = {.lex_state = 2},
  [142] = {.lex_state = 0},
  [143] = {.lex_state = 0},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 13},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 0},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 2, .external_lex_state = 2},
  [153] = {.lex_state = 0},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 0},
  [159] = {.lex_state = 3},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 3},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 9, .external_lex_state = 2},
  [167] = {.lex_state = 9, .external_lex_state = 2},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 9, .external_lex_state = 2},
  [171] = {.lex_state = 9, .external_lex_state = 2},
  [172] = {.lex_state = 9, .external_lex_state = 2},
  [173] = {.lex_state = 9, .external_lex_state = 2},
  [174] = {.lex_state = 2, .external_lex_state = 2},
  [175] = {.lex_state = 9, .external_lex_state = 2},
  [176] = {.lex_state = 9, .external_lex_state = 2},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 9, .external_lex_state = 2},
  [180] = {.lex_state = 9, .external_lex_state = 2},
  [181] = {.lex_state = 9, .external_lex_state = 2},
  [182] = {.lex_state = 2, .external_lex_state = 2},
  [183] = {.lex_state = 9, .external_lex_state = 2},
  [184] = {.lex_state = 0},
  [185] = {.lex_state = 2, .external_lex_state = 2},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 3},
  [188] = {.lex_state = 2, .external_lex_state = 2},
  [189] = {.lex_state = 0},
  [190] = {.lex_state = 3},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 9},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 9},
  [195] = {.lex_state = 3},
  [196] = {.lex_state = 9},
  [197] = {.lex_state = 9},
  [198] = {.lex_state = 9},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 2},
  [201] = {.lex_state = 9},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 0},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 2},
  [206] = {.lex_state = 2},
  [207] = {.lex_state = 3},
  [208] = {.lex_state = 3},
  [209] = {.lex_state = 2},
  [210] = {.lex_state = 0},
  [211] = {.lex_state = 0},
  [212] = {.lex_state = 3},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 0, .external_lex_state = 2},
  [216] = {.lex_state = 3},
  [217] = {.lex_state = 3},
  [218] = {.lex_state = 6},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 24},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 0},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 3},
  [227] = {.lex_state = 15},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 3},
  [230] = {.lex_state = 0},
  [231] = {.lex_state = 9, .external_lex_state = 2},
  [232] = {.lex_state = 2, .external_lex_state = 2},
  [233] = {.lex_state = 3},
  [234] = {.lex_state = 9, .external_lex_state = 2},
  [235] = {.lex_state = 9, .external_lex_state = 2},
  [236] = {.lex_state = 9, .external_lex_state = 2},
  [237] = {.lex_state = 9, .external_lex_state = 2},
  [238] = {.lex_state = 9, .external_lex_state = 2},
  [239] = {.lex_state = 2},
  [240] = {.lex_state = 2, .external_lex_state = 2},
  [241] = {.lex_state = 2, .external_lex_state = 2},
  [242] = {.lex_state = 2, .external_lex_state = 2},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 3},
  [247] = {.lex_state = 3},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 3},
  [250] = {.lex_state = 3, .external_lex_state = 2},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 2, .external_lex_state = 2},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 3},
  [256] = {.lex_state = 3},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 13},
  [263] = {.lex_state = 2, .external_lex_state = 2},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 2, .external_lex_state = 2},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 24},
  [271] = {.lex_state = 2, .external_lex_state = 2},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 0},
  [274] = {.lex_state = 13},
  [275] = {.lex_state = 0},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 2, .external_lex_state = 2},
  [282] = {.lex_state = 2, .external_lex_state = 2},
  [283] = {.lex_state = 2, .external_lex_state = 2},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 2, .external_lex_state = 2},
  [286] = {.lex_state = 9, .external_lex_state = 2},
  [287] = {.lex_state = 0},
  [288] = {.lex_state = 2},
  [289] = {.lex_state = 2, .external_lex_state = 2},
  [290] = {.lex_state = 15, .external_lex_state = 3},
  [291] = {.lex_state = 2, .external_lex_state = 2},
  [292] = {.lex_state = 2, .external_lex_state = 2},
  [293] = {.lex_state = 2, .external_lex_state = 2},
  [294] = {.lex_state = 2, .external_lex_state = 2},
  [295] = {.lex_state = 9, .external_lex_state = 2},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 2, .external_lex_state = 2},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 0},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 0, .external_lex_state = 2},
  [316] = {.lex_state = 0, .external_lex_state = 2},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 0, .external_lex_state = 2},
  [319] = {.lex_state = 0, .external_lex_state = 2},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 0, .external_lex_state = 2},
  [323] = {.lex_state = 0, .external_lex_state = 2},
  [324] = {.lex_state = 0, .external_lex_state = 2},
  [325] = {.lex_state = 0},
  [326] = {.lex_state = 2},
  [327] = {.lex_state = 3},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 13},
  [330] = {.lex_state = 3},
  [331] = {.lex_state = 13},
  [332] = {.lex_state = 13},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 3},
  [335] = {.lex_state = 0},
  [336] = {.lex_state = 3},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 3},
  [339] = {.lex_state = 13},
  [340] = {.lex_state = 13},
  [341] = {.lex_state = 0},
  [342] = {.lex_state = 3},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 3},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 0},
  [347] = {.lex_state = 2, .external_lex_state = 2},
  [348] = {.lex_state = 2},
  [349] = {.lex_state = 0},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 2, .external_lex_state = 2},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 3},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 3},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 2, .external_lex_state = 2},
  [361] = {.lex_state = 3},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 13},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 0, .external_lex_state = 2},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 3},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 3},
  [379] = {.lex_state = 2, .external_lex_state = 2},
  [380] = {.lex_state = 2, .external_lex_state = 2},
  [381] = {.lex_state = 4},
  [382] = {.lex_state = 9, .external_lex_state = 2},
  [383] = {.lex_state = 9, .external_lex_state = 2},
  [384] = {.lex_state = 9, .external_lex_state = 2},
  [385] = {.lex_state = 3},
  [386] = {.lex_state = 9, .external_lex_state = 2},
  [387] = {.lex_state = 3},
  [388] = {.lex_state = 9, .external_lex_state = 2},
  [389] = {.lex_state = 9, .external_lex_state = 2},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 2, .external_lex_state = 2},
  [392] = {.lex_state = 2, .external_lex_state = 2},
  [393] = {.lex_state = 3},
  [394] = {.lex_state = 3},
  [395] = {.lex_state = 3},
  [396] = {.lex_state = 2},
  [397] = {.lex_state = 2},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 2, .external_lex_state = 2},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 9},
  [403] = {.lex_state = 3},
  [404] = {.lex_state = 2},
  [405] = {.lex_state = 3},
  [406] = {.lex_state = 3},
  [407] = {.lex_state = 2, .external_lex_state = 2},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 3},
  [410] = {.lex_state = 3},
  [411] = {.lex_state = 3, .external_lex_state = 2},
  [412] = {.lex_state = 3, .external_lex_state = 2},
  [413] = {.lex_state = 3, .external_lex_state = 2},
  [414] = {.lex_state = 3},
  [415] = {.lex_state = 2, .external_lex_state = 2},
  [416] = {.lex_state = 3},
  [417] = {.lex_state = 3},
  [418] = {.lex_state = 3},
  [419] = {.lex_state = 3, .external_lex_state = 2},
  [420] = {.lex_state = 3, .external_lex_state = 2},
  [421] = {.lex_state = 0, .external_lex_state = 2},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 3, .external_lex_state = 2},
  [424] = {.lex_state = 3},
  [425] = {.lex_state = 3, .external_lex_state = 2},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 2, .external_lex_state = 2},
  [428] = {.lex_state = 2, .external_lex_state = 2},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 2, .external_lex_state = 2},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 3},
  [443] = {.lex_state = 3},
  [444] = {.lex_state = 3},
  [445] = {.lex_state = 3},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 3},
  [449] = {.lex_state = 3},
  [450] = {.lex_state = 3},
  [451] = {.lex_state = 3},
  [452] = {.lex_state = 3},
  [453] = {.lex_state = 3},
  [454] = {.lex_state = 3},
  [455] = {.lex_state = 2},
  [456] = {.lex_state = 3},
  [457] = {.lex_state = 3},
  [458] = {.lex_state = 3},
  [459] = {.lex_state = 3},
  [460] = {.lex_state = 2, .external_lex_state = 2},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 3},
  [463] = {.lex_state = 3},
  [464] = {.lex_state = 3},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 3, .external_lex_state = 2},
  [467] = {.lex_state = 3},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 3},
  [470] = {.lex_state = 3},
  [471] = {.lex_state = 3},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 3},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 0},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 9, .external_lex_state = 2},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 3},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 3},
  [492] = {.lex_state = 3},
  [493] = {.lex_state = 3},
  [494] = {.lex_state = 3},
  [495] = {.lex_state = 3},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 3},
  [498] = {.lex_state = 3},
  [499] = {.lex_state = 0, .external_lex_state = 2},
  [500] = {.lex_state = 3},
  [501] = {.lex_state = 6},
  [502] = {.lex_state = 3, .external_lex_state = 2},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 3},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 3},
  [508] = {.lex_state = 24},
  [509] = {.lex_state = 13},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 13},
  [512] = {.lex_state = 13},
  [513] = {.lex_state = 24},
  [514] = {.lex_state = 0},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 3},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 3},
  [519] = {.lex_state = 0},
  [520] = {.lex_state = 3},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 10, .external_lex_state = 2},
  [526] = {.lex_state = 0, .external_lex_state = 2},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 2, .external_lex_state = 2},
  [530] = {.lex_state = 2, .external_lex_state = 2},
  [531] = {.lex_state = 2, .external_lex_state = 2},
  [532] = {.lex_state = 2, .external_lex_state = 2},
  [533] = {.lex_state = 2, .external_lex_state = 2},
  [534] = {.lex_state = 0, .external_lex_state = 2},
  [535] = {.lex_state = 3, .external_lex_state = 2},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 9, .external_lex_state = 2},
  [539] = {.lex_state = 2, .external_lex_state = 2},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 2, .external_lex_state = 2},
  [545] = {.lex_state = 2, .external_lex_state = 2},
  [546] = {.lex_state = 2, .external_lex_state = 2},
  [547] = {.lex_state = 2, .external_lex_state = 2},
  [548] = {.lex_state = 2, .external_lex_state = 2},
  [549] = {.lex_state = 0, .external_lex_state = 2},
  [550] = {.lex_state = 2, .external_lex_state = 2},
  [551] = {.lex_state = 2},
  [552] = {.lex_state = 2, .external_lex_state = 2},
  [553] = {.lex_state = 2, .external_lex_state = 2},
  [554] = {.lex_state = 9, .external_lex_state = 2},
  [555] = {.lex_state = 2, .external_lex_state = 2},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 9, .external_lex_state = 2},
  [558] = {.lex_state = 3},
  [559] = {.lex_state = 3},
  [560] = {.lex_state = 3},
  [561] = {.lex_state = 9, .external_lex_state = 2},
  [562] = {.lex_state = 3},
  [563] = {.lex_state = 2, .external_lex_state = 2},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 2, .external_lex_state = 2},
  [568] = {.lex_state = 2, .external_lex_state = 2},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 3},
  [571] = {.lex_state = 24},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 2},
  [574] = {.lex_state = 24},
  [575] = {.lex_state = 2, .external_lex_state = 2},
  [576] = {.lex_state = 2, .external_lex_state = 2},
  [577] = {.lex_state = 2, .external_lex_state = 2},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 3},
  [580] = {.lex_state = 2, .external_lex_state = 2},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 3},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 15, .external_lex_state = 3},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 3},
  [589] = {.lex_state = 2, .external_lex_state = 2},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 3},
  [592] = {.lex_state = 3},
  [593] = {.lex_state = 3},
  [594] = {.lex_state = 3},
  [595] = {.lex_state = 3},
  [596] = {.lex_state = 3},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 3},
  [599] = {.lex_state = 3},
  [600] = {.lex_state = 2, .external_lex_state = 2},
  [601] = {.lex_state = 0, .external_lex_state = 2},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 0, .external_lex_state = 2},
  [604] = {.lex_state = 0, .external_lex_state = 2},
  [605] = {.lex_state = 3},
  [606] = {.lex_state = 0, .external_lex_state = 2},
  [607] = {.lex_state = 0, .external_lex_state = 2},
  [608] = {.lex_state = 9, .external_lex_state = 2},
  [609] = {.lex_state = 3},
  [610] = {.lex_state = 13},
  [611] = {.lex_state = 3},
  [612] = {.lex_state = 13},
  [613] = {.lex_state = 3},
  [614] = {.lex_state = 3},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 3, .external_lex_state = 2},
  [617] = {.lex_state = 3, .external_lex_state = 2},
  [618] = {.lex_state = 3, .external_lex_state = 2},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 3},
  [621] = {.lex_state = 3, .external_lex_state = 2},
  [622] = {.lex_state = 3},
  [623] = {.lex_state = 0, .external_lex_state = 2},
  [624] = {.lex_state = 3},
  [625] = {.lex_state = 3},
  [626] = {.lex_state = 3, .external_lex_state = 2},
  [627] = {.lex_state = 3},
  [628] = {.lex_state = 3},
  [629] = {.lex_state = 3},
  [630] = {.lex_state = 3},
  [631] = {.lex_state = 3},
  [632] = {.lex_state = 3},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 3},
  [636] = {.lex_state = 3},
  [637] = {.lex_state = 3},
  [638] = {.lex_state = 3},
  [639] = {.lex_state = 3},
  [640] = {.lex_state = 13},
  [641] = {.lex_state = 13},
  [642] = {.lex_state = 3},
  [643] = {.lex_state = 3},
  [644] = {.lex_state = 13},
  [645] = {.lex_state = 13},
  [646] = {.lex_state = 13},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 2, .external_lex_state = 2},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 3},
  [652] = {.lex_state = 3},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 3},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 3},
  [658] = {.lex_state = 3},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 3},
  [661] = {.lex_state = 3, .external_lex_state = 2},
  [662] = {.lex_state = 13},
  [663] = {.lex_state = 3},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0, .external_lex_state = 2},
  [666] = {.lex_state = 3},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 0, .external_lex_state = 2},
  [669] = {.lex_state = 3},
  [670] = {.lex_state = 3},
  [671] = {.lex_state = 3},
  [672] = {.lex_state = 3},
  [673] = {.lex_state = 3},
  [674] = {.lex_state = 3},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0, .external_lex_state = 2},
  [677] = {.lex_state = 2, .external_lex_state = 2},
  [678] = {.lex_state = 3},
  [679] = {.lex_state = 3},
  [680] = {.lex_state = 9, .external_lex_state = 2},
  [681] = {.lex_state = 9},
  [682] = {.lex_state = 9},
  [683] = {.lex_state = 9},
  [684] = {.lex_state = 9},
  [685] = {.lex_state = 9},
  [686] = {.lex_state = 2, .external_lex_state = 2},
  [687] = {.lex_state = 2, .external_lex_state = 2},
  [688] = {.lex_state = 3},
  [689] = {.lex_state = 3},
  [690] = {.lex_state = 3},
  [691] = {.lex_state = 3},
  [692] = {.lex_state = 3},
  [693] = {.lex_state = 2, .external_lex_state = 2},
  [694] = {.lex_state = 3},
  [695] = {.lex_state = 3},
  [696] = {.lex_state = 3},
  [697] = {.lex_state = 3},
  [698] = {.lex_state = 13},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 3},
  [701] = {.lex_state = 2, .external_lex_state = 2},
  [702] = {.lex_state = 2, .external_lex_state = 2},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 3},
  [705] = {.lex_state = 9},
  [706] = {.lex_state = 9},
  [707] = {.lex_state = 9},
  [708] = {.lex_state = 9},
  [709] = {.lex_state = 9},
  [710] = {.lex_state = 2},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 3, .external_lex_state = 2},
  [713] = {.lex_state = 3},
  [714] = {.lex_state = 3},
  [715] = {.lex_state = 3, .external_lex_state = 2},
  [716] = {.lex_state = 3, .external_lex_state = 2},
  [717] = {.lex_state = 3},
  [718] = {.lex_state = 3, .external_lex_state = 2},
  [719] = {.lex_state = 3, .external_lex_state = 2},
  [720] = {.lex_state = 3},
  [721] = {.lex_state = 3},
  [722] = {.lex_state = 2, .external_lex_state = 2},
  [723] = {.lex_state = 3},
  [724] = {.lex_state = 3, .external_lex_state = 2},
  [725] = {.lex_state = 3},
  [726] = {.lex_state = 3},
  [727] = {.lex_state = 3, .external_lex_state = 2},
  [728] = {.lex_state = 0, .external_lex_state = 2},
  [729] = {.lex_state = 0, .external_lex_state = 2},
  [730] = {.lex_state = 0, .external_lex_state = 2},
  [731] = {.lex_state = 0, .external_lex_state = 2},
  [732] = {.lex_state = 2, .external_lex_state = 2},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 3, .external_lex_state = 2},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 3},
  [737] = {.lex_state = 3},
  [738] = {.lex_state = 3},
  [739] = {.lex_state = 0, .external_lex_state = 2},
  [740] = {.lex_state = 3},
  [741] = {.lex_state = 3},
  [742] = {.lex_state = 3},
  [743] = {.lex_state = 2, .external_lex_state = 2},
  [744] = {.lex_state = 2, .external_lex_state = 2},
  [745] = {.lex_state = 2, .external_lex_state = 2},
  [746] = {.lex_state = 3},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 3},
  [749] = {.lex_state = 3},
  [750] = {.lex_state = 3},
  [751] = {.lex_state = 3},
  [752] = {.lex_state = 2, .external_lex_state = 2},
  [753] = {.lex_state = 2, .external_lex_state = 2},
  [754] = {.lex_state = 2, .external_lex_state = 2},
  [755] = {.lex_state = 2},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 3},
  [759] = {.lex_state = 2, .external_lex_state = 2},
  [760] = {.lex_state = 3},
  [761] = {.lex_state = 3},
  [762] = {.lex_state = 3},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 3},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 3},
  [769] = {.lex_state = 3},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 9, .external_lex_state = 2},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 2, .external_lex_state = 2},
  [781] = {.lex_state = 2, .external_lex_state = 2},
  [782] = {.lex_state = 2, .external_lex_state = 2},
  [783] = {.lex_state = 2, .external_lex_state = 2},
  [784] = {.lex_state = 0, .external_lex_state = 2},
  [785] = {.lex_state = 3},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 2, .external_lex_state = 2},
  [788] = {.lex_state = 2, .external_lex_state = 2},
  [789] = {.lex_state = 2, .external_lex_state = 2},
  [790] = {.lex_state = 3},
  [791] = {.lex_state = 3},
  [792] = {.lex_state = 3},
  [793] = {.lex_state = 3},
  [794] = {.lex_state = 3},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 3},
  [797] = {.lex_state = 3},
  [798] = {.lex_state = 3},
  [799] = {.lex_state = 3},
  [800] = {.lex_state = 3},
  [801] = {.lex_state = 3},
  [802] = {.lex_state = 2, .external_lex_state = 2},
  [803] = {.lex_state = 24},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 3},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 24},
  [808] = {.lex_state = 3},
  [809] = {.lex_state = 3},
  [810] = {.lex_state = 3},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 3},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 2, .external_lex_state = 2},
  [815] = {.lex_state = 3},
  [816] = {.lex_state = 2, .external_lex_state = 2},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 2, .external_lex_state = 2},
  [819] = {.lex_state = 3},
  [820] = {.lex_state = 2, .external_lex_state = 2},
  [821] = {.lex_state = 2},
  [822] = {.lex_state = 3},
  [823] = {.lex_state = 3, .external_lex_state = 2},
  [824] = {.lex_state = 3},
  [825] = {.lex_state = 3, .external_lex_state = 2},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 3},
  [828] = {.lex_state = 0, .external_lex_state = 2},
  [829] = {.lex_state = 0, .external_lex_state = 2},
  [830] = {.lex_state = 3},
  [831] = {.lex_state = 9, .external_lex_state = 2},
  [832] = {.lex_state = 2, .external_lex_state = 2},
  [833] = {.lex_state = 3},
  [834] = {.lex_state = 3},
  [835] = {.lex_state = 3, .external_lex_state = 2},
  [836] = {.lex_state = 3, .external_lex_state = 2},
  [837] = {.lex_state = 3, .external_lex_state = 2},
  [838] = {.lex_state = 2, .external_lex_state = 2},
  [839] = {.lex_state = 3, .external_lex_state = 2},
  [840] = {.lex_state = 3},
  [841] = {.lex_state = 3},
  [842] = {.lex_state = 3, .external_lex_state = 2},
  [843] = {.lex_state = 9},
  [844] = {.lex_state = 9},
  [845] = {.lex_state = 9},
  [846] = {.lex_state = 2},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 0},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 24},
  [855] = {.lex_state = 3},
  [856] = {.lex_state = 2, .external_lex_state = 2},
  [857] = {.lex_state = 2, .external_lex_state = 2},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 3},
  [860] = {.lex_state = 2, .external_lex_state = 2},
  [861] = {.lex_state = 2, .external_lex_state = 2},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 2, .external_lex_state = 2},
  [864] = {.lex_state = 2, .external_lex_state = 2},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 2},
  [867] = {.lex_state = 2},
  [868] = {.lex_state = 2},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 3},
  [871] = {.lex_state = 2, .external_lex_state = 2},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 2, .external_lex_state = 2},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 3},
  [876] = {.lex_state = 3},
  [877] = {.lex_state = 3},
  [878] = {.lex_state = 0, .external_lex_state = 2},
  [879] = {.lex_state = 3},
  [880] = {.lex_state = 3},
  [881] = {.lex_state = 3},
  [882] = {.lex_state = 3},
  [883] = {.lex_state = 3, .external_lex_state = 2},
  [884] = {.lex_state = 3, .external_lex_state = 2},
  [885] = {.lex_state = 0, .external_lex_state = 2},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 3},
  [888] = {.lex_state = 3},
  [889] = {.lex_state = 3},
  [890] = {.lex_state = 0, .external_lex_state = 2},
  [891] = {.lex_state = 3, .external_lex_state = 2},
  [892] = {.lex_state = 3, .external_lex_state = 2},
  [893] = {.lex_state = 0, .external_lex_state = 2},
  [894] = {.lex_state = 0, .external_lex_state = 2},
  [895] = {.lex_state = 3},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 13},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 3},
  [900] = {.lex_state = 3},
  [901] = {.lex_state = 3},
  [902] = {.lex_state = 3},
  [903] = {.lex_state = 3},
  [904] = {.lex_state = 3},
  [905] = {.lex_state = 3},
  [906] = {.lex_state = 3},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 2, .external_lex_state = 2},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 3},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 3},
  [917] = {.lex_state = 3},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 3},
  [921] = {.lex_state = 3, .external_lex_state = 2},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 3},
  [924] = {.lex_state = 3},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 3},
  [927] = {.lex_state = 3},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 3},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 2},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 2},
  [935] = {.lex_state = 3},
  [936] = {.lex_state = 3},
  [937] = {.lex_state = 3},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 3},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 2},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 2},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 2},
  [949] = {.lex_state = 9},
  [950] = {.lex_state = 2},
  [951] = {.lex_state = 2},
  [952] = {.lex_state = 9},
  [953] = {.lex_state = 3},
  [954] = {.lex_state = 2},
  [955] = {.lex_state = 3},
  [956] = {.lex_state = 9},
  [957] = {.lex_state = 3},
  [958] = {.lex_state = 3},
  [959] = {.lex_state = 3},
  [960] = {.lex_state = 2, .external_lex_state = 2},
  [961] = {.lex_state = 3},
  [962] = {.lex_state = 0, .external_lex_state = 2},
  [963] = {.lex_state = 3},
  [964] = {.lex_state = 13},
  [965] = {.lex_state = 3},
  [966] = {.lex_state = 3, .external_lex_state = 2},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 3},
  [969] = {.lex_state = 0, .external_lex_state = 2},
  [970] = {.lex_state = 3, .external_lex_state = 2},
  [971] = {.lex_state = 0, .external_lex_state = 2},
  [972] = {.lex_state = 0, .external_lex_state = 2},
  [973] = {.lex_state = 0, .external_lex_state = 2},
  [974] = {.lex_state = 0, .external_lex_state = 2},
  [975] = {.lex_state = 3},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 3},
  [978] = {.lex_state = 3, .external_lex_state = 2},
  [979] = {.lex_state = 3, .external_lex_state = 2},
  [980] = {.lex_state = 3, .external_lex_state = 2},
  [981] = {.lex_state = 3},
  [982] = {.lex_state = 3},
  [983] = {.lex_state = 3, .external_lex_state = 2},
  [984] = {.lex_state = 3},
  [985] = {.lex_state = 3, .external_lex_state = 2},
  [986] = {.lex_state = 0, .external_lex_state = 2},
  [987] = {.lex_state = 0, .external_lex_state = 2},
  [988] = {.lex_state = 0, .external_lex_state = 2},
  [989] = {.lex_state = 0, .external_lex_state = 2},
  [990] = {.lex_state = 13},
  [991] = {.lex_state = 3, .external_lex_state = 2},
  [992] = {.lex_state = 3, .external_lex_state = 2},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0, .external_lex_state = 2},
  [995] = {.lex_state = 3},
  [996] = {.lex_state = 3, .external_lex_state = 2},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 3, .external_lex_state = 2},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 3},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 3},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 3},
  [1006] = {.lex_state = 3},
  [1007] = {.lex_state = 3},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 3},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 2},
  [1012] = {.lex_state = 3},
  [1013] = {.lex_state = 3},
  [1014] = {.lex_state = 3},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 3},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 3},
  [1020] = {.lex_state = 3},
  [1021] = {.lex_state = 2, .external_lex_state = 2},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 2, .external_lex_state = 2},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 2, .external_lex_state = 2},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 3},
  [1030] = {.lex_state = 3},
  [1031] = {.lex_state = 2, .external_lex_state = 2},
  [1032] = {.lex_state = 24},
  [1033] = {.lex_state = 3},
  [1034] = {.lex_state = 3},
  [1035] = {.lex_state = 3},
  [1036] = {.lex_state = 3},
  [1037] = {.lex_state = 2, .external_lex_state = 2},
  [1038] = {.lex_state = 9},
  [1039] = {.lex_state = 3},
  [1040] = {.lex_state = 9, .external_lex_state = 2},
  [1041] = {.lex_state = 3, .external_lex_state = 2},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 3},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 3},
  [1046] = {.lex_state = 3},
  [1047] = {.lex_state = 2, .external_lex_state = 2},
  [1048] = {.lex_state = 3},
  [1049] = {.lex_state = 3, .external_lex_state = 2},
  [1050] = {.lex_state = 3, .external_lex_state = 2},
  [1051] = {.lex_state = 3, .external_lex_state = 2},
  [1052] = {.lex_state = 3, .external_lex_state = 2},
  [1053] = {.lex_state = 3},
  [1054] = {.lex_state = 3, .external_lex_state = 2},
  [1055] = {.lex_state = 3},
  [1056] = {.lex_state = 3, .external_lex_state = 2},
  [1057] = {.lex_state = 3},
  [1058] = {.lex_state = 3, .external_lex_state = 2},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 2, .external_lex_state = 2},
  [1061] = {.lex_state = 3},
  [1062] = {.lex_state = 3},
  [1063] = {.lex_state = 2, .external_lex_state = 2},
  [1064] = {.lex_state = 2, .external_lex_state = 2},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 2, .external_lex_state = 2},
  [1067] = {.lex_state = 2, .external_lex_state = 2},
  [1068] = {.lex_state = 2, .external_lex_state = 2},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 2, .external_lex_state = 2},
  [1071] = {.lex_state = 2, .external_lex_state = 2},
  [1072] = {.lex_state = 2, .external_lex_state = 2},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 3},
  [1075] = {.lex_state = 3},
  [1076] = {.lex_state = 0, .external_lex_state = 2},
  [1077] = {.lex_state = 3},
  [1078] = {.lex_state = 0, .external_lex_state = 2},
  [1079] = {.lex_state = 3},
  [1080] = {.lex_state = 3, .external_lex_state = 2},
  [1081] = {.lex_state = 3},
  [1082] = {.lex_state = 3, .external_lex_state = 2},
  [1083] = {.lex_state = 3, .external_lex_state = 2},
  [1084] = {.lex_state = 3, .external_lex_state = 2},
  [1085] = {.lex_state = 0, .external_lex_state = 2},
  [1086] = {.lex_state = 0, .external_lex_state = 2},
  [1087] = {.lex_state = 0, .external_lex_state = 2},
  [1088] = {.lex_state = 0, .external_lex_state = 2},
  [1089] = {.lex_state = 0, .external_lex_state = 2},
  [1090] = {.lex_state = 3},
  [1091] = {.lex_state = 0, .external_lex_state = 2},
  [1092] = {.lex_state = 0, .external_lex_state = 2},
  [1093] = {.lex_state = 3},
  [1094] = {.lex_state = 3},
  [1095] = {.lex_state = 13},
  [1096] = {.lex_state = 3},
  [1097] = {.lex_state = 3},
  [1098] = {.lex_state = 3},
  [1099] = {.lex_state = 3},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 3},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 3},
  [1105] = {.lex_state = 3},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 3},
  [1109] = {.lex_state = 3},
  [1110] = {.lex_state = 3},
  [1111] = {.lex_state = 3},
  [1112] = {.lex_state = 2, .external_lex_state = 2},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 2},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 2},
  [1117] = {.lex_state = 2, .external_lex_state = 2},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 2},
  [1120] = {.lex_state = 2, .external_lex_state = 2},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 2},
  [1123] = {.lex_state = 3},
  [1124] = {.lex_state = 3},
  [1125] = {.lex_state = 3},
  [1126] = {.lex_state = 3},
  [1127] = {.lex_state = 3},
  [1128] = {.lex_state = 0, .external_lex_state = 2},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 3},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0, .external_lex_state = 2},
  [1133] = {.lex_state = 3},
  [1134] = {.lex_state = 0, .external_lex_state = 2},
  [1135] = {.lex_state = 0, .external_lex_state = 2},
  [1136] = {.lex_state = 0, .external_lex_state = 2},
  [1137] = {.lex_state = 0, .external_lex_state = 2},
  [1138] = {.lex_state = 0, .external_lex_state = 2},
  [1139] = {.lex_state = 0, .external_lex_state = 2},
  [1140] = {.lex_state = 0, .external_lex_state = 2},
  [1141] = {.lex_state = 0, .external_lex_state = 2},
  [1142] = {.lex_state = 3},
  [1143] = {.lex_state = 0, .external_lex_state = 2},
  [1144] = {.lex_state = 3},
  [1145] = {.lex_state = 3},
  [1146] = {.lex_state = 3},
  [1147] = {.lex_state = 3, .external_lex_state = 2},
  [1148] = {.lex_state = 3, .external_lex_state = 2},
  [1149] = {.lex_state = 3, .external_lex_state = 2},
  [1150] = {.lex_state = 0, .external_lex_state = 2},
  [1151] = {.lex_state = 3},
  [1152] = {.lex_state = 3, .external_lex_state = 2},
  [1153] = {.lex_state = 0, .external_lex_state = 2},
  [1154] = {.lex_state = 3},
  [1155] = {.lex_state = 3, .external_lex_state = 2},
  [1156] = {.lex_state = 3, .external_lex_state = 2},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 3, .external_lex_state = 2},
  [1159] = {.lex_state = 3, .external_lex_state = 2},
  [1160] = {.lex_state = 3, .external_lex_state = 2},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 3},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 3},
  [1168] = {.lex_state = 3},
  [1169] = {.lex_state = 3},
  [1170] = {.lex_state = 3},
  [1171] = {.lex_state = 3},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 3},
  [1174] = {.lex_state = 2, .external_lex_state = 2},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 2, .external_lex_state = 2},
  [1179] = {.lex_state = 3},
  [1180] = {.lex_state = 2},
  [1181] = {.lex_state = 3, .external_lex_state = 2},
  [1182] = {.lex_state = 3},
  [1183] = {.lex_state = 9, .external_lex_state = 2},
  [1184] = {.lex_state = 3, .external_lex_state = 2},
  [1185] = {.lex_state = 3, .external_lex_state = 2},
  [1186] = {.lex_state = 3},
  [1187] = {.lex_state = 3},
  [1188] = {.lex_state = 3},
  [1189] = {.lex_state = 2, .external_lex_state = 2},
  [1190] = {.lex_state = 2, .external_lex_state = 2},
  [1191] = {.lex_state = 2, .external_lex_state = 2},
  [1192] = {.lex_state = 3},
  [1193] = {.lex_state = 3},
  [1194] = {.lex_state = 0, .external_lex_state = 2},
  [1195] = {.lex_state = 3},
  [1196] = {.lex_state = 0, .external_lex_state = 2},
  [1197] = {.lex_state = 3},
  [1198] = {.lex_state = 3},
  [1199] = {.lex_state = 3},
  [1200] = {.lex_state = 3, .external_lex_state = 2},
  [1201] = {.lex_state = 0, .external_lex_state = 2},
  [1202] = {.lex_state = 0, .external_lex_state = 2},
  [1203] = {.lex_state = 0, .external_lex_state = 2},
  [1204] = {.lex_state = 3},
  [1205] = {.lex_state = 3, .external_lex_state = 2},
  [1206] = {.lex_state = 3, .external_lex_state = 2},
  [1207] = {.lex_state = 3},
  [1208] = {.lex_state = 3},
  [1209] = {.lex_state = 3},
  [1210] = {.lex_state = 0, .external_lex_state = 2},
  [1211] = {.lex_state = 3},
  [1212] = {.lex_state = 3},
  [1213] = {.lex_state = 3},
  [1214] = {.lex_state = 3},
  [1215] = {.lex_state = 3},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0, .external_lex_state = 2},
  [1219] = {.lex_state = 0, .external_lex_state = 2},
  [1220] = {.lex_state = 0, .external_lex_state = 2},
  [1221] = {.lex_state = 0, .external_lex_state = 2},
  [1222] = {.lex_state = 0, .external_lex_state = 2},
  [1223] = {.lex_state = 0, .external_lex_state = 2},
  [1224] = {.lex_state = 3},
  [1225] = {.lex_state = 0, .external_lex_state = 2},
  [1226] = {.lex_state = 3},
  [1227] = {.lex_state = 3},
  [1228] = {.lex_state = 3},
  [1229] = {.lex_state = 3, .external_lex_state = 2},
  [1230] = {.lex_state = 0, .external_lex_state = 2},
  [1231] = {.lex_state = 0, .external_lex_state = 2},
  [1232] = {.lex_state = 0, .external_lex_state = 2},
  [1233] = {.lex_state = 3},
  [1234] = {.lex_state = 0, .external_lex_state = 2},
  [1235] = {.lex_state = 3, .external_lex_state = 2},
  [1236] = {.lex_state = 3, .external_lex_state = 2},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 3},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 3},
  [1243] = {.lex_state = 3},
  [1244] = {.lex_state = 3},
  [1245] = {.lex_state = 3},
  [1246] = {.lex_state = 3},
  [1247] = {.lex_state = 3},
  [1248] = {.lex_state = 3, .external_lex_state = 2},
  [1249] = {.lex_state = 3, .external_lex_state = 2},
  [1250] = {.lex_state = 3},
  [1251] = {.lex_state = 3},
  [1252] = {.lex_state = 0, .external_lex_state = 2},
  [1253] = {.lex_state = 3},
  [1254] = {.lex_state = 0, .external_lex_state = 2},
  [1255] = {.lex_state = 3},
  [1256] = {.lex_state = 0, .external_lex_state = 2},
  [1257] = {.lex_state = 3},
  [1258] = {.lex_state = 3},
  [1259] = {.lex_state = 3, .external_lex_state = 2},
  [1260] = {.lex_state = 0, .external_lex_state = 2},
  [1261] = {.lex_state = 0, .external_lex_state = 2},
  [1262] = {.lex_state = 0, .external_lex_state = 2},
  [1263] = {.lex_state = 0, .external_lex_state = 2},
  [1264] = {.lex_state = 0, .external_lex_state = 2},
  [1265] = {.lex_state = 3},
  [1266] = {.lex_state = 0, .external_lex_state = 2},
  [1267] = {.lex_state = 3},
  [1268] = {.lex_state = 0, .external_lex_state = 2},
  [1269] = {.lex_state = 0, .external_lex_state = 2},
  [1270] = {.lex_state = 0, .external_lex_state = 2},
  [1271] = {.lex_state = 0, .external_lex_state = 2},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 3},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 3, .external_lex_state = 2},
  [1278] = {.lex_state = 0, .external_lex_state = 2},
  [1279] = {.lex_state = 3},
  [1280] = {.lex_state = 0, .external_lex_state = 2},
  [1281] = {.lex_state = 3},
  [1282] = {.lex_state = 0, .external_lex_state = 2},
  [1283] = {.lex_state = 0, .external_lex_state = 2},
  [1284] = {.lex_state = 3},
  [1285] = {.lex_state = 0, .external_lex_state = 2},
  [1286] = {.lex_state = 0, .external_lex_state = 2},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0, .external_lex_state = 2},
  [1291] = {.lex_state = 3},
  [1292] = {.lex_state = 0, .external_lex_state = 2},
  [1293] = {.lex_state = 0, .external_lex_state = 2},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0, .external_lex_state = 2},
  [1296] = {.lex_state = 2},
  [1297] = {.lex_state = 3},
  [1298] = {.lex_state = 3},
  [1299] = {.lex_state = 2},
  [1300] = {.lex_state = 3},
  [1301] = {.lex_state = 3},
  [1302] = {.lex_state = 2},
  [1303] = {.lex_state = 9},
  [1304] = {.lex_state = 2},
  [1305] = {.lex_state = 2, .external_lex_state = 2},
  [1306] = {.lex_state = 0, .external_lex_state = 2},
  [1307] = {.lex_state = 2},
  [1308] = {.lex_state = 3},
  [1309] = {.lex_state = 3},
  [1310] = {.lex_state = 3},
  [1311] = {.lex_state = 2},
  [1312] = {.lex_state = 3},
  [1313] = {.lex_state = 3},
  [1314] = {.lex_state = 3},
  [1315] = {.lex_state = 9},
  [1316] = {.lex_state = 9},
  [1317] = {.lex_state = 9},
  [1318] = {.lex_state = 9},
  [1319] = {.lex_state = 2},
  [1320] = {.lex_state = 9},
  [1321] = {.lex_state = 2},
  [1322] = {.lex_state = 2},
  [1323] = {.lex_state = 2},
  [1324] = {.lex_state = 2},
  [1325] = {.lex_state = 3},
  [1326] = {.lex_state = 2},
  [1327] = {.lex_state = 3},
  [1328] = {.lex_state = 3},
  [1329] = {.lex_state = 2, .external_lex_state = 2},
  [1330] = {.lex_state = 2, .external_lex_state = 2},
  [1331] = {.lex_state = 2},
  [1332] = {.lex_state = 2},
  [1333] = {.lex_state = 0, .external_lex_state = 2},
  [1334] = {.lex_state = 2},
  [1335] = {.lex_state = 3},
  [1336] = {.lex_state = 3},
  [1337] = {.lex_state = 3},
  [1338] = {.lex_state = 0, .external_lex_state = 2},
  [1339] = {.lex_state = 2, .external_lex_state = 2},
  [1340] = {.lex_state = 3},
  [1341] = {.lex_state = 9},
  [1342] = {.lex_state = 9},
  [1343] = {.lex_state = 9},
  [1344] = {.lex_state = 9},
  [1345] = {.lex_state = 9},
  [1346] = {.lex_state = 0, .external_lex_state = 2},
  [1347] = {.lex_state = 2},
  [1348] = {.lex_state = 9},
  [1349] = {.lex_state = 2},
  [1350] = {.lex_state = 2},
  [1351] = {.lex_state = 3},
  [1352] = {.lex_state = 9},
  [1353] = {.lex_state = 2},
  [1354] = {.lex_state = 9},
  [1355] = {.lex_state = 9},
  [1356] = {.lex_state = 9},
  [1357] = {.lex_state = 9},
  [1358] = {.lex_state = 9},
  [1359] = {.lex_state = 2},
  [1360] = {.lex_state = 2},
  [1361] = {.lex_state = 2},
  [1362] = {.lex_state = 3},
  [1363] = {.lex_state = 0, .external_lex_state = 2},
  [1364] = {.lex_state = 2},
  [1365] = {.lex_state = 3},
  [1366] = {.lex_state = 3},
  [1367] = {.lex_state = 3},
  [1368] = {.lex_state = 3},
  [1369] = {.lex_state = 3},
  [1370] = {.lex_state = 3},
  [1371] = {.lex_state = 2},
  [1372] = {.lex_state = 3},
  [1373] = {.lex_state = 3},
  [1374] = {.lex_state = 2},
  [1375] = {.lex_state = 3},
  [1376] = {.lex_state = 2},
  [1377] = {.lex_state = 3},
  [1378] = {.lex_state = 0, .external_lex_state = 2},
  [1379] = {.lex_state = 0, .external_lex_state = 2},
  [1380] = {.lex_state = 3},
  [1381] = {.lex_state = 3},
  [1382] = {.lex_state = 2},
  [1383] = {.lex_state = 2},
  [1384] = {.lex_state = 2},
  [1385] = {.lex_state = 2},
  [1386] = {.lex_state = 9},
  [1387] = {.lex_state = 2},
  [1388] = {.lex_state = 2},
  [1389] = {.lex_state = 2},
  [1390] = {.lex_state = 2},
  [1391] = {.lex_state = 2},
  [1392] = {.lex_state = 9},
  [1393] = {.lex_state = 3, .external_lex_state = 2},
  [1394] = {.lex_state = 3, .external_lex_state = 2},
  [1395] = {.lex_state = 2},
  [1396] = {.lex_state = 3},
  [1397] = {.lex_state = 0, .external_lex_state = 2},
  [1398] = {.lex_state = 2, .external_lex_state = 2},
  [1399] = {.lex_state = 2, .external_lex_state = 2},
  [1400] = {.lex_state = 13},
  [1401] = {.lex_state = 13},
  [1402] = {.lex_state = 2, .external_lex_state = 2},
  [1403] = {.lex_state = 2, .external_lex_state = 2},
  [1404] = {.lex_state = 13},
  [1405] = {.lex_state = 2, .external_lex_state = 2},
  [1406] = {.lex_state = 2, .external_lex_state = 2},
  [1407] = {.lex_state = 2},
  [1408] = {.lex_state = 2},
  [1409] = {.lex_state = 0, .external_lex_state = 2},
  [1410] = {.lex_state = 0, .external_lex_state = 2},
  [1411] = {.lex_state = 2},
  [1412] = {.lex_state = 3},
  [1413] = {.lex_state = 2, .external_lex_state = 2},
  [1414] = {.lex_state = 9},
  [1415] = {.lex_state = 9},
  [1416] = {.lex_state = 9},
  [1417] = {.lex_state = 9},
  [1418] = {.lex_state = 9},
  [1419] = {.lex_state = 9},
  [1420] = {.lex_state = 2},
  [1421] = {.lex_state = 2},
  [1422] = {.lex_state = 2},
  [1423] = {.lex_state = 2, .external_lex_state = 2},
  [1424] = {.lex_state = 3},
  [1425] = {.lex_state = 2},
  [1426] = {.lex_state = 2},
  [1427] = {.lex_state = 2},
  [1428] = {.lex_state = 0, .external_lex_state = 2},
  [1429] = {.lex_state = 2},
  [1430] = {.lex_state = 3, .external_lex_state = 2},
  [1431] = {.lex_state = 3, .external_lex_state = 2},
  [1432] = {.lex_state = 2, .external_lex_state = 2},
  [1433] = {.lex_state = 2},
  [1434] = {.lex_state = 2, .external_lex_state = 2},
  [1435] = {.lex_state = 0, .external_lex_state = 2},
  [1436] = {.lex_state = 3},
  [1437] = {.lex_state = 3},
  [1438] = {.lex_state = 3},
  [1439] = {.lex_state = 3},
  [1440] = {.lex_state = 0, .external_lex_state = 2},
  [1441] = {.lex_state = 2, .external_lex_state = 2},
  [1442] = {.lex_state = 10},
  [1443] = {.lex_state = 2},
  [1444] = {.lex_state = 2},
  [1445] = {.lex_state = 2},
  [1446] = {.lex_state = 2},
  [1447] = {.lex_state = 2},
  [1448] = {.lex_state = 9, .external_lex_state = 2},
  [1449] = {.lex_state = 0, .external_lex_state = 2},
  [1450] = {.lex_state = 2},
  [1451] = {.lex_state = 2},
  [1452] = {.lex_state = 2},
  [1453] = {.lex_state = 2},
  [1454] = {.lex_state = 2},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 2},
  [1457] = {.lex_state = 2},
  [1458] = {.lex_state = 2},
  [1459] = {.lex_state = 9},
  [1460] = {.lex_state = 2},
  [1461] = {.lex_state = 3},
  [1462] = {.lex_state = 9},
  [1463] = {.lex_state = 3},
  [1464] = {.lex_state = 3},
  [1465] = {.lex_state = 9},
  [1466] = {.lex_state = 2},
  [1467] = {.lex_state = 3},
  [1468] = {.lex_state = 2},
  [1469] = {.lex_state = 2},
  [1470] = {.lex_state = 3},
  [1471] = {.lex_state = 2},
  [1472] = {.lex_state = 2},
  [1473] = {.lex_state = 2},
  [1474] = {.lex_state = 0, .external_lex_state = 2},
  [1475] = {.lex_state = 3, .external_lex_state = 2},
  [1476] = {.lex_state = 2},
  [1477] = {.lex_state = 0, .external_lex_state = 2},
  [1478] = {.lex_state = 2},
  [1479] = {.lex_state = 2},
  [1480] = {.lex_state = 0, .external_lex_state = 2},
  [1481] = {.lex_state = 0, .external_lex_state = 2},
  [1482] = {.lex_state = 9},
  [1483] = {.lex_state = 13},
  [1484] = {.lex_state = 2, .external_lex_state = 2},
  [1485] = {.lex_state = 2, .external_lex_state = 2},
  [1486] = {.lex_state = 2, .external_lex_state = 2},
  [1487] = {.lex_state = 2, .external_lex_state = 2},
  [1488] = {.lex_state = 2, .external_lex_state = 2},
  [1489] = {.lex_state = 2, .external_lex_state = 2},
  [1490] = {.lex_state = 2, .external_lex_state = 2},
  [1491] = {.lex_state = 2, .external_lex_state = 2},
  [1492] = {.lex_state = 2, .external_lex_state = 2},
  [1493] = {.lex_state = 13},
  [1494] = {.lex_state = 2, .external_lex_state = 2},
  [1495] = {.lex_state = 2, .external_lex_state = 2},
  [1496] = {.lex_state = 13},
  [1497] = {.lex_state = 13},
  [1498] = {.lex_state = 2},
  [1499] = {.lex_state = 0, .external_lex_state = 2},
  [1500] = {.lex_state = 0, .external_lex_state = 2},
  [1501] = {.lex_state = 0, .external_lex_state = 2},
  [1502] = {.lex_state = 0, .external_lex_state = 2},
  [1503] = {.lex_state = 3},
  [1504] = {.lex_state = 2},
  [1505] = {.lex_state = 2, .external_lex_state = 2},
  [1506] = {.lex_state = 2, .external_lex_state = 2},
  [1507] = {.lex_state = 3},
  [1508] = {.lex_state = 2},
  [1509] = {.lex_state = 2},
  [1510] = {.lex_state = 0, .external_lex_state = 2},
  [1511] = {.lex_state = 2},
  [1512] = {.lex_state = 3},
  [1513] = {.lex_state = 2},
  [1514] = {.lex_state = 3, .external_lex_state = 2},
  [1515] = {.lex_state = 2, .external_lex_state = 2},
  [1516] = {.lex_state = 0, .external_lex_state = 2},
  [1517] = {.lex_state = 3},
  [1518] = {.lex_state = 2},
  [1519] = {.lex_state = 2},
  [1520] = {.lex_state = 2},
  [1521] = {.lex_state = 2},
  [1522] = {.lex_state = 2},
  [1523] = {.lex_state = 2},
  [1524] = {.lex_state = 2},
  [1525] = {.lex_state = 0, .external_lex_state = 2},
  [1526] = {.lex_state = 2},
  [1527] = {.lex_state = 2},
  [1528] = {.lex_state = 0, .external_lex_state = 2},
  [1529] = {.lex_state = 2, .external_lex_state = 2},
  [1530] = {.lex_state = 2},
  [1531] = {.lex_state = 2},
  [1532] = {.lex_state = 0, .external_lex_state = 2},
  [1533] = {.lex_state = 0, .external_lex_state = 2},
  [1534] = {.lex_state = 3},
  [1535] = {.lex_state = 9},
  [1536] = {.lex_state = 2},
  [1537] = {.lex_state = 3},
  [1538] = {.lex_state = 3},
  [1539] = {.lex_state = 2, .external_lex_state = 2},
  [1540] = {.lex_state = 2},
  [1541] = {.lex_state = 2},
  [1542] = {.lex_state = 2},
  [1543] = {.lex_state = 2},
  [1544] = {.lex_state = 2},
  [1545] = {.lex_state = 2},
  [1546] = {.lex_state = 2, .external_lex_state = 2},
  [1547] = {.lex_state = 2, .external_lex_state = 2},
  [1548] = {.lex_state = 3, .external_lex_state = 2},
  [1549] = {.lex_state = 2, .external_lex_state = 2},
  [1550] = {.lex_state = 2, .external_lex_state = 2},
  [1551] = {.lex_state = 13},
  [1552] = {.lex_state = 2, .external_lex_state = 2},
  [1553] = {.lex_state = 2, .external_lex_state = 2},
  [1554] = {.lex_state = 2, .external_lex_state = 2},
  [1555] = {.lex_state = 2, .external_lex_state = 2},
  [1556] = {.lex_state = 2, .external_lex_state = 2},
  [1557] = {.lex_state = 2, .external_lex_state = 2},
  [1558] = {.lex_state = 13},
  [1559] = {.lex_state = 2},
  [1560] = {.lex_state = 0, .external_lex_state = 2},
  [1561] = {.lex_state = 0, .external_lex_state = 2},
  [1562] = {.lex_state = 0, .external_lex_state = 2},
  [1563] = {.lex_state = 0, .external_lex_state = 2},
  [1564] = {.lex_state = 0, .external_lex_state = 2},
  [1565] = {.lex_state = 0, .external_lex_state = 2},
  [1566] = {.lex_state = 9, .external_lex_state = 2},
  [1567] = {.lex_state = 2, .external_lex_state = 2},
  [1568] = {.lex_state = 3},
  [1569] = {.lex_state = 3, .external_lex_state = 2},
  [1570] = {.lex_state = 13},
  [1571] = {.lex_state = 0, .external_lex_state = 2},
  [1572] = {.lex_state = 0, .external_lex_state = 2},
  [1573] = {.lex_state = 0, .external_lex_state = 2},
  [1574] = {.lex_state = 3, .external_lex_state = 2},
  [1575] = {.lex_state = 3, .external_lex_state = 2},
  [1576] = {.lex_state = 0, .external_lex_state = 2},
  [1577] = {.lex_state = 0, .external_lex_state = 2},
  [1578] = {.lex_state = 2, .external_lex_state = 2},
  [1579] = {.lex_state = 2},
  [1580] = {.lex_state = 2},
  [1581] = {.lex_state = 2},
  [1582] = {.lex_state = 0, .external_lex_state = 2},
  [1583] = {.lex_state = 2, .external_lex_state = 2},
  [1584] = {.lex_state = 9},
  [1585] = {.lex_state = 0, .external_lex_state = 2},
  [1586] = {.lex_state = 2},
  [1587] = {.lex_state = 2},
  [1588] = {.lex_state = 0, .external_lex_state = 2},
  [1589] = {.lex_state = 2, .external_lex_state = 2},
  [1590] = {.lex_state = 2, .external_lex_state = 2},
  [1591] = {.lex_state = 2},
  [1592] = {.lex_state = 2},
  [1593] = {.lex_state = 2},
  [1594] = {.lex_state = 2},
  [1595] = {.lex_state = 2},
  [1596] = {.lex_state = 2},
  [1597] = {.lex_state = 2, .external_lex_state = 2},
  [1598] = {.lex_state = 3},
  [1599] = {.lex_state = 2, .external_lex_state = 2},
  [1600] = {.lex_state = 2, .external_lex_state = 2},
  [1601] = {.lex_state = 13},
  [1602] = {.lex_state = 2, .external_lex_state = 2},
  [1603] = {.lex_state = 2, .external_lex_state = 2},
  [1604] = {.lex_state = 2, .external_lex_state = 2},
  [1605] = {.lex_state = 0, .external_lex_state = 2},
  [1606] = {.lex_state = 0, .external_lex_state = 2},
  [1607] = {.lex_state = 0, .external_lex_state = 2},
  [1608] = {.lex_state = 3, .external_lex_state = 2},
  [1609] = {.lex_state = 3},
  [1610] = {.lex_state = 0, .external_lex_state = 2},
  [1611] = {.lex_state = 0, .external_lex_state = 2},
  [1612] = {.lex_state = 0, .external_lex_state = 2},
  [1613] = {.lex_state = 3, .external_lex_state = 2},
  [1614] = {.lex_state = 3, .external_lex_state = 2},
  [1615] = {.lex_state = 0, .external_lex_state = 2},
  [1616] = {.lex_state = 0, .external_lex_state = 2},
  [1617] = {.lex_state = 2, .external_lex_state = 2},
  [1618] = {.lex_state = 2},
  [1619] = {.lex_state = 0, .external_lex_state = 2},
  [1620] = {.lex_state = 9},
  [1621] = {.lex_state = 2, .external_lex_state = 2},
  [1622] = {.lex_state = 2},
  [1623] = {.lex_state = 2},
  [1624] = {.lex_state = 2, .external_lex_state = 2},
  [1625] = {.lex_state = 3, .external_lex_state = 2},
  [1626] = {.lex_state = 2, .external_lex_state = 2},
  [1627] = {.lex_state = 0, .external_lex_state = 2},
  [1628] = {.lex_state = 0, .external_lex_state = 2},
  [1629] = {.lex_state = 3, .external_lex_state = 2},
  [1630] = {.lex_state = 3, .external_lex_state = 2},
  [1631] = {.lex_state = 0, .external_lex_state = 2},
  [1632] = {.lex_state = 2, .external_lex_state = 2},
  [1633] = {.lex_state = 3, .external_lex_state = 2},
  [1634] = {.lex_state = 3, .external_lex_state = 2},
  [1635] = {.lex_state = 3, .external_lex_state = 2},
  [1636] = {.lex_state = 3, .external_lex_state = 2},
  [1637] = {.lex_state = 3, .external_lex_state = 2},
  [1638] = {.lex_state = 2, .external_lex_state = 2},
  [1639] = {.lex_state = 2, .external_lex_state = 2},
  [1640] = {.lex_state = 2},
  [1641] = {.lex_state = 2},
  [1642] = {.lex_state = 2, .external_lex_state = 2},
  [1643] = {.lex_state = 9},
  [1644] = {.lex_state = 24},
  [1645] = {.lex_state = 3, .external_lex_state = 2},
  [1646] = {.lex_state = 3, .external_lex_state = 2},
  [1647] = {.lex_state = 13},
  [1648] = {.lex_state = 13},
  [1649] = {.lex_state = 3, .external_lex_state = 2},
  [1650] = {.lex_state = 3, .external_lex_state = 2},
  [1651] = {.lex_state = 13},
  [1652] = {.lex_state = 3, .external_lex_state = 2},
  [1653] = {.lex_state = 3, .external_lex_state = 2},
  [1654] = {.lex_state = 3},
  [1655] = {.lex_state = 2, .external_lex_state = 2},
  [1656] = {.lex_state = 2},
  [1657] = {.lex_state = 2, .external_lex_state = 2},
  [1658] = {.lex_state = 2, .external_lex_state = 2},
  [1659] = {.lex_state = 2, .external_lex_state = 2},
  [1660] = {.lex_state = 9},
  [1661] = {.lex_state = 2, .external_lex_state = 2},
  [1662] = {.lex_state = 10},
  [1663] = {.lex_state = 9},
  [1664] = {.lex_state = 2},
  [1665] = {.lex_state = 9},
  [1666] = {.lex_state = 9},
  [1667] = {.lex_state = 2},
  [1668] = {.lex_state = 3},
  [1669] = {.lex_state = 24},
  [1670] = {.lex_state = 13},
  [1671] = {.lex_state = 3, .external_lex_state = 2},
  [1672] = {.lex_state = 3, .external_lex_state = 2},
  [1673] = {.lex_state = 3, .external_lex_state = 2},
  [1674] = {.lex_state = 3, .external_lex_state = 2},
  [1675] = {.lex_state = 3, .external_lex_state = 2},
  [1676] = {.lex_state = 3, .external_lex_state = 2},
  [1677] = {.lex_state = 3, .external_lex_state = 2},
  [1678] = {.lex_state = 3, .external_lex_state = 2},
  [1679] = {.lex_state = 3, .external_lex_state = 2},
  [1680] = {.lex_state = 13},
  [1681] = {.lex_state = 3, .external_lex_state = 2},
  [1682] = {.lex_state = 3, .external_lex_state = 2},
  [1683] = {.lex_state = 13},
  [1684] = {.lex_state = 13},
  [1685] = {.lex_state = 3},
  [1686] = {.lex_state = 3},
  [1687] = {.lex_state = 2, .external_lex_state = 2},
  [1688] = {.lex_state = 3, .external_lex_state = 2},
  [1689] = {.lex_state = 2, .external_lex_state = 2},
  [1690] = {.lex_state = 9},
  [1691] = {.lex_state = 24},
  [1692] = {.lex_state = 2},
  [1693] = {.lex_state = 9},
  [1694] = {.lex_state = 2},
  [1695] = {.lex_state = 2},
  [1696] = {.lex_state = 3, .external_lex_state = 2},
  [1697] = {.lex_state = 3, .external_lex_state = 2},
  [1698] = {.lex_state = 3, .external_lex_state = 2},
  [1699] = {.lex_state = 3, .external_lex_state = 2},
  [1700] = {.lex_state = 13},
  [1701] = {.lex_state = 3, .external_lex_state = 2},
  [1702] = {.lex_state = 3, .external_lex_state = 2},
  [1703] = {.lex_state = 3, .external_lex_state = 2},
  [1704] = {.lex_state = 3, .external_lex_state = 2},
  [1705] = {.lex_state = 3, .external_lex_state = 2},
  [1706] = {.lex_state = 3, .external_lex_state = 2},
  [1707] = {.lex_state = 13},
  [1708] = {.lex_state = 3},
  [1709] = {.lex_state = 9},
  [1710] = {.lex_state = 13},
  [1711] = {.lex_state = 3},
  [1712] = {.lex_state = 24},
  [1713] = {.lex_state = 24},
  [1714] = {.lex_state = 3, .external_lex_state = 2},
  [1715] = {.lex_state = 3, .external_lex_state = 2},
  [1716] = {.lex_state = 3, .external_lex_state = 2},
  [1717] = {.lex_state = 13},
  [1718] = {.lex_state = 3, .external_lex_state = 2},
  [1719] = {.lex_state = 3, .external_lex_state = 2},
  [1720] = {.lex_state = 3, .external_lex_state = 2},
  [1721] = {.lex_state = 3, .external_lex_state = 2},
  [1722] = {.lex_state = 3},
  [1723] = {.lex_state = 9},
  [1724] = {.lex_state = 3, .external_lex_state = 2},
  [1725] = {.lex_state = 3, .external_lex_state = 2},
  [1726] = {.lex_state = 3, .external_lex_state = 2},
  [1727] = {.lex_state = 2},
  [1728] = {.lex_state = 2},
  [1729] = {.lex_state = 3},
  [1730] = {.lex_state = 3},
  [1731] = {.lex_state = 2, .external_lex_state = 2},
  [1732] = {.lex_state = 3},
  [1733] = {.lex_state = 2},
  [1734] = {.lex_state = 2},
  [1735] = {.lex_state = 13},
  [1736] = {.lex_state = 13},
  [1737] = {.lex_state = 2},
  [1738] = {.lex_state = 2},
  [1739] = {.lex_state = 13},
  [1740] = {.lex_state = 2},
  [1741] = {.lex_state = 2},
  [1742] = {.lex_state = 2},
  [1743] = {.lex_state = 3},
  [1744] = {.lex_state = 3},
  [1745] = {.lex_state = 2},
  [1746] = {.lex_state = 3, .external_lex_state = 2},
  [1747] = {.lex_state = 2, .external_lex_state = 2},
  [1748] = {.lex_state = 9},
  [1749] = {.lex_state = 2},
  [1750] = {.lex_state = 9},
  [1751] = {.lex_state = 9},
  [1752] = {.lex_state = 2},
  [1753] = {.lex_state = 3},
  [1754] = {.lex_state = 13},
  [1755] = {.lex_state = 2},
  [1756] = {.lex_state = 2},
  [1757] = {.lex_state = 2},
  [1758] = {.lex_state = 2},
  [1759] = {.lex_state = 2},
  [1760] = {.lex_state = 2},
  [1761] = {.lex_state = 2},
  [1762] = {.lex_state = 2},
  [1763] = {.lex_state = 2},
  [1764] = {.lex_state = 13},
  [1765] = {.lex_state = 2},
  [1766] = {.lex_state = 2},
  [1767] = {.lex_state = 13},
  [1768] = {.lex_state = 13},
  [1769] = {.lex_state = 2, .external_lex_state = 2},
  [1770] = {.lex_state = 3},
  [1771] = {.lex_state = 2},
  [1772] = {.lex_state = 3},
  [1773] = {.lex_state = 9},
  [1774] = {.lex_state = 2},
  [1775] = {.lex_state = 2},
  [1776] = {.lex_state = 2},
  [1777] = {.lex_state = 2},
  [1778] = {.lex_state = 2},
  [1779] = {.lex_state = 2},
  [1780] = {.lex_state = 13},
  [1781] = {.lex_state = 2},
  [1782] = {.lex_state = 2},
  [1783] = {.lex_state = 2},
  [1784] = {.lex_state = 2},
  [1785] = {.lex_state = 2},
  [1786] = {.lex_state = 2},
  [1787] = {.lex_state = 13},
  [1788] = {.lex_state = 9},
  [1789] = {.lex_state = 3},
  [1790] = {.lex_state = 3},
  [1791] = {.lex_state = 2},
  [1792] = {.lex_state = 2},
  [1793] = {.lex_state = 2},
  [1794] = {.lex_state = 13},
  [1795] = {.lex_state = 2},
  [1796] = {.lex_state = 2},
  [1797] = {.lex_state = 2},
  [1798] = {.lex_state = 9},
  [1799] = {.lex_state = 2},
  [1800] = {.lex_state = 2},
  [1801] = {.lex_state = 2},
  [1802] = {.lex_state = 3, .external_lex_state = 2},
  [1803] = {.lex_state = 3},
  [1804] = {.lex_state = 13},
  [1805] = {.lex_state = 13},
  [1806] = {.lex_state = 13},
  [1807] = {.lex_state = 3},
  [1808] = {.lex_state = 3, .external_lex_state = 2},
  [1809] = {.lex_state = 3, .external_lex_state = 2},
  [1810] = {.lex_state = 3, .external_lex_state = 2},
  [1811] = {.lex_state = 3, .external_lex_state = 2},
  [1812] = {.lex_state = 9, .external_lex_state = 2},
  [1813] = {.lex_state = 2},
  [1814] = {.lex_state = 9, .external_lex_state = 2},
  [1815] = {.lex_state = 9, .external_lex_state = 2},
  [1816] = {.lex_state = 2, .external_lex_state = 2},
  [1817] = {.lex_state = 13},
  [1818] = {.lex_state = 13},
  [1819] = {.lex_state = 3},
  [1820] = {.lex_state = 13},
  [1821] = {.lex_state = 13},
  [1822] = {.lex_state = 2},
  [1823] = {.lex_state = 3, .external_lex_state = 2},
  [1824] = {.lex_state = 3, .external_lex_state = 2},
  [1825] = {.lex_state = 9, .external_lex_state = 2},
  [1826] = {.lex_state = 2, .external_lex_state = 2},
  [1827] = {.lex_state = 2},
  [1828] = {.lex_state = 3},
  [1829] = {.lex_state = 13},
  [1830] = {.lex_state = 3},
  [1831] = {.lex_state = 3},
  [1832] = {.lex_state = 13},
  [1833] = {.lex_state = 9},
  [1834] = {.lex_state = 3},
  [1835] = {.lex_state = 13},
  [1836] = {.lex_state = 3},
  [1837] = {.lex_state = 3},
  [1838] = {.lex_state = 9},
  [1839] = {.lex_state = 3},
  [1840] = {.lex_state = 3},
  [1841] = {.lex_state = 3},
  [1842] = {.lex_state = 3, .external_lex_state = 2},
  [1843] = {.lex_state = 3, .external_lex_state = 2},
  [1844] = {.lex_state = 9, .external_lex_state = 2},
  [1845] = {.lex_state = 2, .external_lex_state = 2},
  [1846] = {.lex_state = 9, .external_lex_state = 2},
  [1847] = {.lex_state = 9, .external_lex_state = 2},
  [1848] = {.lex_state = 2, .external_lex_state = 2},
  [1849] = {.lex_state = 3, .external_lex_state = 2},
  [1850] = {.lex_state = 3, .external_lex_state = 2},
  [1851] = {.lex_state = 2, .external_lex_state = 2},
  [1852] = {.lex_state = 9},
  [1853] = {.lex_state = 9, .external_lex_state = 2},
  [1854] = {.lex_state = 2, .external_lex_state = 2},
  [1855] = {.lex_state = 9, .external_lex_state = 2},
  [1856] = {.lex_state = 9, .external_lex_state = 2},
  [1857] = {.lex_state = 9, .external_lex_state = 2},
  [1858] = {.lex_state = 15, .external_lex_state = 3},
  [1859] = {.lex_state = 3},
  [1860] = {.lex_state = 9, .external_lex_state = 2},
  [1861] = {.lex_state = 4},
  [1862] = {.lex_state = 3},
  [1863] = {.lex_state = 3},
  [1864] = {.lex_state = 6},
  [1865] = {.lex_state = 3},
  [1866] = {.lex_state = 24},
  [1867] = {.lex_state = 0},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 3},
  [1870] = {.lex_state = 3},
  [1871] = {.lex_state = 15, .external_lex_state = 3},
  [1872] = {.lex_state = 3},
  [1873] = {.lex_state = 3},
  [1874] = {.lex_state = 3},
  [1875] = {.lex_state = 0, .external_lex_state = 2},
  [1876] = {.lex_state = 3},
  [1877] = {.lex_state = 0},
  [1878] = {.lex_state = 3},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 3},
  [1881] = {.lex_state = 4},
  [1882] = {.lex_state = 3},
  [1883] = {.lex_state = 2},
  [1884] = {.lex_state = 0},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 3},
  [1887] = {.lex_state = 3},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 3},
  [1890] = {.lex_state = 0},
  [1891] = {.lex_state = 3},
  [1892] = {.lex_state = 9, .external_lex_state = 2},
  [1893] = {.lex_state = 9, .external_lex_state = 2},
  [1894] = {.lex_state = 9, .external_lex_state = 2},
  [1895] = {.lex_state = 9, .external_lex_state = 2},
  [1896] = {.lex_state = 9, .external_lex_state = 2},
  [1897] = {.lex_state = 9, .external_lex_state = 2},
  [1898] = {.lex_state = 9, .external_lex_state = 2},
  [1899] = {.lex_state = 9, .external_lex_state = 2},
  [1900] = {.lex_state = 9, .external_lex_state = 2},
  [1901] = {.lex_state = 9, .external_lex_state = 2},
  [1902] = {.lex_state = 9, .external_lex_state = 2},
  [1903] = {.lex_state = 9, .external_lex_state = 2},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 3},
  [1906] = {.lex_state = 0},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 2},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 0},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 0, .external_lex_state = 2},
  [1914] = {.lex_state = 3},
  [1915] = {.lex_state = 6},
  [1916] = {.lex_state = 3},
  [1917] = {.lex_state = 15},
  [1918] = {.lex_state = 0},
  [1919] = {.lex_state = 3},
  [1920] = {.lex_state = 2},
  [1921] = {.lex_state = 3, .external_lex_state = 2},
  [1922] = {.lex_state = 3},
  [1923] = {.lex_state = 13},
  [1924] = {.lex_state = 3},
  [1925] = {.lex_state = 3},
  [1926] = {.lex_state = 24},
  [1927] = {.lex_state = 13},
  [1928] = {.lex_state = 3},
  [1929] = {.lex_state = 2, .external_lex_state = 2},
  [1930] = {.lex_state = 2, .external_lex_state = 2},
  [1931] = {.lex_state = 2, .external_lex_state = 2},
  [1932] = {.lex_state = 2, .external_lex_state = 2},
  [1933] = {.lex_state = 2, .external_lex_state = 2},
  [1934] = {.lex_state = 2, .external_lex_state = 2},
  [1935] = {.lex_state = 3},
  [1936] = {.lex_state = 3},
  [1937] = {.lex_state = 3},
  [1938] = {.lex_state = 3},
  [1939] = {.lex_state = 3},
  [1940] = {.lex_state = 3},
  [1941] = {.lex_state = 3},
  [1942] = {.lex_state = 0},
  [1943] = {.lex_state = 0, .external_lex_state = 2},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 2},
  [1946] = {.lex_state = 3},
  [1947] = {.lex_state = 3},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 3},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 3},
  [1952] = {.lex_state = 2},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 0},
  [1955] = {.lex_state = 0},
  [1956] = {.lex_state = 3},
  [1957] = {.lex_state = 3},
  [1958] = {.lex_state = 2, .external_lex_state = 2},
  [1959] = {.lex_state = 3},
  [1960] = {.lex_state = 3},
  [1961] = {.lex_state = 3},
  [1962] = {.lex_state = 0},
  [1963] = {.lex_state = 0},
  [1964] = {.lex_state = 3},
  [1965] = {.lex_state = 3},
  [1966] = {.lex_state = 0},
  [1967] = {.lex_state = 3},
  [1968] = {.lex_state = 0},
  [1969] = {.lex_state = 2},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 3, .external_lex_state = 2},
  [1972] = {.lex_state = 3},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 3},
  [1977] = {.lex_state = 0},
  [1978] = {.lex_state = 0, .external_lex_state = 2},
  [1979] = {.lex_state = 0},
  [1980] = {.lex_state = 0, .external_lex_state = 2},
  [1981] = {.lex_state = 0},
  [1982] = {.lex_state = 0, .external_lex_state = 2},
  [1983] = {.lex_state = 2, .external_lex_state = 2},
  [1984] = {.lex_state = 2, .external_lex_state = 2},
  [1985] = {.lex_state = 2, .external_lex_state = 2},
  [1986] = {.lex_state = 2, .external_lex_state = 2},
  [1987] = {.lex_state = 2, .external_lex_state = 2},
  [1988] = {.lex_state = 2, .external_lex_state = 2},
  [1989] = {.lex_state = 2},
  [1990] = {.lex_state = 3},
  [1991] = {.lex_state = 3},
  [1992] = {.lex_state = 0},
  [1993] = {.lex_state = 2, .external_lex_state = 2},
  [1994] = {.lex_state = 2, .external_lex_state = 2},
  [1995] = {.lex_state = 0},
  [1996] = {.lex_state = 2},
  [1997] = {.lex_state = 2, .external_lex_state = 2},
  [1998] = {.lex_state = 2, .external_lex_state = 2},
  [1999] = {.lex_state = 3},
  [2000] = {.lex_state = 0},
  [2001] = {.lex_state = 3},
  [2002] = {.lex_state = 0},
  [2003] = {.lex_state = 3},
  [2004] = {.lex_state = 0},
  [2005] = {.lex_state = 3},
  [2006] = {.lex_state = 3},
  [2007] = {.lex_state = 0, .external_lex_state = 2},
  [2008] = {.lex_state = 3},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 3},
  [2011] = {.lex_state = 13},
  [2012] = {.lex_state = 13},
  [2013] = {.lex_state = 0},
  [2014] = {.lex_state = 0},
  [2015] = {.lex_state = 0},
  [2016] = {.lex_state = 0},
  [2017] = {.lex_state = 0},
  [2018] = {.lex_state = 0},
  [2019] = {.lex_state = 3},
  [2020] = {.lex_state = 0},
  [2021] = {.lex_state = 3},
  [2022] = {.lex_state = 3, .external_lex_state = 2},
  [2023] = {.lex_state = 0, .external_lex_state = 2},
  [2024] = {.lex_state = 3},
  [2025] = {.lex_state = 0},
  [2026] = {.lex_state = 2},
  [2027] = {.lex_state = 0, .external_lex_state = 2},
  [2028] = {.lex_state = 0},
  [2029] = {.lex_state = 0},
  [2030] = {.lex_state = 3},
  [2031] = {.lex_state = 0, .external_lex_state = 2},
  [2032] = {.lex_state = 3},
  [2033] = {.lex_state = 3},
  [2034] = {.lex_state = 3},
  [2035] = {.lex_state = 0},
  [2036] = {.lex_state = 2, .external_lex_state = 2},
  [2037] = {.lex_state = 2, .external_lex_state = 2},
  [2038] = {.lex_state = 0, .external_lex_state = 2},
  [2039] = {.lex_state = 0},
  [2040] = {.lex_state = 2, .external_lex_state = 2},
  [2041] = {.lex_state = 0},
  [2042] = {.lex_state = 0},
  [2043] = {.lex_state = 0},
  [2044] = {.lex_state = 2},
  [2045] = {.lex_state = 0, .external_lex_state = 2},
  [2046] = {.lex_state = 3, .external_lex_state = 2},
  [2047] = {.lex_state = 3, .external_lex_state = 2},
  [2048] = {.lex_state = 3, .external_lex_state = 2},
  [2049] = {.lex_state = 3, .external_lex_state = 2},
  [2050] = {.lex_state = 0},
  [2051] = {.lex_state = 0},
  [2052] = {.lex_state = 0},
  [2053] = {.lex_state = 0},
  [2054] = {.lex_state = 0},
  [2055] = {.lex_state = 0},
  [2056] = {.lex_state = 2, .external_lex_state = 2},
  [2057] = {.lex_state = 0},
  [2058] = {.lex_state = 3},
  [2059] = {.lex_state = 0},
  [2060] = {.lex_state = 0},
  [2061] = {.lex_state = 0},
  [2062] = {.lex_state = 0},
  [2063] = {.lex_state = 0},
  [2064] = {.lex_state = 3},
  [2065] = {.lex_state = 0, .external_lex_state = 2},
  [2066] = {.lex_state = 3},
  [2067] = {.lex_state = 0, .external_lex_state = 2},
  [2068] = {.lex_state = 0},
  [2069] = {.lex_state = 0},
  [2070] = {.lex_state = 3},
  [2071] = {.lex_state = 13},
  [2072] = {.lex_state = 3},
  [2073] = {.lex_state = 0},
  [2074] = {.lex_state = 0},
  [2075] = {.lex_state = 3, .external_lex_state = 2},
  [2076] = {.lex_state = 3},
  [2077] = {.lex_state = 0, .external_lex_state = 2},
  [2078] = {.lex_state = 0, .external_lex_state = 2},
  [2079] = {.lex_state = 0},
  [2080] = {.lex_state = 0, .external_lex_state = 2},
  [2081] = {.lex_state = 0, .external_lex_state = 2},
  [2082] = {.lex_state = 0},
  [2083] = {.lex_state = 3},
  [2084] = {.lex_state = 3},
  [2085] = {.lex_state = 0},
  [2086] = {.lex_state = 0},
  [2087] = {.lex_state = 2, .external_lex_state = 2},
  [2088] = {.lex_state = 3},
  [2089] = {.lex_state = 0},
  [2090] = {.lex_state = 0},
  [2091] = {.lex_state = 0},
  [2092] = {.lex_state = 0},
  [2093] = {.lex_state = 3},
  [2094] = {.lex_state = 0, .external_lex_state = 2},
  [2095] = {.lex_state = 3},
  [2096] = {.lex_state = 3},
  [2097] = {.lex_state = 0, .external_lex_state = 2},
  [2098] = {.lex_state = 0, .external_lex_state = 2},
  [2099] = {.lex_state = 0, .external_lex_state = 2},
  [2100] = {.lex_state = 0, .external_lex_state = 2},
  [2101] = {.lex_state = 0},
  [2102] = {.lex_state = 3},
  [2103] = {.lex_state = 0, .external_lex_state = 2},
  [2104] = {.lex_state = 0, .external_lex_state = 2},
  [2105] = {.lex_state = 0, .external_lex_state = 2},
  [2106] = {.lex_state = 0, .external_lex_state = 2},
  [2107] = {.lex_state = 0, .external_lex_state = 2},
  [2108] = {.lex_state = 0, .external_lex_state = 2},
  [2109] = {.lex_state = 0, .external_lex_state = 2},
  [2110] = {.lex_state = 0, .external_lex_state = 2},
  [2111] = {.lex_state = 2},
  [2112] = {.lex_state = 3},
  [2113] = {.lex_state = 2},
  [2114] = {.lex_state = 2},
  [2115] = {.lex_state = 2},
  [2116] = {.lex_state = 2},
  [2117] = {.lex_state = 2},
  [2118] = {.lex_state = 2},
  [2119] = {.lex_state = 3, .external_lex_state = 2},
  [2120] = {.lex_state = 3, .external_lex_state = 2},
  [2121] = {.lex_state = 2},
  [2122] = {.lex_state = 2, .external_lex_state = 2},
  [2123] = {.lex_state = 2},
  [2124] = {.lex_state = 2},
  [2125] = {.lex_state = 2},
  [2126] = {.lex_state = 2},
  [2127] = {.lex_state = 2},
  [2128] = {.lex_state = 3},
  [2129] = {.lex_state = 3},
  [2130] = {.lex_state = 3},
  [2131] = {.lex_state = 3},
  [2132] = {.lex_state = 2},
  [2133] = {.lex_state = 2},
  [2134] = {.lex_state = 2},
  [2135] = {.lex_state = 2},
  [2136] = {.lex_state = 2},
  [2137] = {.lex_state = 2},
  [2138] = {.lex_state = 2},
  [2139] = {.lex_state = 2},
  [2140] = {.lex_state = 4},
  [2141] = {.lex_state = 3},
  [2142] = {.lex_state = 6},
  [2143] = {.lex_state = 3},
  [2144] = {.lex_state = 24},
  [2145] = {.lex_state = 3},
  [2146] = {.lex_state = 4},
  [2147] = {.lex_state = 3},
  [2148] = {.lex_state = 3},
  [2149] = {.lex_state = 0},
  [2150] = {.lex_state = 2},
  [2151] = {.lex_state = 6},
  [2152] = {.lex_state = 3},
  [2153] = {.lex_state = 15},
  [2154] = {.lex_state = 24},
  [2155] = {.lex_state = 3},
  [2156] = {.lex_state = 3},
  [2157] = {.lex_state = 0},
  [2158] = {.lex_state = 3},
  [2159] = {.lex_state = 0},
  [2160] = {.lex_state = 3},
  [2161] = {.lex_state = 2},
  [2162] = {.lex_state = 0},
  [2163] = {.lex_state = 0},
  [2164] = {.lex_state = 3},
  [2165] = {.lex_state = 3},
  [2166] = {.lex_state = 3},
  [2167] = {.lex_state = 2},
  [2168] = {.lex_state = 3, .external_lex_state = 2},
  [2169] = {.lex_state = 0},
  [2170] = {.lex_state = 0},
  [2171] = {.lex_state = 3},
  [2172] = {.lex_state = 3},
  [2173] = {.lex_state = 3},
  [2174] = {.lex_state = 0, .external_lex_state = 2},
  [2175] = {.lex_state = 3},
  [2176] = {.lex_state = 0},
  [2177] = {.lex_state = 3},
  [2178] = {.lex_state = 13},
  [2179] = {.lex_state = 13},
  [2180] = {.lex_state = 0},
  [2181] = {.lex_state = 0},
  [2182] = {.lex_state = 0},
  [2183] = {.lex_state = 3},
  [2184] = {.lex_state = 0},
  [2185] = {.lex_state = 0},
  [2186] = {.lex_state = 3},
  [2187] = {.lex_state = 3},
  [2188] = {.lex_state = 0},
  [2189] = {.lex_state = 0},
  [2190] = {.lex_state = 0},
  [2191] = {.lex_state = 0},
  [2192] = {.lex_state = 0},
  [2193] = {.lex_state = 0},
  [2194] = {.lex_state = 0, .external_lex_state = 2},
  [2195] = {.lex_state = 3},
  [2196] = {.lex_state = 0, .external_lex_state = 2},
  [2197] = {.lex_state = 0},
  [2198] = {.lex_state = 0},
  [2199] = {.lex_state = 3},
  [2200] = {.lex_state = 13},
  [2201] = {.lex_state = 0},
  [2202] = {.lex_state = 0},
  [2203] = {.lex_state = 3},
  [2204] = {.lex_state = 0},
  [2205] = {.lex_state = 3},
  [2206] = {.lex_state = 3},
  [2207] = {.lex_state = 0, .external_lex_state = 2},
  [2208] = {.lex_state = 0},
  [2209] = {.lex_state = 3},
  [2210] = {.lex_state = 3},
  [2211] = {.lex_state = 2},
  [2212] = {.lex_state = 2},
  [2213] = {.lex_state = 2},
  [2214] = {.lex_state = 2},
  [2215] = {.lex_state = 2},
  [2216] = {.lex_state = 2},
  [2217] = {.lex_state = 2},
  [2218] = {.lex_state = 2},
  [2219] = {.lex_state = 2},
  [2220] = {.lex_state = 2},
  [2221] = {.lex_state = 2},
  [2222] = {.lex_state = 2},
  [2223] = {.lex_state = 3},
  [2224] = {.lex_state = 3},
  [2225] = {.lex_state = 2},
  [2226] = {.lex_state = 2},
  [2227] = {.lex_state = 2},
  [2228] = {.lex_state = 2},
  [2229] = {.lex_state = 2},
  [2230] = {.lex_state = 2},
  [2231] = {.lex_state = 2},
  [2232] = {.lex_state = 2},
  [2233] = {.lex_state = 4},
  [2234] = {.lex_state = 3},
  [2235] = {.lex_state = 6},
  [2236] = {.lex_state = 24},
  [2237] = {.lex_state = 4},
  [2238] = {.lex_state = 3},
  [2239] = {.lex_state = 3},
  [2240] = {.lex_state = 6},
  [2241] = {.lex_state = 3},
  [2242] = {.lex_state = 24},
  [2243] = {.lex_state = 3},
  [2244] = {.lex_state = 3},
  [2245] = {.lex_state = 0},
  [2246] = {.lex_state = 3},
  [2247] = {.lex_state = 0},
  [2248] = {.lex_state = 3},
  [2249] = {.lex_state = 3},
  [2250] = {.lex_state = 3},
  [2251] = {.lex_state = 0},
  [2252] = {.lex_state = 3},
  [2253] = {.lex_state = 3},
  [2254] = {.lex_state = 0, .external_lex_state = 2},
  [2255] = {.lex_state = 3},
  [2256] = {.lex_state = 0},
  [2257] = {.lex_state = 3},
  [2258] = {.lex_state = 13},
  [2259] = {.lex_state = 13},
  [2260] = {.lex_state = 0},
  [2261] = {.lex_state = 0},
  [2262] = {.lex_state = 3},
  [2263] = {.lex_state = 0},
  [2264] = {.lex_state = 0},
  [2265] = {.lex_state = 0},
  [2266] = {.lex_state = 0},
  [2267] = {.lex_state = 0},
  [2268] = {.lex_state = 0, .external_lex_state = 2},
  [2269] = {.lex_state = 3},
  [2270] = {.lex_state = 0, .external_lex_state = 2},
  [2271] = {.lex_state = 0},
  [2272] = {.lex_state = 0},
  [2273] = {.lex_state = 3},
  [2274] = {.lex_state = 13},
  [2275] = {.lex_state = 3},
  [2276] = {.lex_state = 3},
  [2277] = {.lex_state = 0, .external_lex_state = 2},
  [2278] = {.lex_state = 3},
  [2279] = {.lex_state = 3},
  [2280] = {.lex_state = 3},
  [2281] = {.lex_state = 4},
  [2282] = {.lex_state = 6},
  [2283] = {.lex_state = 4},
  [2284] = {.lex_state = 3},
  [2285] = {.lex_state = 3},
  [2286] = {.lex_state = 6},
  [2287] = {.lex_state = 3},
  [2288] = {.lex_state = 0},
  [2289] = {.lex_state = 3},
  [2290] = {.lex_state = 3},
  [2291] = {.lex_state = 3},
  [2292] = {.lex_state = 3},
  [2293] = {.lex_state = 0},
  [2294] = {.lex_state = 13},
  [2295] = {.lex_state = 0},
  [2296] = {.lex_state = 0},
  [2297] = {.lex_state = 3},
  [2298] = {.lex_state = 0},
  [2299] = {.lex_state = 13},
  [2300] = {.lex_state = 3},
  [2301] = {.lex_state = 4},
  [2302] = {.lex_state = 6},
  [2303] = {.lex_state = 4},
  [2304] = {.lex_state = 6},
  [2305] = {.lex_state = 3},
  [2306] = {.lex_state = 3},
  [2307] = {.lex_state = 3},
  [2308] = {.lex_state = 3},
  [2309] = {.lex_state = 3},
  [2310] = {.lex_state = 3},
  [2311] = {.lex_state = 3},
  [2312] = {.lex_state = 3},
  [2313] = {.lex_state = 3},
  [2314] = {.lex_state = 9, .external_lex_state = 2},
  [2315] = {.lex_state = 9, .external_lex_state = 2},
  [2316] = {.lex_state = 9, .external_lex_state = 2},
  [2317] = {.lex_state = 3},
  [2318] = {.lex_state = 3},
  [2319] = {.lex_state = 3},
  [2320] = {.lex_state = 0},
  [2321] = {.lex_state = 9, .external_lex_state = 2},
  [2322] = {.lex_state = 3},
  [2323] = {.lex_state = 9, .external_lex_state = 2},
  [2324] = {.lex_state = 3},
  [2325] = {.lex_state = 9, .external_lex_state = 2},
  [2326] = {.lex_state = 3},
  [2327] = {.lex_state = 9, .external_lex_state = 2},
  [2328] = {.lex_state = 3},
  [2329] = {.lex_state = 0},
  [2330] = {.lex_state = 8},
  [2331] = {.lex_state = 3},
  [2332] = {.lex_state = 9, .external_lex_state = 2},
  [2333] = {.lex_state = 0},
  [2334] = {.lex_state = 3},
  [2335] = {.lex_state = 3},
  [2336] = {.lex_state = 3},
  [2337] = {.lex_state = 3},
  [2338] = {.lex_state = 3},
  [2339] = {.lex_state = 3},
  [2340] = {.lex_state = 3},
  [2341] = {.lex_state = 3},
  [2342] = {.lex_state = 3},
  [2343] = {.lex_state = 9, .external_lex_state = 2},
  [2344] = {.lex_state = 9, .external_lex_state = 2},
  [2345] = {.lex_state = 9, .external_lex_state = 2},
  [2346] = {.lex_state = 9, .external_lex_state = 2},
  [2347] = {.lex_state = 3},
  [2348] = {.lex_state = 9, .external_lex_state = 2},
  [2349] = {.lex_state = 2, .external_lex_state = 2},
  [2350] = {.lex_state = 3},
  [2351] = {.lex_state = 2, .external_lex_state = 2},
  [2352] = {.lex_state = 3},
  [2353] = {.lex_state = 3},
  [2354] = {.lex_state = 13},
  [2355] = {.lex_state = 3},
  [2356] = {.lex_state = 3},
  [2357] = {.lex_state = 2, .external_lex_state = 2},
  [2358] = {.lex_state = 3},
  [2359] = {.lex_state = 0, .external_lex_state = 2},
  [2360] = {.lex_state = 0, .external_lex_state = 2},
  [2361] = {.lex_state = 2, .external_lex_state = 2},
  [2362] = {.lex_state = 0},
  [2363] = {.lex_state = 3},
  [2364] = {.lex_state = 3},
  [2365] = {.lex_state = 3},
  [2366] = {.lex_state = 3},
  [2367] = {.lex_state = 3},
  [2368] = {.lex_state = 3},
  [2369] = {.lex_state = 3},
  [2370] = {.lex_state = 3},
  [2371] = {.lex_state = 3},
  [2372] = {.lex_state = 9, .external_lex_state = 2},
  [2373] = {.lex_state = 9, .external_lex_state = 2},
  [2374] = {.lex_state = 9, .external_lex_state = 2},
  [2375] = {.lex_state = 9, .external_lex_state = 2},
  [2376] = {.lex_state = 9, .external_lex_state = 2},
  [2377] = {.lex_state = 3},
  [2378] = {.lex_state = 3},
  [2379] = {.lex_state = 3},
  [2380] = {.lex_state = 2, .external_lex_state = 2},
  [2381] = {.lex_state = 3},
  [2382] = {.lex_state = 3},
  [2383] = {.lex_state = 3},
  [2384] = {.lex_state = 3},
  [2385] = {.lex_state = 3},
  [2386] = {.lex_state = 3},
  [2387] = {.lex_state = 3},
  [2388] = {.lex_state = 3},
  [2389] = {.lex_state = 3},
  [2390] = {.lex_state = 3},
  [2391] = {.lex_state = 3},
  [2392] = {.lex_state = 3},
  [2393] = {.lex_state = 3},
  [2394] = {.lex_state = 3},
  [2395] = {.lex_state = 3},
  [2396] = {.lex_state = 13},
  [2397] = {.lex_state = 13},
  [2398] = {.lex_state = 13},
  [2399] = {.lex_state = 3},
  [2400] = {.lex_state = 13},
  [2401] = {.lex_state = 13},
  [2402] = {.lex_state = 0},
  [2403] = {.lex_state = 3},
  [2404] = {.lex_state = 0},
  [2405] = {.lex_state = 3},
  [2406] = {.lex_state = 3},
  [2407] = {.lex_state = 13},
  [2408] = {.lex_state = 2},
  [2409] = {.lex_state = 9},
  [2410] = {.lex_state = 3},
  [2411] = {.lex_state = 3},
  [2412] = {.lex_state = 3},
  [2413] = {.lex_state = 0},
  [2414] = {.lex_state = 3},
  [2415] = {.lex_state = 3},
  [2416] = {.lex_state = 3},
  [2417] = {.lex_state = 3},
  [2418] = {.lex_state = 3},
  [2419] = {.lex_state = 3},
  [2420] = {.lex_state = 3},
  [2421] = {.lex_state = 3},
  [2422] = {.lex_state = 3},
  [2423] = {.lex_state = 3},
  [2424] = {.lex_state = 3},
  [2425] = {.lex_state = 3},
  [2426] = {.lex_state = 3},
  [2427] = {.lex_state = 0},
  [2428] = {.lex_state = 3},
  [2429] = {.lex_state = 3},
  [2430] = {.lex_state = 3},
  [2431] = {.lex_state = 3},
  [2432] = {.lex_state = 3},
  [2433] = {.lex_state = 3},
  [2434] = {.lex_state = 13},
  [2435] = {.lex_state = 13},
  [2436] = {.lex_state = 3},
  [2437] = {.lex_state = 0},
  [2438] = {.lex_state = 13},
  [2439] = {.lex_state = 13},
  [2440] = {.lex_state = 13},
  [2441] = {.lex_state = 0},
  [2442] = {.lex_state = 3},
  [2443] = {.lex_state = 13},
  [2444] = {.lex_state = 3},
  [2445] = {.lex_state = 3},
  [2446] = {.lex_state = 3},
  [2447] = {.lex_state = 0, .external_lex_state = 2},
  [2448] = {.lex_state = 3},
  [2449] = {.lex_state = 3},
  [2450] = {.lex_state = 3},
  [2451] = {.lex_state = 9, .external_lex_state = 2},
  [2452] = {.lex_state = 3},
  [2453] = {.lex_state = 0},
  [2454] = {.lex_state = 3},
  [2455] = {.lex_state = 3},
  [2456] = {.lex_state = 13},
  [2457] = {.lex_state = 3},
  [2458] = {.lex_state = 13},
  [2459] = {.lex_state = 0},
  [2460] = {.lex_state = 0},
  [2461] = {.lex_state = 2},
  [2462] = {.lex_state = 9},
  [2463] = {.lex_state = 3},
  [2464] = {.lex_state = 3},
  [2465] = {.lex_state = 3},
  [2466] = {.lex_state = 0, .external_lex_state = 2},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 3},
  [2469] = {.lex_state = 13},
  [2470] = {.lex_state = 3},
  [2471] = {.lex_state = 3},
  [2472] = {.lex_state = 3},
  [2473] = {.lex_state = 0},
  [2474] = {.lex_state = 3},
  [2475] = {.lex_state = 3},
  [2476] = {.lex_state = 3},
  [2477] = {.lex_state = 3},
  [2478] = {.lex_state = 3},
  [2479] = {.lex_state = 3},
  [2480] = {.lex_state = 3},
  [2481] = {.lex_state = 3},
  [2482] = {.lex_state = 2},
  [2483] = {.lex_state = 3},
  [2484] = {.lex_state = 3},
  [2485] = {.lex_state = 3},
  [2486] = {.lex_state = 3},
  [2487] = {.lex_state = 3},
  [2488] = {.lex_state = 3},
  [2489] = {.lex_state = 3},
  [2490] = {.lex_state = 3},
  [2491] = {.lex_state = 9},
  [2492] = {.lex_state = 9},
  [2493] = {.lex_state = 9},
  [2494] = {.lex_state = 9},
  [2495] = {.lex_state = 9},
  [2496] = {.lex_state = 2},
  [2497] = {.lex_state = 2},
  [2498] = {.lex_state = 3},
  [2499] = {.lex_state = 2},
  [2500] = {.lex_state = 2},
  [2501] = {.lex_state = 9},
  [2502] = {.lex_state = 9},
  [2503] = {.lex_state = 9},
  [2504] = {.lex_state = 9},
  [2505] = {.lex_state = 9},
  [2506] = {.lex_state = 2},
  [2507] = {.lex_state = 3},
  [2508] = {.lex_state = 3},
  [2509] = {.lex_state = 3},
  [2510] = {.lex_state = 3},
  [2511] = {.lex_state = 3},
  [2512] = {.lex_state = 3},
  [2513] = {.lex_state = 3},
  [2514] = {.lex_state = 3},
  [2515] = {.lex_state = 3},
  [2516] = {.lex_state = 3},
  [2517] = {.lex_state = 3},
  [2518] = {.lex_state = 3},
  [2519] = {.lex_state = 9},
  [2520] = {.lex_state = 9},
  [2521] = {.lex_state = 3},
  [2522] = {.lex_state = 3},
  [2523] = {.lex_state = 9},
  [2524] = {.lex_state = 3},
  [2525] = {.lex_state = 3},
  [2526] = {.lex_state = 3},
  [2527] = {.lex_state = 9},
  [2528] = {.lex_state = 3, .external_lex_state = 2},
  [2529] = {.lex_state = 13},
  [2530] = {.lex_state = 3, .external_lex_state = 2},
  [2531] = {.lex_state = 3},
  [2532] = {.lex_state = 3},
  [2533] = {.lex_state = 3},
  [2534] = {.lex_state = 0},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 0},
  [2538] = {.lex_state = 2},
  [2539] = {.lex_state = 0},
  [2540] = {.lex_state = 8},
  [2541] = {.lex_state = 13},
  [2542] = {.lex_state = 3},
  [2543] = {.lex_state = 3},
  [2544] = {.lex_state = 3},
  [2545] = {.lex_state = 3},
  [2546] = {.lex_state = 3},
  [2547] = {.lex_state = 3},
  [2548] = {.lex_state = 13},
  [2549] = {.lex_state = 3},
  [2550] = {.lex_state = 13},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 0},
  [2553] = {.lex_state = 3},
  [2554] = {.lex_state = 3},
  [2555] = {.lex_state = 3},
  [2556] = {.lex_state = 3},
  [2557] = {.lex_state = 3},
  [2558] = {.lex_state = 13},
  [2559] = {.lex_state = 3},
  [2560] = {.lex_state = 0},
  [2561] = {.lex_state = 3},
  [2562] = {.lex_state = 0},
  [2563] = {.lex_state = 0},
  [2564] = {.lex_state = 3},
  [2565] = {.lex_state = 3},
  [2566] = {.lex_state = 2},
  [2567] = {.lex_state = 3},
  [2568] = {.lex_state = 3},
  [2569] = {.lex_state = 3},
  [2570] = {.lex_state = 3},
  [2571] = {.lex_state = 3},
  [2572] = {.lex_state = 3},
  [2573] = {.lex_state = 3},
  [2574] = {.lex_state = 3},
  [2575] = {.lex_state = 9},
  [2576] = {.lex_state = 9},
  [2577] = {.lex_state = 9},
  [2578] = {.lex_state = 9},
  [2579] = {.lex_state = 9},
  [2580] = {.lex_state = 2},
  [2581] = {.lex_state = 2},
  [2582] = {.lex_state = 3},
  [2583] = {.lex_state = 2},
  [2584] = {.lex_state = 2},
  [2585] = {.lex_state = 9},
  [2586] = {.lex_state = 9},
  [2587] = {.lex_state = 9},
  [2588] = {.lex_state = 9},
  [2589] = {.lex_state = 2},
  [2590] = {.lex_state = 3},
  [2591] = {.lex_state = 3},
  [2592] = {.lex_state = 3},
  [2593] = {.lex_state = 3},
  [2594] = {.lex_state = 3},
  [2595] = {.lex_state = 3},
  [2596] = {.lex_state = 3},
  [2597] = {.lex_state = 3},
  [2598] = {.lex_state = 3},
  [2599] = {.lex_state = 3},
  [2600] = {.lex_state = 3},
  [2601] = {.lex_state = 3},
  [2602] = {.lex_state = 9},
  [2603] = {.lex_state = 9},
  [2604] = {.lex_state = 3},
  [2605] = {.lex_state = 3},
  [2606] = {.lex_state = 9},
  [2607] = {.lex_state = 3},
  [2608] = {.lex_state = 9},
  [2609] = {.lex_state = 3},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 0},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 0},
  [2614] = {.lex_state = 2},
  [2615] = {.lex_state = 13},
  [2616] = {.lex_state = 3},
  [2617] = {.lex_state = 3},
  [2618] = {.lex_state = 3},
  [2619] = {.lex_state = 3},
  [2620] = {.lex_state = 13},
  [2621] = {.lex_state = 3},
  [2622] = {.lex_state = 13},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 3},
  [2626] = {.lex_state = 3},
  [2627] = {.lex_state = 3},
  [2628] = {.lex_state = 13},
  [2629] = {.lex_state = 3},
  [2630] = {.lex_state = 0},
  [2631] = {.lex_state = 3},
  [2632] = {.lex_state = 3},
  [2633] = {.lex_state = 3},
  [2634] = {.lex_state = 3},
  [2635] = {.lex_state = 3},
  [2636] = {.lex_state = 3},
  [2637] = {.lex_state = 9},
  [2638] = {.lex_state = 9},
  [2639] = {.lex_state = 9},
  [2640] = {.lex_state = 9},
  [2641] = {.lex_state = 9},
  [2642] = {.lex_state = 3},
  [2643] = {.lex_state = 9},
  [2644] = {.lex_state = 9},
  [2645] = {.lex_state = 9},
  [2646] = {.lex_state = 9},
  [2647] = {.lex_state = 3},
  [2648] = {.lex_state = 3},
  [2649] = {.lex_state = 3},
  [2650] = {.lex_state = 3},
  [2651] = {.lex_state = 3},
  [2652] = {.lex_state = 3},
  [2653] = {.lex_state = 3},
  [2654] = {.lex_state = 3},
  [2655] = {.lex_state = 3},
  [2656] = {.lex_state = 3},
  [2657] = {.lex_state = 3},
  [2658] = {.lex_state = 3},
  [2659] = {.lex_state = 3},
  [2660] = {.lex_state = 3},
  [2661] = {.lex_state = 3},
  [2662] = {.lex_state = 9},
  [2663] = {.lex_state = 3},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 0},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 2},
  [2669] = {.lex_state = 13},
  [2670] = {.lex_state = 3},
  [2671] = {.lex_state = 3},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 0},
  [2674] = {.lex_state = 3},
  [2675] = {.lex_state = 3},
  [2676] = {.lex_state = 3},
  [2677] = {.lex_state = 3},
  [2678] = {.lex_state = 2, .external_lex_state = 2},
  [2679] = {.lex_state = 3},
  [2680] = {.lex_state = 3},
  [2681] = {.lex_state = 3},
  [2682] = {.lex_state = 3},
  [2683] = {.lex_state = 3},
  [2684] = {.lex_state = 3},
  [2685] = {.lex_state = 9, .external_lex_state = 2},
  [2686] = {.lex_state = 2, .external_lex_state = 2},
  [2687] = {.lex_state = 0},
  [2688] = {.lex_state = 2, .external_lex_state = 2},
  [2689] = {.lex_state = 3},
  [2690] = {.lex_state = 3},
  [2691] = {.lex_state = 3},
  [2692] = {.lex_state = 3},
  [2693] = {.lex_state = 3},
  [2694] = {.lex_state = 3},
  [2695] = {.lex_state = 3},
  [2696] = {.lex_state = 3},
  [2697] = {.lex_state = 0},
  [2698] = {.lex_state = 0},
  [2699] = {.lex_state = 3},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 24},
  [2702] = {.lex_state = 3},
  [2703] = {.lex_state = 3},
  [2704] = {.lex_state = 3},
  [2705] = {.lex_state = 3},
  [2706] = {.lex_state = 0},
  [2707] = {.lex_state = 0},
  [2708] = {.lex_state = 3},
  [2709] = {.lex_state = 2},
  [2710] = {.lex_state = 3},
  [2711] = {.lex_state = 3},
  [2712] = {.lex_state = 3},
  [2713] = {.lex_state = 3},
  [2714] = {.lex_state = 24},
  [2715] = {.lex_state = 2},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 3},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0},
  [2721] = {.lex_state = 9},
  [2722] = {.lex_state = 9},
  [2723] = {.lex_state = 9},
  [2724] = {.lex_state = 9},
  [2725] = {.lex_state = 9},
  [2726] = {.lex_state = 3, .external_lex_state = 2},
  [2727] = {.lex_state = 3},
  [2728] = {.lex_state = 3, .external_lex_state = 2},
  [2729] = {.lex_state = 3},
  [2730] = {.lex_state = 3},
  [2731] = {.lex_state = 0},
  [2732] = {.lex_state = 2},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 3},
  [2735] = {.lex_state = 3},
  [2736] = {.lex_state = 3, .external_lex_state = 2},
  [2737] = {.lex_state = 3},
  [2738] = {.lex_state = 3},
  [2739] = {.lex_state = 3},
  [2740] = {.lex_state = 3, .external_lex_state = 2},
  [2741] = {.lex_state = 3},
  [2742] = {.lex_state = 3},
  [2743] = {.lex_state = 3},
  [2744] = {.lex_state = 3},
  [2745] = {.lex_state = 2},
  [2746] = {.lex_state = 3},
  [2747] = {.lex_state = 3},
  [2748] = {.lex_state = 9},
  [2749] = {.lex_state = 2},
  [2750] = {.lex_state = 2},
  [2751] = {.lex_state = 9},
  [2752] = {.lex_state = 3},
  [2753] = {.lex_state = 2},
  [2754] = {.lex_state = 2},
  [2755] = {.lex_state = 2},
  [2756] = {.lex_state = 2},
  [2757] = {.lex_state = 2},
  [2758] = {.lex_state = 2},
  [2759] = {.lex_state = 3},
  [2760] = {.lex_state = 3},
  [2761] = {.lex_state = 2},
  [2762] = {.lex_state = 2},
  [2763] = {.lex_state = 2},
  [2764] = {.lex_state = 2},
  [2765] = {.lex_state = 2},
  [2766] = {.lex_state = 2},
  [2767] = {.lex_state = 2},
  [2768] = {.lex_state = 2},
  [2769] = {.lex_state = 2},
  [2770] = {.lex_state = 2},
  [2771] = {.lex_state = 2},
  [2772] = {.lex_state = 2},
  [2773] = {.lex_state = 2},
  [2774] = {.lex_state = 2},
  [2775] = {.lex_state = 3},
  [2776] = {.lex_state = 3},
  [2777] = {.lex_state = 2},
  [2778] = {.lex_state = 2},
  [2779] = {.lex_state = 2},
  [2780] = {.lex_state = 2},
  [2781] = {.lex_state = 2},
  [2782] = {.lex_state = 3},
  [2783] = {.lex_state = 24},
  [2784] = {.lex_state = 3},
  [2785] = {.lex_state = 24},
  [2786] = {.lex_state = 3},
  [2787] = {.lex_state = 3},
  [2788] = {.lex_state = 9},
  [2789] = {.lex_state = 2},
  [2790] = {.lex_state = 2},
  [2791] = {.lex_state = 3},
  [2792] = {.lex_state = 9},
  [2793] = {.lex_state = 2},
  [2794] = {.lex_state = 2},
  [2795] = {.lex_state = 3},
  [2796] = {.lex_state = 3},
  [2797] = {.lex_state = 3},
  [2798] = {.lex_state = 3},
  [2799] = {.lex_state = 3},
  [2800] = {.lex_state = 3},
  [2801] = {.lex_state = 0},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 3},
  [2804] = {.lex_state = 3},
  [2805] = {.lex_state = 0},
  [2806] = {.lex_state = 3},
  [2807] = {.lex_state = 3},
  [2808] = {.lex_state = 9, .external_lex_state = 2},
  [2809] = {.lex_state = 9, .external_lex_state = 2},
  [2810] = {.lex_state = 3},
  [2811] = {.lex_state = 3},
  [2812] = {.lex_state = 3},
  [2813] = {.lex_state = 3},
  [2814] = {.lex_state = 3},
  [2815] = {.lex_state = 3},
  [2816] = {.lex_state = 3},
  [2817] = {.lex_state = 3},
  [2818] = {.lex_state = 3},
  [2819] = {.lex_state = 3},
  [2820] = {.lex_state = 3},
  [2821] = {.lex_state = 3},
  [2822] = {.lex_state = 9, .external_lex_state = 2},
  [2823] = {.lex_state = 9, .external_lex_state = 2},
  [2824] = {.lex_state = 9, .external_lex_state = 2},
  [2825] = {.lex_state = 9, .external_lex_state = 2},
  [2826] = {.lex_state = 3},
  [2827] = {.lex_state = 9, .external_lex_state = 2},
  [2828] = {.lex_state = 9, .external_lex_state = 2},
  [2829] = {.lex_state = 0},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 3},
  [2833] = {.lex_state = 3},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 2},
  [2836] = {.lex_state = 3},
  [2837] = {.lex_state = 3},
  [2838] = {.lex_state = 9, .external_lex_state = 2},
  [2839] = {.lex_state = 3},
  [2840] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
  },
  [1] = {
    [sym_generator_function_declaration] = STATE(62),
    [sym__declaration] = STATE(62),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(62),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(62),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(62),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(62),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(62),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(62),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(62),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(62),
    [sym_function_declaration] = STATE(62),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(62),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_labeled_statement] = STATE(62),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(62),
    [sym_class_declaration] = STATE(62),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(62),
    [sym_ambient_declaration] = STATE(62),
    [sym_type_alias_declaration] = STATE(62),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(62),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(62),
    [sym_program] = STATE(59),
    [sym_switch_statement] = STATE(62),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(62),
    [sym_throw_statement] = STATE(62),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(62),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(62),
    [sym_abstract_class_declaration] = STATE(62),
    [sym_interface_declaration] = STATE(62),
    [sym_export_statement] = STATE(62),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(62),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(62),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(62),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(62),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [sym_hash_bang_line] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [3] = {
    [aux_sym_template_string_repeat1] = STATE(73),
    [sym_template_substitution] = STATE(73),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__template_chars] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__automatic_semicolon] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [6] = {
    [sym_decorator_member_expression] = STATE(80),
    [sym_decorator_call_expression] = STATE(81),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_module] = ACTIONS(145),
    [anon_sym_symbol] = ACTIONS(145),
    [anon_sym_number] = ACTIONS(145),
    [anon_sym_declare] = ACTIONS(145),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_any] = ACTIONS(145),
    [anon_sym_private] = ACTIONS(145),
    [anon_sym_boolean] = ACTIONS(145),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(145),
    [anon_sym_get] = ACTIONS(145),
    [anon_sym_static] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_namespace] = ACTIONS(145),
  },
  [7] = {
    [sym_class] = STATE(91),
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym__expression] = STATE(91),
    [sym_jsx_element] = STATE(91),
    [sym_function] = STATE(52),
    [sym_import] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(91),
    [sym_string] = STATE(91),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(91),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(91),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_new_expression] = STATE(91),
    [sym_assignment_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(91),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_jsx_self_closing_element] = STATE(91),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(153),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(153),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(153),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(153),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [8] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [9] = {
    [sym__automatic_semicolon] = ACTIONS(179),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_array] = STATE(100),
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(99),
    [sym_identifier] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [11] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [12] = {
    [sym_await_expression] = STATE(108),
    [sym_update_expression] = STATE(108),
    [sym_meta_property] = STATE(108),
    [sym__expression] = STATE(108),
    [sym_jsx_element] = STATE(108),
    [sym_function] = STATE(52),
    [sym_import] = STATE(108),
    [sym_call_expression] = STATE(108),
    [sym_ternary_expression] = STATE(108),
    [sym_template_string] = STATE(108),
    [sym_yield_expression] = STATE(108),
    [sym_jsx_fragment] = STATE(108),
    [sym_new_expression] = STATE(108),
    [sym_assignment_expression] = STATE(108),
    [sym_binary_expression] = STATE(108),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(108),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(108),
    [sym_jsx_self_closing_element] = STATE(108),
    [sym_arrow_function] = STATE(108),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(107),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(108),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(108),
    [sym_augmented_assignment_expression] = STATE(108),
    [sym_unary_expression] = STATE(108),
    [sym_regex] = STATE(108),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(108),
    [sym_class] = STATE(108),
    [sym__automatic_semicolon] = ACTIONS(193),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(195),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(197),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [13] = {
    [sym_identifier] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_identifier] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [16] = {
    [sym__automatic_semicolon] = ACTIONS(203),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_SEMI] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_class] = STATE(113),
    [sym_arrow_function] = STATE(113),
    [sym_await_expression] = STATE(113),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(113),
    [sym_meta_property] = STATE(113),
    [sym__expression] = STATE(113),
    [sym_jsx_element] = STATE(113),
    [sym_function] = STATE(52),
    [sym_import] = STATE(113),
    [sym_call_expression] = STATE(113),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(113),
    [sym_string] = STATE(113),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(113),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(113),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(113),
    [sym_generator_function] = STATE(113),
    [sym_new_expression] = STATE(113),
    [sym_assignment_expression] = STATE(113),
    [sym_augmented_assignment_expression] = STATE(113),
    [sym_binary_expression] = STATE(113),
    [sym_unary_expression] = STATE(113),
    [sym_regex] = STATE(113),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(113),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(113),
    [sym_internal_module] = STATE(113),
    [sym_jsx_self_closing_element] = STATE(113),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(207),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(207),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(207),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [18] = {
    [sym_parenthesized_expression] = STATE(115),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_class] = STATE(117),
    [sym_arrow_function] = STATE(117),
    [sym_await_expression] = STATE(117),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(117),
    [sym_meta_property] = STATE(117),
    [sym__expression] = STATE(117),
    [sym_jsx_element] = STATE(117),
    [sym_function] = STATE(52),
    [sym_import] = STATE(117),
    [sym_call_expression] = STATE(117),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(117),
    [sym_string] = STATE(117),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(117),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(117),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(117),
    [sym_generator_function] = STATE(117),
    [sym_new_expression] = STATE(117),
    [sym_assignment_expression] = STATE(117),
    [sym_augmented_assignment_expression] = STATE(117),
    [sym_binary_expression] = STATE(117),
    [sym_unary_expression] = STATE(117),
    [sym_regex] = STATE(117),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(117),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(117),
    [sym_internal_module] = STATE(117),
    [sym_jsx_self_closing_element] = STATE(117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(217),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(219),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [sym_null] = ACTIONS(219),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(219),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(221),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [20] = {
    [sym_await_expression] = STATE(119),
    [sym_update_expression] = STATE(119),
    [sym_meta_property] = STATE(119),
    [sym__expression] = STATE(119),
    [sym_jsx_element] = STATE(119),
    [sym_function] = STATE(52),
    [sym_import] = STATE(119),
    [sym_call_expression] = STATE(119),
    [sym_ternary_expression] = STATE(119),
    [sym_template_string] = STATE(119),
    [sym_yield_expression] = STATE(119),
    [sym_jsx_fragment] = STATE(119),
    [sym_new_expression] = STATE(119),
    [sym_assignment_expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(119),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(119),
    [sym_jsx_self_closing_element] = STATE(119),
    [sym_arrow_function] = STATE(119),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(118),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(119),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(119),
    [sym_augmented_assignment_expression] = STATE(119),
    [sym_unary_expression] = STATE(119),
    [sym_regex] = STATE(119),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(119),
    [sym_class] = STATE(119),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(223),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(223),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(223),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(225),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [21] = {
    [anon_sym_class] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [23] = {
    [sym_namespace_import] = STATE(126),
    [sym_named_imports] = STATE(126),
    [sym_import_require_clause] = STATE(127),
    [sym_string] = STATE(127),
    [sym_import_clause] = STATE(128),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(231),
    [sym__automatic_semicolon] = ACTIONS(231),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_GT_GT_GT] = ACTIONS(231),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(231),
    [anon_sym_PERCENT] = ACTIONS(231),
    [anon_sym_as] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_instanceof] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(231),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_STAR_STAR] = ACTIONS(231),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_typeof] = ACTIONS(239),
    [anon_sym_LT_LT] = ACTIONS(231),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_AMP_AMP] = ACTIONS(231),
    [anon_sym_LT_EQ] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(231),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(231),
  },
  [24] = {
    [sym_nested_identifier] = STATE(129),
    [sym_string] = STATE(130),
    [sym__module] = STATE(131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [25] = {
    [aux_sym_string_repeat1] = STATE(133),
    [sym_escape_sequence] = ACTIONS(249),
    [aux_sym_string_token1] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [sym_comment] = ACTIONS(255),
  },
  [26] = {
    [sym_class] = STATE(134),
    [sym_arrow_function] = STATE(134),
    [sym_await_expression] = STATE(134),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(134),
    [sym_meta_property] = STATE(134),
    [sym__expression] = STATE(134),
    [sym_jsx_element] = STATE(134),
    [sym_function] = STATE(52),
    [sym_import] = STATE(134),
    [sym_call_expression] = STATE(134),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(134),
    [sym_string] = STATE(134),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(134),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(134),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(134),
    [sym_generator_function] = STATE(134),
    [sym_new_expression] = STATE(134),
    [sym_assignment_expression] = STATE(134),
    [sym_augmented_assignment_expression] = STATE(134),
    [sym_binary_expression] = STATE(134),
    [sym_unary_expression] = STATE(134),
    [sym_regex] = STATE(134),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(134),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(134),
    [sym_internal_module] = STATE(134),
    [sym_jsx_self_closing_element] = STATE(134),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(257),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(257),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(259),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(257),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [27] = {
    [sym__for_header] = STATE(137),
    [anon_sym_LPAREN] = ACTIONS(261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(263),
  },
  [28] = {
    [sym_await_expression] = STATE(141),
    [sym_update_expression] = STATE(141),
    [sym_meta_property] = STATE(141),
    [sym__expression] = STATE(141),
    [sym_jsx_element] = STATE(141),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(141),
    [sym_call_expression] = STATE(141),
    [sym_ternary_expression] = STATE(141),
    [sym_template_string] = STATE(141),
    [sym_yield_expression] = STATE(141),
    [sym_jsx_fragment] = STATE(141),
    [sym_new_expression] = STATE(141),
    [sym_assignment_expression] = STATE(141),
    [sym_binary_expression] = STATE(141),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(141),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(141),
    [sym_jsx_self_closing_element] = STATE(141),
    [sym_arrow_function] = STATE(141),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(142),
    [sym_string] = STATE(141),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(141),
    [sym_augmented_assignment_expression] = STATE(141),
    [sym_unary_expression] = STATE(141),
    [sym_regex] = STATE(141),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(143),
    [sym_non_null_expression] = STATE(141),
    [sym_class] = STATE(141),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(283),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(305),
    [sym_null] = ACTIONS(283),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(313),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(283),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [29] = {
    [sym_identifier] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_debugger] = ACTIONS(323),
    [anon_sym_symbol] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
    [anon_sym_DASH] = ACTIONS(323),
    [anon_sym_void] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_const] = ACTIONS(323),
    [sym_super] = ACTIONS(323),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(323),
    [anon_sym_static] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_interface] = ACTIONS(323),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_enum] = ACTIONS(323),
    [anon_sym_delete] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(323),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [anon_sym_if] = ACTIONS(323),
    [sym_this] = ACTIONS(323),
    [anon_sym_yield] = ACTIONS(323),
    [sym_true] = ACTIONS(323),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_abstract] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
    [anon_sym_type] = ACTIONS(323),
    [anon_sym_import] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_else] = ACTIONS(323),
    [anon_sym_BANG] = ACTIONS(325),
    [anon_sym_for] = ACTIONS(323),
    [anon_sym_LBRACK] = ACTIONS(325),
    [sym_false] = ACTIONS(323),
    [anon_sym_SEMI] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(323),
    [anon_sym_module] = ACTIONS(323),
    [anon_sym_number] = ACTIONS(323),
    [anon_sym_class] = ACTIONS(323),
    [anon_sym_declare] = ACTIONS(323),
    [anon_sym_typeof] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(325),
    [anon_sym_switch] = ACTIONS(323),
    [anon_sym_LPAREN] = ACTIONS(325),
    [sym_null] = ACTIONS(323),
    [anon_sym_any] = ACTIONS(323),
    [anon_sym_boolean] = ACTIONS(323),
    [anon_sym_async] = ACTIONS(323),
    [anon_sym_public] = ACTIONS(323),
    [anon_sym_var] = ACTIONS(323),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(325),
    [sym_number] = ACTIONS(325),
    [anon_sym_SLASH] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(323),
    [anon_sym_function] = ACTIONS(323),
    [sym_undefined] = ACTIONS(323),
    [anon_sym_new] = ACTIONS(323),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_let] = ACTIONS(323),
    [anon_sym_PLUS] = ACTIONS(323),
    [anon_sym_export] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(325),
    [anon_sym_with] = ACTIONS(323),
    [anon_sym_await] = ACTIONS(323),
  },
  [30] = {
    [sym_nested_identifier] = STATE(1327),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [31] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(153),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(152),
    [sym_type_parameters] = STATE(154),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [32] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(343),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(365),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [33] = {
    [sym_generator_function_declaration] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(184),
    [sym_jsx_element] = STATE(51),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(187),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(187),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(187),
    [sym_arrow_function] = STATE(51),
    [sym_continue_statement] = STATE(187),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(187),
    [sym_type_alias_declaration] = STATE(187),
    [sym_import_statement] = STATE(187),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(187),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(187),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(187),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_export_statement] = STATE(187),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(187),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(187),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(184),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(187),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(187),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(187),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(187),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(187),
    [sym_template_string] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(187),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(187),
    [sym_parenthesized_expression] = STATE(53),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_class_declaration] = STATE(187),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(187),
    [sym_spread_element] = STATE(184),
    [sym_try_statement] = STATE(187),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_abstract_class_declaration] = STATE(187),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(187),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(187),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(184),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_static] = ACTIONS(385),
    [anon_sym_get] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(391),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(393),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(397),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(399),
    [anon_sym_number] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(375),
    [anon_sym_boolean] = ACTIONS(375),
    [anon_sym_async] = ACTIONS(403),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [34] = {
    [sym_parenthesized_expression] = STATE(191),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(205),
    [sym_update_expression] = STATE(205),
    [sym_meta_property] = STATE(205),
    [sym__expression] = STATE(205),
    [sym_jsx_element] = STATE(205),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(205),
    [sym_call_expression] = STATE(205),
    [sym_ternary_expression] = STATE(205),
    [sym_template_string] = STATE(205),
    [sym_yield_expression] = STATE(205),
    [sym_jsx_fragment] = STATE(205),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(205),
    [sym_assignment_expression] = STATE(205),
    [sym_binary_expression] = STATE(205),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(205),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(205),
    [sym_jsx_self_closing_element] = STATE(205),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(205),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(204),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(205),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(205),
    [sym_augmented_assignment_expression] = STATE(205),
    [sym_unary_expression] = STATE(205),
    [sym_regex] = STATE(205),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(205),
    [sym_class] = STATE(205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(411),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(415),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(421),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(411),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(411),
    [anon_sym_number] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(411),
    [anon_sym_boolean] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(433),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(421),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [36] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(437),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(437),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(437),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_protected] = ACTIONS(437),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(437),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(437),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(437),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [37] = {
    [sym_array] = STATE(100),
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(215),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [38] = {
    [sym_generator_function_declaration] = STATE(216),
    [sym__declaration] = STATE(216),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(216),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(216),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(216),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(216),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(216),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(216),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(216),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(216),
    [sym_function_declaration] = STATE(216),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(216),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(216),
    [sym_break_statement] = STATE(216),
    [sym_labeled_statement] = STATE(216),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(216),
    [sym_class_declaration] = STATE(216),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(216),
    [sym_ambient_declaration] = STATE(216),
    [sym_type_alias_declaration] = STATE(216),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(216),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(216),
    [sym_switch_statement] = STATE(216),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(216),
    [sym_throw_statement] = STATE(216),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(216),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(216),
    [sym_abstract_class_declaration] = STATE(216),
    [sym_interface_declaration] = STATE(216),
    [sym_export_statement] = STATE(216),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(216),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(216),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(216),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(216),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [39] = {
    [sym_parenthesized_expression] = STATE(217),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [aux_sym_string_repeat2] = STATE(218),
    [sym_escape_sequence] = ACTIONS(451),
    [aux_sym_string_token2] = ACTIONS(453),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(253),
  },
  [41] = {
    [sym_statement_block] = STATE(220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [42] = {
    [sym_nested_identifier] = STATE(225),
    [sym_type_parameter] = STATE(224),
    [sym_jsx_namespace_name] = STATE(226),
    [anon_sym_GT] = ACTIONS(457),
    [sym_identifier] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(461),
  },
  [43] = {
    [sym_regex_pattern] = ACTIONS(463),
    [sym_comment] = ACTIONS(255),
  },
  [44] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(230),
    [sym_identifier] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_class] = STATE(232),
    [sym_arrow_function] = STATE(232),
    [sym_await_expression] = STATE(239),
    [sym_member_expression] = STATE(238),
    [sym_update_expression] = STATE(239),
    [sym_meta_property] = STATE(232),
    [sym__expression] = STATE(239),
    [sym_jsx_element] = STATE(239),
    [sym_function] = STATE(240),
    [sym_import] = STATE(232),
    [sym_call_expression] = STATE(239),
    [sym_subscript_expression] = STATE(238),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(239),
    [sym_string] = STATE(232),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(232),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(239),
    [sym_object] = STATE(241),
    [sym_jsx_fragment] = STATE(239),
    [sym_generator_function] = STATE(232),
    [sym_new_expression] = STATE(232),
    [sym_assignment_expression] = STATE(239),
    [sym_augmented_assignment_expression] = STATE(239),
    [sym_binary_expression] = STATE(239),
    [sym_unary_expression] = STATE(239),
    [sym_regex] = STATE(232),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(238),
    [sym_non_null_expression] = STATE(239),
    [sym_array] = STATE(242),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(239),
    [sym_internal_module] = STATE(239),
    [sym_jsx_self_closing_element] = STATE(239),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(473),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(477),
    [sym_super] = ACTIONS(479),
    [anon_sym_private] = ACTIONS(473),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_get] = ACTIONS(473),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
    [anon_sym_protected] = ACTIONS(473),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(473),
    [anon_sym_type] = ACTIONS(473),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(485),
    [anon_sym_module] = ACTIONS(473),
    [anon_sym_number] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(473),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(473),
    [anon_sym_boolean] = ACTIONS(473),
    [anon_sym_async] = ACTIONS(495),
    [anon_sym_public] = ACTIONS(473),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(497),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(473),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [46] = {
    [sym_array] = STATE(100),
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(99),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [47] = {
    [sym_class_declaration] = STATE(249),
    [sym_generator_function_declaration] = STATE(249),
    [sym__declaration] = STATE(249),
    [sym_enum_declaration] = STATE(249),
    [sym_function_signature] = STATE(249),
    [sym_abstract_class_declaration] = STATE(249),
    [sym_module] = STATE(249),
    [sym_interface_declaration] = STATE(249),
    [sym_function_declaration] = STATE(249),
    [sym_export_clause] = STATE(250),
    [sym_variable_declaration] = STATE(249),
    [sym_lexical_declaration] = STATE(249),
    [sym_ambient_declaration] = STATE(249),
    [sym_import_alias] = STATE(249),
    [sym_type_alias_declaration] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(249),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_as] = ACTIONS(507),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(365),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [48] = {
    [sym_generator_function_declaration] = STATE(251),
    [sym__declaration] = STATE(251),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(251),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(251),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(251),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(251),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(251),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(251),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(251),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(251),
    [sym_function_declaration] = STATE(251),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(251),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(251),
    [sym_break_statement] = STATE(251),
    [sym_labeled_statement] = STATE(251),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(251),
    [sym_class_declaration] = STATE(251),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(251),
    [sym_ambient_declaration] = STATE(251),
    [sym_type_alias_declaration] = STATE(251),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(251),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(251),
    [sym_switch_statement] = STATE(251),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(251),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(251),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(251),
    [sym_abstract_class_declaration] = STATE(251),
    [sym_interface_declaration] = STATE(251),
    [sym_export_statement] = STATE(251),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(251),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(251),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(251),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(251),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [49] = {
    [sym_parenthesized_expression] = STATE(252),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_class] = STATE(253),
    [sym_arrow_function] = STATE(253),
    [sym_await_expression] = STATE(253),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(253),
    [sym_meta_property] = STATE(253),
    [sym__expression] = STATE(253),
    [sym_jsx_element] = STATE(253),
    [sym_function] = STATE(52),
    [sym_import] = STATE(253),
    [sym_call_expression] = STATE(253),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(253),
    [sym_string] = STATE(253),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(253),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(253),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(253),
    [sym_generator_function] = STATE(253),
    [sym_new_expression] = STATE(253),
    [sym_assignment_expression] = STATE(253),
    [sym_augmented_assignment_expression] = STATE(253),
    [sym_binary_expression] = STATE(253),
    [sym_unary_expression] = STATE(253),
    [sym_regex] = STATE(253),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(253),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(253),
    [sym_internal_module] = STATE(253),
    [sym_jsx_self_closing_element] = STATE(253),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(547),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(547),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(547),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [51] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [52] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [53] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [54] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [55] = {
    [sym_jsx_element] = STATE(270),
    [sym_jsx_expression] = STATE(270),
    [aux_sym_jsx_element_repeat1] = STATE(270),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(271),
    [sym_jsx_self_closing_element] = STATE(270),
    [sym_jsx_text] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(589),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [56] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(593),
    [anon_sym_symbol] = ACTIONS(595),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(595),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(595),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_interface] = ACTIONS(595),
    [anon_sym_as] = ACTIONS(113),
    [anon_sym_delete] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(595),
    [anon_sym_instanceof] = ACTIONS(113),
    [anon_sym_yield] = ACTIONS(595),
    [sym_true] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_DOT] = ACTIONS(113),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_import] = ACTIONS(595),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [anon_sym_for] = ACTIONS(595),
    [anon_sym_SEMI] = ACTIONS(593),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(595),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [sym_null] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_var] = ACTIONS(595),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(595),
    [anon_sym_SQUOTE] = ACTIONS(593),
    [anon_sym_SLASH] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_new] = ACTIONS(595),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_with] = ACTIONS(595),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_debugger] = ACTIONS(595),
    [anon_sym_AT] = ACTIONS(593),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_const] = ACTIONS(595),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [sym_super] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_default] = ACTIONS(595),
    [anon_sym_enum] = ACTIONS(595),
    [anon_sym_continue] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [sym_this] = ACTIONS(595),
    [anon_sym_throw] = ACTIONS(595),
    [anon_sym_abstract] = ACTIONS(595),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(595),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_else] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(593),
    [sym_false] = ACTIONS(595),
    [anon_sym_case] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_class] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(593),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(595),
    [sym_number] = ACTIONS(593),
    [ts_builtin_sym_end] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [sym_undefined] = ACTIONS(595),
    [anon_sym_let] = ACTIONS(595),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_do] = ACTIONS(595),
    [anon_sym_TILDE] = ACTIONS(593),
    [anon_sym_await] = ACTIONS(595),
  },
  [57] = {
    [sym__automatic_semicolon] = ACTIONS(551),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [anon_sym_EQ_GT] = ACTIONS(597),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_formal_parameters] = STATE(273),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_type_annotation] = STATE(275),
    [anon_sym_EQ_GT] = ACTIONS(601),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(601),
  },
  [62] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [63] = {
    [anon_sym_LBRACK] = ACTIONS(605),
    [sym_identifier] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_symbol] = ACTIONS(607),
    [anon_sym_number] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(605),
    [anon_sym_declare] = ACTIONS(607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(605),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(607),
    [anon_sym_private] = ACTIONS(607),
    [anon_sym_boolean] = ACTIONS(607),
    [anon_sym_static] = ACTIONS(607),
    [anon_sym_async] = ACTIONS(607),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_public] = ACTIONS(607),
    [sym_this] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
    [anon_sym_type] = ACTIONS(607),
    [anon_sym_export] = ACTIONS(607),
    [sym_readonly] = ACTIONS(607),
    [anon_sym_namespace] = ACTIONS(607),
  },
  [64] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [65] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(611),
    [anon_sym_class] = ACTIONS(613),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_await_expression] = STATE(282),
    [sym_statement_block] = STATE(281),
    [sym_update_expression] = STATE(282),
    [sym_meta_property] = STATE(282),
    [sym__expression] = STATE(282),
    [sym_jsx_element] = STATE(282),
    [sym_function] = STATE(52),
    [sym_import] = STATE(282),
    [sym_call_expression] = STATE(282),
    [sym_ternary_expression] = STATE(282),
    [sym_template_string] = STATE(282),
    [sym_yield_expression] = STATE(282),
    [sym_jsx_fragment] = STATE(282),
    [sym_new_expression] = STATE(282),
    [sym_assignment_expression] = STATE(282),
    [sym_binary_expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(282),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(282),
    [sym_jsx_self_closing_element] = STATE(282),
    [sym_arrow_function] = STATE(282),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(282),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(282),
    [sym_augmented_assignment_expression] = STATE(282),
    [sym_unary_expression] = STATE(282),
    [sym_regex] = STATE(282),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(282),
    [sym_class] = STATE(282),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(615),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(615),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [67] = {
    [sym_class] = STATE(283),
    [sym_arrow_function] = STATE(283),
    [sym_await_expression] = STATE(283),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(283),
    [sym_meta_property] = STATE(283),
    [sym__expression] = STATE(283),
    [sym_jsx_element] = STATE(283),
    [sym_function] = STATE(52),
    [sym_import] = STATE(283),
    [sym_call_expression] = STATE(283),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(283),
    [sym_string] = STATE(283),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(283),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(283),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(283),
    [sym_generator_function] = STATE(283),
    [sym_new_expression] = STATE(283),
    [sym_assignment_expression] = STATE(283),
    [sym_augmented_assignment_expression] = STATE(283),
    [sym_binary_expression] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_regex] = STATE(283),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(283),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(283),
    [sym_internal_module] = STATE(283),
    [sym_jsx_self_closing_element] = STATE(283),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(621),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(621),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(621),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(621),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(621),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [68] = {
    [sym_generator_function_declaration] = STATE(284),
    [sym__declaration] = STATE(284),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(284),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(284),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(284),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(284),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(284),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(284),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(284),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(284),
    [sym_function_declaration] = STATE(284),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(284),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(284),
    [sym_break_statement] = STATE(284),
    [sym_labeled_statement] = STATE(284),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(284),
    [sym_class_declaration] = STATE(284),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(284),
    [sym_ambient_declaration] = STATE(284),
    [sym_type_alias_declaration] = STATE(284),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(284),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(284),
    [sym_switch_statement] = STATE(284),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(284),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(284),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(284),
    [sym_abstract_class_declaration] = STATE(284),
    [sym_interface_declaration] = STATE(284),
    [sym_export_statement] = STATE(284),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(284),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(284),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(284),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [69] = {
    [sym_class] = STATE(285),
    [sym_arrow_function] = STATE(285),
    [sym_await_expression] = STATE(285),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(285),
    [sym_meta_property] = STATE(285),
    [sym__expression] = STATE(285),
    [sym_jsx_element] = STATE(285),
    [sym_function] = STATE(52),
    [sym_import] = STATE(285),
    [sym_call_expression] = STATE(285),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(285),
    [sym_string] = STATE(285),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(285),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(285),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(285),
    [sym_generator_function] = STATE(285),
    [sym_new_expression] = STATE(285),
    [sym_assignment_expression] = STATE(285),
    [sym_augmented_assignment_expression] = STATE(285),
    [sym_binary_expression] = STATE(285),
    [sym_unary_expression] = STATE(285),
    [sym_regex] = STATE(285),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(285),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(285),
    [sym_internal_module] = STATE(285),
    [sym_jsx_self_closing_element] = STATE(285),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(625),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(625),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(625),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(627),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(625),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [70] = {
    [sym_identifier] = ACTIONS(629),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_class] = STATE(288),
    [sym_arrow_function] = STATE(288),
    [sym_await_expression] = STATE(288),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(288),
    [sym_sequence_expression] = STATE(287),
    [sym_meta_property] = STATE(288),
    [sym__expression] = STATE(288),
    [sym_jsx_element] = STATE(288),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(288),
    [sym_call_expression] = STATE(288),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(288),
    [sym_string] = STATE(288),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(288),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(288),
    [sym_generator_function] = STATE(288),
    [sym_new_expression] = STATE(288),
    [sym_assignment_expression] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(288),
    [sym_binary_expression] = STATE(288),
    [sym_unary_expression] = STATE(288),
    [sym_regex] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(288),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(288),
    [sym_internal_module] = STATE(288),
    [sym_jsx_self_closing_element] = STATE(288),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(631),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(631),
    [sym_number] = ACTIONS(633),
    [sym_true] = ACTIONS(631),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(631),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [72] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT_GT] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_LT_EQ] = ACTIONS(635),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_as] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_DASH_DASH] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_instanceof] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_SLASH] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(635),
    [anon_sym_CARET] = ACTIONS(635),
    [anon_sym_STAR_STAR] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(637),
    [anon_sym_PLUS_PLUS] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(637),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(637),
  },
  [73] = {
    [aux_sym_template_string_repeat1] = STATE(290),
    [sym_template_substitution] = STATE(290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(639),
    [sym__template_chars] = ACTIONS(641),
    [sym_escape_sequence] = ACTIONS(641),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_identifier] = ACTIONS(643),
    [anon_sym_BQUOTE] = ACTIONS(645),
    [anon_sym_debugger] = ACTIONS(643),
    [anon_sym_symbol] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_break] = ACTIONS(643),
    [anon_sym_const] = ACTIONS(643),
    [sym_super] = ACTIONS(643),
    [anon_sym_return] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_get] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_interface] = ACTIONS(643),
    [anon_sym_default] = ACTIONS(643),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(643),
    [anon_sym_continue] = ACTIONS(643),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(643),
    [sym_this] = ACTIONS(643),
    [anon_sym_yield] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [anon_sym_throw] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_set] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_import] = ACTIONS(643),
    [anon_sym_namespace] = ACTIONS(643),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(645),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(645),
    [sym_false] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_case] = ACTIONS(643),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_number] = ACTIONS(643),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_typeof] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(645),
    [sym_null] = ACTIONS(643),
    [anon_sym_any] = ACTIONS(643),
    [anon_sym_boolean] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_var] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_SQUOTE] = ACTIONS(645),
    [anon_sym_try] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [sym_number] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [sym_undefined] = ACTIONS(643),
    [anon_sym_new] = ACTIONS(643),
    [ts_builtin_sym_end] = ACTIONS(645),
    [anon_sym_let] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(643),
    [anon_sym_do] = ACTIONS(643),
    [anon_sym_TILDE] = ACTIONS(645),
    [anon_sym_with] = ACTIONS(643),
    [anon_sym_await] = ACTIONS(643),
  },
  [75] = {
    [sym_await_expression] = STATE(292),
    [sym_statement_block] = STATE(291),
    [sym_update_expression] = STATE(292),
    [sym_meta_property] = STATE(292),
    [sym__expression] = STATE(292),
    [sym_jsx_element] = STATE(292),
    [sym_function] = STATE(52),
    [sym_import] = STATE(292),
    [sym_call_expression] = STATE(292),
    [sym_ternary_expression] = STATE(292),
    [sym_template_string] = STATE(292),
    [sym_yield_expression] = STATE(292),
    [sym_jsx_fragment] = STATE(292),
    [sym_new_expression] = STATE(292),
    [sym_assignment_expression] = STATE(292),
    [sym_binary_expression] = STATE(292),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(292),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(292),
    [sym_jsx_self_closing_element] = STATE(292),
    [sym_arrow_function] = STATE(292),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(292),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(292),
    [sym_augmented_assignment_expression] = STATE(292),
    [sym_unary_expression] = STATE(292),
    [sym_regex] = STATE(292),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(292),
    [sym_class] = STATE(292),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(647),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(647),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [76] = {
    [sym_class] = STATE(293),
    [sym_arrow_function] = STATE(293),
    [sym_await_expression] = STATE(293),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(293),
    [sym_meta_property] = STATE(293),
    [sym__expression] = STATE(293),
    [sym_jsx_element] = STATE(293),
    [sym_function] = STATE(52),
    [sym_import] = STATE(293),
    [sym_call_expression] = STATE(293),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(293),
    [sym_string] = STATE(293),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(293),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(293),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(293),
    [sym_generator_function] = STATE(293),
    [sym_new_expression] = STATE(293),
    [sym_assignment_expression] = STATE(293),
    [sym_augmented_assignment_expression] = STATE(293),
    [sym_binary_expression] = STATE(293),
    [sym_unary_expression] = STATE(293),
    [sym_regex] = STATE(293),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(293),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(293),
    [sym_internal_module] = STATE(293),
    [sym_jsx_self_closing_element] = STATE(293),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(651),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(651),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(651),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(653),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [77] = {
    [sym_class] = STATE(294),
    [sym_arrow_function] = STATE(294),
    [sym_await_expression] = STATE(294),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(294),
    [sym_meta_property] = STATE(294),
    [sym__expression] = STATE(294),
    [sym_jsx_element] = STATE(294),
    [sym_function] = STATE(52),
    [sym_import] = STATE(294),
    [sym_call_expression] = STATE(294),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(294),
    [sym_string] = STATE(294),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(294),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(294),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(294),
    [sym_generator_function] = STATE(294),
    [sym_new_expression] = STATE(294),
    [sym_assignment_expression] = STATE(294),
    [sym_augmented_assignment_expression] = STATE(294),
    [sym_binary_expression] = STATE(294),
    [sym_unary_expression] = STATE(294),
    [sym_regex] = STATE(294),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(294),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(294),
    [sym_internal_module] = STATE(294),
    [sym_jsx_self_closing_element] = STATE(294),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [78] = {
    [sym_identifier] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_arguments] = STATE(297),
    [anon_sym_DOT] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_export] = ACTIONS(665),
    [anon_sym_class] = ACTIONS(665),
    [anon_sym_AT] = ACTIONS(665),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_arguments] = STATE(299),
    [anon_sym_DOT] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_export] = ACTIONS(669),
    [anon_sym_class] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [anon_sym_LBRACK] = ACTIONS(669),
    [sym_identifier] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_class] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_void] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_async] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_SQUOTE] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_number] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_abstract] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_export] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(671),
    [anon_sym_DQUOTE] = ACTIONS(669),
  },
  [82] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [83] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [84] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(153),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(152),
    [sym_type_parameters] = STATE(154),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(673),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [85] = {
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_object] = STATE(307),
    [sym_accessibility_modifier] = STATE(190),
    [sym_pair] = STATE(184),
    [sym__property_name] = STATE(186),
    [sym_method_definition] = STATE(184),
    [sym_assignment_pattern] = STATE(184),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(184),
    [sym_string] = STATE(186),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_symbol] = ACTIONS(675),
    [anon_sym_number] = ACTIONS(675),
    [anon_sym_declare] = ACTIONS(675),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(675),
    [anon_sym_any] = ACTIONS(675),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_boolean] = ACTIONS(675),
    [anon_sym_async] = ACTIONS(681),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_get] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_static] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_number] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(675),
    [anon_sym_set] = ACTIONS(683),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_export] = ACTIONS(675),
    [anon_sym_namespace] = ACTIONS(675),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [86] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [87] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(437),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(437),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(437),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(437),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(437),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(437),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [88] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(230),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym__automatic_semicolon] = ACTIONS(231),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_LT_LT] = ACTIONS(231),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(231),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_GT_EQ] = ACTIONS(231),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(231),
    [anon_sym_QMARK] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_as] = ACTIONS(231),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_instanceof] = ACTIONS(231),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(231),
    [anon_sym_CARET] = ACTIONS(231),
    [anon_sym_STAR_STAR] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(231),
    [anon_sym_BANG] = ACTIONS(235),
  },
  [90] = {
    [sym_nested_identifier] = STATE(1638),
    [sym_string] = STATE(1639),
    [sym__module] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(697),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [91] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(701),
  },
  [92] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [94] = {
    [sym_identifier] = ACTIONS(708),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [anon_sym_debugger] = ACTIONS(708),
    [anon_sym_symbol] = ACTIONS(708),
    [anon_sym_AT] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(708),
    [anon_sym_void] = ACTIONS(708),
    [anon_sym_break] = ACTIONS(708),
    [anon_sym_const] = ACTIONS(708),
    [sym_super] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_get] = ACTIONS(708),
    [anon_sym_RBRACE] = ACTIONS(710),
    [anon_sym_interface] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(708),
    [anon_sym_enum] = ACTIONS(708),
    [anon_sym_delete] = ACTIONS(708),
    [anon_sym_continue] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(708),
    [sym_this] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(708),
    [sym_true] = ACTIONS(708),
    [anon_sym_throw] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_abstract] = ACTIONS(708),
    [anon_sym_set] = ACTIONS(708),
    [anon_sym_type] = ACTIONS(708),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_PLUS_PLUS] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_else] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(710),
    [sym_false] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(710),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(708),
    [anon_sym_number] = ACTIONS(708),
    [anon_sym_class] = ACTIONS(708),
    [anon_sym_declare] = ACTIONS(708),
    [anon_sym_typeof] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_switch] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [sym_null] = ACTIONS(708),
    [anon_sym_any] = ACTIONS(708),
    [anon_sym_boolean] = ACTIONS(708),
    [anon_sym_async] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_var] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_try] = ACTIONS(708),
    [anon_sym_LT] = ACTIONS(710),
    [sym_number] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(708),
    [anon_sym_function] = ACTIONS(708),
    [sym_undefined] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(708),
    [ts_builtin_sym_end] = ACTIONS(710),
    [anon_sym_let] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(708),
    [anon_sym_export] = ACTIONS(708),
    [anon_sym_do] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(710),
    [anon_sym_with] = ACTIONS(708),
    [anon_sym_await] = ACTIONS(708),
  },
  [95] = {
    [sym__automatic_semicolon] = ACTIONS(712),
    [anon_sym_SEMI] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym__initializer] = STATE(315),
    [sym_type_annotation] = STATE(316),
    [sym__automatic_semicolon] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(714),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__initializer] = STATE(318),
    [sym_type_annotation] = STATE(319),
    [sym__automatic_semicolon] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [aux_sym_variable_declaration_repeat1] = STATE(322),
    [sym__automatic_semicolon] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym__initializer] = STATE(323),
    [sym_type_annotation] = STATE(324),
    [sym__automatic_semicolon] = ACTIONS(728),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_await_expression] = STATE(326),
    [sym_update_expression] = STATE(326),
    [sym_meta_property] = STATE(326),
    [sym__expression] = STATE(326),
    [sym_jsx_element] = STATE(326),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(326),
    [sym_call_expression] = STATE(326),
    [sym_ternary_expression] = STATE(326),
    [sym_template_string] = STATE(326),
    [sym_yield_expression] = STATE(326),
    [sym_jsx_fragment] = STATE(326),
    [sym_new_expression] = STATE(326),
    [sym_assignment_expression] = STATE(326),
    [sym_binary_expression] = STATE(326),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(326),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(326),
    [sym_jsx_self_closing_element] = STATE(326),
    [sym_arrow_function] = STATE(326),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(325),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(326),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(326),
    [sym_augmented_assignment_expression] = STATE(326),
    [sym_unary_expression] = STATE(326),
    [sym_regex] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(326),
    [sym_class] = STATE(326),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(730),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(730),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(730),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(730),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(732),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [102] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_function_type] = STATE(345),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(345),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(345),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [103] = {
    [sym_await_expression] = STATE(348),
    [sym_update_expression] = STATE(348),
    [sym_meta_property] = STATE(348),
    [sym__expression] = STATE(348),
    [sym_jsx_element] = STATE(348),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(348),
    [sym_call_expression] = STATE(348),
    [sym_ternary_expression] = STATE(348),
    [sym_template_string] = STATE(348),
    [sym_yield_expression] = STATE(348),
    [sym_jsx_fragment] = STATE(348),
    [sym_new_expression] = STATE(348),
    [sym_assignment_expression] = STATE(348),
    [sym_binary_expression] = STATE(348),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(348),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(348),
    [sym_arrow_function] = STATE(348),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(349),
    [sym_string] = STATE(348),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(348),
    [sym_unary_expression] = STATE(348),
    [sym_regex] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(350),
    [sym_non_null_expression] = STATE(348),
    [sym_class] = STATE(348),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(768),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(772),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [104] = {
    [sym_template_string] = STATE(351),
    [sym_arguments] = STATE(351),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(774),
    [sym__automatic_semicolon] = ACTIONS(774),
    [anon_sym_SEMI] = ACTIONS(774),
    [anon_sym_BQUOTE] = ACTIONS(774),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_GT_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_AMP] = ACTIONS(774),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_LT_EQ] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_GT_EQ] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(774),
    [anon_sym_RBRACE] = ACTIONS(774),
    [anon_sym_as] = ACTIONS(774),
    [anon_sym_PIPE_PIPE] = ACTIONS(774),
    [anon_sym_DASH_DASH] = ACTIONS(774),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_instanceof] = ACTIONS(774),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(774),
    [anon_sym_CARET] = ACTIONS(774),
    [anon_sym_STAR_STAR] = ACTIONS(774),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_PLUS_PLUS] = ACTIONS(774),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(774),
    [anon_sym_BANG] = ACTIONS(776),
  },
  [106] = {
    [sym_identifier] = ACTIONS(778),
    [anon_sym_BQUOTE] = ACTIONS(780),
    [anon_sym_debugger] = ACTIONS(778),
    [anon_sym_symbol] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(778),
    [anon_sym_break] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(778),
    [sym_super] = ACTIONS(778),
    [anon_sym_return] = ACTIONS(778),
    [anon_sym_private] = ACTIONS(778),
    [anon_sym_static] = ACTIONS(778),
    [anon_sym_get] = ACTIONS(778),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_interface] = ACTIONS(778),
    [anon_sym_default] = ACTIONS(778),
    [anon_sym_enum] = ACTIONS(778),
    [anon_sym_delete] = ACTIONS(778),
    [anon_sym_continue] = ACTIONS(778),
    [anon_sym_DASH_DASH] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(778),
    [sym_this] = ACTIONS(778),
    [anon_sym_yield] = ACTIONS(778),
    [sym_true] = ACTIONS(778),
    [anon_sym_throw] = ACTIONS(778),
    [anon_sym_protected] = ACTIONS(778),
    [anon_sym_abstract] = ACTIONS(778),
    [anon_sym_set] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_import] = ACTIONS(778),
    [anon_sym_namespace] = ACTIONS(778),
    [anon_sym_PLUS_PLUS] = ACTIONS(780),
    [anon_sym_DQUOTE] = ACTIONS(780),
    [anon_sym_else] = ACTIONS(778),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_for] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(780),
    [sym_false] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(780),
    [anon_sym_case] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(778),
    [anon_sym_number] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(778),
    [anon_sym_declare] = ACTIONS(778),
    [anon_sym_typeof] = ACTIONS(778),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_switch] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(780),
    [sym_null] = ACTIONS(778),
    [anon_sym_any] = ACTIONS(778),
    [anon_sym_boolean] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_public] = ACTIONS(778),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_while] = ACTIONS(778),
    [anon_sym_SQUOTE] = ACTIONS(780),
    [anon_sym_try] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(780),
    [sym_number] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(778),
    [anon_sym_function] = ACTIONS(778),
    [sym_undefined] = ACTIONS(778),
    [anon_sym_new] = ACTIONS(778),
    [ts_builtin_sym_end] = ACTIONS(780),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_export] = ACTIONS(778),
    [anon_sym_do] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_with] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(778),
  },
  [107] = {
    [sym__automatic_semicolon] = ACTIONS(782),
    [anon_sym_SEMI] = ACTIONS(782),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(782),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [109] = {
    [sym_object_type] = STATE(353),
    [sym_extends_clause] = STATE(354),
    [sym_type_parameters] = STATE(355),
    [anon_sym_extends] = ACTIONS(784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(750),
  },
  [110] = {
    [sym_enum_body] = STATE(357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(786),
  },
  [111] = {
    [sym_identifier] = ACTIONS(788),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_debugger] = ACTIONS(788),
    [anon_sym_symbol] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_void] = ACTIONS(788),
    [anon_sym_break] = ACTIONS(788),
    [anon_sym_const] = ACTIONS(788),
    [sym_super] = ACTIONS(788),
    [anon_sym_return] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_static] = ACTIONS(788),
    [anon_sym_get] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(790),
    [anon_sym_interface] = ACTIONS(788),
    [anon_sym_default] = ACTIONS(788),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_delete] = ACTIONS(788),
    [anon_sym_continue] = ACTIONS(788),
    [anon_sym_DASH_DASH] = ACTIONS(790),
    [anon_sym_if] = ACTIONS(788),
    [sym_this] = ACTIONS(788),
    [anon_sym_yield] = ACTIONS(788),
    [sym_true] = ACTIONS(788),
    [anon_sym_throw] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_abstract] = ACTIONS(788),
    [anon_sym_set] = ACTIONS(788),
    [anon_sym_type] = ACTIONS(788),
    [anon_sym_import] = ACTIONS(788),
    [anon_sym_namespace] = ACTIONS(788),
    [anon_sym_PLUS_PLUS] = ACTIONS(790),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(790),
    [sym_false] = ACTIONS(788),
    [anon_sym_SEMI] = ACTIONS(790),
    [anon_sym_case] = ACTIONS(788),
    [anon_sym_module] = ACTIONS(788),
    [anon_sym_number] = ACTIONS(788),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_declare] = ACTIONS(788),
    [anon_sym_typeof] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(790),
    [anon_sym_switch] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(790),
    [sym_null] = ACTIONS(788),
    [anon_sym_any] = ACTIONS(788),
    [anon_sym_boolean] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(788),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_var] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_SQUOTE] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(790),
    [sym_number] = ACTIONS(790),
    [anon_sym_SLASH] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(788),
    [anon_sym_function] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_new] = ACTIONS(788),
    [ts_builtin_sym_end] = ACTIONS(790),
    [anon_sym_let] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_export] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(788),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_with] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(788),
  },
  [112] = {
    [sym__automatic_semicolon] = ACTIONS(792),
    [anon_sym_SEMI] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(794),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(794),
    [anon_sym_SEMI] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(794),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(794),
    [anon_sym_LT_LT] = ACTIONS(794),
    [anon_sym_STAR] = ACTIONS(796),
    [anon_sym_GT_GT_GT] = ACTIONS(794),
    [anon_sym_AMP_AMP] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_LT_EQ] = ACTIONS(794),
    [anon_sym_LPAREN] = ACTIONS(794),
    [anon_sym_GT_EQ] = ACTIONS(794),
    [anon_sym_GT] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(796),
    [anon_sym_PERCENT] = ACTIONS(794),
    [anon_sym_QMARK] = ACTIONS(794),
    [anon_sym_RBRACE] = ACTIONS(794),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(794),
    [anon_sym_DASH_DASH] = ACTIONS(794),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_instanceof] = ACTIONS(794),
    [anon_sym_LT] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(794),
    [anon_sym_STAR_STAR] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_PLUS_PLUS] = ACTIONS(794),
    [anon_sym_in] = ACTIONS(796),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(794),
    [anon_sym_BANG] = ACTIONS(796),
  },
  [114] = {
    [sym_await_expression] = STATE(1909),
    [sym_update_expression] = STATE(1909),
    [sym_meta_property] = STATE(1909),
    [sym__expression] = STATE(1909),
    [sym_jsx_element] = STATE(1909),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1909),
    [sym_call_expression] = STATE(1909),
    [sym_ternary_expression] = STATE(1909),
    [sym_template_string] = STATE(1909),
    [sym_yield_expression] = STATE(1909),
    [sym_jsx_fragment] = STATE(1909),
    [sym_new_expression] = STATE(1909),
    [sym_assignment_expression] = STATE(1909),
    [sym_binary_expression] = STATE(1909),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1909),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1909),
    [sym_jsx_self_closing_element] = STATE(1909),
    [sym_arrow_function] = STATE(1909),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(1908),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1909),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1909),
    [sym_augmented_assignment_expression] = STATE(1909),
    [sym_unary_expression] = STATE(1909),
    [sym_regex] = STATE(1909),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1909),
    [sym_class] = STATE(1909),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(798),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(798),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(798),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(798),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(800),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(798),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [115] = {
    [sym_generator_function_declaration] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(359),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(359),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(359),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(359),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(359),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(359),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(359),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(359),
    [sym_function_declaration] = STATE(359),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(359),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(359),
    [sym_break_statement] = STATE(359),
    [sym_labeled_statement] = STATE(359),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(359),
    [sym_class_declaration] = STATE(359),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(359),
    [sym_ambient_declaration] = STATE(359),
    [sym_type_alias_declaration] = STATE(359),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(359),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(359),
    [sym_switch_statement] = STATE(359),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(359),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(359),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(359),
    [sym_abstract_class_declaration] = STATE(359),
    [sym_interface_declaration] = STATE(359),
    [sym_export_statement] = STATE(359),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(359),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(359),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(359),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(359),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [116] = {
    [sym_class] = STATE(360),
    [sym_arrow_function] = STATE(360),
    [sym_await_expression] = STATE(360),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(360),
    [sym_meta_property] = STATE(360),
    [sym__expression] = STATE(360),
    [sym_jsx_element] = STATE(360),
    [sym_function] = STATE(52),
    [sym_import] = STATE(360),
    [sym_call_expression] = STATE(360),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(360),
    [sym_string] = STATE(360),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(360),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(360),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(360),
    [sym_generator_function] = STATE(360),
    [sym_new_expression] = STATE(360),
    [sym_assignment_expression] = STATE(360),
    [sym_augmented_assignment_expression] = STATE(360),
    [sym_binary_expression] = STATE(360),
    [sym_unary_expression] = STATE(360),
    [sym_regex] = STATE(360),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(360),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(360),
    [sym_internal_module] = STATE(360),
    [sym_jsx_self_closing_element] = STATE(360),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(802),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(802),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(802),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(802),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(804),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(802),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [117] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(806),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [118] = {
    [sym__automatic_semicolon] = ACTIONS(808),
    [anon_sym_SEMI] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(808),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(808),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [120] = {
    [sym_identifier] = ACTIONS(810),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_type_parameters] = STATE(364),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(818),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_namespace_import] = STATE(126),
    [sym_named_imports] = STATE(126),
    [sym_import_require_clause] = STATE(368),
    [sym_string] = STATE(368),
    [sym_import_clause] = STATE(369),
    [anon_sym_STAR] = ACTIONS(820),
    [sym_identifier] = ACTIONS(822),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(241),
  },
  [124] = {
    [anon_sym_as] = ACTIONS(824),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym__import_export_specifier] = STATE(375),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(828),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(832),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [anon_sym_from] = ACTIONS(818),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__automatic_semicolon] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(834),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym__from_clause] = STATE(368),
    [anon_sym_from] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_statement_block] = STATE(379),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_symbol] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_as] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(840),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_instanceof] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_DOT] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(840),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_number] = ACTIONS(840),
    [anon_sym_typeof] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [anon_sym_any] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_export] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
    [sym_identifier] = ACTIONS(840),
    [anon_sym_debugger] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_void] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [sym_super] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_get] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [sym_this] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_type] = ACTIONS(840),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_namespace] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_false] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_declare] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_boolean] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [sym_number] = ACTIONS(838),
    [ts_builtin_sym_end] = ACTIONS(838),
    [anon_sym_function] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_await] = ACTIONS(840),
  },
  [130] = {
    [sym_statement_block] = STATE(379),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_symbol] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_as] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(840),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_instanceof] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_set] = ACTIONS(840),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_number] = ACTIONS(840),
    [anon_sym_typeof] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [anon_sym_any] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_export] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
    [sym_identifier] = ACTIONS(840),
    [anon_sym_debugger] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_void] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [sym_super] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_get] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [sym_this] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_type] = ACTIONS(840),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_namespace] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_false] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_declare] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_boolean] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [sym_number] = ACTIONS(838),
    [ts_builtin_sym_end] = ACTIONS(838),
    [anon_sym_function] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_await] = ACTIONS(840),
  },
  [131] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(846),
    [sym__automatic_semicolon] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_symbol] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_GT_GT_GT] = ACTIONS(846),
    [anon_sym_break] = ACTIONS(848),
    [anon_sym_BANG_EQ] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(848),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_PERCENT] = ACTIONS(846),
    [anon_sym_interface] = ACTIONS(848),
    [anon_sym_as] = ACTIONS(848),
    [anon_sym_delete] = ACTIONS(848),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_instanceof] = ACTIONS(848),
    [anon_sym_yield] = ACTIONS(848),
    [sym_true] = ACTIONS(848),
    [anon_sym_protected] = ACTIONS(848),
    [anon_sym_DOT] = ACTIONS(848),
    [anon_sym_set] = ACTIONS(848),
    [anon_sym_PIPE_RBRACE] = ACTIONS(846),
    [anon_sym_import] = ACTIONS(848),
    [anon_sym_in] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(846),
    [anon_sym_for] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_number] = ACTIONS(848),
    [anon_sym_typeof] = ACTIONS(848),
    [anon_sym_LT_LT] = ACTIONS(846),
    [anon_sym_LBRACE] = ACTIONS(846),
    [anon_sym_AMP_AMP] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [sym_null] = ACTIONS(848),
    [anon_sym_any] = ACTIONS(848),
    [anon_sym_async] = ACTIONS(848),
    [anon_sym_public] = ACTIONS(848),
    [anon_sym_var] = ACTIONS(848),
    [anon_sym_QMARK] = ACTIONS(846),
    [anon_sym_while] = ACTIONS(848),
    [anon_sym_SQUOTE] = ACTIONS(846),
    [anon_sym_SLASH] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(848),
    [anon_sym_new] = ACTIONS(848),
    [anon_sym_CARET] = ACTIONS(846),
    [anon_sym_export] = ACTIONS(848),
    [anon_sym_GT_GT] = ACTIONS(848),
    [anon_sym_with] = ACTIONS(848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(846),
    [sym_identifier] = ACTIONS(848),
    [anon_sym_debugger] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_void] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(848),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [sym_super] = ACTIONS(848),
    [anon_sym_private] = ACTIONS(848),
    [anon_sym_get] = ACTIONS(848),
    [anon_sym_default] = ACTIONS(848),
    [anon_sym_enum] = ACTIONS(848),
    [anon_sym_continue] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [sym_this] = ACTIONS(848),
    [anon_sym_throw] = ACTIONS(848),
    [anon_sym_abstract] = ACTIONS(848),
    [anon_sym_type] = ACTIONS(848),
    [anon_sym_STAR_STAR] = ACTIONS(846),
    [anon_sym_namespace] = ACTIONS(848),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_else] = ACTIONS(848),
    [anon_sym_BANG] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym_false] = ACTIONS(848),
    [anon_sym_case] = ACTIONS(848),
    [anon_sym_module] = ACTIONS(848),
    [anon_sym_class] = ACTIONS(848),
    [anon_sym_declare] = ACTIONS(848),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_boolean] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(848),
    [anon_sym_PIPE_PIPE] = ACTIONS(846),
    [anon_sym_try] = ACTIONS(848),
    [anon_sym_EQ_EQ] = ACTIONS(848),
    [anon_sym_LT] = ACTIONS(848),
    [sym_number] = ACTIONS(846),
    [ts_builtin_sym_end] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [sym_undefined] = ACTIONS(848),
    [anon_sym_let] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_do] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_await] = ACTIONS(848),
  },
  [132] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(850),
    [sym__automatic_semicolon] = ACTIONS(850),
    [anon_sym_BQUOTE] = ACTIONS(850),
    [anon_sym_PIPE] = ACTIONS(852),
    [anon_sym_COMMA] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_STAR] = ACTIONS(852),
    [anon_sym_GT_GT_GT] = ACTIONS(850),
    [anon_sym_EQ] = ACTIONS(852),
    [anon_sym_BANG_EQ] = ACTIONS(852),
    [anon_sym_GT_EQ] = ACTIONS(850),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_PERCENT] = ACTIONS(850),
    [anon_sym_as] = ACTIONS(850),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_instanceof] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(850),
    [anon_sym_DOT] = ACTIONS(850),
    [anon_sym_PIPE_RBRACE] = ACTIONS(850),
    [anon_sym_STAR_STAR] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_in] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(850),
    [anon_sym_BANG] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_SEMI] = ACTIONS(850),
    [anon_sym_LT_LT] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(850),
    [anon_sym_LT_EQ] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(852),
    [anon_sym_AMP] = ACTIONS(852),
    [anon_sym_QMARK] = ACTIONS(850),
    [anon_sym_PIPE_PIPE] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(850),
    [anon_sym_EQ_EQ] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(852),
    [anon_sym_SLASH] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(850),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_GT_GT] = ACTIONS(852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(850),
  },
  [133] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(854),
    [aux_sym_string_token1] = ACTIONS(856),
    [anon_sym_DQUOTE] = ACTIONS(858),
    [sym_comment] = ACTIONS(255),
  },
  [134] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [135] = {
    [sym_await_expression] = STATE(51),
    [sym_update_expression] = STATE(51),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_ternary_expression] = STATE(51),
    [sym_template_string] = STATE(51),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(390),
    [sym_binary_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(389),
    [sym_array] = STATE(392),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(389),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(389),
    [sym_expression_statement] = STATE(390),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(391),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(390),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(390),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(862),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(864),
    [anon_sym_const] = ACTIONS(866),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(862),
    [anon_sym_static] = ACTIONS(862),
    [anon_sym_get] = ACTIONS(862),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(862),
    [anon_sym_set] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(862),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(868),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(862),
    [anon_sym_number] = ACTIONS(862),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(862),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(862),
    [anon_sym_boolean] = ACTIONS(862),
    [anon_sym_async] = ACTIONS(870),
    [anon_sym_public] = ACTIONS(862),
    [anon_sym_var] = ACTIONS(872),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(862),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(866),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [136] = {
    [sym__for_header] = STATE(394),
    [anon_sym_LPAREN] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_generator_function_declaration] = STATE(395),
    [sym__declaration] = STATE(395),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(395),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(395),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(395),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(395),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(395),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(395),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(395),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(395),
    [sym_function_declaration] = STATE(395),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(395),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(395),
    [sym_break_statement] = STATE(395),
    [sym_labeled_statement] = STATE(395),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(395),
    [sym_class_declaration] = STATE(395),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(395),
    [sym_ambient_declaration] = STATE(395),
    [sym_type_alias_declaration] = STATE(395),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(395),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(395),
    [sym_switch_statement] = STATE(395),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(395),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(395),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(395),
    [sym_abstract_class_declaration] = STATE(395),
    [sym_interface_declaration] = STATE(395),
    [sym_export_statement] = STATE(395),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(395),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(395),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(395),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(395),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [138] = {
    [sym_class] = STATE(396),
    [sym_arrow_function] = STATE(396),
    [sym_await_expression] = STATE(396),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(396),
    [sym_meta_property] = STATE(396),
    [sym__expression] = STATE(396),
    [sym_jsx_element] = STATE(396),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(396),
    [sym_call_expression] = STATE(396),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(396),
    [sym_string] = STATE(396),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(396),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(396),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(396),
    [sym_generator_function] = STATE(396),
    [sym_new_expression] = STATE(396),
    [sym_assignment_expression] = STATE(396),
    [sym_augmented_assignment_expression] = STATE(396),
    [sym_binary_expression] = STATE(396),
    [sym_unary_expression] = STATE(396),
    [sym_regex] = STATE(396),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(396),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(396),
    [sym_internal_module] = STATE(396),
    [sym_jsx_self_closing_element] = STATE(396),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(876),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(876),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(876),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(876),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [139] = {
    [sym_await_expression] = STATE(397),
    [sym_update_expression] = STATE(397),
    [sym_meta_property] = STATE(397),
    [sym__expression] = STATE(397),
    [sym_jsx_element] = STATE(397),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(397),
    [sym_call_expression] = STATE(397),
    [sym_ternary_expression] = STATE(397),
    [sym_template_string] = STATE(397),
    [sym_yield_expression] = STATE(397),
    [sym_jsx_fragment] = STATE(397),
    [sym_new_expression] = STATE(397),
    [sym_assignment_expression] = STATE(397),
    [sym_binary_expression] = STATE(397),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(397),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(397),
    [sym_jsx_self_closing_element] = STATE(397),
    [sym_arrow_function] = STATE(397),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(398),
    [sym_string] = STATE(397),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(397),
    [sym_augmented_assignment_expression] = STATE(397),
    [sym_unary_expression] = STATE(397),
    [sym_regex] = STATE(397),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(397),
    [sym_class] = STATE(397),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(880),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(882),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(880),
    [sym_null] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(882),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [140] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(886),
    [sym__automatic_semicolon] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT_GT] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_as] = ACTIONS(886),
    [anon_sym_DASH_DASH] = ACTIONS(886),
    [anon_sym_instanceof] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PLUS_PLUS] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(888),
    [anon_sym_BANG] = ACTIONS(888),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_SEMI] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_AMP_AMP] = ACTIONS(886),
    [anon_sym_of] = ACTIONS(886),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_AMP] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(886),
    [anon_sym_PIPE_PIPE] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_SLASH] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(886),
  },
  [141] = {
    [aux_sym_array_repeat1] = STATE(400),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(906),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [142] = {
    [aux_sym_array_repeat1] = STATE(400),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(906),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(928),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_symbol] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_void] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [sym_super] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_get] = ACTIONS(926),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_interface] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_delete] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(926),
    [sym_this] = ACTIONS(926),
    [anon_sym_yield] = ACTIONS(926),
    [sym_true] = ACTIONS(926),
    [anon_sym_throw] = ACTIONS(926),
    [anon_sym_protected] = ACTIONS(926),
    [anon_sym_abstract] = ACTIONS(926),
    [anon_sym_set] = ACTIONS(926),
    [anon_sym_type] = ACTIONS(926),
    [anon_sym_import] = ACTIONS(926),
    [anon_sym_namespace] = ACTIONS(926),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(928),
    [sym_false] = ACTIONS(926),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_module] = ACTIONS(926),
    [anon_sym_number] = ACTIONS(926),
    [anon_sym_class] = ACTIONS(926),
    [anon_sym_declare] = ACTIONS(926),
    [anon_sym_typeof] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(928),
    [sym_null] = ACTIONS(926),
    [anon_sym_any] = ACTIONS(926),
    [anon_sym_boolean] = ACTIONS(926),
    [anon_sym_async] = ACTIONS(926),
    [anon_sym_public] = ACTIONS(926),
    [anon_sym_var] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [sym_number] = ACTIONS(928),
    [anon_sym_SLASH] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(926),
    [anon_sym_function] = ACTIONS(926),
    [sym_undefined] = ACTIONS(926),
    [anon_sym_new] = ACTIONS(926),
    [ts_builtin_sym_end] = ACTIONS(928),
    [anon_sym_let] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_export] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_with] = ACTIONS(926),
    [anon_sym_await] = ACTIONS(926),
  },
  [145] = {
    [sym_class] = STATE(404),
    [sym_arrow_function] = STATE(404),
    [sym_await_expression] = STATE(404),
    [sym_member_expression] = STATE(2748),
    [sym_generic_type] = STATE(403),
    [sym_update_expression] = STATE(404),
    [sym_meta_property] = STATE(404),
    [sym__expression] = STATE(404),
    [sym_jsx_element] = STATE(404),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(405),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(404),
    [sym_call_expression] = STATE(404),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(404),
    [sym_string] = STATE(404),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(404),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(404),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(404),
    [sym_generator_function] = STATE(404),
    [sym_new_expression] = STATE(404),
    [sym_assignment_expression] = STATE(404),
    [sym_augmented_assignment_expression] = STATE(404),
    [sym_binary_expression] = STATE(404),
    [sym_unary_expression] = STATE(404),
    [sym_regex] = STATE(404),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(404),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(404),
    [sym_internal_module] = STATE(404),
    [sym_jsx_self_closing_element] = STATE(404),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(932),
    [sym_false] = ACTIONS(934),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(934),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(934),
    [sym_number] = ACTIONS(948),
    [sym_true] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [146] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(406),
    [sym_function_type] = STATE(406),
    [sym_constructor_type] = STATE(406),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(406),
    [sym__type] = STATE(406),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [147] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(408),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(407),
    [sym_type_parameters] = STATE(409),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [148] = {
    [sym_type_parameter] = STATE(224),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_decorator] = STATE(422),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(422),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [150] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(994),
  },
  [151] = {
    [sym_implements_clause] = STATE(426),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(994),
  },
  [152] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(996),
    [anon_sym_LBRACK] = ACTIONS(996),
    [sym__automatic_semicolon] = ACTIONS(996),
    [anon_sym_SEMI] = ACTIONS(996),
    [anon_sym_BQUOTE] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_LT_LT] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_GT_GT_GT] = ACTIONS(996),
    [anon_sym_AMP_AMP] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(998),
    [anon_sym_BANG_EQ] = ACTIONS(998),
    [anon_sym_LT_EQ] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_GT_EQ] = ACTIONS(996),
    [anon_sym_GT] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_PERCENT] = ACTIONS(996),
    [anon_sym_QMARK] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_as] = ACTIONS(996),
    [anon_sym_PIPE_PIPE] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(996),
    [anon_sym_EQ_EQ] = ACTIONS(998),
    [anon_sym_instanceof] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(998),
    [anon_sym_SLASH] = ACTIONS(998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(996),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_STAR_STAR] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_GT_GT] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(996),
    [anon_sym_in] = ACTIONS(998),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(996),
    [anon_sym_BANG] = ACTIONS(998),
  },
  [153] = {
    [sym_class_body] = STATE(427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [154] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(428),
    [sym_class_heritage] = STATE(429),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [155] = {
    [sym_nested_identifier] = STATE(1327),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_identifier] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_global] = ACTIONS(343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_async] = ACTIONS(365),
  },
  [158] = {
    [sym_statement_block] = STATE(432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [159] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1006),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_nested_identifier] = STATE(1327),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(1729),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(331),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [anon_sym_debugger] = ACTIONS(1016),
    [anon_sym_symbol] = ACTIONS(1016),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [sym_super] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_private] = ACTIONS(1016),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_get] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_interface] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_delete] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_if] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [anon_sym_yield] = ACTIONS(1016),
    [sym_true] = ACTIONS(1016),
    [anon_sym_throw] = ACTIONS(1016),
    [anon_sym_protected] = ACTIONS(1016),
    [anon_sym_abstract] = ACTIONS(1016),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_import] = ACTIONS(1016),
    [anon_sym_namespace] = ACTIONS(1016),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [sym_false] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_module] = ACTIONS(1016),
    [anon_sym_number] = ACTIONS(1016),
    [anon_sym_class] = ACTIONS(1016),
    [anon_sym_declare] = ACTIONS(1016),
    [anon_sym_typeof] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [sym_null] = ACTIONS(1016),
    [anon_sym_any] = ACTIONS(1016),
    [anon_sym_boolean] = ACTIONS(1016),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_public] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1018),
    [sym_number] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1016),
    [sym_undefined] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1016),
    [ts_builtin_sym_end] = ACTIONS(1018),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_export] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_await] = ACTIONS(1016),
  },
  [165] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [aux_sym_object_repeat1] = STATE(440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [167] = {
    [aux_sym_object_repeat1] = STATE(440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [168] = {
    [sym_computed_property_name] = STATE(186),
    [sym_object] = STATE(307),
    [sym_method_definition] = STATE(447),
    [sym_assignment_pattern] = STATE(447),
    [sym_array] = STATE(308),
    [sym_accessibility_modifier] = STATE(190),
    [sym_spread_element] = STATE(447),
    [sym_string] = STATE(186),
    [sym__property_name] = STATE(186),
    [sym_pair] = STATE(447),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(1043),
    [anon_sym_symbol] = ACTIONS(1043),
    [anon_sym_number] = ACTIONS(1043),
    [anon_sym_declare] = ACTIONS(1043),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(1043),
    [anon_sym_any] = ACTIONS(1043),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1043),
    [anon_sym_static] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_number] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1043),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1043),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(1043),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [169] = {
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_computed_property_name] = STATE(449),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [170] = {
    [sym_await_expression] = STATE(93),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_ternary_expression] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_yield_expression] = STATE(93),
    [sym_jsx_fragment] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(93),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_generator_function] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [171] = {
    [aux_sym_object_repeat1] = STATE(440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [sym_number] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [172] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1070),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [sym_number] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [173] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [sym_number] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [174] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_interface] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(1083),
    [sym_true] = ACTIONS(1083),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(1085),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [sym_null] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_var] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_debugger] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [sym_super] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_this] = ACTIONS(1083),
    [anon_sym_throw] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_else] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_false] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1083),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1083),
    [sym_number] = ACTIONS(1081),
    [ts_builtin_sym_end] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(1083),
    [sym_undefined] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1083),
  },
  [175] = {
    [aux_sym_object_repeat1] = STATE(440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [176] = {
    [sym_nested_identifier] = STATE(129),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(130),
    [sym__module] = STATE(131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [177] = {
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_computed_property_name] = STATE(449),
    [anon_sym_get] = ACTIONS(1068),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [178] = {
    [sym_class] = STATE(455),
    [sym_arrow_function] = STATE(455),
    [sym_await_expression] = STATE(455),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(455),
    [sym_meta_property] = STATE(455),
    [sym__expression] = STATE(455),
    [sym_jsx_element] = STATE(455),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(455),
    [sym_call_expression] = STATE(455),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_spread_element] = STATE(142),
    [sym_ternary_expression] = STATE(455),
    [sym_string] = STATE(455),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(455),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(455),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(455),
    [sym_generator_function] = STATE(455),
    [sym_new_expression] = STATE(455),
    [sym_assignment_expression] = STATE(455),
    [sym_augmented_assignment_expression] = STATE(455),
    [sym_binary_expression] = STATE(455),
    [sym_unary_expression] = STATE(455),
    [sym_regex] = STATE(455),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [aux_sym_array_repeat1] = STATE(143),
    [sym_non_null_expression] = STATE(455),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(455),
    [sym_internal_module] = STATE(455),
    [sym_jsx_self_closing_element] = STATE(455),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(305),
    [sym_null] = ACTIONS(1089),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1089),
    [sym_number] = ACTIONS(1091),
    [sym_true] = ACTIONS(1089),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1089),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [179] = {
    [sym_nested_identifier] = STATE(1327),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [180] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(343),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(365),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [181] = {
    [sym_formal_parameters] = STATE(61),
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(440),
    [sym__call_signature] = STATE(214),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_type_parameters] = STATE(60),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_public] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1093),
    [anon_sym_declare] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1093),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1103),
    [sym_number] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [182] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [183] = {
    [sym_class_declaration] = STATE(249),
    [sym_generator_function_declaration] = STATE(249),
    [sym__declaration] = STATE(249),
    [sym_ambient_declaration] = STATE(249),
    [sym_import_alias] = STATE(249),
    [sym_type_alias_declaration] = STATE(249),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_function_signature] = STATE(249),
    [sym_abstract_class_declaration] = STATE(249),
    [sym_module] = STATE(249),
    [sym_interface_declaration] = STATE(249),
    [sym_function_declaration] = STATE(249),
    [sym_export_clause] = STATE(250),
    [sym_variable_declaration] = STATE(249),
    [sym_lexical_declaration] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(249),
    [sym_enum_declaration] = STATE(249),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_as] = ACTIONS(507),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(365),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [184] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [186] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(465),
    [anon_sym_COLON] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [188] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [189] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_computed_property_name] = STATE(449),
    [anon_sym_get] = ACTIONS(1068),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(1070),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_private] = ACTIONS(1055),
  },
  [191] = {
    [sym_switch_body] = STATE(471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1131),
  },
  [192] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [193] = {
    [sym_object] = STATE(474),
    [sym_array] = STATE(475),
    [anon_sym_get] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_public] = ACTIONS(1143),
    [anon_sym_module] = ACTIONS(1143),
    [anon_sym_symbol] = ACTIONS(1143),
    [anon_sym_number] = ACTIONS(1143),
    [anon_sym_declare] = ACTIONS(1143),
    [sym_this] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1143),
    [anon_sym_protected] = ACTIONS(1143),
    [anon_sym_string] = ACTIONS(1143),
    [anon_sym_set] = ACTIONS(1143),
    [anon_sym_type] = ACTIONS(1143),
    [anon_sym_export] = ACTIONS(1143),
    [anon_sym_namespace] = ACTIONS(1143),
    [anon_sym_any] = ACTIONS(1143),
    [anon_sym_private] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1143),
    [anon_sym_static] = ACTIONS(1143),
  },
  [194] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(321),
  },
  [197] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [198] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [199] = {
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_EQ_GT] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1177),
  },
  [200] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [201] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [202] = {
    [aux_sym_formal_parameters_repeat1] = STATE(479),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__initializer] = STATE(481),
    [sym_type_annotation] = STATE(482),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_COMMA] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [anon_sym_RPAREN] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_type_arguments] = STATE(1877),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_annotation] = STATE(484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [206] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1200),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [207] = {
    [sym_object] = STATE(474),
    [sym_array] = STATE(475),
    [anon_sym_get] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_public] = ACTIONS(1143),
    [anon_sym_module] = ACTIONS(1143),
    [anon_sym_symbol] = ACTIONS(1143),
    [anon_sym_number] = ACTIONS(1143),
    [anon_sym_declare] = ACTIONS(1143),
    [sym_this] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1143),
    [anon_sym_protected] = ACTIONS(1143),
    [anon_sym_string] = ACTIONS(1143),
    [anon_sym_set] = ACTIONS(1143),
    [anon_sym_type] = ACTIONS(1143),
    [anon_sym_export] = ACTIONS(1143),
    [sym_readonly] = ACTIONS(1203),
    [anon_sym_namespace] = ACTIONS(1143),
    [anon_sym_any] = ACTIONS(1143),
    [anon_sym_private] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(1143),
  },
  [208] = {
    [sym_optional_parameter] = STATE(488),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(488),
    [aux_sym_export_statement_repeat1] = STATE(2705),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(488),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_class] = ACTIONS(1209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [209] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [210] = {
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [anon_sym_EQ_GT] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(202),
    [aux_sym_export_statement_repeat1] = STATE(493),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(431),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [213] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(496),
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [aux_sym_variable_declaration_repeat1] = STATE(499),
    [sym__automatic_semicolon] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [217] = {
    [sym_generator_function_declaration] = STATE(500),
    [sym__declaration] = STATE(500),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(500),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(500),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(500),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(500),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(500),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(500),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(500),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(500),
    [sym_function_declaration] = STATE(500),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(500),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_labeled_statement] = STATE(500),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(500),
    [sym_class_declaration] = STATE(500),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(500),
    [sym_ambient_declaration] = STATE(500),
    [sym_type_alias_declaration] = STATE(500),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(500),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(500),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(500),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(500),
    [sym_abstract_class_declaration] = STATE(500),
    [sym_interface_declaration] = STATE(500),
    [sym_export_statement] = STATE(500),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(500),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(500),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(500),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(500),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [218] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(1233),
    [aux_sym_string_token2] = ACTIONS(1235),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(858),
  },
  [219] = {
    [sym_generator_function_declaration] = STATE(187),
    [sym__declaration] = STATE(187),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(187),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(187),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(187),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(187),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(187),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(187),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(187),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(187),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(187),
    [sym_break_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(187),
    [sym_class_declaration] = STATE(187),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(187),
    [sym_ambient_declaration] = STATE(187),
    [sym_type_alias_declaration] = STATE(187),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(187),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(187),
    [sym_switch_statement] = STATE(187),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(187),
    [sym_throw_statement] = STATE(187),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(187),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(187),
    [sym_abstract_class_declaration] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_export_statement] = STATE(187),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(187),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(187),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(187),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(187),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [220] = {
    [sym_catch_clause] = STATE(505),
    [sym_finally_clause] = STATE(506),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1241),
    [anon_sym_delete] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(1241),
    [sym_true] = ACTIONS(1241),
    [anon_sym_protected] = ACTIONS(1241),
    [anon_sym_set] = ACTIONS(1241),
    [anon_sym_import] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_number] = ACTIONS(1241),
    [anon_sym_typeof] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1241),
    [sym_null] = ACTIONS(1241),
    [anon_sym_catch] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1241),
    [anon_sym_async] = ACTIONS(1241),
    [anon_sym_public] = ACTIONS(1241),
    [anon_sym_var] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1241),
    [anon_sym_new] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_with] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_debugger] = ACTIONS(1241),
    [anon_sym_AT] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [sym_super] = ACTIONS(1241),
    [anon_sym_private] = ACTIONS(1241),
    [anon_sym_get] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [sym_this] = ACTIONS(1241),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_abstract] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1241),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [sym_false] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_module] = ACTIONS(1241),
    [anon_sym_class] = ACTIONS(1241),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_boolean] = ACTIONS(1241),
    [anon_sym_try] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1239),
    [sym_number] = ACTIONS(1239),
    [anon_sym_finally] = ACTIONS(1245),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1241),
    [sym_undefined] = ACTIONS(1241),
    [anon_sym_let] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_await] = ACTIONS(1241),
  },
  [221] = {
    [sym_jsx_element] = STATE(508),
    [sym_jsx_expression] = STATE(508),
    [aux_sym_jsx_element_repeat1] = STATE(508),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_self_closing_element] = STATE(508),
    [sym_jsx_text] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1249),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [222] = {
    [sym_default_type] = STATE(519),
    [sym_jsx_expression] = STATE(516),
    [sym_type_arguments] = STATE(518),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_constraint] = STATE(517),
    [aux_sym_jsx_opening_element_repeat1] = STATE(515),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_extends] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1271),
  },
  [223] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(515),
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [224] = {
    [aux_sym_type_parameters_repeat1] = STATE(524),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_COMMA] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_jsx_expression] = STATE(516),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_type_arguments] = STATE(518),
    [sym_jsx_attribute] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(515),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [226] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(515),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [227] = {
    [anon_sym_SLASH2] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(526),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(528),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_statement_block] = STATE(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [231] = {
    [sym_arguments] = STATE(530),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [232] = {
    [sym_arguments] = STATE(530),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1294),
  },
  [233] = {
    [anon_sym_target] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_arguments] = STATE(532),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1300),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [235] = {
    [sym_await_expression] = STATE(2497),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_ternary_expression] = STATE(2497),
    [sym_template_string] = STATE(2497),
    [sym_yield_expression] = STATE(2497),
    [sym_jsx_fragment] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2497),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_arguments] = STATE(532),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2497),
    [sym_class] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [sym_this] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [sym_number] = ACTIONS(1322),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [236] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(532),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(437),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(437),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_protected] = ACTIONS(437),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(437),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(437),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(437),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [237] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_arguments] = STATE(532),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [238] = {
    [sym_arguments] = STATE(530),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [239] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [240] = {
    [sym_arguments] = STATE(533),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1294),
  },
  [241] = {
    [sym_arguments] = STATE(530),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [242] = {
    [sym_arguments] = STATE(530),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [243] = {
    [sym_nested_identifier] = STATE(1327),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(331),
  },
  [244] = {
    [sym__from_clause] = STATE(534),
    [anon_sym_from] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym__import_export_specifier] = STATE(537),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_class] = STATE(294),
    [sym_arrow_function] = STATE(294),
    [sym_await_expression] = STATE(294),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(294),
    [sym_meta_property] = STATE(294),
    [sym__expression] = STATE(294),
    [sym_jsx_element] = STATE(294),
    [sym_function] = STATE(52),
    [sym_import] = STATE(294),
    [sym_call_expression] = STATE(294),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(294),
    [sym_string] = STATE(294),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(294),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(294),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(294),
    [sym_generator_function] = STATE(294),
    [sym_new_expression] = STATE(294),
    [sym_assignment_expression] = STATE(294),
    [sym_augmented_assignment_expression] = STATE(294),
    [sym_binary_expression] = STATE(294),
    [sym_unary_expression] = STATE(294),
    [sym_regex] = STATE(294),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(294),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(294),
    [sym_internal_module] = STATE(294),
    [sym_jsx_self_closing_element] = STATE(294),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(655),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [247] = {
    [sym_class] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_await_expression] = STATE(539),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym__expression] = STATE(539),
    [sym_jsx_element] = STATE(539),
    [sym_function] = STATE(52),
    [sym_import] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(539),
    [sym_string] = STATE(539),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(539),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(539),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(539),
    [sym_generator_function] = STATE(539),
    [sym_new_expression] = STATE(539),
    [sym_assignment_expression] = STATE(539),
    [sym_augmented_assignment_expression] = STATE(539),
    [sym_binary_expression] = STATE(539),
    [sym_unary_expression] = STATE(539),
    [sym_regex] = STATE(539),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(539),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(539),
    [sym_internal_module] = STATE(539),
    [sym_jsx_self_closing_element] = STATE(539),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(1370),
    [anon_sym_yield] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1370),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1370),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1380),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_await] = ACTIONS(1384),
  },
  [248] = {
    [anon_sym_namespace] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_debugger] = ACTIONS(1388),
    [anon_sym_symbol] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_void] = ACTIONS(1388),
    [anon_sym_break] = ACTIONS(1388),
    [anon_sym_const] = ACTIONS(1388),
    [sym_super] = ACTIONS(1388),
    [anon_sym_return] = ACTIONS(1388),
    [anon_sym_private] = ACTIONS(1388),
    [anon_sym_static] = ACTIONS(1388),
    [anon_sym_get] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_default] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1388),
    [anon_sym_delete] = ACTIONS(1388),
    [anon_sym_continue] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1388),
    [sym_this] = ACTIONS(1388),
    [anon_sym_yield] = ACTIONS(1388),
    [sym_true] = ACTIONS(1388),
    [anon_sym_throw] = ACTIONS(1388),
    [anon_sym_protected] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1388),
    [anon_sym_set] = ACTIONS(1388),
    [anon_sym_type] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(1388),
    [anon_sym_namespace] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [sym_false] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1388),
    [anon_sym_module] = ACTIONS(1388),
    [anon_sym_number] = ACTIONS(1388),
    [anon_sym_class] = ACTIONS(1388),
    [anon_sym_declare] = ACTIONS(1388),
    [anon_sym_typeof] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [sym_null] = ACTIONS(1388),
    [anon_sym_any] = ACTIONS(1388),
    [anon_sym_boolean] = ACTIONS(1388),
    [anon_sym_async] = ACTIONS(1388),
    [anon_sym_public] = ACTIONS(1388),
    [anon_sym_var] = ACTIONS(1388),
    [anon_sym_while] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_try] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1390),
    [sym_number] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1388),
    [anon_sym_function] = ACTIONS(1388),
    [sym_undefined] = ACTIONS(1388),
    [anon_sym_new] = ACTIONS(1388),
    [ts_builtin_sym_end] = ACTIONS(1390),
    [anon_sym_let] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1388),
    [anon_sym_do] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_with] = ACTIONS(1388),
    [anon_sym_await] = ACTIONS(1388),
  },
  [250] = {
    [sym__from_clause] = STATE(534),
    [sym__automatic_semicolon] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym_from] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [anon_sym_while] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_generator_function_declaration] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(543),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(543),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(543),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(543),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(543),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(543),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(543),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(543),
    [sym_function_declaration] = STATE(543),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(543),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(543),
    [sym_class_declaration] = STATE(543),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(543),
    [sym_ambient_declaration] = STATE(543),
    [sym_type_alias_declaration] = STATE(543),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(543),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(543),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(543),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(543),
    [sym_abstract_class_declaration] = STATE(543),
    [sym_interface_declaration] = STATE(543),
    [sym_export_statement] = STATE(543),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(543),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(543),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(543),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(543),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [253] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [254] = {
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_debugger] = ACTIONS(1398),
    [anon_sym_symbol] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_void] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [sym_super] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_private] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_get] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_delete] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1398),
    [sym_this] = ACTIONS(1398),
    [anon_sym_yield] = ACTIONS(1398),
    [sym_true] = ACTIONS(1398),
    [anon_sym_throw] = ACTIONS(1398),
    [anon_sym_protected] = ACTIONS(1398),
    [anon_sym_abstract] = ACTIONS(1398),
    [anon_sym_set] = ACTIONS(1398),
    [anon_sym_type] = ACTIONS(1398),
    [anon_sym_import] = ACTIONS(1398),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [sym_false] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_module] = ACTIONS(1398),
    [anon_sym_number] = ACTIONS(1398),
    [anon_sym_class] = ACTIONS(1398),
    [anon_sym_declare] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [sym_null] = ACTIONS(1398),
    [anon_sym_any] = ACTIONS(1398),
    [anon_sym_boolean] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_public] = ACTIONS(1398),
    [anon_sym_var] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1398),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1400),
    [sym_number] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1398),
    [anon_sym_function] = ACTIONS(1398),
    [sym_undefined] = ACTIONS(1398),
    [anon_sym_new] = ACTIONS(1398),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_with] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1398),
  },
  [255] = {
    [sym_class] = STATE(544),
    [sym_arrow_function] = STATE(544),
    [sym_await_expression] = STATE(544),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(544),
    [sym_meta_property] = STATE(544),
    [sym__expression] = STATE(544),
    [sym_jsx_element] = STATE(544),
    [sym_function] = STATE(52),
    [sym_import] = STATE(544),
    [sym_call_expression] = STATE(544),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(544),
    [sym_string] = STATE(544),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(544),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(544),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(544),
    [sym_generator_function] = STATE(544),
    [sym_new_expression] = STATE(544),
    [sym_assignment_expression] = STATE(544),
    [sym_augmented_assignment_expression] = STATE(544),
    [sym_binary_expression] = STATE(544),
    [sym_unary_expression] = STATE(544),
    [sym_regex] = STATE(544),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(544),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(544),
    [sym_internal_module] = STATE(544),
    [sym_jsx_self_closing_element] = STATE(544),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1402),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1402),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1402),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1404),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1402),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [256] = {
    [sym_class] = STATE(545),
    [sym_arrow_function] = STATE(545),
    [sym_await_expression] = STATE(545),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(545),
    [sym_meta_property] = STATE(545),
    [sym__expression] = STATE(545),
    [sym_jsx_element] = STATE(545),
    [sym_function] = STATE(52),
    [sym_import] = STATE(545),
    [sym_call_expression] = STATE(545),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(545),
    [sym_string] = STATE(545),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(545),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(545),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(545),
    [sym_generator_function] = STATE(545),
    [sym_new_expression] = STATE(545),
    [sym_assignment_expression] = STATE(545),
    [sym_augmented_assignment_expression] = STATE(545),
    [sym_binary_expression] = STATE(545),
    [sym_unary_expression] = STATE(545),
    [sym_regex] = STATE(545),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(545),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(545),
    [sym_internal_module] = STATE(545),
    [sym_jsx_self_closing_element] = STATE(545),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1406),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [257] = {
    [sym_class] = STATE(546),
    [sym_arrow_function] = STATE(546),
    [sym_await_expression] = STATE(546),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(546),
    [sym_meta_property] = STATE(546),
    [sym__expression] = STATE(546),
    [sym_jsx_element] = STATE(546),
    [sym_function] = STATE(52),
    [sym_import] = STATE(546),
    [sym_call_expression] = STATE(546),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(546),
    [sym_string] = STATE(546),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(546),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(546),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(546),
    [sym_generator_function] = STATE(546),
    [sym_new_expression] = STATE(546),
    [sym_assignment_expression] = STATE(546),
    [sym_augmented_assignment_expression] = STATE(546),
    [sym_binary_expression] = STATE(546),
    [sym_unary_expression] = STATE(546),
    [sym_regex] = STATE(546),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(546),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(546),
    [sym_internal_module] = STATE(546),
    [sym_jsx_self_closing_element] = STATE(546),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1410),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1410),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [258] = {
    [sym_class] = STATE(547),
    [sym_arrow_function] = STATE(547),
    [sym_await_expression] = STATE(547),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(547),
    [sym_meta_property] = STATE(547),
    [sym__expression] = STATE(547),
    [sym_jsx_element] = STATE(547),
    [sym_function] = STATE(52),
    [sym_import] = STATE(547),
    [sym_call_expression] = STATE(547),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(547),
    [sym_string] = STATE(547),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(547),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(547),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(547),
    [sym_generator_function] = STATE(547),
    [sym_new_expression] = STATE(547),
    [sym_assignment_expression] = STATE(547),
    [sym_augmented_assignment_expression] = STATE(547),
    [sym_binary_expression] = STATE(547),
    [sym_unary_expression] = STATE(547),
    [sym_regex] = STATE(547),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(547),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(547),
    [sym_internal_module] = STATE(547),
    [sym_jsx_self_closing_element] = STATE(547),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1414),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1416),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [259] = {
    [sym_class] = STATE(548),
    [sym_arrow_function] = STATE(548),
    [sym_await_expression] = STATE(548),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(548),
    [sym_meta_property] = STATE(548),
    [sym__expression] = STATE(548),
    [sym_jsx_element] = STATE(548),
    [sym_function] = STATE(52),
    [sym_import] = STATE(548),
    [sym_call_expression] = STATE(548),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(548),
    [sym_string] = STATE(548),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(548),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(548),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(548),
    [sym_generator_function] = STATE(548),
    [sym_new_expression] = STATE(548),
    [sym_assignment_expression] = STATE(548),
    [sym_augmented_assignment_expression] = STATE(548),
    [sym_binary_expression] = STATE(548),
    [sym_unary_expression] = STATE(548),
    [sym_regex] = STATE(548),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(548),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(548),
    [sym_internal_module] = STATE(548),
    [sym_jsx_self_closing_element] = STATE(548),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1418),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1418),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1418),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1420),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1418),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [260] = {
    [sym_class] = STATE(550),
    [sym_arrow_function] = STATE(550),
    [sym_await_expression] = STATE(550),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(550),
    [sym_sequence_expression] = STATE(549),
    [sym_meta_property] = STATE(550),
    [sym__expression] = STATE(550),
    [sym_jsx_element] = STATE(550),
    [sym_function] = STATE(52),
    [sym_import] = STATE(550),
    [sym_call_expression] = STATE(550),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(550),
    [sym_string] = STATE(550),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(550),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(550),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(550),
    [sym_generator_function] = STATE(550),
    [sym_new_expression] = STATE(550),
    [sym_assignment_expression] = STATE(550),
    [sym_augmented_assignment_expression] = STATE(550),
    [sym_binary_expression] = STATE(550),
    [sym_unary_expression] = STATE(550),
    [sym_regex] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(550),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(550),
    [sym_internal_module] = STATE(550),
    [sym_jsx_self_closing_element] = STATE(550),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1422),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_true] = ACTIONS(1422),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1422),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [261] = {
    [sym_class] = STATE(551),
    [sym_arrow_function] = STATE(551),
    [sym_await_expression] = STATE(551),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(551),
    [sym_meta_property] = STATE(551),
    [sym__expression] = STATE(551),
    [sym_jsx_element] = STATE(551),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(551),
    [sym_call_expression] = STATE(551),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(551),
    [sym_string] = STATE(551),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(551),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(551),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(551),
    [sym_generator_function] = STATE(551),
    [sym_new_expression] = STATE(551),
    [sym_assignment_expression] = STATE(551),
    [sym_augmented_assignment_expression] = STATE(551),
    [sym_binary_expression] = STATE(551),
    [sym_unary_expression] = STATE(551),
    [sym_regex] = STATE(551),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(551),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(551),
    [sym_internal_module] = STATE(551),
    [sym_jsx_self_closing_element] = STATE(551),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(1426),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1426),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1426),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1426),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1426),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [262] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(552),
    [sym_function_type] = STATE(552),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(552),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_template_string] = STATE(553),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(552),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(552),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [263] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [sym__automatic_semicolon] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_BQUOTE] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1466),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_LT_LT] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_GT_GT_GT] = ACTIONS(1464),
    [anon_sym_AMP_AMP] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_BANG_EQ] = ACTIONS(1466),
    [anon_sym_LT_EQ] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_GT_EQ] = ACTIONS(1464),
    [anon_sym_GT] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_PERCENT] = ACTIONS(1464),
    [anon_sym_QMARK] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_as] = ACTIONS(1464),
    [anon_sym_PIPE_PIPE] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_EQ_EQ] = ACTIONS(1466),
    [anon_sym_instanceof] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_CARET] = ACTIONS(1464),
    [anon_sym_STAR_STAR] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_GT_GT] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_in] = ACTIONS(1466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1466),
  },
  [264] = {
    [sym_await_expression] = STATE(544),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(544),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(544),
    [sym_function_type] = STATE(345),
    [sym__expression] = STATE(544),
    [sym_jsx_element] = STATE(544),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(52),
    [sym_import] = STATE(544),
    [sym_call_expression] = STATE(544),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(544),
    [sym_template_string] = STATE(544),
    [sym_yield_expression] = STATE(544),
    [sym_jsx_fragment] = STATE(544),
    [sym_new_expression] = STATE(544),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(544),
    [sym_binary_expression] = STATE(544),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(544),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(544),
    [sym_jsx_self_closing_element] = STATE(544),
    [sym_arrow_function] = STATE(544),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(53),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(58),
    [sym__type] = STATE(345),
    [sym_subscript_expression] = STATE(53),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(555),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(544),
    [sym_constructor_type] = STATE(345),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(544),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(544),
    [sym_regex] = STATE(544),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(544),
    [sym_class] = STATE(544),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(1474),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1476),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [sym_false] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(1470),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [sym_null] = ACTIONS(1402),
    [anon_sym_any] = ACTIONS(1470),
    [anon_sym_boolean] = ACTIONS(1470),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1488),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1402),
    [anon_sym_new] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [265] = {
    [sym_class] = STATE(567),
    [sym_arrow_function] = STATE(567),
    [sym_await_expression] = STATE(567),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(567),
    [sym_meta_property] = STATE(567),
    [sym__expression] = STATE(567),
    [sym_jsx_element] = STATE(567),
    [sym_function] = STATE(52),
    [sym_import] = STATE(567),
    [sym_call_expression] = STATE(567),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(567),
    [sym_string] = STATE(567),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(567),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(567),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(567),
    [sym_generator_function] = STATE(567),
    [sym_new_expression] = STATE(567),
    [sym_assignment_expression] = STATE(567),
    [sym_augmented_assignment_expression] = STATE(567),
    [sym_binary_expression] = STATE(567),
    [sym_unary_expression] = STATE(567),
    [sym_regex] = STATE(567),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(567),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(567),
    [sym_internal_module] = STATE(567),
    [sym_jsx_self_closing_element] = STATE(567),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1492),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1492),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1494),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1492),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [266] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [sym__automatic_semicolon] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym_BQUOTE] = ACTIONS(1496),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_COMMA] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_GT_GT_GT] = ACTIONS(1496),
    [anon_sym_AMP_AMP] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_BANG_EQ] = ACTIONS(1498),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_PERCENT] = ACTIONS(1496),
    [anon_sym_QMARK] = ACTIONS(1496),
    [anon_sym_RBRACE] = ACTIONS(1496),
    [anon_sym_as] = ACTIONS(1496),
    [anon_sym_PIPE_PIPE] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_EQ_EQ] = ACTIONS(1498),
    [anon_sym_instanceof] = ACTIONS(1496),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_SLASH] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1496),
    [anon_sym_CARET] = ACTIONS(1496),
    [anon_sym_STAR_STAR] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_in] = ACTIONS(1498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1498),
  },
  [267] = {
    [sym_class] = STATE(568),
    [sym_arrow_function] = STATE(568),
    [sym_await_expression] = STATE(568),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(568),
    [sym_meta_property] = STATE(568),
    [sym__expression] = STATE(568),
    [sym_jsx_element] = STATE(568),
    [sym_function] = STATE(52),
    [sym_import] = STATE(568),
    [sym_call_expression] = STATE(568),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(568),
    [sym_string] = STATE(568),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(568),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(568),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(568),
    [sym_generator_function] = STATE(568),
    [sym_new_expression] = STATE(568),
    [sym_assignment_expression] = STATE(568),
    [sym_augmented_assignment_expression] = STATE(568),
    [sym_binary_expression] = STATE(568),
    [sym_unary_expression] = STATE(568),
    [sym_regex] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(568),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(568),
    [sym_internal_module] = STATE(568),
    [sym_jsx_self_closing_element] = STATE(568),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1500),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1500),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1500),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1500),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1502),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1500),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [268] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [269] = {
    [sym_class] = STATE(573),
    [sym_arrow_function] = STATE(573),
    [sym_await_expression] = STATE(573),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(573),
    [sym_sequence_expression] = STATE(572),
    [sym_meta_property] = STATE(573),
    [sym__expression] = STATE(573),
    [sym_jsx_element] = STATE(573),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(573),
    [sym_call_expression] = STATE(573),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_spread_element] = STATE(572),
    [sym_ternary_expression] = STATE(573),
    [sym_string] = STATE(573),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(573),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(573),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(573),
    [sym_generator_function] = STATE(573),
    [sym_new_expression] = STATE(573),
    [sym_assignment_expression] = STATE(573),
    [sym_augmented_assignment_expression] = STATE(573),
    [sym_binary_expression] = STATE(573),
    [sym_unary_expression] = STATE(573),
    [sym_regex] = STATE(573),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(573),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(573),
    [sym_internal_module] = STATE(573),
    [sym_jsx_self_closing_element] = STATE(573),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1510),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1510),
    [sym_number] = ACTIONS(1516),
    [sym_true] = ACTIONS(1510),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1510),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [270] = {
    [sym_jsx_element] = STATE(574),
    [sym_jsx_expression] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(575),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(589),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [271] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1520),
    [sym__automatic_semicolon] = ACTIONS(1520),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_LT_LT] = ACTIONS(1520),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_GT_GT_GT] = ACTIONS(1520),
    [anon_sym_AMP_AMP] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_BANG_EQ] = ACTIONS(1522),
    [anon_sym_LT_EQ] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_GT_EQ] = ACTIONS(1520),
    [anon_sym_GT] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_QMARK] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_as] = ACTIONS(1520),
    [anon_sym_PIPE_PIPE] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_EQ_EQ] = ACTIONS(1522),
    [anon_sym_instanceof] = ACTIONS(1520),
    [anon_sym_LT] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1520),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_STAR_STAR] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_in] = ACTIONS(1522),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1522),
  },
  [272] = {
    [sym_await_expression] = STATE(577),
    [sym_statement_block] = STATE(576),
    [sym_update_expression] = STATE(577),
    [sym_meta_property] = STATE(577),
    [sym__expression] = STATE(577),
    [sym_jsx_element] = STATE(577),
    [sym_function] = STATE(52),
    [sym_import] = STATE(577),
    [sym_call_expression] = STATE(577),
    [sym_ternary_expression] = STATE(577),
    [sym_template_string] = STATE(577),
    [sym_yield_expression] = STATE(577),
    [sym_jsx_fragment] = STATE(577),
    [sym_new_expression] = STATE(577),
    [sym_assignment_expression] = STATE(577),
    [sym_binary_expression] = STATE(577),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(577),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(577),
    [sym_jsx_self_closing_element] = STATE(577),
    [sym_arrow_function] = STATE(577),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(577),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(577),
    [sym_augmented_assignment_expression] = STATE(577),
    [sym_unary_expression] = STATE(577),
    [sym_regex] = STATE(577),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(577),
    [sym_class] = STATE(577),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1526),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [273] = {
    [sym_type_annotation] = STATE(578),
    [anon_sym_EQ_GT] = ACTIONS(1528),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1528),
  },
  [274] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(579),
    [sym_function_type] = STATE(579),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(579),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(579),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(579),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [275] = {
    [anon_sym_EQ_GT] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1530),
  },
  [276] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [anon_sym_debugger] = ACTIONS(1538),
    [anon_sym_symbol] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_void] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1556),
    [sym_super] = ACTIONS(1559),
    [anon_sym_return] = ACTIONS(1562),
    [anon_sym_private] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1541),
    [anon_sym_get] = ACTIONS(1541),
    [anon_sym_RBRACE] = ACTIONS(1565),
    [anon_sym_interface] = ACTIONS(1567),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_enum] = ACTIONS(1572),
    [anon_sym_delete] = ACTIONS(1575),
    [anon_sym_continue] = ACTIONS(1578),
    [anon_sym_DASH_DASH] = ACTIONS(1581),
    [anon_sym_if] = ACTIONS(1584),
    [sym_this] = ACTIONS(1587),
    [anon_sym_yield] = ACTIONS(1590),
    [sym_true] = ACTIONS(1587),
    [anon_sym_throw] = ACTIONS(1593),
    [anon_sym_protected] = ACTIONS(1541),
    [anon_sym_abstract] = ACTIONS(1596),
    [anon_sym_set] = ACTIONS(1541),
    [anon_sym_type] = ACTIONS(1599),
    [anon_sym_import] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1617),
    [sym_false] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1620),
    [anon_sym_case] = ACTIONS(1570),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1541),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_declare] = ACTIONS(1629),
    [anon_sym_typeof] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_switch] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [sym_null] = ACTIONS(1587),
    [anon_sym_any] = ACTIONS(1541),
    [anon_sym_boolean] = ACTIONS(1541),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1541),
    [anon_sym_var] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [anon_sym_try] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1656),
    [sym_number] = ACTIONS(1659),
    [anon_sym_SLASH] = ACTIONS(1662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1665),
    [sym_undefined] = ACTIONS(1587),
    [anon_sym_new] = ACTIONS(1668),
    [ts_builtin_sym_end] = ACTIONS(1565),
    [anon_sym_let] = ACTIONS(1671),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1674),
    [anon_sym_do] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_with] = ACTIONS(1680),
    [anon_sym_await] = ACTIONS(1683),
  },
  [277] = {
    [sym_class] = STATE(580),
    [sym_arrow_function] = STATE(580),
    [sym_await_expression] = STATE(580),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(580),
    [sym_meta_property] = STATE(580),
    [sym__expression] = STATE(580),
    [sym_jsx_element] = STATE(580),
    [sym_function] = STATE(52),
    [sym_import] = STATE(580),
    [sym_call_expression] = STATE(580),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(580),
    [sym_string] = STATE(580),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(580),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(580),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(580),
    [sym_generator_function] = STATE(580),
    [sym_new_expression] = STATE(580),
    [sym_assignment_expression] = STATE(580),
    [sym_augmented_assignment_expression] = STATE(580),
    [sym_binary_expression] = STATE(580),
    [sym_unary_expression] = STATE(580),
    [sym_regex] = STATE(580),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(580),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(580),
    [sym_internal_module] = STATE(580),
    [sym_jsx_self_closing_element] = STATE(580),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1686),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1686),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1686),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1686),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1688),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1686),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [278] = {
    [sym_class_declaration] = STATE(582),
    [sym_generator_function_declaration] = STATE(582),
    [sym__declaration] = STATE(582),
    [sym_enum_declaration] = STATE(582),
    [sym_function_signature] = STATE(582),
    [sym_abstract_class_declaration] = STATE(582),
    [sym_module] = STATE(582),
    [sym_interface_declaration] = STATE(582),
    [sym_function_declaration] = STATE(582),
    [sym_variable_declaration] = STATE(582),
    [sym_lexical_declaration] = STATE(582),
    [sym_ambient_declaration] = STATE(582),
    [sym_import_alias] = STATE(582),
    [sym_type_alias_declaration] = STATE(582),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(582),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(1690),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_async] = ACTIONS(365),
  },
  [279] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(584),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(427),
    [sym_type_parameters] = STATE(585),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [280] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_export] = ACTIONS(1694),
    [anon_sym_class] = ACTIONS(1694),
    [anon_sym_AT] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [sym__automatic_semicolon] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_BQUOTE] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_GT_GT_GT] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1699),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_instanceof] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1701),
  },
  [282] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [283] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1705),
    [anon_sym_BQUOTE] = ACTIONS(1707),
    [anon_sym_debugger] = ACTIONS(1705),
    [anon_sym_symbol] = ACTIONS(1705),
    [anon_sym_AT] = ACTIONS(1707),
    [anon_sym_DASH] = ACTIONS(1705),
    [anon_sym_void] = ACTIONS(1705),
    [anon_sym_break] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [sym_super] = ACTIONS(1705),
    [anon_sym_return] = ACTIONS(1705),
    [anon_sym_private] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_interface] = ACTIONS(1705),
    [anon_sym_default] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_delete] = ACTIONS(1705),
    [anon_sym_continue] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1705),
    [sym_this] = ACTIONS(1705),
    [anon_sym_yield] = ACTIONS(1705),
    [sym_true] = ACTIONS(1705),
    [anon_sym_throw] = ACTIONS(1705),
    [anon_sym_protected] = ACTIONS(1705),
    [anon_sym_abstract] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_import] = ACTIONS(1705),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_PLUS_PLUS] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [anon_sym_else] = ACTIONS(1705),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_for] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [sym_false] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_case] = ACTIONS(1705),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_number] = ACTIONS(1705),
    [anon_sym_class] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_switch] = ACTIONS(1705),
    [anon_sym_LPAREN] = ACTIONS(1707),
    [sym_null] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1705),
    [anon_sym_boolean] = ACTIONS(1705),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1705),
    [anon_sym_var] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_SQUOTE] = ACTIONS(1707),
    [anon_sym_try] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1707),
    [sym_number] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1705),
    [anon_sym_function] = ACTIONS(1705),
    [sym_undefined] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(1705),
    [ts_builtin_sym_end] = ACTIONS(1707),
    [anon_sym_let] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1705),
    [anon_sym_TILDE] = ACTIONS(1707),
    [anon_sym_with] = ACTIONS(1705),
    [anon_sym_await] = ACTIONS(1705),
  },
  [285] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [286] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [sym__automatic_semicolon] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1713),
    [anon_sym_COMMA] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(1711),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_of] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [287] = {
    [anon_sym_RBRACE] = ACTIONS(1715),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(1715),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [289] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1717),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [sym__automatic_semicolon] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(1717),
    [anon_sym_BQUOTE] = ACTIONS(1717),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_LT_LT] = ACTIONS(1717),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_GT_GT_GT] = ACTIONS(1717),
    [anon_sym_AMP_AMP] = ACTIONS(1717),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1717),
    [anon_sym_LPAREN] = ACTIONS(1717),
    [anon_sym_GT_EQ] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1717),
    [anon_sym_QMARK] = ACTIONS(1717),
    [anon_sym_RBRACE] = ACTIONS(1717),
    [anon_sym_as] = ACTIONS(1717),
    [anon_sym_PIPE_PIPE] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_EQ_EQ] = ACTIONS(1719),
    [anon_sym_instanceof] = ACTIONS(1717),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1717),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_STAR_STAR] = ACTIONS(1717),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1717),
    [anon_sym_BANG] = ACTIONS(1719),
  },
  [290] = {
    [aux_sym_template_string_repeat1] = STATE(290),
    [sym_template_substitution] = STATE(290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1721),
    [sym_escape_sequence] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1727),
    [sym__template_chars] = ACTIONS(1724),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [sym__automatic_semicolon] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_GT_GT_GT] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [anon_sym_QMARK] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(1729),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_instanceof] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_in] = ACTIONS(1731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
  },
  [292] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [293] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [294] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1735),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [295] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1737),
    [sym__automatic_semicolon] = ACTIONS(1737),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [anon_sym_PERCENT_EQ] = ACTIONS(1737),
    [anon_sym_AMP_EQ] = ACTIONS(1737),
    [anon_sym_PLUS_EQ] = ACTIONS(1737),
    [anon_sym_PIPE] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1737),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1739),
    [anon_sym_GT_GT_GT] = ACTIONS(1739),
    [anon_sym_EQ] = ACTIONS(1739),
    [anon_sym_BANG_EQ] = ACTIONS(1739),
    [anon_sym_GT_EQ] = ACTIONS(1737),
    [anon_sym_CARET_EQ] = ACTIONS(1737),
    [anon_sym_PIPE_EQ] = ACTIONS(1737),
    [anon_sym_DASH_EQ] = ACTIONS(1737),
    [anon_sym_RBRACE] = ACTIONS(1737),
    [anon_sym_PERCENT] = ACTIONS(1739),
    [anon_sym_LT_LT_EQ] = ACTIONS(1737),
    [anon_sym_as] = ACTIONS(1737),
    [anon_sym_DASH_DASH] = ACTIONS(1737),
    [anon_sym_instanceof] = ACTIONS(1737),
    [anon_sym_GT_GT_EQ] = ACTIONS(1737),
    [anon_sym_DOT] = ACTIONS(1737),
    [anon_sym_STAR_STAR] = ACTIONS(1739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1737),
    [anon_sym_PLUS_PLUS] = ACTIONS(1737),
    [anon_sym_in] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1737),
    [anon_sym_LT_LT] = ACTIONS(1739),
    [anon_sym_AMP_AMP] = ACTIONS(1737),
    [anon_sym_of] = ACTIONS(1737),
    [anon_sym_LT_EQ] = ACTIONS(1737),
    [anon_sym_LPAREN] = ACTIONS(1737),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_STAR_EQ] = ACTIONS(1737),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_QMARK] = ACTIONS(1737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1737),
    [anon_sym_EQ_EQ] = ACTIONS(1739),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_SLASH] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1737),
    [anon_sym_CARET] = ACTIONS(1739),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_GT_GT] = ACTIONS(1739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1737),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1741),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [anon_sym_LBRACK] = ACTIONS(1743),
    [sym_identifier] = ACTIONS(1745),
    [anon_sym_module] = ACTIONS(1745),
    [anon_sym_symbol] = ACTIONS(1745),
    [anon_sym_number] = ACTIONS(1745),
    [anon_sym_class] = ACTIONS(1745),
    [anon_sym_AT] = ACTIONS(1743),
    [anon_sym_declare] = ACTIONS(1745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_void] = ACTIONS(1745),
    [anon_sym_any] = ACTIONS(1745),
    [anon_sym_private] = ACTIONS(1745),
    [anon_sym_boolean] = ACTIONS(1745),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_get] = ACTIONS(1745),
    [anon_sym_public] = ACTIONS(1745),
    [anon_sym_RBRACE] = ACTIONS(1743),
    [anon_sym_SQUOTE] = ACTIONS(1743),
    [sym_this] = ACTIONS(1745),
    [sym_number] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1745),
    [anon_sym_string] = ACTIONS(1745),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_set] = ACTIONS(1745),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_export] = ACTIONS(1745),
    [sym_readonly] = ACTIONS(1745),
    [anon_sym_namespace] = ACTIONS(1745),
    [anon_sym_DQUOTE] = ACTIONS(1743),
  },
  [298] = {
    [sym_identifier] = ACTIONS(1747),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [anon_sym_LBRACK] = ACTIONS(1749),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_module] = ACTIONS(1751),
    [anon_sym_symbol] = ACTIONS(1751),
    [anon_sym_number] = ACTIONS(1751),
    [anon_sym_class] = ACTIONS(1751),
    [anon_sym_AT] = ACTIONS(1749),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1749),
    [anon_sym_LBRACE] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1749),
    [anon_sym_void] = ACTIONS(1751),
    [anon_sym_any] = ACTIONS(1751),
    [anon_sym_private] = ACTIONS(1751),
    [anon_sym_boolean] = ACTIONS(1751),
    [anon_sym_static] = ACTIONS(1751),
    [anon_sym_async] = ACTIONS(1751),
    [anon_sym_get] = ACTIONS(1751),
    [anon_sym_public] = ACTIONS(1751),
    [anon_sym_RBRACE] = ACTIONS(1749),
    [anon_sym_SQUOTE] = ACTIONS(1749),
    [sym_this] = ACTIONS(1751),
    [sym_number] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1751),
    [anon_sym_string] = ACTIONS(1751),
    [anon_sym_abstract] = ACTIONS(1751),
    [anon_sym_set] = ACTIONS(1751),
    [anon_sym_type] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [sym_readonly] = ACTIONS(1751),
    [anon_sym_namespace] = ACTIONS(1751),
    [anon_sym_DQUOTE] = ACTIONS(1749),
  },
  [300] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(590),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(589),
    [sym_type_parameters] = STATE(591),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [301] = {
    [aux_sym_object_repeat1] = STATE(440),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [aux_sym_object_repeat1] = STATE(440),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
  },
  [303] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [304] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(1070),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [305] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [306] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_of] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
  },
  [307] = {
    [anon_sym_EQ] = ACTIONS(1757),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [anon_sym_EQ] = ACTIONS(1759),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(496),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(1763),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(597),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(528),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(584),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(427),
    [sym_type_parameters] = STATE(585),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(1767),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [313] = {
    [sym_identifier] = ACTIONS(1769),
    [anon_sym_BQUOTE] = ACTIONS(1771),
    [anon_sym_debugger] = ACTIONS(1769),
    [anon_sym_symbol] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_void] = ACTIONS(1769),
    [anon_sym_break] = ACTIONS(1769),
    [anon_sym_const] = ACTIONS(1769),
    [sym_super] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1769),
    [anon_sym_private] = ACTIONS(1769),
    [anon_sym_static] = ACTIONS(1769),
    [anon_sym_get] = ACTIONS(1769),
    [anon_sym_RBRACE] = ACTIONS(1771),
    [anon_sym_interface] = ACTIONS(1769),
    [anon_sym_default] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1769),
    [anon_sym_delete] = ACTIONS(1769),
    [anon_sym_continue] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1771),
    [anon_sym_if] = ACTIONS(1769),
    [sym_this] = ACTIONS(1769),
    [anon_sym_yield] = ACTIONS(1769),
    [sym_true] = ACTIONS(1769),
    [anon_sym_throw] = ACTIONS(1769),
    [anon_sym_protected] = ACTIONS(1769),
    [anon_sym_abstract] = ACTIONS(1769),
    [anon_sym_set] = ACTIONS(1769),
    [anon_sym_type] = ACTIONS(1769),
    [anon_sym_import] = ACTIONS(1769),
    [anon_sym_namespace] = ACTIONS(1769),
    [anon_sym_PLUS_PLUS] = ACTIONS(1771),
    [anon_sym_DQUOTE] = ACTIONS(1771),
    [anon_sym_else] = ACTIONS(1769),
    [anon_sym_BANG] = ACTIONS(1771),
    [anon_sym_for] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [sym_false] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1771),
    [anon_sym_case] = ACTIONS(1769),
    [anon_sym_module] = ACTIONS(1769),
    [anon_sym_number] = ACTIONS(1769),
    [anon_sym_class] = ACTIONS(1769),
    [anon_sym_declare] = ACTIONS(1769),
    [anon_sym_typeof] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1771),
    [anon_sym_switch] = ACTIONS(1769),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [sym_null] = ACTIONS(1769),
    [anon_sym_any] = ACTIONS(1769),
    [anon_sym_boolean] = ACTIONS(1769),
    [anon_sym_async] = ACTIONS(1769),
    [anon_sym_public] = ACTIONS(1769),
    [anon_sym_var] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1771),
    [anon_sym_try] = ACTIONS(1769),
    [anon_sym_LT] = ACTIONS(1771),
    [sym_number] = ACTIONS(1771),
    [anon_sym_SLASH] = ACTIONS(1769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1769),
    [anon_sym_function] = ACTIONS(1769),
    [sym_undefined] = ACTIONS(1769),
    [anon_sym_new] = ACTIONS(1769),
    [ts_builtin_sym_end] = ACTIONS(1771),
    [anon_sym_let] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_export] = ACTIONS(1769),
    [anon_sym_do] = ACTIONS(1769),
    [anon_sym_TILDE] = ACTIONS(1771),
    [anon_sym_with] = ACTIONS(1769),
    [anon_sym_await] = ACTIONS(1769),
  },
  [314] = {
    [sym_class] = STATE(600),
    [sym_arrow_function] = STATE(600),
    [sym_await_expression] = STATE(600),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(600),
    [sym_meta_property] = STATE(600),
    [sym__expression] = STATE(600),
    [sym_jsx_element] = STATE(600),
    [sym_function] = STATE(52),
    [sym_import] = STATE(600),
    [sym_call_expression] = STATE(600),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(600),
    [sym_string] = STATE(600),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(600),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(600),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(600),
    [sym_generator_function] = STATE(600),
    [sym_new_expression] = STATE(600),
    [sym_assignment_expression] = STATE(600),
    [sym_augmented_assignment_expression] = STATE(600),
    [sym_binary_expression] = STATE(600),
    [sym_unary_expression] = STATE(600),
    [sym_regex] = STATE(600),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(600),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(600),
    [sym_internal_module] = STATE(600),
    [sym_jsx_self_closing_element] = STATE(600),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(1773),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1773),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_true] = ACTIONS(1773),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1773),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [315] = {
    [sym__automatic_semicolon] = ACTIONS(1777),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_COMMA] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym__initializer] = STATE(601),
    [sym__automatic_semicolon] = ACTIONS(1779),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(1779),
    [anon_sym_COMMA] = ACTIONS(1779),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_enum_body] = STATE(602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(786),
  },
  [318] = {
    [sym__automatic_semicolon] = ACTIONS(1781),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym__initializer] = STATE(603),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(604),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [321] = {
    [sym_identifier] = ACTIONS(1785),
    [anon_sym_BQUOTE] = ACTIONS(1787),
    [anon_sym_debugger] = ACTIONS(1785),
    [anon_sym_symbol] = ACTIONS(1785),
    [anon_sym_AT] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1785),
    [anon_sym_break] = ACTIONS(1785),
    [anon_sym_const] = ACTIONS(1785),
    [sym_super] = ACTIONS(1785),
    [anon_sym_return] = ACTIONS(1785),
    [anon_sym_private] = ACTIONS(1785),
    [anon_sym_static] = ACTIONS(1785),
    [anon_sym_get] = ACTIONS(1785),
    [anon_sym_RBRACE] = ACTIONS(1787),
    [anon_sym_interface] = ACTIONS(1785),
    [anon_sym_default] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1785),
    [anon_sym_delete] = ACTIONS(1785),
    [anon_sym_continue] = ACTIONS(1785),
    [anon_sym_DASH_DASH] = ACTIONS(1787),
    [anon_sym_if] = ACTIONS(1785),
    [sym_this] = ACTIONS(1785),
    [anon_sym_yield] = ACTIONS(1785),
    [sym_true] = ACTIONS(1785),
    [anon_sym_throw] = ACTIONS(1785),
    [anon_sym_protected] = ACTIONS(1785),
    [anon_sym_abstract] = ACTIONS(1785),
    [anon_sym_set] = ACTIONS(1785),
    [anon_sym_type] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1785),
    [anon_sym_namespace] = ACTIONS(1785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(1787),
    [anon_sym_else] = ACTIONS(1785),
    [anon_sym_BANG] = ACTIONS(1787),
    [anon_sym_for] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [sym_false] = ACTIONS(1785),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_case] = ACTIONS(1785),
    [anon_sym_module] = ACTIONS(1785),
    [anon_sym_number] = ACTIONS(1785),
    [anon_sym_class] = ACTIONS(1785),
    [anon_sym_declare] = ACTIONS(1785),
    [anon_sym_typeof] = ACTIONS(1785),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_switch] = ACTIONS(1785),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [sym_null] = ACTIONS(1785),
    [anon_sym_any] = ACTIONS(1785),
    [anon_sym_boolean] = ACTIONS(1785),
    [anon_sym_async] = ACTIONS(1785),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_var] = ACTIONS(1785),
    [anon_sym_while] = ACTIONS(1785),
    [anon_sym_SQUOTE] = ACTIONS(1787),
    [anon_sym_try] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1787),
    [sym_number] = ACTIONS(1787),
    [anon_sym_SLASH] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1785),
    [anon_sym_function] = ACTIONS(1785),
    [sym_undefined] = ACTIONS(1785),
    [anon_sym_new] = ACTIONS(1785),
    [ts_builtin_sym_end] = ACTIONS(1787),
    [anon_sym_let] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1785),
    [anon_sym_export] = ACTIONS(1785),
    [anon_sym_do] = ACTIONS(1785),
    [anon_sym_TILDE] = ACTIONS(1787),
    [anon_sym_with] = ACTIONS(1785),
    [anon_sym_await] = ACTIONS(1785),
  },
  [322] = {
    [aux_sym_variable_declaration_repeat1] = STATE(606),
    [sym__automatic_semicolon] = ACTIONS(1789),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym__automatic_semicolon] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_COMMA] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym__initializer] = STATE(607),
    [sym__automatic_semicolon] = ACTIONS(1793),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_COMMA] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [anon_sym_RBRACK] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [327] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_EQ_GT] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_RPAREN] = ACTIONS(1797),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1797),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_EQ] = ACTIONS(1801),
    [anon_sym_DOT] = ACTIONS(1803),
    [anon_sym_RBRACK] = ACTIONS(1797),
    [anon_sym_GT] = ACTIONS(1797),
  },
  [328] = {
    [anon_sym_BQUOTE] = ACTIONS(1805),
    [anon_sym_symbol] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1805),
    [anon_sym_break] = ACTIONS(1807),
    [anon_sym_return] = ACTIONS(1807),
    [anon_sym_static] = ACTIONS(1807),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_interface] = ACTIONS(1807),
    [anon_sym_delete] = ACTIONS(1807),
    [anon_sym_if] = ACTIONS(1807),
    [anon_sym_yield] = ACTIONS(1807),
    [sym_true] = ACTIONS(1807),
    [anon_sym_protected] = ACTIONS(1807),
    [anon_sym_set] = ACTIONS(1807),
    [anon_sym_import] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(1805),
    [anon_sym_for] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_number] = ACTIONS(1807),
    [anon_sym_typeof] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_RBRACK] = ACTIONS(1805),
    [sym_null] = ACTIONS(1807),
    [anon_sym_any] = ACTIONS(1807),
    [anon_sym_async] = ACTIONS(1807),
    [anon_sym_public] = ACTIONS(1807),
    [anon_sym_var] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1807),
    [anon_sym_SQUOTE] = ACTIONS(1805),
    [anon_sym_RPAREN] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1807),
    [anon_sym_with] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_debugger] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(1805),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1807),
    [anon_sym_void] = ACTIONS(1807),
    [anon_sym_const] = ACTIONS(1807),
    [sym_super] = ACTIONS(1807),
    [anon_sym_private] = ACTIONS(1807),
    [anon_sym_get] = ACTIONS(1807),
    [anon_sym_default] = ACTIONS(1807),
    [anon_sym_enum] = ACTIONS(1807),
    [anon_sym_continue] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [sym_this] = ACTIONS(1807),
    [anon_sym_throw] = ACTIONS(1807),
    [anon_sym_abstract] = ACTIONS(1807),
    [anon_sym_type] = ACTIONS(1807),
    [anon_sym_namespace] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_else] = ACTIONS(1807),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [sym_false] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1807),
    [anon_sym_module] = ACTIONS(1807),
    [anon_sym_class] = ACTIONS(1807),
    [anon_sym_declare] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [anon_sym_GT] = ACTIONS(1805),
    [anon_sym_boolean] = ACTIONS(1807),
    [anon_sym_EQ_GT] = ACTIONS(1805),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_try] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1805),
    [sym_number] = ACTIONS(1805),
    [ts_builtin_sym_end] = ACTIONS(1805),
    [anon_sym_function] = ACTIONS(1807),
    [sym_undefined] = ACTIONS(1807),
    [anon_sym_let] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_do] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1805),
    [anon_sym_await] = ACTIONS(1807),
  },
  [329] = {
    [sym_array_type] = STATE(613),
    [sym_generic_type] = STATE(613),
    [sym_type_predicate] = STATE(613),
    [sym_literal_type] = STATE(613),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(613),
    [sym__primary_type] = STATE(613),
    [sym_lookup_type] = STATE(613),
    [sym_parenthesized_type] = STATE(613),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(613),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(613),
    [sym_type_query] = STATE(613),
    [sym_index_type_query] = STATE(613),
    [sym_existential_type] = STATE(613),
    [sym_flow_maybe_type] = STATE(613),
    [sym_string] = STATE(328),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(1811),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [330] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(623),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(623),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(623),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(623),
    [sym_property_signature] = STATE(623),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(623),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(1823),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [331] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(627),
    [sym_function_type] = STATE(627),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(627),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(627),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(627),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [332] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(628),
    [sym_function_type] = STATE(628),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(628),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(628),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(628),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [333] = {
    [anon_sym_BQUOTE] = ACTIONS(1833),
    [anon_sym_symbol] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1835),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_static] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1833),
    [anon_sym_interface] = ACTIONS(1835),
    [anon_sym_delete] = ACTIONS(1835),
    [anon_sym_if] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1835),
    [sym_true] = ACTIONS(1835),
    [anon_sym_protected] = ACTIONS(1835),
    [anon_sym_set] = ACTIONS(1835),
    [anon_sym_import] = ACTIONS(1835),
    [anon_sym_DQUOTE] = ACTIONS(1833),
    [anon_sym_for] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_number] = ACTIONS(1835),
    [anon_sym_typeof] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1833),
    [anon_sym_switch] = ACTIONS(1835),
    [anon_sym_RBRACK] = ACTIONS(1833),
    [sym_null] = ACTIONS(1835),
    [anon_sym_any] = ACTIONS(1835),
    [anon_sym_async] = ACTIONS(1835),
    [anon_sym_public] = ACTIONS(1835),
    [anon_sym_var] = ACTIONS(1835),
    [anon_sym_while] = ACTIONS(1835),
    [anon_sym_SQUOTE] = ACTIONS(1833),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_SLASH] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1835),
    [anon_sym_new] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1835),
    [anon_sym_with] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [anon_sym_debugger] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(1833),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_void] = ACTIONS(1835),
    [anon_sym_const] = ACTIONS(1835),
    [sym_super] = ACTIONS(1835),
    [anon_sym_private] = ACTIONS(1835),
    [anon_sym_get] = ACTIONS(1835),
    [anon_sym_default] = ACTIONS(1835),
    [anon_sym_enum] = ACTIONS(1835),
    [anon_sym_continue] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1833),
    [sym_this] = ACTIONS(1835),
    [anon_sym_throw] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(1835),
    [anon_sym_type] = ACTIONS(1835),
    [anon_sym_namespace] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1833),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1833),
    [sym_false] = ACTIONS(1835),
    [anon_sym_case] = ACTIONS(1835),
    [anon_sym_module] = ACTIONS(1835),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_declare] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1833),
    [anon_sym_GT] = ACTIONS(1833),
    [anon_sym_boolean] = ACTIONS(1835),
    [anon_sym_EQ_GT] = ACTIONS(1833),
    [anon_sym_AMP] = ACTIONS(1833),
    [anon_sym_try] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1833),
    [sym_number] = ACTIONS(1833),
    [ts_builtin_sym_end] = ACTIONS(1833),
    [anon_sym_function] = ACTIONS(1835),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_let] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1835),
    [anon_sym_do] = ACTIONS(1835),
    [anon_sym_TILDE] = ACTIONS(1833),
    [anon_sym_await] = ACTIONS(1835),
  },
  [334] = {
    [sym_nested_identifier] = STATE(629),
    [sym_identifier] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_number] = ACTIONS(1839),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [anon_sym_symbol] = ACTIONS(1843),
    [anon_sym_PIPE] = ACTIONS(1841),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_delete] = ACTIONS(1843),
    [anon_sym_if] = ACTIONS(1843),
    [anon_sym_yield] = ACTIONS(1843),
    [sym_true] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_set] = ACTIONS(1843),
    [anon_sym_import] = ACTIONS(1843),
    [anon_sym_DQUOTE] = ACTIONS(1841),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_number] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(1843),
    [anon_sym_RBRACK] = ACTIONS(1841),
    [sym_null] = ACTIONS(1843),
    [anon_sym_any] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_var] = ACTIONS(1843),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [anon_sym_RPAREN] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_new] = ACTIONS(1843),
    [anon_sym_export] = ACTIONS(1843),
    [anon_sym_with] = ACTIONS(1843),
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_debugger] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(1841),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_EQ] = ACTIONS(1843),
    [anon_sym_void] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_get] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_else] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [sym_false] = ACTIONS(1843),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_module] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_declare] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_GT] = ACTIONS(1841),
    [anon_sym_boolean] = ACTIONS(1843),
    [anon_sym_EQ_GT] = ACTIONS(1841),
    [anon_sym_AMP] = ACTIONS(1841),
    [anon_sym_try] = ACTIONS(1843),
    [anon_sym_LT] = ACTIONS(1841),
    [sym_number] = ACTIONS(1841),
    [ts_builtin_sym_end] = ACTIONS(1841),
    [anon_sym_function] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_do] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_await] = ACTIONS(1843),
  },
  [337] = {
    [sym_nested_type_identifier] = STATE(632),
    [sym_nested_identifier] = STATE(343),
    [sym_identifier] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_formal_parameters] = STATE(633),
    [sym_type_parameters] = STATE(634),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(638),
    [sym_function_type] = STATE(638),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(638),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_object] = STATE(489),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(638),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(638),
    [aux_sym_export_statement_repeat1] = STATE(493),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(490),
    [sym_identifier] = ACTIONS(1847),
    [anon_sym_symbol] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_this] = ACTIONS(1851),
    [sym_true] = ACTIONS(736),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(736),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_export] = ACTIONS(1207),
  },
  [340] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(639),
    [sym_function_type] = STATE(639),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(639),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(639),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(639),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [341] = {
    [anon_sym_EQ_GT] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [anon_sym_BQUOTE] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1861),
    [anon_sym_return] = ACTIONS(1861),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_interface] = ACTIONS(1861),
    [anon_sym_delete] = ACTIONS(1861),
    [anon_sym_if] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(1861),
    [sym_true] = ACTIONS(1861),
    [anon_sym_protected] = ACTIONS(1861),
    [anon_sym_set] = ACTIONS(1861),
    [anon_sym_import] = ACTIONS(1861),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [anon_sym_for] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1861),
    [anon_sym_typeof] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_switch] = ACTIONS(1861),
    [anon_sym_RBRACK] = ACTIONS(1859),
    [sym_null] = ACTIONS(1861),
    [anon_sym_any] = ACTIONS(1861),
    [anon_sym_async] = ACTIONS(1861),
    [anon_sym_public] = ACTIONS(1861),
    [anon_sym_var] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1861),
    [anon_sym_SQUOTE] = ACTIONS(1859),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1861),
    [anon_sym_new] = ACTIONS(1861),
    [anon_sym_export] = ACTIONS(1861),
    [anon_sym_with] = ACTIONS(1861),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_debugger] = ACTIONS(1861),
    [anon_sym_AT] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_EQ] = ACTIONS(1861),
    [anon_sym_void] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [sym_super] = ACTIONS(1861),
    [anon_sym_private] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(1861),
    [anon_sym_default] = ACTIONS(1861),
    [anon_sym_enum] = ACTIONS(1861),
    [anon_sym_continue] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [sym_this] = ACTIONS(1861),
    [anon_sym_throw] = ACTIONS(1861),
    [anon_sym_abstract] = ACTIONS(1861),
    [anon_sym_type] = ACTIONS(1861),
    [anon_sym_namespace] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_else] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [sym_false] = ACTIONS(1861),
    [anon_sym_case] = ACTIONS(1861),
    [anon_sym_module] = ACTIONS(1861),
    [anon_sym_class] = ACTIONS(1861),
    [anon_sym_declare] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1861),
    [anon_sym_EQ_GT] = ACTIONS(1859),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_try] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1859),
    [sym_number] = ACTIONS(1859),
    [ts_builtin_sym_end] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(1861),
    [sym_undefined] = ACTIONS(1861),
    [anon_sym_let] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_do] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1859),
    [anon_sym_await] = ACTIONS(1861),
  },
  [343] = {
    [anon_sym_DOT] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_type_arguments] = STATE(642),
    [anon_sym_EQ_GT] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1865),
  },
  [345] = {
    [aux_sym_implements_clause_repeat1] = STATE(647),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(1871),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_formal_parameters] = STATE(648),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [sym__automatic_semicolon] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1877),
    [anon_sym_BQUOTE] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1879),
    [anon_sym_GT_GT_GT] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1879),
    [anon_sym_BANG_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_GT_EQ] = ACTIONS(1877),
    [anon_sym_GT] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_PERCENT] = ACTIONS(1877),
    [anon_sym_QMARK] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_as] = ACTIONS(1877),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_DASH_DASH] = ACTIONS(1877),
    [anon_sym_EQ_EQ] = ACTIONS(1879),
    [anon_sym_instanceof] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_CARET] = ACTIONS(1877),
    [anon_sym_STAR_STAR] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1877),
    [anon_sym_in] = ACTIONS(1879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
  },
  [348] = {
    [aux_sym_array_repeat1] = STATE(650),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(1881),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [349] = {
    [aux_sym_array_repeat1] = STATE(650),
    [anon_sym_RPAREN] = ACTIONS(1881),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(1881),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(1883),
    [sym__automatic_semicolon] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_GT_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_QMARK] = ACTIONS(1883),
    [anon_sym_RBRACE] = ACTIONS(1883),
    [anon_sym_as] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_instanceof] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_STAR_STAR] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1883),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1883),
    [anon_sym_BANG] = ACTIONS(1885),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1887),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_debugger] = ACTIONS(1887),
    [anon_sym_symbol] = ACTIONS(1887),
    [anon_sym_AT] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_void] = ACTIONS(1887),
    [anon_sym_break] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1887),
    [sym_super] = ACTIONS(1887),
    [anon_sym_return] = ACTIONS(1887),
    [anon_sym_private] = ACTIONS(1887),
    [anon_sym_static] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(1887),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_interface] = ACTIONS(1887),
    [anon_sym_default] = ACTIONS(1887),
    [anon_sym_enum] = ACTIONS(1887),
    [anon_sym_delete] = ACTIONS(1887),
    [anon_sym_continue] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1887),
    [sym_this] = ACTIONS(1887),
    [anon_sym_yield] = ACTIONS(1887),
    [sym_true] = ACTIONS(1887),
    [anon_sym_throw] = ACTIONS(1887),
    [anon_sym_protected] = ACTIONS(1887),
    [anon_sym_abstract] = ACTIONS(1887),
    [anon_sym_set] = ACTIONS(1887),
    [anon_sym_type] = ACTIONS(1887),
    [anon_sym_import] = ACTIONS(1887),
    [anon_sym_namespace] = ACTIONS(1887),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [anon_sym_else] = ACTIONS(1887),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_for] = ACTIONS(1887),
    [anon_sym_LBRACK] = ACTIONS(1889),
    [sym_false] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_case] = ACTIONS(1887),
    [anon_sym_module] = ACTIONS(1887),
    [anon_sym_number] = ACTIONS(1887),
    [anon_sym_class] = ACTIONS(1887),
    [anon_sym_declare] = ACTIONS(1887),
    [anon_sym_typeof] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_switch] = ACTIONS(1887),
    [anon_sym_LPAREN] = ACTIONS(1889),
    [sym_null] = ACTIONS(1887),
    [anon_sym_any] = ACTIONS(1887),
    [anon_sym_boolean] = ACTIONS(1887),
    [anon_sym_async] = ACTIONS(1887),
    [anon_sym_public] = ACTIONS(1887),
    [anon_sym_var] = ACTIONS(1887),
    [anon_sym_while] = ACTIONS(1887),
    [anon_sym_SQUOTE] = ACTIONS(1889),
    [anon_sym_try] = ACTIONS(1887),
    [anon_sym_LT] = ACTIONS(1889),
    [sym_number] = ACTIONS(1889),
    [anon_sym_SLASH] = ACTIONS(1887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1887),
    [anon_sym_function] = ACTIONS(1887),
    [sym_undefined] = ACTIONS(1887),
    [anon_sym_new] = ACTIONS(1887),
    [ts_builtin_sym_end] = ACTIONS(1889),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_export] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_with] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1887),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_BQUOTE] = ACTIONS(1893),
    [anon_sym_debugger] = ACTIONS(1891),
    [anon_sym_symbol] = ACTIONS(1891),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1891),
    [anon_sym_break] = ACTIONS(1891),
    [anon_sym_const] = ACTIONS(1891),
    [sym_super] = ACTIONS(1891),
    [anon_sym_return] = ACTIONS(1891),
    [anon_sym_private] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1891),
    [anon_sym_get] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1893),
    [anon_sym_interface] = ACTIONS(1891),
    [anon_sym_default] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_delete] = ACTIONS(1891),
    [anon_sym_continue] = ACTIONS(1891),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_if] = ACTIONS(1891),
    [sym_this] = ACTIONS(1891),
    [anon_sym_yield] = ACTIONS(1891),
    [sym_true] = ACTIONS(1891),
    [anon_sym_throw] = ACTIONS(1891),
    [anon_sym_protected] = ACTIONS(1891),
    [anon_sym_abstract] = ACTIONS(1891),
    [anon_sym_set] = ACTIONS(1891),
    [anon_sym_type] = ACTIONS(1891),
    [anon_sym_import] = ACTIONS(1891),
    [anon_sym_namespace] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DQUOTE] = ACTIONS(1893),
    [anon_sym_else] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_for] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(1893),
    [sym_false] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_case] = ACTIONS(1891),
    [anon_sym_module] = ACTIONS(1891),
    [anon_sym_number] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1891),
    [anon_sym_declare] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_switch] = ACTIONS(1891),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [sym_null] = ACTIONS(1891),
    [anon_sym_any] = ACTIONS(1891),
    [anon_sym_boolean] = ACTIONS(1891),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1891),
    [anon_sym_var] = ACTIONS(1891),
    [anon_sym_while] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1893),
    [anon_sym_try] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [sym_number] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1891),
    [anon_sym_function] = ACTIONS(1891),
    [sym_undefined] = ACTIONS(1891),
    [anon_sym_new] = ACTIONS(1891),
    [ts_builtin_sym_end] = ACTIONS(1893),
    [anon_sym_let] = ACTIONS(1891),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_export] = ACTIONS(1891),
    [anon_sym_do] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_with] = ACTIONS(1891),
    [anon_sym_await] = ACTIONS(1891),
  },
  [354] = {
    [sym_object_type] = STATE(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(750),
  },
  [355] = {
    [sym_object_type] = STATE(652),
    [sym_extends_clause] = STATE(653),
    [anon_sym_extends] = ACTIONS(784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(750),
  },
  [356] = {
    [sym_computed_property_name] = STATE(655),
    [sym_string] = STATE(655),
    [sym__property_name] = STATE(655),
    [sym_enum_assignment] = STATE(656),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_number] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1899),
    [anon_sym_BQUOTE] = ACTIONS(1901),
    [anon_sym_debugger] = ACTIONS(1899),
    [anon_sym_symbol] = ACTIONS(1899),
    [anon_sym_AT] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1899),
    [anon_sym_void] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1899),
    [anon_sym_const] = ACTIONS(1899),
    [sym_super] = ACTIONS(1899),
    [anon_sym_return] = ACTIONS(1899),
    [anon_sym_private] = ACTIONS(1899),
    [anon_sym_static] = ACTIONS(1899),
    [anon_sym_get] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_interface] = ACTIONS(1899),
    [anon_sym_default] = ACTIONS(1899),
    [anon_sym_enum] = ACTIONS(1899),
    [anon_sym_delete] = ACTIONS(1899),
    [anon_sym_continue] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1899),
    [sym_this] = ACTIONS(1899),
    [anon_sym_yield] = ACTIONS(1899),
    [sym_true] = ACTIONS(1899),
    [anon_sym_throw] = ACTIONS(1899),
    [anon_sym_protected] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1899),
    [anon_sym_set] = ACTIONS(1899),
    [anon_sym_type] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1899),
    [anon_sym_namespace] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_DQUOTE] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [sym_false] = ACTIONS(1899),
    [anon_sym_SEMI] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1899),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_number] = ACTIONS(1899),
    [anon_sym_class] = ACTIONS(1899),
    [anon_sym_declare] = ACTIONS(1899),
    [anon_sym_typeof] = ACTIONS(1899),
    [anon_sym_LBRACE] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1899),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [sym_null] = ACTIONS(1899),
    [anon_sym_any] = ACTIONS(1899),
    [anon_sym_boolean] = ACTIONS(1899),
    [anon_sym_async] = ACTIONS(1899),
    [anon_sym_public] = ACTIONS(1899),
    [anon_sym_var] = ACTIONS(1899),
    [anon_sym_while] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1899),
    [anon_sym_LT] = ACTIONS(1901),
    [sym_number] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1899),
    [anon_sym_function] = ACTIONS(1899),
    [sym_undefined] = ACTIONS(1899),
    [anon_sym_new] = ACTIONS(1899),
    [ts_builtin_sym_end] = ACTIONS(1901),
    [anon_sym_let] = ACTIONS(1899),
    [anon_sym_PLUS] = ACTIONS(1899),
    [anon_sym_export] = ACTIONS(1899),
    [anon_sym_do] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1901),
    [anon_sym_with] = ACTIONS(1899),
    [anon_sym_await] = ACTIONS(1899),
  },
  [358] = {
    [sym_identifier] = ACTIONS(1903),
    [anon_sym_BQUOTE] = ACTIONS(1905),
    [anon_sym_debugger] = ACTIONS(1903),
    [anon_sym_symbol] = ACTIONS(1903),
    [anon_sym_AT] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_void] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [sym_super] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_private] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(1903),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_interface] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_if] = ACTIONS(1903),
    [sym_this] = ACTIONS(1903),
    [anon_sym_yield] = ACTIONS(1903),
    [sym_true] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_protected] = ACTIONS(1903),
    [anon_sym_abstract] = ACTIONS(1903),
    [anon_sym_set] = ACTIONS(1903),
    [anon_sym_type] = ACTIONS(1903),
    [anon_sym_import] = ACTIONS(1903),
    [anon_sym_namespace] = ACTIONS(1903),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1905),
    [sym_false] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym_case] = ACTIONS(1903),
    [anon_sym_module] = ACTIONS(1903),
    [anon_sym_number] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_declare] = ACTIONS(1903),
    [anon_sym_typeof] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [sym_null] = ACTIONS(1903),
    [anon_sym_any] = ACTIONS(1903),
    [anon_sym_boolean] = ACTIONS(1903),
    [anon_sym_async] = ACTIONS(1903),
    [anon_sym_public] = ACTIONS(1903),
    [anon_sym_var] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_LT] = ACTIONS(1905),
    [sym_number] = ACTIONS(1905),
    [anon_sym_SLASH] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1903),
    [anon_sym_function] = ACTIONS(1903),
    [sym_undefined] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [ts_builtin_sym_end] = ACTIONS(1905),
    [anon_sym_let] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_export] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_with] = ACTIONS(1903),
    [anon_sym_await] = ACTIONS(1903),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1907),
    [anon_sym_BQUOTE] = ACTIONS(1909),
    [anon_sym_debugger] = ACTIONS(1907),
    [anon_sym_symbol] = ACTIONS(1907),
    [anon_sym_AT] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1907),
    [anon_sym_break] = ACTIONS(1907),
    [anon_sym_const] = ACTIONS(1907),
    [sym_super] = ACTIONS(1907),
    [anon_sym_return] = ACTIONS(1907),
    [anon_sym_private] = ACTIONS(1907),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_get] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1909),
    [anon_sym_interface] = ACTIONS(1907),
    [anon_sym_default] = ACTIONS(1907),
    [anon_sym_enum] = ACTIONS(1907),
    [anon_sym_delete] = ACTIONS(1907),
    [anon_sym_continue] = ACTIONS(1907),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1907),
    [sym_this] = ACTIONS(1907),
    [anon_sym_yield] = ACTIONS(1907),
    [sym_true] = ACTIONS(1907),
    [anon_sym_throw] = ACTIONS(1907),
    [anon_sym_protected] = ACTIONS(1907),
    [anon_sym_abstract] = ACTIONS(1907),
    [anon_sym_set] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_import] = ACTIONS(1907),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DQUOTE] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [sym_false] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1907),
    [anon_sym_module] = ACTIONS(1907),
    [anon_sym_number] = ACTIONS(1907),
    [anon_sym_class] = ACTIONS(1907),
    [anon_sym_declare] = ACTIONS(1907),
    [anon_sym_typeof] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1907),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [sym_null] = ACTIONS(1907),
    [anon_sym_any] = ACTIONS(1907),
    [anon_sym_boolean] = ACTIONS(1907),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_public] = ACTIONS(1907),
    [anon_sym_var] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1909),
    [sym_number] = ACTIONS(1909),
    [anon_sym_SLASH] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1907),
    [anon_sym_function] = ACTIONS(1907),
    [sym_undefined] = ACTIONS(1907),
    [anon_sym_new] = ACTIONS(1907),
    [ts_builtin_sym_end] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_export] = ACTIONS(1907),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_with] = ACTIONS(1907),
    [anon_sym_await] = ACTIONS(1907),
  },
  [360] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1913),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(1913),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(1913),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1915),
    [anon_sym_BQUOTE] = ACTIONS(1917),
    [anon_sym_debugger] = ACTIONS(1915),
    [anon_sym_symbol] = ACTIONS(1915),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_void] = ACTIONS(1915),
    [anon_sym_break] = ACTIONS(1915),
    [anon_sym_const] = ACTIONS(1915),
    [sym_super] = ACTIONS(1915),
    [anon_sym_return] = ACTIONS(1915),
    [anon_sym_private] = ACTIONS(1915),
    [anon_sym_static] = ACTIONS(1915),
    [anon_sym_get] = ACTIONS(1915),
    [anon_sym_RBRACE] = ACTIONS(1917),
    [anon_sym_interface] = ACTIONS(1915),
    [anon_sym_default] = ACTIONS(1915),
    [anon_sym_enum] = ACTIONS(1915),
    [anon_sym_delete] = ACTIONS(1915),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_if] = ACTIONS(1915),
    [sym_this] = ACTIONS(1915),
    [anon_sym_yield] = ACTIONS(1915),
    [sym_true] = ACTIONS(1915),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_protected] = ACTIONS(1915),
    [anon_sym_abstract] = ACTIONS(1915),
    [anon_sym_set] = ACTIONS(1915),
    [anon_sym_type] = ACTIONS(1915),
    [anon_sym_import] = ACTIONS(1915),
    [anon_sym_namespace] = ACTIONS(1915),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [anon_sym_else] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_for] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [sym_false] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym_case] = ACTIONS(1915),
    [anon_sym_module] = ACTIONS(1915),
    [anon_sym_number] = ACTIONS(1915),
    [anon_sym_class] = ACTIONS(1915),
    [anon_sym_declare] = ACTIONS(1915),
    [anon_sym_typeof] = ACTIONS(1915),
    [anon_sym_LBRACE] = ACTIONS(1917),
    [anon_sym_switch] = ACTIONS(1915),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [sym_null] = ACTIONS(1915),
    [anon_sym_any] = ACTIONS(1915),
    [anon_sym_boolean] = ACTIONS(1915),
    [anon_sym_async] = ACTIONS(1915),
    [anon_sym_public] = ACTIONS(1915),
    [anon_sym_var] = ACTIONS(1915),
    [anon_sym_while] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1917),
    [anon_sym_try] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1917),
    [sym_number] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1915),
    [anon_sym_function] = ACTIONS(1915),
    [sym_undefined] = ACTIONS(1915),
    [anon_sym_new] = ACTIONS(1915),
    [ts_builtin_sym_end] = ACTIONS(1917),
    [anon_sym_let] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_export] = ACTIONS(1915),
    [anon_sym_do] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_with] = ACTIONS(1915),
    [anon_sym_await] = ACTIONS(1915),
  },
  [362] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(659),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(658),
    [sym_type_parameters] = STATE(660),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1919),
  },
  [363] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(661),
    [sym_function_type] = STATE(661),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(661),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(661),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(661),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [364] = {
    [anon_sym_EQ] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_named_imports] = STATE(663),
    [sym_namespace_import] = STATE(663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(241),
  },
  [366] = {
    [sym_nested_identifier] = STATE(665),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_require] = ACTIONS(1959),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [anon_sym_EQ] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(818),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym__automatic_semicolon] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1963),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym__from_clause] = STATE(668),
    [anon_sym_from] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [anon_sym_from] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_identifier] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [anon_sym_RBRACE] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [aux_sym_named_imports_repeat1] = STATE(675),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_identifier] = ACTIONS(1981),
    [anon_sym_BQUOTE] = ACTIONS(1983),
    [anon_sym_debugger] = ACTIONS(1981),
    [anon_sym_symbol] = ACTIONS(1981),
    [anon_sym_AT] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_void] = ACTIONS(1981),
    [anon_sym_break] = ACTIONS(1981),
    [anon_sym_const] = ACTIONS(1981),
    [sym_super] = ACTIONS(1981),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_private] = ACTIONS(1981),
    [anon_sym_static] = ACTIONS(1981),
    [anon_sym_get] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1983),
    [anon_sym_interface] = ACTIONS(1981),
    [anon_sym_default] = ACTIONS(1981),
    [anon_sym_enum] = ACTIONS(1981),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_continue] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1981),
    [sym_this] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1981),
    [sym_true] = ACTIONS(1981),
    [anon_sym_throw] = ACTIONS(1981),
    [anon_sym_protected] = ACTIONS(1981),
    [anon_sym_abstract] = ACTIONS(1981),
    [anon_sym_set] = ACTIONS(1981),
    [anon_sym_type] = ACTIONS(1981),
    [anon_sym_import] = ACTIONS(1981),
    [anon_sym_namespace] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1983),
    [anon_sym_DQUOTE] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [sym_false] = ACTIONS(1981),
    [anon_sym_SEMI] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1981),
    [anon_sym_module] = ACTIONS(1981),
    [anon_sym_number] = ACTIONS(1981),
    [anon_sym_class] = ACTIONS(1981),
    [anon_sym_declare] = ACTIONS(1981),
    [anon_sym_typeof] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1983),
    [sym_null] = ACTIONS(1981),
    [anon_sym_any] = ACTIONS(1981),
    [anon_sym_boolean] = ACTIONS(1981),
    [anon_sym_async] = ACTIONS(1981),
    [anon_sym_public] = ACTIONS(1981),
    [anon_sym_var] = ACTIONS(1981),
    [anon_sym_while] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1983),
    [sym_number] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1981),
    [anon_sym_function] = ACTIONS(1981),
    [sym_undefined] = ACTIONS(1981),
    [anon_sym_new] = ACTIONS(1981),
    [ts_builtin_sym_end] = ACTIONS(1983),
    [anon_sym_let] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1981),
    [anon_sym_export] = ACTIONS(1981),
    [anon_sym_do] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1983),
    [anon_sym_with] = ACTIONS(1981),
    [anon_sym_await] = ACTIONS(1981),
  },
  [377] = {
    [sym_string] = STATE(676),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [378] = {
    [sym_identifier] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1987),
    [sym__automatic_semicolon] = ACTIONS(1987),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [anon_sym_symbol] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_GT_GT_GT] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_return] = ACTIONS(1989),
    [anon_sym_static] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_interface] = ACTIONS(1989),
    [anon_sym_as] = ACTIONS(1989),
    [anon_sym_delete] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(1989),
    [anon_sym_instanceof] = ACTIONS(1989),
    [anon_sym_yield] = ACTIONS(1989),
    [sym_true] = ACTIONS(1989),
    [anon_sym_protected] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1989),
    [anon_sym_set] = ACTIONS(1989),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1987),
    [anon_sym_import] = ACTIONS(1989),
    [anon_sym_in] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_number] = ACTIONS(1989),
    [anon_sym_typeof] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [sym_null] = ACTIONS(1989),
    [anon_sym_any] = ACTIONS(1989),
    [anon_sym_async] = ACTIONS(1989),
    [anon_sym_public] = ACTIONS(1989),
    [anon_sym_var] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1989),
    [anon_sym_new] = ACTIONS(1989),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_export] = ACTIONS(1989),
    [anon_sym_GT_GT] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1987),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_debugger] = ACTIONS(1989),
    [anon_sym_AT] = ACTIONS(1987),
    [anon_sym_COMMA] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_void] = ACTIONS(1989),
    [anon_sym_const] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1987),
    [sym_super] = ACTIONS(1989),
    [anon_sym_private] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(1989),
    [anon_sym_default] = ACTIONS(1989),
    [anon_sym_enum] = ACTIONS(1989),
    [anon_sym_continue] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1987),
    [sym_this] = ACTIONS(1989),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_abstract] = ACTIONS(1989),
    [anon_sym_type] = ACTIONS(1989),
    [anon_sym_STAR_STAR] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [sym_false] = ACTIONS(1989),
    [anon_sym_case] = ACTIONS(1989),
    [anon_sym_module] = ACTIONS(1989),
    [anon_sym_class] = ACTIONS(1989),
    [anon_sym_declare] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_boolean] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1989),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1989),
    [sym_number] = ACTIONS(1987),
    [ts_builtin_sym_end] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(1989),
    [sym_undefined] = ACTIONS(1989),
    [anon_sym_let] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1989),
    [anon_sym_do] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1987),
    [anon_sym_await] = ACTIONS(1989),
  },
  [380] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1991),
    [sym__automatic_semicolon] = ACTIONS(1991),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_GT_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_as] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [anon_sym_instanceof] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1991),
    [anon_sym_STAR_STAR] = ACTIONS(1991),
    [anon_sym_PLUS_PLUS] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1993),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_SLASH] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1993),
    [anon_sym_GT_GT] = ACTIONS(1993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1991),
  },
  [381] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(1995),
    [aux_sym_string_token1] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [sym_comment] = ACTIONS(255),
  },
  [382] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2003),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [383] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [384] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(107),
  },
  [385] = {
    [sym_class] = STATE(1920),
    [sym_arrow_function] = STATE(1920),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(685),
    [sym_variable_declarator] = STATE(99),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1920),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1920),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(685),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1920),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1920),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(686),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1920),
    [sym_new_expression] = STATE(1920),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1920),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(685),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(687),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(2015),
    [sym_false] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(2021),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2017),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2017),
    [sym_number] = ACTIONS(2025),
    [sym_true] = ACTIONS(2017),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2017),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [386] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(437),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(437),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(437),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(437),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(437),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(437),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(437),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [387] = {
    [sym_class] = STATE(1920),
    [sym_arrow_function] = STATE(1920),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(685),
    [sym_variable_declarator] = STATE(215),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1920),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1920),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(685),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1920),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1920),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(686),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1920),
    [sym_new_expression] = STATE(1920),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1920),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(685),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(687),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(2015),
    [sym_false] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(2021),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2017),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2017),
    [sym_number] = ACTIONS(2025),
    [sym_true] = ACTIONS(2017),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2017),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [388] = {
    [sym_string] = STATE(1639),
    [sym_nested_identifier] = STATE(1638),
    [sym__module] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(697),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [389] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2003),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [390] = {
    [sym_await_expression] = STATE(51),
    [sym_update_expression] = STATE(51),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_ternary_expression] = STATE(51),
    [sym_template_string] = STATE(51),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(688),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(688),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [391] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2029),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [392] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2034),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2036),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [393] = {
    [sym_class] = STATE(1920),
    [sym_arrow_function] = STATE(1920),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1419),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1920),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1920),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1419),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1920),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1920),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1420),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1920),
    [sym_new_expression] = STATE(1920),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1920),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1419),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1421),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(2039),
    [sym_false] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2043),
    [anon_sym_const] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2017),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_async] = ACTIONS(2047),
    [anon_sym_var] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2017),
    [sym_number] = ACTIONS(2025),
    [sym_true] = ACTIONS(2017),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2017),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_let] = ACTIONS(2045),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_namespace] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [394] = {
    [sym_generator_function_declaration] = STATE(692),
    [sym__declaration] = STATE(692),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(692),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(692),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(692),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(692),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(692),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(692),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(692),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(692),
    [sym_function_declaration] = STATE(692),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(692),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(692),
    [sym_break_statement] = STATE(692),
    [sym_labeled_statement] = STATE(692),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(692),
    [sym_class_declaration] = STATE(692),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(692),
    [sym_ambient_declaration] = STATE(692),
    [sym_type_alias_declaration] = STATE(692),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(692),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(692),
    [sym_switch_statement] = STATE(692),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(692),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(692),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(692),
    [sym_abstract_class_declaration] = STATE(692),
    [sym_interface_declaration] = STATE(692),
    [sym_export_statement] = STATE(692),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(692),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(692),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(692),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(692),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [395] = {
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_BQUOTE] = ACTIONS(2053),
    [anon_sym_debugger] = ACTIONS(2051),
    [anon_sym_symbol] = ACTIONS(2051),
    [anon_sym_AT] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_void] = ACTIONS(2051),
    [anon_sym_break] = ACTIONS(2051),
    [anon_sym_const] = ACTIONS(2051),
    [sym_super] = ACTIONS(2051),
    [anon_sym_return] = ACTIONS(2051),
    [anon_sym_private] = ACTIONS(2051),
    [anon_sym_static] = ACTIONS(2051),
    [anon_sym_get] = ACTIONS(2051),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_interface] = ACTIONS(2051),
    [anon_sym_default] = ACTIONS(2051),
    [anon_sym_enum] = ACTIONS(2051),
    [anon_sym_delete] = ACTIONS(2051),
    [anon_sym_continue] = ACTIONS(2051),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(2051),
    [sym_this] = ACTIONS(2051),
    [anon_sym_yield] = ACTIONS(2051),
    [sym_true] = ACTIONS(2051),
    [anon_sym_throw] = ACTIONS(2051),
    [anon_sym_protected] = ACTIONS(2051),
    [anon_sym_abstract] = ACTIONS(2051),
    [anon_sym_set] = ACTIONS(2051),
    [anon_sym_type] = ACTIONS(2051),
    [anon_sym_import] = ACTIONS(2051),
    [anon_sym_namespace] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_else] = ACTIONS(2051),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_for] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(2053),
    [sym_false] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2051),
    [anon_sym_module] = ACTIONS(2051),
    [anon_sym_number] = ACTIONS(2051),
    [anon_sym_class] = ACTIONS(2051),
    [anon_sym_declare] = ACTIONS(2051),
    [anon_sym_typeof] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_switch] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [sym_null] = ACTIONS(2051),
    [anon_sym_any] = ACTIONS(2051),
    [anon_sym_boolean] = ACTIONS(2051),
    [anon_sym_async] = ACTIONS(2051),
    [anon_sym_public] = ACTIONS(2051),
    [anon_sym_var] = ACTIONS(2051),
    [anon_sym_while] = ACTIONS(2051),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [anon_sym_try] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2053),
    [sym_number] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2051),
    [anon_sym_function] = ACTIONS(2051),
    [sym_undefined] = ACTIONS(2051),
    [anon_sym_new] = ACTIONS(2051),
    [ts_builtin_sym_end] = ACTIONS(2053),
    [anon_sym_let] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2051),
    [anon_sym_do] = ACTIONS(2051),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_with] = ACTIONS(2051),
    [anon_sym_await] = ACTIONS(2051),
  },
  [396] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [397] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [398] = {
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACK] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2059),
    [sym__automatic_semicolon] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2059),
    [anon_sym_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_PERCENT] = ACTIONS(2059),
    [anon_sym_as] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_instanceof] = ACTIONS(2059),
    [anon_sym_COLON] = ACTIONS(2059),
    [anon_sym_DOT] = ACTIONS(2059),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2059),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_LT_LT] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_of] = ACTIONS(2059),
    [anon_sym_LT_EQ] = ACTIONS(2059),
    [anon_sym_LPAREN] = ACTIONS(2059),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2059),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2059),
  },
  [400] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [aux_sym_extends_clause_repeat1] = STATE(696),
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_AMP_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(2070),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(2072),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2068),
    [anon_sym_STAR_EQ] = ACTIONS(2068),
    [anon_sym_PIPE_EQ] = ACTIONS(2068),
    [anon_sym_DASH_EQ] = ACTIONS(2068),
    [anon_sym_EQ_GT] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2068),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(2072),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [403] = {
    [aux_sym_extends_clause_repeat1] = STATE(697),
    [anon_sym_implements] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2083),
  },
  [404] = {
    [sym_arguments] = STATE(1323),
    [aux_sym_extends_clause_repeat1] = STATE(697),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [405] = {
    [aux_sym_extends_clause_repeat1] = STATE(697),
    [sym_type_arguments] = STATE(642),
    [anon_sym_implements] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2083),
  },
  [406] = {
    [aux_sym_implements_clause_repeat1] = STATE(699),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2113),
  },
  [407] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2115),
    [sym__automatic_semicolon] = ACTIONS(2117),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_PIPE] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_as] = ACTIONS(2123),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_instanceof] = ACTIONS(2123),
    [anon_sym_yield] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_DOT] = ACTIONS(2123),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_AMP_AMP] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [sym_null] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_QMARK] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(2121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_GT_EQ] = ACTIONS(2115),
    [sym_super] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [sym_this] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_STAR_STAR] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [sym_false] = ACTIONS(2121),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_GT] = ACTIONS(2123),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_PIPE_PIPE] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2121),
    [sym_number] = ACTIONS(2119),
    [ts_builtin_sym_end] = ACTIONS(2119),
    [anon_sym_function] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2121),
  },
  [408] = {
    [sym_class_body] = STATE(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [409] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(702),
    [sym_class_heritage] = STATE(703),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [410] = {
    [sym_default_type] = STATE(519),
    [sym_constraint] = STATE(517),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_COLON] = ACTIONS(2125),
    [anon_sym_extends] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(1255),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_string] = STATE(704),
    [sym__property_name] = STATE(704),
    [sym_computed_property_name] = STATE(704),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [412] = {
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [413] = {
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [414] = {
    [sym_await_expression] = STATE(710),
    [sym_update_expression] = STATE(710),
    [sym_meta_property] = STATE(710),
    [sym__expression] = STATE(710),
    [sym_jsx_element] = STATE(710),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(710),
    [sym_call_expression] = STATE(710),
    [sym_ternary_expression] = STATE(710),
    [sym_template_string] = STATE(710),
    [sym_yield_expression] = STATE(710),
    [sym_jsx_fragment] = STATE(710),
    [sym_new_expression] = STATE(710),
    [sym_assignment_expression] = STATE(710),
    [sym_mapped_type_clause] = STATE(711),
    [sym_binary_expression] = STATE(710),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(710),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(710),
    [sym_jsx_self_closing_element] = STATE(710),
    [sym_arrow_function] = STATE(710),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(710),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(710),
    [sym_augmented_assignment_expression] = STATE(710),
    [sym_unary_expression] = STATE(710),
    [sym_regex] = STATE(710),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(710),
    [sym_class] = STATE(710),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2131),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(2133),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(2131),
    [anon_sym_static] = ACTIONS(2131),
    [anon_sym_get] = ACTIONS(2131),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2135),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(2135),
    [anon_sym_protected] = ACTIONS(2131),
    [anon_sym_set] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2131),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2135),
    [anon_sym_module] = ACTIONS(2131),
    [anon_sym_number] = ACTIONS(2131),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(2131),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2135),
    [anon_sym_any] = ACTIONS(2131),
    [anon_sym_boolean] = ACTIONS(2131),
    [anon_sym_async] = ACTIONS(2139),
    [anon_sym_public] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2141),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2135),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [415] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2143),
    [sym__automatic_semicolon] = ACTIONS(2143),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2143),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_PERCENT] = ACTIONS(2143),
    [anon_sym_as] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_instanceof] = ACTIONS(2143),
    [anon_sym_DOT] = ACTIONS(2143),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2143),
    [anon_sym_STAR_STAR] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_LT_LT] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(2143),
    [anon_sym_LT_EQ] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2143),
    [anon_sym_PIPE_PIPE] = ACTIONS(2143),
    [anon_sym_while] = ACTIONS(2143),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2143),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2143),
  },
  [416] = {
    [sym_string] = STATE(704),
    [sym__property_name] = STATE(704),
    [sym_computed_property_name] = STATE(704),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [417] = {
    [sym_string] = STATE(715),
    [sym__property_name] = STATE(715),
    [sym_computed_property_name] = STATE(715),
    [anon_sym_get] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(2147),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
  },
  [418] = {
    [sym_string] = STATE(719),
    [sym__property_name] = STATE(719),
    [sym_computed_property_name] = STATE(719),
    [anon_sym_get] = ACTIONS(2157),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(2155),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [419] = {
    [sym_string] = STATE(704),
    [sym__property_name] = STATE(704),
    [sym_computed_property_name] = STATE(704),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(2165),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(2165),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [420] = {
    [sym_string] = STATE(719),
    [sym__property_name] = STATE(719),
    [sym_computed_property_name] = STATE(719),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(2159),
    [anon_sym_get] = ACTIONS(2157),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [421] = {
    [sym__automatic_semicolon] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_decorator] = STATE(723),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(723),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [423] = {
    [sym__automatic_semicolon] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2173),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [sym_number] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [sym_readonly] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2173),
  },
  [424] = {
    [sym_string] = STATE(719),
    [sym__property_name] = STATE(719),
    [sym_computed_property_name] = STATE(719),
    [anon_sym_get] = ACTIONS(2157),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(2177),
    [anon_sym_set] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(2179),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(2181),
    [anon_sym_private] = ACTIONS(968),
  },
  [425] = {
    [sym_type_annotation] = STATE(731),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(730),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(729),
    [sym__automatic_semicolon] = ACTIONS(2183),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2187),
  },
  [426] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2189),
  },
  [427] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [sym__automatic_semicolon] = ACTIONS(2191),
    [anon_sym_SEMI] = ACTIONS(2191),
    [anon_sym_BQUOTE] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_GT_GT_GT] = ACTIONS(2191),
    [anon_sym_AMP_AMP] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_BANG_EQ] = ACTIONS(2193),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_QMARK] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [anon_sym_as] = ACTIONS(2191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2193),
    [anon_sym_instanceof] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_GT_GT] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2191),
    [anon_sym_in] = ACTIONS(2193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG] = ACTIONS(2193),
  },
  [428] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [sym__automatic_semicolon] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_BQUOTE] = ACTIONS(2195),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_LT_LT] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_GT_GT_GT] = ACTIONS(2195),
    [anon_sym_AMP_AMP] = ACTIONS(2195),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_BANG_EQ] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2195),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_GT_EQ] = ACTIONS(2195),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2195),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [anon_sym_as] = ACTIONS(2195),
    [anon_sym_PIPE_PIPE] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_EQ_EQ] = ACTIONS(2197),
    [anon_sym_instanceof] = ACTIONS(2195),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_STAR_STAR] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2195),
    [anon_sym_BANG] = ACTIONS(2197),
  },
  [429] = {
    [sym_class_body] = STATE(732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [430] = {
    [sym_identifier] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(735),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(734),
    [sym_type_parameters] = STATE(736),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [432] = {
    [sym_identifier] = ACTIONS(2203),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2203),
    [anon_sym_symbol] = ACTIONS(2203),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_void] = ACTIONS(2203),
    [anon_sym_break] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [sym_super] = ACTIONS(2203),
    [anon_sym_return] = ACTIONS(2203),
    [anon_sym_private] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_get] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2203),
    [anon_sym_default] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_delete] = ACTIONS(2203),
    [anon_sym_continue] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2203),
    [sym_this] = ACTIONS(2203),
    [anon_sym_yield] = ACTIONS(2203),
    [sym_true] = ACTIONS(2203),
    [anon_sym_throw] = ACTIONS(2203),
    [anon_sym_protected] = ACTIONS(2203),
    [anon_sym_abstract] = ACTIONS(2203),
    [anon_sym_set] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(2203),
    [anon_sym_import] = ACTIONS(2203),
    [anon_sym_namespace] = ACTIONS(2203),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [sym_false] = ACTIONS(2203),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_case] = ACTIONS(2203),
    [anon_sym_module] = ACTIONS(2203),
    [anon_sym_number] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_declare] = ACTIONS(2203),
    [anon_sym_typeof] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [sym_null] = ACTIONS(2203),
    [anon_sym_any] = ACTIONS(2203),
    [anon_sym_boolean] = ACTIONS(2203),
    [anon_sym_async] = ACTIONS(2203),
    [anon_sym_public] = ACTIONS(2203),
    [anon_sym_var] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2203),
    [anon_sym_function] = ACTIONS(2203),
    [sym_undefined] = ACTIONS(2203),
    [anon_sym_new] = ACTIONS(2203),
    [ts_builtin_sym_end] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_export] = ACTIONS(2203),
    [anon_sym_do] = ACTIONS(2203),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2203),
    [anon_sym_await] = ACTIONS(2203),
  },
  [433] = {
    [sym_identifier] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(739),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym_identifier] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [anon_sym_EQ] = ACTIONS(2213),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [sym_identifier] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2217),
    [sym__automatic_semicolon] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_GT_GT_GT] = ACTIONS(2217),
    [anon_sym_EQ] = ACTIONS(2219),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_GT_EQ] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_PERCENT] = ACTIONS(2217),
    [anon_sym_as] = ACTIONS(2217),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_instanceof] = ACTIONS(2217),
    [anon_sym_COLON] = ACTIONS(2217),
    [anon_sym_DOT] = ACTIONS(2217),
    [anon_sym_STAR_STAR] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_in] = ACTIONS(2219),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym_LT_LT] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_of] = ACTIONS(2217),
    [anon_sym_LT_EQ] = ACTIONS(2217),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2217),
  },
  [439] = {
    [sym_class] = STATE(743),
    [sym_arrow_function] = STATE(743),
    [sym_await_expression] = STATE(743),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(743),
    [sym_meta_property] = STATE(743),
    [sym__expression] = STATE(743),
    [sym_jsx_element] = STATE(743),
    [sym_function] = STATE(52),
    [sym_import] = STATE(743),
    [sym_call_expression] = STATE(743),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(743),
    [sym_string] = STATE(743),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(743),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(743),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(743),
    [sym_generator_function] = STATE(743),
    [sym_new_expression] = STATE(743),
    [sym_assignment_expression] = STATE(743),
    [sym_augmented_assignment_expression] = STATE(743),
    [sym_binary_expression] = STATE(743),
    [sym_unary_expression] = STATE(743),
    [sym_regex] = STATE(743),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(743),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(743),
    [sym_internal_module] = STATE(743),
    [sym_jsx_self_closing_element] = STATE(743),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2221),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2221),
    [sym_number] = ACTIONS(2223),
    [sym_true] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [440] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_class] = STATE(745),
    [sym_arrow_function] = STATE(745),
    [sym_await_expression] = STATE(745),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(745),
    [sym_meta_property] = STATE(745),
    [sym__expression] = STATE(745),
    [sym_jsx_element] = STATE(745),
    [sym_function] = STATE(52),
    [sym_import] = STATE(745),
    [sym_call_expression] = STATE(745),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(745),
    [sym_string] = STATE(745),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(745),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(745),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(745),
    [sym_generator_function] = STATE(745),
    [sym_new_expression] = STATE(745),
    [sym_assignment_expression] = STATE(745),
    [sym_augmented_assignment_expression] = STATE(745),
    [sym_binary_expression] = STATE(745),
    [sym_unary_expression] = STATE(745),
    [sym_regex] = STATE(745),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(745),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(745),
    [sym_internal_module] = STATE(745),
    [sym_jsx_self_closing_element] = STATE(745),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2227),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2227),
    [sym_number] = ACTIONS(2229),
    [sym_true] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2227),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [442] = {
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_computed_property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [443] = {
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_computed_property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [445] = {
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
  },
  [446] = {
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_computed_property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(1070),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [447] = {
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym_class] = STATE(2026),
    [sym_arrow_function] = STATE(2026),
    [sym_await_expression] = STATE(2026),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2026),
    [sym_meta_property] = STATE(2026),
    [sym__expression] = STATE(2026),
    [sym_jsx_element] = STATE(2026),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2026),
    [sym_call_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2026),
    [sym_string] = STATE(2026),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2026),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2026),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2026),
    [sym_generator_function] = STATE(2026),
    [sym_new_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2026),
    [sym_augmented_assignment_expression] = STATE(2026),
    [sym_binary_expression] = STATE(2026),
    [sym_unary_expression] = STATE(2026),
    [sym_regex] = STATE(2026),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2026),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2026),
    [sym_internal_module] = STATE(2026),
    [sym_jsx_self_closing_element] = STATE(2026),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2235),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(2235),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2235),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2235),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2235),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [449] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(747),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(2239),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [451] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_get] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(2243),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [452] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [453] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_get] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(2247),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(2243),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [454] = {
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [anon_sym_catch] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [sym_this] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_false] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2249),
    [sym_number] = ACTIONS(2249),
    [anon_sym_finally] = ACTIONS(2251),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_await] = ACTIONS(2251),
  },
  [455] = {
    [aux_sym_array_repeat1] = STATE(400),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(2253),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [456] = {
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [anon_sym_EQ_GT] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_EQ_GT] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [459] = {
    [sym_class] = STATE(745),
    [sym_arrow_function] = STATE(745),
    [sym_await_expression] = STATE(745),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(745),
    [sym_meta_property] = STATE(745),
    [sym__expression] = STATE(745),
    [sym_jsx_element] = STATE(745),
    [sym_function] = STATE(52),
    [sym_import] = STATE(745),
    [sym_call_expression] = STATE(745),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(745),
    [sym_string] = STATE(745),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(745),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(745),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(745),
    [sym_generator_function] = STATE(745),
    [sym_new_expression] = STATE(745),
    [sym_assignment_expression] = STATE(745),
    [sym_augmented_assignment_expression] = STATE(745),
    [sym_binary_expression] = STATE(745),
    [sym_unary_expression] = STATE(745),
    [sym_regex] = STATE(745),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(745),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(745),
    [sym_internal_module] = STATE(745),
    [sym_jsx_self_closing_element] = STATE(745),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(1356),
    [sym_false] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2227),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2227),
    [sym_number] = ACTIONS(2229),
    [sym_true] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2227),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [460] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_GT_GT_GT] = ACTIONS(2255),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2255),
    [anon_sym_COLON] = ACTIONS(2255),
    [anon_sym_DOT] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_in] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_of] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_QMARK] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_EQ_EQ] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2257),
    [anon_sym_SLASH] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
  },
  [461] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_RBRACE] = ACTIONS(2259),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_class] = STATE(754),
    [sym_arrow_function] = STATE(754),
    [sym_await_expression] = STATE(754),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(754),
    [sym_meta_property] = STATE(754),
    [sym__expression] = STATE(754),
    [sym_jsx_element] = STATE(754),
    [sym_function] = STATE(52),
    [sym_import] = STATE(754),
    [sym_call_expression] = STATE(754),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(754),
    [sym_string] = STATE(754),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(754),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(754),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(754),
    [sym_generator_function] = STATE(754),
    [sym_new_expression] = STATE(754),
    [sym_assignment_expression] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(754),
    [sym_binary_expression] = STATE(754),
    [sym_unary_expression] = STATE(754),
    [sym_regex] = STATE(754),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(754),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(754),
    [sym_internal_module] = STATE(754),
    [sym_jsx_self_closing_element] = STATE(754),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2261),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2261),
    [sym_number] = ACTIONS(2263),
    [sym_true] = ACTIONS(2261),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [463] = {
    [sym_class] = STATE(755),
    [sym_arrow_function] = STATE(755),
    [sym_await_expression] = STATE(755),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(755),
    [sym_meta_property] = STATE(755),
    [sym__expression] = STATE(755),
    [sym_jsx_element] = STATE(755),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(755),
    [sym_call_expression] = STATE(755),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(755),
    [sym_string] = STATE(755),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(755),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(755),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(755),
    [sym_generator_function] = STATE(755),
    [sym_new_expression] = STATE(755),
    [sym_assignment_expression] = STATE(755),
    [sym_augmented_assignment_expression] = STATE(755),
    [sym_binary_expression] = STATE(755),
    [sym_unary_expression] = STATE(755),
    [sym_regex] = STATE(755),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(755),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(755),
    [sym_internal_module] = STATE(755),
    [sym_jsx_self_closing_element] = STATE(755),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2265),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2265),
    [sym_number] = ACTIONS(2267),
    [sym_true] = ACTIONS(2265),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [464] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(756),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [465] = {
    [sym_statement_block] = STATE(757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [466] = {
    [sym__automatic_semicolon] = ACTIONS(2269),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [anon_sym_catch] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [sym_this] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_false] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2249),
    [sym_number] = ACTIONS(2249),
    [anon_sym_finally] = ACTIONS(2251),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_await] = ACTIONS(2251),
  },
  [467] = {
    [sym_class] = STATE(759),
    [sym_arrow_function] = STATE(759),
    [sym_await_expression] = STATE(759),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(759),
    [sym_meta_property] = STATE(759),
    [sym__expression] = STATE(759),
    [sym_jsx_element] = STATE(759),
    [sym_function] = STATE(52),
    [sym_import] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(759),
    [sym_string] = STATE(759),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(759),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(759),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(759),
    [sym_generator_function] = STATE(759),
    [sym_new_expression] = STATE(759),
    [sym_assignment_expression] = STATE(759),
    [sym_augmented_assignment_expression] = STATE(759),
    [sym_binary_expression] = STATE(759),
    [sym_unary_expression] = STATE(759),
    [sym_regex] = STATE(759),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(759),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(759),
    [sym_internal_module] = STATE(759),
    [sym_jsx_self_closing_element] = STATE(759),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2271),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2271),
    [sym_number] = ACTIONS(2273),
    [sym_true] = ACTIONS(2271),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2271),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [468] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_COMMA] = ACTIONS(2275),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(2245),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(2247),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(2243),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(2278),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [470] = {
    [sym_switch_default] = STATE(764),
    [aux_sym_switch_body_repeat1] = STATE(764),
    [sym_switch_case] = STATE(764),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2282),
    [anon_sym_case] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_identifier] = ACTIONS(2286),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2286),
    [anon_sym_symbol] = ACTIONS(2286),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2286),
    [anon_sym_void] = ACTIONS(2286),
    [anon_sym_break] = ACTIONS(2286),
    [anon_sym_const] = ACTIONS(2286),
    [sym_super] = ACTIONS(2286),
    [anon_sym_return] = ACTIONS(2286),
    [anon_sym_private] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2286),
    [anon_sym_get] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2286),
    [anon_sym_default] = ACTIONS(2286),
    [anon_sym_enum] = ACTIONS(2286),
    [anon_sym_delete] = ACTIONS(2286),
    [anon_sym_continue] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2286),
    [sym_this] = ACTIONS(2286),
    [anon_sym_yield] = ACTIONS(2286),
    [sym_true] = ACTIONS(2286),
    [anon_sym_throw] = ACTIONS(2286),
    [anon_sym_protected] = ACTIONS(2286),
    [anon_sym_abstract] = ACTIONS(2286),
    [anon_sym_set] = ACTIONS(2286),
    [anon_sym_type] = ACTIONS(2286),
    [anon_sym_import] = ACTIONS(2286),
    [anon_sym_namespace] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [sym_false] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2286),
    [anon_sym_module] = ACTIONS(2286),
    [anon_sym_number] = ACTIONS(2286),
    [anon_sym_class] = ACTIONS(2286),
    [anon_sym_declare] = ACTIONS(2286),
    [anon_sym_typeof] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2286),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [sym_null] = ACTIONS(2286),
    [anon_sym_any] = ACTIONS(2286),
    [anon_sym_boolean] = ACTIONS(2286),
    [anon_sym_async] = ACTIONS(2286),
    [anon_sym_public] = ACTIONS(2286),
    [anon_sym_var] = ACTIONS(2286),
    [anon_sym_while] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2286),
    [anon_sym_function] = ACTIONS(2286),
    [sym_undefined] = ACTIONS(2286),
    [anon_sym_new] = ACTIONS(2286),
    [ts_builtin_sym_end] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2286),
    [anon_sym_export] = ACTIONS(2286),
    [anon_sym_do] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2286),
    [anon_sym_await] = ACTIONS(2286),
  },
  [472] = {
    [anon_sym_EQ] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [anon_sym_EQ] = ACTIONS(2294),
    [anon_sym_COLON] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_QMARK] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [anon_sym_EQ] = ACTIONS(2296),
    [anon_sym_COLON] = ACTIONS(2296),
    [anon_sym_RPAREN] = ACTIONS(2296),
    [anon_sym_QMARK] = ACTIONS(2296),
    [anon_sym_COMMA] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_type_annotation] = STATE(765),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_COMMA] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(2300),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [478] = {
    [anon_sym_COLON] = ACTIONS(2302),
    [anon_sym_EQ_GT] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2302),
  },
  [479] = {
    [aux_sym_formal_parameters_repeat1] = STATE(770),
    [anon_sym_RPAREN] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym__initializer] = STATE(771),
    [sym_type_annotation] = STATE(772),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_COMMA] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [anon_sym_COMMA] = ACTIONS(2308),
    [anon_sym_RPAREN] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [sym__initializer] = STATE(773),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COMMA] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2312),
    [sym__automatic_semicolon] = ACTIONS(2312),
    [anon_sym_BQUOTE] = ACTIONS(2312),
    [anon_sym_PERCENT_EQ] = ACTIONS(2312),
    [anon_sym_AMP_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_GT_GT_GT] = ACTIONS(2314),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT_EQ] = ACTIONS(2312),
    [anon_sym_CARET_EQ] = ACTIONS(2312),
    [anon_sym_PIPE_EQ] = ACTIONS(2312),
    [anon_sym_DASH_EQ] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_LT_LT_EQ] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_instanceof] = ACTIONS(2312),
    [anon_sym_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_STAR_STAR] = ACTIONS(2314),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_of] = ACTIONS(2312),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_GT] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_GT_GT] = ACTIONS(2314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2312),
  },
  [484] = {
    [anon_sym_RPAREN] = ACTIONS(2316),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_object] = STATE(777),
    [sym_array] = STATE(778),
    [anon_sym_get] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2318),
    [anon_sym_module] = ACTIONS(2318),
    [anon_sym_symbol] = ACTIONS(2318),
    [anon_sym_number] = ACTIONS(2318),
    [anon_sym_declare] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2318),
    [anon_sym_protected] = ACTIONS(2318),
    [anon_sym_string] = ACTIONS(2318),
    [anon_sym_set] = ACTIONS(2318),
    [anon_sym_type] = ACTIONS(2318),
    [anon_sym_export] = ACTIONS(2318),
    [anon_sym_namespace] = ACTIONS(2318),
    [anon_sym_any] = ACTIONS(2318),
    [anon_sym_private] = ACTIONS(2318),
    [anon_sym_boolean] = ACTIONS(2318),
    [anon_sym_async] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
  },
  [486] = {
    [anon_sym_EQ] = ACTIONS(2322),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_RPAREN] = ACTIONS(2322),
    [anon_sym_QMARK] = ACTIONS(2322),
    [anon_sym_COMMA] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(2322),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(2322),
    [anon_sym_RPAREN] = ACTIONS(2322),
    [sym_this] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
  },
  [488] = {
    [aux_sym_formal_parameters_repeat1] = STATE(779),
    [anon_sym_RPAREN] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [anon_sym_EQ] = ACTIONS(2324),
    [anon_sym_COLON] = ACTIONS(2324),
    [anon_sym_RPAREN] = ACTIONS(2324),
    [anon_sym_QMARK] = ACTIONS(2324),
    [anon_sym_COMMA] = ACTIONS(2324),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [anon_sym_EQ] = ACTIONS(2326),
    [anon_sym_COLON] = ACTIONS(2326),
    [anon_sym_RPAREN] = ACTIONS(2326),
    [anon_sym_QMARK] = ACTIONS(2326),
    [anon_sym_COMMA] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_await_expression] = STATE(781),
    [sym_statement_block] = STATE(780),
    [sym_update_expression] = STATE(781),
    [sym_meta_property] = STATE(781),
    [sym__expression] = STATE(781),
    [sym_jsx_element] = STATE(781),
    [sym_function] = STATE(52),
    [sym_import] = STATE(781),
    [sym_call_expression] = STATE(781),
    [sym_ternary_expression] = STATE(781),
    [sym_template_string] = STATE(781),
    [sym_yield_expression] = STATE(781),
    [sym_jsx_fragment] = STATE(781),
    [sym_new_expression] = STATE(781),
    [sym_assignment_expression] = STATE(781),
    [sym_binary_expression] = STATE(781),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(781),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(781),
    [sym_jsx_self_closing_element] = STATE(781),
    [sym_arrow_function] = STATE(781),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(781),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(781),
    [sym_augmented_assignment_expression] = STATE(781),
    [sym_unary_expression] = STATE(781),
    [sym_regex] = STATE(781),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(781),
    [sym_class] = STATE(781),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2328),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2328),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2328),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2330),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2328),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [492] = {
    [sym_await_expression] = STATE(783),
    [sym_statement_block] = STATE(782),
    [sym_update_expression] = STATE(783),
    [sym_meta_property] = STATE(783),
    [sym__expression] = STATE(783),
    [sym_jsx_element] = STATE(783),
    [sym_function] = STATE(52),
    [sym_import] = STATE(783),
    [sym_call_expression] = STATE(783),
    [sym_ternary_expression] = STATE(783),
    [sym_template_string] = STATE(783),
    [sym_yield_expression] = STATE(783),
    [sym_jsx_fragment] = STATE(783),
    [sym_new_expression] = STATE(783),
    [sym_assignment_expression] = STATE(783),
    [sym_binary_expression] = STATE(783),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(783),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(783),
    [sym_jsx_self_closing_element] = STATE(783),
    [sym_arrow_function] = STATE(783),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(783),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(783),
    [sym_augmented_assignment_expression] = STATE(783),
    [sym_unary_expression] = STATE(783),
    [sym_regex] = STATE(783),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(783),
    [sym_class] = STATE(783),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2332),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2332),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2332),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2334),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2332),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [493] = {
    [sym_optional_parameter] = STATE(488),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(488),
    [aux_sym_export_statement_repeat1] = STATE(2705),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(488),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [494] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(784),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(786),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_statement_block] = STATE(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [497] = {
    [sym_await_expression] = STATE(789),
    [sym_statement_block] = STATE(788),
    [sym_update_expression] = STATE(789),
    [sym_meta_property] = STATE(789),
    [sym__expression] = STATE(789),
    [sym_jsx_element] = STATE(789),
    [sym_function] = STATE(52),
    [sym_import] = STATE(789),
    [sym_call_expression] = STATE(789),
    [sym_ternary_expression] = STATE(789),
    [sym_template_string] = STATE(789),
    [sym_yield_expression] = STATE(789),
    [sym_jsx_fragment] = STATE(789),
    [sym_new_expression] = STATE(789),
    [sym_assignment_expression] = STATE(789),
    [sym_binary_expression] = STATE(789),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(789),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(789),
    [sym_jsx_self_closing_element] = STATE(789),
    [sym_arrow_function] = STATE(789),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(789),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(789),
    [sym_augmented_assignment_expression] = STATE(789),
    [sym_unary_expression] = STATE(789),
    [sym_regex] = STATE(789),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(789),
    [sym_class] = STATE(789),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2338),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2338),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2338),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2338),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2340),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [498] = {
    [sym_identifier] = ACTIONS(2342),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2342),
    [anon_sym_symbol] = ACTIONS(2342),
    [anon_sym_AT] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [sym_super] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_private] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_get] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2342),
    [sym_true] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_protected] = ACTIONS(2342),
    [anon_sym_abstract] = ACTIONS(2342),
    [anon_sym_set] = ACTIONS(2342),
    [anon_sym_type] = ACTIONS(2342),
    [anon_sym_import] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [sym_false] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_module] = ACTIONS(2342),
    [anon_sym_number] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_declare] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2344),
    [sym_null] = ACTIONS(2342),
    [anon_sym_any] = ACTIONS(2342),
    [anon_sym_boolean] = ACTIONS(2342),
    [anon_sym_async] = ACTIONS(2342),
    [anon_sym_public] = ACTIONS(2342),
    [anon_sym_var] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2344),
    [sym_number] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2342),
    [sym_undefined] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_export] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2342),
  },
  [499] = {
    [aux_sym_variable_declaration_repeat1] = STATE(606),
    [sym__automatic_semicolon] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_BQUOTE] = ACTIONS(2350),
    [anon_sym_debugger] = ACTIONS(2348),
    [anon_sym_symbol] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_void] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_interface] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2348),
    [sym_this] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [sym_true] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_import] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [sym_false] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2348),
    [anon_sym_number] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_declare] = ACTIONS(2348),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [sym_null] = ACTIONS(2348),
    [anon_sym_any] = ACTIONS(2348),
    [anon_sym_boolean] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2350),
    [sym_number] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2348),
    [anon_sym_function] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [ts_builtin_sym_end] = ACTIONS(2350),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_export] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_with] = ACTIONS(2348),
    [anon_sym_await] = ACTIONS(2348),
  },
  [501] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(2352),
    [aux_sym_string_token2] = ACTIONS(2355),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(2358),
  },
  [502] = {
    [sym__automatic_semicolon] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_interface] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [sym_true] = ACTIONS(1083),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [sym_null] = ACTIONS(1083),
    [anon_sym_catch] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_var] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_with] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_debugger] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [sym_super] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_this] = ACTIONS(1083),
    [anon_sym_throw] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_namespace] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_else] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_false] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1083),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1081),
    [sym_number] = ACTIONS(1081),
    [anon_sym_finally] = ACTIONS(1083),
    [ts_builtin_sym_end] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(1083),
    [sym_undefined] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1083),
  },
  [503] = {
    [sym_statement_block] = STATE(792),
    [anon_sym_LPAREN] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [504] = {
    [sym_statement_block] = STATE(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [505] = {
    [sym_finally_clause] = STATE(794),
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2364),
    [anon_sym_debugger] = ACTIONS(2362),
    [anon_sym_symbol] = ACTIONS(2362),
    [anon_sym_AT] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_void] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [sym_super] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_private] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_get] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_interface] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym_yield] = ACTIONS(2362),
    [sym_true] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_protected] = ACTIONS(2362),
    [anon_sym_abstract] = ACTIONS(2362),
    [anon_sym_set] = ACTIONS(2362),
    [anon_sym_type] = ACTIONS(2362),
    [anon_sym_import] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2364),
    [sym_false] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_module] = ACTIONS(2362),
    [anon_sym_number] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_declare] = ACTIONS(2362),
    [anon_sym_typeof] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_LPAREN] = ACTIONS(2364),
    [sym_null] = ACTIONS(2362),
    [anon_sym_any] = ACTIONS(2362),
    [anon_sym_boolean] = ACTIONS(2362),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_public] = ACTIONS(2362),
    [anon_sym_var] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [sym_number] = ACTIONS(2364),
    [anon_sym_SLASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1245),
    [anon_sym_string] = ACTIONS(2362),
    [anon_sym_function] = ACTIONS(2362),
    [sym_undefined] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_export] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_with] = ACTIONS(2362),
    [anon_sym_await] = ACTIONS(2362),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2366),
    [anon_sym_BQUOTE] = ACTIONS(2368),
    [anon_sym_debugger] = ACTIONS(2366),
    [anon_sym_symbol] = ACTIONS(2366),
    [anon_sym_AT] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_void] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [sym_super] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_private] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_get] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym_yield] = ACTIONS(2366),
    [sym_true] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_protected] = ACTIONS(2366),
    [anon_sym_abstract] = ACTIONS(2366),
    [anon_sym_set] = ACTIONS(2366),
    [anon_sym_type] = ACTIONS(2366),
    [anon_sym_import] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [sym_false] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_module] = ACTIONS(2366),
    [anon_sym_number] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_declare] = ACTIONS(2366),
    [anon_sym_typeof] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_LPAREN] = ACTIONS(2368),
    [sym_null] = ACTIONS(2366),
    [anon_sym_any] = ACTIONS(2366),
    [anon_sym_boolean] = ACTIONS(2366),
    [anon_sym_async] = ACTIONS(2366),
    [anon_sym_public] = ACTIONS(2366),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2368),
    [sym_number] = ACTIONS(2368),
    [anon_sym_SLASH] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2366),
    [anon_sym_function] = ACTIONS(2366),
    [sym_undefined] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [ts_builtin_sym_end] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_export] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_with] = ACTIONS(2366),
    [anon_sym_await] = ACTIONS(2366),
  },
  [507] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [508] = {
    [sym_jsx_element] = STATE(574),
    [sym_jsx_expression] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(2372),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [509] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(797),
    [sym_function_type] = STATE(797),
    [sym_constructor_type] = STATE(797),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(797),
    [sym__type] = STATE(797),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [510] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(2374),
    [anon_sym_EQ] = ACTIONS(2376),
    [sym_jsx_identifier] = ACTIONS(2378),
    [anon_sym_GT] = ACTIONS(2378),
    [anon_sym_SLASH] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2378),
  },
  [511] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(801),
    [sym_function_type] = STATE(801),
    [sym_constructor_type] = STATE(801),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(801),
    [sym__type] = STATE(801),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_identifier] = ACTIONS(2380),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [sym_jsx_identifier] = ACTIONS(2382),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [512] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(801),
    [sym_function_type] = STATE(801),
    [sym_constructor_type] = STATE(801),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(801),
    [sym__type] = STATE(801),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [513] = {
    [sym_jsx_text] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2384),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(2384),
  },
  [514] = {
    [anon_sym_GT] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(805),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2392),
    [sym_jsx_identifier] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2394),
  },
  [517] = {
    [sym_default_type] = STATE(806),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(808),
    [anon_sym_GT] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [519] = {
    [anon_sym_COMMA] = ACTIONS(2396),
    [anon_sym_GT] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [anon_sym_EQ] = ACTIONS(2400),
    [sym_identifier] = ACTIONS(2402),
    [sym_jsx_identifier] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2404),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(2382),
  },
  [522] = {
    [sym_type_parameter] = STATE(811),
    [anon_sym_GT] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [anon_sym_extends] = ACTIONS(2410),
    [anon_sym_implements] = ACTIONS(2410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2410),
    [anon_sym_EQ] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2412),
  },
  [524] = {
    [aux_sym_type_parameters_repeat1] = STATE(813),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [sym__automatic_semicolon] = ACTIONS(2416),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2418),
    [sym_regex_flags] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
  },
  [526] = {
    [sym_statement_block] = STATE(816),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(844),
  },
  [527] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(817),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [sym_statement_block] = STATE(818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [529] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
  },
  [530] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [sym__automatic_semicolon] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
  },
  [531] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [sym__automatic_semicolon] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
  },
  [532] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [sym__automatic_semicolon] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
  },
  [533] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [sym__automatic_semicolon] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
  },
  [534] = {
    [sym__automatic_semicolon] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [sym__automatic_semicolon] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_from] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [anon_sym_RBRACE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [aux_sym_export_clause_repeat1] = STATE(826),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [539] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2452),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [540] = {
    [sym_identifier] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2478),
    [sym_this] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [sym_false] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [sym_null] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2478),
    [ts_builtin_sym_end] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_await] = ACTIONS(2478),
  },
  [542] = {
    [sym_parenthesized_expression] = STATE(829),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_identifier] = ACTIONS(2484),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [anon_sym_debugger] = ACTIONS(2484),
    [anon_sym_symbol] = ACTIONS(2484),
    [anon_sym_AT] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [sym_super] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_private] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_get] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_interface] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [anon_sym_delete] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2484),
    [sym_this] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2484),
    [sym_true] = ACTIONS(2484),
    [anon_sym_throw] = ACTIONS(2484),
    [anon_sym_protected] = ACTIONS(2484),
    [anon_sym_abstract] = ACTIONS(2484),
    [anon_sym_set] = ACTIONS(2484),
    [anon_sym_type] = ACTIONS(2484),
    [anon_sym_import] = ACTIONS(2484),
    [anon_sym_namespace] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [sym_false] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_case] = ACTIONS(2484),
    [anon_sym_module] = ACTIONS(2484),
    [anon_sym_number] = ACTIONS(2484),
    [anon_sym_class] = ACTIONS(2484),
    [anon_sym_declare] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_switch] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [sym_null] = ACTIONS(2484),
    [anon_sym_any] = ACTIONS(2484),
    [anon_sym_boolean] = ACTIONS(2484),
    [anon_sym_async] = ACTIONS(2484),
    [anon_sym_public] = ACTIONS(2484),
    [anon_sym_var] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2486),
    [sym_number] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2484),
    [anon_sym_function] = ACTIONS(2484),
    [sym_undefined] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2484),
    [ts_builtin_sym_end] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_export] = ACTIONS(2484),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_with] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2484),
  },
  [544] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [545] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [546] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [547] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [548] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [549] = {
    [sym__automatic_semicolon] = ACTIONS(2495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2495),
  },
  [550] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2495),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [551] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2497),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [552] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2499),
    [anon_sym_LBRACK] = ACTIONS(2499),
    [sym__automatic_semicolon] = ACTIONS(2499),
    [anon_sym_SEMI] = ACTIONS(2499),
    [anon_sym_BQUOTE] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_COMMA] = ACTIONS(2499),
    [anon_sym_LT_LT] = ACTIONS(2499),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_GT_GT_GT] = ACTIONS(2499),
    [anon_sym_AMP_AMP] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2501),
    [anon_sym_BANG_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2499),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_GT_EQ] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2501),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_QMARK] = ACTIONS(2499),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [anon_sym_as] = ACTIONS(2499),
    [anon_sym_PIPE_PIPE] = ACTIONS(2499),
    [anon_sym_DASH_DASH] = ACTIONS(2499),
    [anon_sym_EQ_EQ] = ACTIONS(2501),
    [anon_sym_instanceof] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2499),
    [anon_sym_CARET] = ACTIONS(2499),
    [anon_sym_STAR_STAR] = ACTIONS(2499),
    [anon_sym_PLUS] = ACTIONS(2501),
    [anon_sym_GT_GT] = ACTIONS(2501),
    [anon_sym_PLUS_PLUS] = ACTIONS(2499),
    [anon_sym_in] = ACTIONS(2501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
  },
  [553] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2499),
    [anon_sym_LBRACK] = ACTIONS(2499),
    [sym__automatic_semicolon] = ACTIONS(2499),
    [anon_sym_SEMI] = ACTIONS(2499),
    [anon_sym_BQUOTE] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_COMMA] = ACTIONS(2499),
    [anon_sym_LT_LT] = ACTIONS(2499),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_GT_GT_GT] = ACTIONS(2499),
    [anon_sym_AMP_AMP] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2501),
    [anon_sym_BANG_EQ] = ACTIONS(2501),
    [anon_sym_LT_EQ] = ACTIONS(2499),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_GT_EQ] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2501),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_QMARK] = ACTIONS(2499),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [anon_sym_as] = ACTIONS(2499),
    [anon_sym_PIPE_PIPE] = ACTIONS(2499),
    [anon_sym_DASH_DASH] = ACTIONS(2499),
    [anon_sym_EQ_EQ] = ACTIONS(2501),
    [anon_sym_instanceof] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2499),
    [anon_sym_CARET] = ACTIONS(2499),
    [anon_sym_STAR_STAR] = ACTIONS(2499),
    [anon_sym_PLUS] = ACTIONS(2501),
    [anon_sym_GT_GT] = ACTIONS(2501),
    [anon_sym_PLUS_PLUS] = ACTIONS(2499),
    [anon_sym_in] = ACTIONS(2501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2501),
  },
  [554] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(2509),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2503),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [555] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [556] = {
    [sym_await_expression] = STATE(141),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(141),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(141),
    [sym_function_type] = STATE(627),
    [sym__expression] = STATE(141),
    [sym_jsx_element] = STATE(141),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(141),
    [sym_call_expression] = STATE(141),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(141),
    [sym_template_string] = STATE(141),
    [sym_yield_expression] = STATE(141),
    [sym_jsx_fragment] = STATE(141),
    [sym_new_expression] = STATE(141),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(141),
    [sym_binary_expression] = STATE(141),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(627),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(141),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(141),
    [sym_jsx_self_closing_element] = STATE(141),
    [sym_arrow_function] = STATE(141),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(627),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(627),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_spread_element] = STATE(142),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1749),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(141),
    [sym_constructor_type] = STATE(627),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(141),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(141),
    [sym_regex] = STATE(141),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(143),
    [sym_non_null_expression] = STATE(141),
    [sym_class] = STATE(141),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(2526),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(2532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(305),
    [sym_null] = ACTIONS(283),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2538),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(283),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [557] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [558] = {
    [sym_await_expression] = STATE(93),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_ternary_expression] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_yield_expression] = STATE(93),
    [sym_jsx_fragment] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(93),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(93),
    [sym_class] = STATE(93),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [559] = {
    [sym_class] = STATE(91),
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym__expression] = STATE(91),
    [sym_jsx_element] = STATE(91),
    [sym_function] = STATE(52),
    [sym_import] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(91),
    [sym_string] = STATE(91),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(91),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(91),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_new_expression] = STATE(91),
    [sym_assignment_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(91),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_jsx_self_closing_element] = STATE(91),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(153),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(153),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(153),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(153),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [560] = {
    [sym_construct_signature] = STATE(623),
    [sym_pair] = STATE(184),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(623),
    [sym__call_signature] = STATE(623),
    [sym_spread_element] = STATE(184),
    [sym_property_signature] = STATE(623),
    [sym_type_parameters] = STATE(1868),
    [sym_decorator] = STATE(63),
    [sym_string] = STATE(842),
    [sym_formal_parameters] = STATE(1306),
    [sym_index_signature] = STATE(623),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(623),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(184),
    [sym_assignment_pattern] = STATE(184),
    [sym_array] = STATE(308),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_module] = ACTIONS(2552),
    [anon_sym_symbol] = ACTIONS(2552),
    [anon_sym_number] = ACTIONS(2552),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(2552),
    [anon_sym_private] = ACTIONS(2560),
    [anon_sym_boolean] = ACTIONS(2552),
    [anon_sym_async] = ACTIONS(2562),
    [anon_sym_public] = ACTIONS(2560),
    [anon_sym_get] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2560),
    [anon_sym_string] = ACTIONS(2552),
    [anon_sym_set] = ACTIONS(2564),
    [anon_sym_type] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(2572),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [561] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [562] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(205),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(205),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(205),
    [sym_function_type] = STATE(638),
    [sym__expression] = STATE(205),
    [sym_jsx_element] = STATE(205),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(205),
    [sym_call_expression] = STATE(205),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(205),
    [sym_template_string] = STATE(205),
    [sym_yield_expression] = STATE(205),
    [sym_jsx_fragment] = STATE(205),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(205),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(205),
    [sym_binary_expression] = STATE(205),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(638),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(205),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(205),
    [sym_jsx_self_closing_element] = STATE(205),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(205),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_sequence_expression] = STATE(204),
    [sym_intersection_type] = STATE(638),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(638),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1813),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(205),
    [sym_constructor_type] = STATE(638),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(205),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(205),
    [sym_regex] = STATE(205),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(205),
    [sym_class] = STATE(205),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(2582),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2584),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(411),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(411),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(421),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [563] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [564] = {
    [sym_class] = STATE(232),
    [sym_arrow_function] = STATE(232),
    [sym_await_expression] = STATE(239),
    [sym_member_expression] = STATE(238),
    [sym_update_expression] = STATE(239),
    [sym_meta_property] = STATE(232),
    [sym__expression] = STATE(239),
    [sym_jsx_element] = STATE(239),
    [sym_function] = STATE(240),
    [sym_import] = STATE(232),
    [sym_call_expression] = STATE(239),
    [sym_subscript_expression] = STATE(238),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(239),
    [sym_string] = STATE(232),
    [sym_type_parameters] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(232),
    [sym_formal_parameters] = STATE(848),
    [sym_yield_expression] = STATE(239),
    [sym_object] = STATE(241),
    [sym_jsx_fragment] = STATE(239),
    [sym_generator_function] = STATE(232),
    [sym_new_expression] = STATE(232),
    [sym_assignment_expression] = STATE(239),
    [sym_augmented_assignment_expression] = STATE(239),
    [sym_binary_expression] = STATE(239),
    [sym_unary_expression] = STATE(239),
    [sym_regex] = STATE(232),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(238),
    [sym_non_null_expression] = STATE(239),
    [sym_array] = STATE(242),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(239),
    [sym_internal_module] = STATE(239),
    [sym_jsx_self_closing_element] = STATE(239),
    [sym_identifier] = ACTIONS(471),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(473),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(477),
    [sym_super] = ACTIONS(479),
    [anon_sym_private] = ACTIONS(473),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_get] = ACTIONS(473),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(485),
    [anon_sym_protected] = ACTIONS(473),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(473),
    [anon_sym_type] = ACTIONS(473),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(485),
    [anon_sym_module] = ACTIONS(473),
    [anon_sym_number] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(473),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(473),
    [anon_sym_boolean] = ACTIONS(473),
    [anon_sym_async] = ACTIONS(495),
    [anon_sym_public] = ACTIONS(473),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(497),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(473),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [565] = {
    [sym_formal_parameters] = STATE(849),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_type_annotation] = STATE(275),
    [anon_sym_EQ_GT] = ACTIONS(2600),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [568] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2603),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [569] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(2556),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_expression] = STATE(516),
    [sym_type_arguments] = STATE(518),
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [570] = {
    [sym_nested_identifier] = STATE(852),
    [sym_jsx_namespace_name] = STATE(853),
    [sym_identifier] = ACTIONS(2607),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(2609),
  },
  [571] = {
    [sym_jsx_text] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2611),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(2611),
  },
  [572] = {
    [anon_sym_RBRACE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
  },
  [573] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [574] = {
    [sym_jsx_element] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_expression] = STATE(574),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2618),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(2621),
  },
  [575] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [sym__automatic_semicolon] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2624),
    [anon_sym_BQUOTE] = ACTIONS(2624),
    [anon_sym_PIPE] = ACTIONS(2626),
    [anon_sym_COMMA] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_GT_GT_GT] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_GT_EQ] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_RBRACE] = ACTIONS(2624),
    [anon_sym_as] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2626),
    [anon_sym_instanceof] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_STAR_STAR] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_PLUS_PLUS] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2626),
  },
  [576] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [sym__automatic_semicolon] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(2628),
    [anon_sym_PIPE] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_GT_GT_GT] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_GT_EQ] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2630),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_as] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2630),
    [anon_sym_instanceof] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_STAR_STAR] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
  },
  [577] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [578] = {
    [anon_sym_EQ_GT] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2632),
  },
  [579] = {
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2634),
  },
  [580] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [581] = {
    [sym_class] = STATE(856),
    [sym_arrow_function] = STATE(856),
    [sym_await_expression] = STATE(856),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(856),
    [sym_meta_property] = STATE(856),
    [sym__expression] = STATE(856),
    [sym_jsx_element] = STATE(856),
    [sym_function] = STATE(52),
    [sym_import] = STATE(856),
    [sym_call_expression] = STATE(856),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(856),
    [sym_string] = STATE(856),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(856),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(856),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(856),
    [sym_generator_function] = STATE(856),
    [sym_new_expression] = STATE(856),
    [sym_assignment_expression] = STATE(856),
    [sym_augmented_assignment_expression] = STATE(856),
    [sym_binary_expression] = STATE(856),
    [sym_unary_expression] = STATE(856),
    [sym_regex] = STATE(856),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(856),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(856),
    [sym_internal_module] = STATE(856),
    [sym_jsx_self_closing_element] = STATE(856),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(2640),
    [anon_sym_yield] = ACTIONS(1372),
    [sym_true] = ACTIONS(2640),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2640),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2642),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_await] = ACTIONS(1384),
  },
  [582] = {
    [sym_identifier] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [anon_sym_debugger] = ACTIONS(2644),
    [anon_sym_symbol] = ACTIONS(2644),
    [anon_sym_AT] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_void] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [sym_super] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_private] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_get] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_interface] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_delete] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_if] = ACTIONS(2644),
    [sym_this] = ACTIONS(2644),
    [anon_sym_yield] = ACTIONS(2644),
    [sym_true] = ACTIONS(2644),
    [anon_sym_throw] = ACTIONS(2644),
    [anon_sym_protected] = ACTIONS(2644),
    [anon_sym_abstract] = ACTIONS(2644),
    [anon_sym_set] = ACTIONS(2644),
    [anon_sym_type] = ACTIONS(2644),
    [anon_sym_import] = ACTIONS(2644),
    [anon_sym_namespace] = ACTIONS(2644),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [sym_false] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_number] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_declare] = ACTIONS(2644),
    [anon_sym_typeof] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_switch] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [sym_null] = ACTIONS(2644),
    [anon_sym_any] = ACTIONS(2644),
    [anon_sym_boolean] = ACTIONS(2644),
    [anon_sym_async] = ACTIONS(2644),
    [anon_sym_public] = ACTIONS(2644),
    [anon_sym_var] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [anon_sym_try] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2646),
    [sym_number] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2644),
    [anon_sym_function] = ACTIONS(2644),
    [sym_undefined] = ACTIONS(2644),
    [anon_sym_new] = ACTIONS(2644),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_let] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_export] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2646),
    [anon_sym_with] = ACTIONS(2644),
    [anon_sym_await] = ACTIONS(2644),
  },
  [583] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(858),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(857),
    [sym_type_parameters] = STATE(859),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [584] = {
    [sym_class_body] = STATE(860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [585] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(861),
    [sym_class_heritage] = STATE(862),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [586] = {
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2648),
    [sym_escape_sequence] = ACTIONS(2648),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym__template_chars] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [anon_sym_LBRACK] = ACTIONS(2650),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_module] = ACTIONS(2652),
    [anon_sym_symbol] = ACTIONS(2652),
    [anon_sym_number] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_AT] = ACTIONS(2650),
    [anon_sym_declare] = ACTIONS(2652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_void] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(2650),
    [anon_sym_any] = ACTIONS(2652),
    [anon_sym_private] = ACTIONS(2652),
    [anon_sym_boolean] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_async] = ACTIONS(2652),
    [anon_sym_get] = ACTIONS(2652),
    [anon_sym_public] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [sym_this] = ACTIONS(2652),
    [sym_number] = ACTIONS(2650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2652),
    [anon_sym_string] = ACTIONS(2652),
    [anon_sym_abstract] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_set] = ACTIONS(2652),
    [anon_sym_type] = ACTIONS(2652),
    [anon_sym_export] = ACTIONS(2652),
    [sym_readonly] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2650),
  },
  [588] = {
    [anon_sym_LBRACK] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_module] = ACTIONS(2656),
    [anon_sym_symbol] = ACTIONS(2656),
    [anon_sym_number] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2656),
    [anon_sym_private] = ACTIONS(2656),
    [anon_sym_boolean] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_get] = ACTIONS(2656),
    [anon_sym_public] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [sym_this] = ACTIONS(2656),
    [sym_number] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2656),
    [anon_sym_string] = ACTIONS(2656),
    [anon_sym_abstract] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2656),
    [anon_sym_set] = ACTIONS(2656),
    [anon_sym_type] = ACTIONS(2656),
    [anon_sym_export] = ACTIONS(2656),
    [sym_readonly] = ACTIONS(2656),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_DQUOTE] = ACTIONS(2654),
  },
  [589] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2115),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [anon_sym_PIPE] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2115),
    [anon_sym_AMP_AMP] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2123),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_GT_EQ] = ACTIONS(2115),
    [anon_sym_GT] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_QMARK] = ACTIONS(2115),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_as] = ACTIONS(2115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2115),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_instanceof] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2123),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2115),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_STAR_STAR] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2123),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2115),
    [anon_sym_BANG] = ACTIONS(2123),
  },
  [590] = {
    [sym_class_body] = STATE(863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [591] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(864),
    [sym_class_heritage] = STATE(865),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [592] = {
    [sym_class] = STATE(866),
    [sym_arrow_function] = STATE(866),
    [sym_await_expression] = STATE(866),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(866),
    [sym_meta_property] = STATE(866),
    [sym__expression] = STATE(866),
    [sym_jsx_element] = STATE(866),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(866),
    [sym_call_expression] = STATE(866),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(866),
    [sym_string] = STATE(866),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(866),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(866),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(866),
    [sym_generator_function] = STATE(866),
    [sym_new_expression] = STATE(866),
    [sym_assignment_expression] = STATE(866),
    [sym_augmented_assignment_expression] = STATE(866),
    [sym_binary_expression] = STATE(866),
    [sym_unary_expression] = STATE(866),
    [sym_regex] = STATE(866),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(866),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(866),
    [sym_internal_module] = STATE(866),
    [sym_jsx_self_closing_element] = STATE(866),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2658),
    [sym_number] = ACTIONS(2660),
    [sym_true] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2658),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [593] = {
    [sym_class] = STATE(867),
    [sym_arrow_function] = STATE(867),
    [sym_await_expression] = STATE(867),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(867),
    [sym_meta_property] = STATE(867),
    [sym__expression] = STATE(867),
    [sym_jsx_element] = STATE(867),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(867),
    [sym_call_expression] = STATE(867),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(867),
    [sym_string] = STATE(867),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(867),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(867),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(867),
    [sym_generator_function] = STATE(867),
    [sym_new_expression] = STATE(867),
    [sym_assignment_expression] = STATE(867),
    [sym_augmented_assignment_expression] = STATE(867),
    [sym_binary_expression] = STATE(867),
    [sym_unary_expression] = STATE(867),
    [sym_regex] = STATE(867),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(867),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(867),
    [sym_internal_module] = STATE(867),
    [sym_jsx_self_closing_element] = STATE(867),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2662),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2662),
    [sym_number] = ACTIONS(2664),
    [sym_true] = ACTIONS(2662),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2662),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [594] = {
    [sym_class] = STATE(868),
    [sym_arrow_function] = STATE(868),
    [sym_await_expression] = STATE(868),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(868),
    [sym_meta_property] = STATE(868),
    [sym__expression] = STATE(868),
    [sym_jsx_element] = STATE(868),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(868),
    [sym_call_expression] = STATE(868),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(868),
    [sym_string] = STATE(868),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(868),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(868),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(868),
    [sym_generator_function] = STATE(868),
    [sym_new_expression] = STATE(868),
    [sym_assignment_expression] = STATE(868),
    [sym_augmented_assignment_expression] = STATE(868),
    [sym_binary_expression] = STATE(868),
    [sym_unary_expression] = STATE(868),
    [sym_regex] = STATE(868),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(868),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(868),
    [sym_internal_module] = STATE(868),
    [sym_jsx_self_closing_element] = STATE(868),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2666),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2666),
    [sym_number] = ACTIONS(2668),
    [sym_true] = ACTIONS(2666),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2666),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [595] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(869),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(786),
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [597] = {
    [sym_statement_block] = STATE(871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [598] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(872),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(874),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(873),
    [sym_type_parameters] = STATE(875),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [600] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2672),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [601] = {
    [sym__automatic_semicolon] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_COMMA] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2676),
    [anon_sym_BQUOTE] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2676),
    [anon_sym_symbol] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_void] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [sym_super] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_get] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_yield] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_abstract] = ACTIONS(2676),
    [anon_sym_set] = ACTIONS(2676),
    [anon_sym_type] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [anon_sym_else] = ACTIONS(2676),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [sym_false] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_number] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_declare] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_LPAREN] = ACTIONS(2678),
    [sym_null] = ACTIONS(2676),
    [anon_sym_any] = ACTIONS(2676),
    [anon_sym_boolean] = ACTIONS(2676),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_var] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_LT] = ACTIONS(2678),
    [sym_number] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(2676),
    [sym_undefined] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [ts_builtin_sym_end] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2676),
    [anon_sym_await] = ACTIONS(2676),
  },
  [603] = {
    [sym__automatic_semicolon] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_COMMA] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
  },
  [604] = {
    [sym__automatic_semicolon] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_COMMA] = ACTIONS(2682),
    [sym_comment] = ACTIONS(3),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2684),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [anon_sym_debugger] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_void] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [sym_super] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_interface] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2684),
    [sym_this] = ACTIONS(2684),
    [anon_sym_yield] = ACTIONS(2684),
    [sym_true] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_abstract] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_import] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [anon_sym_else] = ACTIONS(2684),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2686),
    [sym_false] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_typeof] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [sym_null] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_var] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_LT] = ACTIONS(2686),
    [sym_number] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_function] = ACTIONS(2684),
    [sym_undefined] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [ts_builtin_sym_end] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_with] = ACTIONS(2684),
    [anon_sym_await] = ACTIONS(2684),
  },
  [606] = {
    [aux_sym_variable_declaration_repeat1] = STATE(606),
    [sym__automatic_semicolon] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_COMMA] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
  },
  [607] = {
    [sym__automatic_semicolon] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym_COMMA] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
  },
  [608] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2693),
    [sym__automatic_semicolon] = ACTIONS(2693),
    [anon_sym_BQUOTE] = ACTIONS(2693),
    [anon_sym_PERCENT_EQ] = ACTIONS(2693),
    [anon_sym_AMP_EQ] = ACTIONS(2693),
    [anon_sym_PLUS_EQ] = ACTIONS(2693),
    [anon_sym_PIPE] = ACTIONS(2695),
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_GT_GT_GT] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(2695),
    [anon_sym_BANG_EQ] = ACTIONS(2695),
    [anon_sym_GT_EQ] = ACTIONS(2693),
    [anon_sym_CARET_EQ] = ACTIONS(2693),
    [anon_sym_PIPE_EQ] = ACTIONS(2693),
    [anon_sym_DASH_EQ] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2695),
    [anon_sym_LT_LT_EQ] = ACTIONS(2693),
    [anon_sym_as] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_instanceof] = ACTIONS(2693),
    [anon_sym_GT_GT_EQ] = ACTIONS(2693),
    [anon_sym_DOT] = ACTIONS(2693),
    [anon_sym_STAR_STAR] = ACTIONS(2695),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2693),
    [anon_sym_LT_LT] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_of] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(2693),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_GT] = ACTIONS(2695),
    [anon_sym_STAR_EQ] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_QMARK] = ACTIONS(2693),
    [anon_sym_PIPE_PIPE] = ACTIONS(2693),
    [anon_sym_EQ_EQ] = ACTIONS(2695),
    [anon_sym_LT] = ACTIONS(2695),
    [anon_sym_SLASH] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2693),
    [anon_sym_CARET] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_GT_GT] = ACTIONS(2695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2693),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
  },
  [610] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(877),
    [sym_function_type] = STATE(877),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(877),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(877),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(877),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [611] = {
    [anon_sym_BQUOTE] = ACTIONS(2699),
    [anon_sym_symbol] = ACTIONS(2701),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_interface] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_yield] = ACTIONS(2701),
    [sym_true] = ACTIONS(2701),
    [anon_sym_protected] = ACTIONS(2701),
    [anon_sym_set] = ACTIONS(2701),
    [anon_sym_import] = ACTIONS(2701),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_number] = ACTIONS(2701),
    [anon_sym_typeof] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_RBRACK] = ACTIONS(2699),
    [sym_null] = ACTIONS(2701),
    [anon_sym_any] = ACTIONS(2701),
    [anon_sym_async] = ACTIONS(2701),
    [anon_sym_public] = ACTIONS(2701),
    [anon_sym_var] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_RPAREN] = ACTIONS(2699),
    [anon_sym_SLASH] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_export] = ACTIONS(2701),
    [anon_sym_with] = ACTIONS(2701),
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_debugger] = ACTIONS(2701),
    [anon_sym_AT] = ACTIONS(2699),
    [anon_sym_COMMA] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_EQ] = ACTIONS(2701),
    [anon_sym_void] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [sym_super] = ACTIONS(2701),
    [anon_sym_private] = ACTIONS(2701),
    [anon_sym_get] = ACTIONS(2701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2699),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [sym_this] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_abstract] = ACTIONS(2701),
    [anon_sym_type] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [sym_false] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_module] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_declare] = ACTIONS(2701),
    [anon_sym_LPAREN] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_boolean] = ACTIONS(2701),
    [anon_sym_EQ_GT] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_LT] = ACTIONS(2699),
    [sym_number] = ACTIONS(2699),
    [ts_builtin_sym_end] = ACTIONS(2699),
    [anon_sym_function] = ACTIONS(2701),
    [sym_undefined] = ACTIONS(2701),
    [anon_sym_let] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_implements] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_await] = ACTIONS(2701),
  },
  [612] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(638),
    [sym_function_type] = STATE(638),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(638),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(638),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(638),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [613] = {
    [anon_sym_BQUOTE] = ACTIONS(2703),
    [anon_sym_symbol] = ACTIONS(2705),
    [anon_sym_PIPE] = ACTIONS(2703),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_interface] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_yield] = ACTIONS(2705),
    [sym_true] = ACTIONS(2705),
    [anon_sym_protected] = ACTIONS(2705),
    [anon_sym_set] = ACTIONS(2705),
    [anon_sym_import] = ACTIONS(2705),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_number] = ACTIONS(2705),
    [anon_sym_typeof] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_RBRACK] = ACTIONS(2703),
    [sym_null] = ACTIONS(2705),
    [anon_sym_any] = ACTIONS(2705),
    [anon_sym_async] = ACTIONS(2705),
    [anon_sym_public] = ACTIONS(2705),
    [anon_sym_var] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_RPAREN] = ACTIONS(2703),
    [anon_sym_SLASH] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_export] = ACTIONS(2705),
    [anon_sym_with] = ACTIONS(2705),
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_debugger] = ACTIONS(2705),
    [anon_sym_AT] = ACTIONS(2703),
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_EQ] = ACTIONS(2705),
    [anon_sym_void] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [sym_super] = ACTIONS(2705),
    [anon_sym_private] = ACTIONS(2705),
    [anon_sym_get] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [sym_this] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_abstract] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [sym_false] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_module] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_declare] = ACTIONS(2705),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_GT] = ACTIONS(2703),
    [anon_sym_boolean] = ACTIONS(2705),
    [anon_sym_EQ_GT] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_LT] = ACTIONS(2703),
    [sym_number] = ACTIONS(2703),
    [ts_builtin_sym_end] = ACTIONS(2703),
    [anon_sym_function] = ACTIONS(2705),
    [sym_undefined] = ACTIONS(2705),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_await] = ACTIONS(2705),
  },
  [614] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(878),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(878),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(878),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(878),
    [sym_property_signature] = STATE(878),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(878),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_namespace] = ACTIONS(968),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [615] = {
    [sym_string] = STATE(879),
    [sym__property_name] = STATE(879),
    [sym_computed_property_name] = STATE(879),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [616] = {
    [sym_string] = STATE(879),
    [sym__property_name] = STATE(879),
    [sym_computed_property_name] = STATE(879),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(2711),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [617] = {
    [sym_string] = STATE(879),
    [sym__property_name] = STATE(879),
    [sym_computed_property_name] = STATE(879),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [618] = {
    [sym_string] = STATE(884),
    [sym__property_name] = STATE(884),
    [sym_computed_property_name] = STATE(884),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2709),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_get] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(2715),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [619] = {
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [anon_sym_symbol] = ACTIONS(2723),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_interface] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_yield] = ACTIONS(2723),
    [sym_true] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_set] = ACTIONS(2723),
    [anon_sym_import] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2721),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_number] = ACTIONS(2723),
    [anon_sym_typeof] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_RBRACK] = ACTIONS(2721),
    [sym_null] = ACTIONS(2723),
    [anon_sym_any] = ACTIONS(2723),
    [anon_sym_async] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_var] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_SQUOTE] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_export] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_debugger] = ACTIONS(2723),
    [anon_sym_AT] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2723),
    [anon_sym_void] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [sym_super] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_get] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [sym_this] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_abstract] = ACTIONS(2723),
    [anon_sym_type] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [sym_false] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_module] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_declare] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_boolean] = ACTIONS(2723),
    [anon_sym_EQ_GT] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_LT] = ACTIONS(2721),
    [sym_number] = ACTIONS(2721),
    [ts_builtin_sym_end] = ACTIONS(2721),
    [anon_sym_function] = ACTIONS(2723),
    [sym_undefined] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2721),
    [anon_sym_await] = ACTIONS(2723),
  },
  [620] = {
    [sym_formal_parameters] = STATE(885),
    [sym_type_parameters] = STATE(886),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [621] = {
    [sym_class_declaration] = STATE(1363),
    [sym_generator_function_declaration] = STATE(1363),
    [sym__declaration] = STATE(1363),
    [sym_enum_declaration] = STATE(1363),
    [sym_function_signature] = STATE(1363),
    [sym_abstract_class_declaration] = STATE(1363),
    [sym_module] = STATE(1363),
    [sym_interface_declaration] = STATE(1363),
    [sym_function_declaration] = STATE(1363),
    [sym_export_clause] = STATE(1921),
    [sym_variable_declaration] = STATE(1363),
    [sym_lexical_declaration] = STATE(1363),
    [sym_ambient_declaration] = STATE(1363),
    [sym_import_alias] = STATE(1363),
    [sym_type_alias_declaration] = STATE(1363),
    [aux_sym_export_statement_repeat1] = STATE(2782),
    [sym_internal_module] = STATE(1363),
    [sym_decorator] = STATE(63),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(2725),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(2733),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_var] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_as] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2759),
  },
  [622] = {
    [sym_string] = STATE(884),
    [sym__property_name] = STATE(884),
    [sym_computed_property_name] = STATE(884),
    [anon_sym_get] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(2715),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [623] = {
    [aux_sym_object_type_repeat1] = STATE(890),
    [sym__automatic_semicolon] = ACTIONS(2761),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2763),
    [anon_sym_COMMA] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
  },
  [625] = {
    [sym_string] = STATE(884),
    [sym__property_name] = STATE(884),
    [sym_computed_property_name] = STATE(884),
    [anon_sym_get] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(2715),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(2719),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(968),
  },
  [626] = {
    [sym__call_signature] = STATE(894),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(893),
    [sym__automatic_semicolon] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym_QMARK] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
  },
  [627] = {
    [aux_sym_implements_clause_repeat1] = STATE(896),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
  },
  [628] = {
    [anon_sym_BQUOTE] = ACTIONS(2775),
    [anon_sym_symbol] = ACTIONS(2777),
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2777),
    [anon_sym_static] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_interface] = ACTIONS(2777),
    [anon_sym_delete] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2777),
    [anon_sym_yield] = ACTIONS(2777),
    [sym_true] = ACTIONS(2777),
    [anon_sym_protected] = ACTIONS(2777),
    [anon_sym_set] = ACTIONS(2777),
    [anon_sym_import] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [anon_sym_for] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_number] = ACTIONS(2777),
    [anon_sym_typeof] = ACTIONS(2777),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_switch] = ACTIONS(2777),
    [anon_sym_RBRACK] = ACTIONS(2775),
    [sym_null] = ACTIONS(2777),
    [anon_sym_any] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(2777),
    [anon_sym_public] = ACTIONS(2777),
    [anon_sym_var] = ACTIONS(2777),
    [anon_sym_while] = ACTIONS(2777),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_SLASH] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(2777),
    [anon_sym_export] = ACTIONS(2777),
    [anon_sym_with] = ACTIONS(2777),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_debugger] = ACTIONS(2777),
    [anon_sym_AT] = ACTIONS(2775),
    [anon_sym_COMMA] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_void] = ACTIONS(2777),
    [anon_sym_const] = ACTIONS(2777),
    [sym_super] = ACTIONS(2777),
    [anon_sym_private] = ACTIONS(2777),
    [anon_sym_get] = ACTIONS(2777),
    [anon_sym_default] = ACTIONS(2777),
    [anon_sym_enum] = ACTIONS(2777),
    [anon_sym_continue] = ACTIONS(2777),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [sym_this] = ACTIONS(2777),
    [anon_sym_throw] = ACTIONS(2777),
    [anon_sym_abstract] = ACTIONS(2777),
    [anon_sym_type] = ACTIONS(2777),
    [anon_sym_namespace] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_else] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [sym_false] = ACTIONS(2777),
    [anon_sym_case] = ACTIONS(2777),
    [anon_sym_module] = ACTIONS(2777),
    [anon_sym_class] = ACTIONS(2777),
    [anon_sym_declare] = ACTIONS(2777),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_boolean] = ACTIONS(2777),
    [anon_sym_EQ_GT] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_try] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2775),
    [sym_number] = ACTIONS(2775),
    [ts_builtin_sym_end] = ACTIONS(2775),
    [anon_sym_function] = ACTIONS(2777),
    [sym_undefined] = ACTIONS(2777),
    [anon_sym_let] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_do] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2777),
  },
  [629] = {
    [anon_sym_BQUOTE] = ACTIONS(2779),
    [anon_sym_symbol] = ACTIONS(2781),
    [anon_sym_PIPE] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2781),
    [anon_sym_return] = ACTIONS(2781),
    [anon_sym_static] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_interface] = ACTIONS(2781),
    [anon_sym_delete] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2781),
    [anon_sym_yield] = ACTIONS(2781),
    [sym_true] = ACTIONS(2781),
    [anon_sym_protected] = ACTIONS(2781),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_set] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_number] = ACTIONS(2781),
    [anon_sym_typeof] = ACTIONS(2781),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2781),
    [anon_sym_RBRACK] = ACTIONS(2779),
    [sym_null] = ACTIONS(2781),
    [anon_sym_any] = ACTIONS(2781),
    [anon_sym_async] = ACTIONS(2781),
    [anon_sym_public] = ACTIONS(2781),
    [anon_sym_var] = ACTIONS(2781),
    [anon_sym_while] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2779),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_SLASH] = ACTIONS(2781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2781),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_export] = ACTIONS(2781),
    [anon_sym_with] = ACTIONS(2781),
    [sym_identifier] = ACTIONS(2781),
    [anon_sym_debugger] = ACTIONS(2781),
    [anon_sym_AT] = ACTIONS(2779),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2781),
    [anon_sym_EQ] = ACTIONS(2781),
    [anon_sym_void] = ACTIONS(2781),
    [anon_sym_const] = ACTIONS(2781),
    [sym_super] = ACTIONS(2781),
    [anon_sym_private] = ACTIONS(2781),
    [anon_sym_get] = ACTIONS(2781),
    [anon_sym_default] = ACTIONS(2781),
    [anon_sym_enum] = ACTIONS(2781),
    [anon_sym_continue] = ACTIONS(2781),
    [anon_sym_DASH_DASH] = ACTIONS(2779),
    [sym_this] = ACTIONS(2781),
    [anon_sym_throw] = ACTIONS(2781),
    [anon_sym_abstract] = ACTIONS(2781),
    [anon_sym_type] = ACTIONS(2781),
    [anon_sym_namespace] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [sym_false] = ACTIONS(2781),
    [anon_sym_case] = ACTIONS(2781),
    [anon_sym_module] = ACTIONS(2781),
    [anon_sym_class] = ACTIONS(2781),
    [anon_sym_declare] = ACTIONS(2781),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_GT] = ACTIONS(2779),
    [anon_sym_boolean] = ACTIONS(2781),
    [anon_sym_EQ_GT] = ACTIONS(2779),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2781),
    [anon_sym_LT] = ACTIONS(2779),
    [sym_number] = ACTIONS(2779),
    [ts_builtin_sym_end] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(2781),
    [sym_undefined] = ACTIONS(2781),
    [anon_sym_let] = ACTIONS(2781),
    [anon_sym_PLUS] = ACTIONS(2781),
    [anon_sym_do] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2779),
    [anon_sym_await] = ACTIONS(2781),
  },
  [630] = {
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [anon_sym_symbol] = ACTIONS(2787),
    [anon_sym_PIPE] = ACTIONS(2785),
    [anon_sym_break] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2787),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_interface] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_yield] = ACTIONS(2787),
    [sym_true] = ACTIONS(2787),
    [anon_sym_protected] = ACTIONS(2787),
    [anon_sym_set] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_number] = ACTIONS(2787),
    [anon_sym_typeof] = ACTIONS(2787),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_switch] = ACTIONS(2787),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [sym_null] = ACTIONS(2787),
    [anon_sym_any] = ACTIONS(2787),
    [anon_sym_async] = ACTIONS(2787),
    [anon_sym_public] = ACTIONS(2787),
    [anon_sym_var] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_SLASH] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2787),
    [anon_sym_new] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_with] = ACTIONS(2787),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_debugger] = ACTIONS(2787),
    [anon_sym_AT] = ACTIONS(2785),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2787),
    [anon_sym_void] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [sym_super] = ACTIONS(2787),
    [anon_sym_private] = ACTIONS(2787),
    [anon_sym_get] = ACTIONS(2787),
    [anon_sym_default] = ACTIONS(2787),
    [anon_sym_enum] = ACTIONS(2787),
    [anon_sym_continue] = ACTIONS(2787),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [sym_this] = ACTIONS(2787),
    [anon_sym_throw] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_type] = ACTIONS(2787),
    [anon_sym_namespace] = ACTIONS(2787),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_else] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [sym_false] = ACTIONS(2787),
    [anon_sym_case] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_GT] = ACTIONS(2785),
    [anon_sym_boolean] = ACTIONS(2787),
    [anon_sym_EQ_GT] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2785),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(2785),
    [sym_number] = ACTIONS(2785),
    [ts_builtin_sym_end] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2787),
    [sym_undefined] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_do] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_await] = ACTIONS(2787),
  },
  [631] = {
    [anon_sym_BQUOTE] = ACTIONS(2789),
    [anon_sym_symbol] = ACTIONS(2791),
    [anon_sym_PIPE] = ACTIONS(2789),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_interface] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_yield] = ACTIONS(2791),
    [sym_true] = ACTIONS(2791),
    [anon_sym_protected] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(2793),
    [anon_sym_set] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_number] = ACTIONS(2791),
    [anon_sym_typeof] = ACTIONS(2791),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_switch] = ACTIONS(2791),
    [anon_sym_RBRACK] = ACTIONS(2789),
    [sym_null] = ACTIONS(2791),
    [anon_sym_any] = ACTIONS(2791),
    [anon_sym_async] = ACTIONS(2791),
    [anon_sym_public] = ACTIONS(2791),
    [anon_sym_var] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_RPAREN] = ACTIONS(2789),
    [anon_sym_SLASH] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2791),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_debugger] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_void] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [sym_super] = ACTIONS(2791),
    [anon_sym_private] = ACTIONS(2791),
    [anon_sym_get] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [sym_this] = ACTIONS(2791),
    [anon_sym_throw] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_else] = ACTIONS(2791),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [sym_false] = ACTIONS(2791),
    [anon_sym_case] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2791),
    [anon_sym_declare] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2789),
    [anon_sym_boolean] = ACTIONS(2791),
    [anon_sym_EQ_GT] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_LT] = ACTIONS(2789),
    [sym_number] = ACTIONS(2789),
    [ts_builtin_sym_end] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2791),
    [sym_undefined] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2789),
    [anon_sym_await] = ACTIONS(2791),
  },
  [632] = {
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [anon_sym_symbol] = ACTIONS(2797),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_interface] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_yield] = ACTIONS(2797),
    [sym_true] = ACTIONS(2797),
    [anon_sym_protected] = ACTIONS(2797),
    [anon_sym_set] = ACTIONS(2797),
    [anon_sym_import] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_number] = ACTIONS(2797),
    [anon_sym_typeof] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2795),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_RBRACK] = ACTIONS(2795),
    [sym_null] = ACTIONS(2797),
    [anon_sym_any] = ACTIONS(2797),
    [anon_sym_async] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(2797),
    [anon_sym_var] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_SQUOTE] = ACTIONS(2795),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_export] = ACTIONS(2797),
    [anon_sym_with] = ACTIONS(2797),
    [sym_identifier] = ACTIONS(2797),
    [anon_sym_debugger] = ACTIONS(2797),
    [anon_sym_AT] = ACTIONS(2795),
    [anon_sym_COMMA] = ACTIONS(2795),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_EQ] = ACTIONS(2797),
    [anon_sym_void] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [sym_super] = ACTIONS(2797),
    [anon_sym_private] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2795),
    [sym_this] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_abstract] = ACTIONS(2797),
    [anon_sym_type] = ACTIONS(2797),
    [anon_sym_namespace] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2795),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [sym_false] = ACTIONS(2797),
    [anon_sym_case] = ACTIONS(2797),
    [anon_sym_module] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_declare] = ACTIONS(2797),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_GT] = ACTIONS(2795),
    [anon_sym_boolean] = ACTIONS(2797),
    [anon_sym_EQ_GT] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_LT] = ACTIONS(2795),
    [sym_number] = ACTIONS(2795),
    [ts_builtin_sym_end] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(2797),
    [sym_undefined] = ACTIONS(2797),
    [anon_sym_let] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2795),
    [anon_sym_await] = ACTIONS(2797),
  },
  [633] = {
    [anon_sym_EQ_GT] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
  },
  [634] = {
    [sym_formal_parameters] = STATE(898),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [635] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(1803),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_COMMA] = ACTIONS(2801),
    [anon_sym_LT] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(1799),
  },
  [636] = {
    [anon_sym_EQ] = ACTIONS(2322),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(1833),
    [anon_sym_QMARK] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(1833),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_PIPE] = ACTIONS(1833),
    [anon_sym_COMMA] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
  },
  [637] = {
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
  },
  [638] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RPAREN] = ACTIONS(2812),
    [anon_sym_PIPE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
  },
  [639] = {
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_PIPE] = ACTIONS(2814),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_RBRACK] = ACTIONS(2814),
    [sym_null] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_EQ] = ACTIONS(2816),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [sym_false] = ACTIONS(2816),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(2814),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_EQ_GT] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [ts_builtin_sym_end] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
  },
  [640] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(900),
    [sym_function_type] = STATE(900),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(900),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(900),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(900),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [641] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(902),
    [sym_function_type] = STATE(902),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(902),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(902),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(902),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_RBRACK] = ACTIONS(2818),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [642] = {
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_return] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2822),
    [anon_sym_delete] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2822),
    [anon_sym_yield] = ACTIONS(2822),
    [sym_true] = ACTIONS(2822),
    [anon_sym_protected] = ACTIONS(2822),
    [anon_sym_set] = ACTIONS(2822),
    [anon_sym_import] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2822),
    [anon_sym_typeof] = ACTIONS(2822),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_switch] = ACTIONS(2822),
    [anon_sym_RBRACK] = ACTIONS(2820),
    [sym_null] = ACTIONS(2822),
    [anon_sym_any] = ACTIONS(2822),
    [anon_sym_async] = ACTIONS(2822),
    [anon_sym_public] = ACTIONS(2822),
    [anon_sym_var] = ACTIONS(2822),
    [anon_sym_while] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2820),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_SLASH] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(2822),
    [anon_sym_export] = ACTIONS(2822),
    [anon_sym_with] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2822),
    [anon_sym_debugger] = ACTIONS(2822),
    [anon_sym_AT] = ACTIONS(2820),
    [anon_sym_COMMA] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_EQ] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [sym_super] = ACTIONS(2822),
    [anon_sym_private] = ACTIONS(2822),
    [anon_sym_get] = ACTIONS(2822),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_continue] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [sym_this] = ACTIONS(2822),
    [anon_sym_throw] = ACTIONS(2822),
    [anon_sym_abstract] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2822),
    [anon_sym_namespace] = ACTIONS(2822),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2822),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [sym_false] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2822),
    [anon_sym_module] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_declare] = ACTIONS(2822),
    [anon_sym_LPAREN] = ACTIONS(2820),
    [anon_sym_GT] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2822),
    [anon_sym_EQ_GT] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2820),
    [sym_number] = ACTIONS(2820),
    [ts_builtin_sym_end] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2822),
    [sym_undefined] = ACTIONS(2822),
    [anon_sym_let] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_implements] = ACTIONS(2822),
    [anon_sym_do] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_await] = ACTIONS(2822),
  },
  [643] = {
    [anon_sym_EQ_GT] = ACTIONS(2824),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2824),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_EQ] = ACTIONS(2826),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [sym_jsx_identifier] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2824),
  },
  [644] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(903),
    [sym_function_type] = STATE(903),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(903),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(903),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(903),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [645] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(904),
    [sym_function_type] = STATE(904),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(904),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(904),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(904),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [646] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [647] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_GT] = ACTIONS(2828),
    [anon_sym_COMMA] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [anon_sym_EQ_GT] = ACTIONS(2832),
    [sym_comment] = ACTIONS(3),
  },
  [649] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [sym__automatic_semicolon] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [anon_sym_PIPE] = ACTIONS(2836),
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_LT_LT] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_GT_GT_GT] = ACTIONS(2834),
    [anon_sym_AMP_AMP] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG_EQ] = ACTIONS(2836),
    [anon_sym_LT_EQ] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_GT_EQ] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_PERCENT] = ACTIONS(2834),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_PIPE_PIPE] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_EQ_EQ] = ACTIONS(2836),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2836),
    [anon_sym_SLASH] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_CARET] = ACTIONS(2834),
    [anon_sym_STAR_STAR] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_GT_GT] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2834),
    [anon_sym_BANG] = ACTIONS(2836),
  },
  [650] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(2838),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [anon_sym_debugger] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2840),
    [sym_this] = ACTIONS(2840),
    [anon_sym_yield] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [anon_sym_throw] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_abstract] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [sym_false] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2840),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [sym_null] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_var] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2840),
    [anon_sym_LT] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2840),
    [ts_builtin_sym_end] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_do] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_with] = ACTIONS(2840),
    [anon_sym_await] = ACTIONS(2840),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [anon_sym_debugger] = ACTIONS(2844),
    [anon_sym_symbol] = ACTIONS(2844),
    [anon_sym_AT] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_void] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_private] = ACTIONS(2844),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
    [anon_sym_delete] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_DASH_DASH] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2844),
    [sym_this] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [sym_true] = ACTIONS(2844),
    [anon_sym_throw] = ACTIONS(2844),
    [anon_sym_protected] = ACTIONS(2844),
    [anon_sym_abstract] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_import] = ACTIONS(2844),
    [anon_sym_namespace] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2846),
    [anon_sym_DQUOTE] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [sym_false] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2844),
    [anon_sym_module] = ACTIONS(2844),
    [anon_sym_number] = ACTIONS(2844),
    [anon_sym_class] = ACTIONS(2844),
    [anon_sym_declare] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [sym_null] = ACTIONS(2844),
    [anon_sym_any] = ACTIONS(2844),
    [anon_sym_boolean] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_public] = ACTIONS(2844),
    [anon_sym_var] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2844),
    [anon_sym_LT] = ACTIONS(2846),
    [sym_number] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2844),
    [anon_sym_function] = ACTIONS(2844),
    [sym_undefined] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2844),
    [ts_builtin_sym_end] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_do] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2846),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_await] = ACTIONS(2844),
  },
  [653] = {
    [sym_object_type] = STATE(911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(750),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [anon_sym_debugger] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_AT] = ACTIONS(2850),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_private] = ACTIONS(2848),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
    [anon_sym_delete] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_DASH_DASH] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2848),
    [sym_this] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [anon_sym_throw] = ACTIONS(2848),
    [anon_sym_protected] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_import] = ACTIONS(2848),
    [anon_sym_namespace] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [sym_false] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2848),
    [anon_sym_module] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_class] = ACTIONS(2848),
    [anon_sym_declare] = ACTIONS(2848),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [sym_null] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_public] = ACTIONS(2848),
    [anon_sym_var] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2848),
    [anon_sym_LT] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2848),
    [ts_builtin_sym_end] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_export] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2850),
    [anon_sym_with] = ACTIONS(2848),
    [anon_sym_await] = ACTIONS(2848),
  },
  [655] = {
    [sym__initializer] = STATE(914),
    [aux_sym_enum_body_repeat1] = STATE(915),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
  },
  [656] = {
    [aux_sym_enum_body_repeat1] = STATE(915),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
  },
  [657] = {
    [sym_generator_function_declaration] = STATE(916),
    [sym__declaration] = STATE(916),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(916),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(916),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(916),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(916),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(916),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(916),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(916),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(916),
    [sym_function_declaration] = STATE(916),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(916),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(916),
    [sym_break_statement] = STATE(916),
    [sym_labeled_statement] = STATE(916),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(916),
    [sym_class_declaration] = STATE(916),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(916),
    [sym_ambient_declaration] = STATE(916),
    [sym_type_alias_declaration] = STATE(916),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(916),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(916),
    [sym_switch_statement] = STATE(916),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(916),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(916),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(916),
    [sym_abstract_class_declaration] = STATE(916),
    [sym_interface_declaration] = STATE(916),
    [sym_export_statement] = STATE(916),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(916),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(916),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(916),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(916),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [658] = {
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_if] = ACTIONS(2856),
    [sym_this] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [sym_false] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [sym_null] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [ts_builtin_sym_end] = ACTIONS(2858),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_await] = ACTIONS(2856),
  },
  [659] = {
    [sym_class_body] = STATE(917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1919),
  },
  [660] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(918),
    [sym_class_heritage] = STATE(919),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1919),
  },
  [661] = {
    [sym__automatic_semicolon] = ACTIONS(2860),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(2860),
    [anon_sym_PIPE] = ACTIONS(2864),
    [sym_comment] = ACTIONS(3),
  },
  [662] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(921),
    [sym_function_type] = STATE(921),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(921),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(921),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(921),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [663] = {
    [anon_sym_from] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
  },
  [664] = {
    [anon_sym_LPAREN] = ACTIONS(2868),
    [sym_comment] = ACTIONS(3),
  },
  [665] = {
    [sym__automatic_semicolon] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_DOT] = ACTIONS(2872),
    [sym_comment] = ACTIONS(3),
  },
  [666] = {
    [anon_sym_require] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_BQUOTE] = ACTIONS(2878),
    [anon_sym_debugger] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_AT] = ACTIONS(2878),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_void] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_private] = ACTIONS(2876),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_interface] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [anon_sym_delete] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2876),
    [sym_this] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [anon_sym_throw] = ACTIONS(2876),
    [anon_sym_protected] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_import] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DQUOTE] = ACTIONS(2878),
    [anon_sym_else] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2878),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [sym_false] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_case] = ACTIONS(2876),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_class] = ACTIONS(2876),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_typeof] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [sym_null] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2876),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_SQUOTE] = ACTIONS(2878),
    [anon_sym_try] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2878),
    [sym_number] = ACTIONS(2878),
    [anon_sym_SLASH] = ACTIONS(2876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_function] = ACTIONS(2876),
    [sym_undefined] = ACTIONS(2876),
    [anon_sym_new] = ACTIONS(2876),
    [ts_builtin_sym_end] = ACTIONS(2878),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2876),
    [anon_sym_do] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2878),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_await] = ACTIONS(2876),
  },
  [668] = {
    [sym__automatic_semicolon] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
  },
  [669] = {
    [anon_sym_from] = ACTIONS(2882),
    [sym_comment] = ACTIONS(3),
  },
  [670] = {
    [sym_identifier] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_COMMA] = ACTIONS(2886),
    [anon_sym_as] = ACTIONS(2888),
    [sym_comment] = ACTIONS(3),
  },
  [672] = {
    [anon_sym_from] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
  },
  [673] = {
    [sym__import_export_specifier] = STATE(928),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [674] = {
    [anon_sym_from] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
  },
  [675] = {
    [aux_sym_named_imports_repeat1] = STATE(930),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
  },
  [676] = {
    [sym__automatic_semicolon] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2898),
  },
  [677] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2900),
    [sym__automatic_semicolon] = ACTIONS(2900),
    [anon_sym_BQUOTE] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2902),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2900),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_PERCENT] = ACTIONS(2900),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_as] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_instanceof] = ACTIONS(2902),
    [anon_sym_yield] = ACTIONS(2902),
    [sym_true] = ACTIONS(2902),
    [anon_sym_protected] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_set] = ACTIONS(2902),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2902),
    [anon_sym_typeof] = ACTIONS(2902),
    [anon_sym_LT_LT] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_LT_EQ] = ACTIONS(2900),
    [sym_null] = ACTIONS(2902),
    [anon_sym_any] = ACTIONS(2902),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_public] = ACTIONS(2902),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_CARET] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2902),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2900),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_debugger] = ACTIONS(2902),
    [anon_sym_AT] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_void] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_GT_EQ] = ACTIONS(2900),
    [sym_super] = ACTIONS(2902),
    [anon_sym_private] = ACTIONS(2902),
    [anon_sym_get] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [sym_this] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_abstract] = ACTIONS(2902),
    [anon_sym_type] = ACTIONS(2902),
    [anon_sym_STAR_STAR] = ACTIONS(2900),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [sym_false] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_module] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_declare] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_boolean] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2902),
    [sym_number] = ACTIONS(2900),
    [ts_builtin_sym_end] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2902),
    [sym_undefined] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_await] = ACTIONS(2902),
  },
  [678] = {
    [sym_class] = STATE(932),
    [sym_arrow_function] = STATE(932),
    [sym_await_expression] = STATE(932),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(932),
    [sym_sequence_expression] = STATE(931),
    [sym_meta_property] = STATE(932),
    [sym__expression] = STATE(932),
    [sym_jsx_element] = STATE(932),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(932),
    [sym_call_expression] = STATE(932),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(932),
    [sym_string] = STATE(932),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(932),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(932),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(932),
    [sym_generator_function] = STATE(932),
    [sym_new_expression] = STATE(932),
    [sym_assignment_expression] = STATE(932),
    [sym_augmented_assignment_expression] = STATE(932),
    [sym_binary_expression] = STATE(932),
    [sym_unary_expression] = STATE(932),
    [sym_regex] = STATE(932),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(932),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(932),
    [sym_internal_module] = STATE(932),
    [sym_jsx_self_closing_element] = STATE(932),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2904),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2904),
    [sym_number] = ACTIONS(2906),
    [sym_true] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [679] = {
    [sym_class] = STATE(934),
    [sym_arrow_function] = STATE(934),
    [sym_await_expression] = STATE(934),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(934),
    [sym_sequence_expression] = STATE(933),
    [sym_meta_property] = STATE(934),
    [sym__expression] = STATE(934),
    [sym_jsx_element] = STATE(934),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(934),
    [sym_call_expression] = STATE(934),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(934),
    [sym_string] = STATE(934),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(934),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(934),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(934),
    [sym_generator_function] = STATE(934),
    [sym_new_expression] = STATE(934),
    [sym_assignment_expression] = STATE(934),
    [sym_augmented_assignment_expression] = STATE(934),
    [sym_binary_expression] = STATE(934),
    [sym_unary_expression] = STATE(934),
    [sym_regex] = STATE(934),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(934),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(934),
    [sym_internal_module] = STATE(934),
    [sym_jsx_self_closing_element] = STATE(934),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2908),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2908),
    [sym_number] = ACTIONS(2910),
    [sym_true] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2908),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [680] = {
    [sym__initializer] = STATE(315),
    [sym_type_annotation] = STATE(316),
    [sym__automatic_semicolon] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2914),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [681] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_of] = ACTIONS(2921),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [682] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(499),
  },
  [683] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2930),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [684] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_of] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [685] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_of] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [686] = {
    [sym__initializer] = STATE(318),
    [sym_type_annotation] = STATE(319),
    [sym__automatic_semicolon] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2940),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [687] = {
    [sym__initializer] = STATE(323),
    [sym_type_annotation] = STATE(324),
    [sym__automatic_semicolon] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(728),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [688] = {
    [sym_await_expression] = STATE(944),
    [sym_update_expression] = STATE(944),
    [sym_meta_property] = STATE(944),
    [sym__expression] = STATE(944),
    [sym_jsx_element] = STATE(944),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(944),
    [sym_call_expression] = STATE(944),
    [sym_ternary_expression] = STATE(944),
    [sym_template_string] = STATE(944),
    [sym_yield_expression] = STATE(944),
    [sym_jsx_fragment] = STATE(944),
    [sym_new_expression] = STATE(944),
    [sym_assignment_expression] = STATE(944),
    [sym_binary_expression] = STATE(944),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(944),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(944),
    [sym_jsx_self_closing_element] = STATE(944),
    [sym_arrow_function] = STATE(944),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(943),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(944),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(944),
    [sym_augmented_assignment_expression] = STATE(944),
    [sym_unary_expression] = STATE(944),
    [sym_regex] = STATE(944),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(944),
    [sym_class] = STATE(944),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2950),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2950),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2950),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2950),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [689] = {
    [sym_class] = STATE(946),
    [sym_arrow_function] = STATE(946),
    [sym_await_expression] = STATE(946),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(946),
    [sym_sequence_expression] = STATE(945),
    [sym_meta_property] = STATE(946),
    [sym__expression] = STATE(946),
    [sym_jsx_element] = STATE(946),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(946),
    [sym_call_expression] = STATE(946),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(946),
    [sym_string] = STATE(946),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(946),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(946),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(946),
    [sym_generator_function] = STATE(946),
    [sym_new_expression] = STATE(946),
    [sym_assignment_expression] = STATE(946),
    [sym_augmented_assignment_expression] = STATE(946),
    [sym_binary_expression] = STATE(946),
    [sym_unary_expression] = STATE(946),
    [sym_regex] = STATE(946),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(946),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(946),
    [sym_internal_module] = STATE(946),
    [sym_jsx_self_closing_element] = STATE(946),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2956),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2956),
    [sym_number] = ACTIONS(2958),
    [sym_true] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2956),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [690] = {
    [sym_class] = STATE(948),
    [sym_arrow_function] = STATE(948),
    [sym_await_expression] = STATE(948),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(948),
    [sym_sequence_expression] = STATE(947),
    [sym_meta_property] = STATE(948),
    [sym__expression] = STATE(948),
    [sym_jsx_element] = STATE(948),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(948),
    [sym_call_expression] = STATE(948),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(948),
    [sym_string] = STATE(948),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(948),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(948),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(948),
    [sym_generator_function] = STATE(948),
    [sym_new_expression] = STATE(948),
    [sym_assignment_expression] = STATE(948),
    [sym_augmented_assignment_expression] = STATE(948),
    [sym_binary_expression] = STATE(948),
    [sym_unary_expression] = STATE(948),
    [sym_regex] = STATE(948),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(948),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(948),
    [sym_internal_module] = STATE(948),
    [sym_jsx_self_closing_element] = STATE(948),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2960),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2960),
    [sym_number] = ACTIONS(2962),
    [sym_true] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2960),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [691] = {
    [sym_class] = STATE(1920),
    [sym_arrow_function] = STATE(1920),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(685),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1920),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1920),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(685),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1920),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1920),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(950),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1920),
    [sym_new_expression] = STATE(1920),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1920),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(685),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(951),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(2964),
    [sym_false] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2021),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2017),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2017),
    [sym_number] = ACTIONS(2025),
    [sym_true] = ACTIONS(2017),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2017),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [692] = {
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_BQUOTE] = ACTIONS(2968),
    [anon_sym_debugger] = ACTIONS(2966),
    [anon_sym_symbol] = ACTIONS(2966),
    [anon_sym_AT] = ACTIONS(2968),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_void] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [sym_super] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_private] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_get] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_interface] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2966),
    [sym_this] = ACTIONS(2966),
    [anon_sym_yield] = ACTIONS(2966),
    [sym_true] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_protected] = ACTIONS(2966),
    [anon_sym_abstract] = ACTIONS(2966),
    [anon_sym_set] = ACTIONS(2966),
    [anon_sym_type] = ACTIONS(2966),
    [anon_sym_import] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [sym_false] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_module] = ACTIONS(2966),
    [anon_sym_number] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_declare] = ACTIONS(2966),
    [anon_sym_typeof] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2968),
    [sym_null] = ACTIONS(2966),
    [anon_sym_any] = ACTIONS(2966),
    [anon_sym_boolean] = ACTIONS(2966),
    [anon_sym_async] = ACTIONS(2966),
    [anon_sym_public] = ACTIONS(2966),
    [anon_sym_var] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_LT] = ACTIONS(2968),
    [sym_number] = ACTIONS(2968),
    [anon_sym_SLASH] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2966),
    [anon_sym_function] = ACTIONS(2966),
    [sym_undefined] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [ts_builtin_sym_end] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_await] = ACTIONS(2966),
  },
  [693] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2970),
    [sym__automatic_semicolon] = ACTIONS(2970),
    [anon_sym_BQUOTE] = ACTIONS(2970),
    [anon_sym_PIPE] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_GT_GT_GT] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_instanceof] = ACTIONS(2970),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_STAR_STAR] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_of] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
  },
  [694] = {
    [sym_class] = STATE(954),
    [sym_arrow_function] = STATE(954),
    [sym_await_expression] = STATE(954),
    [sym_member_expression] = STATE(2748),
    [sym_generic_type] = STATE(953),
    [sym_update_expression] = STATE(954),
    [sym_meta_property] = STATE(954),
    [sym__expression] = STATE(954),
    [sym_jsx_element] = STATE(954),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(955),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(954),
    [sym_call_expression] = STATE(954),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(954),
    [sym_string] = STATE(954),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(954),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(954),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(954),
    [sym_generator_function] = STATE(954),
    [sym_new_expression] = STATE(954),
    [sym_assignment_expression] = STATE(954),
    [sym_augmented_assignment_expression] = STATE(954),
    [sym_binary_expression] = STATE(954),
    [sym_unary_expression] = STATE(954),
    [sym_regex] = STATE(954),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(954),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(954),
    [sym_internal_module] = STATE(954),
    [sym_jsx_self_closing_element] = STATE(954),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(2974),
    [sym_false] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2976),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(2976),
    [sym_number] = ACTIONS(2978),
    [sym_true] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [695] = {
    [sym_identifier] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
  },
  [696] = {
    [aux_sym_extends_clause_repeat1] = STATE(957),
    [anon_sym_implements] = ACTIONS(2982),
    [anon_sym_COMMA] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2982),
  },
  [697] = {
    [aux_sym_extends_clause_repeat1] = STATE(957),
    [anon_sym_implements] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2984),
  },
  [698] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [699] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2986),
  },
  [700] = {
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [anon_sym_debugger] = ACTIONS(2988),
    [anon_sym_symbol] = ACTIONS(2988),
    [anon_sym_AT] = ACTIONS(2990),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_void] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2988),
    [sym_super] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_private] = ACTIONS(2988),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_get] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_interface] = ACTIONS(2988),
    [anon_sym_default] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2988),
    [anon_sym_delete] = ACTIONS(2988),
    [anon_sym_continue] = ACTIONS(2988),
    [anon_sym_DASH_DASH] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2988),
    [sym_this] = ACTIONS(2988),
    [anon_sym_yield] = ACTIONS(2988),
    [sym_true] = ACTIONS(2988),
    [anon_sym_throw] = ACTIONS(2988),
    [anon_sym_protected] = ACTIONS(2988),
    [anon_sym_abstract] = ACTIONS(2988),
    [anon_sym_set] = ACTIONS(2988),
    [anon_sym_type] = ACTIONS(2988),
    [anon_sym_import] = ACTIONS(2988),
    [anon_sym_namespace] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_else] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [sym_false] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2990),
    [anon_sym_case] = ACTIONS(2988),
    [anon_sym_module] = ACTIONS(2988),
    [anon_sym_number] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_declare] = ACTIONS(2988),
    [anon_sym_typeof] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_switch] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [sym_null] = ACTIONS(2988),
    [anon_sym_any] = ACTIONS(2988),
    [anon_sym_boolean] = ACTIONS(2988),
    [anon_sym_async] = ACTIONS(2988),
    [anon_sym_public] = ACTIONS(2988),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(2990),
    [sym_number] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2988),
    [anon_sym_function] = ACTIONS(2988),
    [sym_undefined] = ACTIONS(2988),
    [anon_sym_new] = ACTIONS(2988),
    [ts_builtin_sym_end] = ACTIONS(2990),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_export] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_await] = ACTIONS(2988),
  },
  [701] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2992),
    [sym__automatic_semicolon] = ACTIONS(2994),
    [anon_sym_BQUOTE] = ACTIONS(2996),
    [anon_sym_symbol] = ACTIONS(2998),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_GT_GT_GT] = ACTIONS(2992),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_BANG_EQ] = ACTIONS(3000),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_interface] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(3000),
    [anon_sym_delete] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_instanceof] = ACTIONS(3000),
    [anon_sym_yield] = ACTIONS(2998),
    [sym_true] = ACTIONS(2998),
    [anon_sym_protected] = ACTIONS(2998),
    [anon_sym_DOT] = ACTIONS(3000),
    [anon_sym_set] = ACTIONS(2998),
    [anon_sym_import] = ACTIONS(2998),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_number] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(2998),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_switch] = ACTIONS(2998),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [sym_null] = ACTIONS(2998),
    [anon_sym_any] = ACTIONS(2998),
    [anon_sym_async] = ACTIONS(2998),
    [anon_sym_public] = ACTIONS(2998),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_SQUOTE] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2998),
    [anon_sym_CARET] = ACTIONS(2992),
    [anon_sym_export] = ACTIONS(2998),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2992),
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_debugger] = ACTIONS(2998),
    [anon_sym_AT] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_void] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [sym_super] = ACTIONS(2998),
    [anon_sym_private] = ACTIONS(2998),
    [anon_sym_get] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2998),
    [anon_sym_enum] = ACTIONS(2998),
    [anon_sym_continue] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [sym_this] = ACTIONS(2998),
    [anon_sym_throw] = ACTIONS(2998),
    [anon_sym_abstract] = ACTIONS(2998),
    [anon_sym_type] = ACTIONS(2998),
    [anon_sym_STAR_STAR] = ACTIONS(2992),
    [anon_sym_namespace] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [sym_false] = ACTIONS(2998),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2998),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(2998),
    [sym_number] = ACTIONS(2996),
    [ts_builtin_sym_end] = ACTIONS(2996),
    [anon_sym_function] = ACTIONS(2998),
    [sym_undefined] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_await] = ACTIONS(2998),
  },
  [702] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3002),
    [sym__automatic_semicolon] = ACTIONS(3004),
    [anon_sym_BQUOTE] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_PIPE] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_GT_GT_GT] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_BANG_EQ] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_as] = ACTIONS(3010),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_instanceof] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_DOT] = ACTIONS(3010),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3006),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [sym_null] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3006),
    [anon_sym_SLASH] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_GT_GT] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3006),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [sym_super] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3006),
    [sym_this] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3006),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [sym_false] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3006),
    [anon_sym_GT] = ACTIONS(3010),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_EQ_EQ] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3008),
    [sym_number] = ACTIONS(3006),
    [ts_builtin_sym_end] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3006),
    [anon_sym_await] = ACTIONS(3008),
  },
  [703] = {
    [sym_class_body] = STATE(960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [704] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(962),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [705] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(3014),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [706] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [707] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1322),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [708] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [709] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [710] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [711] = {
    [anon_sym_RBRACK] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
  },
  [712] = {
    [sym_string] = STATE(968),
    [sym__property_name] = STATE(968),
    [sym_computed_property_name] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [713] = {
    [sym_string] = STATE(969),
    [sym__property_name] = STATE(969),
    [sym_computed_property_name] = STATE(969),
    [anon_sym_get] = ACTIONS(968),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(968),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [714] = {
    [sym_string] = STATE(968),
    [sym__property_name] = STATE(968),
    [sym_computed_property_name] = STATE(968),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [715] = {
    [sym_type_annotation] = STATE(974),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(973),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(972),
    [sym__automatic_semicolon] = ACTIONS(3028),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3032),
  },
  [716] = {
    [sym_string] = STATE(975),
    [sym__property_name] = STATE(975),
    [sym_computed_property_name] = STATE(975),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [717] = {
    [sym_string] = STATE(975),
    [sym__property_name] = STATE(975),
    [sym_computed_property_name] = STATE(975),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [718] = {
    [sym_string] = STATE(975),
    [sym__property_name] = STATE(975),
    [sym_computed_property_name] = STATE(975),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3038),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [719] = {
    [sym_type_annotation] = STATE(974),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(973),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(962),
    [sym__automatic_semicolon] = ACTIONS(3028),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3032),
  },
  [720] = {
    [sym_string] = STATE(980),
    [sym__property_name] = STATE(980),
    [sym_computed_property_name] = STATE(980),
    [anon_sym_get] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(3044),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3042),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [721] = {
    [anon_sym_LBRACK] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_module] = ACTIONS(3050),
    [anon_sym_symbol] = ACTIONS(3050),
    [anon_sym_number] = ACTIONS(3050),
    [anon_sym_AT] = ACTIONS(3048),
    [anon_sym_declare] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_void] = ACTIONS(3050),
    [anon_sym_any] = ACTIONS(3050),
    [anon_sym_private] = ACTIONS(3050),
    [anon_sym_boolean] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_public] = ACTIONS(3050),
    [anon_sym_get] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_async] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [sym_number] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3050),
    [anon_sym_string] = ACTIONS(3050),
    [anon_sym_abstract] = ACTIONS(3050),
    [anon_sym_set] = ACTIONS(3050),
    [anon_sym_type] = ACTIONS(3050),
    [anon_sym_export] = ACTIONS(3050),
    [sym_readonly] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3048),
  },
  [722] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3052),
    [sym__automatic_semicolon] = ACTIONS(3052),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_GT_GT_GT] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_as] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_instanceof] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3052),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3052),
  },
  [723] = {
    [sym_abstract_method_signature] = STATE(421),
    [sym_index_signature] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_computed_property_name] = STATE(425),
    [sym_decorator] = STATE(723),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(723),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym_string] = STATE(425),
    [sym_method_signature] = STATE(421),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_module] = ACTIONS(3059),
    [anon_sym_symbol] = ACTIONS(3059),
    [anon_sym_number] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3062),
    [anon_sym_declare] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_void] = ACTIONS(3059),
    [anon_sym_any] = ACTIONS(3059),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_boolean] = ACTIONS(3059),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_async] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [sym_number] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_string] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3086),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_type] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(3059),
    [sym_readonly] = ACTIONS(3089),
    [anon_sym_namespace] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3092),
  },
  [724] = {
    [sym_string] = STATE(980),
    [sym__property_name] = STATE(980),
    [sym_computed_property_name] = STATE(980),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(3044),
    [anon_sym_get] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3042),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [725] = {
    [sym_string] = STATE(980),
    [sym__property_name] = STATE(980),
    [sym_computed_property_name] = STATE(980),
    [anon_sym_get] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(3044),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(3097),
    [anon_sym_set] = ACTIONS(3042),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [726] = {
    [sym_string] = STATE(985),
    [sym__property_name] = STATE(985),
    [sym_computed_property_name] = STATE(985),
    [anon_sym_get] = ACTIONS(3099),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3097),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
  },
  [727] = {
    [sym_type_annotation] = STATE(988),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(987),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(986),
    [sym__automatic_semicolon] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [sym__initializer] = STATE(987),
    [sym_type_annotation] = STATE(988),
    [sym__automatic_semicolon] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_COMMA] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [sym_statement_block] = STATE(1514),
    [sym__automatic_semicolon] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [730] = {
    [sym__automatic_semicolon] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
  },
  [731] = {
    [sym__initializer] = STATE(989),
    [sym__automatic_semicolon] = ACTIONS(3113),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_COMMA] = ACTIONS(3113),
    [sym_comment] = ACTIONS(3),
  },
  [732] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [sym__automatic_semicolon] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3115),
    [anon_sym_EQ_EQ] = ACTIONS(3117),
    [anon_sym_instanceof] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_SLASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_GT_GT] = ACTIONS(3117),
    [anon_sym_PLUS_PLUS] = ACTIONS(3115),
    [anon_sym_in] = ACTIONS(3117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BANG] = ACTIONS(3117),
  },
  [733] = {
    [anon_sym_COLON] = ACTIONS(3119),
    [sym_comment] = ACTIONS(3),
  },
  [734] = {
    [sym__automatic_semicolon] = ACTIONS(2117),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_if] = ACTIONS(2121),
    [sym_this] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [sym_false] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [sym_null] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(2121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_new] = ACTIONS(2121),
    [ts_builtin_sym_end] = ACTIONS(2119),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_await] = ACTIONS(2121),
  },
  [735] = {
    [sym_class_body] = STATE(991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [736] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(992),
    [sym_class_heritage] = STATE(993),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [737] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(994),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [738] = {
    [sym_identifier] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
  },
  [739] = {
    [sym_statement_block] = STATE(996),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3123),
  },
  [740] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(997),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [741] = {
    [sym_nested_identifier] = STATE(665),
    [sym_identifier] = ACTIONS(3125),
    [sym_comment] = ACTIONS(3),
  },
  [742] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(999),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(998),
    [sym_type_parameters] = STATE(1000),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [743] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3127),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [744] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3132),
    [sym__automatic_semicolon] = ACTIONS(3132),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [anon_sym_PIPE] = ACTIONS(3134),
    [anon_sym_COMMA] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_GT_GT_GT] = ACTIONS(3132),
    [anon_sym_EQ] = ACTIONS(3134),
    [anon_sym_BANG_EQ] = ACTIONS(3134),
    [anon_sym_GT_EQ] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3132),
    [anon_sym_as] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_instanceof] = ACTIONS(3132),
    [anon_sym_COLON] = ACTIONS(3132),
    [anon_sym_DOT] = ACTIONS(3132),
    [anon_sym_STAR_STAR] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_in] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_LT_LT] = ACTIONS(3132),
    [anon_sym_AMP_AMP] = ACTIONS(3132),
    [anon_sym_of] = ACTIONS(3132),
    [anon_sym_LT_EQ] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_GT] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_PIPE_PIPE] = ACTIONS(3132),
    [anon_sym_EQ_EQ] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_GT_GT] = ACTIONS(3134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3132),
  },
  [745] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3136),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [746] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1001),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [747] = {
    [sym_statement_block] = STATE(1002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [748] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1004),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [749] = {
    [sym_string] = STATE(1005),
    [sym__property_name] = STATE(1005),
    [sym_computed_property_name] = STATE(1005),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [750] = {
    [sym_string] = STATE(1005),
    [sym__property_name] = STATE(1005),
    [sym_computed_property_name] = STATE(1005),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [751] = {
    [sym_string] = STATE(1005),
    [sym__property_name] = STATE(1005),
    [sym_computed_property_name] = STATE(1005),
    [anon_sym_get] = ACTIONS(3143),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(3143),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [752] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2059),
    [anon_sym_LBRACK] = ACTIONS(2059),
    [sym__automatic_semicolon] = ACTIONS(2059),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2059),
    [anon_sym_LT_LT] = ACTIONS(2059),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2059),
    [anon_sym_EQ] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_LT_EQ] = ACTIONS(2059),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2059),
    [anon_sym_QMARK] = ACTIONS(3147),
    [anon_sym_as] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_instanceof] = ACTIONS(2059),
    [anon_sym_LT] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3153),
    [anon_sym_DOT] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2059),
    [anon_sym_BANG] = ACTIONS(2061),
  },
  [753] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3155),
    [sym__automatic_semicolon] = ACTIONS(3155),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [anon_sym_PIPE] = ACTIONS(3157),
    [anon_sym_COMMA] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_GT_GT_GT] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(3157),
    [anon_sym_BANG_EQ] = ACTIONS(3157),
    [anon_sym_GT_EQ] = ACTIONS(3155),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_PERCENT] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3155),
    [anon_sym_instanceof] = ACTIONS(3155),
    [anon_sym_COLON] = ACTIONS(3155),
    [anon_sym_DOT] = ACTIONS(3155),
    [anon_sym_STAR_STAR] = ACTIONS(3155),
    [anon_sym_PLUS_PLUS] = ACTIONS(3155),
    [anon_sym_in] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_LT_LT] = ACTIONS(3155),
    [anon_sym_AMP_AMP] = ACTIONS(3155),
    [anon_sym_of] = ACTIONS(3155),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3157),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_QMARK] = ACTIONS(3155),
    [anon_sym_PIPE_PIPE] = ACTIONS(3155),
    [anon_sym_EQ_EQ] = ACTIONS(3157),
    [anon_sym_LT] = ACTIONS(3157),
    [anon_sym_SLASH] = ACTIONS(3157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_GT_GT] = ACTIONS(3157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3155),
  },
  [754] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3159),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [755] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3164),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [756] = {
    [sym_statement_block] = STATE(1008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [757] = {
    [anon_sym_COMMA] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
  },
  [758] = {
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [anon_sym_catch] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_with] = ACTIONS(3170),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_COMMA] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [sym_super] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [sym_this] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [sym_false] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [anon_sym_finally] = ACTIONS(3170),
    [ts_builtin_sym_end] = ACTIONS(3168),
    [anon_sym_function] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_await] = ACTIONS(3170),
  },
  [759] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3172),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [760] = {
    [sym_string] = STATE(1005),
    [sym__property_name] = STATE(1005),
    [sym_computed_property_name] = STATE(1005),
    [anon_sym_get] = ACTIONS(3143),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(3177),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3143),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [761] = {
    [sym_class] = STATE(1011),
    [sym_arrow_function] = STATE(1011),
    [sym_await_expression] = STATE(1011),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1011),
    [sym_sequence_expression] = STATE(1010),
    [sym_meta_property] = STATE(1011),
    [sym__expression] = STATE(1011),
    [sym_jsx_element] = STATE(1011),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1011),
    [sym_call_expression] = STATE(1011),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1011),
    [sym_string] = STATE(1011),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1011),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1011),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1011),
    [sym_generator_function] = STATE(1011),
    [sym_new_expression] = STATE(1011),
    [sym_assignment_expression] = STATE(1011),
    [sym_augmented_assignment_expression] = STATE(1011),
    [sym_binary_expression] = STATE(1011),
    [sym_unary_expression] = STATE(1011),
    [sym_regex] = STATE(1011),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1011),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1011),
    [sym_internal_module] = STATE(1011),
    [sym_jsx_self_closing_element] = STATE(1011),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3179),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3179),
    [sym_number] = ACTIONS(3181),
    [sym_true] = ACTIONS(3179),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [762] = {
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_BQUOTE] = ACTIONS(3185),
    [anon_sym_debugger] = ACTIONS(3183),
    [anon_sym_symbol] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_void] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [sym_super] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_get] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3185),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [anon_sym_delete] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3183),
    [sym_this] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [sym_true] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_set] = ACTIONS(3183),
    [anon_sym_type] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DQUOTE] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [sym_false] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_case] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_number] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_declare] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [sym_null] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3183),
    [anon_sym_boolean] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_LT] = ACTIONS(3185),
    [sym_number] = ACTIONS(3185),
    [anon_sym_SLASH] = ACTIONS(3183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [sym_undefined] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [ts_builtin_sym_end] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_with] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
  },
  [763] = {
    [anon_sym_COLON] = ACTIONS(3187),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [sym_switch_default] = STATE(1014),
    [aux_sym_switch_body_repeat1] = STATE(1014),
    [sym_switch_case] = STATE(1014),
    [anon_sym_RBRACE] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(2282),
    [anon_sym_case] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
  },
  [765] = {
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_RPAREN] = ACTIONS(3191),
    [sym_comment] = ACTIONS(3),
  },
  [766] = {
    [anon_sym_COLON] = ACTIONS(3193),
    [anon_sym_EQ_GT] = ACTIONS(3193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3193),
  },
  [767] = {
    [anon_sym_COMMA] = ACTIONS(3195),
    [anon_sym_RPAREN] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
  },
  [768] = {
    [sym_optional_parameter] = STATE(1015),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(1015),
    [aux_sym_export_statement_repeat1] = STATE(2705),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(1015),
    [sym_decorator] = STATE(63),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [sym_this] = ACTIONS(1205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_boolean] = ACTIONS(1207),
  },
  [769] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [770] = {
    [aux_sym_formal_parameters_repeat1] = STATE(770),
    [anon_sym_COMMA] = ACTIONS(3199),
    [anon_sym_RPAREN] = ACTIONS(3202),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
  },
  [772] = {
    [sym__initializer] = STATE(1018),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(3206),
    [anon_sym_COMMA] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
  },
  [773] = {
    [anon_sym_COMMA] = ACTIONS(3208),
    [anon_sym_RPAREN] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
  },
  [774] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3210),
    [sym__automatic_semicolon] = ACTIONS(3210),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [anon_sym_PERCENT_EQ] = ACTIONS(3210),
    [anon_sym_AMP_EQ] = ACTIONS(3210),
    [anon_sym_PLUS_EQ] = ACTIONS(3210),
    [anon_sym_PIPE] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_GT_GT_GT] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_GT_EQ] = ACTIONS(3210),
    [anon_sym_CARET_EQ] = ACTIONS(3210),
    [anon_sym_PIPE_EQ] = ACTIONS(3210),
    [anon_sym_DASH_EQ] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_LT_LT_EQ] = ACTIONS(3210),
    [anon_sym_as] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [anon_sym_instanceof] = ACTIONS(3210),
    [anon_sym_GT_GT_EQ] = ACTIONS(3210),
    [anon_sym_DOT] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3210),
    [anon_sym_LT_LT] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3210),
    [anon_sym_of] = ACTIONS(3210),
    [anon_sym_LT_EQ] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_GT] = ACTIONS(3212),
    [anon_sym_STAR_EQ] = ACTIONS(3210),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3210),
    [anon_sym_EQ_EQ] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3210),
    [anon_sym_CARET] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_GT_GT] = ACTIONS(3212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3210),
  },
  [775] = {
    [anon_sym_EQ] = ACTIONS(3214),
    [anon_sym_COLON] = ACTIONS(3214),
    [anon_sym_RPAREN] = ACTIONS(3214),
    [anon_sym_QMARK] = ACTIONS(3214),
    [anon_sym_COMMA] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
  },
  [776] = {
    [anon_sym_EQ] = ACTIONS(3216),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_RPAREN] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3216),
    [anon_sym_COMMA] = ACTIONS(3216),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [anon_sym_EQ] = ACTIONS(3218),
    [anon_sym_COLON] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3218),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_COMMA] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
  },
  [778] = {
    [anon_sym_EQ] = ACTIONS(3220),
    [anon_sym_COLON] = ACTIONS(3220),
    [anon_sym_RPAREN] = ACTIONS(3220),
    [anon_sym_QMARK] = ACTIONS(3220),
    [anon_sym_COMMA] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
  },
  [779] = {
    [aux_sym_formal_parameters_repeat1] = STATE(770),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(3222),
    [sym_comment] = ACTIONS(3),
  },
  [780] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [sym__automatic_semicolon] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [anon_sym_PIPE] = ACTIONS(3226),
    [anon_sym_COMMA] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(3224),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_GT_GT_GT] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_GT_EQ] = ACTIONS(3224),
    [anon_sym_GT] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_PERCENT] = ACTIONS(3224),
    [anon_sym_QMARK] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_as] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_EQ_EQ] = ACTIONS(3226),
    [anon_sym_instanceof] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3224),
    [anon_sym_CARET] = ACTIONS(3224),
    [anon_sym_STAR_STAR] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_GT_GT] = ACTIONS(3226),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3226),
  },
  [781] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [782] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [sym__automatic_semicolon] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [anon_sym_PIPE] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_GT_GT_GT] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_LT_EQ] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_GT_EQ] = ACTIONS(3228),
    [anon_sym_GT] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_PERCENT] = ACTIONS(3228),
    [anon_sym_QMARK] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_as] = ACTIONS(3228),
    [anon_sym_PIPE_PIPE] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_instanceof] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3228),
    [anon_sym_CARET] = ACTIONS(3228),
    [anon_sym_STAR_STAR] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_GT_GT] = ACTIONS(3230),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3230),
  },
  [783] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [784] = {
    [sym_statement_block] = STATE(1021),
    [sym__automatic_semicolon] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(844),
  },
  [785] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1022),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [786] = {
    [sym_statement_block] = STATE(1023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [787] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [sym__automatic_semicolon] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_COMMA] = ACTIONS(3234),
    [anon_sym_LT_LT] = ACTIONS(3234),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_GT_GT_GT] = ACTIONS(3234),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_BANG_EQ] = ACTIONS(3236),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3234),
    [anon_sym_QMARK] = ACTIONS(3234),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_as] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_EQ_EQ] = ACTIONS(3236),
    [anon_sym_instanceof] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3234),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_STAR_STAR] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG] = ACTIONS(3236),
  },
  [788] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [sym__automatic_semicolon] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3238),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_LT_EQ] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_GT_EQ] = ACTIONS(3238),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3238),
    [anon_sym_QMARK] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_as] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_instanceof] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_CARET] = ACTIONS(3238),
    [anon_sym_STAR_STAR] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3240),
  },
  [789] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [790] = {
    [sym_identifier] = ACTIONS(3242),
    [anon_sym_BQUOTE] = ACTIONS(3244),
    [anon_sym_debugger] = ACTIONS(3242),
    [anon_sym_symbol] = ACTIONS(3242),
    [anon_sym_AT] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_void] = ACTIONS(3242),
    [anon_sym_break] = ACTIONS(3242),
    [anon_sym_const] = ACTIONS(3242),
    [sym_super] = ACTIONS(3242),
    [anon_sym_return] = ACTIONS(3242),
    [anon_sym_private] = ACTIONS(3242),
    [anon_sym_static] = ACTIONS(3242),
    [anon_sym_get] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_interface] = ACTIONS(3242),
    [anon_sym_default] = ACTIONS(3242),
    [anon_sym_enum] = ACTIONS(3242),
    [anon_sym_delete] = ACTIONS(3242),
    [anon_sym_continue] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3244),
    [anon_sym_if] = ACTIONS(3242),
    [sym_this] = ACTIONS(3242),
    [anon_sym_yield] = ACTIONS(3242),
    [sym_true] = ACTIONS(3242),
    [anon_sym_throw] = ACTIONS(3242),
    [anon_sym_protected] = ACTIONS(3242),
    [anon_sym_abstract] = ACTIONS(3242),
    [anon_sym_set] = ACTIONS(3242),
    [anon_sym_type] = ACTIONS(3242),
    [anon_sym_import] = ACTIONS(3242),
    [anon_sym_namespace] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3244),
    [anon_sym_DQUOTE] = ACTIONS(3244),
    [anon_sym_else] = ACTIONS(3242),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_for] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [sym_false] = ACTIONS(3242),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym_case] = ACTIONS(3242),
    [anon_sym_module] = ACTIONS(3242),
    [anon_sym_number] = ACTIONS(3242),
    [anon_sym_class] = ACTIONS(3242),
    [anon_sym_declare] = ACTIONS(3242),
    [anon_sym_typeof] = ACTIONS(3242),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_switch] = ACTIONS(3242),
    [anon_sym_LPAREN] = ACTIONS(3244),
    [sym_null] = ACTIONS(3242),
    [anon_sym_any] = ACTIONS(3242),
    [anon_sym_boolean] = ACTIONS(3242),
    [anon_sym_async] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(3242),
    [anon_sym_var] = ACTIONS(3242),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_SQUOTE] = ACTIONS(3244),
    [anon_sym_try] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(3244),
    [sym_number] = ACTIONS(3244),
    [anon_sym_SLASH] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3242),
    [anon_sym_function] = ACTIONS(3242),
    [sym_undefined] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3242),
    [ts_builtin_sym_end] = ACTIONS(3244),
    [anon_sym_let] = ACTIONS(3242),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_export] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3242),
    [anon_sym_TILDE] = ACTIONS(3244),
    [anon_sym_with] = ACTIONS(3242),
    [anon_sym_await] = ACTIONS(3242),
  },
  [791] = {
    [sym_object] = STATE(1025),
    [sym_array] = STATE(1026),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
  },
  [792] = {
    [sym_identifier] = ACTIONS(3248),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [anon_sym_debugger] = ACTIONS(3248),
    [anon_sym_symbol] = ACTIONS(3248),
    [anon_sym_AT] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3248),
    [anon_sym_void] = ACTIONS(3248),
    [anon_sym_break] = ACTIONS(3248),
    [anon_sym_const] = ACTIONS(3248),
    [sym_super] = ACTIONS(3248),
    [anon_sym_return] = ACTIONS(3248),
    [anon_sym_private] = ACTIONS(3248),
    [anon_sym_static] = ACTIONS(3248),
    [anon_sym_get] = ACTIONS(3248),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3248),
    [anon_sym_default] = ACTIONS(3248),
    [anon_sym_enum] = ACTIONS(3248),
    [anon_sym_delete] = ACTIONS(3248),
    [anon_sym_continue] = ACTIONS(3248),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3248),
    [sym_this] = ACTIONS(3248),
    [anon_sym_yield] = ACTIONS(3248),
    [sym_true] = ACTIONS(3248),
    [anon_sym_throw] = ACTIONS(3248),
    [anon_sym_protected] = ACTIONS(3248),
    [anon_sym_abstract] = ACTIONS(3248),
    [anon_sym_set] = ACTIONS(3248),
    [anon_sym_type] = ACTIONS(3248),
    [anon_sym_import] = ACTIONS(3248),
    [anon_sym_namespace] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3248),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [sym_false] = ACTIONS(3248),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3248),
    [anon_sym_module] = ACTIONS(3248),
    [anon_sym_number] = ACTIONS(3248),
    [anon_sym_class] = ACTIONS(3248),
    [anon_sym_declare] = ACTIONS(3248),
    [anon_sym_typeof] = ACTIONS(3248),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [sym_null] = ACTIONS(3248),
    [anon_sym_any] = ACTIONS(3248),
    [anon_sym_boolean] = ACTIONS(3248),
    [anon_sym_async] = ACTIONS(3248),
    [anon_sym_public] = ACTIONS(3248),
    [anon_sym_var] = ACTIONS(3248),
    [anon_sym_while] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3248),
    [anon_sym_LT] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3248),
    [anon_sym_string] = ACTIONS(3248),
    [anon_sym_function] = ACTIONS(3248),
    [sym_undefined] = ACTIONS(3248),
    [anon_sym_new] = ACTIONS(3248),
    [ts_builtin_sym_end] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3248),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_export] = ACTIONS(3248),
    [anon_sym_do] = ACTIONS(3248),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_with] = ACTIONS(3248),
    [anon_sym_await] = ACTIONS(3248),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [anon_sym_debugger] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_AT] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_break] = ACTIONS(3252),
    [anon_sym_const] = ACTIONS(3252),
    [sym_super] = ACTIONS(3252),
    [anon_sym_return] = ACTIONS(3252),
    [anon_sym_private] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_interface] = ACTIONS(3252),
    [anon_sym_default] = ACTIONS(3252),
    [anon_sym_enum] = ACTIONS(3252),
    [anon_sym_delete] = ACTIONS(3252),
    [anon_sym_continue] = ACTIONS(3252),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3252),
    [sym_this] = ACTIONS(3252),
    [anon_sym_yield] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [anon_sym_throw] = ACTIONS(3252),
    [anon_sym_protected] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_type] = ACTIONS(3252),
    [anon_sym_import] = ACTIONS(3252),
    [anon_sym_namespace] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_else] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3252),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [sym_false] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3252),
    [anon_sym_module] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_class] = ACTIONS(3252),
    [anon_sym_declare] = ACTIONS(3252),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [sym_null] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_public] = ACTIONS(3252),
    [anon_sym_var] = ACTIONS(3252),
    [anon_sym_while] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3252),
    [anon_sym_LT] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_function] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_new] = ACTIONS(3252),
    [ts_builtin_sym_end] = ACTIONS(3254),
    [anon_sym_let] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_export] = ACTIONS(3252),
    [anon_sym_do] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3254),
    [anon_sym_with] = ACTIONS(3252),
    [anon_sym_await] = ACTIONS(3252),
  },
  [794] = {
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [anon_sym_debugger] = ACTIONS(3256),
    [anon_sym_symbol] = ACTIONS(3256),
    [anon_sym_AT] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_void] = ACTIONS(3256),
    [anon_sym_break] = ACTIONS(3256),
    [anon_sym_const] = ACTIONS(3256),
    [sym_super] = ACTIONS(3256),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_private] = ACTIONS(3256),
    [anon_sym_static] = ACTIONS(3256),
    [anon_sym_get] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_interface] = ACTIONS(3256),
    [anon_sym_default] = ACTIONS(3256),
    [anon_sym_enum] = ACTIONS(3256),
    [anon_sym_delete] = ACTIONS(3256),
    [anon_sym_continue] = ACTIONS(3256),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3256),
    [sym_this] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [anon_sym_throw] = ACTIONS(3256),
    [anon_sym_protected] = ACTIONS(3256),
    [anon_sym_abstract] = ACTIONS(3256),
    [anon_sym_set] = ACTIONS(3256),
    [anon_sym_type] = ACTIONS(3256),
    [anon_sym_import] = ACTIONS(3256),
    [anon_sym_namespace] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_else] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3256),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [sym_false] = ACTIONS(3256),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3256),
    [anon_sym_module] = ACTIONS(3256),
    [anon_sym_number] = ACTIONS(3256),
    [anon_sym_class] = ACTIONS(3256),
    [anon_sym_declare] = ACTIONS(3256),
    [anon_sym_typeof] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [sym_null] = ACTIONS(3256),
    [anon_sym_any] = ACTIONS(3256),
    [anon_sym_boolean] = ACTIONS(3256),
    [anon_sym_async] = ACTIONS(3256),
    [anon_sym_public] = ACTIONS(3256),
    [anon_sym_var] = ACTIONS(3256),
    [anon_sym_while] = ACTIONS(3256),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3256),
    [anon_sym_LT] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [anon_sym_SLASH] = ACTIONS(3256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3256),
    [anon_sym_function] = ACTIONS(3256),
    [sym_undefined] = ACTIONS(3256),
    [anon_sym_new] = ACTIONS(3256),
    [ts_builtin_sym_end] = ACTIONS(3258),
    [anon_sym_let] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_export] = ACTIONS(3256),
    [anon_sym_do] = ACTIONS(3256),
    [anon_sym_TILDE] = ACTIONS(3258),
    [anon_sym_with] = ACTIONS(3256),
    [anon_sym_await] = ACTIONS(3256),
  },
  [795] = {
    [anon_sym_GT] = ACTIONS(3260),
    [sym_comment] = ACTIONS(3),
  },
  [796] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [797] = {
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
  },
  [798] = {
    [sym_jsx_element] = STATE(1030),
    [sym_jsx_fragment] = STATE(1030),
    [sym_jsx_expression] = STATE(1030),
    [sym_jsx_opening_element] = STATE(2236),
    [sym_string] = STATE(1030),
    [sym_jsx_self_closing_element] = STATE(1030),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [799] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_EQ] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1797),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_DOT] = ACTIONS(1803),
    [anon_sym_is] = ACTIONS(3274),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3278),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(3276),
  },
  [800] = {
    [anon_sym_EQ] = ACTIONS(3276),
    [sym_identifier] = ACTIONS(3272),
    [sym_jsx_identifier] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3276),
    [anon_sym_SLASH] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3276),
  },
  [801] = {
    [anon_sym_EQ] = ACTIONS(3281),
    [anon_sym_GT] = ACTIONS(3281),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(3281),
    [sym_comment] = ACTIONS(3),
  },
  [802] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [sym__automatic_semicolon] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_LT_EQ] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_GT_EQ] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_QMARK] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_EQ_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_in] = ACTIONS(3285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
  },
  [803] = {
    [sym_jsx_text] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3287),
  },
  [804] = {
    [anon_sym_GT] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
  },
  [805] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(805),
    [sym_identifier] = ACTIONS(3291),
    [sym_jsx_identifier] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(3299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3301),
  },
  [806] = {
    [anon_sym_COMMA] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
  },
  [807] = {
    [sym_jsx_text] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3306),
  },
  [808] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(805),
    [anon_sym_GT] = ACTIONS(3308),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [809] = {
    [sym_jsx_element] = STATE(1033),
    [sym_jsx_fragment] = STATE(1033),
    [sym_jsx_expression] = STATE(1033),
    [sym_jsx_opening_element] = STATE(2236),
    [sym_string] = STATE(1033),
    [sym_jsx_self_closing_element] = STATE(1033),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [810] = {
    [anon_sym_extends] = ACTIONS(3310),
    [anon_sym_implements] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_EQ] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3312),
  },
  [811] = {
    [anon_sym_COMMA] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
  },
  [812] = {
    [sym_type_parameter] = STATE(811),
    [anon_sym_GT] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [aux_sym_type_parameters_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(3318),
    [anon_sym_GT] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
  },
  [814] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [sym__automatic_semicolon] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_PIPE] = ACTIONS(3323),
    [anon_sym_COMMA] = ACTIONS(3321),
    [anon_sym_LT_LT] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_GT_GT_GT] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_BANG_EQ] = ACTIONS(3323),
    [anon_sym_LT_EQ] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_GT_EQ] = ACTIONS(3321),
    [anon_sym_GT] = ACTIONS(3323),
    [anon_sym_AMP] = ACTIONS(3323),
    [anon_sym_PERCENT] = ACTIONS(3321),
    [anon_sym_QMARK] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_as] = ACTIONS(3321),
    [anon_sym_PIPE_PIPE] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_EQ_EQ] = ACTIONS(3323),
    [anon_sym_instanceof] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_STAR_STAR] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_GT_GT] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_in] = ACTIONS(3323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3323),
  },
  [815] = {
    [sym_identifier] = ACTIONS(3325),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [anon_sym_debugger] = ACTIONS(3325),
    [anon_sym_symbol] = ACTIONS(3325),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3325),
    [anon_sym_void] = ACTIONS(3325),
    [anon_sym_break] = ACTIONS(3325),
    [anon_sym_const] = ACTIONS(3325),
    [sym_super] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3325),
    [anon_sym_private] = ACTIONS(3325),
    [anon_sym_static] = ACTIONS(3325),
    [anon_sym_get] = ACTIONS(3325),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3325),
    [anon_sym_default] = ACTIONS(3325),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_delete] = ACTIONS(3325),
    [anon_sym_continue] = ACTIONS(3325),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3325),
    [sym_this] = ACTIONS(3325),
    [anon_sym_yield] = ACTIONS(3325),
    [sym_true] = ACTIONS(3325),
    [anon_sym_throw] = ACTIONS(3325),
    [anon_sym_protected] = ACTIONS(3325),
    [anon_sym_abstract] = ACTIONS(3325),
    [anon_sym_set] = ACTIONS(3325),
    [anon_sym_type] = ACTIONS(3325),
    [anon_sym_import] = ACTIONS(3325),
    [anon_sym_namespace] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3325),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [sym_false] = ACTIONS(3325),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_case] = ACTIONS(3325),
    [anon_sym_module] = ACTIONS(3325),
    [anon_sym_number] = ACTIONS(3325),
    [anon_sym_class] = ACTIONS(3325),
    [anon_sym_declare] = ACTIONS(3325),
    [anon_sym_typeof] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [sym_null] = ACTIONS(3325),
    [anon_sym_any] = ACTIONS(3325),
    [anon_sym_boolean] = ACTIONS(3325),
    [anon_sym_async] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3325),
    [anon_sym_var] = ACTIONS(3325),
    [anon_sym_while] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3325),
    [anon_sym_LT] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [anon_sym_SLASH] = ACTIONS(3325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3325),
    [anon_sym_function] = ACTIONS(3325),
    [sym_undefined] = ACTIONS(3325),
    [anon_sym_new] = ACTIONS(3325),
    [ts_builtin_sym_end] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3325),
    [anon_sym_PLUS] = ACTIONS(3325),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3325),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_with] = ACTIONS(3325),
    [anon_sym_await] = ACTIONS(3325),
  },
  [816] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3329),
    [sym__automatic_semicolon] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [anon_sym_symbol] = ACTIONS(3335),
    [anon_sym_PIPE] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_GT_GT_GT] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_BANG_EQ] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_PERCENT] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3335),
    [anon_sym_as] = ACTIONS(3337),
    [anon_sym_delete] = ACTIONS(3335),
    [anon_sym_if] = ACTIONS(3335),
    [anon_sym_instanceof] = ACTIONS(3337),
    [anon_sym_yield] = ACTIONS(3335),
    [sym_true] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_DOT] = ACTIONS(3337),
    [anon_sym_set] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3335),
    [anon_sym_in] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_number] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym_LT_LT] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_AMP_AMP] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_LT_EQ] = ACTIONS(3329),
    [sym_null] = ACTIONS(3335),
    [anon_sym_any] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [anon_sym_QMARK] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_SLASH] = ACTIONS(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_export] = ACTIONS(3335),
    [anon_sym_GT_GT] = ACTIONS(3337),
    [anon_sym_with] = ACTIONS(3335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3329),
    [sym_identifier] = ACTIONS(3335),
    [anon_sym_debugger] = ACTIONS(3335),
    [anon_sym_AT] = ACTIONS(3333),
    [anon_sym_COMMA] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_void] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [anon_sym_GT_EQ] = ACTIONS(3329),
    [sym_super] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_get] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_enum] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [sym_this] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_type] = ACTIONS(3335),
    [anon_sym_STAR_STAR] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [sym_false] = ACTIONS(3335),
    [anon_sym_case] = ACTIONS(3335),
    [anon_sym_module] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_declare] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_GT] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3335),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_PIPE_PIPE] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_EQ_EQ] = ACTIONS(3337),
    [anon_sym_LT] = ACTIONS(3335),
    [sym_number] = ACTIONS(3333),
    [ts_builtin_sym_end] = ACTIONS(3333),
    [anon_sym_function] = ACTIONS(3335),
    [sym_undefined] = ACTIONS(3335),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3335),
  },
  [817] = {
    [sym_statement_block] = STATE(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(844),
  },
  [818] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3339),
    [anon_sym_LBRACK] = ACTIONS(3339),
    [sym__automatic_semicolon] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [anon_sym_PIPE] = ACTIONS(3341),
    [anon_sym_COMMA] = ACTIONS(3339),
    [anon_sym_LT_LT] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_GT_GT_GT] = ACTIONS(3339),
    [anon_sym_AMP_AMP] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_BANG_EQ] = ACTIONS(3341),
    [anon_sym_LT_EQ] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3339),
    [anon_sym_GT_EQ] = ACTIONS(3339),
    [anon_sym_GT] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_PERCENT] = ACTIONS(3339),
    [anon_sym_QMARK] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_as] = ACTIONS(3339),
    [anon_sym_PIPE_PIPE] = ACTIONS(3339),
    [anon_sym_DASH_DASH] = ACTIONS(3339),
    [anon_sym_EQ_EQ] = ACTIONS(3341),
    [anon_sym_instanceof] = ACTIONS(3339),
    [anon_sym_LT] = ACTIONS(3341),
    [anon_sym_SLASH] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3339),
    [anon_sym_CARET] = ACTIONS(3339),
    [anon_sym_STAR_STAR] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3341),
    [anon_sym_GT_GT] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3339),
    [anon_sym_in] = ACTIONS(3341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3341),
  },
  [819] = {
    [sym_class] = STATE(396),
    [sym_arrow_function] = STATE(396),
    [sym_await_expression] = STATE(396),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(396),
    [sym_meta_property] = STATE(396),
    [sym__expression] = STATE(396),
    [sym_jsx_element] = STATE(396),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(396),
    [sym_call_expression] = STATE(396),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(396),
    [sym_string] = STATE(396),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(396),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(396),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(396),
    [sym_generator_function] = STATE(396),
    [sym_new_expression] = STATE(396),
    [sym_assignment_expression] = STATE(396),
    [sym_augmented_assignment_expression] = STATE(396),
    [sym_binary_expression] = STATE(396),
    [sym_unary_expression] = STATE(396),
    [sym_regex] = STATE(396),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(396),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(396),
    [sym_internal_module] = STATE(396),
    [sym_jsx_self_closing_element] = STATE(396),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(3343),
    [sym_false] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(876),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(876),
    [sym_number] = ACTIONS(878),
    [sym_true] = ACTIONS(876),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(876),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [820] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1877),
    [sym__automatic_semicolon] = ACTIONS(1877),
    [anon_sym_BQUOTE] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1879),
    [anon_sym_STAR] = ACTIONS(1879),
    [anon_sym_GT_GT_GT] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_PERCENT] = ACTIONS(1877),
    [anon_sym_as] = ACTIONS(1877),
    [anon_sym_DASH_DASH] = ACTIONS(1877),
    [anon_sym_instanceof] = ACTIONS(1877),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_STAR_STAR] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1877),
    [anon_sym_in] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_GT] = ACTIONS(1879),
    [anon_sym_EQ_GT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_QMARK] = ACTIONS(1877),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_EQ_EQ] = ACTIONS(1879),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
  },
  [821] = {
    [sym_type_arguments] = STATE(1877),
    [sym_type_annotation] = STATE(2169),
    [aux_sym_array_repeat1] = STATE(650),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [822] = {
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_BQUOTE] = ACTIONS(3351),
    [anon_sym_debugger] = ACTIONS(3349),
    [anon_sym_symbol] = ACTIONS(3349),
    [anon_sym_AT] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [sym_super] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_get] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [anon_sym_delete] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3349),
    [sym_this] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_set] = ACTIONS(3349),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_import] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [sym_false] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_case] = ACTIONS(3349),
    [anon_sym_module] = ACTIONS(3349),
    [anon_sym_number] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_declare] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [sym_null] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3349),
    [anon_sym_boolean] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(3351),
    [sym_number] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3349),
    [anon_sym_function] = ACTIONS(3349),
    [sym_undefined] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [ts_builtin_sym_end] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_export] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_with] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
  },
  [823] = {
    [sym__automatic_semicolon] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_from] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
  },
  [824] = {
    [sym__import_export_specifier] = STATE(1042),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [825] = {
    [sym__automatic_semicolon] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_from] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
  },
  [826] = {
    [aux_sym_export_clause_repeat1] = STATE(1044),
    [anon_sym_COMMA] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [sym_comment] = ACTIONS(3),
  },
  [827] = {
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [anon_sym_debugger] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_AT] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [sym_super] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_import] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [sym_false] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_declare] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [sym_null] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_LT] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_function] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [ts_builtin_sym_end] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_export] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
  },
  [828] = {
    [sym__automatic_semicolon] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [sym_comment] = ACTIONS(3),
  },
  [829] = {
    [sym__automatic_semicolon] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
  },
  [830] = {
    [sym_class] = STATE(1047),
    [sym_arrow_function] = STATE(1047),
    [sym_await_expression] = STATE(1047),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(1047),
    [sym_meta_property] = STATE(1047),
    [sym__expression] = STATE(1047),
    [sym_jsx_element] = STATE(1047),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1047),
    [sym_call_expression] = STATE(1047),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1047),
    [sym_string] = STATE(1047),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1047),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1047),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(1047),
    [sym_generator_function] = STATE(1047),
    [sym_new_expression] = STATE(1047),
    [sym_assignment_expression] = STATE(1047),
    [sym_augmented_assignment_expression] = STATE(1047),
    [sym_binary_expression] = STATE(1047),
    [sym_unary_expression] = STATE(1047),
    [sym_regex] = STATE(1047),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1047),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1047),
    [sym_internal_module] = STATE(1047),
    [sym_jsx_self_closing_element] = STATE(1047),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(3369),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [831] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(3373),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [832] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [833] = {
    [sym_class] = STATE(2167),
    [sym_arrow_function] = STATE(2167),
    [sym_await_expression] = STATE(2167),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(2167),
    [sym_meta_property] = STATE(2167),
    [sym__expression] = STATE(2167),
    [sym_jsx_element] = STATE(2167),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2167),
    [sym_call_expression] = STATE(2167),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_spread_element] = STATE(1884),
    [sym_ternary_expression] = STATE(2167),
    [sym_string] = STATE(2167),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2167),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2167),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(2167),
    [sym_generator_function] = STATE(2167),
    [sym_new_expression] = STATE(2167),
    [sym_assignment_expression] = STATE(2167),
    [sym_augmented_assignment_expression] = STATE(2167),
    [sym_binary_expression] = STATE(2167),
    [sym_unary_expression] = STATE(2167),
    [sym_mapped_type_clause] = STATE(711),
    [sym_regex] = STATE(2167),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [aux_sym_array_repeat1] = STATE(1885),
    [sym_non_null_expression] = STATE(2167),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2167),
    [sym_internal_module] = STATE(2167),
    [sym_jsx_self_closing_element] = STATE(2167),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(3375),
    [sym_false] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(3381),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [sym_null] = ACTIONS(3377),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3377),
    [sym_number] = ACTIONS(3387),
    [sym_true] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [834] = {
    [sym_construct_signature] = STATE(878),
    [sym_pair] = STATE(447),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(878),
    [sym__call_signature] = STATE(878),
    [sym_spread_element] = STATE(447),
    [sym_property_signature] = STATE(878),
    [sym_type_parameters] = STATE(1868),
    [sym_decorator] = STATE(63),
    [sym_string] = STATE(842),
    [sym_formal_parameters] = STATE(1306),
    [sym_index_signature] = STATE(878),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(878),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(447),
    [sym_assignment_pattern] = STATE(447),
    [sym_array] = STATE(308),
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3397),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3397),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(3401),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [835] = {
    [sym_computed_property_name] = STATE(2445),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [836] = {
    [sym_computed_property_name] = STATE(1054),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_get] = ACTIONS(3411),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3411),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [837] = {
    [sym_computed_property_name] = STATE(2445),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [838] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
  },
  [839] = {
    [sym_class_declaration] = STATE(1363),
    [sym_generator_function_declaration] = STATE(1363),
    [sym__declaration] = STATE(1363),
    [sym_ambient_declaration] = STATE(1363),
    [sym_import_alias] = STATE(1363),
    [sym_type_alias_declaration] = STATE(1363),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(440),
    [sym_function_signature] = STATE(1363),
    [sym_abstract_class_declaration] = STATE(1363),
    [sym_module] = STATE(1363),
    [sym_interface_declaration] = STATE(1363),
    [sym_function_declaration] = STATE(1363),
    [sym_export_clause] = STATE(1921),
    [sym_variable_declaration] = STATE(1363),
    [sym_lexical_declaration] = STATE(1363),
    [aux_sym_export_statement_repeat1] = STATE(2782),
    [sym_internal_module] = STATE(1363),
    [sym_enum_declaration] = STATE(1363),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(2725),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_var] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_as] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2759),
  },
  [840] = {
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym_computed_property_name] = STATE(1054),
    [anon_sym_get] = ACTIONS(3411),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3411),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [841] = {
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym_computed_property_name] = STATE(1054),
    [anon_sym_get] = ACTIONS(3411),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3411),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(968),
  },
  [842] = {
    [sym__call_signature] = STATE(2027),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(893),
    [sym__automatic_semicolon] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym_QMARK] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
  },
  [843] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(3429),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [844] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [845] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(321),
  },
  [846] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [847] = {
    [sym_formal_parameters] = STATE(1059),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [848] = {
    [sym_type_annotation] = STATE(275),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [849] = {
    [sym_type_annotation] = STATE(578),
    [anon_sym_EQ_GT] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [850] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(3445),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [851] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [anon_sym_GT] = ACTIONS(3445),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [853] = {
    [anon_sym_GT] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
  },
  [854] = {
    [sym_jsx_text] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3449),
  },
  [855] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [856] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3451),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [857] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3453),
    [sym__automatic_semicolon] = ACTIONS(3455),
    [anon_sym_BQUOTE] = ACTIONS(3457),
    [anon_sym_symbol] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3461),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_instanceof] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(3459),
    [sym_true] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_set] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym_number] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym_LT_LT] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3453),
    [sym_null] = ACTIONS(3459),
    [anon_sym_any] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_SLASH] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_CARET] = ACTIONS(3453),
    [anon_sym_export] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_with] = ACTIONS(3459),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3453),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_debugger] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_void] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3453),
    [sym_super] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_get] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [sym_this] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_type] = ACTIONS(3459),
    [anon_sym_STAR_STAR] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [sym_false] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_module] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_declare] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_boolean] = ACTIONS(3459),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_PIPE_PIPE] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3459),
    [sym_number] = ACTIONS(3457),
    [ts_builtin_sym_end] = ACTIONS(3457),
    [anon_sym_function] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_await] = ACTIONS(3459),
  },
  [858] = {
    [sym_class_body] = STATE(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [859] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1064),
    [sym_class_heritage] = STATE(1065),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [860] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [sym__automatic_semicolon] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_BQUOTE] = ACTIONS(3463),
    [anon_sym_PIPE] = ACTIONS(3465),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_LT_LT] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_GT_GT_GT] = ACTIONS(3463),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3465),
    [anon_sym_BANG_EQ] = ACTIONS(3465),
    [anon_sym_LT_EQ] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_GT_EQ] = ACTIONS(3463),
    [anon_sym_GT] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3465),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_as] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3465),
    [anon_sym_instanceof] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_SLASH] = ACTIONS(3465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_CARET] = ACTIONS(3463),
    [anon_sym_STAR_STAR] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3465),
    [anon_sym_GT_GT] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3463),
    [anon_sym_BANG] = ACTIONS(3465),
  },
  [861] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [sym__automatic_semicolon] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_BQUOTE] = ACTIONS(3467),
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_COMMA] = ACTIONS(3467),
    [anon_sym_LT_LT] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_GT_GT_GT] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_BANG_EQ] = ACTIONS(3469),
    [anon_sym_LT_EQ] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_GT_EQ] = ACTIONS(3467),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [anon_sym_PERCENT] = ACTIONS(3467),
    [anon_sym_QMARK] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3467),
    [anon_sym_as] = ACTIONS(3467),
    [anon_sym_PIPE_PIPE] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3467),
    [anon_sym_EQ_EQ] = ACTIONS(3469),
    [anon_sym_instanceof] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_SLASH] = ACTIONS(3469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3467),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_STAR_STAR] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_GT_GT] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3467),
    [anon_sym_BANG] = ACTIONS(3469),
  },
  [862] = {
    [sym_class_body] = STATE(1066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [863] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [sym__automatic_semicolon] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_GT_GT_GT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_BANG_EQ] = ACTIONS(3000),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_instanceof] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(2992),
    [anon_sym_STAR_STAR] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(3000),
  },
  [864] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [sym__automatic_semicolon] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_BQUOTE] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_GT_GT_GT] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_BANG_EQ] = ACTIONS(3010),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_GT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_as] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3010),
    [anon_sym_instanceof] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_GT_GT] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(3010),
  },
  [865] = {
    [sym_class_body] = STATE(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [866] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [867] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3175),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(3175),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [868] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3162),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [869] = {
    [sym_statement_block] = STATE(1068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [870] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1069),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [871] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [sym__automatic_semicolon] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [anon_sym_PIPE] = ACTIONS(3337),
    [anon_sym_COMMA] = ACTIONS(3329),
    [anon_sym_LT_LT] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_GT_GT_GT] = ACTIONS(3329),
    [anon_sym_AMP_AMP] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_BANG_EQ] = ACTIONS(3337),
    [anon_sym_LT_EQ] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_GT_EQ] = ACTIONS(3329),
    [anon_sym_GT] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_PERCENT] = ACTIONS(3329),
    [anon_sym_QMARK] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_as] = ACTIONS(3329),
    [anon_sym_PIPE_PIPE] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_EQ_EQ] = ACTIONS(3337),
    [anon_sym_instanceof] = ACTIONS(3329),
    [anon_sym_LT] = ACTIONS(3337),
    [anon_sym_SLASH] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3329),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_STAR_STAR] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_GT_GT] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_in] = ACTIONS(3337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3337),
  },
  [872] = {
    [sym_statement_block] = STATE(1070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [873] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [sym__automatic_semicolon] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_LT_LT] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_BANG_EQ] = ACTIONS(3461),
    [anon_sym_LT_EQ] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_GT_EQ] = ACTIONS(3453),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3453),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_as] = ACTIONS(3453),
    [anon_sym_PIPE_PIPE] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_EQ_EQ] = ACTIONS(3461),
    [anon_sym_instanceof] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3453),
    [anon_sym_CARET] = ACTIONS(3453),
    [anon_sym_STAR_STAR] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3461),
  },
  [874] = {
    [sym_class_body] = STATE(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [875] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1072),
    [sym_class_heritage] = STATE(1073),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [876] = {
    [anon_sym_BQUOTE] = ACTIONS(3471),
    [anon_sym_symbol] = ACTIONS(3473),
    [anon_sym_PIPE] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3473),
    [anon_sym_return] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_interface] = ACTIONS(3473),
    [anon_sym_delete] = ACTIONS(3473),
    [anon_sym_if] = ACTIONS(3473),
    [anon_sym_yield] = ACTIONS(3473),
    [sym_true] = ACTIONS(3473),
    [anon_sym_protected] = ACTIONS(3473),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_set] = ACTIONS(3473),
    [anon_sym_import] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_number] = ACTIONS(3473),
    [anon_sym_typeof] = ACTIONS(3473),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_switch] = ACTIONS(3473),
    [anon_sym_RBRACK] = ACTIONS(3471),
    [sym_null] = ACTIONS(3473),
    [anon_sym_any] = ACTIONS(3473),
    [anon_sym_async] = ACTIONS(3473),
    [anon_sym_public] = ACTIONS(3473),
    [anon_sym_var] = ACTIONS(3473),
    [anon_sym_while] = ACTIONS(3473),
    [anon_sym_SQUOTE] = ACTIONS(3471),
    [anon_sym_RPAREN] = ACTIONS(3471),
    [anon_sym_SLASH] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3473),
    [anon_sym_new] = ACTIONS(3473),
    [anon_sym_export] = ACTIONS(3473),
    [anon_sym_with] = ACTIONS(3473),
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_debugger] = ACTIONS(3473),
    [anon_sym_AT] = ACTIONS(3471),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_EQ] = ACTIONS(3473),
    [anon_sym_void] = ACTIONS(3473),
    [anon_sym_const] = ACTIONS(3473),
    [sym_super] = ACTIONS(3473),
    [anon_sym_private] = ACTIONS(3473),
    [anon_sym_get] = ACTIONS(3473),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(3473),
    [anon_sym_continue] = ACTIONS(3473),
    [anon_sym_DASH_DASH] = ACTIONS(3471),
    [sym_this] = ACTIONS(3473),
    [anon_sym_throw] = ACTIONS(3473),
    [anon_sym_abstract] = ACTIONS(3473),
    [anon_sym_type] = ACTIONS(3473),
    [anon_sym_namespace] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3471),
    [anon_sym_else] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [sym_false] = ACTIONS(3473),
    [anon_sym_case] = ACTIONS(3473),
    [anon_sym_module] = ACTIONS(3473),
    [anon_sym_class] = ACTIONS(3473),
    [anon_sym_declare] = ACTIONS(3473),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3471),
    [anon_sym_boolean] = ACTIONS(3473),
    [anon_sym_EQ_GT] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3473),
    [anon_sym_LT] = ACTIONS(3471),
    [sym_number] = ACTIONS(3471),
    [ts_builtin_sym_end] = ACTIONS(3471),
    [anon_sym_function] = ACTIONS(3473),
    [sym_undefined] = ACTIONS(3473),
    [anon_sym_let] = ACTIONS(3473),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_implements] = ACTIONS(3473),
    [anon_sym_do] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3471),
    [anon_sym_await] = ACTIONS(3473),
  },
  [877] = {
    [anon_sym_EQ_GT] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_RPAREN] = ACTIONS(3475),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_RBRACK] = ACTIONS(3475),
    [anon_sym_GT] = ACTIONS(3475),
  },
  [878] = {
    [aux_sym_object_type_repeat1] = STATE(1076),
    [sym__automatic_semicolon] = ACTIONS(3479),
    [anon_sym_RBRACE] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3481),
    [anon_sym_COMMA] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
  },
  [879] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1078),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [880] = {
    [sym_string] = STATE(1079),
    [sym__property_name] = STATE(1079),
    [sym_computed_property_name] = STATE(1079),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [881] = {
    [sym_string] = STATE(1079),
    [sym__property_name] = STATE(1079),
    [sym_computed_property_name] = STATE(1079),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [882] = {
    [sym_string] = STATE(1083),
    [sym__property_name] = STATE(1083),
    [sym_computed_property_name] = STATE(1083),
    [anon_sym_get] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [883] = {
    [sym_string] = STATE(1079),
    [sym__property_name] = STATE(1079),
    [sym_computed_property_name] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [884] = {
    [sym__call_signature] = STATE(1078),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1085),
    [sym__automatic_semicolon] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3497),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym_QMARK] = ACTIONS(3499),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3497),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
  },
  [885] = {
    [sym_type_annotation] = STATE(1086),
    [sym__automatic_semicolon] = ACTIONS(3501),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym_COMMA] = ACTIONS(3501),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3501),
    [sym_comment] = ACTIONS(3),
  },
  [886] = {
    [sym_formal_parameters] = STATE(1087),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [887] = {
    [sym_identifier] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
  },
  [888] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(3481),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3481),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [889] = {
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [anon_sym_symbol] = ACTIONS(3507),
    [anon_sym_PIPE] = ACTIONS(3505),
    [anon_sym_break] = ACTIONS(3507),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_static] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3507),
    [anon_sym_delete] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_yield] = ACTIONS(3507),
    [sym_true] = ACTIONS(3507),
    [anon_sym_protected] = ACTIONS(3507),
    [anon_sym_set] = ACTIONS(3507),
    [anon_sym_import] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym_number] = ACTIONS(3507),
    [anon_sym_typeof] = ACTIONS(3507),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_switch] = ACTIONS(3507),
    [anon_sym_RBRACK] = ACTIONS(3505),
    [sym_null] = ACTIONS(3507),
    [anon_sym_any] = ACTIONS(3507),
    [anon_sym_async] = ACTIONS(3507),
    [anon_sym_public] = ACTIONS(3507),
    [anon_sym_var] = ACTIONS(3507),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [anon_sym_RPAREN] = ACTIONS(3505),
    [anon_sym_SLASH] = ACTIONS(3507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_export] = ACTIONS(3507),
    [anon_sym_with] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3507),
    [anon_sym_debugger] = ACTIONS(3507),
    [anon_sym_AT] = ACTIONS(3505),
    [anon_sym_COMMA] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_EQ] = ACTIONS(3507),
    [anon_sym_void] = ACTIONS(3507),
    [anon_sym_const] = ACTIONS(3507),
    [sym_super] = ACTIONS(3507),
    [anon_sym_private] = ACTIONS(3507),
    [anon_sym_get] = ACTIONS(3507),
    [anon_sym_default] = ACTIONS(3507),
    [anon_sym_enum] = ACTIONS(3507),
    [anon_sym_continue] = ACTIONS(3507),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [sym_this] = ACTIONS(3507),
    [anon_sym_throw] = ACTIONS(3507),
    [anon_sym_abstract] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_else] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [sym_false] = ACTIONS(3507),
    [anon_sym_case] = ACTIONS(3507),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_class] = ACTIONS(3507),
    [anon_sym_declare] = ACTIONS(3507),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_GT] = ACTIONS(3505),
    [anon_sym_boolean] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_LT] = ACTIONS(3505),
    [sym_number] = ACTIONS(3505),
    [ts_builtin_sym_end] = ACTIONS(3505),
    [anon_sym_function] = ACTIONS(3507),
    [sym_undefined] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_await] = ACTIONS(3507),
  },
  [890] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(3479),
    [anon_sym_RBRACE] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3481),
    [anon_sym_COMMA] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
  },
  [891] = {
    [sym_string] = STATE(1083),
    [sym__property_name] = STATE(1083),
    [sym_computed_property_name] = STATE(1083),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_get] = ACTIONS(3487),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3487),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3509),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [892] = {
    [sym__call_signature] = STATE(1092),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1091),
    [sym__automatic_semicolon] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3511),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3511),
    [sym_comment] = ACTIONS(3),
  },
  [893] = {
    [sym__automatic_semicolon] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3513),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
  },
  [894] = {
    [sym__automatic_semicolon] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
  },
  [895] = {
    [anon_sym_BQUOTE] = ACTIONS(3515),
    [anon_sym_symbol] = ACTIONS(3517),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_if] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3517),
    [sym_true] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_set] = ACTIONS(3517),
    [anon_sym_import] = ACTIONS(3517),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_number] = ACTIONS(3517),
    [anon_sym_typeof] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_RBRACK] = ACTIONS(3515),
    [sym_null] = ACTIONS(3517),
    [anon_sym_any] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_var] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_RPAREN] = ACTIONS(3515),
    [anon_sym_SLASH] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_export] = ACTIONS(3517),
    [anon_sym_with] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3517),
    [anon_sym_debugger] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(3515),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_EQ] = ACTIONS(3517),
    [anon_sym_void] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [sym_super] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_get] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [sym_this] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_type] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_else] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [sym_false] = ACTIONS(3517),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_module] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_declare] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_GT] = ACTIONS(3515),
    [anon_sym_boolean] = ACTIONS(3517),
    [anon_sym_EQ_GT] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3515),
    [sym_number] = ACTIONS(3515),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [anon_sym_function] = ACTIONS(3517),
    [sym_undefined] = ACTIONS(3517),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_await] = ACTIONS(3517),
  },
  [896] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACK] = ACTIONS(3519),
    [sym_comment] = ACTIONS(3),
  },
  [897] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1094),
    [sym_function_type] = STATE(1094),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(1094),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(1094),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1094),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [898] = {
    [anon_sym_EQ_GT] = ACTIONS(3521),
    [sym_comment] = ACTIONS(3),
  },
  [899] = {
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [anon_sym_symbol] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3525),
    [sym_true] = ACTIONS(3525),
    [anon_sym_protected] = ACTIONS(3525),
    [anon_sym_set] = ACTIONS(3525),
    [anon_sym_import] = ACTIONS(3525),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_number] = ACTIONS(3525),
    [anon_sym_typeof] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_RBRACK] = ACTIONS(3523),
    [sym_null] = ACTIONS(3525),
    [anon_sym_any] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_public] = ACTIONS(3525),
    [anon_sym_var] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_SLASH] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_export] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3525),
    [anon_sym_debugger] = ACTIONS(3525),
    [anon_sym_AT] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_void] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [sym_super] = ACTIONS(3525),
    [anon_sym_private] = ACTIONS(3525),
    [anon_sym_get] = ACTIONS(3525),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [sym_this] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_type] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_else] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [sym_false] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_module] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_declare] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3523),
    [anon_sym_boolean] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3523),
    [sym_number] = ACTIONS(3523),
    [ts_builtin_sym_end] = ACTIONS(3523),
    [anon_sym_function] = ACTIONS(3525),
    [sym_undefined] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
    [anon_sym_await] = ACTIONS(3525),
  },
  [900] = {
    [anon_sym_EQ_GT] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
  },
  [901] = {
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [anon_sym_symbol] = ACTIONS(3533),
    [anon_sym_PIPE] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_static] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3533),
    [anon_sym_delete] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3533),
    [sym_true] = ACTIONS(3533),
    [anon_sym_protected] = ACTIONS(3533),
    [anon_sym_set] = ACTIONS(3533),
    [anon_sym_import] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_number] = ACTIONS(3533),
    [anon_sym_typeof] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3533),
    [anon_sym_RBRACK] = ACTIONS(3531),
    [sym_null] = ACTIONS(3533),
    [anon_sym_any] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_public] = ACTIONS(3533),
    [anon_sym_var] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3531),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_SLASH] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_export] = ACTIONS(3533),
    [anon_sym_with] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_debugger] = ACTIONS(3533),
    [anon_sym_AT] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_void] = ACTIONS(3533),
    [anon_sym_const] = ACTIONS(3533),
    [sym_super] = ACTIONS(3533),
    [anon_sym_private] = ACTIONS(3533),
    [anon_sym_get] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3533),
    [anon_sym_enum] = ACTIONS(3533),
    [anon_sym_continue] = ACTIONS(3533),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [sym_this] = ACTIONS(3533),
    [anon_sym_throw] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_type] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_else] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [sym_false] = ACTIONS(3533),
    [anon_sym_case] = ACTIONS(3533),
    [anon_sym_module] = ACTIONS(3533),
    [anon_sym_class] = ACTIONS(3533),
    [anon_sym_declare] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3531),
    [anon_sym_boolean] = ACTIONS(3533),
    [anon_sym_EQ_GT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3531),
    [sym_number] = ACTIONS(3531),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [anon_sym_function] = ACTIONS(3533),
    [sym_undefined] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3531),
    [anon_sym_await] = ACTIONS(3533),
  },
  [902] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_RBRACK] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
  },
  [903] = {
    [anon_sym_BQUOTE] = ACTIONS(3537),
    [anon_sym_symbol] = ACTIONS(3539),
    [anon_sym_PIPE] = ACTIONS(3537),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_delete] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_yield] = ACTIONS(3539),
    [sym_true] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_set] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_number] = ACTIONS(3539),
    [anon_sym_typeof] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_RBRACK] = ACTIONS(3537),
    [sym_null] = ACTIONS(3539),
    [anon_sym_any] = ACTIONS(3539),
    [anon_sym_async] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_var] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [anon_sym_RPAREN] = ACTIONS(3537),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_export] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3539),
    [sym_identifier] = ACTIONS(3539),
    [anon_sym_debugger] = ACTIONS(3539),
    [anon_sym_AT] = ACTIONS(3537),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_EQ] = ACTIONS(3539),
    [anon_sym_void] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [sym_super] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_get] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [sym_this] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_else] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [sym_false] = ACTIONS(3539),
    [anon_sym_case] = ACTIONS(3539),
    [anon_sym_module] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_declare] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_GT] = ACTIONS(3537),
    [anon_sym_boolean] = ACTIONS(3539),
    [anon_sym_EQ_GT] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3537),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_LT] = ACTIONS(3537),
    [sym_number] = ACTIONS(3537),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [anon_sym_function] = ACTIONS(3539),
    [sym_undefined] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_await] = ACTIONS(3539),
  },
  [904] = {
    [anon_sym_BQUOTE] = ACTIONS(3541),
    [anon_sym_symbol] = ACTIONS(3543),
    [anon_sym_PIPE] = ACTIONS(3541),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_delete] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_yield] = ACTIONS(3543),
    [sym_true] = ACTIONS(3543),
    [anon_sym_protected] = ACTIONS(3543),
    [anon_sym_set] = ACTIONS(3543),
    [anon_sym_import] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_number] = ACTIONS(3543),
    [anon_sym_typeof] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_RBRACK] = ACTIONS(3541),
    [sym_null] = ACTIONS(3543),
    [anon_sym_any] = ACTIONS(3543),
    [anon_sym_async] = ACTIONS(3543),
    [anon_sym_public] = ACTIONS(3543),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [anon_sym_RPAREN] = ACTIONS(3541),
    [anon_sym_SLASH] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_export] = ACTIONS(3543),
    [anon_sym_with] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(3543),
    [anon_sym_debugger] = ACTIONS(3543),
    [anon_sym_AT] = ACTIONS(3541),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_EQ] = ACTIONS(3543),
    [anon_sym_void] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [sym_super] = ACTIONS(3543),
    [anon_sym_private] = ACTIONS(3543),
    [anon_sym_get] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [sym_this] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_type] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_else] = ACTIONS(3543),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [sym_false] = ACTIONS(3543),
    [anon_sym_case] = ACTIONS(3543),
    [anon_sym_module] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_declare] = ACTIONS(3543),
    [anon_sym_LPAREN] = ACTIONS(3541),
    [anon_sym_GT] = ACTIONS(3541),
    [anon_sym_boolean] = ACTIONS(3543),
    [anon_sym_EQ_GT] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_LT] = ACTIONS(3541),
    [sym_number] = ACTIONS(3541),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3543),
    [sym_undefined] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_await] = ACTIONS(3543),
  },
  [905] = {
    [anon_sym_EQ_GT] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [anon_sym_BQUOTE] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_RPAREN] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_COMMA] = ACTIONS(3545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_RBRACK] = ACTIONS(3545),
    [sym_jsx_identifier] = ACTIONS(3545),
    [anon_sym_GT] = ACTIONS(3545),
  },
  [906] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RBRACK] = ACTIONS(3549),
    [anon_sym_GT] = ACTIONS(3549),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(3549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3549),
  },
  [907] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [908] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_GT] = ACTIONS(3549),
    [anon_sym_RBRACK] = ACTIONS(3549),
    [anon_sym_COMMA] = ACTIONS(3553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3549),
  },
  [909] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1098),
    [sym_function_type] = STATE(1098),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(1098),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(1098),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1098),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [910] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(3556),
    [sym__automatic_semicolon] = ACTIONS(3556),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_BQUOTE] = ACTIONS(3556),
    [anon_sym_PIPE] = ACTIONS(3558),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_LT_LT] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3558),
    [anon_sym_GT_GT_GT] = ACTIONS(3556),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_BANG_EQ] = ACTIONS(3558),
    [anon_sym_LT_EQ] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3556),
    [anon_sym_GT_EQ] = ACTIONS(3556),
    [anon_sym_GT] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(3558),
    [anon_sym_PERCENT] = ACTIONS(3556),
    [anon_sym_QMARK] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_as] = ACTIONS(3556),
    [anon_sym_PIPE_PIPE] = ACTIONS(3556),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_EQ_EQ] = ACTIONS(3558),
    [anon_sym_instanceof] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3558),
    [anon_sym_SLASH] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3556),
    [anon_sym_CARET] = ACTIONS(3556),
    [anon_sym_STAR_STAR] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_GT_GT] = ACTIONS(3558),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3556),
    [anon_sym_BANG] = ACTIONS(3558),
  },
  [911] = {
    [sym_identifier] = ACTIONS(3560),
    [anon_sym_BQUOTE] = ACTIONS(3562),
    [anon_sym_debugger] = ACTIONS(3560),
    [anon_sym_symbol] = ACTIONS(3560),
    [anon_sym_AT] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3560),
    [anon_sym_void] = ACTIONS(3560),
    [anon_sym_break] = ACTIONS(3560),
    [anon_sym_const] = ACTIONS(3560),
    [sym_super] = ACTIONS(3560),
    [anon_sym_return] = ACTIONS(3560),
    [anon_sym_private] = ACTIONS(3560),
    [anon_sym_static] = ACTIONS(3560),
    [anon_sym_get] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3560),
    [anon_sym_default] = ACTIONS(3560),
    [anon_sym_enum] = ACTIONS(3560),
    [anon_sym_delete] = ACTIONS(3560),
    [anon_sym_continue] = ACTIONS(3560),
    [anon_sym_DASH_DASH] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3560),
    [sym_this] = ACTIONS(3560),
    [anon_sym_yield] = ACTIONS(3560),
    [sym_true] = ACTIONS(3560),
    [anon_sym_throw] = ACTIONS(3560),
    [anon_sym_protected] = ACTIONS(3560),
    [anon_sym_abstract] = ACTIONS(3560),
    [anon_sym_set] = ACTIONS(3560),
    [anon_sym_type] = ACTIONS(3560),
    [anon_sym_import] = ACTIONS(3560),
    [anon_sym_namespace] = ACTIONS(3560),
    [anon_sym_PLUS_PLUS] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [anon_sym_else] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [sym_false] = ACTIONS(3560),
    [anon_sym_SEMI] = ACTIONS(3562),
    [anon_sym_case] = ACTIONS(3560),
    [anon_sym_module] = ACTIONS(3560),
    [anon_sym_number] = ACTIONS(3560),
    [anon_sym_class] = ACTIONS(3560),
    [anon_sym_declare] = ACTIONS(3560),
    [anon_sym_typeof] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3562),
    [anon_sym_switch] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3562),
    [sym_null] = ACTIONS(3560),
    [anon_sym_any] = ACTIONS(3560),
    [anon_sym_boolean] = ACTIONS(3560),
    [anon_sym_async] = ACTIONS(3560),
    [anon_sym_public] = ACTIONS(3560),
    [anon_sym_var] = ACTIONS(3560),
    [anon_sym_while] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_try] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3562),
    [sym_number] = ACTIONS(3562),
    [anon_sym_SLASH] = ACTIONS(3560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3560),
    [anon_sym_function] = ACTIONS(3560),
    [sym_undefined] = ACTIONS(3560),
    [anon_sym_new] = ACTIONS(3560),
    [ts_builtin_sym_end] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3560),
    [anon_sym_export] = ACTIONS(3560),
    [anon_sym_do] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3562),
    [anon_sym_with] = ACTIONS(3560),
    [anon_sym_await] = ACTIONS(3560),
  },
  [912] = {
    [sym_computed_property_name] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_enum_assignment] = STATE(1101),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(3564),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_number] = ACTIONS(3566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [913] = {
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_BQUOTE] = ACTIONS(3570),
    [anon_sym_debugger] = ACTIONS(3568),
    [anon_sym_symbol] = ACTIONS(3568),
    [anon_sym_AT] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3568),
    [anon_sym_void] = ACTIONS(3568),
    [anon_sym_break] = ACTIONS(3568),
    [anon_sym_const] = ACTIONS(3568),
    [sym_super] = ACTIONS(3568),
    [anon_sym_return] = ACTIONS(3568),
    [anon_sym_private] = ACTIONS(3568),
    [anon_sym_static] = ACTIONS(3568),
    [anon_sym_get] = ACTIONS(3568),
    [anon_sym_RBRACE] = ACTIONS(3570),
    [anon_sym_interface] = ACTIONS(3568),
    [anon_sym_default] = ACTIONS(3568),
    [anon_sym_enum] = ACTIONS(3568),
    [anon_sym_delete] = ACTIONS(3568),
    [anon_sym_continue] = ACTIONS(3568),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_if] = ACTIONS(3568),
    [sym_this] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3568),
    [sym_true] = ACTIONS(3568),
    [anon_sym_throw] = ACTIONS(3568),
    [anon_sym_protected] = ACTIONS(3568),
    [anon_sym_abstract] = ACTIONS(3568),
    [anon_sym_set] = ACTIONS(3568),
    [anon_sym_type] = ACTIONS(3568),
    [anon_sym_import] = ACTIONS(3568),
    [anon_sym_namespace] = ACTIONS(3568),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_DQUOTE] = ACTIONS(3570),
    [anon_sym_else] = ACTIONS(3568),
    [anon_sym_BANG] = ACTIONS(3570),
    [anon_sym_for] = ACTIONS(3568),
    [anon_sym_LBRACK] = ACTIONS(3570),
    [sym_false] = ACTIONS(3568),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym_case] = ACTIONS(3568),
    [anon_sym_module] = ACTIONS(3568),
    [anon_sym_number] = ACTIONS(3568),
    [anon_sym_class] = ACTIONS(3568),
    [anon_sym_declare] = ACTIONS(3568),
    [anon_sym_typeof] = ACTIONS(3568),
    [anon_sym_LBRACE] = ACTIONS(3570),
    [anon_sym_switch] = ACTIONS(3568),
    [anon_sym_LPAREN] = ACTIONS(3570),
    [sym_null] = ACTIONS(3568),
    [anon_sym_any] = ACTIONS(3568),
    [anon_sym_boolean] = ACTIONS(3568),
    [anon_sym_async] = ACTIONS(3568),
    [anon_sym_public] = ACTIONS(3568),
    [anon_sym_var] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(3568),
    [anon_sym_SQUOTE] = ACTIONS(3570),
    [anon_sym_try] = ACTIONS(3568),
    [anon_sym_LT] = ACTIONS(3570),
    [sym_number] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3568),
    [anon_sym_function] = ACTIONS(3568),
    [sym_undefined] = ACTIONS(3568),
    [anon_sym_new] = ACTIONS(3568),
    [ts_builtin_sym_end] = ACTIONS(3570),
    [anon_sym_let] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_export] = ACTIONS(3568),
    [anon_sym_do] = ACTIONS(3568),
    [anon_sym_TILDE] = ACTIONS(3570),
    [anon_sym_with] = ACTIONS(3568),
    [anon_sym_await] = ACTIONS(3568),
  },
  [914] = {
    [anon_sym_COMMA] = ACTIONS(3572),
    [anon_sym_RBRACE] = ACTIONS(3572),
    [sym_comment] = ACTIONS(3),
  },
  [915] = {
    [aux_sym_enum_body_repeat1] = STATE(1103),
    [anon_sym_RBRACE] = ACTIONS(3564),
    [anon_sym_COMMA] = ACTIONS(3574),
    [sym_comment] = ACTIONS(3),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3576),
    [anon_sym_BQUOTE] = ACTIONS(3578),
    [anon_sym_debugger] = ACTIONS(3576),
    [anon_sym_symbol] = ACTIONS(3576),
    [anon_sym_AT] = ACTIONS(3578),
    [anon_sym_DASH] = ACTIONS(3576),
    [anon_sym_void] = ACTIONS(3576),
    [anon_sym_break] = ACTIONS(3576),
    [anon_sym_const] = ACTIONS(3576),
    [sym_super] = ACTIONS(3576),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_private] = ACTIONS(3576),
    [anon_sym_static] = ACTIONS(3576),
    [anon_sym_get] = ACTIONS(3576),
    [anon_sym_RBRACE] = ACTIONS(3578),
    [anon_sym_interface] = ACTIONS(3576),
    [anon_sym_default] = ACTIONS(3576),
    [anon_sym_enum] = ACTIONS(3576),
    [anon_sym_delete] = ACTIONS(3576),
    [anon_sym_continue] = ACTIONS(3576),
    [anon_sym_DASH_DASH] = ACTIONS(3578),
    [anon_sym_if] = ACTIONS(3576),
    [sym_this] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3576),
    [sym_true] = ACTIONS(3576),
    [anon_sym_throw] = ACTIONS(3576),
    [anon_sym_protected] = ACTIONS(3576),
    [anon_sym_abstract] = ACTIONS(3576),
    [anon_sym_set] = ACTIONS(3576),
    [anon_sym_type] = ACTIONS(3576),
    [anon_sym_import] = ACTIONS(3576),
    [anon_sym_namespace] = ACTIONS(3576),
    [anon_sym_PLUS_PLUS] = ACTIONS(3578),
    [anon_sym_DQUOTE] = ACTIONS(3578),
    [anon_sym_else] = ACTIONS(3576),
    [anon_sym_BANG] = ACTIONS(3578),
    [anon_sym_for] = ACTIONS(3576),
    [anon_sym_LBRACK] = ACTIONS(3578),
    [sym_false] = ACTIONS(3576),
    [anon_sym_SEMI] = ACTIONS(3578),
    [anon_sym_case] = ACTIONS(3576),
    [anon_sym_module] = ACTIONS(3576),
    [anon_sym_number] = ACTIONS(3576),
    [anon_sym_class] = ACTIONS(3576),
    [anon_sym_declare] = ACTIONS(3576),
    [anon_sym_typeof] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3578),
    [anon_sym_switch] = ACTIONS(3576),
    [anon_sym_LPAREN] = ACTIONS(3578),
    [sym_null] = ACTIONS(3576),
    [anon_sym_any] = ACTIONS(3576),
    [anon_sym_boolean] = ACTIONS(3576),
    [anon_sym_async] = ACTIONS(3576),
    [anon_sym_public] = ACTIONS(3576),
    [anon_sym_var] = ACTIONS(3576),
    [anon_sym_while] = ACTIONS(3576),
    [anon_sym_SQUOTE] = ACTIONS(3578),
    [anon_sym_try] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3578),
    [sym_number] = ACTIONS(3578),
    [anon_sym_SLASH] = ACTIONS(3576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3576),
    [anon_sym_function] = ACTIONS(3576),
    [sym_undefined] = ACTIONS(3576),
    [anon_sym_new] = ACTIONS(3576),
    [ts_builtin_sym_end] = ACTIONS(3578),
    [anon_sym_let] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3576),
    [anon_sym_export] = ACTIONS(3576),
    [anon_sym_do] = ACTIONS(3576),
    [anon_sym_TILDE] = ACTIONS(3578),
    [anon_sym_with] = ACTIONS(3576),
    [anon_sym_await] = ACTIONS(3576),
  },
  [917] = {
    [sym_identifier] = ACTIONS(3580),
    [anon_sym_BQUOTE] = ACTIONS(3582),
    [anon_sym_debugger] = ACTIONS(3580),
    [anon_sym_symbol] = ACTIONS(3580),
    [anon_sym_AT] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_void] = ACTIONS(3580),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_const] = ACTIONS(3580),
    [sym_super] = ACTIONS(3580),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_private] = ACTIONS(3580),
    [anon_sym_static] = ACTIONS(3580),
    [anon_sym_get] = ACTIONS(3580),
    [anon_sym_RBRACE] = ACTIONS(3582),
    [anon_sym_interface] = ACTIONS(3580),
    [anon_sym_default] = ACTIONS(3580),
    [anon_sym_enum] = ACTIONS(3580),
    [anon_sym_delete] = ACTIONS(3580),
    [anon_sym_continue] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(3582),
    [anon_sym_if] = ACTIONS(3580),
    [sym_this] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3580),
    [sym_true] = ACTIONS(3580),
    [anon_sym_throw] = ACTIONS(3580),
    [anon_sym_protected] = ACTIONS(3580),
    [anon_sym_abstract] = ACTIONS(3580),
    [anon_sym_set] = ACTIONS(3580),
    [anon_sym_type] = ACTIONS(3580),
    [anon_sym_import] = ACTIONS(3580),
    [anon_sym_namespace] = ACTIONS(3580),
    [anon_sym_PLUS_PLUS] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3582),
    [anon_sym_else] = ACTIONS(3580),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_for] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [sym_false] = ACTIONS(3580),
    [anon_sym_SEMI] = ACTIONS(3582),
    [anon_sym_case] = ACTIONS(3580),
    [anon_sym_module] = ACTIONS(3580),
    [anon_sym_number] = ACTIONS(3580),
    [anon_sym_class] = ACTIONS(3580),
    [anon_sym_declare] = ACTIONS(3580),
    [anon_sym_typeof] = ACTIONS(3580),
    [anon_sym_LBRACE] = ACTIONS(3582),
    [anon_sym_switch] = ACTIONS(3580),
    [anon_sym_LPAREN] = ACTIONS(3582),
    [sym_null] = ACTIONS(3580),
    [anon_sym_any] = ACTIONS(3580),
    [anon_sym_boolean] = ACTIONS(3580),
    [anon_sym_async] = ACTIONS(3580),
    [anon_sym_public] = ACTIONS(3580),
    [anon_sym_var] = ACTIONS(3580),
    [anon_sym_while] = ACTIONS(3580),
    [anon_sym_SQUOTE] = ACTIONS(3582),
    [anon_sym_try] = ACTIONS(3580),
    [anon_sym_LT] = ACTIONS(3582),
    [sym_number] = ACTIONS(3582),
    [anon_sym_SLASH] = ACTIONS(3580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3580),
    [anon_sym_function] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_new] = ACTIONS(3580),
    [ts_builtin_sym_end] = ACTIONS(3582),
    [anon_sym_let] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_export] = ACTIONS(3580),
    [anon_sym_do] = ACTIONS(3580),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_with] = ACTIONS(3580),
    [anon_sym_await] = ACTIONS(3580),
  },
  [918] = {
    [sym_identifier] = ACTIONS(3584),
    [anon_sym_BQUOTE] = ACTIONS(3586),
    [anon_sym_debugger] = ACTIONS(3584),
    [anon_sym_symbol] = ACTIONS(3584),
    [anon_sym_AT] = ACTIONS(3586),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_void] = ACTIONS(3584),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_const] = ACTIONS(3584),
    [sym_super] = ACTIONS(3584),
    [anon_sym_return] = ACTIONS(3584),
    [anon_sym_private] = ACTIONS(3584),
    [anon_sym_static] = ACTIONS(3584),
    [anon_sym_get] = ACTIONS(3584),
    [anon_sym_RBRACE] = ACTIONS(3586),
    [anon_sym_interface] = ACTIONS(3584),
    [anon_sym_default] = ACTIONS(3584),
    [anon_sym_enum] = ACTIONS(3584),
    [anon_sym_delete] = ACTIONS(3584),
    [anon_sym_continue] = ACTIONS(3584),
    [anon_sym_DASH_DASH] = ACTIONS(3586),
    [anon_sym_if] = ACTIONS(3584),
    [sym_this] = ACTIONS(3584),
    [anon_sym_yield] = ACTIONS(3584),
    [sym_true] = ACTIONS(3584),
    [anon_sym_throw] = ACTIONS(3584),
    [anon_sym_protected] = ACTIONS(3584),
    [anon_sym_abstract] = ACTIONS(3584),
    [anon_sym_set] = ACTIONS(3584),
    [anon_sym_type] = ACTIONS(3584),
    [anon_sym_import] = ACTIONS(3584),
    [anon_sym_namespace] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3586),
    [anon_sym_else] = ACTIONS(3584),
    [anon_sym_BANG] = ACTIONS(3586),
    [anon_sym_for] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(3586),
    [sym_false] = ACTIONS(3584),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_case] = ACTIONS(3584),
    [anon_sym_module] = ACTIONS(3584),
    [anon_sym_number] = ACTIONS(3584),
    [anon_sym_class] = ACTIONS(3584),
    [anon_sym_declare] = ACTIONS(3584),
    [anon_sym_typeof] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_switch] = ACTIONS(3584),
    [anon_sym_LPAREN] = ACTIONS(3586),
    [sym_null] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3584),
    [anon_sym_boolean] = ACTIONS(3584),
    [anon_sym_async] = ACTIONS(3584),
    [anon_sym_public] = ACTIONS(3584),
    [anon_sym_var] = ACTIONS(3584),
    [anon_sym_while] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(3586),
    [anon_sym_try] = ACTIONS(3584),
    [anon_sym_LT] = ACTIONS(3586),
    [sym_number] = ACTIONS(3586),
    [anon_sym_SLASH] = ACTIONS(3584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3584),
    [anon_sym_function] = ACTIONS(3584),
    [sym_undefined] = ACTIONS(3584),
    [anon_sym_new] = ACTIONS(3584),
    [ts_builtin_sym_end] = ACTIONS(3586),
    [anon_sym_let] = ACTIONS(3584),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_do] = ACTIONS(3584),
    [anon_sym_TILDE] = ACTIONS(3586),
    [anon_sym_with] = ACTIONS(3584),
    [anon_sym_await] = ACTIONS(3584),
  },
  [919] = {
    [sym_class_body] = STATE(1104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1919),
  },
  [920] = {
    [sym_identifier] = ACTIONS(3588),
    [anon_sym_BQUOTE] = ACTIONS(3590),
    [anon_sym_debugger] = ACTIONS(3588),
    [anon_sym_symbol] = ACTIONS(3588),
    [anon_sym_AT] = ACTIONS(3590),
    [anon_sym_DASH] = ACTIONS(3588),
    [anon_sym_void] = ACTIONS(3588),
    [anon_sym_break] = ACTIONS(3588),
    [anon_sym_const] = ACTIONS(3588),
    [sym_super] = ACTIONS(3588),
    [anon_sym_return] = ACTIONS(3588),
    [anon_sym_private] = ACTIONS(3588),
    [anon_sym_static] = ACTIONS(3588),
    [anon_sym_get] = ACTIONS(3588),
    [anon_sym_RBRACE] = ACTIONS(3590),
    [anon_sym_interface] = ACTIONS(3588),
    [anon_sym_default] = ACTIONS(3588),
    [anon_sym_enum] = ACTIONS(3588),
    [anon_sym_delete] = ACTIONS(3588),
    [anon_sym_continue] = ACTIONS(3588),
    [anon_sym_DASH_DASH] = ACTIONS(3590),
    [anon_sym_if] = ACTIONS(3588),
    [sym_this] = ACTIONS(3588),
    [anon_sym_yield] = ACTIONS(3588),
    [sym_true] = ACTIONS(3588),
    [anon_sym_throw] = ACTIONS(3588),
    [anon_sym_protected] = ACTIONS(3588),
    [anon_sym_abstract] = ACTIONS(3588),
    [anon_sym_set] = ACTIONS(3588),
    [anon_sym_type] = ACTIONS(3588),
    [anon_sym_import] = ACTIONS(3588),
    [anon_sym_namespace] = ACTIONS(3588),
    [anon_sym_PLUS_PLUS] = ACTIONS(3590),
    [anon_sym_DQUOTE] = ACTIONS(3590),
    [anon_sym_else] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_for] = ACTIONS(3588),
    [anon_sym_LBRACK] = ACTIONS(3590),
    [sym_false] = ACTIONS(3588),
    [anon_sym_SEMI] = ACTIONS(3590),
    [anon_sym_case] = ACTIONS(3588),
    [anon_sym_module] = ACTIONS(3588),
    [anon_sym_number] = ACTIONS(3588),
    [anon_sym_class] = ACTIONS(3588),
    [anon_sym_declare] = ACTIONS(3588),
    [anon_sym_typeof] = ACTIONS(3588),
    [anon_sym_LBRACE] = ACTIONS(3590),
    [anon_sym_switch] = ACTIONS(3588),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [sym_null] = ACTIONS(3588),
    [anon_sym_any] = ACTIONS(3588),
    [anon_sym_boolean] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(3588),
    [anon_sym_public] = ACTIONS(3588),
    [anon_sym_var] = ACTIONS(3588),
    [anon_sym_while] = ACTIONS(3588),
    [anon_sym_SQUOTE] = ACTIONS(3590),
    [anon_sym_try] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(3590),
    [sym_number] = ACTIONS(3590),
    [anon_sym_SLASH] = ACTIONS(3588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3588),
    [anon_sym_function] = ACTIONS(3588),
    [sym_undefined] = ACTIONS(3588),
    [anon_sym_new] = ACTIONS(3588),
    [ts_builtin_sym_end] = ACTIONS(3590),
    [anon_sym_let] = ACTIONS(3588),
    [anon_sym_PLUS] = ACTIONS(3588),
    [anon_sym_export] = ACTIONS(3588),
    [anon_sym_do] = ACTIONS(3588),
    [anon_sym_TILDE] = ACTIONS(3590),
    [anon_sym_with] = ACTIONS(3588),
    [anon_sym_await] = ACTIONS(3588),
  },
  [921] = {
    [sym__automatic_semicolon] = ACTIONS(3592),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(3592),
    [anon_sym_PIPE] = ACTIONS(2864),
    [sym_comment] = ACTIONS(3),
  },
  [922] = {
    [sym_string] = STATE(1106),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [923] = {
    [sym_identifier] = ACTIONS(3594),
    [anon_sym_BQUOTE] = ACTIONS(3596),
    [anon_sym_debugger] = ACTIONS(3594),
    [anon_sym_symbol] = ACTIONS(3594),
    [anon_sym_AT] = ACTIONS(3596),
    [anon_sym_DASH] = ACTIONS(3594),
    [anon_sym_void] = ACTIONS(3594),
    [anon_sym_break] = ACTIONS(3594),
    [anon_sym_const] = ACTIONS(3594),
    [sym_super] = ACTIONS(3594),
    [anon_sym_return] = ACTIONS(3594),
    [anon_sym_private] = ACTIONS(3594),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3594),
    [anon_sym_RBRACE] = ACTIONS(3596),
    [anon_sym_interface] = ACTIONS(3594),
    [anon_sym_default] = ACTIONS(3594),
    [anon_sym_enum] = ACTIONS(3594),
    [anon_sym_delete] = ACTIONS(3594),
    [anon_sym_continue] = ACTIONS(3594),
    [anon_sym_DASH_DASH] = ACTIONS(3596),
    [anon_sym_if] = ACTIONS(3594),
    [sym_this] = ACTIONS(3594),
    [anon_sym_yield] = ACTIONS(3594),
    [sym_true] = ACTIONS(3594),
    [anon_sym_throw] = ACTIONS(3594),
    [anon_sym_protected] = ACTIONS(3594),
    [anon_sym_abstract] = ACTIONS(3594),
    [anon_sym_set] = ACTIONS(3594),
    [anon_sym_type] = ACTIONS(3594),
    [anon_sym_import] = ACTIONS(3594),
    [anon_sym_namespace] = ACTIONS(3594),
    [anon_sym_PLUS_PLUS] = ACTIONS(3596),
    [anon_sym_DQUOTE] = ACTIONS(3596),
    [anon_sym_else] = ACTIONS(3594),
    [anon_sym_BANG] = ACTIONS(3596),
    [anon_sym_for] = ACTIONS(3594),
    [anon_sym_LBRACK] = ACTIONS(3596),
    [sym_false] = ACTIONS(3594),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_case] = ACTIONS(3594),
    [anon_sym_module] = ACTIONS(3594),
    [anon_sym_number] = ACTIONS(3594),
    [anon_sym_class] = ACTIONS(3594),
    [anon_sym_declare] = ACTIONS(3594),
    [anon_sym_typeof] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(3596),
    [anon_sym_switch] = ACTIONS(3594),
    [anon_sym_LPAREN] = ACTIONS(3596),
    [sym_null] = ACTIONS(3594),
    [anon_sym_any] = ACTIONS(3594),
    [anon_sym_boolean] = ACTIONS(3594),
    [anon_sym_async] = ACTIONS(3594),
    [anon_sym_public] = ACTIONS(3594),
    [anon_sym_var] = ACTIONS(3594),
    [anon_sym_while] = ACTIONS(3594),
    [anon_sym_SQUOTE] = ACTIONS(3596),
    [anon_sym_try] = ACTIONS(3594),
    [anon_sym_LT] = ACTIONS(3596),
    [sym_number] = ACTIONS(3596),
    [anon_sym_SLASH] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3594),
    [anon_sym_function] = ACTIONS(3594),
    [sym_undefined] = ACTIONS(3594),
    [anon_sym_new] = ACTIONS(3594),
    [ts_builtin_sym_end] = ACTIONS(3596),
    [anon_sym_let] = ACTIONS(3594),
    [anon_sym_PLUS] = ACTIONS(3594),
    [anon_sym_export] = ACTIONS(3594),
    [anon_sym_do] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3596),
    [anon_sym_with] = ACTIONS(3594),
    [anon_sym_await] = ACTIONS(3594),
  },
  [924] = {
    [sym_identifier] = ACTIONS(3598),
    [anon_sym_BQUOTE] = ACTIONS(3600),
    [anon_sym_debugger] = ACTIONS(3598),
    [anon_sym_symbol] = ACTIONS(3598),
    [anon_sym_AT] = ACTIONS(3600),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_void] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3598),
    [anon_sym_const] = ACTIONS(3598),
    [sym_super] = ACTIONS(3598),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_static] = ACTIONS(3598),
    [anon_sym_get] = ACTIONS(3598),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_interface] = ACTIONS(3598),
    [anon_sym_default] = ACTIONS(3598),
    [anon_sym_enum] = ACTIONS(3598),
    [anon_sym_delete] = ACTIONS(3598),
    [anon_sym_continue] = ACTIONS(3598),
    [anon_sym_DASH_DASH] = ACTIONS(3600),
    [anon_sym_if] = ACTIONS(3598),
    [sym_this] = ACTIONS(3598),
    [anon_sym_yield] = ACTIONS(3598),
    [sym_true] = ACTIONS(3598),
    [anon_sym_throw] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_abstract] = ACTIONS(3598),
    [anon_sym_set] = ACTIONS(3598),
    [anon_sym_type] = ACTIONS(3598),
    [anon_sym_import] = ACTIONS(3598),
    [anon_sym_namespace] = ACTIONS(3598),
    [anon_sym_PLUS_PLUS] = ACTIONS(3600),
    [anon_sym_DQUOTE] = ACTIONS(3600),
    [anon_sym_else] = ACTIONS(3598),
    [anon_sym_BANG] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(3600),
    [sym_false] = ACTIONS(3598),
    [anon_sym_SEMI] = ACTIONS(3600),
    [anon_sym_case] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3598),
    [anon_sym_number] = ACTIONS(3598),
    [anon_sym_class] = ACTIONS(3598),
    [anon_sym_declare] = ACTIONS(3598),
    [anon_sym_typeof] = ACTIONS(3598),
    [anon_sym_LBRACE] = ACTIONS(3600),
    [anon_sym_switch] = ACTIONS(3598),
    [anon_sym_LPAREN] = ACTIONS(3600),
    [sym_null] = ACTIONS(3598),
    [anon_sym_any] = ACTIONS(3598),
    [anon_sym_boolean] = ACTIONS(3598),
    [anon_sym_async] = ACTIONS(3598),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_var] = ACTIONS(3598),
    [anon_sym_while] = ACTIONS(3598),
    [anon_sym_SQUOTE] = ACTIONS(3600),
    [anon_sym_try] = ACTIONS(3598),
    [anon_sym_LT] = ACTIONS(3600),
    [sym_number] = ACTIONS(3600),
    [anon_sym_SLASH] = ACTIONS(3598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3598),
    [anon_sym_function] = ACTIONS(3598),
    [sym_undefined] = ACTIONS(3598),
    [anon_sym_new] = ACTIONS(3598),
    [ts_builtin_sym_end] = ACTIONS(3600),
    [anon_sym_let] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_export] = ACTIONS(3598),
    [anon_sym_do] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3600),
    [anon_sym_with] = ACTIONS(3598),
    [anon_sym_await] = ACTIONS(3598),
  },
  [925] = {
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_RBRACE] = ACTIONS(3602),
    [sym_comment] = ACTIONS(3),
  },
  [926] = {
    [sym_identifier] = ACTIONS(3604),
    [sym_comment] = ACTIONS(3),
  },
  [927] = {
    [anon_sym_from] = ACTIONS(3606),
    [sym_comment] = ACTIONS(3),
  },
  [928] = {
    [anon_sym_COMMA] = ACTIONS(3608),
    [anon_sym_RBRACE] = ACTIONS(3608),
    [sym_comment] = ACTIONS(3),
  },
  [929] = {
    [sym__import_export_specifier] = STATE(928),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [930] = {
    [aux_sym_named_imports_repeat1] = STATE(930),
    [anon_sym_COMMA] = ACTIONS(3612),
    [anon_sym_RBRACE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [931] = {
    [anon_sym_RPAREN] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
  },
  [932] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [933] = {
    [anon_sym_RPAREN] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
  },
  [934] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [935] = {
    [sym_class] = STATE(1112),
    [sym_arrow_function] = STATE(1112),
    [sym_await_expression] = STATE(1112),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(1112),
    [sym_meta_property] = STATE(1112),
    [sym__expression] = STATE(1112),
    [sym_jsx_element] = STATE(1112),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1112),
    [sym_call_expression] = STATE(1112),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1112),
    [sym_string] = STATE(1112),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1112),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1112),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(1112),
    [sym_generator_function] = STATE(1112),
    [sym_new_expression] = STATE(1112),
    [sym_assignment_expression] = STATE(1112),
    [sym_augmented_assignment_expression] = STATE(1112),
    [sym_binary_expression] = STATE(1112),
    [sym_unary_expression] = STATE(1112),
    [sym_regex] = STATE(1112),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1112),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1112),
    [sym_internal_module] = STATE(1112),
    [sym_jsx_self_closing_element] = STATE(1112),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(3621),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3621),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3621),
    [sym_number] = ACTIONS(3623),
    [sym_true] = ACTIONS(3621),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3621),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [936] = {
    [sym_class] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1114),
    [sym_sequence_expression] = STATE(1113),
    [sym_meta_property] = STATE(1114),
    [sym__expression] = STATE(1114),
    [sym_jsx_element] = STATE(1114),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1114),
    [sym_call_expression] = STATE(1114),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1114),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1114),
    [sym_generator_function] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_regex] = STATE(1114),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1114),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_jsx_self_closing_element] = STATE(1114),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3625),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3625),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3625),
    [sym_number] = ACTIONS(3627),
    [sym_true] = ACTIONS(3625),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3625),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [937] = {
    [sym_class] = STATE(1116),
    [sym_arrow_function] = STATE(1116),
    [sym_await_expression] = STATE(1116),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1116),
    [sym_sequence_expression] = STATE(1115),
    [sym_meta_property] = STATE(1116),
    [sym__expression] = STATE(1116),
    [sym_jsx_element] = STATE(1116),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1116),
    [sym_call_expression] = STATE(1116),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1116),
    [sym_string] = STATE(1116),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1116),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1116),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1116),
    [sym_generator_function] = STATE(1116),
    [sym_new_expression] = STATE(1116),
    [sym_assignment_expression] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(1116),
    [sym_binary_expression] = STATE(1116),
    [sym_unary_expression] = STATE(1116),
    [sym_regex] = STATE(1116),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1116),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1116),
    [sym_internal_module] = STATE(1116),
    [sym_jsx_self_closing_element] = STATE(1116),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3629),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3629),
    [sym_number] = ACTIONS(3631),
    [sym_true] = ACTIONS(3629),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3629),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [938] = {
    [sym_class] = STATE(1117),
    [sym_arrow_function] = STATE(1117),
    [sym_await_expression] = STATE(1117),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(1117),
    [sym_meta_property] = STATE(1117),
    [sym__expression] = STATE(1117),
    [sym_jsx_element] = STATE(1117),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1117),
    [sym_call_expression] = STATE(1117),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1117),
    [sym_string] = STATE(1117),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1117),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1117),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(1117),
    [sym_generator_function] = STATE(1117),
    [sym_new_expression] = STATE(1117),
    [sym_assignment_expression] = STATE(1117),
    [sym_augmented_assignment_expression] = STATE(1117),
    [sym_binary_expression] = STATE(1117),
    [sym_unary_expression] = STATE(1117),
    [sym_regex] = STATE(1117),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1117),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1117),
    [sym_internal_module] = STATE(1117),
    [sym_jsx_self_closing_element] = STATE(1117),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(3633),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3633),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3633),
    [sym_number] = ACTIONS(3635),
    [sym_true] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3633),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [939] = {
    [sym_class] = STATE(1119),
    [sym_arrow_function] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1119),
    [sym_sequence_expression] = STATE(1118),
    [sym_meta_property] = STATE(1119),
    [sym__expression] = STATE(1119),
    [sym_jsx_element] = STATE(1119),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1119),
    [sym_call_expression] = STATE(1119),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1119),
    [sym_string] = STATE(1119),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1119),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1119),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1119),
    [sym_generator_function] = STATE(1119),
    [sym_new_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1119),
    [sym_augmented_assignment_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_regex] = STATE(1119),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1119),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1119),
    [sym_internal_module] = STATE(1119),
    [sym_jsx_self_closing_element] = STATE(1119),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3637),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3637),
    [sym_number] = ACTIONS(3639),
    [sym_true] = ACTIONS(3637),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3637),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [940] = {
    [sym_class] = STATE(1120),
    [sym_arrow_function] = STATE(1120),
    [sym_await_expression] = STATE(1120),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(1120),
    [sym_meta_property] = STATE(1120),
    [sym__expression] = STATE(1120),
    [sym_jsx_element] = STATE(1120),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1120),
    [sym_call_expression] = STATE(1120),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1120),
    [sym_string] = STATE(1120),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1120),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1120),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(1120),
    [sym_generator_function] = STATE(1120),
    [sym_new_expression] = STATE(1120),
    [sym_assignment_expression] = STATE(1120),
    [sym_augmented_assignment_expression] = STATE(1120),
    [sym_binary_expression] = STATE(1120),
    [sym_unary_expression] = STATE(1120),
    [sym_regex] = STATE(1120),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1120),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1120),
    [sym_internal_module] = STATE(1120),
    [sym_jsx_self_closing_element] = STATE(1120),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3641),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3641),
    [sym_number] = ACTIONS(3643),
    [sym_true] = ACTIONS(3641),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3641),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [941] = {
    [sym_class] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1122),
    [sym_sequence_expression] = STATE(1121),
    [sym_meta_property] = STATE(1122),
    [sym__expression] = STATE(1122),
    [sym_jsx_element] = STATE(1122),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1122),
    [sym_call_expression] = STATE(1122),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1122),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1122),
    [sym_generator_function] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_regex] = STATE(1122),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1122),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_jsx_self_closing_element] = STATE(1122),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3645),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3645),
    [sym_number] = ACTIONS(3647),
    [sym_true] = ACTIONS(3645),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3645),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [942] = {
    [sym_generator_function_declaration] = STATE(1123),
    [sym__declaration] = STATE(1123),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1123),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1123),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1123),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1123),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1123),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1123),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1123),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1123),
    [sym_function_declaration] = STATE(1123),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1123),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1123),
    [sym_break_statement] = STATE(1123),
    [sym_labeled_statement] = STATE(1123),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1123),
    [sym_class_declaration] = STATE(1123),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1123),
    [sym_ambient_declaration] = STATE(1123),
    [sym_type_alias_declaration] = STATE(1123),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1123),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1123),
    [sym_switch_statement] = STATE(1123),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1123),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1123),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1123),
    [sym_abstract_class_declaration] = STATE(1123),
    [sym_interface_declaration] = STATE(1123),
    [sym_export_statement] = STATE(1123),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1123),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1123),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1123),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1123),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [943] = {
    [anon_sym_RPAREN] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
  },
  [944] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(3649),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [945] = {
    [anon_sym_RPAREN] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
  },
  [946] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(3651),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [947] = {
    [anon_sym_RPAREN] = ACTIONS(3653),
    [sym_comment] = ACTIONS(3),
  },
  [948] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(3653),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [949] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_of] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [950] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_of] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2940),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [951] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_of] = ACTIONS(2945),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [952] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_AMP_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(3655),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2068),
    [anon_sym_STAR_EQ] = ACTIONS(2068),
    [anon_sym_PIPE_EQ] = ACTIONS(2068),
    [anon_sym_DASH_EQ] = ACTIONS(2068),
    [anon_sym_EQ_GT] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2068),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(3655),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [953] = {
    [anon_sym_implements] = ACTIONS(3657),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3657),
    [anon_sym_COMMA] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3659),
  },
  [954] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(3657),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(3657),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [955] = {
    [sym_type_arguments] = STATE(642),
    [anon_sym_implements] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3657),
  },
  [956] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1713),
    [anon_sym_COMMA] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3661),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_implements] = ACTIONS(3661),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [957] = {
    [aux_sym_extends_clause_repeat1] = STATE(957),
    [anon_sym_implements] = ACTIONS(3657),
    [anon_sym_COMMA] = ACTIONS(3670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3657),
  },
  [958] = {
    [sym_identifier] = ACTIONS(3673),
    [anon_sym_BQUOTE] = ACTIONS(3675),
    [anon_sym_debugger] = ACTIONS(3673),
    [anon_sym_symbol] = ACTIONS(3673),
    [anon_sym_AT] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_void] = ACTIONS(3673),
    [anon_sym_break] = ACTIONS(3673),
    [anon_sym_const] = ACTIONS(3673),
    [sym_super] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3673),
    [anon_sym_private] = ACTIONS(3673),
    [anon_sym_static] = ACTIONS(3673),
    [anon_sym_get] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_interface] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3673),
    [anon_sym_enum] = ACTIONS(3673),
    [anon_sym_delete] = ACTIONS(3673),
    [anon_sym_continue] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3673),
    [sym_this] = ACTIONS(3673),
    [anon_sym_yield] = ACTIONS(3673),
    [sym_true] = ACTIONS(3673),
    [anon_sym_throw] = ACTIONS(3673),
    [anon_sym_protected] = ACTIONS(3673),
    [anon_sym_abstract] = ACTIONS(3673),
    [anon_sym_set] = ACTIONS(3673),
    [anon_sym_type] = ACTIONS(3673),
    [anon_sym_import] = ACTIONS(3673),
    [anon_sym_namespace] = ACTIONS(3673),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3675),
    [anon_sym_else] = ACTIONS(3673),
    [anon_sym_BANG] = ACTIONS(3675),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [sym_false] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_case] = ACTIONS(3673),
    [anon_sym_module] = ACTIONS(3673),
    [anon_sym_number] = ACTIONS(3673),
    [anon_sym_class] = ACTIONS(3673),
    [anon_sym_declare] = ACTIONS(3673),
    [anon_sym_typeof] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_switch] = ACTIONS(3673),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [sym_null] = ACTIONS(3673),
    [anon_sym_any] = ACTIONS(3673),
    [anon_sym_boolean] = ACTIONS(3673),
    [anon_sym_async] = ACTIONS(3673),
    [anon_sym_public] = ACTIONS(3673),
    [anon_sym_var] = ACTIONS(3673),
    [anon_sym_while] = ACTIONS(3673),
    [anon_sym_SQUOTE] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3673),
    [anon_sym_LT] = ACTIONS(3675),
    [sym_number] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3673),
    [anon_sym_function] = ACTIONS(3673),
    [sym_undefined] = ACTIONS(3673),
    [anon_sym_new] = ACTIONS(3673),
    [ts_builtin_sym_end] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_export] = ACTIONS(3673),
    [anon_sym_do] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_with] = ACTIONS(3673),
    [anon_sym_await] = ACTIONS(3673),
  },
  [959] = {
    [sym_identifier] = ACTIONS(3677),
    [anon_sym_BQUOTE] = ACTIONS(3679),
    [anon_sym_debugger] = ACTIONS(3677),
    [anon_sym_symbol] = ACTIONS(3677),
    [anon_sym_AT] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_void] = ACTIONS(3677),
    [anon_sym_break] = ACTIONS(3677),
    [anon_sym_const] = ACTIONS(3677),
    [sym_super] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3677),
    [anon_sym_private] = ACTIONS(3677),
    [anon_sym_static] = ACTIONS(3677),
    [anon_sym_get] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_interface] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3677),
    [anon_sym_enum] = ACTIONS(3677),
    [anon_sym_delete] = ACTIONS(3677),
    [anon_sym_continue] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3677),
    [sym_this] = ACTIONS(3677),
    [anon_sym_yield] = ACTIONS(3677),
    [sym_true] = ACTIONS(3677),
    [anon_sym_throw] = ACTIONS(3677),
    [anon_sym_protected] = ACTIONS(3677),
    [anon_sym_abstract] = ACTIONS(3677),
    [anon_sym_set] = ACTIONS(3677),
    [anon_sym_type] = ACTIONS(3677),
    [anon_sym_import] = ACTIONS(3677),
    [anon_sym_namespace] = ACTIONS(3677),
    [anon_sym_PLUS_PLUS] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [anon_sym_else] = ACTIONS(3677),
    [anon_sym_BANG] = ACTIONS(3679),
    [anon_sym_for] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3679),
    [sym_false] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym_case] = ACTIONS(3677),
    [anon_sym_module] = ACTIONS(3677),
    [anon_sym_number] = ACTIONS(3677),
    [anon_sym_class] = ACTIONS(3677),
    [anon_sym_declare] = ACTIONS(3677),
    [anon_sym_typeof] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_switch] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3679),
    [sym_null] = ACTIONS(3677),
    [anon_sym_any] = ACTIONS(3677),
    [anon_sym_boolean] = ACTIONS(3677),
    [anon_sym_async] = ACTIONS(3677),
    [anon_sym_public] = ACTIONS(3677),
    [anon_sym_var] = ACTIONS(3677),
    [anon_sym_while] = ACTIONS(3677),
    [anon_sym_SQUOTE] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3679),
    [sym_number] = ACTIONS(3679),
    [anon_sym_SLASH] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3677),
    [anon_sym_function] = ACTIONS(3677),
    [sym_undefined] = ACTIONS(3677),
    [anon_sym_new] = ACTIONS(3677),
    [ts_builtin_sym_end] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(3677),
    [anon_sym_export] = ACTIONS(3677),
    [anon_sym_do] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3679),
    [anon_sym_with] = ACTIONS(3677),
    [anon_sym_await] = ACTIONS(3677),
  },
  [960] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3681),
    [sym__automatic_semicolon] = ACTIONS(3683),
    [anon_sym_BQUOTE] = ACTIONS(3685),
    [anon_sym_symbol] = ACTIONS(3687),
    [anon_sym_PIPE] = ACTIONS(3689),
    [anon_sym_STAR] = ACTIONS(3689),
    [anon_sym_GT_GT_GT] = ACTIONS(3681),
    [anon_sym_break] = ACTIONS(3687),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3687),
    [anon_sym_static] = ACTIONS(3687),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_PERCENT] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3687),
    [anon_sym_as] = ACTIONS(3689),
    [anon_sym_delete] = ACTIONS(3687),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_instanceof] = ACTIONS(3689),
    [anon_sym_yield] = ACTIONS(3687),
    [sym_true] = ACTIONS(3687),
    [anon_sym_protected] = ACTIONS(3687),
    [anon_sym_DOT] = ACTIONS(3689),
    [anon_sym_set] = ACTIONS(3687),
    [anon_sym_import] = ACTIONS(3687),
    [anon_sym_in] = ACTIONS(3689),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_number] = ACTIONS(3687),
    [anon_sym_typeof] = ACTIONS(3687),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_switch] = ACTIONS(3687),
    [anon_sym_LT_EQ] = ACTIONS(3681),
    [sym_null] = ACTIONS(3687),
    [anon_sym_any] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_public] = ACTIONS(3687),
    [anon_sym_var] = ACTIONS(3687),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3685),
    [anon_sym_SLASH] = ACTIONS(3687),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3687),
    [anon_sym_new] = ACTIONS(3687),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_export] = ACTIONS(3687),
    [anon_sym_GT_GT] = ACTIONS(3689),
    [anon_sym_with] = ACTIONS(3687),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3681),
    [sym_identifier] = ACTIONS(3687),
    [anon_sym_debugger] = ACTIONS(3687),
    [anon_sym_AT] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3687),
    [anon_sym_const] = ACTIONS(3687),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [sym_super] = ACTIONS(3687),
    [anon_sym_private] = ACTIONS(3687),
    [anon_sym_get] = ACTIONS(3687),
    [anon_sym_default] = ACTIONS(3687),
    [anon_sym_enum] = ACTIONS(3687),
    [anon_sym_continue] = ACTIONS(3687),
    [anon_sym_DASH_DASH] = ACTIONS(3685),
    [sym_this] = ACTIONS(3687),
    [anon_sym_throw] = ACTIONS(3687),
    [anon_sym_abstract] = ACTIONS(3687),
    [anon_sym_type] = ACTIONS(3687),
    [anon_sym_STAR_STAR] = ACTIONS(3681),
    [anon_sym_namespace] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3685),
    [anon_sym_else] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [sym_false] = ACTIONS(3687),
    [anon_sym_case] = ACTIONS(3687),
    [anon_sym_module] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_declare] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_GT] = ACTIONS(3689),
    [anon_sym_boolean] = ACTIONS(3687),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_try] = ACTIONS(3687),
    [anon_sym_EQ_EQ] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3687),
    [sym_number] = ACTIONS(3685),
    [ts_builtin_sym_end] = ACTIONS(3685),
    [anon_sym_function] = ACTIONS(3687),
    [sym_undefined] = ACTIONS(3687),
    [anon_sym_let] = ACTIONS(3687),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_do] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3685),
    [anon_sym_await] = ACTIONS(3687),
  },
  [961] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1128),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [962] = {
    [sym_statement_block] = STATE(1574),
    [sym__automatic_semicolon] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3691),
    [anon_sym_COMMA] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [963] = {
    [sym_predefined_type] = STATE(1129),
    [anon_sym_void] = ACTIONS(3693),
    [anon_sym_string] = ACTIONS(3693),
    [anon_sym_symbol] = ACTIONS(3693),
    [anon_sym_number] = ACTIONS(3693),
    [anon_sym_any] = ACTIONS(3693),
    [anon_sym_boolean] = ACTIONS(3693),
    [sym_comment] = ACTIONS(3),
  },
  [964] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1130),
    [sym_function_type] = STATE(1130),
    [sym_constructor_type] = STATE(1130),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1130),
    [sym__type] = STATE(1130),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [965] = {
    [sym_predefined_type] = STATE(1131),
    [anon_sym_void] = ACTIONS(3693),
    [anon_sym_string] = ACTIONS(3693),
    [anon_sym_symbol] = ACTIONS(3693),
    [anon_sym_number] = ACTIONS(3693),
    [anon_sym_any] = ACTIONS(3693),
    [anon_sym_boolean] = ACTIONS(3693),
    [sym_comment] = ACTIONS(3),
  },
  [966] = {
    [sym__automatic_semicolon] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_COMMA] = ACTIONS(3153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3153),
    [anon_sym_COLON] = ACTIONS(3153),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3153),
  },
  [967] = {
    [sym_type_annotation] = STATE(1132),
    [anon_sym_COLON] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
  },
  [968] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1134),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [969] = {
    [sym__initializer] = STATE(1136),
    [sym_type_annotation] = STATE(1137),
    [sym__automatic_semicolon] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3699),
  },
  [970] = {
    [sym_type_annotation] = STATE(1140),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1139),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1138),
    [sym__automatic_semicolon] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3701),
    [sym_comment] = ACTIONS(3),
  },
  [971] = {
    [sym__initializer] = STATE(1139),
    [sym_type_annotation] = STATE(1140),
    [sym__automatic_semicolon] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_COMMA] = ACTIONS(3701),
    [sym_comment] = ACTIONS(3),
  },
  [972] = {
    [sym__automatic_semicolon] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
  },
  [973] = {
    [sym__automatic_semicolon] = ACTIONS(3705),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [sym_comment] = ACTIONS(3),
  },
  [974] = {
    [sym__initializer] = STATE(1141),
    [sym__automatic_semicolon] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
  },
  [975] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1143),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [976] = {
    [sym_string] = STATE(1144),
    [sym__property_name] = STATE(1144),
    [sym_computed_property_name] = STATE(1144),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [977] = {
    [sym_string] = STATE(1144),
    [sym__property_name] = STATE(1144),
    [sym_computed_property_name] = STATE(1144),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [978] = {
    [sym_type_annotation] = STATE(1140),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1139),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1128),
    [sym__automatic_semicolon] = ACTIONS(3701),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3701),
    [sym_comment] = ACTIONS(3),
  },
  [979] = {
    [sym_string] = STATE(1144),
    [sym__property_name] = STATE(1144),
    [sym_computed_property_name] = STATE(1144),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [980] = {
    [sym_type_annotation] = STATE(1137),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1136),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1143),
    [sym__automatic_semicolon] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3699),
  },
  [981] = {
    [sym_string] = STATE(1149),
    [sym__property_name] = STATE(1149),
    [sym_computed_property_name] = STATE(1149),
    [anon_sym_get] = ACTIONS(3719),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(3721),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3719),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [982] = {
    [sym_string] = STATE(1150),
    [sym__property_name] = STATE(1150),
    [sym_computed_property_name] = STATE(1150),
    [anon_sym_get] = ACTIONS(968),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(968),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [983] = {
    [sym_string] = STATE(1151),
    [sym__property_name] = STATE(1151),
    [sym_computed_property_name] = STATE(1151),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [984] = {
    [sym_string] = STATE(1151),
    [sym__property_name] = STATE(1151),
    [sym_computed_property_name] = STATE(1151),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [985] = {
    [sym_type_annotation] = STATE(1137),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1136),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1134),
    [sym__automatic_semicolon] = ACTIONS(3697),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3699),
  },
  [986] = {
    [sym_statement_block] = STATE(1575),
    [sym__automatic_semicolon] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [987] = {
    [sym__automatic_semicolon] = ACTIONS(3733),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym_COMMA] = ACTIONS(3733),
    [sym_comment] = ACTIONS(3),
  },
  [988] = {
    [sym__initializer] = STATE(1153),
    [sym__automatic_semicolon] = ACTIONS(3735),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(3735),
    [anon_sym_COMMA] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
  },
  [989] = {
    [sym__automatic_semicolon] = ACTIONS(3737),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym_COMMA] = ACTIONS(3737),
    [sym_comment] = ACTIONS(3),
  },
  [990] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1154),
    [sym_function_type] = STATE(1154),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(1154),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(1154),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1154),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [991] = {
    [sym__automatic_semicolon] = ACTIONS(2994),
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_BQUOTE] = ACTIONS(2996),
    [anon_sym_debugger] = ACTIONS(2998),
    [anon_sym_symbol] = ACTIONS(2998),
    [anon_sym_AT] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_void] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [sym_super] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_private] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_get] = ACTIONS(2998),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_interface] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2998),
    [anon_sym_enum] = ACTIONS(2998),
    [anon_sym_delete] = ACTIONS(2998),
    [anon_sym_continue] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2998),
    [sym_this] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2998),
    [sym_true] = ACTIONS(2998),
    [anon_sym_throw] = ACTIONS(2998),
    [anon_sym_protected] = ACTIONS(2998),
    [anon_sym_abstract] = ACTIONS(2998),
    [anon_sym_set] = ACTIONS(2998),
    [anon_sym_type] = ACTIONS(2998),
    [anon_sym_import] = ACTIONS(2998),
    [anon_sym_namespace] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [sym_false] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_number] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_switch] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [sym_null] = ACTIONS(2998),
    [anon_sym_any] = ACTIONS(2998),
    [anon_sym_boolean] = ACTIONS(2998),
    [anon_sym_async] = ACTIONS(2998),
    [anon_sym_public] = ACTIONS(2998),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_SQUOTE] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2996),
    [sym_number] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2998),
    [sym_undefined] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2998),
    [ts_builtin_sym_end] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_export] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_await] = ACTIONS(2998),
  },
  [992] = {
    [sym__automatic_semicolon] = ACTIONS(3004),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_BQUOTE] = ACTIONS(3006),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3006),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3006),
    [anon_sym_if] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [anon_sym_yield] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3006),
    [anon_sym_DQUOTE] = ACTIONS(3006),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [sym_false] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3006),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3006),
    [sym_null] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3006),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3006),
    [sym_number] = ACTIONS(3006),
    [anon_sym_SLASH] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [ts_builtin_sym_end] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3006),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_await] = ACTIONS(3008),
  },
  [993] = {
    [sym_class_body] = STATE(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [994] = {
    [sym_statement_block] = STATE(1156),
    [sym__automatic_semicolon] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3123),
  },
  [995] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1157),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [996] = {
    [sym__automatic_semicolon] = ACTIONS(3331),
    [sym_identifier] = ACTIONS(3335),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [anon_sym_debugger] = ACTIONS(3335),
    [anon_sym_symbol] = ACTIONS(3335),
    [anon_sym_AT] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_void] = ACTIONS(3335),
    [anon_sym_break] = ACTIONS(3335),
    [anon_sym_const] = ACTIONS(3335),
    [sym_super] = ACTIONS(3335),
    [anon_sym_return] = ACTIONS(3335),
    [anon_sym_private] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_get] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3335),
    [anon_sym_default] = ACTIONS(3335),
    [anon_sym_enum] = ACTIONS(3335),
    [anon_sym_delete] = ACTIONS(3335),
    [anon_sym_continue] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3335),
    [sym_this] = ACTIONS(3335),
    [anon_sym_yield] = ACTIONS(3335),
    [sym_true] = ACTIONS(3335),
    [anon_sym_throw] = ACTIONS(3335),
    [anon_sym_protected] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_set] = ACTIONS(3335),
    [anon_sym_type] = ACTIONS(3335),
    [anon_sym_import] = ACTIONS(3335),
    [anon_sym_namespace] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [sym_false] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_case] = ACTIONS(3335),
    [anon_sym_module] = ACTIONS(3335),
    [anon_sym_number] = ACTIONS(3335),
    [anon_sym_class] = ACTIONS(3335),
    [anon_sym_declare] = ACTIONS(3335),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [sym_null] = ACTIONS(3335),
    [anon_sym_any] = ACTIONS(3335),
    [anon_sym_boolean] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_public] = ACTIONS(3335),
    [anon_sym_var] = ACTIONS(3335),
    [anon_sym_while] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3333),
    [sym_number] = ACTIONS(3333),
    [anon_sym_SLASH] = ACTIONS(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3335),
    [anon_sym_function] = ACTIONS(3335),
    [sym_undefined] = ACTIONS(3335),
    [anon_sym_new] = ACTIONS(3335),
    [ts_builtin_sym_end] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_export] = ACTIONS(3335),
    [anon_sym_do] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_with] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3335),
  },
  [997] = {
    [sym_statement_block] = STATE(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3123),
  },
  [998] = {
    [sym__automatic_semicolon] = ACTIONS(3455),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_BQUOTE] = ACTIONS(3457),
    [anon_sym_debugger] = ACTIONS(3459),
    [anon_sym_symbol] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_void] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [sym_super] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_get] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_if] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [sym_true] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_set] = ACTIONS(3459),
    [anon_sym_type] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_else] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [sym_false] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_module] = ACTIONS(3459),
    [anon_sym_number] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_declare] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [sym_null] = ACTIONS(3459),
    [anon_sym_any] = ACTIONS(3459),
    [anon_sym_boolean] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3457),
    [sym_number] = ACTIONS(3457),
    [anon_sym_SLASH] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3459),
    [anon_sym_function] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [ts_builtin_sym_end] = ACTIONS(3457),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_export] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_with] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
  },
  [999] = {
    [sym_class_body] = STATE(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [1000] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1160),
    [sym_class_heritage] = STATE(1161),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [1001] = {
    [sym_statement_block] = STATE(1162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1002] = {
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [sym_comment] = ACTIONS(3),
  },
  [1003] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1163),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1004] = {
    [sym_statement_block] = STATE(1164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1005] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1166),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [1006] = {
    [sym_string] = STATE(1167),
    [sym__property_name] = STATE(1167),
    [sym_computed_property_name] = STATE(1167),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1007] = {
    [sym_string] = STATE(1167),
    [sym__property_name] = STATE(1167),
    [sym_computed_property_name] = STATE(1167),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1008] = {
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
  },
  [1009] = {
    [sym_string] = STATE(1167),
    [sym__property_name] = STATE(1167),
    [sym_computed_property_name] = STATE(1167),
    [anon_sym_get] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3753),
    [anon_sym_STAR] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(3757),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1010] = {
    [anon_sym_COLON] = ACTIONS(3761),
    [sym_comment] = ACTIONS(3),
  },
  [1011] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1012] = {
    [sym_generator_function_declaration] = STATE(1171),
    [sym__declaration] = STATE(1171),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1171),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1171),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1171),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1171),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1171),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1171),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1171),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1171),
    [sym_function_declaration] = STATE(1171),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1171),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1171),
    [sym_break_statement] = STATE(1171),
    [sym_labeled_statement] = STATE(1171),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1171),
    [sym_class_declaration] = STATE(1171),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1171),
    [sym_ambient_declaration] = STATE(1171),
    [sym_type_alias_declaration] = STATE(1171),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1171),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1171),
    [sym_switch_statement] = STATE(1171),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(1171),
    [sym_throw_statement] = STATE(1171),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1171),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1171),
    [sym_abstract_class_declaration] = STATE(1171),
    [sym_interface_declaration] = STATE(1171),
    [sym_export_statement] = STATE(1171),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1171),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1171),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1171),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1171),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3765),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(3765),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [anon_sym_debugger] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_AT] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_void] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [sym_super] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_get] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_if] = ACTIONS(3767),
    [sym_this] = ACTIONS(3767),
    [anon_sym_yield] = ACTIONS(3767),
    [sym_true] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_protected] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_set] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_import] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [anon_sym_else] = ACTIONS(3767),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3769),
    [sym_false] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_declare] = ACTIONS(3767),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(3769),
    [sym_null] = ACTIONS(3767),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_async] = ACTIONS(3767),
    [anon_sym_public] = ACTIONS(3767),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3769),
    [sym_number] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_function] = ACTIONS(3767),
    [sym_undefined] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [ts_builtin_sym_end] = ACTIONS(3769),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_export] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_await] = ACTIONS(3767),
  },
  [1014] = {
    [sym_switch_case] = STATE(1014),
    [sym_switch_default] = STATE(1014),
    [aux_sym_switch_body_repeat1] = STATE(1014),
    [anon_sym_RBRACE] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3773),
    [anon_sym_case] = ACTIONS(3776),
    [sym_comment] = ACTIONS(3),
  },
  [1015] = {
    [anon_sym_COMMA] = ACTIONS(3779),
    [anon_sym_RPAREN] = ACTIONS(3779),
    [sym_comment] = ACTIONS(3),
  },
  [1016] = {
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_EQ_GT] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3781),
  },
  [1017] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [sym_this] = ACTIONS(1205),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_boolean] = ACTIONS(1207),
  },
  [1018] = {
    [anon_sym_COMMA] = ACTIONS(3783),
    [anon_sym_RPAREN] = ACTIONS(3783),
    [sym_comment] = ACTIONS(3),
  },
  [1019] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(3785),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [1020] = {
    [sym_identifier] = ACTIONS(3787),
    [anon_sym_BQUOTE] = ACTIONS(3789),
    [anon_sym_debugger] = ACTIONS(3787),
    [anon_sym_symbol] = ACTIONS(3787),
    [anon_sym_AT] = ACTIONS(3789),
    [anon_sym_DASH] = ACTIONS(3787),
    [anon_sym_void] = ACTIONS(3787),
    [anon_sym_break] = ACTIONS(3787),
    [anon_sym_const] = ACTIONS(3787),
    [sym_super] = ACTIONS(3787),
    [anon_sym_return] = ACTIONS(3787),
    [anon_sym_private] = ACTIONS(3787),
    [anon_sym_static] = ACTIONS(3787),
    [anon_sym_get] = ACTIONS(3787),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_interface] = ACTIONS(3787),
    [anon_sym_default] = ACTIONS(3787),
    [anon_sym_enum] = ACTIONS(3787),
    [anon_sym_delete] = ACTIONS(3787),
    [anon_sym_continue] = ACTIONS(3787),
    [anon_sym_DASH_DASH] = ACTIONS(3789),
    [anon_sym_if] = ACTIONS(3787),
    [sym_this] = ACTIONS(3787),
    [anon_sym_yield] = ACTIONS(3787),
    [sym_true] = ACTIONS(3787),
    [anon_sym_throw] = ACTIONS(3787),
    [anon_sym_protected] = ACTIONS(3787),
    [anon_sym_abstract] = ACTIONS(3787),
    [anon_sym_set] = ACTIONS(3787),
    [anon_sym_type] = ACTIONS(3787),
    [anon_sym_import] = ACTIONS(3787),
    [anon_sym_namespace] = ACTIONS(3787),
    [anon_sym_PLUS_PLUS] = ACTIONS(3789),
    [anon_sym_DQUOTE] = ACTIONS(3789),
    [anon_sym_else] = ACTIONS(3787),
    [anon_sym_BANG] = ACTIONS(3789),
    [anon_sym_for] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [sym_false] = ACTIONS(3787),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_case] = ACTIONS(3787),
    [anon_sym_module] = ACTIONS(3787),
    [anon_sym_number] = ACTIONS(3787),
    [anon_sym_class] = ACTIONS(3787),
    [anon_sym_declare] = ACTIONS(3787),
    [anon_sym_typeof] = ACTIONS(3787),
    [anon_sym_LBRACE] = ACTIONS(3789),
    [anon_sym_switch] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(3789),
    [sym_null] = ACTIONS(3787),
    [anon_sym_any] = ACTIONS(3787),
    [anon_sym_boolean] = ACTIONS(3787),
    [anon_sym_async] = ACTIONS(3787),
    [anon_sym_public] = ACTIONS(3787),
    [anon_sym_var] = ACTIONS(3787),
    [anon_sym_while] = ACTIONS(3787),
    [anon_sym_SQUOTE] = ACTIONS(3789),
    [anon_sym_try] = ACTIONS(3787),
    [anon_sym_LT] = ACTIONS(3789),
    [sym_number] = ACTIONS(3789),
    [anon_sym_SLASH] = ACTIONS(3787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3787),
    [anon_sym_function] = ACTIONS(3787),
    [sym_undefined] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(3787),
    [ts_builtin_sym_end] = ACTIONS(3789),
    [anon_sym_let] = ACTIONS(3787),
    [anon_sym_PLUS] = ACTIONS(3787),
    [anon_sym_export] = ACTIONS(3787),
    [anon_sym_do] = ACTIONS(3787),
    [anon_sym_TILDE] = ACTIONS(3789),
    [anon_sym_with] = ACTIONS(3787),
    [anon_sym_await] = ACTIONS(3787),
  },
  [1021] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [sym__automatic_semicolon] = ACTIONS(3793),
    [anon_sym_BQUOTE] = ACTIONS(3795),
    [anon_sym_symbol] = ACTIONS(3797),
    [anon_sym_PIPE] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3799),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_break] = ACTIONS(3797),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_return] = ACTIONS(3797),
    [anon_sym_static] = ACTIONS(3797),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_interface] = ACTIONS(3797),
    [anon_sym_as] = ACTIONS(3799),
    [anon_sym_delete] = ACTIONS(3797),
    [anon_sym_if] = ACTIONS(3797),
    [anon_sym_instanceof] = ACTIONS(3799),
    [anon_sym_yield] = ACTIONS(3797),
    [sym_true] = ACTIONS(3797),
    [anon_sym_protected] = ACTIONS(3797),
    [anon_sym_DOT] = ACTIONS(3799),
    [anon_sym_set] = ACTIONS(3797),
    [anon_sym_import] = ACTIONS(3797),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_DQUOTE] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3797),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym_number] = ACTIONS(3797),
    [anon_sym_typeof] = ACTIONS(3797),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3795),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3797),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [sym_null] = ACTIONS(3797),
    [anon_sym_any] = ACTIONS(3797),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_public] = ACTIONS(3797),
    [anon_sym_var] = ACTIONS(3797),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3797),
    [anon_sym_SQUOTE] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3797),
    [anon_sym_new] = ACTIONS(3797),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_export] = ACTIONS(3797),
    [anon_sym_GT_GT] = ACTIONS(3799),
    [anon_sym_with] = ACTIONS(3797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_debugger] = ACTIONS(3797),
    [anon_sym_AT] = ACTIONS(3795),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_void] = ACTIONS(3797),
    [anon_sym_const] = ACTIONS(3797),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [sym_super] = ACTIONS(3797),
    [anon_sym_private] = ACTIONS(3797),
    [anon_sym_get] = ACTIONS(3797),
    [anon_sym_default] = ACTIONS(3797),
    [anon_sym_enum] = ACTIONS(3797),
    [anon_sym_continue] = ACTIONS(3797),
    [anon_sym_DASH_DASH] = ACTIONS(3795),
    [sym_this] = ACTIONS(3797),
    [anon_sym_throw] = ACTIONS(3797),
    [anon_sym_abstract] = ACTIONS(3797),
    [anon_sym_type] = ACTIONS(3797),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3795),
    [anon_sym_else] = ACTIONS(3797),
    [anon_sym_BANG] = ACTIONS(3797),
    [anon_sym_LBRACK] = ACTIONS(3795),
    [sym_false] = ACTIONS(3797),
    [anon_sym_case] = ACTIONS(3797),
    [anon_sym_module] = ACTIONS(3797),
    [anon_sym_class] = ACTIONS(3797),
    [anon_sym_declare] = ACTIONS(3797),
    [anon_sym_LPAREN] = ACTIONS(3795),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_boolean] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_try] = ACTIONS(3797),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_LT] = ACTIONS(3797),
    [sym_number] = ACTIONS(3795),
    [ts_builtin_sym_end] = ACTIONS(3795),
    [anon_sym_function] = ACTIONS(3797),
    [sym_undefined] = ACTIONS(3797),
    [anon_sym_let] = ACTIONS(3797),
    [anon_sym_PLUS] = ACTIONS(3797),
    [anon_sym_do] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3795),
    [anon_sym_await] = ACTIONS(3797),
  },
  [1022] = {
    [sym_statement_block] = STATE(1174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(844),
  },
  [1023] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3801),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [sym__automatic_semicolon] = ACTIONS(3801),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym_BQUOTE] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3803),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LT_LT] = ACTIONS(3801),
    [anon_sym_STAR] = ACTIONS(3803),
    [anon_sym_GT_GT_GT] = ACTIONS(3801),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_BANG_EQ] = ACTIONS(3803),
    [anon_sym_LT_EQ] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3801),
    [anon_sym_GT_EQ] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3803),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_as] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_EQ_EQ] = ACTIONS(3803),
    [anon_sym_instanceof] = ACTIONS(3801),
    [anon_sym_LT] = ACTIONS(3803),
    [anon_sym_SLASH] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3801),
    [anon_sym_CARET] = ACTIONS(3801),
    [anon_sym_STAR_STAR] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_GT_GT] = ACTIONS(3803),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_in] = ACTIONS(3803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3801),
    [anon_sym_BANG] = ACTIONS(3803),
  },
  [1024] = {
    [anon_sym_RPAREN] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
  },
  [1025] = {
    [anon_sym_RPAREN] = ACTIONS(3807),
    [sym_comment] = ACTIONS(3),
  },
  [1026] = {
    [anon_sym_RPAREN] = ACTIONS(3809),
    [sym_comment] = ACTIONS(3),
  },
  [1027] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [sym__automatic_semicolon] = ACTIONS(3811),
    [anon_sym_SEMI] = ACTIONS(3811),
    [anon_sym_BQUOTE] = ACTIONS(3811),
    [anon_sym_PIPE] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_LT_LT] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3811),
    [anon_sym_AMP_AMP] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_LT_EQ] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3811),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3811),
    [anon_sym_QMARK] = ACTIONS(3811),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_as] = ACTIONS(3811),
    [anon_sym_PIPE_PIPE] = ACTIONS(3811),
    [anon_sym_DASH_DASH] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3813),
    [anon_sym_instanceof] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3813),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3811),
    [anon_sym_CARET] = ACTIONS(3811),
    [anon_sym_STAR_STAR] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(3811),
    [anon_sym_in] = ACTIONS(3813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BANG] = ACTIONS(3813),
  },
  [1028] = {
    [anon_sym_GT] = ACTIONS(3815),
    [sym_comment] = ACTIONS(3),
  },
  [1029] = {
    [sym_nested_identifier] = STATE(2617),
    [sym_jsx_namespace_name] = STATE(2618),
    [anon_sym_GT] = ACTIONS(3817),
    [sym_identifier] = ACTIONS(3819),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(3821),
  },
  [1030] = {
    [sym_identifier] = ACTIONS(3823),
    [sym_jsx_identifier] = ACTIONS(3825),
    [anon_sym_GT] = ACTIONS(3825),
    [anon_sym_SLASH] = ACTIONS(3823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3825),
  },
  [1031] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3827),
    [anon_sym_LBRACK] = ACTIONS(3827),
    [sym__automatic_semicolon] = ACTIONS(3827),
    [anon_sym_SEMI] = ACTIONS(3827),
    [anon_sym_BQUOTE] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3829),
    [anon_sym_GT_GT_GT] = ACTIONS(3827),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3827),
    [anon_sym_GT_EQ] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_QMARK] = ACTIONS(3827),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_DASH_DASH] = ACTIONS(3827),
    [anon_sym_EQ_EQ] = ACTIONS(3829),
    [anon_sym_instanceof] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3829),
    [anon_sym_SLASH] = ACTIONS(3829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_CARET] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_GT_GT] = ACTIONS(3829),
    [anon_sym_PLUS_PLUS] = ACTIONS(3827),
    [anon_sym_in] = ACTIONS(3829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3827),
    [anon_sym_BANG] = ACTIONS(3829),
  },
  [1032] = {
    [sym_jsx_text] = ACTIONS(3831),
    [anon_sym_LT] = ACTIONS(3831),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3831),
  },
  [1033] = {
    [sym_identifier] = ACTIONS(3833),
    [sym_jsx_identifier] = ACTIONS(3835),
    [anon_sym_GT] = ACTIONS(3835),
    [anon_sym_SLASH] = ACTIONS(3833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3835),
  },
  [1034] = {
    [anon_sym_extends] = ACTIONS(3837),
    [anon_sym_implements] = ACTIONS(3837),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3837),
    [anon_sym_EQ] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3839),
  },
  [1035] = {
    [sym_type_parameter] = STATE(811),
    [sym_identifier] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3841),
    [anon_sym_BQUOTE] = ACTIONS(3843),
    [anon_sym_debugger] = ACTIONS(3841),
    [anon_sym_symbol] = ACTIONS(3841),
    [anon_sym_AT] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3841),
    [anon_sym_break] = ACTIONS(3841),
    [anon_sym_const] = ACTIONS(3841),
    [sym_super] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3841),
    [anon_sym_private] = ACTIONS(3841),
    [anon_sym_static] = ACTIONS(3841),
    [anon_sym_get] = ACTIONS(3841),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_interface] = ACTIONS(3841),
    [anon_sym_default] = ACTIONS(3841),
    [anon_sym_enum] = ACTIONS(3841),
    [anon_sym_delete] = ACTIONS(3841),
    [anon_sym_continue] = ACTIONS(3841),
    [anon_sym_DASH_DASH] = ACTIONS(3843),
    [anon_sym_if] = ACTIONS(3841),
    [sym_this] = ACTIONS(3841),
    [anon_sym_yield] = ACTIONS(3841),
    [sym_true] = ACTIONS(3841),
    [anon_sym_throw] = ACTIONS(3841),
    [anon_sym_protected] = ACTIONS(3841),
    [anon_sym_abstract] = ACTIONS(3841),
    [anon_sym_set] = ACTIONS(3841),
    [anon_sym_type] = ACTIONS(3841),
    [anon_sym_import] = ACTIONS(3841),
    [anon_sym_namespace] = ACTIONS(3841),
    [anon_sym_PLUS_PLUS] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3843),
    [anon_sym_else] = ACTIONS(3841),
    [anon_sym_BANG] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3843),
    [sym_false] = ACTIONS(3841),
    [anon_sym_SEMI] = ACTIONS(3843),
    [anon_sym_case] = ACTIONS(3841),
    [anon_sym_module] = ACTIONS(3841),
    [anon_sym_number] = ACTIONS(3841),
    [anon_sym_class] = ACTIONS(3841),
    [anon_sym_declare] = ACTIONS(3841),
    [anon_sym_typeof] = ACTIONS(3841),
    [anon_sym_LBRACE] = ACTIONS(3843),
    [anon_sym_switch] = ACTIONS(3841),
    [anon_sym_LPAREN] = ACTIONS(3843),
    [sym_null] = ACTIONS(3841),
    [anon_sym_any] = ACTIONS(3841),
    [anon_sym_boolean] = ACTIONS(3841),
    [anon_sym_async] = ACTIONS(3841),
    [anon_sym_public] = ACTIONS(3841),
    [anon_sym_var] = ACTIONS(3841),
    [anon_sym_while] = ACTIONS(3841),
    [anon_sym_SQUOTE] = ACTIONS(3843),
    [anon_sym_try] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [sym_number] = ACTIONS(3843),
    [anon_sym_SLASH] = ACTIONS(3841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3841),
    [anon_sym_function] = ACTIONS(3841),
    [sym_undefined] = ACTIONS(3841),
    [anon_sym_new] = ACTIONS(3841),
    [ts_builtin_sym_end] = ACTIONS(3843),
    [anon_sym_let] = ACTIONS(3841),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_export] = ACTIONS(3841),
    [anon_sym_do] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3843),
    [anon_sym_with] = ACTIONS(3841),
    [anon_sym_await] = ACTIONS(3841),
  },
  [1037] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3845),
    [sym__automatic_semicolon] = ACTIONS(3847),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [anon_sym_symbol] = ACTIONS(3851),
    [anon_sym_PIPE] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_GT_GT_GT] = ACTIONS(3845),
    [anon_sym_break] = ACTIONS(3851),
    [anon_sym_BANG_EQ] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3851),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3851),
    [anon_sym_as] = ACTIONS(3853),
    [anon_sym_delete] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_instanceof] = ACTIONS(3853),
    [anon_sym_yield] = ACTIONS(3851),
    [sym_true] = ACTIONS(3851),
    [anon_sym_protected] = ACTIONS(3851),
    [anon_sym_DOT] = ACTIONS(3853),
    [anon_sym_set] = ACTIONS(3851),
    [anon_sym_import] = ACTIONS(3851),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_DQUOTE] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3849),
    [anon_sym_number] = ACTIONS(3851),
    [anon_sym_typeof] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3849),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_switch] = ACTIONS(3851),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [sym_null] = ACTIONS(3851),
    [anon_sym_any] = ACTIONS(3851),
    [anon_sym_async] = ACTIONS(3851),
    [anon_sym_public] = ACTIONS(3851),
    [anon_sym_var] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3849),
    [anon_sym_SLASH] = ACTIONS(3851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3851),
    [anon_sym_new] = ACTIONS(3851),
    [anon_sym_CARET] = ACTIONS(3845),
    [anon_sym_export] = ACTIONS(3851),
    [anon_sym_GT_GT] = ACTIONS(3853),
    [anon_sym_with] = ACTIONS(3851),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3845),
    [sym_identifier] = ACTIONS(3851),
    [anon_sym_debugger] = ACTIONS(3851),
    [anon_sym_AT] = ACTIONS(3849),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_void] = ACTIONS(3851),
    [anon_sym_const] = ACTIONS(3851),
    [anon_sym_GT_EQ] = ACTIONS(3845),
    [sym_super] = ACTIONS(3851),
    [anon_sym_private] = ACTIONS(3851),
    [anon_sym_get] = ACTIONS(3851),
    [anon_sym_default] = ACTIONS(3851),
    [anon_sym_enum] = ACTIONS(3851),
    [anon_sym_continue] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3849),
    [sym_this] = ACTIONS(3851),
    [anon_sym_throw] = ACTIONS(3851),
    [anon_sym_abstract] = ACTIONS(3851),
    [anon_sym_type] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3845),
    [anon_sym_namespace] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3849),
    [anon_sym_else] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [sym_false] = ACTIONS(3851),
    [anon_sym_case] = ACTIONS(3851),
    [anon_sym_module] = ACTIONS(3851),
    [anon_sym_class] = ACTIONS(3851),
    [anon_sym_declare] = ACTIONS(3851),
    [anon_sym_LPAREN] = ACTIONS(3849),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_boolean] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_try] = ACTIONS(3851),
    [anon_sym_EQ_EQ] = ACTIONS(3853),
    [anon_sym_LT] = ACTIONS(3851),
    [sym_number] = ACTIONS(3849),
    [ts_builtin_sym_end] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3851),
    [sym_undefined] = ACTIONS(3851),
    [anon_sym_let] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_do] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3849),
    [anon_sym_await] = ACTIONS(3851),
  },
  [1038] = {
    [sym_type_annotation] = STATE(765),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(3855),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3855),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1039] = {
    [sym_class] = STATE(1180),
    [sym_arrow_function] = STATE(1180),
    [sym_await_expression] = STATE(1180),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1180),
    [sym_sequence_expression] = STATE(1455),
    [sym_meta_property] = STATE(1180),
    [sym__expression] = STATE(1180),
    [sym_jsx_element] = STATE(1180),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1180),
    [sym_call_expression] = STATE(1180),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_spread_element] = STATE(398),
    [sym_ternary_expression] = STATE(1180),
    [sym_string] = STATE(1180),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1180),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1180),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1180),
    [sym_generator_function] = STATE(1180),
    [sym_new_expression] = STATE(1180),
    [sym_assignment_expression] = STATE(1180),
    [sym_augmented_assignment_expression] = STATE(1180),
    [sym_binary_expression] = STATE(1180),
    [sym_unary_expression] = STATE(1180),
    [sym_regex] = STATE(1180),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1180),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1180),
    [sym_internal_module] = STATE(1180),
    [sym_jsx_self_closing_element] = STATE(1180),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(880),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3860),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_RPAREN] = ACTIONS(880),
    [sym_this] = ACTIONS(3860),
    [sym_number] = ACTIONS(3862),
    [sym_true] = ACTIONS(3860),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(3860),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1040] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2834),
    [sym__automatic_semicolon] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [anon_sym_PERCENT_EQ] = ACTIONS(2312),
    [anon_sym_AMP_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2836),
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_GT_GT_GT] = ACTIONS(2836),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2836),
    [anon_sym_GT_EQ] = ACTIONS(2834),
    [anon_sym_CARET_EQ] = ACTIONS(2312),
    [anon_sym_PIPE_EQ] = ACTIONS(2312),
    [anon_sym_DASH_EQ] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_PERCENT] = ACTIONS(2836),
    [anon_sym_LT_LT_EQ] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_STAR_STAR] = ACTIONS(2836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2834),
    [anon_sym_LT_EQ] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2836),
    [anon_sym_STAR_EQ] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_PIPE_PIPE] = ACTIONS(2834),
    [anon_sym_EQ_EQ] = ACTIONS(2836),
    [anon_sym_LT] = ACTIONS(2836),
    [anon_sym_SLASH] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_GT_GT] = ACTIONS(2836),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2834),
  },
  [1041] = {
    [sym__automatic_semicolon] = ACTIONS(3864),
    [anon_sym_SEMI] = ACTIONS(3864),
    [anon_sym_from] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [1042] = {
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_RBRACE] = ACTIONS(3866),
    [sym_comment] = ACTIONS(3),
  },
  [1043] = {
    [sym__import_export_specifier] = STATE(1042),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(3868),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [1044] = {
    [aux_sym_export_clause_repeat1] = STATE(1044),
    [anon_sym_COMMA] = ACTIONS(3870),
    [anon_sym_RBRACE] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
  },
  [1045] = {
    [sym_identifier] = ACTIONS(3875),
    [anon_sym_BQUOTE] = ACTIONS(3877),
    [anon_sym_debugger] = ACTIONS(3875),
    [anon_sym_symbol] = ACTIONS(3875),
    [anon_sym_AT] = ACTIONS(3877),
    [anon_sym_DASH] = ACTIONS(3875),
    [anon_sym_void] = ACTIONS(3875),
    [anon_sym_break] = ACTIONS(3875),
    [anon_sym_const] = ACTIONS(3875),
    [sym_super] = ACTIONS(3875),
    [anon_sym_return] = ACTIONS(3875),
    [anon_sym_private] = ACTIONS(3875),
    [anon_sym_static] = ACTIONS(3875),
    [anon_sym_get] = ACTIONS(3875),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_interface] = ACTIONS(3875),
    [anon_sym_default] = ACTIONS(3875),
    [anon_sym_enum] = ACTIONS(3875),
    [anon_sym_delete] = ACTIONS(3875),
    [anon_sym_continue] = ACTIONS(3875),
    [anon_sym_DASH_DASH] = ACTIONS(3877),
    [anon_sym_if] = ACTIONS(3875),
    [sym_this] = ACTIONS(3875),
    [anon_sym_yield] = ACTIONS(3875),
    [sym_true] = ACTIONS(3875),
    [anon_sym_throw] = ACTIONS(3875),
    [anon_sym_protected] = ACTIONS(3875),
    [anon_sym_abstract] = ACTIONS(3875),
    [anon_sym_set] = ACTIONS(3875),
    [anon_sym_type] = ACTIONS(3875),
    [anon_sym_import] = ACTIONS(3875),
    [anon_sym_namespace] = ACTIONS(3875),
    [anon_sym_PLUS_PLUS] = ACTIONS(3877),
    [anon_sym_DQUOTE] = ACTIONS(3877),
    [anon_sym_else] = ACTIONS(3875),
    [anon_sym_BANG] = ACTIONS(3877),
    [anon_sym_for] = ACTIONS(3875),
    [anon_sym_LBRACK] = ACTIONS(3877),
    [sym_false] = ACTIONS(3875),
    [anon_sym_SEMI] = ACTIONS(3877),
    [anon_sym_case] = ACTIONS(3875),
    [anon_sym_module] = ACTIONS(3875),
    [anon_sym_number] = ACTIONS(3875),
    [anon_sym_class] = ACTIONS(3875),
    [anon_sym_declare] = ACTIONS(3875),
    [anon_sym_typeof] = ACTIONS(3875),
    [anon_sym_LBRACE] = ACTIONS(3877),
    [anon_sym_switch] = ACTIONS(3875),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [sym_null] = ACTIONS(3875),
    [anon_sym_any] = ACTIONS(3875),
    [anon_sym_boolean] = ACTIONS(3875),
    [anon_sym_async] = ACTIONS(3875),
    [anon_sym_public] = ACTIONS(3875),
    [anon_sym_var] = ACTIONS(3875),
    [anon_sym_while] = ACTIONS(3875),
    [anon_sym_SQUOTE] = ACTIONS(3877),
    [anon_sym_try] = ACTIONS(3875),
    [anon_sym_LT] = ACTIONS(3877),
    [sym_number] = ACTIONS(3877),
    [anon_sym_SLASH] = ACTIONS(3875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3875),
    [anon_sym_function] = ACTIONS(3875),
    [sym_undefined] = ACTIONS(3875),
    [anon_sym_new] = ACTIONS(3875),
    [ts_builtin_sym_end] = ACTIONS(3877),
    [anon_sym_let] = ACTIONS(3875),
    [anon_sym_PLUS] = ACTIONS(3875),
    [anon_sym_export] = ACTIONS(3875),
    [anon_sym_do] = ACTIONS(3875),
    [anon_sym_TILDE] = ACTIONS(3877),
    [anon_sym_with] = ACTIONS(3875),
    [anon_sym_await] = ACTIONS(3875),
  },
  [1046] = {
    [sym_identifier] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_debugger] = ACTIONS(3879),
    [anon_sym_symbol] = ACTIONS(3879),
    [anon_sym_AT] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_void] = ACTIONS(3879),
    [anon_sym_break] = ACTIONS(3879),
    [anon_sym_const] = ACTIONS(3879),
    [sym_super] = ACTIONS(3879),
    [anon_sym_return] = ACTIONS(3879),
    [anon_sym_private] = ACTIONS(3879),
    [anon_sym_static] = ACTIONS(3879),
    [anon_sym_get] = ACTIONS(3879),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3879),
    [anon_sym_default] = ACTIONS(3879),
    [anon_sym_enum] = ACTIONS(3879),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_continue] = ACTIONS(3879),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3879),
    [sym_this] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3879),
    [sym_true] = ACTIONS(3879),
    [anon_sym_throw] = ACTIONS(3879),
    [anon_sym_protected] = ACTIONS(3879),
    [anon_sym_abstract] = ACTIONS(3879),
    [anon_sym_set] = ACTIONS(3879),
    [anon_sym_type] = ACTIONS(3879),
    [anon_sym_import] = ACTIONS(3879),
    [anon_sym_namespace] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_BANG] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [sym_false] = ACTIONS(3879),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_case] = ACTIONS(3879),
    [anon_sym_module] = ACTIONS(3879),
    [anon_sym_number] = ACTIONS(3879),
    [anon_sym_class] = ACTIONS(3879),
    [anon_sym_declare] = ACTIONS(3879),
    [anon_sym_typeof] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [sym_null] = ACTIONS(3879),
    [anon_sym_any] = ACTIONS(3879),
    [anon_sym_boolean] = ACTIONS(3879),
    [anon_sym_async] = ACTIONS(3879),
    [anon_sym_public] = ACTIONS(3879),
    [anon_sym_var] = ACTIONS(3879),
    [anon_sym_while] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3881),
    [sym_number] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3879),
    [sym_undefined] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_export] = ACTIONS(3879),
    [anon_sym_do] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3879),
    [anon_sym_await] = ACTIONS(3879),
  },
  [1047] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3883),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1048] = {
    [sym_identifier] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
  },
  [1049] = {
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym_computed_property_name] = STATE(2445),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1050] = {
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym_computed_property_name] = STATE(1054),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_get] = ACTIONS(3411),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3411),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1051] = {
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym_computed_property_name] = STATE(2445),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1052] = {
    [sym_class_declaration] = STATE(1363),
    [sym_generator_function_declaration] = STATE(1363),
    [sym__declaration] = STATE(1363),
    [sym_enum_declaration] = STATE(1363),
    [sym_function_signature] = STATE(1363),
    [sym_abstract_class_declaration] = STATE(1363),
    [sym_module] = STATE(1363),
    [sym_interface_declaration] = STATE(1363),
    [sym_function_declaration] = STATE(1363),
    [sym_export_clause] = STATE(1921),
    [sym_variable_declaration] = STATE(1363),
    [sym_lexical_declaration] = STATE(1363),
    [sym_ambient_declaration] = STATE(1363),
    [sym_import_alias] = STATE(1363),
    [sym_type_alias_declaration] = STATE(1363),
    [aux_sym_export_statement_repeat1] = STATE(2782),
    [sym_internal_module] = STATE(1363),
    [sym_decorator] = STATE(63),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(2725),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_var] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_as] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2759),
  },
  [1053] = {
    [sym_string] = STATE(1184),
    [sym__property_name] = STATE(1184),
    [sym_computed_property_name] = STATE(1184),
    [anon_sym_get] = ACTIONS(3890),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(3894),
    [anon_sym_STAR] = ACTIONS(3896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3890),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1054] = {
    [sym__call_signature] = STATE(2077),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1085),
    [sym__automatic_semicolon] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3497),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym_QMARK] = ACTIONS(3898),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3497),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
  },
  [1055] = {
    [sym_class] = STATE(866),
    [sym_arrow_function] = STATE(866),
    [sym_await_expression] = STATE(866),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(866),
    [sym_meta_property] = STATE(866),
    [sym__expression] = STATE(866),
    [sym_jsx_element] = STATE(866),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(866),
    [sym_call_expression] = STATE(866),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(866),
    [sym_string] = STATE(866),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(866),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(866),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(866),
    [sym_generator_function] = STATE(866),
    [sym_new_expression] = STATE(866),
    [sym_assignment_expression] = STATE(866),
    [sym_augmented_assignment_expression] = STATE(866),
    [sym_binary_expression] = STATE(866),
    [sym_unary_expression] = STATE(866),
    [sym_regex] = STATE(866),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(866),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(866),
    [sym_internal_module] = STATE(866),
    [sym_jsx_self_closing_element] = STATE(866),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(3900),
    [sym_false] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2658),
    [sym_number] = ACTIONS(2660),
    [sym_true] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2658),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1056] = {
    [sym_string] = STATE(1184),
    [sym__property_name] = STATE(1184),
    [sym_computed_property_name] = STATE(1184),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3896),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_get] = ACTIONS(3890),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3890),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3902),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1057] = {
    [sym_await_expression] = STATE(755),
    [sym_type_predicate] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_update_expression] = STATE(755),
    [sym_object_type] = STATE(1652),
    [sym_meta_property] = STATE(755),
    [sym_function_type] = STATE(1475),
    [sym__expression] = STATE(755),
    [sym_jsx_element] = STATE(755),
    [sym_nested_identifier] = STATE(2551),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(755),
    [sym_call_expression] = STATE(755),
    [sym_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_ternary_expression] = STATE(755),
    [sym_template_string] = STATE(755),
    [sym_yield_expression] = STATE(755),
    [sym_jsx_fragment] = STATE(755),
    [sym_new_expression] = STATE(755),
    [sym__primary_type] = STATE(1652),
    [sym_assignment_expression] = STATE(755),
    [sym_binary_expression] = STATE(755),
    [sym_predefined_type] = STATE(1652),
    [sym_union_type] = STATE(1475),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(755),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(755),
    [sym_jsx_self_closing_element] = STATE(755),
    [sym_arrow_function] = STATE(755),
    [sym_generic_type] = STATE(1652),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(1652),
    [sym_intersection_type] = STATE(1475),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(1475),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1854),
    [sym_type_parameters] = STATE(2427),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(1992),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(755),
    [sym_constructor_type] = STATE(1475),
    [sym_lookup_type] = STATE(1652),
    [sym_augmented_assignment_expression] = STATE(755),
    [sym_parenthesized_type] = STATE(1652),
    [sym_unary_expression] = STATE(755),
    [sym_regex] = STATE(755),
    [sym_tuple_type] = STATE(1652),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(755),
    [sym_class] = STATE(755),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(3904),
    [sym_false] = ACTIONS(3906),
    [anon_sym_LBRACK] = ACTIONS(3908),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(3910),
    [anon_sym_number] = ACTIONS(3910),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(3912),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3914),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_LBRACE] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_void] = ACTIONS(3918),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_LPAREN] = ACTIONS(3920),
    [sym_null] = ACTIONS(2265),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(3910),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(3910),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3922),
    [sym_number] = ACTIONS(3924),
    [sym_true] = ACTIONS(3906),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(3910),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(3926),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1058] = {
    [sym__call_signature] = STATE(2078),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1091),
    [sym__automatic_semicolon] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3511),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3511),
    [sym_comment] = ACTIONS(3),
  },
  [1059] = {
    [sym_type_annotation] = STATE(578),
    [anon_sym_EQ_GT] = ACTIONS(3928),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [1060] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3931),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [sym__automatic_semicolon] = ACTIONS(3931),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_BQUOTE] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_as] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3933),
    [anon_sym_instanceof] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_SLASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_STAR_STAR] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BANG] = ACTIONS(3933),
  },
  [1061] = {
    [sym_identifier] = ACTIONS(3935),
    [anon_sym_BQUOTE] = ACTIONS(3937),
    [anon_sym_debugger] = ACTIONS(3935),
    [anon_sym_symbol] = ACTIONS(3935),
    [anon_sym_AT] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3935),
    [anon_sym_void] = ACTIONS(3935),
    [anon_sym_break] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3935),
    [sym_super] = ACTIONS(3935),
    [anon_sym_return] = ACTIONS(3935),
    [anon_sym_private] = ACTIONS(3935),
    [anon_sym_static] = ACTIONS(3935),
    [anon_sym_get] = ACTIONS(3935),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_interface] = ACTIONS(3935),
    [anon_sym_default] = ACTIONS(3935),
    [anon_sym_enum] = ACTIONS(3935),
    [anon_sym_delete] = ACTIONS(3935),
    [anon_sym_continue] = ACTIONS(3935),
    [anon_sym_DASH_DASH] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3935),
    [sym_this] = ACTIONS(3935),
    [anon_sym_yield] = ACTIONS(3935),
    [sym_true] = ACTIONS(3935),
    [anon_sym_throw] = ACTIONS(3935),
    [anon_sym_protected] = ACTIONS(3935),
    [anon_sym_abstract] = ACTIONS(3935),
    [anon_sym_set] = ACTIONS(3935),
    [anon_sym_type] = ACTIONS(3935),
    [anon_sym_import] = ACTIONS(3935),
    [anon_sym_namespace] = ACTIONS(3935),
    [anon_sym_PLUS_PLUS] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3937),
    [anon_sym_else] = ACTIONS(3935),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_for] = ACTIONS(3935),
    [anon_sym_LBRACK] = ACTIONS(3937),
    [sym_false] = ACTIONS(3935),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym_case] = ACTIONS(3935),
    [anon_sym_module] = ACTIONS(3935),
    [anon_sym_number] = ACTIONS(3935),
    [anon_sym_class] = ACTIONS(3935),
    [anon_sym_declare] = ACTIONS(3935),
    [anon_sym_typeof] = ACTIONS(3935),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_switch] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [sym_null] = ACTIONS(3935),
    [anon_sym_any] = ACTIONS(3935),
    [anon_sym_boolean] = ACTIONS(3935),
    [anon_sym_async] = ACTIONS(3935),
    [anon_sym_public] = ACTIONS(3935),
    [anon_sym_var] = ACTIONS(3935),
    [anon_sym_while] = ACTIONS(3935),
    [anon_sym_SQUOTE] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3935),
    [anon_sym_LT] = ACTIONS(3937),
    [sym_number] = ACTIONS(3937),
    [anon_sym_SLASH] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3935),
    [anon_sym_function] = ACTIONS(3935),
    [sym_undefined] = ACTIONS(3935),
    [anon_sym_new] = ACTIONS(3935),
    [ts_builtin_sym_end] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(3935),
    [anon_sym_export] = ACTIONS(3935),
    [anon_sym_do] = ACTIONS(3935),
    [anon_sym_TILDE] = ACTIONS(3937),
    [anon_sym_with] = ACTIONS(3935),
    [anon_sym_await] = ACTIONS(3935),
  },
  [1062] = {
    [sym_identifier] = ACTIONS(3939),
    [anon_sym_BQUOTE] = ACTIONS(3941),
    [anon_sym_debugger] = ACTIONS(3939),
    [anon_sym_symbol] = ACTIONS(3939),
    [anon_sym_AT] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_void] = ACTIONS(3939),
    [anon_sym_break] = ACTIONS(3939),
    [anon_sym_const] = ACTIONS(3939),
    [sym_super] = ACTIONS(3939),
    [anon_sym_return] = ACTIONS(3939),
    [anon_sym_private] = ACTIONS(3939),
    [anon_sym_static] = ACTIONS(3939),
    [anon_sym_get] = ACTIONS(3939),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_interface] = ACTIONS(3939),
    [anon_sym_default] = ACTIONS(3939),
    [anon_sym_enum] = ACTIONS(3939),
    [anon_sym_delete] = ACTIONS(3939),
    [anon_sym_continue] = ACTIONS(3939),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3939),
    [sym_this] = ACTIONS(3939),
    [anon_sym_yield] = ACTIONS(3939),
    [sym_true] = ACTIONS(3939),
    [anon_sym_throw] = ACTIONS(3939),
    [anon_sym_protected] = ACTIONS(3939),
    [anon_sym_abstract] = ACTIONS(3939),
    [anon_sym_set] = ACTIONS(3939),
    [anon_sym_type] = ACTIONS(3939),
    [anon_sym_import] = ACTIONS(3939),
    [anon_sym_namespace] = ACTIONS(3939),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_else] = ACTIONS(3939),
    [anon_sym_BANG] = ACTIONS(3941),
    [anon_sym_for] = ACTIONS(3939),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [sym_false] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_case] = ACTIONS(3939),
    [anon_sym_module] = ACTIONS(3939),
    [anon_sym_number] = ACTIONS(3939),
    [anon_sym_class] = ACTIONS(3939),
    [anon_sym_declare] = ACTIONS(3939),
    [anon_sym_typeof] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_switch] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [sym_null] = ACTIONS(3939),
    [anon_sym_any] = ACTIONS(3939),
    [anon_sym_boolean] = ACTIONS(3939),
    [anon_sym_async] = ACTIONS(3939),
    [anon_sym_public] = ACTIONS(3939),
    [anon_sym_var] = ACTIONS(3939),
    [anon_sym_while] = ACTIONS(3939),
    [anon_sym_SQUOTE] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3941),
    [sym_number] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3939),
    [anon_sym_function] = ACTIONS(3939),
    [sym_undefined] = ACTIONS(3939),
    [anon_sym_new] = ACTIONS(3939),
    [ts_builtin_sym_end] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3939),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_export] = ACTIONS(3939),
    [anon_sym_do] = ACTIONS(3939),
    [anon_sym_TILDE] = ACTIONS(3941),
    [anon_sym_with] = ACTIONS(3939),
    [anon_sym_await] = ACTIONS(3939),
  },
  [1063] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3943),
    [sym__automatic_semicolon] = ACTIONS(3945),
    [anon_sym_BQUOTE] = ACTIONS(3947),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_PIPE] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_GT_GT_GT] = ACTIONS(3943),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_BANG_EQ] = ACTIONS(3951),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_as] = ACTIONS(3951),
    [anon_sym_delete] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_instanceof] = ACTIONS(3951),
    [anon_sym_yield] = ACTIONS(3949),
    [sym_true] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_DOT] = ACTIONS(3951),
    [anon_sym_set] = ACTIONS(3949),
    [anon_sym_import] = ACTIONS(3949),
    [anon_sym_in] = ACTIONS(3951),
    [anon_sym_DQUOTE] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3947),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_typeof] = ACTIONS(3949),
    [anon_sym_LT_LT] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3947),
    [anon_sym_AMP_AMP] = ACTIONS(3943),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_LT_EQ] = ACTIONS(3943),
    [sym_null] = ACTIONS(3949),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_async] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_QMARK] = ACTIONS(3943),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3947),
    [anon_sym_SLASH] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_CARET] = ACTIONS(3943),
    [anon_sym_export] = ACTIONS(3949),
    [anon_sym_GT_GT] = ACTIONS(3951),
    [anon_sym_with] = ACTIONS(3949),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3943),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_debugger] = ACTIONS(3949),
    [anon_sym_AT] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_void] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_GT_EQ] = ACTIONS(3943),
    [sym_super] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_get] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3947),
    [sym_this] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3949),
    [anon_sym_type] = ACTIONS(3949),
    [anon_sym_STAR_STAR] = ACTIONS(3943),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3947),
    [anon_sym_else] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [sym_false] = ACTIONS(3949),
    [anon_sym_case] = ACTIONS(3949),
    [anon_sym_module] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_declare] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3947),
    [anon_sym_GT] = ACTIONS(3951),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_PIPE_PIPE] = ACTIONS(3943),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_EQ_EQ] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3949),
    [sym_number] = ACTIONS(3947),
    [ts_builtin_sym_end] = ACTIONS(3947),
    [anon_sym_function] = ACTIONS(3949),
    [sym_undefined] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3947),
    [anon_sym_await] = ACTIONS(3949),
  },
  [1064] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3953),
    [sym__automatic_semicolon] = ACTIONS(3955),
    [anon_sym_BQUOTE] = ACTIONS(3957),
    [anon_sym_symbol] = ACTIONS(3959),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3959),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_return] = ACTIONS(3959),
    [anon_sym_static] = ACTIONS(3959),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_interface] = ACTIONS(3959),
    [anon_sym_as] = ACTIONS(3961),
    [anon_sym_delete] = ACTIONS(3959),
    [anon_sym_if] = ACTIONS(3959),
    [anon_sym_instanceof] = ACTIONS(3961),
    [anon_sym_yield] = ACTIONS(3959),
    [sym_true] = ACTIONS(3959),
    [anon_sym_protected] = ACTIONS(3959),
    [anon_sym_DOT] = ACTIONS(3961),
    [anon_sym_set] = ACTIONS(3959),
    [anon_sym_import] = ACTIONS(3959),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_for] = ACTIONS(3959),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_number] = ACTIONS(3959),
    [anon_sym_typeof] = ACTIONS(3959),
    [anon_sym_LT_LT] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3959),
    [anon_sym_LT_EQ] = ACTIONS(3953),
    [sym_null] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3959),
    [anon_sym_async] = ACTIONS(3959),
    [anon_sym_public] = ACTIONS(3959),
    [anon_sym_var] = ACTIONS(3959),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3959),
    [anon_sym_SQUOTE] = ACTIONS(3957),
    [anon_sym_SLASH] = ACTIONS(3959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3953),
    [anon_sym_export] = ACTIONS(3959),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_with] = ACTIONS(3959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3953),
    [sym_identifier] = ACTIONS(3959),
    [anon_sym_debugger] = ACTIONS(3959),
    [anon_sym_AT] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3959),
    [anon_sym_void] = ACTIONS(3959),
    [anon_sym_const] = ACTIONS(3959),
    [anon_sym_GT_EQ] = ACTIONS(3953),
    [sym_super] = ACTIONS(3959),
    [anon_sym_private] = ACTIONS(3959),
    [anon_sym_get] = ACTIONS(3959),
    [anon_sym_default] = ACTIONS(3959),
    [anon_sym_enum] = ACTIONS(3959),
    [anon_sym_continue] = ACTIONS(3959),
    [anon_sym_DASH_DASH] = ACTIONS(3957),
    [sym_this] = ACTIONS(3959),
    [anon_sym_throw] = ACTIONS(3959),
    [anon_sym_abstract] = ACTIONS(3959),
    [anon_sym_type] = ACTIONS(3959),
    [anon_sym_STAR_STAR] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3959),
    [anon_sym_PLUS_PLUS] = ACTIONS(3957),
    [anon_sym_else] = ACTIONS(3959),
    [anon_sym_BANG] = ACTIONS(3959),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [sym_false] = ACTIONS(3959),
    [anon_sym_case] = ACTIONS(3959),
    [anon_sym_module] = ACTIONS(3959),
    [anon_sym_class] = ACTIONS(3959),
    [anon_sym_declare] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_boolean] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3959),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_LT] = ACTIONS(3959),
    [sym_number] = ACTIONS(3957),
    [ts_builtin_sym_end] = ACTIONS(3957),
    [anon_sym_function] = ACTIONS(3959),
    [sym_undefined] = ACTIONS(3959),
    [anon_sym_let] = ACTIONS(3959),
    [anon_sym_PLUS] = ACTIONS(3959),
    [anon_sym_do] = ACTIONS(3959),
    [anon_sym_TILDE] = ACTIONS(3957),
    [anon_sym_await] = ACTIONS(3959),
  },
  [1065] = {
    [sym_class_body] = STATE(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(964),
  },
  [1066] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [sym__automatic_semicolon] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3963),
    [anon_sym_BQUOTE] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_GT_GT_GT] = ACTIONS(3963),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_GT_EQ] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_QMARK] = ACTIONS(3963),
    [anon_sym_RBRACE] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [anon_sym_EQ_EQ] = ACTIONS(3965),
    [anon_sym_instanceof] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3965),
    [anon_sym_SLASH] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_GT_GT] = ACTIONS(3965),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3963),
    [anon_sym_BANG] = ACTIONS(3965),
  },
  [1067] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [sym__automatic_semicolon] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym_BQUOTE] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_STAR] = ACTIONS(3689),
    [anon_sym_GT_GT_GT] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_LT_EQ] = ACTIONS(3681),
    [anon_sym_LPAREN] = ACTIONS(3681),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_PERCENT] = ACTIONS(3681),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_as] = ACTIONS(3681),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_EQ_EQ] = ACTIONS(3689),
    [anon_sym_instanceof] = ACTIONS(3681),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_SLASH] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3681),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_STAR_STAR] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_GT_GT] = ACTIONS(3689),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BANG] = ACTIONS(3689),
  },
  [1068] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [sym__automatic_semicolon] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3791),
    [anon_sym_BQUOTE] = ACTIONS(3791),
    [anon_sym_PIPE] = ACTIONS(3799),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3799),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3791),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_instanceof] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_SLASH] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_GT_GT] = ACTIONS(3799),
    [anon_sym_PLUS_PLUS] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3799),
  },
  [1069] = {
    [sym_statement_block] = STATE(1190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [1070] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [sym__automatic_semicolon] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_BQUOTE] = ACTIONS(3845),
    [anon_sym_PIPE] = ACTIONS(3853),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_LT_LT] = ACTIONS(3845),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_GT_GT_GT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_BANG_EQ] = ACTIONS(3853),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_GT_EQ] = ACTIONS(3845),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_as] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3845),
    [anon_sym_EQ_EQ] = ACTIONS(3853),
    [anon_sym_instanceof] = ACTIONS(3845),
    [anon_sym_LT] = ACTIONS(3853),
    [anon_sym_SLASH] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_CARET] = ACTIONS(3845),
    [anon_sym_STAR_STAR] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_GT_GT] = ACTIONS(3853),
    [anon_sym_PLUS_PLUS] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3845),
    [anon_sym_BANG] = ACTIONS(3853),
  },
  [1071] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3943),
    [anon_sym_LBRACK] = ACTIONS(3943),
    [sym__automatic_semicolon] = ACTIONS(3943),
    [anon_sym_SEMI] = ACTIONS(3943),
    [anon_sym_BQUOTE] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3951),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_LT_LT] = ACTIONS(3943),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_GT_GT_GT] = ACTIONS(3943),
    [anon_sym_AMP_AMP] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_BANG_EQ] = ACTIONS(3951),
    [anon_sym_LT_EQ] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3943),
    [anon_sym_GT_EQ] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_QMARK] = ACTIONS(3943),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_PIPE_PIPE] = ACTIONS(3943),
    [anon_sym_DASH_DASH] = ACTIONS(3943),
    [anon_sym_EQ_EQ] = ACTIONS(3951),
    [anon_sym_instanceof] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_SLASH] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3943),
    [anon_sym_CARET] = ACTIONS(3943),
    [anon_sym_STAR_STAR] = ACTIONS(3943),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_GT_GT] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3943),
    [anon_sym_in] = ACTIONS(3951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3951),
  },
  [1072] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [sym__automatic_semicolon] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym_BQUOTE] = ACTIONS(3953),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_LT_LT] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_LT_EQ] = ACTIONS(3953),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_GT_EQ] = ACTIONS(3953),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_RBRACE] = ACTIONS(3953),
    [anon_sym_as] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_instanceof] = ACTIONS(3953),
    [anon_sym_LT] = ACTIONS(3961),
    [anon_sym_SLASH] = ACTIONS(3961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_CARET] = ACTIONS(3953),
    [anon_sym_STAR_STAR] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3953),
    [anon_sym_BANG] = ACTIONS(3961),
  },
  [1073] = {
    [sym_class_body] = STATE(1191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [1074] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3967),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1075] = {
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3969),
    [anon_sym_break] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3971),
    [anon_sym_static] = ACTIONS(3971),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_interface] = ACTIONS(3971),
    [anon_sym_delete] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(3971),
    [sym_true] = ACTIONS(3971),
    [anon_sym_protected] = ACTIONS(3971),
    [anon_sym_set] = ACTIONS(3971),
    [anon_sym_import] = ACTIONS(3971),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3971),
    [anon_sym_typeof] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_switch] = ACTIONS(3971),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [sym_null] = ACTIONS(3971),
    [anon_sym_any] = ACTIONS(3971),
    [anon_sym_async] = ACTIONS(3971),
    [anon_sym_public] = ACTIONS(3971),
    [anon_sym_var] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3971),
    [anon_sym_SQUOTE] = ACTIONS(3969),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_SLASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3971),
    [anon_sym_new] = ACTIONS(3971),
    [anon_sym_export] = ACTIONS(3971),
    [anon_sym_with] = ACTIONS(3971),
    [sym_identifier] = ACTIONS(3971),
    [anon_sym_debugger] = ACTIONS(3971),
    [anon_sym_AT] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_EQ] = ACTIONS(3971),
    [anon_sym_void] = ACTIONS(3971),
    [anon_sym_const] = ACTIONS(3971),
    [sym_super] = ACTIONS(3971),
    [anon_sym_private] = ACTIONS(3971),
    [anon_sym_get] = ACTIONS(3971),
    [anon_sym_default] = ACTIONS(3971),
    [anon_sym_enum] = ACTIONS(3971),
    [anon_sym_continue] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_this] = ACTIONS(3971),
    [anon_sym_throw] = ACTIONS(3971),
    [anon_sym_abstract] = ACTIONS(3971),
    [anon_sym_type] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_else] = ACTIONS(3971),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [sym_false] = ACTIONS(3971),
    [anon_sym_case] = ACTIONS(3971),
    [anon_sym_module] = ACTIONS(3971),
    [anon_sym_class] = ACTIONS(3971),
    [anon_sym_declare] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_GT] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3971),
    [anon_sym_EQ_GT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3969),
    [sym_number] = ACTIONS(3969),
    [ts_builtin_sym_end] = ACTIONS(3969),
    [anon_sym_function] = ACTIONS(3971),
    [sym_undefined] = ACTIONS(3971),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_do] = ACTIONS(3971),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_await] = ACTIONS(3971),
  },
  [1076] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3973),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3973),
    [sym_comment] = ACTIONS(3),
  },
  [1077] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1194),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1078] = {
    [sym__automatic_semicolon] = ACTIONS(3691),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3691),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
  },
  [1079] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1196),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1080] = {
    [sym_string] = STATE(1197),
    [sym__property_name] = STATE(1197),
    [sym_computed_property_name] = STATE(1197),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1081] = {
    [sym_string] = STATE(1197),
    [sym__property_name] = STATE(1197),
    [sym_computed_property_name] = STATE(1197),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1082] = {
    [sym_string] = STATE(1197),
    [sym__property_name] = STATE(1197),
    [sym_computed_property_name] = STATE(1197),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3981),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1083] = {
    [sym__call_signature] = STATE(1196),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1201),
    [sym__automatic_semicolon] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(3985),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
  },
  [1084] = {
    [sym__call_signature] = STATE(1194),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1202),
    [sym__automatic_semicolon] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
  },
  [1085] = {
    [sym__automatic_semicolon] = ACTIONS(3989),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_SEMI] = ACTIONS(3989),
    [anon_sym_COMMA] = ACTIONS(3989),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
  },
  [1086] = {
    [sym__automatic_semicolon] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3991),
    [sym_comment] = ACTIONS(3),
  },
  [1087] = {
    [sym_type_annotation] = STATE(1203),
    [sym__automatic_semicolon] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3991),
    [sym_comment] = ACTIONS(3),
  },
  [1088] = {
    [sym__automatic_semicolon] = ACTIONS(3993),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3993),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
  },
  [1089] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(3995),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_SEMI] = ACTIONS(3995),
    [anon_sym_COMMA] = ACTIONS(3995),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
  },
  [1090] = {
    [sym_string] = STATE(1206),
    [sym__property_name] = STATE(1206),
    [sym_computed_property_name] = STATE(1206),
    [anon_sym_get] = ACTIONS(4000),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(4002),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(4004),
    [anon_sym_STAR] = ACTIONS(3979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(4000),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1091] = {
    [sym__automatic_semicolon] = ACTIONS(4006),
    [anon_sym_RBRACE] = ACTIONS(4006),
    [anon_sym_SEMI] = ACTIONS(4006),
    [anon_sym_COMMA] = ACTIONS(4006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4006),
    [sym_comment] = ACTIONS(3),
  },
  [1092] = {
    [sym__automatic_semicolon] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
  },
  [1093] = {
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_symbol] = ACTIONS(4010),
    [anon_sym_PIPE] = ACTIONS(4008),
    [anon_sym_break] = ACTIONS(4010),
    [anon_sym_return] = ACTIONS(4010),
    [anon_sym_static] = ACTIONS(4010),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_interface] = ACTIONS(4010),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_if] = ACTIONS(4010),
    [anon_sym_yield] = ACTIONS(4010),
    [sym_true] = ACTIONS(4010),
    [anon_sym_protected] = ACTIONS(4010),
    [anon_sym_set] = ACTIONS(4010),
    [anon_sym_import] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(4008),
    [anon_sym_for] = ACTIONS(4010),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_number] = ACTIONS(4010),
    [anon_sym_typeof] = ACTIONS(4010),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [anon_sym_switch] = ACTIONS(4010),
    [anon_sym_RBRACK] = ACTIONS(4008),
    [sym_null] = ACTIONS(4010),
    [anon_sym_any] = ACTIONS(4010),
    [anon_sym_async] = ACTIONS(4010),
    [anon_sym_public] = ACTIONS(4010),
    [anon_sym_var] = ACTIONS(4010),
    [anon_sym_while] = ACTIONS(4010),
    [anon_sym_SQUOTE] = ACTIONS(4008),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_SLASH] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4010),
    [anon_sym_new] = ACTIONS(4010),
    [anon_sym_export] = ACTIONS(4010),
    [anon_sym_with] = ACTIONS(4010),
    [sym_identifier] = ACTIONS(4010),
    [anon_sym_debugger] = ACTIONS(4010),
    [anon_sym_AT] = ACTIONS(4008),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_EQ] = ACTIONS(4010),
    [anon_sym_void] = ACTIONS(4010),
    [anon_sym_const] = ACTIONS(4010),
    [sym_super] = ACTIONS(4010),
    [anon_sym_private] = ACTIONS(4010),
    [anon_sym_get] = ACTIONS(4010),
    [anon_sym_default] = ACTIONS(4010),
    [anon_sym_enum] = ACTIONS(4010),
    [anon_sym_continue] = ACTIONS(4010),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [sym_this] = ACTIONS(4010),
    [anon_sym_throw] = ACTIONS(4010),
    [anon_sym_abstract] = ACTIONS(4010),
    [anon_sym_type] = ACTIONS(4010),
    [anon_sym_namespace] = ACTIONS(4010),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_else] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [sym_false] = ACTIONS(4010),
    [anon_sym_case] = ACTIONS(4010),
    [anon_sym_module] = ACTIONS(4010),
    [anon_sym_class] = ACTIONS(4010),
    [anon_sym_declare] = ACTIONS(4010),
    [anon_sym_LPAREN] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4008),
    [anon_sym_boolean] = ACTIONS(4010),
    [anon_sym_EQ_GT] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4008),
    [anon_sym_try] = ACTIONS(4010),
    [anon_sym_LT] = ACTIONS(4008),
    [sym_number] = ACTIONS(4008),
    [ts_builtin_sym_end] = ACTIONS(4008),
    [anon_sym_function] = ACTIONS(4010),
    [sym_undefined] = ACTIONS(4010),
    [anon_sym_let] = ACTIONS(4010),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_do] = ACTIONS(4010),
    [anon_sym_TILDE] = ACTIONS(4008),
    [anon_sym_await] = ACTIONS(4010),
  },
  [1094] = {
    [anon_sym_EQ_GT] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(4012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_RBRACK] = ACTIONS(4012),
    [anon_sym_GT] = ACTIONS(4012),
  },
  [1095] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1207),
    [sym_function_type] = STATE(1207),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(1207),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(1207),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1207),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1096] = {
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_symbol] = ACTIONS(4018),
    [anon_sym_PIPE] = ACTIONS(4016),
    [anon_sym_break] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4018),
    [anon_sym_static] = ACTIONS(4018),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_interface] = ACTIONS(4018),
    [anon_sym_delete] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4018),
    [anon_sym_yield] = ACTIONS(4018),
    [sym_true] = ACTIONS(4018),
    [anon_sym_protected] = ACTIONS(4018),
    [anon_sym_set] = ACTIONS(4018),
    [anon_sym_import] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4016),
    [anon_sym_number] = ACTIONS(4018),
    [anon_sym_typeof] = ACTIONS(4018),
    [anon_sym_LBRACE] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4018),
    [anon_sym_RBRACK] = ACTIONS(4016),
    [sym_null] = ACTIONS(4018),
    [anon_sym_any] = ACTIONS(4018),
    [anon_sym_async] = ACTIONS(4018),
    [anon_sym_public] = ACTIONS(4018),
    [anon_sym_var] = ACTIONS(4018),
    [anon_sym_while] = ACTIONS(4018),
    [anon_sym_SQUOTE] = ACTIONS(4016),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_SLASH] = ACTIONS(4018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4018),
    [anon_sym_new] = ACTIONS(4018),
    [anon_sym_export] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4018),
    [sym_identifier] = ACTIONS(4018),
    [anon_sym_debugger] = ACTIONS(4018),
    [anon_sym_AT] = ACTIONS(4016),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_EQ] = ACTIONS(4018),
    [anon_sym_void] = ACTIONS(4018),
    [anon_sym_const] = ACTIONS(4018),
    [sym_super] = ACTIONS(4018),
    [anon_sym_private] = ACTIONS(4018),
    [anon_sym_get] = ACTIONS(4018),
    [anon_sym_default] = ACTIONS(4018),
    [anon_sym_enum] = ACTIONS(4018),
    [anon_sym_continue] = ACTIONS(4018),
    [anon_sym_DASH_DASH] = ACTIONS(4016),
    [sym_this] = ACTIONS(4018),
    [anon_sym_throw] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4018),
    [anon_sym_type] = ACTIONS(4018),
    [anon_sym_namespace] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4016),
    [anon_sym_else] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4016),
    [anon_sym_LBRACK] = ACTIONS(4016),
    [sym_false] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4018),
    [anon_sym_module] = ACTIONS(4018),
    [anon_sym_class] = ACTIONS(4018),
    [anon_sym_declare] = ACTIONS(4018),
    [anon_sym_LPAREN] = ACTIONS(4016),
    [anon_sym_GT] = ACTIONS(4016),
    [anon_sym_boolean] = ACTIONS(4018),
    [anon_sym_EQ_GT] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4016),
    [anon_sym_try] = ACTIONS(4018),
    [anon_sym_LT] = ACTIONS(4016),
    [sym_number] = ACTIONS(4016),
    [ts_builtin_sym_end] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4018),
    [sym_undefined] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4018),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_do] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4016),
    [anon_sym_await] = ACTIONS(4018),
  },
  [1097] = {
    [anon_sym_EQ_GT] = ACTIONS(4020),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4020),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4020),
    [anon_sym_COMMA] = ACTIONS(4020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [sym_jsx_identifier] = ACTIONS(4020),
    [anon_sym_GT] = ACTIONS(4020),
  },
  [1098] = {
    [anon_sym_EQ_GT] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(4024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_EQ] = ACTIONS(4026),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_GT] = ACTIONS(4024),
  },
  [1099] = {
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_BQUOTE] = ACTIONS(4030),
    [anon_sym_debugger] = ACTIONS(4028),
    [anon_sym_symbol] = ACTIONS(4028),
    [anon_sym_AT] = ACTIONS(4030),
    [anon_sym_DASH] = ACTIONS(4028),
    [anon_sym_void] = ACTIONS(4028),
    [anon_sym_break] = ACTIONS(4028),
    [anon_sym_const] = ACTIONS(4028),
    [sym_super] = ACTIONS(4028),
    [anon_sym_return] = ACTIONS(4028),
    [anon_sym_private] = ACTIONS(4028),
    [anon_sym_static] = ACTIONS(4028),
    [anon_sym_get] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_interface] = ACTIONS(4028),
    [anon_sym_default] = ACTIONS(4028),
    [anon_sym_enum] = ACTIONS(4028),
    [anon_sym_delete] = ACTIONS(4028),
    [anon_sym_continue] = ACTIONS(4028),
    [anon_sym_DASH_DASH] = ACTIONS(4030),
    [anon_sym_if] = ACTIONS(4028),
    [sym_this] = ACTIONS(4028),
    [anon_sym_yield] = ACTIONS(4028),
    [sym_true] = ACTIONS(4028),
    [anon_sym_throw] = ACTIONS(4028),
    [anon_sym_protected] = ACTIONS(4028),
    [anon_sym_abstract] = ACTIONS(4028),
    [anon_sym_set] = ACTIONS(4028),
    [anon_sym_type] = ACTIONS(4028),
    [anon_sym_import] = ACTIONS(4028),
    [anon_sym_namespace] = ACTIONS(4028),
    [anon_sym_PLUS_PLUS] = ACTIONS(4030),
    [anon_sym_DQUOTE] = ACTIONS(4030),
    [anon_sym_else] = ACTIONS(4028),
    [anon_sym_BANG] = ACTIONS(4030),
    [anon_sym_for] = ACTIONS(4028),
    [anon_sym_LBRACK] = ACTIONS(4030),
    [sym_false] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4030),
    [anon_sym_case] = ACTIONS(4028),
    [anon_sym_module] = ACTIONS(4028),
    [anon_sym_number] = ACTIONS(4028),
    [anon_sym_class] = ACTIONS(4028),
    [anon_sym_declare] = ACTIONS(4028),
    [anon_sym_typeof] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_switch] = ACTIONS(4028),
    [anon_sym_LPAREN] = ACTIONS(4030),
    [sym_null] = ACTIONS(4028),
    [anon_sym_any] = ACTIONS(4028),
    [anon_sym_boolean] = ACTIONS(4028),
    [anon_sym_async] = ACTIONS(4028),
    [anon_sym_public] = ACTIONS(4028),
    [anon_sym_var] = ACTIONS(4028),
    [anon_sym_while] = ACTIONS(4028),
    [anon_sym_SQUOTE] = ACTIONS(4030),
    [anon_sym_try] = ACTIONS(4028),
    [anon_sym_LT] = ACTIONS(4030),
    [sym_number] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4028),
    [anon_sym_function] = ACTIONS(4028),
    [sym_undefined] = ACTIONS(4028),
    [anon_sym_new] = ACTIONS(4028),
    [ts_builtin_sym_end] = ACTIONS(4030),
    [anon_sym_let] = ACTIONS(4028),
    [anon_sym_PLUS] = ACTIONS(4028),
    [anon_sym_export] = ACTIONS(4028),
    [anon_sym_do] = ACTIONS(4028),
    [anon_sym_TILDE] = ACTIONS(4030),
    [anon_sym_with] = ACTIONS(4028),
    [anon_sym_await] = ACTIONS(4028),
  },
  [1100] = {
    [sym__initializer] = STATE(914),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_COMMA] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
  },
  [1101] = {
    [anon_sym_COMMA] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
  },
  [1102] = {
    [sym_computed_property_name] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_enum_assignment] = STATE(1101),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_number] = ACTIONS(3566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1103] = {
    [aux_sym_enum_body_repeat1] = STATE(1103),
    [anon_sym_COMMA] = ACTIONS(4036),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
  },
  [1104] = {
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_BQUOTE] = ACTIONS(4041),
    [anon_sym_debugger] = ACTIONS(4039),
    [anon_sym_symbol] = ACTIONS(4039),
    [anon_sym_AT] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_void] = ACTIONS(4039),
    [anon_sym_break] = ACTIONS(4039),
    [anon_sym_const] = ACTIONS(4039),
    [sym_super] = ACTIONS(4039),
    [anon_sym_return] = ACTIONS(4039),
    [anon_sym_private] = ACTIONS(4039),
    [anon_sym_static] = ACTIONS(4039),
    [anon_sym_get] = ACTIONS(4039),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_interface] = ACTIONS(4039),
    [anon_sym_default] = ACTIONS(4039),
    [anon_sym_enum] = ACTIONS(4039),
    [anon_sym_delete] = ACTIONS(4039),
    [anon_sym_continue] = ACTIONS(4039),
    [anon_sym_DASH_DASH] = ACTIONS(4041),
    [anon_sym_if] = ACTIONS(4039),
    [sym_this] = ACTIONS(4039),
    [anon_sym_yield] = ACTIONS(4039),
    [sym_true] = ACTIONS(4039),
    [anon_sym_throw] = ACTIONS(4039),
    [anon_sym_protected] = ACTIONS(4039),
    [anon_sym_abstract] = ACTIONS(4039),
    [anon_sym_set] = ACTIONS(4039),
    [anon_sym_type] = ACTIONS(4039),
    [anon_sym_import] = ACTIONS(4039),
    [anon_sym_namespace] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4041),
    [anon_sym_DQUOTE] = ACTIONS(4041),
    [anon_sym_else] = ACTIONS(4039),
    [anon_sym_BANG] = ACTIONS(4041),
    [anon_sym_for] = ACTIONS(4039),
    [anon_sym_LBRACK] = ACTIONS(4041),
    [sym_false] = ACTIONS(4039),
    [anon_sym_SEMI] = ACTIONS(4041),
    [anon_sym_case] = ACTIONS(4039),
    [anon_sym_module] = ACTIONS(4039),
    [anon_sym_number] = ACTIONS(4039),
    [anon_sym_class] = ACTIONS(4039),
    [anon_sym_declare] = ACTIONS(4039),
    [anon_sym_typeof] = ACTIONS(4039),
    [anon_sym_LBRACE] = ACTIONS(4041),
    [anon_sym_switch] = ACTIONS(4039),
    [anon_sym_LPAREN] = ACTIONS(4041),
    [sym_null] = ACTIONS(4039),
    [anon_sym_any] = ACTIONS(4039),
    [anon_sym_boolean] = ACTIONS(4039),
    [anon_sym_async] = ACTIONS(4039),
    [anon_sym_public] = ACTIONS(4039),
    [anon_sym_var] = ACTIONS(4039),
    [anon_sym_while] = ACTIONS(4039),
    [anon_sym_SQUOTE] = ACTIONS(4041),
    [anon_sym_try] = ACTIONS(4039),
    [anon_sym_LT] = ACTIONS(4041),
    [sym_number] = ACTIONS(4041),
    [anon_sym_SLASH] = ACTIONS(4039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4039),
    [anon_sym_function] = ACTIONS(4039),
    [sym_undefined] = ACTIONS(4039),
    [anon_sym_new] = ACTIONS(4039),
    [ts_builtin_sym_end] = ACTIONS(4041),
    [anon_sym_let] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4039),
    [anon_sym_export] = ACTIONS(4039),
    [anon_sym_do] = ACTIONS(4039),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_with] = ACTIONS(4039),
    [anon_sym_await] = ACTIONS(4039),
  },
  [1105] = {
    [sym_identifier] = ACTIONS(4043),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [anon_sym_debugger] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_AT] = ACTIONS(4045),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_break] = ACTIONS(4043),
    [anon_sym_const] = ACTIONS(4043),
    [sym_super] = ACTIONS(4043),
    [anon_sym_return] = ACTIONS(4043),
    [anon_sym_private] = ACTIONS(4043),
    [anon_sym_static] = ACTIONS(4043),
    [anon_sym_get] = ACTIONS(4043),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_interface] = ACTIONS(4043),
    [anon_sym_default] = ACTIONS(4043),
    [anon_sym_enum] = ACTIONS(4043),
    [anon_sym_delete] = ACTIONS(4043),
    [anon_sym_continue] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [anon_sym_if] = ACTIONS(4043),
    [sym_this] = ACTIONS(4043),
    [anon_sym_yield] = ACTIONS(4043),
    [sym_true] = ACTIONS(4043),
    [anon_sym_throw] = ACTIONS(4043),
    [anon_sym_protected] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4043),
    [anon_sym_set] = ACTIONS(4043),
    [anon_sym_type] = ACTIONS(4043),
    [anon_sym_import] = ACTIONS(4043),
    [anon_sym_namespace] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DQUOTE] = ACTIONS(4045),
    [anon_sym_else] = ACTIONS(4043),
    [anon_sym_BANG] = ACTIONS(4045),
    [anon_sym_for] = ACTIONS(4043),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [sym_false] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4045),
    [anon_sym_case] = ACTIONS(4043),
    [anon_sym_module] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_class] = ACTIONS(4043),
    [anon_sym_declare] = ACTIONS(4043),
    [anon_sym_typeof] = ACTIONS(4043),
    [anon_sym_LBRACE] = ACTIONS(4045),
    [anon_sym_switch] = ACTIONS(4043),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [sym_null] = ACTIONS(4043),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_async] = ACTIONS(4043),
    [anon_sym_public] = ACTIONS(4043),
    [anon_sym_var] = ACTIONS(4043),
    [anon_sym_while] = ACTIONS(4043),
    [anon_sym_SQUOTE] = ACTIONS(4045),
    [anon_sym_try] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4045),
    [sym_number] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_function] = ACTIONS(4043),
    [sym_undefined] = ACTIONS(4043),
    [anon_sym_new] = ACTIONS(4043),
    [ts_builtin_sym_end] = ACTIONS(4045),
    [anon_sym_let] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_export] = ACTIONS(4043),
    [anon_sym_do] = ACTIONS(4043),
    [anon_sym_TILDE] = ACTIONS(4045),
    [anon_sym_with] = ACTIONS(4043),
    [anon_sym_await] = ACTIONS(4043),
  },
  [1106] = {
    [anon_sym_RPAREN] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
  },
  [1107] = {
    [anon_sym_COMMA] = ACTIONS(4049),
    [anon_sym_RBRACE] = ACTIONS(4049),
    [sym_comment] = ACTIONS(3),
  },
  [1108] = {
    [anon_sym_from] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
  },
  [1109] = {
    [sym__import_export_specifier] = STATE(928),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [1110] = {
    [sym_identifier] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4055),
    [anon_sym_debugger] = ACTIONS(4053),
    [anon_sym_symbol] = ACTIONS(4053),
    [anon_sym_AT] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_void] = ACTIONS(4053),
    [anon_sym_break] = ACTIONS(4053),
    [anon_sym_const] = ACTIONS(4053),
    [sym_super] = ACTIONS(4053),
    [anon_sym_return] = ACTIONS(4053),
    [anon_sym_private] = ACTIONS(4053),
    [anon_sym_static] = ACTIONS(4053),
    [anon_sym_get] = ACTIONS(4053),
    [anon_sym_interface] = ACTIONS(4053),
    [anon_sym_enum] = ACTIONS(4053),
    [anon_sym_delete] = ACTIONS(4053),
    [anon_sym_continue] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4055),
    [anon_sym_if] = ACTIONS(4053),
    [sym_this] = ACTIONS(4053),
    [anon_sym_yield] = ACTIONS(4053),
    [sym_true] = ACTIONS(4053),
    [anon_sym_throw] = ACTIONS(4053),
    [anon_sym_protected] = ACTIONS(4053),
    [anon_sym_abstract] = ACTIONS(4053),
    [anon_sym_set] = ACTIONS(4053),
    [anon_sym_type] = ACTIONS(4053),
    [anon_sym_import] = ACTIONS(4053),
    [anon_sym_namespace] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(4055),
    [anon_sym_BANG] = ACTIONS(4055),
    [anon_sym_for] = ACTIONS(4053),
    [anon_sym_LBRACK] = ACTIONS(4055),
    [sym_false] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_module] = ACTIONS(4053),
    [anon_sym_number] = ACTIONS(4053),
    [anon_sym_class] = ACTIONS(4053),
    [anon_sym_declare] = ACTIONS(4053),
    [anon_sym_typeof] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(4055),
    [anon_sym_switch] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(4055),
    [sym_null] = ACTIONS(4053),
    [anon_sym_any] = ACTIONS(4053),
    [anon_sym_boolean] = ACTIONS(4053),
    [anon_sym_async] = ACTIONS(4053),
    [anon_sym_public] = ACTIONS(4053),
    [anon_sym_var] = ACTIONS(4053),
    [anon_sym_while] = ACTIONS(4053),
    [anon_sym_SQUOTE] = ACTIONS(4055),
    [anon_sym_try] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [sym_number] = ACTIONS(4055),
    [anon_sym_SLASH] = ACTIONS(4053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4053),
    [anon_sym_function] = ACTIONS(4053),
    [sym_undefined] = ACTIONS(4053),
    [anon_sym_new] = ACTIONS(4053),
    [anon_sym_let] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_export] = ACTIONS(4053),
    [anon_sym_do] = ACTIONS(4053),
    [anon_sym_TILDE] = ACTIONS(4055),
    [anon_sym_with] = ACTIONS(4053),
    [anon_sym_await] = ACTIONS(4053),
  },
  [1111] = {
    [sym_identifier] = ACTIONS(4057),
    [anon_sym_BQUOTE] = ACTIONS(4059),
    [anon_sym_debugger] = ACTIONS(4057),
    [anon_sym_symbol] = ACTIONS(4057),
    [anon_sym_AT] = ACTIONS(4059),
    [anon_sym_DASH] = ACTIONS(4057),
    [anon_sym_void] = ACTIONS(4057),
    [anon_sym_break] = ACTIONS(4057),
    [anon_sym_const] = ACTIONS(4057),
    [sym_super] = ACTIONS(4057),
    [anon_sym_return] = ACTIONS(4057),
    [anon_sym_private] = ACTIONS(4057),
    [anon_sym_static] = ACTIONS(4057),
    [anon_sym_get] = ACTIONS(4057),
    [anon_sym_interface] = ACTIONS(4057),
    [anon_sym_enum] = ACTIONS(4057),
    [anon_sym_delete] = ACTIONS(4057),
    [anon_sym_continue] = ACTIONS(4057),
    [anon_sym_DASH_DASH] = ACTIONS(4059),
    [anon_sym_if] = ACTIONS(4057),
    [sym_this] = ACTIONS(4057),
    [anon_sym_yield] = ACTIONS(4057),
    [sym_true] = ACTIONS(4057),
    [anon_sym_throw] = ACTIONS(4057),
    [anon_sym_protected] = ACTIONS(4057),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_set] = ACTIONS(4057),
    [anon_sym_type] = ACTIONS(4057),
    [anon_sym_import] = ACTIONS(4057),
    [anon_sym_namespace] = ACTIONS(4057),
    [anon_sym_PLUS_PLUS] = ACTIONS(4059),
    [anon_sym_DQUOTE] = ACTIONS(4059),
    [anon_sym_BANG] = ACTIONS(4059),
    [anon_sym_for] = ACTIONS(4057),
    [anon_sym_LBRACK] = ACTIONS(4059),
    [sym_false] = ACTIONS(4057),
    [anon_sym_SEMI] = ACTIONS(4059),
    [anon_sym_module] = ACTIONS(4057),
    [anon_sym_number] = ACTIONS(4057),
    [anon_sym_class] = ACTIONS(4057),
    [anon_sym_declare] = ACTIONS(4057),
    [anon_sym_typeof] = ACTIONS(4057),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_switch] = ACTIONS(4057),
    [anon_sym_LPAREN] = ACTIONS(4059),
    [sym_null] = ACTIONS(4057),
    [anon_sym_any] = ACTIONS(4057),
    [anon_sym_boolean] = ACTIONS(4057),
    [anon_sym_async] = ACTIONS(4057),
    [anon_sym_public] = ACTIONS(4057),
    [anon_sym_var] = ACTIONS(4057),
    [anon_sym_while] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(4059),
    [anon_sym_try] = ACTIONS(4057),
    [anon_sym_LT] = ACTIONS(4059),
    [sym_number] = ACTIONS(4059),
    [anon_sym_SLASH] = ACTIONS(4057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4057),
    [anon_sym_function] = ACTIONS(4057),
    [sym_undefined] = ACTIONS(4057),
    [anon_sym_new] = ACTIONS(4057),
    [anon_sym_let] = ACTIONS(4057),
    [anon_sym_PLUS] = ACTIONS(4057),
    [anon_sym_export] = ACTIONS(4057),
    [anon_sym_do] = ACTIONS(4057),
    [anon_sym_TILDE] = ACTIONS(4059),
    [anon_sym_with] = ACTIONS(4057),
    [anon_sym_await] = ACTIONS(4057),
  },
  [1112] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1113] = {
    [anon_sym_RPAREN] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
  },
  [1114] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1115] = {
    [anon_sym_RPAREN] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
  },
  [1116] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(4063),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1117] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1118] = {
    [anon_sym_RPAREN] = ACTIONS(4065),
    [sym_comment] = ACTIONS(3),
  },
  [1119] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(4065),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1120] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_GT_GT_GT] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_instanceof] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(567),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(553),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1121] = {
    [anon_sym_RPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(3),
  },
  [1122] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1123] = {
    [sym_identifier] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_debugger] = ACTIONS(4069),
    [anon_sym_symbol] = ACTIONS(4069),
    [anon_sym_AT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_void] = ACTIONS(4069),
    [anon_sym_break] = ACTIONS(4069),
    [anon_sym_const] = ACTIONS(4069),
    [sym_super] = ACTIONS(4069),
    [anon_sym_return] = ACTIONS(4069),
    [anon_sym_private] = ACTIONS(4069),
    [anon_sym_static] = ACTIONS(4069),
    [anon_sym_get] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_interface] = ACTIONS(4069),
    [anon_sym_default] = ACTIONS(4069),
    [anon_sym_enum] = ACTIONS(4069),
    [anon_sym_delete] = ACTIONS(4069),
    [anon_sym_continue] = ACTIONS(4069),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_if] = ACTIONS(4069),
    [sym_this] = ACTIONS(4069),
    [anon_sym_yield] = ACTIONS(4069),
    [sym_true] = ACTIONS(4069),
    [anon_sym_throw] = ACTIONS(4069),
    [anon_sym_protected] = ACTIONS(4069),
    [anon_sym_abstract] = ACTIONS(4069),
    [anon_sym_set] = ACTIONS(4069),
    [anon_sym_type] = ACTIONS(4069),
    [anon_sym_import] = ACTIONS(4069),
    [anon_sym_namespace] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4071),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_for] = ACTIONS(4069),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [sym_false] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_case] = ACTIONS(4069),
    [anon_sym_module] = ACTIONS(4069),
    [anon_sym_number] = ACTIONS(4069),
    [anon_sym_class] = ACTIONS(4069),
    [anon_sym_declare] = ACTIONS(4069),
    [anon_sym_typeof] = ACTIONS(4069),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_switch] = ACTIONS(4069),
    [anon_sym_LPAREN] = ACTIONS(4071),
    [sym_null] = ACTIONS(4069),
    [anon_sym_any] = ACTIONS(4069),
    [anon_sym_boolean] = ACTIONS(4069),
    [anon_sym_async] = ACTIONS(4069),
    [anon_sym_public] = ACTIONS(4069),
    [anon_sym_var] = ACTIONS(4069),
    [anon_sym_while] = ACTIONS(4069),
    [anon_sym_SQUOTE] = ACTIONS(4071),
    [anon_sym_try] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4071),
    [sym_number] = ACTIONS(4071),
    [anon_sym_SLASH] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4069),
    [anon_sym_function] = ACTIONS(4069),
    [sym_undefined] = ACTIONS(4069),
    [anon_sym_new] = ACTIONS(4069),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [anon_sym_let] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_export] = ACTIONS(4069),
    [anon_sym_do] = ACTIONS(4069),
    [anon_sym_TILDE] = ACTIONS(4071),
    [anon_sym_with] = ACTIONS(4069),
    [anon_sym_await] = ACTIONS(4069),
  },
  [1124] = {
    [sym_generator_function_declaration] = STATE(1215),
    [sym__declaration] = STATE(1215),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1215),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1215),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1215),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1215),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1215),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1215),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1215),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1215),
    [sym_function_declaration] = STATE(1215),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1215),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1215),
    [sym_break_statement] = STATE(1215),
    [sym_labeled_statement] = STATE(1215),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1215),
    [sym_class_declaration] = STATE(1215),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1215),
    [sym_ambient_declaration] = STATE(1215),
    [sym_type_alias_declaration] = STATE(1215),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1215),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1215),
    [sym_switch_statement] = STATE(1215),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1215),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1215),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1215),
    [sym_abstract_class_declaration] = STATE(1215),
    [sym_interface_declaration] = STATE(1215),
    [sym_export_statement] = STATE(1215),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1215),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1215),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1215),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1125] = {
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_BQUOTE] = ACTIONS(4075),
    [anon_sym_debugger] = ACTIONS(4073),
    [anon_sym_symbol] = ACTIONS(4073),
    [anon_sym_AT] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_void] = ACTIONS(4073),
    [anon_sym_break] = ACTIONS(4073),
    [anon_sym_const] = ACTIONS(4073),
    [sym_super] = ACTIONS(4073),
    [anon_sym_return] = ACTIONS(4073),
    [anon_sym_private] = ACTIONS(4073),
    [anon_sym_static] = ACTIONS(4073),
    [anon_sym_get] = ACTIONS(4073),
    [anon_sym_interface] = ACTIONS(4073),
    [anon_sym_enum] = ACTIONS(4073),
    [anon_sym_delete] = ACTIONS(4073),
    [anon_sym_continue] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4075),
    [anon_sym_if] = ACTIONS(4073),
    [sym_this] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [sym_true] = ACTIONS(4073),
    [anon_sym_throw] = ACTIONS(4073),
    [anon_sym_protected] = ACTIONS(4073),
    [anon_sym_abstract] = ACTIONS(4073),
    [anon_sym_set] = ACTIONS(4073),
    [anon_sym_type] = ACTIONS(4073),
    [anon_sym_import] = ACTIONS(4073),
    [anon_sym_namespace] = ACTIONS(4073),
    [anon_sym_PLUS_PLUS] = ACTIONS(4075),
    [anon_sym_DQUOTE] = ACTIONS(4075),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_for] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(4075),
    [sym_false] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(4075),
    [anon_sym_module] = ACTIONS(4073),
    [anon_sym_number] = ACTIONS(4073),
    [anon_sym_class] = ACTIONS(4073),
    [anon_sym_declare] = ACTIONS(4073),
    [anon_sym_typeof] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_switch] = ACTIONS(4073),
    [anon_sym_LPAREN] = ACTIONS(4075),
    [sym_null] = ACTIONS(4073),
    [anon_sym_any] = ACTIONS(4073),
    [anon_sym_boolean] = ACTIONS(4073),
    [anon_sym_async] = ACTIONS(4073),
    [anon_sym_public] = ACTIONS(4073),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_while] = ACTIONS(4073),
    [anon_sym_SQUOTE] = ACTIONS(4075),
    [anon_sym_try] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4075),
    [sym_number] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4073),
    [anon_sym_function] = ACTIONS(4073),
    [sym_undefined] = ACTIONS(4073),
    [anon_sym_new] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_export] = ACTIONS(4073),
    [anon_sym_do] = ACTIONS(4073),
    [anon_sym_TILDE] = ACTIONS(4075),
    [anon_sym_with] = ACTIONS(4073),
    [anon_sym_await] = ACTIONS(4073),
  },
  [1126] = {
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_BQUOTE] = ACTIONS(4079),
    [anon_sym_debugger] = ACTIONS(4077),
    [anon_sym_symbol] = ACTIONS(4077),
    [anon_sym_AT] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4077),
    [anon_sym_void] = ACTIONS(4077),
    [anon_sym_break] = ACTIONS(4077),
    [anon_sym_const] = ACTIONS(4077),
    [sym_super] = ACTIONS(4077),
    [anon_sym_return] = ACTIONS(4077),
    [anon_sym_private] = ACTIONS(4077),
    [anon_sym_static] = ACTIONS(4077),
    [anon_sym_get] = ACTIONS(4077),
    [anon_sym_interface] = ACTIONS(4077),
    [anon_sym_enum] = ACTIONS(4077),
    [anon_sym_delete] = ACTIONS(4077),
    [anon_sym_continue] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4079),
    [anon_sym_if] = ACTIONS(4077),
    [sym_this] = ACTIONS(4077),
    [anon_sym_yield] = ACTIONS(4077),
    [sym_true] = ACTIONS(4077),
    [anon_sym_throw] = ACTIONS(4077),
    [anon_sym_protected] = ACTIONS(4077),
    [anon_sym_abstract] = ACTIONS(4077),
    [anon_sym_set] = ACTIONS(4077),
    [anon_sym_type] = ACTIONS(4077),
    [anon_sym_import] = ACTIONS(4077),
    [anon_sym_namespace] = ACTIONS(4077),
    [anon_sym_PLUS_PLUS] = ACTIONS(4079),
    [anon_sym_DQUOTE] = ACTIONS(4079),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_for] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [sym_false] = ACTIONS(4077),
    [anon_sym_SEMI] = ACTIONS(4079),
    [anon_sym_module] = ACTIONS(4077),
    [anon_sym_number] = ACTIONS(4077),
    [anon_sym_class] = ACTIONS(4077),
    [anon_sym_declare] = ACTIONS(4077),
    [anon_sym_typeof] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4079),
    [anon_sym_switch] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4079),
    [sym_null] = ACTIONS(4077),
    [anon_sym_any] = ACTIONS(4077),
    [anon_sym_boolean] = ACTIONS(4077),
    [anon_sym_async] = ACTIONS(4077),
    [anon_sym_public] = ACTIONS(4077),
    [anon_sym_var] = ACTIONS(4077),
    [anon_sym_while] = ACTIONS(4077),
    [anon_sym_SQUOTE] = ACTIONS(4079),
    [anon_sym_try] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4079),
    [sym_number] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4077),
    [anon_sym_function] = ACTIONS(4077),
    [sym_undefined] = ACTIONS(4077),
    [anon_sym_new] = ACTIONS(4077),
    [anon_sym_let] = ACTIONS(4077),
    [anon_sym_PLUS] = ACTIONS(4077),
    [anon_sym_export] = ACTIONS(4077),
    [anon_sym_do] = ACTIONS(4077),
    [anon_sym_TILDE] = ACTIONS(4079),
    [anon_sym_with] = ACTIONS(4077),
    [anon_sym_await] = ACTIONS(4077),
  },
  [1127] = {
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_BQUOTE] = ACTIONS(4083),
    [anon_sym_debugger] = ACTIONS(4081),
    [anon_sym_symbol] = ACTIONS(4081),
    [anon_sym_AT] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4081),
    [anon_sym_void] = ACTIONS(4081),
    [anon_sym_break] = ACTIONS(4081),
    [anon_sym_const] = ACTIONS(4081),
    [sym_super] = ACTIONS(4081),
    [anon_sym_return] = ACTIONS(4081),
    [anon_sym_private] = ACTIONS(4081),
    [anon_sym_static] = ACTIONS(4081),
    [anon_sym_get] = ACTIONS(4081),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_interface] = ACTIONS(4081),
    [anon_sym_default] = ACTIONS(4081),
    [anon_sym_enum] = ACTIONS(4081),
    [anon_sym_delete] = ACTIONS(4081),
    [anon_sym_continue] = ACTIONS(4081),
    [anon_sym_DASH_DASH] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4081),
    [sym_this] = ACTIONS(4081),
    [anon_sym_yield] = ACTIONS(4081),
    [sym_true] = ACTIONS(4081),
    [anon_sym_throw] = ACTIONS(4081),
    [anon_sym_protected] = ACTIONS(4081),
    [anon_sym_abstract] = ACTIONS(4081),
    [anon_sym_set] = ACTIONS(4081),
    [anon_sym_type] = ACTIONS(4081),
    [anon_sym_import] = ACTIONS(4081),
    [anon_sym_namespace] = ACTIONS(4081),
    [anon_sym_PLUS_PLUS] = ACTIONS(4083),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4081),
    [anon_sym_BANG] = ACTIONS(4083),
    [anon_sym_for] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [sym_false] = ACTIONS(4081),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4081),
    [anon_sym_module] = ACTIONS(4081),
    [anon_sym_number] = ACTIONS(4081),
    [anon_sym_class] = ACTIONS(4081),
    [anon_sym_declare] = ACTIONS(4081),
    [anon_sym_typeof] = ACTIONS(4081),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [anon_sym_switch] = ACTIONS(4081),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [sym_null] = ACTIONS(4081),
    [anon_sym_any] = ACTIONS(4081),
    [anon_sym_boolean] = ACTIONS(4081),
    [anon_sym_async] = ACTIONS(4081),
    [anon_sym_public] = ACTIONS(4081),
    [anon_sym_var] = ACTIONS(4081),
    [anon_sym_while] = ACTIONS(4081),
    [anon_sym_SQUOTE] = ACTIONS(4083),
    [anon_sym_try] = ACTIONS(4081),
    [anon_sym_LT] = ACTIONS(4083),
    [sym_number] = ACTIONS(4083),
    [anon_sym_SLASH] = ACTIONS(4081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4081),
    [anon_sym_function] = ACTIONS(4081),
    [sym_undefined] = ACTIONS(4081),
    [anon_sym_new] = ACTIONS(4081),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_let] = ACTIONS(4081),
    [anon_sym_PLUS] = ACTIONS(4081),
    [anon_sym_export] = ACTIONS(4081),
    [anon_sym_do] = ACTIONS(4081),
    [anon_sym_TILDE] = ACTIONS(4083),
    [anon_sym_with] = ACTIONS(4081),
    [anon_sym_await] = ACTIONS(4081),
  },
  [1128] = {
    [sym_statement_block] = STATE(1613),
    [sym__automatic_semicolon] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1129] = {
    [anon_sym_RBRACK] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
  },
  [1130] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_RBRACK] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
  },
  [1131] = {
    [anon_sym_RBRACK] = ACTIONS(4091),
    [sym_comment] = ACTIONS(3),
  },
  [1132] = {
    [sym__automatic_semicolon] = ACTIONS(4093),
    [anon_sym_RBRACE] = ACTIONS(4093),
    [anon_sym_SEMI] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4093),
  },
  [1133] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1218),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1134] = {
    [sym__automatic_semicolon] = ACTIONS(4095),
    [anon_sym_SEMI] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4095),
    [sym_comment] = ACTIONS(3),
  },
  [1135] = {
    [sym__initializer] = STATE(1219),
    [sym_type_annotation] = STATE(1220),
    [sym__automatic_semicolon] = ACTIONS(4097),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4097),
    [anon_sym_COMMA] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
  },
  [1136] = {
    [sym__automatic_semicolon] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(4099),
    [anon_sym_COMMA] = ACTIONS(4099),
    [sym_comment] = ACTIONS(3),
  },
  [1137] = {
    [sym__initializer] = STATE(1221),
    [sym__automatic_semicolon] = ACTIONS(4101),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(4101),
    [anon_sym_COMMA] = ACTIONS(4101),
    [sym_comment] = ACTIONS(3),
  },
  [1138] = {
    [sym__automatic_semicolon] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
  },
  [1139] = {
    [sym__automatic_semicolon] = ACTIONS(4105),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_COMMA] = ACTIONS(4105),
    [sym_comment] = ACTIONS(3),
  },
  [1140] = {
    [sym__initializer] = STATE(1222),
    [sym__automatic_semicolon] = ACTIONS(4107),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(4107),
    [anon_sym_COMMA] = ACTIONS(4107),
    [sym_comment] = ACTIONS(3),
  },
  [1141] = {
    [sym__automatic_semicolon] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
  },
  [1142] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1223),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1143] = {
    [sym_statement_block] = STATE(1614),
    [sym__automatic_semicolon] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1144] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1225),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1145] = {
    [sym_string] = STATE(1226),
    [sym__property_name] = STATE(1226),
    [sym_computed_property_name] = STATE(1226),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1146] = {
    [sym_string] = STATE(1226),
    [sym__property_name] = STATE(1226),
    [sym_computed_property_name] = STATE(1226),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(4115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1147] = {
    [sym_type_annotation] = STATE(1220),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1219),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1223),
    [sym__automatic_semicolon] = ACTIONS(4097),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4097),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
  },
  [1148] = {
    [sym_string] = STATE(1226),
    [sym__property_name] = STATE(1226),
    [sym_computed_property_name] = STATE(1226),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(4119),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(4119),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [1149] = {
    [sym_type_annotation] = STATE(1232),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1231),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1225),
    [sym__automatic_semicolon] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(4123),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4125),
  },
  [1150] = {
    [sym__initializer] = STATE(1231),
    [sym_type_annotation] = STATE(1232),
    [sym__automatic_semicolon] = ACTIONS(4121),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(4125),
    [anon_sym_COMMA] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4125),
  },
  [1151] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1234),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4127),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1152] = {
    [sym_type_annotation] = STATE(1220),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1219),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1218),
    [sym__automatic_semicolon] = ACTIONS(4097),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4097),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
  },
  [1153] = {
    [sym__automatic_semicolon] = ACTIONS(4129),
    [anon_sym_SEMI] = ACTIONS(4129),
    [anon_sym_COMMA] = ACTIONS(4129),
    [sym_comment] = ACTIONS(3),
  },
  [1154] = {
    [anon_sym_BQUOTE] = ACTIONS(4131),
    [anon_sym_symbol] = ACTIONS(4133),
    [anon_sym_PIPE] = ACTIONS(4135),
    [anon_sym_break] = ACTIONS(4133),
    [anon_sym_return] = ACTIONS(4133),
    [anon_sym_static] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4131),
    [anon_sym_interface] = ACTIONS(4133),
    [anon_sym_delete] = ACTIONS(4133),
    [anon_sym_if] = ACTIONS(4133),
    [anon_sym_yield] = ACTIONS(4133),
    [sym_true] = ACTIONS(4133),
    [anon_sym_protected] = ACTIONS(4133),
    [anon_sym_set] = ACTIONS(4133),
    [anon_sym_import] = ACTIONS(4133),
    [anon_sym_DQUOTE] = ACTIONS(4131),
    [anon_sym_for] = ACTIONS(4133),
    [anon_sym_SEMI] = ACTIONS(4131),
    [anon_sym_number] = ACTIONS(4133),
    [anon_sym_typeof] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(4131),
    [anon_sym_switch] = ACTIONS(4133),
    [sym_null] = ACTIONS(4133),
    [anon_sym_any] = ACTIONS(4133),
    [anon_sym_async] = ACTIONS(4133),
    [anon_sym_public] = ACTIONS(4133),
    [anon_sym_var] = ACTIONS(4133),
    [anon_sym_while] = ACTIONS(4133),
    [anon_sym_SQUOTE] = ACTIONS(4131),
    [anon_sym_SLASH] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4133),
    [anon_sym_new] = ACTIONS(4133),
    [anon_sym_export] = ACTIONS(4133),
    [anon_sym_with] = ACTIONS(4133),
    [sym_identifier] = ACTIONS(4133),
    [anon_sym_debugger] = ACTIONS(4133),
    [anon_sym_AT] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4133),
    [anon_sym_void] = ACTIONS(4133),
    [anon_sym_const] = ACTIONS(4133),
    [sym_super] = ACTIONS(4133),
    [anon_sym_private] = ACTIONS(4133),
    [anon_sym_get] = ACTIONS(4133),
    [anon_sym_default] = ACTIONS(4133),
    [anon_sym_enum] = ACTIONS(4133),
    [anon_sym_continue] = ACTIONS(4133),
    [anon_sym_DASH_DASH] = ACTIONS(4131),
    [sym_this] = ACTIONS(4133),
    [anon_sym_throw] = ACTIONS(4133),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_type] = ACTIONS(4133),
    [anon_sym_namespace] = ACTIONS(4133),
    [anon_sym_PLUS_PLUS] = ACTIONS(4131),
    [anon_sym_else] = ACTIONS(4133),
    [anon_sym_BANG] = ACTIONS(4131),
    [anon_sym_LBRACK] = ACTIONS(4131),
    [sym_false] = ACTIONS(4133),
    [anon_sym_case] = ACTIONS(4133),
    [anon_sym_module] = ACTIONS(4133),
    [anon_sym_class] = ACTIONS(4133),
    [anon_sym_declare] = ACTIONS(4133),
    [anon_sym_LPAREN] = ACTIONS(4131),
    [anon_sym_boolean] = ACTIONS(4133),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4133),
    [anon_sym_LT] = ACTIONS(4131),
    [sym_number] = ACTIONS(4131),
    [ts_builtin_sym_end] = ACTIONS(4131),
    [anon_sym_function] = ACTIONS(4133),
    [sym_undefined] = ACTIONS(4133),
    [anon_sym_let] = ACTIONS(4133),
    [anon_sym_PLUS] = ACTIONS(4133),
    [anon_sym_do] = ACTIONS(4133),
    [anon_sym_TILDE] = ACTIONS(4131),
    [anon_sym_await] = ACTIONS(4133),
  },
  [1155] = {
    [sym__automatic_semicolon] = ACTIONS(3683),
    [sym_identifier] = ACTIONS(3687),
    [anon_sym_BQUOTE] = ACTIONS(3685),
    [anon_sym_debugger] = ACTIONS(3687),
    [anon_sym_symbol] = ACTIONS(3687),
    [anon_sym_AT] = ACTIONS(3685),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_void] = ACTIONS(3687),
    [anon_sym_break] = ACTIONS(3687),
    [anon_sym_const] = ACTIONS(3687),
    [sym_super] = ACTIONS(3687),
    [anon_sym_return] = ACTIONS(3687),
    [anon_sym_private] = ACTIONS(3687),
    [anon_sym_static] = ACTIONS(3687),
    [anon_sym_get] = ACTIONS(3687),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3687),
    [anon_sym_default] = ACTIONS(3687),
    [anon_sym_enum] = ACTIONS(3687),
    [anon_sym_delete] = ACTIONS(3687),
    [anon_sym_continue] = ACTIONS(3687),
    [anon_sym_DASH_DASH] = ACTIONS(3685),
    [anon_sym_if] = ACTIONS(3687),
    [sym_this] = ACTIONS(3687),
    [anon_sym_yield] = ACTIONS(3687),
    [sym_true] = ACTIONS(3687),
    [anon_sym_throw] = ACTIONS(3687),
    [anon_sym_protected] = ACTIONS(3687),
    [anon_sym_abstract] = ACTIONS(3687),
    [anon_sym_set] = ACTIONS(3687),
    [anon_sym_type] = ACTIONS(3687),
    [anon_sym_import] = ACTIONS(3687),
    [anon_sym_namespace] = ACTIONS(3687),
    [anon_sym_PLUS_PLUS] = ACTIONS(3685),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_else] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3685),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [sym_false] = ACTIONS(3687),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_case] = ACTIONS(3687),
    [anon_sym_module] = ACTIONS(3687),
    [anon_sym_number] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_declare] = ACTIONS(3687),
    [anon_sym_typeof] = ACTIONS(3687),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_switch] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [sym_null] = ACTIONS(3687),
    [anon_sym_any] = ACTIONS(3687),
    [anon_sym_boolean] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_public] = ACTIONS(3687),
    [anon_sym_var] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3685),
    [anon_sym_try] = ACTIONS(3687),
    [anon_sym_LT] = ACTIONS(3685),
    [sym_number] = ACTIONS(3685),
    [anon_sym_SLASH] = ACTIONS(3687),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3687),
    [anon_sym_function] = ACTIONS(3687),
    [sym_undefined] = ACTIONS(3687),
    [anon_sym_new] = ACTIONS(3687),
    [ts_builtin_sym_end] = ACTIONS(3685),
    [anon_sym_let] = ACTIONS(3687),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_export] = ACTIONS(3687),
    [anon_sym_do] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3685),
    [anon_sym_with] = ACTIONS(3687),
    [anon_sym_await] = ACTIONS(3687),
  },
  [1156] = {
    [sym__automatic_semicolon] = ACTIONS(3793),
    [sym_identifier] = ACTIONS(3797),
    [anon_sym_BQUOTE] = ACTIONS(3795),
    [anon_sym_debugger] = ACTIONS(3797),
    [anon_sym_symbol] = ACTIONS(3797),
    [anon_sym_AT] = ACTIONS(3795),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_void] = ACTIONS(3797),
    [anon_sym_break] = ACTIONS(3797),
    [anon_sym_const] = ACTIONS(3797),
    [sym_super] = ACTIONS(3797),
    [anon_sym_return] = ACTIONS(3797),
    [anon_sym_private] = ACTIONS(3797),
    [anon_sym_static] = ACTIONS(3797),
    [anon_sym_get] = ACTIONS(3797),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_interface] = ACTIONS(3797),
    [anon_sym_default] = ACTIONS(3797),
    [anon_sym_enum] = ACTIONS(3797),
    [anon_sym_delete] = ACTIONS(3797),
    [anon_sym_continue] = ACTIONS(3797),
    [anon_sym_DASH_DASH] = ACTIONS(3795),
    [anon_sym_if] = ACTIONS(3797),
    [sym_this] = ACTIONS(3797),
    [anon_sym_yield] = ACTIONS(3797),
    [sym_true] = ACTIONS(3797),
    [anon_sym_throw] = ACTIONS(3797),
    [anon_sym_protected] = ACTIONS(3797),
    [anon_sym_abstract] = ACTIONS(3797),
    [anon_sym_set] = ACTIONS(3797),
    [anon_sym_type] = ACTIONS(3797),
    [anon_sym_import] = ACTIONS(3797),
    [anon_sym_namespace] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3795),
    [anon_sym_DQUOTE] = ACTIONS(3795),
    [anon_sym_else] = ACTIONS(3797),
    [anon_sym_BANG] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3797),
    [anon_sym_LBRACK] = ACTIONS(3795),
    [sym_false] = ACTIONS(3797),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym_case] = ACTIONS(3797),
    [anon_sym_module] = ACTIONS(3797),
    [anon_sym_number] = ACTIONS(3797),
    [anon_sym_class] = ACTIONS(3797),
    [anon_sym_declare] = ACTIONS(3797),
    [anon_sym_typeof] = ACTIONS(3797),
    [anon_sym_LBRACE] = ACTIONS(3795),
    [anon_sym_switch] = ACTIONS(3797),
    [anon_sym_LPAREN] = ACTIONS(3795),
    [sym_null] = ACTIONS(3797),
    [anon_sym_any] = ACTIONS(3797),
    [anon_sym_boolean] = ACTIONS(3797),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_public] = ACTIONS(3797),
    [anon_sym_var] = ACTIONS(3797),
    [anon_sym_while] = ACTIONS(3797),
    [anon_sym_SQUOTE] = ACTIONS(3795),
    [anon_sym_try] = ACTIONS(3797),
    [anon_sym_LT] = ACTIONS(3795),
    [sym_number] = ACTIONS(3795),
    [anon_sym_SLASH] = ACTIONS(3797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3797),
    [anon_sym_function] = ACTIONS(3797),
    [sym_undefined] = ACTIONS(3797),
    [anon_sym_new] = ACTIONS(3797),
    [ts_builtin_sym_end] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3797),
    [anon_sym_PLUS] = ACTIONS(3797),
    [anon_sym_export] = ACTIONS(3797),
    [anon_sym_do] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3795),
    [anon_sym_with] = ACTIONS(3797),
    [anon_sym_await] = ACTIONS(3797),
  },
  [1157] = {
    [sym_statement_block] = STATE(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3123),
  },
  [1158] = {
    [sym__automatic_semicolon] = ACTIONS(3847),
    [sym_identifier] = ACTIONS(3851),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [anon_sym_debugger] = ACTIONS(3851),
    [anon_sym_symbol] = ACTIONS(3851),
    [anon_sym_AT] = ACTIONS(3849),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_void] = ACTIONS(3851),
    [anon_sym_break] = ACTIONS(3851),
    [anon_sym_const] = ACTIONS(3851),
    [sym_super] = ACTIONS(3851),
    [anon_sym_return] = ACTIONS(3851),
    [anon_sym_private] = ACTIONS(3851),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_get] = ACTIONS(3851),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3851),
    [anon_sym_default] = ACTIONS(3851),
    [anon_sym_enum] = ACTIONS(3851),
    [anon_sym_delete] = ACTIONS(3851),
    [anon_sym_continue] = ACTIONS(3851),
    [anon_sym_DASH_DASH] = ACTIONS(3849),
    [anon_sym_if] = ACTIONS(3851),
    [sym_this] = ACTIONS(3851),
    [anon_sym_yield] = ACTIONS(3851),
    [sym_true] = ACTIONS(3851),
    [anon_sym_throw] = ACTIONS(3851),
    [anon_sym_protected] = ACTIONS(3851),
    [anon_sym_abstract] = ACTIONS(3851),
    [anon_sym_set] = ACTIONS(3851),
    [anon_sym_type] = ACTIONS(3851),
    [anon_sym_import] = ACTIONS(3851),
    [anon_sym_namespace] = ACTIONS(3851),
    [anon_sym_PLUS_PLUS] = ACTIONS(3849),
    [anon_sym_DQUOTE] = ACTIONS(3849),
    [anon_sym_else] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3849),
    [anon_sym_for] = ACTIONS(3851),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [sym_false] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3849),
    [anon_sym_case] = ACTIONS(3851),
    [anon_sym_module] = ACTIONS(3851),
    [anon_sym_number] = ACTIONS(3851),
    [anon_sym_class] = ACTIONS(3851),
    [anon_sym_declare] = ACTIONS(3851),
    [anon_sym_typeof] = ACTIONS(3851),
    [anon_sym_LBRACE] = ACTIONS(3849),
    [anon_sym_switch] = ACTIONS(3851),
    [anon_sym_LPAREN] = ACTIONS(3849),
    [sym_null] = ACTIONS(3851),
    [anon_sym_any] = ACTIONS(3851),
    [anon_sym_boolean] = ACTIONS(3851),
    [anon_sym_async] = ACTIONS(3851),
    [anon_sym_public] = ACTIONS(3851),
    [anon_sym_var] = ACTIONS(3851),
    [anon_sym_while] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3849),
    [anon_sym_try] = ACTIONS(3851),
    [anon_sym_LT] = ACTIONS(3849),
    [sym_number] = ACTIONS(3849),
    [anon_sym_SLASH] = ACTIONS(3851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3851),
    [anon_sym_function] = ACTIONS(3851),
    [sym_undefined] = ACTIONS(3851),
    [anon_sym_new] = ACTIONS(3851),
    [ts_builtin_sym_end] = ACTIONS(3849),
    [anon_sym_let] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_export] = ACTIONS(3851),
    [anon_sym_do] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3849),
    [anon_sym_with] = ACTIONS(3851),
    [anon_sym_await] = ACTIONS(3851),
  },
  [1159] = {
    [sym__automatic_semicolon] = ACTIONS(3945),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_BQUOTE] = ACTIONS(3947),
    [anon_sym_debugger] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_AT] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_void] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [sym_super] = ACTIONS(3949),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_get] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_delete] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_DASH_DASH] = ACTIONS(3947),
    [anon_sym_if] = ACTIONS(3949),
    [sym_this] = ACTIONS(3949),
    [anon_sym_yield] = ACTIONS(3949),
    [sym_true] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3949),
    [anon_sym_set] = ACTIONS(3949),
    [anon_sym_type] = ACTIONS(3949),
    [anon_sym_import] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_PLUS_PLUS] = ACTIONS(3947),
    [anon_sym_DQUOTE] = ACTIONS(3947),
    [anon_sym_else] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [sym_false] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3947),
    [anon_sym_case] = ACTIONS(3949),
    [anon_sym_module] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_declare] = ACTIONS(3949),
    [anon_sym_typeof] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3947),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_LPAREN] = ACTIONS(3947),
    [sym_null] = ACTIONS(3949),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_async] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_LT] = ACTIONS(3947),
    [sym_number] = ACTIONS(3947),
    [anon_sym_SLASH] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_function] = ACTIONS(3949),
    [sym_undefined] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [ts_builtin_sym_end] = ACTIONS(3947),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_export] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3947),
    [anon_sym_with] = ACTIONS(3949),
    [anon_sym_await] = ACTIONS(3949),
  },
  [1160] = {
    [sym__automatic_semicolon] = ACTIONS(3955),
    [sym_identifier] = ACTIONS(3959),
    [anon_sym_BQUOTE] = ACTIONS(3957),
    [anon_sym_debugger] = ACTIONS(3959),
    [anon_sym_symbol] = ACTIONS(3959),
    [anon_sym_AT] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3959),
    [anon_sym_void] = ACTIONS(3959),
    [anon_sym_break] = ACTIONS(3959),
    [anon_sym_const] = ACTIONS(3959),
    [sym_super] = ACTIONS(3959),
    [anon_sym_return] = ACTIONS(3959),
    [anon_sym_private] = ACTIONS(3959),
    [anon_sym_static] = ACTIONS(3959),
    [anon_sym_get] = ACTIONS(3959),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_interface] = ACTIONS(3959),
    [anon_sym_default] = ACTIONS(3959),
    [anon_sym_enum] = ACTIONS(3959),
    [anon_sym_delete] = ACTIONS(3959),
    [anon_sym_continue] = ACTIONS(3959),
    [anon_sym_DASH_DASH] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3959),
    [sym_this] = ACTIONS(3959),
    [anon_sym_yield] = ACTIONS(3959),
    [sym_true] = ACTIONS(3959),
    [anon_sym_throw] = ACTIONS(3959),
    [anon_sym_protected] = ACTIONS(3959),
    [anon_sym_abstract] = ACTIONS(3959),
    [anon_sym_set] = ACTIONS(3959),
    [anon_sym_type] = ACTIONS(3959),
    [anon_sym_import] = ACTIONS(3959),
    [anon_sym_namespace] = ACTIONS(3959),
    [anon_sym_PLUS_PLUS] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3957),
    [anon_sym_else] = ACTIONS(3959),
    [anon_sym_BANG] = ACTIONS(3957),
    [anon_sym_for] = ACTIONS(3959),
    [anon_sym_LBRACK] = ACTIONS(3957),
    [sym_false] = ACTIONS(3959),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_case] = ACTIONS(3959),
    [anon_sym_module] = ACTIONS(3959),
    [anon_sym_number] = ACTIONS(3959),
    [anon_sym_class] = ACTIONS(3959),
    [anon_sym_declare] = ACTIONS(3959),
    [anon_sym_typeof] = ACTIONS(3959),
    [anon_sym_LBRACE] = ACTIONS(3957),
    [anon_sym_switch] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [sym_null] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3959),
    [anon_sym_boolean] = ACTIONS(3959),
    [anon_sym_async] = ACTIONS(3959),
    [anon_sym_public] = ACTIONS(3959),
    [anon_sym_var] = ACTIONS(3959),
    [anon_sym_while] = ACTIONS(3959),
    [anon_sym_SQUOTE] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(3957),
    [sym_number] = ACTIONS(3957),
    [anon_sym_SLASH] = ACTIONS(3959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3959),
    [anon_sym_function] = ACTIONS(3959),
    [sym_undefined] = ACTIONS(3959),
    [anon_sym_new] = ACTIONS(3959),
    [ts_builtin_sym_end] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3959),
    [anon_sym_PLUS] = ACTIONS(3959),
    [anon_sym_export] = ACTIONS(3959),
    [anon_sym_do] = ACTIONS(3959),
    [anon_sym_TILDE] = ACTIONS(3957),
    [anon_sym_with] = ACTIONS(3959),
    [anon_sym_await] = ACTIONS(3959),
  },
  [1161] = {
    [sym_class_body] = STATE(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2201),
  },
  [1162] = {
    [anon_sym_COMMA] = ACTIONS(4139),
    [anon_sym_RBRACE] = ACTIONS(4139),
    [sym_comment] = ACTIONS(3),
  },
  [1163] = {
    [sym_statement_block] = STATE(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1164] = {
    [anon_sym_COMMA] = ACTIONS(4141),
    [anon_sym_RBRACE] = ACTIONS(4141),
    [sym_comment] = ACTIONS(3),
  },
  [1165] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1238),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1166] = {
    [sym_statement_block] = STATE(1239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1167] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1241),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4143),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [1168] = {
    [sym_string] = STATE(1242),
    [sym__property_name] = STATE(1242),
    [sym_computed_property_name] = STATE(1242),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1169] = {
    [sym_string] = STATE(1242),
    [sym__property_name] = STATE(1242),
    [sym_computed_property_name] = STATE(1242),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(4145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1170] = {
    [sym_generator_function_declaration] = STATE(1243),
    [sym__declaration] = STATE(1243),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1243),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1243),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1243),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1243),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1243),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1243),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1243),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1243),
    [sym_function_declaration] = STATE(1243),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1243),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1243),
    [sym_break_statement] = STATE(1243),
    [sym_labeled_statement] = STATE(1243),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1243),
    [sym_class_declaration] = STATE(1243),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1243),
    [sym_ambient_declaration] = STATE(1243),
    [sym_type_alias_declaration] = STATE(1243),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1243),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1243),
    [sym_switch_statement] = STATE(1243),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(1243),
    [sym_throw_statement] = STATE(1243),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1243),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1243),
    [sym_abstract_class_declaration] = STATE(1243),
    [sym_interface_declaration] = STATE(1243),
    [sym_export_statement] = STATE(1243),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1243),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1243),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1243),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_default] = ACTIONS(4149),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(4149),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1171] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4151),
    [anon_sym_default] = ACTIONS(4153),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(4153),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1172] = {
    [anon_sym_COLON] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4155),
  },
  [1173] = {
    [sym_identifier] = ACTIONS(4157),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_debugger] = ACTIONS(4157),
    [anon_sym_symbol] = ACTIONS(4157),
    [anon_sym_AT] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4157),
    [anon_sym_void] = ACTIONS(4157),
    [anon_sym_break] = ACTIONS(4157),
    [anon_sym_const] = ACTIONS(4157),
    [sym_super] = ACTIONS(4157),
    [anon_sym_return] = ACTIONS(4157),
    [anon_sym_private] = ACTIONS(4157),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_get] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_interface] = ACTIONS(4157),
    [anon_sym_default] = ACTIONS(4157),
    [anon_sym_enum] = ACTIONS(4157),
    [anon_sym_delete] = ACTIONS(4157),
    [anon_sym_continue] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [anon_sym_if] = ACTIONS(4157),
    [sym_this] = ACTIONS(4157),
    [anon_sym_yield] = ACTIONS(4157),
    [sym_true] = ACTIONS(4157),
    [anon_sym_throw] = ACTIONS(4157),
    [anon_sym_protected] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4157),
    [anon_sym_set] = ACTIONS(4157),
    [anon_sym_type] = ACTIONS(4157),
    [anon_sym_import] = ACTIONS(4157),
    [anon_sym_namespace] = ACTIONS(4157),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_else] = ACTIONS(4157),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_for] = ACTIONS(4157),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [sym_false] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_case] = ACTIONS(4157),
    [anon_sym_module] = ACTIONS(4157),
    [anon_sym_number] = ACTIONS(4157),
    [anon_sym_class] = ACTIONS(4157),
    [anon_sym_declare] = ACTIONS(4157),
    [anon_sym_typeof] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4159),
    [sym_null] = ACTIONS(4157),
    [anon_sym_any] = ACTIONS(4157),
    [anon_sym_boolean] = ACTIONS(4157),
    [anon_sym_async] = ACTIONS(4157),
    [anon_sym_public] = ACTIONS(4157),
    [anon_sym_var] = ACTIONS(4157),
    [anon_sym_while] = ACTIONS(4157),
    [anon_sym_SQUOTE] = ACTIONS(4159),
    [anon_sym_try] = ACTIONS(4157),
    [anon_sym_LT] = ACTIONS(4159),
    [sym_number] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4157),
    [anon_sym_function] = ACTIONS(4157),
    [sym_undefined] = ACTIONS(4157),
    [anon_sym_new] = ACTIONS(4157),
    [ts_builtin_sym_end] = ACTIONS(4159),
    [anon_sym_let] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4157),
    [anon_sym_export] = ACTIONS(4157),
    [anon_sym_do] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(4159),
    [anon_sym_with] = ACTIONS(4157),
    [anon_sym_await] = ACTIONS(4157),
  },
  [1174] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4161),
    [sym__automatic_semicolon] = ACTIONS(4163),
    [anon_sym_BQUOTE] = ACTIONS(4165),
    [anon_sym_symbol] = ACTIONS(4167),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4161),
    [anon_sym_break] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_return] = ACTIONS(4167),
    [anon_sym_static] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4165),
    [anon_sym_PERCENT] = ACTIONS(4161),
    [anon_sym_interface] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4169),
    [anon_sym_delete] = ACTIONS(4167),
    [anon_sym_if] = ACTIONS(4167),
    [anon_sym_instanceof] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4167),
    [sym_true] = ACTIONS(4167),
    [anon_sym_protected] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_set] = ACTIONS(4167),
    [anon_sym_import] = ACTIONS(4167),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_DQUOTE] = ACTIONS(4165),
    [anon_sym_for] = ACTIONS(4167),
    [anon_sym_SEMI] = ACTIONS(4165),
    [anon_sym_number] = ACTIONS(4167),
    [anon_sym_typeof] = ACTIONS(4167),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4165),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [sym_null] = ACTIONS(4167),
    [anon_sym_any] = ACTIONS(4167),
    [anon_sym_async] = ACTIONS(4167),
    [anon_sym_public] = ACTIONS(4167),
    [anon_sym_var] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4161),
    [anon_sym_while] = ACTIONS(4167),
    [anon_sym_SQUOTE] = ACTIONS(4165),
    [anon_sym_SLASH] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4167),
    [anon_sym_new] = ACTIONS(4167),
    [anon_sym_CARET] = ACTIONS(4161),
    [anon_sym_export] = ACTIONS(4167),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_with] = ACTIONS(4167),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4161),
    [sym_identifier] = ACTIONS(4167),
    [anon_sym_debugger] = ACTIONS(4167),
    [anon_sym_AT] = ACTIONS(4165),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4167),
    [anon_sym_void] = ACTIONS(4167),
    [anon_sym_const] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [sym_super] = ACTIONS(4167),
    [anon_sym_private] = ACTIONS(4167),
    [anon_sym_get] = ACTIONS(4167),
    [anon_sym_default] = ACTIONS(4167),
    [anon_sym_enum] = ACTIONS(4167),
    [anon_sym_continue] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4165),
    [sym_this] = ACTIONS(4167),
    [anon_sym_throw] = ACTIONS(4167),
    [anon_sym_abstract] = ACTIONS(4167),
    [anon_sym_type] = ACTIONS(4167),
    [anon_sym_STAR_STAR] = ACTIONS(4161),
    [anon_sym_namespace] = ACTIONS(4167),
    [anon_sym_PLUS_PLUS] = ACTIONS(4165),
    [anon_sym_else] = ACTIONS(4167),
    [anon_sym_BANG] = ACTIONS(4167),
    [anon_sym_LBRACK] = ACTIONS(4165),
    [sym_false] = ACTIONS(4167),
    [anon_sym_case] = ACTIONS(4167),
    [anon_sym_module] = ACTIONS(4167),
    [anon_sym_class] = ACTIONS(4167),
    [anon_sym_declare] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4165),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_boolean] = ACTIONS(4167),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_try] = ACTIONS(4167),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4167),
    [sym_number] = ACTIONS(4165),
    [ts_builtin_sym_end] = ACTIONS(4165),
    [anon_sym_function] = ACTIONS(4167),
    [sym_undefined] = ACTIONS(4167),
    [anon_sym_let] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_do] = ACTIONS(4167),
    [anon_sym_TILDE] = ACTIONS(4165),
    [anon_sym_await] = ACTIONS(4167),
  },
  [1175] = {
    [sym_statement_block] = STATE(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1176] = {
    [sym_statement_block] = STATE(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1177] = {
    [sym_statement_block] = STATE(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1178] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [sym__automatic_semicolon] = ACTIONS(4171),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_BQUOTE] = ACTIONS(4171),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_instanceof] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4171),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG] = ACTIONS(4173),
  },
  [1179] = {
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_BQUOTE] = ACTIONS(4177),
    [anon_sym_debugger] = ACTIONS(4175),
    [anon_sym_symbol] = ACTIONS(4175),
    [anon_sym_AT] = ACTIONS(4177),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_void] = ACTIONS(4175),
    [anon_sym_break] = ACTIONS(4175),
    [anon_sym_const] = ACTIONS(4175),
    [sym_super] = ACTIONS(4175),
    [anon_sym_return] = ACTIONS(4175),
    [anon_sym_private] = ACTIONS(4175),
    [anon_sym_static] = ACTIONS(4175),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_interface] = ACTIONS(4175),
    [anon_sym_default] = ACTIONS(4175),
    [anon_sym_enum] = ACTIONS(4175),
    [anon_sym_delete] = ACTIONS(4175),
    [anon_sym_continue] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4177),
    [anon_sym_if] = ACTIONS(4175),
    [sym_this] = ACTIONS(4175),
    [anon_sym_yield] = ACTIONS(4175),
    [sym_true] = ACTIONS(4175),
    [anon_sym_throw] = ACTIONS(4175),
    [anon_sym_protected] = ACTIONS(4175),
    [anon_sym_abstract] = ACTIONS(4175),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_type] = ACTIONS(4175),
    [anon_sym_import] = ACTIONS(4175),
    [anon_sym_namespace] = ACTIONS(4175),
    [anon_sym_PLUS_PLUS] = ACTIONS(4177),
    [anon_sym_DQUOTE] = ACTIONS(4177),
    [anon_sym_else] = ACTIONS(4175),
    [anon_sym_BANG] = ACTIONS(4177),
    [anon_sym_for] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [sym_false] = ACTIONS(4175),
    [anon_sym_SEMI] = ACTIONS(4177),
    [anon_sym_case] = ACTIONS(4175),
    [anon_sym_module] = ACTIONS(4175),
    [anon_sym_number] = ACTIONS(4175),
    [anon_sym_class] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(4175),
    [anon_sym_typeof] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4177),
    [anon_sym_switch] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4177),
    [sym_null] = ACTIONS(4175),
    [anon_sym_any] = ACTIONS(4175),
    [anon_sym_boolean] = ACTIONS(4175),
    [anon_sym_async] = ACTIONS(4175),
    [anon_sym_public] = ACTIONS(4175),
    [anon_sym_var] = ACTIONS(4175),
    [anon_sym_while] = ACTIONS(4175),
    [anon_sym_SQUOTE] = ACTIONS(4177),
    [anon_sym_try] = ACTIONS(4175),
    [anon_sym_LT] = ACTIONS(4177),
    [sym_number] = ACTIONS(4177),
    [anon_sym_SLASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4175),
    [anon_sym_function] = ACTIONS(4175),
    [sym_undefined] = ACTIONS(4175),
    [anon_sym_new] = ACTIONS(4175),
    [ts_builtin_sym_end] = ACTIONS(4177),
    [anon_sym_let] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_export] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4175),
    [anon_sym_TILDE] = ACTIONS(4177),
    [anon_sym_with] = ACTIONS(4175),
    [anon_sym_await] = ACTIONS(4175),
  },
  [1180] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1181] = {
    [sym__automatic_semicolon] = ACTIONS(4179),
    [anon_sym_SEMI] = ACTIONS(4179),
    [anon_sym_from] = ACTIONS(4179),
    [sym_comment] = ACTIONS(3),
  },
  [1182] = {
    [sym__import_export_specifier] = STATE(1042),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
  },
  [1183] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [sym__automatic_semicolon] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(4181),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1184] = {
    [sym__call_signature] = STATE(2098),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1201),
    [sym__automatic_semicolon] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
  },
  [1185] = {
    [sym__call_signature] = STATE(2097),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1202),
    [sym__automatic_semicolon] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3987),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3987),
    [sym_comment] = ACTIONS(3),
  },
  [1186] = {
    [sym_string] = STATE(1249),
    [sym__property_name] = STATE(1249),
    [sym_computed_property_name] = STATE(1249),
    [anon_sym_get] = ACTIONS(4186),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(4188),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [sym_number] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(4186),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1187] = {
    [sym_identifier] = ACTIONS(4194),
    [anon_sym_BQUOTE] = ACTIONS(4196),
    [anon_sym_debugger] = ACTIONS(4194),
    [anon_sym_symbol] = ACTIONS(4194),
    [anon_sym_AT] = ACTIONS(4196),
    [anon_sym_DASH] = ACTIONS(4194),
    [anon_sym_void] = ACTIONS(4194),
    [anon_sym_break] = ACTIONS(4194),
    [anon_sym_const] = ACTIONS(4194),
    [sym_super] = ACTIONS(4194),
    [anon_sym_return] = ACTIONS(4194),
    [anon_sym_private] = ACTIONS(4194),
    [anon_sym_static] = ACTIONS(4194),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_RBRACE] = ACTIONS(4196),
    [anon_sym_interface] = ACTIONS(4194),
    [anon_sym_default] = ACTIONS(4194),
    [anon_sym_enum] = ACTIONS(4194),
    [anon_sym_delete] = ACTIONS(4194),
    [anon_sym_continue] = ACTIONS(4194),
    [anon_sym_DASH_DASH] = ACTIONS(4196),
    [anon_sym_if] = ACTIONS(4194),
    [sym_this] = ACTIONS(4194),
    [anon_sym_yield] = ACTIONS(4194),
    [sym_true] = ACTIONS(4194),
    [anon_sym_throw] = ACTIONS(4194),
    [anon_sym_protected] = ACTIONS(4194),
    [anon_sym_abstract] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_type] = ACTIONS(4194),
    [anon_sym_import] = ACTIONS(4194),
    [anon_sym_namespace] = ACTIONS(4194),
    [anon_sym_PLUS_PLUS] = ACTIONS(4196),
    [anon_sym_DQUOTE] = ACTIONS(4196),
    [anon_sym_else] = ACTIONS(4194),
    [anon_sym_BANG] = ACTIONS(4196),
    [anon_sym_for] = ACTIONS(4194),
    [anon_sym_LBRACK] = ACTIONS(4196),
    [sym_false] = ACTIONS(4194),
    [anon_sym_SEMI] = ACTIONS(4196),
    [anon_sym_case] = ACTIONS(4194),
    [anon_sym_module] = ACTIONS(4194),
    [anon_sym_number] = ACTIONS(4194),
    [anon_sym_class] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(4194),
    [anon_sym_typeof] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(4196),
    [anon_sym_switch] = ACTIONS(4194),
    [anon_sym_LPAREN] = ACTIONS(4196),
    [sym_null] = ACTIONS(4194),
    [anon_sym_any] = ACTIONS(4194),
    [anon_sym_boolean] = ACTIONS(4194),
    [anon_sym_async] = ACTIONS(4194),
    [anon_sym_public] = ACTIONS(4194),
    [anon_sym_var] = ACTIONS(4194),
    [anon_sym_while] = ACTIONS(4194),
    [anon_sym_SQUOTE] = ACTIONS(4196),
    [anon_sym_try] = ACTIONS(4194),
    [anon_sym_LT] = ACTIONS(4196),
    [sym_number] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4194),
    [anon_sym_function] = ACTIONS(4194),
    [sym_undefined] = ACTIONS(4194),
    [anon_sym_new] = ACTIONS(4194),
    [ts_builtin_sym_end] = ACTIONS(4196),
    [anon_sym_let] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4194),
    [anon_sym_export] = ACTIONS(4194),
    [anon_sym_do] = ACTIONS(4194),
    [anon_sym_TILDE] = ACTIONS(4196),
    [anon_sym_with] = ACTIONS(4194),
    [anon_sym_await] = ACTIONS(4194),
  },
  [1188] = {
    [sym_identifier] = ACTIONS(4198),
    [anon_sym_BQUOTE] = ACTIONS(4200),
    [anon_sym_debugger] = ACTIONS(4198),
    [anon_sym_symbol] = ACTIONS(4198),
    [anon_sym_AT] = ACTIONS(4200),
    [anon_sym_DASH] = ACTIONS(4198),
    [anon_sym_void] = ACTIONS(4198),
    [anon_sym_break] = ACTIONS(4198),
    [anon_sym_const] = ACTIONS(4198),
    [sym_super] = ACTIONS(4198),
    [anon_sym_return] = ACTIONS(4198),
    [anon_sym_private] = ACTIONS(4198),
    [anon_sym_static] = ACTIONS(4198),
    [anon_sym_get] = ACTIONS(4198),
    [anon_sym_RBRACE] = ACTIONS(4200),
    [anon_sym_interface] = ACTIONS(4198),
    [anon_sym_default] = ACTIONS(4198),
    [anon_sym_enum] = ACTIONS(4198),
    [anon_sym_delete] = ACTIONS(4198),
    [anon_sym_continue] = ACTIONS(4198),
    [anon_sym_DASH_DASH] = ACTIONS(4200),
    [anon_sym_if] = ACTIONS(4198),
    [sym_this] = ACTIONS(4198),
    [anon_sym_yield] = ACTIONS(4198),
    [sym_true] = ACTIONS(4198),
    [anon_sym_throw] = ACTIONS(4198),
    [anon_sym_protected] = ACTIONS(4198),
    [anon_sym_abstract] = ACTIONS(4198),
    [anon_sym_set] = ACTIONS(4198),
    [anon_sym_type] = ACTIONS(4198),
    [anon_sym_import] = ACTIONS(4198),
    [anon_sym_namespace] = ACTIONS(4198),
    [anon_sym_PLUS_PLUS] = ACTIONS(4200),
    [anon_sym_DQUOTE] = ACTIONS(4200),
    [anon_sym_else] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4200),
    [anon_sym_for] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4200),
    [sym_false] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4200),
    [anon_sym_case] = ACTIONS(4198),
    [anon_sym_module] = ACTIONS(4198),
    [anon_sym_number] = ACTIONS(4198),
    [anon_sym_class] = ACTIONS(4198),
    [anon_sym_declare] = ACTIONS(4198),
    [anon_sym_typeof] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(4200),
    [anon_sym_switch] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4200),
    [sym_null] = ACTIONS(4198),
    [anon_sym_any] = ACTIONS(4198),
    [anon_sym_boolean] = ACTIONS(4198),
    [anon_sym_async] = ACTIONS(4198),
    [anon_sym_public] = ACTIONS(4198),
    [anon_sym_var] = ACTIONS(4198),
    [anon_sym_while] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4200),
    [anon_sym_try] = ACTIONS(4198),
    [anon_sym_LT] = ACTIONS(4200),
    [sym_number] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(4198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4198),
    [anon_sym_function] = ACTIONS(4198),
    [sym_undefined] = ACTIONS(4198),
    [anon_sym_new] = ACTIONS(4198),
    [ts_builtin_sym_end] = ACTIONS(4200),
    [anon_sym_let] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4198),
    [anon_sym_export] = ACTIONS(4198),
    [anon_sym_do] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4200),
    [anon_sym_with] = ACTIONS(4198),
    [anon_sym_await] = ACTIONS(4198),
  },
  [1189] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4202),
    [sym__automatic_semicolon] = ACTIONS(4204),
    [anon_sym_BQUOTE] = ACTIONS(4206),
    [anon_sym_symbol] = ACTIONS(4208),
    [anon_sym_PIPE] = ACTIONS(4210),
    [anon_sym_STAR] = ACTIONS(4210),
    [anon_sym_GT_GT_GT] = ACTIONS(4202),
    [anon_sym_break] = ACTIONS(4208),
    [anon_sym_BANG_EQ] = ACTIONS(4210),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_PERCENT] = ACTIONS(4202),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_as] = ACTIONS(4210),
    [anon_sym_delete] = ACTIONS(4208),
    [anon_sym_if] = ACTIONS(4208),
    [anon_sym_instanceof] = ACTIONS(4210),
    [anon_sym_yield] = ACTIONS(4208),
    [sym_true] = ACTIONS(4208),
    [anon_sym_protected] = ACTIONS(4208),
    [anon_sym_DOT] = ACTIONS(4210),
    [anon_sym_set] = ACTIONS(4208),
    [anon_sym_import] = ACTIONS(4208),
    [anon_sym_in] = ACTIONS(4210),
    [anon_sym_DQUOTE] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_SEMI] = ACTIONS(4206),
    [anon_sym_number] = ACTIONS(4208),
    [anon_sym_typeof] = ACTIONS(4208),
    [anon_sym_LT_LT] = ACTIONS(4202),
    [anon_sym_LBRACE] = ACTIONS(4206),
    [anon_sym_AMP_AMP] = ACTIONS(4202),
    [anon_sym_switch] = ACTIONS(4208),
    [anon_sym_LT_EQ] = ACTIONS(4202),
    [sym_null] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4208),
    [anon_sym_async] = ACTIONS(4208),
    [anon_sym_public] = ACTIONS(4208),
    [anon_sym_var] = ACTIONS(4208),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_SQUOTE] = ACTIONS(4206),
    [anon_sym_SLASH] = ACTIONS(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4208),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_CARET] = ACTIONS(4202),
    [anon_sym_export] = ACTIONS(4208),
    [anon_sym_GT_GT] = ACTIONS(4210),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4202),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_debugger] = ACTIONS(4208),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_void] = ACTIONS(4208),
    [anon_sym_const] = ACTIONS(4208),
    [anon_sym_GT_EQ] = ACTIONS(4202),
    [sym_super] = ACTIONS(4208),
    [anon_sym_private] = ACTIONS(4208),
    [anon_sym_get] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_enum] = ACTIONS(4208),
    [anon_sym_continue] = ACTIONS(4208),
    [anon_sym_DASH_DASH] = ACTIONS(4206),
    [sym_this] = ACTIONS(4208),
    [anon_sym_throw] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_type] = ACTIONS(4208),
    [anon_sym_STAR_STAR] = ACTIONS(4202),
    [anon_sym_namespace] = ACTIONS(4208),
    [anon_sym_PLUS_PLUS] = ACTIONS(4206),
    [anon_sym_else] = ACTIONS(4208),
    [anon_sym_BANG] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4206),
    [sym_false] = ACTIONS(4208),
    [anon_sym_case] = ACTIONS(4208),
    [anon_sym_module] = ACTIONS(4208),
    [anon_sym_class] = ACTIONS(4208),
    [anon_sym_declare] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(4206),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_boolean] = ACTIONS(4208),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_PIPE_PIPE] = ACTIONS(4202),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_EQ_EQ] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4208),
    [sym_number] = ACTIONS(4206),
    [ts_builtin_sym_end] = ACTIONS(4206),
    [anon_sym_function] = ACTIONS(4208),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [anon_sym_await] = ACTIONS(4208),
  },
  [1190] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [sym__automatic_semicolon] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4161),
    [anon_sym_QMARK] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_as] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_instanceof] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_SLASH] = ACTIONS(4169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4161),
    [anon_sym_CARET] = ACTIONS(4161),
    [anon_sym_STAR_STAR] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4161),
    [anon_sym_BANG] = ACTIONS(4169),
  },
  [1191] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4202),
    [anon_sym_LBRACK] = ACTIONS(4202),
    [sym__automatic_semicolon] = ACTIONS(4202),
    [anon_sym_SEMI] = ACTIONS(4202),
    [anon_sym_BQUOTE] = ACTIONS(4202),
    [anon_sym_PIPE] = ACTIONS(4210),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_LT_LT] = ACTIONS(4202),
    [anon_sym_STAR] = ACTIONS(4210),
    [anon_sym_GT_GT_GT] = ACTIONS(4202),
    [anon_sym_AMP_AMP] = ACTIONS(4202),
    [anon_sym_DASH] = ACTIONS(4210),
    [anon_sym_BANG_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ] = ACTIONS(4202),
    [anon_sym_LPAREN] = ACTIONS(4202),
    [anon_sym_GT_EQ] = ACTIONS(4202),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4202),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_as] = ACTIONS(4202),
    [anon_sym_PIPE_PIPE] = ACTIONS(4202),
    [anon_sym_DASH_DASH] = ACTIONS(4202),
    [anon_sym_EQ_EQ] = ACTIONS(4210),
    [anon_sym_instanceof] = ACTIONS(4202),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4202),
    [anon_sym_CARET] = ACTIONS(4202),
    [anon_sym_STAR_STAR] = ACTIONS(4202),
    [anon_sym_PLUS] = ACTIONS(4210),
    [anon_sym_GT_GT] = ACTIONS(4210),
    [anon_sym_PLUS_PLUS] = ACTIONS(4202),
    [anon_sym_in] = ACTIONS(4210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4202),
    [anon_sym_BANG] = ACTIONS(4210),
  },
  [1192] = {
    [anon_sym_BQUOTE] = ACTIONS(4212),
    [anon_sym_symbol] = ACTIONS(4214),
    [anon_sym_PIPE] = ACTIONS(4212),
    [anon_sym_break] = ACTIONS(4214),
    [anon_sym_return] = ACTIONS(4214),
    [anon_sym_static] = ACTIONS(4214),
    [anon_sym_RBRACE] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4214),
    [anon_sym_delete] = ACTIONS(4214),
    [anon_sym_if] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(4214),
    [sym_true] = ACTIONS(4214),
    [anon_sym_protected] = ACTIONS(4214),
    [anon_sym_set] = ACTIONS(4214),
    [anon_sym_import] = ACTIONS(4214),
    [anon_sym_DQUOTE] = ACTIONS(4212),
    [anon_sym_for] = ACTIONS(4214),
    [anon_sym_SEMI] = ACTIONS(4212),
    [anon_sym_number] = ACTIONS(4214),
    [anon_sym_typeof] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_switch] = ACTIONS(4214),
    [anon_sym_RBRACK] = ACTIONS(4212),
    [sym_null] = ACTIONS(4214),
    [anon_sym_any] = ACTIONS(4214),
    [anon_sym_async] = ACTIONS(4214),
    [anon_sym_public] = ACTIONS(4214),
    [anon_sym_var] = ACTIONS(4214),
    [anon_sym_while] = ACTIONS(4214),
    [anon_sym_SQUOTE] = ACTIONS(4212),
    [anon_sym_RPAREN] = ACTIONS(4212),
    [anon_sym_SLASH] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(4214),
    [anon_sym_export] = ACTIONS(4214),
    [anon_sym_with] = ACTIONS(4214),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_debugger] = ACTIONS(4214),
    [anon_sym_AT] = ACTIONS(4212),
    [anon_sym_COMMA] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4214),
    [anon_sym_EQ] = ACTIONS(4214),
    [anon_sym_void] = ACTIONS(4214),
    [anon_sym_const] = ACTIONS(4214),
    [sym_super] = ACTIONS(4214),
    [anon_sym_private] = ACTIONS(4214),
    [anon_sym_get] = ACTIONS(4214),
    [anon_sym_default] = ACTIONS(4214),
    [anon_sym_enum] = ACTIONS(4214),
    [anon_sym_continue] = ACTIONS(4214),
    [anon_sym_DASH_DASH] = ACTIONS(4212),
    [sym_this] = ACTIONS(4214),
    [anon_sym_throw] = ACTIONS(4214),
    [anon_sym_abstract] = ACTIONS(4214),
    [anon_sym_type] = ACTIONS(4214),
    [anon_sym_namespace] = ACTIONS(4214),
    [anon_sym_PLUS_PLUS] = ACTIONS(4212),
    [anon_sym_else] = ACTIONS(4214),
    [anon_sym_BANG] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [sym_false] = ACTIONS(4214),
    [anon_sym_case] = ACTIONS(4214),
    [anon_sym_module] = ACTIONS(4214),
    [anon_sym_class] = ACTIONS(4214),
    [anon_sym_declare] = ACTIONS(4214),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4212),
    [anon_sym_boolean] = ACTIONS(4214),
    [anon_sym_EQ_GT] = ACTIONS(4212),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_try] = ACTIONS(4214),
    [anon_sym_LT] = ACTIONS(4212),
    [sym_number] = ACTIONS(4212),
    [ts_builtin_sym_end] = ACTIONS(4212),
    [anon_sym_function] = ACTIONS(4214),
    [sym_undefined] = ACTIONS(4214),
    [anon_sym_let] = ACTIONS(4214),
    [anon_sym_PLUS] = ACTIONS(4214),
    [anon_sym_do] = ACTIONS(4214),
    [anon_sym_TILDE] = ACTIONS(4212),
    [anon_sym_await] = ACTIONS(4214),
  },
  [1193] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(4216),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4216),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1194] = {
    [sym__automatic_semicolon] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4085),
    [sym_comment] = ACTIONS(3),
  },
  [1195] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1252),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1196] = {
    [sym__automatic_semicolon] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
  },
  [1197] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1254),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1198] = {
    [sym_string] = STATE(1255),
    [sym__property_name] = STATE(1255),
    [sym_computed_property_name] = STATE(1255),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1199] = {
    [sym_string] = STATE(1255),
    [sym__property_name] = STATE(1255),
    [sym_computed_property_name] = STATE(1255),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1200] = {
    [sym__call_signature] = STATE(1252),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1256),
    [sym__automatic_semicolon] = ACTIONS(4222),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4222),
    [sym_comment] = ACTIONS(3),
  },
  [1201] = {
    [sym__automatic_semicolon] = ACTIONS(4224),
    [anon_sym_RBRACE] = ACTIONS(4224),
    [anon_sym_SEMI] = ACTIONS(4224),
    [anon_sym_COMMA] = ACTIONS(4224),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4224),
    [sym_comment] = ACTIONS(3),
  },
  [1202] = {
    [sym__automatic_semicolon] = ACTIONS(4226),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_SEMI] = ACTIONS(4226),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4226),
    [sym_comment] = ACTIONS(3),
  },
  [1203] = {
    [sym__automatic_semicolon] = ACTIONS(4228),
    [anon_sym_RBRACE] = ACTIONS(4228),
    [anon_sym_SEMI] = ACTIONS(4228),
    [anon_sym_COMMA] = ACTIONS(4228),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4228),
    [sym_comment] = ACTIONS(3),
  },
  [1204] = {
    [sym_index_signature] = STATE(1088),
    [sym_formal_parameters] = STATE(1306),
    [sym_method_signature] = STATE(1088),
    [sym_computed_property_name] = STATE(626),
    [sym__property_name] = STATE(626),
    [sym_type_parameters] = STATE(1868),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_string] = STATE(626),
    [sym_decorator] = STATE(63),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_namespace] = ACTIONS(968),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1205] = {
    [sym_string] = STATE(1255),
    [sym__property_name] = STATE(1255),
    [sym_computed_property_name] = STATE(1255),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(4230),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(4232),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(4232),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1206] = {
    [sym__call_signature] = STATE(1254),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1260),
    [sym__automatic_semicolon] = ACTIONS(4234),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4234),
    [anon_sym_QMARK] = ACTIONS(4236),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4234),
    [sym_comment] = ACTIONS(3),
  },
  [1207] = {
    [anon_sym_EQ_GT] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [anon_sym_while] = ACTIONS(4238),
    [anon_sym_RPAREN] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(4238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_RBRACK] = ACTIONS(4238),
    [anon_sym_GT] = ACTIONS(4238),
  },
  [1208] = {
    [sym_identifier] = ACTIONS(4242),
    [anon_sym_BQUOTE] = ACTIONS(4244),
    [anon_sym_debugger] = ACTIONS(4242),
    [anon_sym_symbol] = ACTIONS(4242),
    [anon_sym_AT] = ACTIONS(4244),
    [anon_sym_DASH] = ACTIONS(4242),
    [anon_sym_void] = ACTIONS(4242),
    [anon_sym_break] = ACTIONS(4242),
    [anon_sym_const] = ACTIONS(4242),
    [sym_super] = ACTIONS(4242),
    [anon_sym_return] = ACTIONS(4242),
    [anon_sym_private] = ACTIONS(4242),
    [anon_sym_static] = ACTIONS(4242),
    [anon_sym_get] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4242),
    [anon_sym_default] = ACTIONS(4242),
    [anon_sym_enum] = ACTIONS(4242),
    [anon_sym_delete] = ACTIONS(4242),
    [anon_sym_continue] = ACTIONS(4242),
    [anon_sym_DASH_DASH] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4242),
    [sym_this] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4242),
    [sym_true] = ACTIONS(4242),
    [anon_sym_throw] = ACTIONS(4242),
    [anon_sym_protected] = ACTIONS(4242),
    [anon_sym_abstract] = ACTIONS(4242),
    [anon_sym_set] = ACTIONS(4242),
    [anon_sym_type] = ACTIONS(4242),
    [anon_sym_import] = ACTIONS(4242),
    [anon_sym_namespace] = ACTIONS(4242),
    [anon_sym_PLUS_PLUS] = ACTIONS(4244),
    [anon_sym_DQUOTE] = ACTIONS(4244),
    [anon_sym_else] = ACTIONS(4242),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4244),
    [sym_false] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4242),
    [anon_sym_module] = ACTIONS(4242),
    [anon_sym_number] = ACTIONS(4242),
    [anon_sym_class] = ACTIONS(4242),
    [anon_sym_declare] = ACTIONS(4242),
    [anon_sym_typeof] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4244),
    [anon_sym_switch] = ACTIONS(4242),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [sym_null] = ACTIONS(4242),
    [anon_sym_any] = ACTIONS(4242),
    [anon_sym_boolean] = ACTIONS(4242),
    [anon_sym_async] = ACTIONS(4242),
    [anon_sym_public] = ACTIONS(4242),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_SQUOTE] = ACTIONS(4244),
    [anon_sym_try] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4244),
    [sym_number] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4242),
    [anon_sym_function] = ACTIONS(4242),
    [sym_undefined] = ACTIONS(4242),
    [anon_sym_new] = ACTIONS(4242),
    [ts_builtin_sym_end] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_export] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_TILDE] = ACTIONS(4244),
    [anon_sym_with] = ACTIONS(4242),
    [anon_sym_await] = ACTIONS(4242),
  },
  [1209] = {
    [sym_computed_property_name] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_enum_assignment] = STATE(1101),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1210] = {
    [sym__automatic_semicolon] = ACTIONS(4246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4246),
  },
  [1211] = {
    [sym_identifier] = ACTIONS(4248),
    [anon_sym_BQUOTE] = ACTIONS(4250),
    [anon_sym_debugger] = ACTIONS(4248),
    [anon_sym_symbol] = ACTIONS(4248),
    [anon_sym_AT] = ACTIONS(4250),
    [anon_sym_DASH] = ACTIONS(4248),
    [anon_sym_void] = ACTIONS(4248),
    [anon_sym_break] = ACTIONS(4248),
    [anon_sym_const] = ACTIONS(4248),
    [sym_super] = ACTIONS(4248),
    [anon_sym_return] = ACTIONS(4248),
    [anon_sym_private] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_get] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_enum] = ACTIONS(4248),
    [anon_sym_delete] = ACTIONS(4248),
    [anon_sym_continue] = ACTIONS(4248),
    [anon_sym_DASH_DASH] = ACTIONS(4250),
    [anon_sym_if] = ACTIONS(4248),
    [sym_this] = ACTIONS(4248),
    [anon_sym_yield] = ACTIONS(4248),
    [sym_true] = ACTIONS(4248),
    [anon_sym_throw] = ACTIONS(4248),
    [anon_sym_protected] = ACTIONS(4248),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_set] = ACTIONS(4248),
    [anon_sym_type] = ACTIONS(4248),
    [anon_sym_import] = ACTIONS(4248),
    [anon_sym_namespace] = ACTIONS(4248),
    [anon_sym_PLUS_PLUS] = ACTIONS(4250),
    [anon_sym_DQUOTE] = ACTIONS(4250),
    [anon_sym_BANG] = ACTIONS(4250),
    [anon_sym_for] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4250),
    [sym_false] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4250),
    [anon_sym_module] = ACTIONS(4248),
    [anon_sym_number] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(4248),
    [anon_sym_declare] = ACTIONS(4248),
    [anon_sym_typeof] = ACTIONS(4248),
    [anon_sym_LBRACE] = ACTIONS(4250),
    [anon_sym_switch] = ACTIONS(4248),
    [anon_sym_LPAREN] = ACTIONS(4250),
    [sym_null] = ACTIONS(4248),
    [anon_sym_any] = ACTIONS(4248),
    [anon_sym_boolean] = ACTIONS(4248),
    [anon_sym_async] = ACTIONS(4248),
    [anon_sym_public] = ACTIONS(4248),
    [anon_sym_var] = ACTIONS(4248),
    [anon_sym_while] = ACTIONS(4248),
    [anon_sym_SQUOTE] = ACTIONS(4250),
    [anon_sym_try] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4250),
    [sym_number] = ACTIONS(4250),
    [anon_sym_SLASH] = ACTIONS(4248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4248),
    [anon_sym_function] = ACTIONS(4248),
    [sym_undefined] = ACTIONS(4248),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_export] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4250),
    [anon_sym_with] = ACTIONS(4248),
    [anon_sym_await] = ACTIONS(4248),
  },
  [1212] = {
    [sym_identifier] = ACTIONS(4252),
    [anon_sym_BQUOTE] = ACTIONS(4254),
    [anon_sym_debugger] = ACTIONS(4252),
    [anon_sym_symbol] = ACTIONS(4252),
    [anon_sym_AT] = ACTIONS(4254),
    [anon_sym_DASH] = ACTIONS(4252),
    [anon_sym_void] = ACTIONS(4252),
    [anon_sym_break] = ACTIONS(4252),
    [anon_sym_const] = ACTIONS(4252),
    [sym_super] = ACTIONS(4252),
    [anon_sym_return] = ACTIONS(4252),
    [anon_sym_private] = ACTIONS(4252),
    [anon_sym_static] = ACTIONS(4252),
    [anon_sym_get] = ACTIONS(4252),
    [anon_sym_interface] = ACTIONS(4252),
    [anon_sym_enum] = ACTIONS(4252),
    [anon_sym_delete] = ACTIONS(4252),
    [anon_sym_continue] = ACTIONS(4252),
    [anon_sym_DASH_DASH] = ACTIONS(4254),
    [anon_sym_if] = ACTIONS(4252),
    [sym_this] = ACTIONS(4252),
    [anon_sym_yield] = ACTIONS(4252),
    [sym_true] = ACTIONS(4252),
    [anon_sym_throw] = ACTIONS(4252),
    [anon_sym_protected] = ACTIONS(4252),
    [anon_sym_abstract] = ACTIONS(4252),
    [anon_sym_set] = ACTIONS(4252),
    [anon_sym_type] = ACTIONS(4252),
    [anon_sym_import] = ACTIONS(4252),
    [anon_sym_namespace] = ACTIONS(4252),
    [anon_sym_PLUS_PLUS] = ACTIONS(4254),
    [anon_sym_DQUOTE] = ACTIONS(4254),
    [anon_sym_BANG] = ACTIONS(4254),
    [anon_sym_for] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4254),
    [sym_false] = ACTIONS(4252),
    [anon_sym_SEMI] = ACTIONS(4254),
    [anon_sym_module] = ACTIONS(4252),
    [anon_sym_number] = ACTIONS(4252),
    [anon_sym_class] = ACTIONS(4252),
    [anon_sym_declare] = ACTIONS(4252),
    [anon_sym_typeof] = ACTIONS(4252),
    [anon_sym_LBRACE] = ACTIONS(4254),
    [anon_sym_switch] = ACTIONS(4252),
    [anon_sym_LPAREN] = ACTIONS(4254),
    [sym_null] = ACTIONS(4252),
    [anon_sym_any] = ACTIONS(4252),
    [anon_sym_boolean] = ACTIONS(4252),
    [anon_sym_async] = ACTIONS(4252),
    [anon_sym_public] = ACTIONS(4252),
    [anon_sym_var] = ACTIONS(4252),
    [anon_sym_while] = ACTIONS(4252),
    [anon_sym_SQUOTE] = ACTIONS(4254),
    [anon_sym_try] = ACTIONS(4252),
    [anon_sym_LT] = ACTIONS(4254),
    [sym_number] = ACTIONS(4254),
    [anon_sym_SLASH] = ACTIONS(4252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4252),
    [anon_sym_function] = ACTIONS(4252),
    [sym_undefined] = ACTIONS(4252),
    [anon_sym_new] = ACTIONS(4252),
    [anon_sym_let] = ACTIONS(4252),
    [anon_sym_PLUS] = ACTIONS(4252),
    [anon_sym_export] = ACTIONS(4252),
    [anon_sym_do] = ACTIONS(4252),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_with] = ACTIONS(4252),
    [anon_sym_await] = ACTIONS(4252),
  },
  [1213] = {
    [sym_identifier] = ACTIONS(4256),
    [anon_sym_BQUOTE] = ACTIONS(4258),
    [anon_sym_debugger] = ACTIONS(4256),
    [anon_sym_symbol] = ACTIONS(4256),
    [anon_sym_AT] = ACTIONS(4258),
    [anon_sym_DASH] = ACTIONS(4256),
    [anon_sym_void] = ACTIONS(4256),
    [anon_sym_break] = ACTIONS(4256),
    [anon_sym_const] = ACTIONS(4256),
    [sym_super] = ACTIONS(4256),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_private] = ACTIONS(4256),
    [anon_sym_static] = ACTIONS(4256),
    [anon_sym_get] = ACTIONS(4256),
    [anon_sym_interface] = ACTIONS(4256),
    [anon_sym_enum] = ACTIONS(4256),
    [anon_sym_delete] = ACTIONS(4256),
    [anon_sym_continue] = ACTIONS(4256),
    [anon_sym_DASH_DASH] = ACTIONS(4258),
    [anon_sym_if] = ACTIONS(4256),
    [sym_this] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4256),
    [sym_true] = ACTIONS(4256),
    [anon_sym_throw] = ACTIONS(4256),
    [anon_sym_protected] = ACTIONS(4256),
    [anon_sym_abstract] = ACTIONS(4256),
    [anon_sym_set] = ACTIONS(4256),
    [anon_sym_type] = ACTIONS(4256),
    [anon_sym_import] = ACTIONS(4256),
    [anon_sym_namespace] = ACTIONS(4256),
    [anon_sym_PLUS_PLUS] = ACTIONS(4258),
    [anon_sym_DQUOTE] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4258),
    [anon_sym_for] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [sym_false] = ACTIONS(4256),
    [anon_sym_SEMI] = ACTIONS(4258),
    [anon_sym_module] = ACTIONS(4256),
    [anon_sym_number] = ACTIONS(4256),
    [anon_sym_class] = ACTIONS(4256),
    [anon_sym_declare] = ACTIONS(4256),
    [anon_sym_typeof] = ACTIONS(4256),
    [anon_sym_LBRACE] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4256),
    [anon_sym_LPAREN] = ACTIONS(4258),
    [sym_null] = ACTIONS(4256),
    [anon_sym_any] = ACTIONS(4256),
    [anon_sym_boolean] = ACTIONS(4256),
    [anon_sym_async] = ACTIONS(4256),
    [anon_sym_public] = ACTIONS(4256),
    [anon_sym_var] = ACTIONS(4256),
    [anon_sym_while] = ACTIONS(4256),
    [anon_sym_SQUOTE] = ACTIONS(4258),
    [anon_sym_try] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4258),
    [sym_number] = ACTIONS(4258),
    [anon_sym_SLASH] = ACTIONS(4256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4256),
    [anon_sym_function] = ACTIONS(4256),
    [sym_undefined] = ACTIONS(4256),
    [anon_sym_new] = ACTIONS(4256),
    [anon_sym_let] = ACTIONS(4256),
    [anon_sym_PLUS] = ACTIONS(4256),
    [anon_sym_export] = ACTIONS(4256),
    [anon_sym_do] = ACTIONS(4256),
    [anon_sym_TILDE] = ACTIONS(4258),
    [anon_sym_with] = ACTIONS(4256),
    [anon_sym_await] = ACTIONS(4256),
  },
  [1214] = {
    [sym_identifier] = ACTIONS(4260),
    [anon_sym_BQUOTE] = ACTIONS(4262),
    [anon_sym_debugger] = ACTIONS(4260),
    [anon_sym_symbol] = ACTIONS(4260),
    [anon_sym_AT] = ACTIONS(4262),
    [anon_sym_DASH] = ACTIONS(4260),
    [anon_sym_void] = ACTIONS(4260),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_const] = ACTIONS(4260),
    [sym_super] = ACTIONS(4260),
    [anon_sym_return] = ACTIONS(4260),
    [anon_sym_private] = ACTIONS(4260),
    [anon_sym_static] = ACTIONS(4260),
    [anon_sym_get] = ACTIONS(4260),
    [anon_sym_interface] = ACTIONS(4260),
    [anon_sym_enum] = ACTIONS(4260),
    [anon_sym_delete] = ACTIONS(4260),
    [anon_sym_continue] = ACTIONS(4260),
    [anon_sym_DASH_DASH] = ACTIONS(4262),
    [anon_sym_if] = ACTIONS(4260),
    [sym_this] = ACTIONS(4260),
    [anon_sym_yield] = ACTIONS(4260),
    [sym_true] = ACTIONS(4260),
    [anon_sym_throw] = ACTIONS(4260),
    [anon_sym_protected] = ACTIONS(4260),
    [anon_sym_abstract] = ACTIONS(4260),
    [anon_sym_set] = ACTIONS(4260),
    [anon_sym_type] = ACTIONS(4260),
    [anon_sym_import] = ACTIONS(4260),
    [anon_sym_namespace] = ACTIONS(4260),
    [anon_sym_PLUS_PLUS] = ACTIONS(4262),
    [anon_sym_DQUOTE] = ACTIONS(4262),
    [anon_sym_BANG] = ACTIONS(4262),
    [anon_sym_for] = ACTIONS(4260),
    [anon_sym_LBRACK] = ACTIONS(4262),
    [sym_false] = ACTIONS(4260),
    [anon_sym_SEMI] = ACTIONS(4262),
    [anon_sym_module] = ACTIONS(4260),
    [anon_sym_number] = ACTIONS(4260),
    [anon_sym_class] = ACTIONS(4260),
    [anon_sym_declare] = ACTIONS(4260),
    [anon_sym_typeof] = ACTIONS(4260),
    [anon_sym_LBRACE] = ACTIONS(4262),
    [anon_sym_switch] = ACTIONS(4260),
    [anon_sym_LPAREN] = ACTIONS(4262),
    [sym_null] = ACTIONS(4260),
    [anon_sym_any] = ACTIONS(4260),
    [anon_sym_boolean] = ACTIONS(4260),
    [anon_sym_async] = ACTIONS(4260),
    [anon_sym_public] = ACTIONS(4260),
    [anon_sym_var] = ACTIONS(4260),
    [anon_sym_while] = ACTIONS(4260),
    [anon_sym_SQUOTE] = ACTIONS(4262),
    [anon_sym_try] = ACTIONS(4260),
    [anon_sym_LT] = ACTIONS(4262),
    [sym_number] = ACTIONS(4262),
    [anon_sym_SLASH] = ACTIONS(4260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4260),
    [anon_sym_function] = ACTIONS(4260),
    [sym_undefined] = ACTIONS(4260),
    [anon_sym_new] = ACTIONS(4260),
    [anon_sym_let] = ACTIONS(4260),
    [anon_sym_PLUS] = ACTIONS(4260),
    [anon_sym_export] = ACTIONS(4260),
    [anon_sym_do] = ACTIONS(4260),
    [anon_sym_TILDE] = ACTIONS(4262),
    [anon_sym_with] = ACTIONS(4260),
    [anon_sym_await] = ACTIONS(4260),
  },
  [1215] = {
    [sym_identifier] = ACTIONS(4264),
    [anon_sym_BQUOTE] = ACTIONS(4266),
    [anon_sym_debugger] = ACTIONS(4264),
    [anon_sym_symbol] = ACTIONS(4264),
    [anon_sym_AT] = ACTIONS(4266),
    [anon_sym_DASH] = ACTIONS(4264),
    [anon_sym_void] = ACTIONS(4264),
    [anon_sym_break] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [sym_super] = ACTIONS(4264),
    [anon_sym_return] = ACTIONS(4264),
    [anon_sym_private] = ACTIONS(4264),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_get] = ACTIONS(4264),
    [anon_sym_RBRACE] = ACTIONS(4266),
    [anon_sym_interface] = ACTIONS(4264),
    [anon_sym_default] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_delete] = ACTIONS(4264),
    [anon_sym_continue] = ACTIONS(4264),
    [anon_sym_DASH_DASH] = ACTIONS(4266),
    [anon_sym_if] = ACTIONS(4264),
    [sym_this] = ACTIONS(4264),
    [anon_sym_yield] = ACTIONS(4264),
    [sym_true] = ACTIONS(4264),
    [anon_sym_throw] = ACTIONS(4264),
    [anon_sym_protected] = ACTIONS(4264),
    [anon_sym_abstract] = ACTIONS(4264),
    [anon_sym_set] = ACTIONS(4264),
    [anon_sym_type] = ACTIONS(4264),
    [anon_sym_import] = ACTIONS(4264),
    [anon_sym_namespace] = ACTIONS(4264),
    [anon_sym_PLUS_PLUS] = ACTIONS(4266),
    [anon_sym_DQUOTE] = ACTIONS(4266),
    [anon_sym_else] = ACTIONS(4264),
    [anon_sym_BANG] = ACTIONS(4266),
    [anon_sym_for] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [sym_false] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_case] = ACTIONS(4264),
    [anon_sym_module] = ACTIONS(4264),
    [anon_sym_number] = ACTIONS(4264),
    [anon_sym_class] = ACTIONS(4264),
    [anon_sym_declare] = ACTIONS(4264),
    [anon_sym_typeof] = ACTIONS(4264),
    [anon_sym_LBRACE] = ACTIONS(4266),
    [anon_sym_switch] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [sym_null] = ACTIONS(4264),
    [anon_sym_any] = ACTIONS(4264),
    [anon_sym_boolean] = ACTIONS(4264),
    [anon_sym_async] = ACTIONS(4264),
    [anon_sym_public] = ACTIONS(4264),
    [anon_sym_var] = ACTIONS(4264),
    [anon_sym_while] = ACTIONS(4264),
    [anon_sym_SQUOTE] = ACTIONS(4266),
    [anon_sym_try] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [sym_number] = ACTIONS(4266),
    [anon_sym_SLASH] = ACTIONS(4264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4264),
    [anon_sym_function] = ACTIONS(4264),
    [sym_undefined] = ACTIONS(4264),
    [anon_sym_new] = ACTIONS(4264),
    [ts_builtin_sym_end] = ACTIONS(4266),
    [anon_sym_let] = ACTIONS(4264),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_export] = ACTIONS(4264),
    [anon_sym_do] = ACTIONS(4264),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_with] = ACTIONS(4264),
    [anon_sym_await] = ACTIONS(4264),
  },
  [1216] = {
    [sym_type_annotation] = STATE(1261),
    [anon_sym_COLON] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
  },
  [1217] = {
    [sym_type_annotation] = STATE(1262),
    [anon_sym_COLON] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
  },
  [1218] = {
    [sym__automatic_semicolon] = ACTIONS(4268),
    [anon_sym_SEMI] = ACTIONS(4268),
    [anon_sym_COMMA] = ACTIONS(4268),
    [sym_comment] = ACTIONS(3),
  },
  [1219] = {
    [sym__automatic_semicolon] = ACTIONS(4270),
    [anon_sym_SEMI] = ACTIONS(4270),
    [anon_sym_COMMA] = ACTIONS(4270),
    [sym_comment] = ACTIONS(3),
  },
  [1220] = {
    [sym__initializer] = STATE(1263),
    [sym__automatic_semicolon] = ACTIONS(4272),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(4272),
    [anon_sym_COMMA] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
  },
  [1221] = {
    [sym__automatic_semicolon] = ACTIONS(4274),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_COMMA] = ACTIONS(4274),
    [sym_comment] = ACTIONS(3),
  },
  [1222] = {
    [sym__automatic_semicolon] = ACTIONS(4276),
    [anon_sym_SEMI] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(4276),
    [sym_comment] = ACTIONS(3),
  },
  [1223] = {
    [sym_statement_block] = STATE(1629),
    [sym__automatic_semicolon] = ACTIONS(4278),
    [anon_sym_SEMI] = ACTIONS(4278),
    [anon_sym_COMMA] = ACTIONS(4278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1224] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1264),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1225] = {
    [sym_statement_block] = STATE(1630),
    [sym__automatic_semicolon] = ACTIONS(4280),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1226] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1266),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4282),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1227] = {
    [sym_string] = STATE(1267),
    [sym__property_name] = STATE(1267),
    [sym_computed_property_name] = STATE(1267),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1228] = {
    [sym_string] = STATE(1267),
    [sym__property_name] = STATE(1267),
    [sym_computed_property_name] = STATE(1267),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(4284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1229] = {
    [sym_type_annotation] = STATE(1269),
    [sym_formal_parameters] = STATE(1306),
    [sym__initializer] = STATE(1268),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1264),
    [sym__automatic_semicolon] = ACTIONS(4286),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
  },
  [1230] = {
    [sym__initializer] = STATE(1268),
    [sym_type_annotation] = STATE(1269),
    [sym__automatic_semicolon] = ACTIONS(4286),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4286),
    [anon_sym_COMMA] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
  },
  [1231] = {
    [sym__automatic_semicolon] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(4288),
    [anon_sym_COMMA] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
  },
  [1232] = {
    [sym__initializer] = STATE(1270),
    [sym__automatic_semicolon] = ACTIONS(4290),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(4290),
    [anon_sym_COMMA] = ACTIONS(4290),
    [sym_comment] = ACTIONS(3),
  },
  [1233] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1271),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1234] = {
    [sym__automatic_semicolon] = ACTIONS(4292),
    [anon_sym_SEMI] = ACTIONS(4292),
    [anon_sym_COMMA] = ACTIONS(4292),
    [sym_comment] = ACTIONS(3),
  },
  [1235] = {
    [sym__automatic_semicolon] = ACTIONS(4163),
    [sym_identifier] = ACTIONS(4167),
    [anon_sym_BQUOTE] = ACTIONS(4165),
    [anon_sym_debugger] = ACTIONS(4167),
    [anon_sym_symbol] = ACTIONS(4167),
    [anon_sym_AT] = ACTIONS(4165),
    [anon_sym_DASH] = ACTIONS(4167),
    [anon_sym_void] = ACTIONS(4167),
    [anon_sym_break] = ACTIONS(4167),
    [anon_sym_const] = ACTIONS(4167),
    [sym_super] = ACTIONS(4167),
    [anon_sym_return] = ACTIONS(4167),
    [anon_sym_private] = ACTIONS(4167),
    [anon_sym_static] = ACTIONS(4167),
    [anon_sym_get] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4165),
    [anon_sym_interface] = ACTIONS(4167),
    [anon_sym_default] = ACTIONS(4167),
    [anon_sym_enum] = ACTIONS(4167),
    [anon_sym_delete] = ACTIONS(4167),
    [anon_sym_continue] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4165),
    [anon_sym_if] = ACTIONS(4167),
    [sym_this] = ACTIONS(4167),
    [anon_sym_yield] = ACTIONS(4167),
    [sym_true] = ACTIONS(4167),
    [anon_sym_throw] = ACTIONS(4167),
    [anon_sym_protected] = ACTIONS(4167),
    [anon_sym_abstract] = ACTIONS(4167),
    [anon_sym_set] = ACTIONS(4167),
    [anon_sym_type] = ACTIONS(4167),
    [anon_sym_import] = ACTIONS(4167),
    [anon_sym_namespace] = ACTIONS(4167),
    [anon_sym_PLUS_PLUS] = ACTIONS(4165),
    [anon_sym_DQUOTE] = ACTIONS(4165),
    [anon_sym_else] = ACTIONS(4167),
    [anon_sym_BANG] = ACTIONS(4165),
    [anon_sym_for] = ACTIONS(4167),
    [anon_sym_LBRACK] = ACTIONS(4165),
    [sym_false] = ACTIONS(4167),
    [anon_sym_SEMI] = ACTIONS(4165),
    [anon_sym_case] = ACTIONS(4167),
    [anon_sym_module] = ACTIONS(4167),
    [anon_sym_number] = ACTIONS(4167),
    [anon_sym_class] = ACTIONS(4167),
    [anon_sym_declare] = ACTIONS(4167),
    [anon_sym_typeof] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4165),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4165),
    [sym_null] = ACTIONS(4167),
    [anon_sym_any] = ACTIONS(4167),
    [anon_sym_boolean] = ACTIONS(4167),
    [anon_sym_async] = ACTIONS(4167),
    [anon_sym_public] = ACTIONS(4167),
    [anon_sym_var] = ACTIONS(4167),
    [anon_sym_while] = ACTIONS(4167),
    [anon_sym_SQUOTE] = ACTIONS(4165),
    [anon_sym_try] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4165),
    [sym_number] = ACTIONS(4165),
    [anon_sym_SLASH] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4167),
    [anon_sym_function] = ACTIONS(4167),
    [sym_undefined] = ACTIONS(4167),
    [anon_sym_new] = ACTIONS(4167),
    [ts_builtin_sym_end] = ACTIONS(4165),
    [anon_sym_let] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4167),
    [anon_sym_export] = ACTIONS(4167),
    [anon_sym_do] = ACTIONS(4167),
    [anon_sym_TILDE] = ACTIONS(4165),
    [anon_sym_with] = ACTIONS(4167),
    [anon_sym_await] = ACTIONS(4167),
  },
  [1236] = {
    [sym__automatic_semicolon] = ACTIONS(4204),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_BQUOTE] = ACTIONS(4206),
    [anon_sym_debugger] = ACTIONS(4208),
    [anon_sym_symbol] = ACTIONS(4208),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_DASH] = ACTIONS(4208),
    [anon_sym_void] = ACTIONS(4208),
    [anon_sym_break] = ACTIONS(4208),
    [anon_sym_const] = ACTIONS(4208),
    [sym_super] = ACTIONS(4208),
    [anon_sym_return] = ACTIONS(4208),
    [anon_sym_private] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_get] = ACTIONS(4208),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_default] = ACTIONS(4208),
    [anon_sym_enum] = ACTIONS(4208),
    [anon_sym_delete] = ACTIONS(4208),
    [anon_sym_continue] = ACTIONS(4208),
    [anon_sym_DASH_DASH] = ACTIONS(4206),
    [anon_sym_if] = ACTIONS(4208),
    [sym_this] = ACTIONS(4208),
    [anon_sym_yield] = ACTIONS(4208),
    [sym_true] = ACTIONS(4208),
    [anon_sym_throw] = ACTIONS(4208),
    [anon_sym_protected] = ACTIONS(4208),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_set] = ACTIONS(4208),
    [anon_sym_type] = ACTIONS(4208),
    [anon_sym_import] = ACTIONS(4208),
    [anon_sym_namespace] = ACTIONS(4208),
    [anon_sym_PLUS_PLUS] = ACTIONS(4206),
    [anon_sym_DQUOTE] = ACTIONS(4206),
    [anon_sym_else] = ACTIONS(4208),
    [anon_sym_BANG] = ACTIONS(4206),
    [anon_sym_for] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4206),
    [sym_false] = ACTIONS(4208),
    [anon_sym_SEMI] = ACTIONS(4206),
    [anon_sym_case] = ACTIONS(4208),
    [anon_sym_module] = ACTIONS(4208),
    [anon_sym_number] = ACTIONS(4208),
    [anon_sym_class] = ACTIONS(4208),
    [anon_sym_declare] = ACTIONS(4208),
    [anon_sym_typeof] = ACTIONS(4208),
    [anon_sym_LBRACE] = ACTIONS(4206),
    [anon_sym_switch] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(4206),
    [sym_null] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4208),
    [anon_sym_boolean] = ACTIONS(4208),
    [anon_sym_async] = ACTIONS(4208),
    [anon_sym_public] = ACTIONS(4208),
    [anon_sym_var] = ACTIONS(4208),
    [anon_sym_while] = ACTIONS(4208),
    [anon_sym_SQUOTE] = ACTIONS(4206),
    [anon_sym_try] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(4206),
    [sym_number] = ACTIONS(4206),
    [anon_sym_SLASH] = ACTIONS(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4208),
    [anon_sym_function] = ACTIONS(4208),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_new] = ACTIONS(4208),
    [ts_builtin_sym_end] = ACTIONS(4206),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_PLUS] = ACTIONS(4208),
    [anon_sym_export] = ACTIONS(4208),
    [anon_sym_do] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4206),
    [anon_sym_with] = ACTIONS(4208),
    [anon_sym_await] = ACTIONS(4208),
  },
  [1237] = {
    [anon_sym_COMMA] = ACTIONS(4294),
    [anon_sym_RBRACE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
  },
  [1238] = {
    [sym_statement_block] = STATE(1272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1239] = {
    [anon_sym_COMMA] = ACTIONS(4296),
    [anon_sym_RBRACE] = ACTIONS(4296),
    [sym_comment] = ACTIONS(3),
  },
  [1240] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1273),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1241] = {
    [sym_statement_block] = STATE(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1242] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1276),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [1243] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4300),
    [anon_sym_default] = ACTIONS(4302),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(4302),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1244] = {
    [sym_identifier] = ACTIONS(4304),
    [anon_sym_BQUOTE] = ACTIONS(4306),
    [anon_sym_debugger] = ACTIONS(4304),
    [anon_sym_symbol] = ACTIONS(4304),
    [anon_sym_AT] = ACTIONS(4306),
    [anon_sym_DASH] = ACTIONS(4304),
    [anon_sym_void] = ACTIONS(4304),
    [anon_sym_break] = ACTIONS(4304),
    [anon_sym_const] = ACTIONS(4304),
    [sym_super] = ACTIONS(4304),
    [anon_sym_return] = ACTIONS(4304),
    [anon_sym_private] = ACTIONS(4304),
    [anon_sym_static] = ACTIONS(4304),
    [anon_sym_get] = ACTIONS(4304),
    [anon_sym_RBRACE] = ACTIONS(4306),
    [anon_sym_interface] = ACTIONS(4304),
    [anon_sym_default] = ACTIONS(4304),
    [anon_sym_enum] = ACTIONS(4304),
    [anon_sym_delete] = ACTIONS(4304),
    [anon_sym_continue] = ACTIONS(4304),
    [anon_sym_DASH_DASH] = ACTIONS(4306),
    [anon_sym_if] = ACTIONS(4304),
    [sym_this] = ACTIONS(4304),
    [anon_sym_yield] = ACTIONS(4304),
    [sym_true] = ACTIONS(4304),
    [anon_sym_throw] = ACTIONS(4304),
    [anon_sym_protected] = ACTIONS(4304),
    [anon_sym_abstract] = ACTIONS(4304),
    [anon_sym_set] = ACTIONS(4304),
    [anon_sym_type] = ACTIONS(4304),
    [anon_sym_import] = ACTIONS(4304),
    [anon_sym_namespace] = ACTIONS(4304),
    [anon_sym_PLUS_PLUS] = ACTIONS(4306),
    [anon_sym_DQUOTE] = ACTIONS(4306),
    [anon_sym_else] = ACTIONS(4304),
    [anon_sym_BANG] = ACTIONS(4306),
    [anon_sym_for] = ACTIONS(4304),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [sym_false] = ACTIONS(4304),
    [anon_sym_SEMI] = ACTIONS(4306),
    [anon_sym_case] = ACTIONS(4304),
    [anon_sym_module] = ACTIONS(4304),
    [anon_sym_number] = ACTIONS(4304),
    [anon_sym_class] = ACTIONS(4304),
    [anon_sym_declare] = ACTIONS(4304),
    [anon_sym_typeof] = ACTIONS(4304),
    [anon_sym_LBRACE] = ACTIONS(4306),
    [anon_sym_switch] = ACTIONS(4304),
    [anon_sym_LPAREN] = ACTIONS(4306),
    [sym_null] = ACTIONS(4304),
    [anon_sym_any] = ACTIONS(4304),
    [anon_sym_boolean] = ACTIONS(4304),
    [anon_sym_async] = ACTIONS(4304),
    [anon_sym_public] = ACTIONS(4304),
    [anon_sym_var] = ACTIONS(4304),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_SQUOTE] = ACTIONS(4306),
    [anon_sym_try] = ACTIONS(4304),
    [anon_sym_LT] = ACTIONS(4306),
    [sym_number] = ACTIONS(4306),
    [anon_sym_SLASH] = ACTIONS(4304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4304),
    [anon_sym_function] = ACTIONS(4304),
    [sym_undefined] = ACTIONS(4304),
    [anon_sym_new] = ACTIONS(4304),
    [ts_builtin_sym_end] = ACTIONS(4306),
    [anon_sym_let] = ACTIONS(4304),
    [anon_sym_PLUS] = ACTIONS(4304),
    [anon_sym_export] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(4304),
    [anon_sym_TILDE] = ACTIONS(4306),
    [anon_sym_with] = ACTIONS(4304),
    [anon_sym_await] = ACTIONS(4304),
  },
  [1245] = {
    [sym_identifier] = ACTIONS(4308),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [anon_sym_debugger] = ACTIONS(4308),
    [anon_sym_symbol] = ACTIONS(4308),
    [anon_sym_AT] = ACTIONS(4310),
    [anon_sym_DASH] = ACTIONS(4308),
    [anon_sym_void] = ACTIONS(4308),
    [anon_sym_break] = ACTIONS(4308),
    [anon_sym_const] = ACTIONS(4308),
    [sym_super] = ACTIONS(4308),
    [anon_sym_return] = ACTIONS(4308),
    [anon_sym_private] = ACTIONS(4308),
    [anon_sym_static] = ACTIONS(4308),
    [anon_sym_get] = ACTIONS(4308),
    [anon_sym_RBRACE] = ACTIONS(4310),
    [anon_sym_interface] = ACTIONS(4308),
    [anon_sym_default] = ACTIONS(4308),
    [anon_sym_enum] = ACTIONS(4308),
    [anon_sym_delete] = ACTIONS(4308),
    [anon_sym_continue] = ACTIONS(4308),
    [anon_sym_DASH_DASH] = ACTIONS(4310),
    [anon_sym_if] = ACTIONS(4308),
    [sym_this] = ACTIONS(4308),
    [anon_sym_yield] = ACTIONS(4308),
    [sym_true] = ACTIONS(4308),
    [anon_sym_throw] = ACTIONS(4308),
    [anon_sym_protected] = ACTIONS(4308),
    [anon_sym_abstract] = ACTIONS(4308),
    [anon_sym_set] = ACTIONS(4308),
    [anon_sym_type] = ACTIONS(4308),
    [anon_sym_import] = ACTIONS(4308),
    [anon_sym_namespace] = ACTIONS(4308),
    [anon_sym_PLUS_PLUS] = ACTIONS(4310),
    [anon_sym_DQUOTE] = ACTIONS(4310),
    [anon_sym_else] = ACTIONS(4308),
    [anon_sym_BANG] = ACTIONS(4310),
    [anon_sym_for] = ACTIONS(4308),
    [anon_sym_LBRACK] = ACTIONS(4310),
    [sym_false] = ACTIONS(4308),
    [anon_sym_SEMI] = ACTIONS(4310),
    [anon_sym_case] = ACTIONS(4308),
    [anon_sym_module] = ACTIONS(4308),
    [anon_sym_number] = ACTIONS(4308),
    [anon_sym_class] = ACTIONS(4308),
    [anon_sym_declare] = ACTIONS(4308),
    [anon_sym_typeof] = ACTIONS(4308),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_switch] = ACTIONS(4308),
    [anon_sym_LPAREN] = ACTIONS(4310),
    [sym_null] = ACTIONS(4308),
    [anon_sym_any] = ACTIONS(4308),
    [anon_sym_boolean] = ACTIONS(4308),
    [anon_sym_async] = ACTIONS(4308),
    [anon_sym_public] = ACTIONS(4308),
    [anon_sym_var] = ACTIONS(4308),
    [anon_sym_while] = ACTIONS(4308),
    [anon_sym_SQUOTE] = ACTIONS(4310),
    [anon_sym_try] = ACTIONS(4308),
    [anon_sym_LT] = ACTIONS(4310),
    [sym_number] = ACTIONS(4310),
    [anon_sym_SLASH] = ACTIONS(4308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(4308),
    [anon_sym_string] = ACTIONS(4308),
    [anon_sym_function] = ACTIONS(4308),
    [sym_undefined] = ACTIONS(4308),
    [anon_sym_new] = ACTIONS(4308),
    [ts_builtin_sym_end] = ACTIONS(4310),
    [anon_sym_let] = ACTIONS(4308),
    [anon_sym_PLUS] = ACTIONS(4308),
    [anon_sym_export] = ACTIONS(4308),
    [anon_sym_do] = ACTIONS(4308),
    [anon_sym_TILDE] = ACTIONS(4310),
    [anon_sym_with] = ACTIONS(4308),
    [anon_sym_await] = ACTIONS(4308),
  },
  [1246] = {
    [sym_identifier] = ACTIONS(4312),
    [anon_sym_BQUOTE] = ACTIONS(4314),
    [anon_sym_debugger] = ACTIONS(4312),
    [anon_sym_symbol] = ACTIONS(4312),
    [anon_sym_AT] = ACTIONS(4314),
    [anon_sym_DASH] = ACTIONS(4312),
    [anon_sym_void] = ACTIONS(4312),
    [anon_sym_break] = ACTIONS(4312),
    [anon_sym_const] = ACTIONS(4312),
    [sym_super] = ACTIONS(4312),
    [anon_sym_return] = ACTIONS(4312),
    [anon_sym_private] = ACTIONS(4312),
    [anon_sym_static] = ACTIONS(4312),
    [anon_sym_get] = ACTIONS(4312),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_interface] = ACTIONS(4312),
    [anon_sym_default] = ACTIONS(4312),
    [anon_sym_enum] = ACTIONS(4312),
    [anon_sym_delete] = ACTIONS(4312),
    [anon_sym_continue] = ACTIONS(4312),
    [anon_sym_DASH_DASH] = ACTIONS(4314),
    [anon_sym_if] = ACTIONS(4312),
    [sym_this] = ACTIONS(4312),
    [anon_sym_yield] = ACTIONS(4312),
    [sym_true] = ACTIONS(4312),
    [anon_sym_throw] = ACTIONS(4312),
    [anon_sym_protected] = ACTIONS(4312),
    [anon_sym_abstract] = ACTIONS(4312),
    [anon_sym_set] = ACTIONS(4312),
    [anon_sym_type] = ACTIONS(4312),
    [anon_sym_import] = ACTIONS(4312),
    [anon_sym_namespace] = ACTIONS(4312),
    [anon_sym_PLUS_PLUS] = ACTIONS(4314),
    [anon_sym_DQUOTE] = ACTIONS(4314),
    [anon_sym_else] = ACTIONS(4312),
    [anon_sym_BANG] = ACTIONS(4314),
    [anon_sym_for] = ACTIONS(4312),
    [anon_sym_LBRACK] = ACTIONS(4314),
    [sym_false] = ACTIONS(4312),
    [anon_sym_SEMI] = ACTIONS(4314),
    [anon_sym_case] = ACTIONS(4312),
    [anon_sym_module] = ACTIONS(4312),
    [anon_sym_number] = ACTIONS(4312),
    [anon_sym_class] = ACTIONS(4312),
    [anon_sym_declare] = ACTIONS(4312),
    [anon_sym_typeof] = ACTIONS(4312),
    [anon_sym_LBRACE] = ACTIONS(4314),
    [anon_sym_switch] = ACTIONS(4312),
    [anon_sym_LPAREN] = ACTIONS(4314),
    [sym_null] = ACTIONS(4312),
    [anon_sym_any] = ACTIONS(4312),
    [anon_sym_boolean] = ACTIONS(4312),
    [anon_sym_async] = ACTIONS(4312),
    [anon_sym_public] = ACTIONS(4312),
    [anon_sym_var] = ACTIONS(4312),
    [anon_sym_while] = ACTIONS(4312),
    [anon_sym_SQUOTE] = ACTIONS(4314),
    [anon_sym_try] = ACTIONS(4312),
    [anon_sym_LT] = ACTIONS(4314),
    [sym_number] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_string] = ACTIONS(4312),
    [anon_sym_function] = ACTIONS(4312),
    [sym_undefined] = ACTIONS(4312),
    [anon_sym_new] = ACTIONS(4312),
    [ts_builtin_sym_end] = ACTIONS(4314),
    [anon_sym_let] = ACTIONS(4312),
    [anon_sym_PLUS] = ACTIONS(4312),
    [anon_sym_export] = ACTIONS(4312),
    [anon_sym_do] = ACTIONS(4312),
    [anon_sym_TILDE] = ACTIONS(4314),
    [anon_sym_with] = ACTIONS(4312),
    [anon_sym_await] = ACTIONS(4312),
  },
  [1247] = {
    [sym_identifier] = ACTIONS(4316),
    [anon_sym_BQUOTE] = ACTIONS(4318),
    [anon_sym_debugger] = ACTIONS(4316),
    [anon_sym_symbol] = ACTIONS(4316),
    [anon_sym_AT] = ACTIONS(4318),
    [anon_sym_DASH] = ACTIONS(4316),
    [anon_sym_void] = ACTIONS(4316),
    [anon_sym_break] = ACTIONS(4316),
    [anon_sym_const] = ACTIONS(4316),
    [sym_super] = ACTIONS(4316),
    [anon_sym_return] = ACTIONS(4316),
    [anon_sym_private] = ACTIONS(4316),
    [anon_sym_static] = ACTIONS(4316),
    [anon_sym_get] = ACTIONS(4316),
    [anon_sym_RBRACE] = ACTIONS(4318),
    [anon_sym_interface] = ACTIONS(4316),
    [anon_sym_default] = ACTIONS(4316),
    [anon_sym_enum] = ACTIONS(4316),
    [anon_sym_delete] = ACTIONS(4316),
    [anon_sym_continue] = ACTIONS(4316),
    [anon_sym_DASH_DASH] = ACTIONS(4318),
    [anon_sym_if] = ACTIONS(4316),
    [sym_this] = ACTIONS(4316),
    [anon_sym_yield] = ACTIONS(4316),
    [sym_true] = ACTIONS(4316),
    [anon_sym_throw] = ACTIONS(4316),
    [anon_sym_protected] = ACTIONS(4316),
    [anon_sym_abstract] = ACTIONS(4316),
    [anon_sym_set] = ACTIONS(4316),
    [anon_sym_type] = ACTIONS(4316),
    [anon_sym_import] = ACTIONS(4316),
    [anon_sym_namespace] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4318),
    [anon_sym_DQUOTE] = ACTIONS(4318),
    [anon_sym_else] = ACTIONS(4316),
    [anon_sym_BANG] = ACTIONS(4318),
    [anon_sym_for] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [sym_false] = ACTIONS(4316),
    [anon_sym_SEMI] = ACTIONS(4318),
    [anon_sym_case] = ACTIONS(4316),
    [anon_sym_module] = ACTIONS(4316),
    [anon_sym_number] = ACTIONS(4316),
    [anon_sym_class] = ACTIONS(4316),
    [anon_sym_declare] = ACTIONS(4316),
    [anon_sym_typeof] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(4318),
    [anon_sym_switch] = ACTIONS(4316),
    [anon_sym_LPAREN] = ACTIONS(4318),
    [sym_null] = ACTIONS(4316),
    [anon_sym_any] = ACTIONS(4316),
    [anon_sym_boolean] = ACTIONS(4316),
    [anon_sym_async] = ACTIONS(4316),
    [anon_sym_public] = ACTIONS(4316),
    [anon_sym_var] = ACTIONS(4316),
    [anon_sym_while] = ACTIONS(4316),
    [anon_sym_SQUOTE] = ACTIONS(4318),
    [anon_sym_try] = ACTIONS(4316),
    [anon_sym_LT] = ACTIONS(4318),
    [sym_number] = ACTIONS(4318),
    [anon_sym_SLASH] = ACTIONS(4316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(4316),
    [anon_sym_string] = ACTIONS(4316),
    [anon_sym_function] = ACTIONS(4316),
    [sym_undefined] = ACTIONS(4316),
    [anon_sym_new] = ACTIONS(4316),
    [ts_builtin_sym_end] = ACTIONS(4318),
    [anon_sym_let] = ACTIONS(4316),
    [anon_sym_PLUS] = ACTIONS(4316),
    [anon_sym_export] = ACTIONS(4316),
    [anon_sym_do] = ACTIONS(4316),
    [anon_sym_TILDE] = ACTIONS(4318),
    [anon_sym_with] = ACTIONS(4316),
    [anon_sym_await] = ACTIONS(4316),
  },
  [1248] = {
    [sym__call_signature] = STATE(2103),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1256),
    [sym__automatic_semicolon] = ACTIONS(4222),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4222),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4222),
    [sym_comment] = ACTIONS(3),
  },
  [1249] = {
    [sym__call_signature] = STATE(2104),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1260),
    [sym__automatic_semicolon] = ACTIONS(4234),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4234),
    [anon_sym_QMARK] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4234),
    [sym_comment] = ACTIONS(3),
  },
  [1250] = {
    [sym_identifier] = ACTIONS(4322),
    [anon_sym_BQUOTE] = ACTIONS(4324),
    [anon_sym_debugger] = ACTIONS(4322),
    [anon_sym_symbol] = ACTIONS(4322),
    [anon_sym_AT] = ACTIONS(4324),
    [anon_sym_DASH] = ACTIONS(4322),
    [anon_sym_void] = ACTIONS(4322),
    [anon_sym_break] = ACTIONS(4322),
    [anon_sym_const] = ACTIONS(4322),
    [sym_super] = ACTIONS(4322),
    [anon_sym_return] = ACTIONS(4322),
    [anon_sym_private] = ACTIONS(4322),
    [anon_sym_static] = ACTIONS(4322),
    [anon_sym_get] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_interface] = ACTIONS(4322),
    [anon_sym_default] = ACTIONS(4322),
    [anon_sym_enum] = ACTIONS(4322),
    [anon_sym_delete] = ACTIONS(4322),
    [anon_sym_continue] = ACTIONS(4322),
    [anon_sym_DASH_DASH] = ACTIONS(4324),
    [anon_sym_if] = ACTIONS(4322),
    [sym_this] = ACTIONS(4322),
    [anon_sym_yield] = ACTIONS(4322),
    [sym_true] = ACTIONS(4322),
    [anon_sym_throw] = ACTIONS(4322),
    [anon_sym_protected] = ACTIONS(4322),
    [anon_sym_abstract] = ACTIONS(4322),
    [anon_sym_set] = ACTIONS(4322),
    [anon_sym_type] = ACTIONS(4322),
    [anon_sym_import] = ACTIONS(4322),
    [anon_sym_namespace] = ACTIONS(4322),
    [anon_sym_PLUS_PLUS] = ACTIONS(4324),
    [anon_sym_DQUOTE] = ACTIONS(4324),
    [anon_sym_else] = ACTIONS(4322),
    [anon_sym_BANG] = ACTIONS(4324),
    [anon_sym_for] = ACTIONS(4322),
    [anon_sym_LBRACK] = ACTIONS(4324),
    [sym_false] = ACTIONS(4322),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_case] = ACTIONS(4322),
    [anon_sym_module] = ACTIONS(4322),
    [anon_sym_number] = ACTIONS(4322),
    [anon_sym_class] = ACTIONS(4322),
    [anon_sym_declare] = ACTIONS(4322),
    [anon_sym_typeof] = ACTIONS(4322),
    [anon_sym_LBRACE] = ACTIONS(4324),
    [anon_sym_switch] = ACTIONS(4322),
    [anon_sym_LPAREN] = ACTIONS(4324),
    [sym_null] = ACTIONS(4322),
    [anon_sym_any] = ACTIONS(4322),
    [anon_sym_boolean] = ACTIONS(4322),
    [anon_sym_async] = ACTIONS(4322),
    [anon_sym_public] = ACTIONS(4322),
    [anon_sym_var] = ACTIONS(4322),
    [anon_sym_while] = ACTIONS(4322),
    [anon_sym_SQUOTE] = ACTIONS(4324),
    [anon_sym_try] = ACTIONS(4322),
    [anon_sym_LT] = ACTIONS(4324),
    [sym_number] = ACTIONS(4324),
    [anon_sym_SLASH] = ACTIONS(4322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4322),
    [anon_sym_function] = ACTIONS(4322),
    [sym_undefined] = ACTIONS(4322),
    [anon_sym_new] = ACTIONS(4322),
    [ts_builtin_sym_end] = ACTIONS(4324),
    [anon_sym_let] = ACTIONS(4322),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_export] = ACTIONS(4322),
    [anon_sym_do] = ACTIONS(4322),
    [anon_sym_TILDE] = ACTIONS(4324),
    [anon_sym_with] = ACTIONS(4322),
    [anon_sym_await] = ACTIONS(4322),
  },
  [1251] = {
    [anon_sym_BQUOTE] = ACTIONS(4326),
    [anon_sym_symbol] = ACTIONS(4328),
    [anon_sym_PIPE] = ACTIONS(4326),
    [anon_sym_break] = ACTIONS(4328),
    [anon_sym_return] = ACTIONS(4328),
    [anon_sym_static] = ACTIONS(4328),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [anon_sym_interface] = ACTIONS(4328),
    [anon_sym_delete] = ACTIONS(4328),
    [anon_sym_if] = ACTIONS(4328),
    [anon_sym_yield] = ACTIONS(4328),
    [sym_true] = ACTIONS(4328),
    [anon_sym_protected] = ACTIONS(4328),
    [anon_sym_set] = ACTIONS(4328),
    [anon_sym_import] = ACTIONS(4328),
    [anon_sym_DQUOTE] = ACTIONS(4326),
    [anon_sym_for] = ACTIONS(4328),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_number] = ACTIONS(4328),
    [anon_sym_typeof] = ACTIONS(4328),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [anon_sym_switch] = ACTIONS(4328),
    [anon_sym_RBRACK] = ACTIONS(4326),
    [sym_null] = ACTIONS(4328),
    [anon_sym_any] = ACTIONS(4328),
    [anon_sym_async] = ACTIONS(4328),
    [anon_sym_public] = ACTIONS(4328),
    [anon_sym_var] = ACTIONS(4328),
    [anon_sym_while] = ACTIONS(4328),
    [anon_sym_SQUOTE] = ACTIONS(4326),
    [anon_sym_RPAREN] = ACTIONS(4326),
    [anon_sym_SLASH] = ACTIONS(4328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4328),
    [anon_sym_new] = ACTIONS(4328),
    [anon_sym_export] = ACTIONS(4328),
    [anon_sym_with] = ACTIONS(4328),
    [sym_identifier] = ACTIONS(4328),
    [anon_sym_debugger] = ACTIONS(4328),
    [anon_sym_AT] = ACTIONS(4326),
    [anon_sym_COMMA] = ACTIONS(4326),
    [anon_sym_DASH] = ACTIONS(4328),
    [anon_sym_EQ] = ACTIONS(4328),
    [anon_sym_void] = ACTIONS(4328),
    [anon_sym_const] = ACTIONS(4328),
    [sym_super] = ACTIONS(4328),
    [anon_sym_private] = ACTIONS(4328),
    [anon_sym_get] = ACTIONS(4328),
    [anon_sym_default] = ACTIONS(4328),
    [anon_sym_enum] = ACTIONS(4328),
    [anon_sym_continue] = ACTIONS(4328),
    [anon_sym_DASH_DASH] = ACTIONS(4326),
    [sym_this] = ACTIONS(4328),
    [anon_sym_throw] = ACTIONS(4328),
    [anon_sym_abstract] = ACTIONS(4328),
    [anon_sym_type] = ACTIONS(4328),
    [anon_sym_namespace] = ACTIONS(4328),
    [anon_sym_PLUS_PLUS] = ACTIONS(4326),
    [anon_sym_else] = ACTIONS(4328),
    [anon_sym_BANG] = ACTIONS(4326),
    [anon_sym_LBRACK] = ACTIONS(4326),
    [sym_false] = ACTIONS(4328),
    [anon_sym_case] = ACTIONS(4328),
    [anon_sym_module] = ACTIONS(4328),
    [anon_sym_class] = ACTIONS(4328),
    [anon_sym_declare] = ACTIONS(4328),
    [anon_sym_LPAREN] = ACTIONS(4326),
    [anon_sym_GT] = ACTIONS(4326),
    [anon_sym_boolean] = ACTIONS(4328),
    [anon_sym_EQ_GT] = ACTIONS(4326),
    [anon_sym_AMP] = ACTIONS(4326),
    [anon_sym_try] = ACTIONS(4328),
    [anon_sym_LT] = ACTIONS(4326),
    [sym_number] = ACTIONS(4326),
    [ts_builtin_sym_end] = ACTIONS(4326),
    [anon_sym_function] = ACTIONS(4328),
    [sym_undefined] = ACTIONS(4328),
    [anon_sym_let] = ACTIONS(4328),
    [anon_sym_PLUS] = ACTIONS(4328),
    [anon_sym_do] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4326),
    [anon_sym_await] = ACTIONS(4328),
  },
  [1252] = {
    [sym__automatic_semicolon] = ACTIONS(4278),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [anon_sym_SEMI] = ACTIONS(4278),
    [anon_sym_COMMA] = ACTIONS(4278),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4278),
    [sym_comment] = ACTIONS(3),
  },
  [1253] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1278),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1254] = {
    [sym__automatic_semicolon] = ACTIONS(4280),
    [anon_sym_RBRACE] = ACTIONS(4280),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4280),
    [sym_comment] = ACTIONS(3),
  },
  [1255] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1280),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4330),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1256] = {
    [sym__automatic_semicolon] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_COMMA] = ACTIONS(4332),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4332),
    [sym_comment] = ACTIONS(3),
  },
  [1257] = {
    [sym_string] = STATE(1281),
    [sym__property_name] = STATE(1281),
    [sym_computed_property_name] = STATE(1281),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1258] = {
    [sym_string] = STATE(1281),
    [sym__property_name] = STATE(1281),
    [sym_computed_property_name] = STATE(1281),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(4334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1259] = {
    [sym__call_signature] = STATE(1278),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1282),
    [sym__automatic_semicolon] = ACTIONS(4336),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4336),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4336),
    [sym_comment] = ACTIONS(3),
  },
  [1260] = {
    [sym__automatic_semicolon] = ACTIONS(4338),
    [anon_sym_RBRACE] = ACTIONS(4338),
    [anon_sym_SEMI] = ACTIONS(4338),
    [anon_sym_COMMA] = ACTIONS(4338),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4338),
    [sym_comment] = ACTIONS(3),
  },
  [1261] = {
    [sym__automatic_semicolon] = ACTIONS(4340),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_COMMA] = ACTIONS(4340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4340),
  },
  [1262] = {
    [sym__automatic_semicolon] = ACTIONS(4342),
    [anon_sym_RBRACE] = ACTIONS(4342),
    [anon_sym_SEMI] = ACTIONS(4342),
    [anon_sym_COMMA] = ACTIONS(4342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4342),
  },
  [1263] = {
    [sym__automatic_semicolon] = ACTIONS(4344),
    [anon_sym_SEMI] = ACTIONS(4344),
    [anon_sym_COMMA] = ACTIONS(4344),
    [sym_comment] = ACTIONS(3),
  },
  [1264] = {
    [sym_statement_block] = STATE(1633),
    [sym__automatic_semicolon] = ACTIONS(4346),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1265] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1283),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1266] = {
    [sym_statement_block] = STATE(1634),
    [sym__automatic_semicolon] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1267] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1285),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4350),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1268] = {
    [sym__automatic_semicolon] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym_COMMA] = ACTIONS(4352),
    [sym_comment] = ACTIONS(3),
  },
  [1269] = {
    [sym__initializer] = STATE(1286),
    [sym__automatic_semicolon] = ACTIONS(4354),
    [anon_sym_EQ] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(4354),
    [anon_sym_COMMA] = ACTIONS(4354),
    [sym_comment] = ACTIONS(3),
  },
  [1270] = {
    [sym__automatic_semicolon] = ACTIONS(4356),
    [anon_sym_SEMI] = ACTIONS(4356),
    [anon_sym_COMMA] = ACTIONS(4356),
    [sym_comment] = ACTIONS(3),
  },
  [1271] = {
    [sym__automatic_semicolon] = ACTIONS(4358),
    [anon_sym_SEMI] = ACTIONS(4358),
    [anon_sym_COMMA] = ACTIONS(4358),
    [sym_comment] = ACTIONS(3),
  },
  [1272] = {
    [anon_sym_COMMA] = ACTIONS(4360),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [sym_comment] = ACTIONS(3),
  },
  [1273] = {
    [sym_statement_block] = STATE(1287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1274] = {
    [anon_sym_COMMA] = ACTIONS(4362),
    [anon_sym_RBRACE] = ACTIONS(4362),
    [sym_comment] = ACTIONS(3),
  },
  [1275] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1288),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1276] = {
    [sym_statement_block] = STATE(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1277] = {
    [sym__call_signature] = STATE(2106),
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym_type_annotation] = STATE(1282),
    [sym__automatic_semicolon] = ACTIONS(4336),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4336),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(4336),
    [sym_comment] = ACTIONS(3),
  },
  [1278] = {
    [sym__automatic_semicolon] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4346),
    [sym_comment] = ACTIONS(3),
  },
  [1279] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1290),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1280] = {
    [sym__automatic_semicolon] = ACTIONS(4348),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4348),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4348),
    [sym_comment] = ACTIONS(3),
  },
  [1281] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1292),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(4364),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1282] = {
    [sym__automatic_semicolon] = ACTIONS(4366),
    [anon_sym_RBRACE] = ACTIONS(4366),
    [anon_sym_SEMI] = ACTIONS(4366),
    [anon_sym_COMMA] = ACTIONS(4366),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4366),
    [sym_comment] = ACTIONS(3),
  },
  [1283] = {
    [sym_statement_block] = STATE(1635),
    [sym__automatic_semicolon] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_COMMA] = ACTIONS(4368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1284] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1293),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1285] = {
    [sym_statement_block] = STATE(1636),
    [sym__automatic_semicolon] = ACTIONS(4370),
    [anon_sym_SEMI] = ACTIONS(4370),
    [anon_sym_COMMA] = ACTIONS(4370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1286] = {
    [sym__automatic_semicolon] = ACTIONS(4372),
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym_COMMA] = ACTIONS(4372),
    [sym_comment] = ACTIONS(3),
  },
  [1287] = {
    [anon_sym_COMMA] = ACTIONS(4374),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [sym_comment] = ACTIONS(3),
  },
  [1288] = {
    [sym_statement_block] = STATE(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [1289] = {
    [anon_sym_COMMA] = ACTIONS(4376),
    [anon_sym_RBRACE] = ACTIONS(4376),
    [sym_comment] = ACTIONS(3),
  },
  [1290] = {
    [sym__automatic_semicolon] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_COMMA] = ACTIONS(4368),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4368),
    [sym_comment] = ACTIONS(3),
  },
  [1291] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1295),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [1292] = {
    [sym__automatic_semicolon] = ACTIONS(4370),
    [anon_sym_RBRACE] = ACTIONS(4370),
    [anon_sym_SEMI] = ACTIONS(4370),
    [anon_sym_COMMA] = ACTIONS(4370),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4370),
    [sym_comment] = ACTIONS(3),
  },
  [1293] = {
    [sym_statement_block] = STATE(1637),
    [sym__automatic_semicolon] = ACTIONS(4378),
    [anon_sym_SEMI] = ACTIONS(4378),
    [anon_sym_COMMA] = ACTIONS(4378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3109),
  },
  [1294] = {
    [anon_sym_COMMA] = ACTIONS(4380),
    [anon_sym_RBRACE] = ACTIONS(4380),
    [sym_comment] = ACTIONS(3),
  },
  [1295] = {
    [sym__automatic_semicolon] = ACTIONS(4378),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_SEMI] = ACTIONS(4378),
    [anon_sym_COMMA] = ACTIONS(4378),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4378),
    [sym_comment] = ACTIONS(3),
  },
  [1296] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1297] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1298] = {
    [sym_class] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym__expression] = STATE(1324),
    [sym_jsx_element] = STATE(1324),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1324),
    [sym_call_expression] = STATE(1324),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1324),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1324),
    [sym_generator_function] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_regex] = STATE(1324),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1324),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_jsx_self_closing_element] = STATE(1324),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4382),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4382),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4382),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4382),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4382),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1299] = {
    [sym_class] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym__expression] = STATE(1326),
    [sym_jsx_element] = STATE(1326),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1326),
    [sym_call_expression] = STATE(1326),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1326),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1326),
    [sym_generator_function] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_regex] = STATE(1326),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1326),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_jsx_self_closing_element] = STATE(1326),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(4386),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4388),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(213),
    [sym_null] = ACTIONS(4388),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4388),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4388),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(4390),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4388),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1300] = {
    [sym_class] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym__expression] = STATE(1331),
    [sym_jsx_element] = STATE(1331),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1331),
    [sym_call_expression] = STATE(1331),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1331),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1331),
    [sym_generator_function] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_regex] = STATE(1331),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1331),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_jsx_self_closing_element] = STATE(1331),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4392),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4392),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4392),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4392),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4394),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4392),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1301] = {
    [sym_class] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym__expression] = STATE(1364),
    [sym_jsx_element] = STATE(1364),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1364),
    [sym_call_expression] = STATE(1364),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1364),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1364),
    [sym_generator_function] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_regex] = STATE(1364),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1364),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4396),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4396),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4396),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4396),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4398),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4396),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1302] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1303] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1304] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4400),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1305] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_else] = ACTIONS(593),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(593),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1306] = {
    [sym_type_annotation] = STATE(1379),
    [sym__automatic_semicolon] = ACTIONS(601),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_RBRACE] = ACTIONS(601),
    [anon_sym_COMMA] = ACTIONS(601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(601),
  },
  [1307] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4402),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1308] = {
    [sym_await_expression] = STATE(1383),
    [sym_statement_block] = STATE(1382),
    [sym_update_expression] = STATE(1383),
    [sym_meta_property] = STATE(1383),
    [sym__expression] = STATE(1383),
    [sym_jsx_element] = STATE(1383),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1383),
    [sym_call_expression] = STATE(1383),
    [sym_ternary_expression] = STATE(1383),
    [sym_template_string] = STATE(1383),
    [sym_yield_expression] = STATE(1383),
    [sym_jsx_fragment] = STATE(1383),
    [sym_new_expression] = STATE(1383),
    [sym_assignment_expression] = STATE(1383),
    [sym_binary_expression] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1383),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1383),
    [sym_jsx_self_closing_element] = STATE(1383),
    [sym_arrow_function] = STATE(1383),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1383),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1383),
    [sym_augmented_assignment_expression] = STATE(1383),
    [sym_unary_expression] = STATE(1383),
    [sym_regex] = STATE(1383),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1383),
    [sym_class] = STATE(1383),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4404),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4404),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4404),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4404),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4408),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4404),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1309] = {
    [sym_class] = STATE(1384),
    [sym_arrow_function] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1384),
    [sym_meta_property] = STATE(1384),
    [sym__expression] = STATE(1384),
    [sym_jsx_element] = STATE(1384),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1384),
    [sym_string] = STATE(1384),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1384),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1384),
    [sym_generator_function] = STATE(1384),
    [sym_new_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(1384),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_regex] = STATE(1384),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1384),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_jsx_self_closing_element] = STATE(1384),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4410),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4410),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4410),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4410),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4412),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4410),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1310] = {
    [sym_class] = STATE(1385),
    [sym_arrow_function] = STATE(1385),
    [sym_await_expression] = STATE(1385),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1385),
    [sym_meta_property] = STATE(1385),
    [sym__expression] = STATE(1385),
    [sym_jsx_element] = STATE(1385),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1385),
    [sym_call_expression] = STATE(1385),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1385),
    [sym_string] = STATE(1385),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1385),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1385),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1385),
    [sym_generator_function] = STATE(1385),
    [sym_new_expression] = STATE(1385),
    [sym_assignment_expression] = STATE(1385),
    [sym_augmented_assignment_expression] = STATE(1385),
    [sym_binary_expression] = STATE(1385),
    [sym_unary_expression] = STATE(1385),
    [sym_regex] = STATE(1385),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1385),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1385),
    [sym_internal_module] = STATE(1385),
    [sym_jsx_self_closing_element] = STATE(1385),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4414),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4414),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4414),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4414),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4414),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1311] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT_GT] = ACTIONS(635),
    [anon_sym_BANG_EQ] = ACTIONS(637),
    [anon_sym_GT_EQ] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_PERCENT] = ACTIONS(635),
    [anon_sym_LBRACE_PIPE] = ACTIONS(635),
    [anon_sym_as] = ACTIONS(635),
    [anon_sym_DASH_DASH] = ACTIONS(635),
    [anon_sym_instanceof] = ACTIONS(635),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_DOT] = ACTIONS(635),
    [anon_sym_STAR_STAR] = ACTIONS(635),
    [anon_sym_PLUS_PLUS] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_LT_EQ] = ACTIONS(635),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(637),
    [anon_sym_AMP] = ACTIONS(637),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(637),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_SLASH] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_implements] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(637),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(635),
  },
  [1312] = {
    [sym_await_expression] = STATE(1389),
    [sym_statement_block] = STATE(1388),
    [sym_update_expression] = STATE(1389),
    [sym_meta_property] = STATE(1389),
    [sym__expression] = STATE(1389),
    [sym_jsx_element] = STATE(1389),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1389),
    [sym_call_expression] = STATE(1389),
    [sym_ternary_expression] = STATE(1389),
    [sym_template_string] = STATE(1389),
    [sym_yield_expression] = STATE(1389),
    [sym_jsx_fragment] = STATE(1389),
    [sym_new_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1389),
    [sym_binary_expression] = STATE(1389),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1389),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1389),
    [sym_jsx_self_closing_element] = STATE(1389),
    [sym_arrow_function] = STATE(1389),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1389),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1389),
    [sym_augmented_assignment_expression] = STATE(1389),
    [sym_unary_expression] = STATE(1389),
    [sym_regex] = STATE(1389),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1389),
    [sym_class] = STATE(1389),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4418),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4418),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4418),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4418),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4418),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1313] = {
    [sym_class] = STATE(1390),
    [sym_arrow_function] = STATE(1390),
    [sym_await_expression] = STATE(1390),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1390),
    [sym_meta_property] = STATE(1390),
    [sym__expression] = STATE(1390),
    [sym_jsx_element] = STATE(1390),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1390),
    [sym_call_expression] = STATE(1390),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1390),
    [sym_string] = STATE(1390),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1390),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1390),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1390),
    [sym_generator_function] = STATE(1390),
    [sym_new_expression] = STATE(1390),
    [sym_assignment_expression] = STATE(1390),
    [sym_augmented_assignment_expression] = STATE(1390),
    [sym_binary_expression] = STATE(1390),
    [sym_unary_expression] = STATE(1390),
    [sym_regex] = STATE(1390),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1390),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1390),
    [sym_internal_module] = STATE(1390),
    [sym_jsx_self_closing_element] = STATE(1390),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4422),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4422),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4422),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4422),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4424),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4422),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1314] = {
    [sym_class] = STATE(1391),
    [sym_arrow_function] = STATE(1391),
    [sym_await_expression] = STATE(1391),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1391),
    [sym_meta_property] = STATE(1391),
    [sym__expression] = STATE(1391),
    [sym_jsx_element] = STATE(1391),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1391),
    [sym_call_expression] = STATE(1391),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1391),
    [sym_string] = STATE(1391),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1391),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1391),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1391),
    [sym_generator_function] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_assignment_expression] = STATE(1391),
    [sym_augmented_assignment_expression] = STATE(1391),
    [sym_binary_expression] = STATE(1391),
    [sym_unary_expression] = STATE(1391),
    [sym_regex] = STATE(1391),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1391),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1391),
    [sym_internal_module] = STATE(1391),
    [sym_jsx_self_closing_element] = STATE(1391),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4426),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4426),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4426),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4426),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4428),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4426),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1315] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1316] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1317] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1318] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1319] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(231),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_PERCENT] = ACTIONS(231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(231),
    [anon_sym_as] = ACTIONS(231),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_instanceof] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_DOT] = ACTIONS(231),
    [anon_sym_STAR_STAR] = ACTIONS(231),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_LT_LT] = ACTIONS(231),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(231),
    [anon_sym_LT_EQ] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(231),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(231),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(231),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_implements] = ACTIONS(231),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(231),
  },
  [1320] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1321] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
  },
  [1322] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
  },
  [1323] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(774),
    [anon_sym_BQUOTE] = ACTIONS(774),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(774),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_GT_GT_GT] = ACTIONS(774),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(774),
    [anon_sym_RBRACE] = ACTIONS(774),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(774),
    [anon_sym_as] = ACTIONS(774),
    [anon_sym_DASH_DASH] = ACTIONS(774),
    [anon_sym_instanceof] = ACTIONS(774),
    [anon_sym_COLON] = ACTIONS(774),
    [anon_sym_DOT] = ACTIONS(774),
    [anon_sym_STAR_STAR] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(774),
    [anon_sym_in] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_AMP_AMP] = ACTIONS(774),
    [anon_sym_LT_EQ] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_RBRACK] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_QMARK] = ACTIONS(774),
    [anon_sym_PIPE_PIPE] = ACTIONS(774),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(774),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_SLASH] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(774),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_implements] = ACTIONS(774),
    [anon_sym_GT_GT] = ACTIONS(776),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(774),
  },
  [1324] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(794),
    [anon_sym_BQUOTE] = ACTIONS(794),
    [anon_sym_PIPE] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(796),
    [anon_sym_GT_GT_GT] = ACTIONS(794),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(794),
    [anon_sym_RBRACE] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(794),
    [anon_sym_LBRACE_PIPE] = ACTIONS(794),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(794),
    [anon_sym_instanceof] = ACTIONS(794),
    [anon_sym_COLON] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(794),
    [anon_sym_PLUS_PLUS] = ACTIONS(794),
    [anon_sym_in] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(796),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(796),
    [anon_sym_AMP_AMP] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(794),
    [anon_sym_LPAREN] = ACTIONS(794),
    [anon_sym_RBRACK] = ACTIONS(794),
    [anon_sym_GT] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(796),
    [anon_sym_QMARK] = ACTIONS(794),
    [anon_sym_PIPE_PIPE] = ACTIONS(794),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_RPAREN] = ACTIONS(794),
    [anon_sym_LT] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_implements] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(796),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(794),
  },
  [1325] = {
    [sym_class] = STATE(1411),
    [sym_arrow_function] = STATE(1411),
    [sym_await_expression] = STATE(1411),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1411),
    [sym_meta_property] = STATE(1411),
    [sym__expression] = STATE(1411),
    [sym_jsx_element] = STATE(1411),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1411),
    [sym_call_expression] = STATE(1411),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1411),
    [sym_string] = STATE(1411),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1411),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1411),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1411),
    [sym_generator_function] = STATE(1411),
    [sym_new_expression] = STATE(1411),
    [sym_assignment_expression] = STATE(1411),
    [sym_augmented_assignment_expression] = STATE(1411),
    [sym_binary_expression] = STATE(1411),
    [sym_unary_expression] = STATE(1411),
    [sym_regex] = STATE(1411),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1411),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1411),
    [sym_internal_module] = STATE(1411),
    [sym_jsx_self_closing_element] = STATE(1411),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4435),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4435),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4435),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4435),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4437),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4435),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1326] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(806),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1327] = {
    [sym_statement_block] = STATE(1412),
    [sym_identifier] = ACTIONS(840),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_debugger] = ACTIONS(840),
    [anon_sym_symbol] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_void] = ACTIONS(840),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(840),
    [sym_super] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_get] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(840),
    [sym_this] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_set] = ACTIONS(840),
    [anon_sym_type] = ACTIONS(840),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_namespace] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_false] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_number] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_declare] = ACTIONS(840),
    [anon_sym_typeof] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [anon_sym_any] = ACTIONS(840),
    [anon_sym_boolean] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(838),
    [sym_number] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(840),
    [anon_sym_function] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(840),
    [ts_builtin_sym_end] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_export] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_await] = ACTIONS(840),
  },
  [1328] = {
    [sym_statement_block] = STATE(1412),
    [sym_identifier] = ACTIONS(840),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_debugger] = ACTIONS(840),
    [anon_sym_symbol] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_void] = ACTIONS(840),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(840),
    [sym_super] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_get] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(840),
    [sym_this] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_set] = ACTIONS(840),
    [anon_sym_type] = ACTIONS(840),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_namespace] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_false] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_number] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_declare] = ACTIONS(840),
    [anon_sym_typeof] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [anon_sym_any] = ACTIONS(840),
    [anon_sym_boolean] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(838),
    [sym_number] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(840),
    [anon_sym_function] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(840),
    [ts_builtin_sym_end] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_export] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_await] = ACTIONS(840),
  },
  [1329] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(846),
    [sym__automatic_semicolon] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_GT_GT_GT] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(848),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_PERCENT] = ACTIONS(846),
    [anon_sym_as] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_DOT] = ACTIONS(846),
    [anon_sym_STAR_STAR] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(848),
    [anon_sym_else] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(846),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_LT_LT] = ACTIONS(846),
    [anon_sym_AMP_AMP] = ACTIONS(846),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(848),
    [anon_sym_QMARK] = ACTIONS(846),
    [anon_sym_PIPE_PIPE] = ACTIONS(846),
    [anon_sym_while] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(848),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_SLASH] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_GT_GT] = ACTIONS(848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(846),
  },
  [1330] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(850),
    [sym__automatic_semicolon] = ACTIONS(850),
    [anon_sym_BQUOTE] = ACTIONS(850),
    [anon_sym_symbol] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(852),
    [anon_sym_STAR] = ACTIONS(852),
    [anon_sym_GT_GT_GT] = ACTIONS(850),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_BANG_EQ] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(852),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_PERCENT] = ACTIONS(850),
    [anon_sym_interface] = ACTIONS(852),
    [anon_sym_as] = ACTIONS(852),
    [anon_sym_delete] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_instanceof] = ACTIONS(852),
    [anon_sym_yield] = ACTIONS(852),
    [sym_true] = ACTIONS(852),
    [anon_sym_protected] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(852),
    [anon_sym_set] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_in] = ACTIONS(852),
    [anon_sym_DQUOTE] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(852),
    [anon_sym_typeof] = ACTIONS(852),
    [anon_sym_LT_LT] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_AMP_AMP] = ACTIONS(850),
    [anon_sym_switch] = ACTIONS(852),
    [anon_sym_LT_EQ] = ACTIONS(850),
    [sym_null] = ACTIONS(852),
    [anon_sym_any] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(852),
    [anon_sym_public] = ACTIONS(852),
    [anon_sym_var] = ACTIONS(852),
    [anon_sym_QMARK] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(850),
    [anon_sym_SLASH] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(852),
    [anon_sym_new] = ACTIONS(852),
    [anon_sym_CARET] = ACTIONS(850),
    [anon_sym_export] = ACTIONS(852),
    [anon_sym_GT_GT] = ACTIONS(852),
    [anon_sym_with] = ACTIONS(852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(850),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_debugger] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(850),
    [anon_sym_COMMA] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_void] = ACTIONS(852),
    [anon_sym_const] = ACTIONS(852),
    [anon_sym_GT_EQ] = ACTIONS(850),
    [sym_super] = ACTIONS(852),
    [anon_sym_private] = ACTIONS(852),
    [anon_sym_get] = ACTIONS(852),
    [anon_sym_default] = ACTIONS(852),
    [anon_sym_enum] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [sym_this] = ACTIONS(852),
    [anon_sym_throw] = ACTIONS(852),
    [anon_sym_abstract] = ACTIONS(852),
    [anon_sym_type] = ACTIONS(852),
    [anon_sym_STAR_STAR] = ACTIONS(850),
    [anon_sym_namespace] = ACTIONS(852),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_BANG] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(850),
    [sym_false] = ACTIONS(852),
    [anon_sym_case] = ACTIONS(852),
    [anon_sym_module] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_declare] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(852),
    [anon_sym_boolean] = ACTIONS(852),
    [anon_sym_AMP] = ACTIONS(852),
    [anon_sym_PIPE_PIPE] = ACTIONS(850),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_EQ_EQ] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(852),
    [sym_number] = ACTIONS(850),
    [ts_builtin_sym_end] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_let] = ACTIONS(852),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(852),
    [anon_sym_TILDE] = ACTIONS(850),
    [anon_sym_await] = ACTIONS(852),
  },
  [1331] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(4432),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
  },
  [1332] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(886),
    [anon_sym_BQUOTE] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_STAR] = ACTIONS(888),
    [anon_sym_GT_GT_GT] = ACTIONS(886),
    [anon_sym_EQ] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(886),
    [anon_sym_RBRACE] = ACTIONS(886),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(886),
    [anon_sym_as] = ACTIONS(886),
    [anon_sym_DASH_DASH] = ACTIONS(886),
    [anon_sym_instanceof] = ACTIONS(886),
    [anon_sym_COLON] = ACTIONS(886),
    [anon_sym_DOT] = ACTIONS(886),
    [anon_sym_STAR_STAR] = ACTIONS(886),
    [anon_sym_PLUS_PLUS] = ACTIONS(886),
    [anon_sym_in] = ACTIONS(888),
    [anon_sym_BANG] = ACTIONS(888),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(886),
    [anon_sym_of] = ACTIONS(886),
    [anon_sym_LT_EQ] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RBRACK] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(888),
    [anon_sym_AMP] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(886),
    [anon_sym_PIPE_PIPE] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_RPAREN] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(888),
    [anon_sym_SLASH] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_implements] = ACTIONS(886),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(886),
  },
  [1333] = {
    [sym__automatic_semicolon] = ACTIONS(928),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_COMMA] = ACTIONS(928),
    [anon_sym_PIPE_RBRACE] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
  },
  [1334] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(996),
    [anon_sym_BQUOTE] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(998),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_GT_GT_GT] = ACTIONS(996),
    [anon_sym_BANG_EQ] = ACTIONS(998),
    [anon_sym_GT_EQ] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_PERCENT] = ACTIONS(996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(996),
    [anon_sym_as] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(996),
    [anon_sym_instanceof] = ACTIONS(996),
    [anon_sym_COLON] = ACTIONS(996),
    [anon_sym_DOT] = ACTIONS(996),
    [anon_sym_STAR_STAR] = ACTIONS(996),
    [anon_sym_PLUS_PLUS] = ACTIONS(996),
    [anon_sym_in] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(996),
    [anon_sym_LT_LT] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_AMP_AMP] = ACTIONS(996),
    [anon_sym_LT_EQ] = ACTIONS(996),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_RBRACK] = ACTIONS(996),
    [anon_sym_GT] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_QMARK] = ACTIONS(996),
    [anon_sym_PIPE_PIPE] = ACTIONS(996),
    [anon_sym_EQ_EQ] = ACTIONS(998),
    [anon_sym_RPAREN] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(998),
    [anon_sym_SLASH] = ACTIONS(998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_implements] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(998),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(996),
  },
  [1335] = {
    [sym_string] = STATE(2360),
    [sym_nested_identifier] = STATE(2359),
    [sym__module] = STATE(1333),
    [sym_identifier] = ACTIONS(4439),
    [anon_sym_DOT] = ACTIONS(4441),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [1336] = {
    [sym_class_declaration] = STATE(1338),
    [sym_generator_function_declaration] = STATE(1338),
    [sym__declaration] = STATE(1338),
    [sym_enum_declaration] = STATE(1338),
    [sym_function_signature] = STATE(1338),
    [sym_abstract_class_declaration] = STATE(1338),
    [sym_module] = STATE(1338),
    [sym_interface_declaration] = STATE(1338),
    [sym_function_declaration] = STATE(1338),
    [sym_variable_declaration] = STATE(1338),
    [sym_lexical_declaration] = STATE(1338),
    [sym_ambient_declaration] = STATE(1338),
    [sym_import_alias] = STATE(1338),
    [sym_type_alias_declaration] = STATE(1338),
    [aux_sym_export_statement_repeat1] = STATE(2782),
    [sym_internal_module] = STATE(1338),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(2739),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_module] = ACTIONS(4443),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(4445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2737),
  },
  [1337] = {
    [sym_string] = STATE(2360),
    [sym_nested_identifier] = STATE(2359),
    [sym__module] = STATE(131),
    [sym_identifier] = ACTIONS(4439),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [1338] = {
    [sym__automatic_semicolon] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_COMMA] = ACTIONS(1018),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1018),
    [sym_comment] = ACTIONS(3),
  },
  [1339] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(1079),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
  },
  [1340] = {
    [sym_class] = STATE(1969),
    [sym_arrow_function] = STATE(1969),
    [sym_await_expression] = STATE(1969),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1969),
    [sym_meta_property] = STATE(1969),
    [sym__expression] = STATE(1969),
    [sym_jsx_element] = STATE(1969),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1969),
    [sym_call_expression] = STATE(1969),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_spread_element] = STATE(1884),
    [sym_ternary_expression] = STATE(1969),
    [sym_string] = STATE(1969),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1969),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1969),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1969),
    [sym_generator_function] = STATE(1969),
    [sym_new_expression] = STATE(1969),
    [sym_assignment_expression] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1969),
    [sym_binary_expression] = STATE(1969),
    [sym_unary_expression] = STATE(1969),
    [sym_regex] = STATE(1969),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [aux_sym_array_repeat1] = STATE(1885),
    [sym_non_null_expression] = STATE(1969),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1969),
    [sym_internal_module] = STATE(1969),
    [sym_jsx_self_closing_element] = STATE(1969),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4447),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [sym_null] = ACTIONS(4447),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4447),
    [sym_number] = ACTIONS(4449),
    [sym_true] = ACTIONS(4447),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4447),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1341] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1138),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2801),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1342] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1343] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(321),
  },
  [1344] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1345] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1346] = {
    [anon_sym_COLON] = ACTIONS(1177),
    [sym__automatic_semicolon] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1177),
  },
  [1347] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2801),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1348] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2322),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1349] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1200),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2324),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1350] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2326),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1351] = {
    [sym_optional_parameter] = STATE(1907),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(1907),
    [aux_sym_export_statement_repeat1] = STATE(1976),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(1907),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [1352] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1353] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1354] = {
    [sym_arguments] = STATE(1446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1300),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [1355] = {
    [sym_await_expression] = STATE(2497),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_ternary_expression] = STATE(2497),
    [sym_template_string] = STATE(2497),
    [sym_yield_expression] = STATE(2497),
    [sym_jsx_fragment] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2497),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_arguments] = STATE(1446),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2497),
    [sym_class] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [sym_this] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [sym_number] = ACTIONS(1322),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [1356] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1446),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [1357] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_arguments] = STATE(1446),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [1358] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1359] = {
    [sym_arguments] = STATE(1447),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1360] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1361] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1362] = {
    [sym_string] = STATE(2360),
    [sym_nested_identifier] = STATE(2359),
    [sym__module] = STATE(1333),
    [sym_identifier] = ACTIONS(4439),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [1363] = {
    [sym__automatic_semicolon] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [1364] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1396),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1365] = {
    [sym_class] = STATE(1450),
    [sym_arrow_function] = STATE(1450),
    [sym_await_expression] = STATE(1450),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1450),
    [sym_meta_property] = STATE(1450),
    [sym__expression] = STATE(1450),
    [sym_jsx_element] = STATE(1450),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1450),
    [sym_call_expression] = STATE(1450),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1450),
    [sym_string] = STATE(1450),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1450),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1450),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1450),
    [sym_generator_function] = STATE(1450),
    [sym_new_expression] = STATE(1450),
    [sym_assignment_expression] = STATE(1450),
    [sym_augmented_assignment_expression] = STATE(1450),
    [sym_binary_expression] = STATE(1450),
    [sym_unary_expression] = STATE(1450),
    [sym_regex] = STATE(1450),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1450),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1450),
    [sym_internal_module] = STATE(1450),
    [sym_jsx_self_closing_element] = STATE(1450),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4453),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4453),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4453),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4453),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4453),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1366] = {
    [sym_class] = STATE(1451),
    [sym_arrow_function] = STATE(1451),
    [sym_await_expression] = STATE(1451),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1451),
    [sym_meta_property] = STATE(1451),
    [sym__expression] = STATE(1451),
    [sym_jsx_element] = STATE(1451),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1451),
    [sym_call_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1451),
    [sym_string] = STATE(1451),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1451),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1451),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1451),
    [sym_generator_function] = STATE(1451),
    [sym_new_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1451),
    [sym_augmented_assignment_expression] = STATE(1451),
    [sym_binary_expression] = STATE(1451),
    [sym_unary_expression] = STATE(1451),
    [sym_regex] = STATE(1451),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1451),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1451),
    [sym_internal_module] = STATE(1451),
    [sym_jsx_self_closing_element] = STATE(1451),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4457),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4457),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4457),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4457),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4459),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4457),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1367] = {
    [sym_class] = STATE(1452),
    [sym_arrow_function] = STATE(1452),
    [sym_await_expression] = STATE(1452),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1452),
    [sym_meta_property] = STATE(1452),
    [sym__expression] = STATE(1452),
    [sym_jsx_element] = STATE(1452),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1452),
    [sym_call_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1452),
    [sym_string] = STATE(1452),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1452),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1452),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1452),
    [sym_generator_function] = STATE(1452),
    [sym_new_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1452),
    [sym_augmented_assignment_expression] = STATE(1452),
    [sym_binary_expression] = STATE(1452),
    [sym_unary_expression] = STATE(1452),
    [sym_regex] = STATE(1452),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1452),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1452),
    [sym_internal_module] = STATE(1452),
    [sym_jsx_self_closing_element] = STATE(1452),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4461),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4461),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4461),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4463),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4461),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1368] = {
    [sym_class] = STATE(1453),
    [sym_arrow_function] = STATE(1453),
    [sym_await_expression] = STATE(1453),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1453),
    [sym_meta_property] = STATE(1453),
    [sym__expression] = STATE(1453),
    [sym_jsx_element] = STATE(1453),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1453),
    [sym_call_expression] = STATE(1453),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1453),
    [sym_string] = STATE(1453),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1453),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1453),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1453),
    [sym_generator_function] = STATE(1453),
    [sym_new_expression] = STATE(1453),
    [sym_assignment_expression] = STATE(1453),
    [sym_augmented_assignment_expression] = STATE(1453),
    [sym_binary_expression] = STATE(1453),
    [sym_unary_expression] = STATE(1453),
    [sym_regex] = STATE(1453),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1453),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1453),
    [sym_internal_module] = STATE(1453),
    [sym_jsx_self_closing_element] = STATE(1453),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4465),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4465),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4465),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4465),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4465),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1369] = {
    [sym_class] = STATE(1454),
    [sym_arrow_function] = STATE(1454),
    [sym_await_expression] = STATE(1454),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1454),
    [sym_meta_property] = STATE(1454),
    [sym__expression] = STATE(1454),
    [sym_jsx_element] = STATE(1454),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1454),
    [sym_call_expression] = STATE(1454),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1454),
    [sym_string] = STATE(1454),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1454),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1454),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1454),
    [sym_generator_function] = STATE(1454),
    [sym_new_expression] = STATE(1454),
    [sym_assignment_expression] = STATE(1454),
    [sym_augmented_assignment_expression] = STATE(1454),
    [sym_binary_expression] = STATE(1454),
    [sym_unary_expression] = STATE(1454),
    [sym_regex] = STATE(1454),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1454),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1454),
    [sym_internal_module] = STATE(1454),
    [sym_jsx_self_closing_element] = STATE(1454),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4469),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4469),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4469),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4469),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4471),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4469),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1370] = {
    [sym_await_expression] = STATE(1456),
    [sym_update_expression] = STATE(1456),
    [sym_meta_property] = STATE(1456),
    [sym__expression] = STATE(1456),
    [sym_jsx_element] = STATE(1456),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1456),
    [sym_call_expression] = STATE(1456),
    [sym_ternary_expression] = STATE(1456),
    [sym_template_string] = STATE(1456),
    [sym_yield_expression] = STATE(1456),
    [sym_jsx_fragment] = STATE(1456),
    [sym_new_expression] = STATE(1456),
    [sym_assignment_expression] = STATE(1456),
    [sym_binary_expression] = STATE(1456),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1456),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1456),
    [sym_jsx_self_closing_element] = STATE(1456),
    [sym_arrow_function] = STATE(1456),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(1455),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1456),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1456),
    [sym_augmented_assignment_expression] = STATE(1456),
    [sym_unary_expression] = STATE(1456),
    [sym_regex] = STATE(1456),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1456),
    [sym_class] = STATE(1456),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4473),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4473),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4473),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4473),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4475),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4473),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1371] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1464),
    [anon_sym_BQUOTE] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1466),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_GT_GT_GT] = ACTIONS(1464),
    [anon_sym_BANG_EQ] = ACTIONS(1466),
    [anon_sym_GT_EQ] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_PERCENT] = ACTIONS(1464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1464),
    [anon_sym_as] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_instanceof] = ACTIONS(1464),
    [anon_sym_COLON] = ACTIONS(1464),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_STAR_STAR] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_in] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_LT_LT] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_AMP_AMP] = ACTIONS(1464),
    [anon_sym_LT_EQ] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_GT] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_QMARK] = ACTIONS(1464),
    [anon_sym_PIPE_PIPE] = ACTIONS(1464),
    [anon_sym_EQ_EQ] = ACTIONS(1466),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_implements] = ACTIONS(1464),
    [anon_sym_GT_GT] = ACTIONS(1466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1464),
  },
  [1372] = {
    [sym_await_expression] = STATE(1450),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(1450),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(1450),
    [sym_function_type] = STATE(345),
    [sym__expression] = STATE(1450),
    [sym_jsx_element] = STATE(1450),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1450),
    [sym_call_expression] = STATE(1450),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(1450),
    [sym_template_string] = STATE(1450),
    [sym_yield_expression] = STATE(1450),
    [sym_jsx_fragment] = STATE(1450),
    [sym_new_expression] = STATE(1450),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(1450),
    [sym_binary_expression] = STATE(1450),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1450),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1450),
    [sym_jsx_self_closing_element] = STATE(1450),
    [sym_arrow_function] = STATE(1450),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(345),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1460),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1450),
    [sym_constructor_type] = STATE(345),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(1450),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(1450),
    [sym_regex] = STATE(1450),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1450),
    [sym_class] = STATE(1450),
    [sym_identifier] = ACTIONS(4477),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4479),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(4481),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(4483),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4485),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4487),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(4487),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(4479),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(4489),
    [anon_sym_LBRACE] = ACTIONS(4491),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(4453),
    [anon_sym_any] = ACTIONS(4479),
    [anon_sym_boolean] = ACTIONS(4479),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4493),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4479),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4453),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(4481),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1373] = {
    [sym_class] = STATE(1468),
    [sym_arrow_function] = STATE(1468),
    [sym_await_expression] = STATE(1468),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1468),
    [sym_meta_property] = STATE(1468),
    [sym__expression] = STATE(1468),
    [sym_jsx_element] = STATE(1468),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1468),
    [sym_call_expression] = STATE(1468),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1468),
    [sym_string] = STATE(1468),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1468),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1468),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1468),
    [sym_generator_function] = STATE(1468),
    [sym_new_expression] = STATE(1468),
    [sym_assignment_expression] = STATE(1468),
    [sym_augmented_assignment_expression] = STATE(1468),
    [sym_binary_expression] = STATE(1468),
    [sym_unary_expression] = STATE(1468),
    [sym_regex] = STATE(1468),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1468),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1468),
    [sym_internal_module] = STATE(1468),
    [sym_jsx_self_closing_element] = STATE(1468),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4495),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4495),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4495),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4495),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4497),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4495),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1374] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1496),
    [anon_sym_BQUOTE] = ACTIONS(1496),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_COMMA] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_GT_GT_GT] = ACTIONS(1496),
    [anon_sym_BANG_EQ] = ACTIONS(1498),
    [anon_sym_GT_EQ] = ACTIONS(1496),
    [anon_sym_RBRACE] = ACTIONS(1496),
    [anon_sym_PERCENT] = ACTIONS(1496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1496),
    [anon_sym_as] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_instanceof] = ACTIONS(1496),
    [anon_sym_COLON] = ACTIONS(1496),
    [anon_sym_DOT] = ACTIONS(1496),
    [anon_sym_STAR_STAR] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_in] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_AMP_AMP] = ACTIONS(1496),
    [anon_sym_LT_EQ] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_RBRACK] = ACTIONS(1496),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1498),
    [anon_sym_QMARK] = ACTIONS(1496),
    [anon_sym_PIPE_PIPE] = ACTIONS(1496),
    [anon_sym_EQ_EQ] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(1496),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_SLASH] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_implements] = ACTIONS(1496),
    [anon_sym_GT_GT] = ACTIONS(1498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1496),
  },
  [1375] = {
    [sym_class] = STATE(1469),
    [sym_arrow_function] = STATE(1469),
    [sym_await_expression] = STATE(1469),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1469),
    [sym_meta_property] = STATE(1469),
    [sym__expression] = STATE(1469),
    [sym_jsx_element] = STATE(1469),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1469),
    [sym_call_expression] = STATE(1469),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1469),
    [sym_string] = STATE(1469),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1469),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1469),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1469),
    [sym_generator_function] = STATE(1469),
    [sym_new_expression] = STATE(1469),
    [sym_assignment_expression] = STATE(1469),
    [sym_augmented_assignment_expression] = STATE(1469),
    [sym_binary_expression] = STATE(1469),
    [sym_unary_expression] = STATE(1469),
    [sym_regex] = STATE(1469),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1469),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1469),
    [sym_internal_module] = STATE(1469),
    [sym_jsx_self_closing_element] = STATE(1469),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4499),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4499),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4499),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4499),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4501),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4499),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1376] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1520),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_GT_GT_GT] = ACTIONS(1520),
    [anon_sym_BANG_EQ] = ACTIONS(1522),
    [anon_sym_GT_EQ] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1520),
    [anon_sym_as] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_instanceof] = ACTIONS(1520),
    [anon_sym_COLON] = ACTIONS(1520),
    [anon_sym_DOT] = ACTIONS(1520),
    [anon_sym_STAR_STAR] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_in] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1520),
    [anon_sym_LT_LT] = ACTIONS(1520),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1520),
    [anon_sym_LT_EQ] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_GT] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_QMARK] = ACTIONS(1520),
    [anon_sym_PIPE_PIPE] = ACTIONS(1520),
    [anon_sym_EQ_EQ] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1520),
    [anon_sym_LT] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_implements] = ACTIONS(1520),
    [anon_sym_GT_GT] = ACTIONS(1522),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1520),
  },
  [1377] = {
    [sym_await_expression] = STATE(1473),
    [sym_statement_block] = STATE(1472),
    [sym_update_expression] = STATE(1473),
    [sym_meta_property] = STATE(1473),
    [sym__expression] = STATE(1473),
    [sym_jsx_element] = STATE(1473),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1473),
    [sym_call_expression] = STATE(1473),
    [sym_ternary_expression] = STATE(1473),
    [sym_template_string] = STATE(1473),
    [sym_yield_expression] = STATE(1473),
    [sym_jsx_fragment] = STATE(1473),
    [sym_new_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1473),
    [sym_binary_expression] = STATE(1473),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1473),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1473),
    [sym_jsx_self_closing_element] = STATE(1473),
    [sym_arrow_function] = STATE(1473),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1473),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1473),
    [sym_augmented_assignment_expression] = STATE(1473),
    [sym_unary_expression] = STATE(1473),
    [sym_regex] = STATE(1473),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1473),
    [sym_class] = STATE(1473),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4503),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4503),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4503),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4503),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4505),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1378] = {
    [sym_type_annotation] = STATE(1474),
    [sym__automatic_semicolon] = ACTIONS(1528),
    [anon_sym_COLON] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1528),
    [anon_sym_COMMA] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1528),
  },
  [1379] = {
    [sym__automatic_semicolon] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1530),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1530),
    [anon_sym_COMMA] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1530),
  },
  [1380] = {
    [sym_class] = STATE(1476),
    [sym_arrow_function] = STATE(1476),
    [sym_await_expression] = STATE(1476),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1476),
    [sym_meta_property] = STATE(1476),
    [sym__expression] = STATE(1476),
    [sym_jsx_element] = STATE(1476),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1476),
    [sym_call_expression] = STATE(1476),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1476),
    [sym_string] = STATE(1476),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1476),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1476),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1476),
    [sym_generator_function] = STATE(1476),
    [sym_new_expression] = STATE(1476),
    [sym_assignment_expression] = STATE(1476),
    [sym_augmented_assignment_expression] = STATE(1476),
    [sym_binary_expression] = STATE(1476),
    [sym_unary_expression] = STATE(1476),
    [sym_regex] = STATE(1476),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1476),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1476),
    [sym_internal_module] = STATE(1476),
    [sym_jsx_self_closing_element] = STATE(1476),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4507),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4507),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4507),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4507),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4509),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4507),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1381] = {
    [sym_class_declaration] = STATE(1477),
    [sym_generator_function_declaration] = STATE(1477),
    [sym__declaration] = STATE(1477),
    [sym_enum_declaration] = STATE(1477),
    [sym_function_signature] = STATE(1477),
    [sym_abstract_class_declaration] = STATE(1477),
    [sym_module] = STATE(1477),
    [sym_interface_declaration] = STATE(1477),
    [sym_function_declaration] = STATE(1477),
    [sym_variable_declaration] = STATE(1477),
    [sym_lexical_declaration] = STATE(1477),
    [sym_ambient_declaration] = STATE(1477),
    [sym_import_alias] = STATE(1477),
    [sym_type_alias_declaration] = STATE(1477),
    [aux_sym_export_statement_repeat1] = STATE(2782),
    [sym_internal_module] = STATE(1477),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(4511),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_module] = ACTIONS(2725),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2737),
  },
  [1382] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1699),
    [anon_sym_BQUOTE] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_GT_GT_GT] = ACTIONS(1699),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [anon_sym_instanceof] = ACTIONS(1699),
    [anon_sym_COLON] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_implements] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
  },
  [1383] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1384] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1385] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1709),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1386] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1713),
    [anon_sym_COMMA] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(1711),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_of] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_implements] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1387] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1717),
    [anon_sym_BQUOTE] = ACTIONS(1717),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_GT_GT_GT] = ACTIONS(1717),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_GT_EQ] = ACTIONS(1717),
    [anon_sym_RBRACE] = ACTIONS(1717),
    [anon_sym_PERCENT] = ACTIONS(1717),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1717),
    [anon_sym_as] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1717),
    [anon_sym_instanceof] = ACTIONS(1717),
    [anon_sym_COLON] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(1717),
    [anon_sym_STAR_STAR] = ACTIONS(1717),
    [anon_sym_PLUS_PLUS] = ACTIONS(1717),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_LT_LT] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_AMP_AMP] = ACTIONS(1717),
    [anon_sym_LT_EQ] = ACTIONS(1717),
    [anon_sym_LPAREN] = ACTIONS(1717),
    [anon_sym_RBRACK] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1717),
    [anon_sym_PIPE_PIPE] = ACTIONS(1717),
    [anon_sym_EQ_EQ] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1717),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1717),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_implements] = ACTIONS(1717),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1717),
  },
  [1388] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_GT_GT_GT] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_instanceof] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(1729),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_in] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_QMARK] = ACTIONS(1729),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_RPAREN] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_implements] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1729),
  },
  [1389] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1729),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1390] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1391] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1735),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1392] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1737),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [anon_sym_PERCENT_EQ] = ACTIONS(1737),
    [anon_sym_AMP_EQ] = ACTIONS(1737),
    [anon_sym_PLUS_EQ] = ACTIONS(1737),
    [anon_sym_PIPE] = ACTIONS(1739),
    [anon_sym_COMMA] = ACTIONS(1737),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1739),
    [anon_sym_GT_GT_GT] = ACTIONS(1739),
    [anon_sym_EQ] = ACTIONS(1739),
    [anon_sym_BANG_EQ] = ACTIONS(1739),
    [anon_sym_GT_EQ] = ACTIONS(1737),
    [anon_sym_CARET_EQ] = ACTIONS(1737),
    [anon_sym_PIPE_EQ] = ACTIONS(1737),
    [anon_sym_DASH_EQ] = ACTIONS(1737),
    [anon_sym_RBRACE] = ACTIONS(1737),
    [anon_sym_PERCENT] = ACTIONS(1739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1737),
    [anon_sym_LT_LT_EQ] = ACTIONS(1737),
    [anon_sym_as] = ACTIONS(1737),
    [anon_sym_DASH_DASH] = ACTIONS(1737),
    [anon_sym_instanceof] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(1737),
    [anon_sym_GT_GT_EQ] = ACTIONS(1737),
    [anon_sym_DOT] = ACTIONS(1737),
    [anon_sym_STAR_STAR] = ACTIONS(1739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1737),
    [anon_sym_PLUS_PLUS] = ACTIONS(1737),
    [anon_sym_in] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1737),
    [anon_sym_LT_LT] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_AMP_AMP] = ACTIONS(1737),
    [anon_sym_of] = ACTIONS(1737),
    [anon_sym_LT_EQ] = ACTIONS(1737),
    [anon_sym_LPAREN] = ACTIONS(1737),
    [anon_sym_RBRACK] = ACTIONS(1737),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_STAR_EQ] = ACTIONS(1737),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_QMARK] = ACTIONS(1737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1737),
    [anon_sym_EQ_EQ] = ACTIONS(1739),
    [anon_sym_RPAREN] = ACTIONS(1737),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_SLASH] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1737),
    [anon_sym_CARET] = ACTIONS(1739),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_implements] = ACTIONS(1737),
    [anon_sym_GT_GT] = ACTIONS(1739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1737),
  },
  [1393] = {
    [aux_sym_object_repeat1] = STATE(440),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
  },
  [1394] = {
    [aux_sym_object_repeat1] = STATE(440),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
  },
  [1395] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1085),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_of] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_implements] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
  },
  [1396] = {
    [sym_class] = STATE(1479),
    [sym_arrow_function] = STATE(1479),
    [sym_await_expression] = STATE(1479),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1479),
    [sym_meta_property] = STATE(1479),
    [sym__expression] = STATE(1479),
    [sym_jsx_element] = STATE(1479),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1479),
    [sym_call_expression] = STATE(1479),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1479),
    [sym_string] = STATE(1479),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1479),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1479),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1479),
    [sym_generator_function] = STATE(1479),
    [sym_new_expression] = STATE(1479),
    [sym_assignment_expression] = STATE(1479),
    [sym_augmented_assignment_expression] = STATE(1479),
    [sym_binary_expression] = STATE(1479),
    [sym_unary_expression] = STATE(1479),
    [sym_regex] = STATE(1479),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1479),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1479),
    [sym_internal_module] = STATE(1479),
    [sym_jsx_self_closing_element] = STATE(1479),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4513),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4513),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4513),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4513),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4515),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4513),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1397] = {
    [sym__automatic_semicolon] = ACTIONS(1787),
    [anon_sym_RBRACE] = ACTIONS(1787),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1787),
    [sym_comment] = ACTIONS(3),
  },
  [1398] = {
    [sym_type_arguments] = STATE(1484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1797),
    [sym__automatic_semicolon] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1797),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_GT_GT_GT] = ACTIONS(1797),
    [anon_sym_BANG_EQ] = ACTIONS(1801),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [anon_sym_PERCENT] = ACTIONS(1797),
    [anon_sym_as] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1797),
    [anon_sym_instanceof] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(4517),
    [anon_sym_STAR_STAR] = ACTIONS(1797),
    [anon_sym_PLUS_PLUS] = ACTIONS(1797),
    [anon_sym_in] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym_LT_LT] = ACTIONS(1797),
    [anon_sym_is] = ACTIONS(4519),
    [anon_sym_AMP_AMP] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_QMARK] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1797),
    [anon_sym_EQ_EQ] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(4521),
    [anon_sym_SLASH] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1797),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1797),
  },
  [1399] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [sym__automatic_semicolon] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_BQUOTE] = ACTIONS(1805),
    [anon_sym_PIPE] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_LT_LT] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1807),
    [anon_sym_GT_GT_GT] = ACTIONS(1805),
    [anon_sym_AMP_AMP] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_LT_EQ] = ACTIONS(1805),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_PERCENT] = ACTIONS(1805),
    [anon_sym_QMARK] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_as] = ACTIONS(1805),
    [anon_sym_PIPE_PIPE] = ACTIONS(1805),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_instanceof] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_SLASH] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1805),
    [anon_sym_STAR_STAR] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_GT_GT] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_in] = ACTIONS(1807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
  },
  [1400] = {
    [sym_array_type] = STATE(1485),
    [sym_generic_type] = STATE(1485),
    [sym_type_predicate] = STATE(1485),
    [sym_literal_type] = STATE(1485),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1485),
    [sym__primary_type] = STATE(1485),
    [sym_lookup_type] = STATE(1485),
    [sym_parenthesized_type] = STATE(1485),
    [sym_nested_identifier] = STATE(2402),
    [sym_predefined_type] = STATE(1485),
    [sym_nested_type_identifier] = STATE(1406),
    [sym_tuple_type] = STATE(1485),
    [sym_type_query] = STATE(1485),
    [sym_index_type_query] = STATE(1485),
    [sym_existential_type] = STATE(1485),
    [sym_flow_maybe_type] = STATE(1485),
    [sym_string] = STATE(1399),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(4524),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(4526),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1401] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1487),
    [sym_function_type] = STATE(1487),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1487),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1487),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1487),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1402] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1833),
    [sym__automatic_semicolon] = ACTIONS(1833),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_BQUOTE] = ACTIONS(1833),
    [anon_sym_PIPE] = ACTIONS(1835),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR] = ACTIONS(1835),
    [anon_sym_GT_GT_GT] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1835),
    [anon_sym_BANG_EQ] = ACTIONS(1835),
    [anon_sym_LT_EQ] = ACTIONS(1833),
    [anon_sym_LPAREN] = ACTIONS(1833),
    [anon_sym_GT_EQ] = ACTIONS(1833),
    [anon_sym_GT] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_PERCENT] = ACTIONS(1833),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_RBRACE] = ACTIONS(1833),
    [anon_sym_as] = ACTIONS(1833),
    [anon_sym_PIPE_PIPE] = ACTIONS(1833),
    [anon_sym_DASH_DASH] = ACTIONS(1833),
    [anon_sym_EQ_EQ] = ACTIONS(1835),
    [anon_sym_instanceof] = ACTIONS(1833),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_SLASH] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1833),
    [anon_sym_CARET] = ACTIONS(1833),
    [anon_sym_STAR_STAR] = ACTIONS(1833),
    [anon_sym_PLUS] = ACTIONS(1835),
    [anon_sym_GT_GT] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1833),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1833),
    [anon_sym_BANG] = ACTIONS(1835),
  },
  [1403] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [sym__automatic_semicolon] = ACTIONS(1841),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [anon_sym_PIPE] = ACTIONS(1843),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_LT_LT] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1843),
    [anon_sym_GT_GT_GT] = ACTIONS(1841),
    [anon_sym_AMP_AMP] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_BANG_EQ] = ACTIONS(1843),
    [anon_sym_LT_EQ] = ACTIONS(1841),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_GT_EQ] = ACTIONS(1841),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_PERCENT] = ACTIONS(1841),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_as] = ACTIONS(1841),
    [anon_sym_PIPE_PIPE] = ACTIONS(1841),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_EQ_EQ] = ACTIONS(1843),
    [anon_sym_instanceof] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_SLASH] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1841),
    [anon_sym_CARET] = ACTIONS(1841),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_GT_GT] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_in] = ACTIONS(1843),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
  },
  [1404] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1492),
    [sym_function_type] = STATE(1492),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1492),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1492),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1492),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1405] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [sym__automatic_semicolon] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1859),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1861),
    [anon_sym_GT_GT_GT] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_BANG_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1859),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_as] = ACTIONS(1859),
    [anon_sym_PIPE_PIPE] = ACTIONS(1859),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [anon_sym_EQ_EQ] = ACTIONS(1861),
    [anon_sym_instanceof] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1859),
    [anon_sym_CARET] = ACTIONS(1859),
    [anon_sym_STAR_STAR] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_GT_GT] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(1861),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1861),
  },
  [1406] = {
    [sym_type_arguments] = STATE(1494),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1865),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_GT_GT_GT] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_BANG_EQ] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_PERCENT] = ACTIONS(1865),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_as] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_EQ_EQ] = ACTIONS(1867),
    [anon_sym_instanceof] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_CARET] = ACTIONS(1865),
    [anon_sym_STAR_STAR] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_in] = ACTIONS(1867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1867),
  },
  [1407] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BQUOTE] = ACTIONS(1877),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1879),
    [anon_sym_STAR] = ACTIONS(1879),
    [anon_sym_GT_GT_GT] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_PERCENT] = ACTIONS(1877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1877),
    [anon_sym_as] = ACTIONS(1877),
    [anon_sym_DASH_DASH] = ACTIONS(1877),
    [anon_sym_instanceof] = ACTIONS(1877),
    [anon_sym_COLON] = ACTIONS(1877),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_STAR_STAR] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1877),
    [anon_sym_in] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_class] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1879),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_RBRACK] = ACTIONS(1877),
    [anon_sym_GT] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_QMARK] = ACTIONS(1877),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_EQ_EQ] = ACTIONS(1879),
    [anon_sym_RPAREN] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1879),
    [anon_sym_export] = ACTIONS(1877),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_implements] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
  },
  [1408] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_GT_GT_GT] = ACTIONS(1883),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_RBRACE] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1883),
    [anon_sym_as] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1883),
    [anon_sym_instanceof] = ACTIONS(1883),
    [anon_sym_COLON] = ACTIONS(1883),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_STAR_STAR] = ACTIONS(1883),
    [anon_sym_PLUS_PLUS] = ACTIONS(1883),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1883),
    [anon_sym_RBRACK] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
    [anon_sym_QMARK] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_implements] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1883),
  },
  [1409] = {
    [sym__automatic_semicolon] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_COMMA] = ACTIONS(1893),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1893),
    [sym_comment] = ACTIONS(3),
  },
  [1410] = {
    [sym__automatic_semicolon] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1901),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
  },
  [1411] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(1913),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(1913),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1412] = {
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [anon_sym_debugger] = ACTIONS(1989),
    [anon_sym_symbol] = ACTIONS(1989),
    [anon_sym_AT] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_void] = ACTIONS(1989),
    [anon_sym_break] = ACTIONS(1989),
    [anon_sym_const] = ACTIONS(1989),
    [sym_super] = ACTIONS(1989),
    [anon_sym_return] = ACTIONS(1989),
    [anon_sym_private] = ACTIONS(1989),
    [anon_sym_static] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1987),
    [anon_sym_interface] = ACTIONS(1989),
    [anon_sym_default] = ACTIONS(1989),
    [anon_sym_enum] = ACTIONS(1989),
    [anon_sym_delete] = ACTIONS(1989),
    [anon_sym_continue] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1989),
    [sym_this] = ACTIONS(1989),
    [anon_sym_yield] = ACTIONS(1989),
    [sym_true] = ACTIONS(1989),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_protected] = ACTIONS(1989),
    [anon_sym_abstract] = ACTIONS(1989),
    [anon_sym_set] = ACTIONS(1989),
    [anon_sym_type] = ACTIONS(1989),
    [anon_sym_import] = ACTIONS(1989),
    [anon_sym_namespace] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [sym_false] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_case] = ACTIONS(1989),
    [anon_sym_module] = ACTIONS(1989),
    [anon_sym_number] = ACTIONS(1989),
    [anon_sym_class] = ACTIONS(1989),
    [anon_sym_declare] = ACTIONS(1989),
    [anon_sym_typeof] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [sym_null] = ACTIONS(1989),
    [anon_sym_any] = ACTIONS(1989),
    [anon_sym_boolean] = ACTIONS(1989),
    [anon_sym_async] = ACTIONS(1989),
    [anon_sym_public] = ACTIONS(1989),
    [anon_sym_var] = ACTIONS(1989),
    [anon_sym_while] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1987),
    [sym_number] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1989),
    [anon_sym_function] = ACTIONS(1989),
    [sym_undefined] = ACTIONS(1989),
    [anon_sym_new] = ACTIONS(1989),
    [ts_builtin_sym_end] = ACTIONS(1987),
    [anon_sym_let] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1989),
    [anon_sym_export] = ACTIONS(1989),
    [anon_sym_do] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1987),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_await] = ACTIONS(1989),
  },
  [1413] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1991),
    [sym__automatic_semicolon] = ACTIONS(1991),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_GT_GT_GT] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_return] = ACTIONS(1993),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_interface] = ACTIONS(1993),
    [anon_sym_as] = ACTIONS(1993),
    [anon_sym_delete] = ACTIONS(1993),
    [anon_sym_if] = ACTIONS(1993),
    [anon_sym_instanceof] = ACTIONS(1993),
    [anon_sym_yield] = ACTIONS(1993),
    [sym_true] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_import] = ACTIONS(1993),
    [anon_sym_in] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1993),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_typeof] = ACTIONS(1993),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [sym_null] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_var] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1993),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_GT_GT] = ACTIONS(1993),
    [anon_sym_with] = ACTIONS(1993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1991),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_debugger] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(1991),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_void] = ACTIONS(1993),
    [anon_sym_const] = ACTIONS(1993),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [sym_super] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_default] = ACTIONS(1993),
    [anon_sym_enum] = ACTIONS(1993),
    [anon_sym_continue] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [sym_this] = ACTIONS(1993),
    [anon_sym_throw] = ACTIONS(1993),
    [anon_sym_abstract] = ACTIONS(1993),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_STAR_STAR] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [sym_false] = ACTIONS(1993),
    [anon_sym_case] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1993),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1993),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1993),
    [sym_number] = ACTIONS(1991),
    [ts_builtin_sym_end] = ACTIONS(1991),
    [anon_sym_function] = ACTIONS(1993),
    [sym_undefined] = ACTIONS(1993),
    [anon_sym_let] = ACTIONS(1993),
    [anon_sym_PLUS] = ACTIONS(1993),
    [anon_sym_do] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1991),
    [anon_sym_await] = ACTIONS(1993),
  },
  [1414] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_of] = ACTIONS(2003),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1415] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_of] = ACTIONS(2008),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1416] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(499),
  },
  [1417] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1418] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_of] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1419] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_of] = ACTIONS(2003),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1420] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_of] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1421] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_of] = ACTIONS(2034),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2036),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1422] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_COMMA] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_GT_GT_GT] = ACTIONS(2059),
    [anon_sym_EQ] = ACTIONS(2061),
    [anon_sym_BANG_EQ] = ACTIONS(2061),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_PERCENT] = ACTIONS(2059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2059),
    [anon_sym_as] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_instanceof] = ACTIONS(2059),
    [anon_sym_COLON] = ACTIONS(2059),
    [anon_sym_DOT] = ACTIONS(2059),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(2059),
    [anon_sym_LT_LT] = ACTIONS(2059),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_of] = ACTIONS(2059),
    [anon_sym_LT_EQ] = ACTIONS(2059),
    [anon_sym_LPAREN] = ACTIONS(2059),
    [anon_sym_RBRACK] = ACTIONS(2059),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_QMARK] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2059),
    [anon_sym_EQ_EQ] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2059),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2061),
    [anon_sym_implements] = ACTIONS(2059),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2059),
  },
  [1423] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2115),
    [sym__automatic_semicolon] = ACTIONS(2117),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [anon_sym_PIPE] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2115),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_GT_EQ] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_as] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2115),
    [anon_sym_instanceof] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [anon_sym_STAR_STAR] = ACTIONS(2115),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2119),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_AMP_AMP] = ACTIONS(2115),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_GT] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(2115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2119),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2123),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2123),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2115),
  },
  [1424] = {
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1753),
  },
  [1425] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2143),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2143),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_PERCENT] = ACTIONS(2143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2143),
    [anon_sym_as] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_instanceof] = ACTIONS(2143),
    [anon_sym_COLON] = ACTIONS(2143),
    [anon_sym_DOT] = ACTIONS(2143),
    [anon_sym_STAR_STAR] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_LT_LT] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2143),
    [anon_sym_LT_EQ] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_RBRACK] = ACTIONS(2143),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2143),
    [anon_sym_PIPE_PIPE] = ACTIONS(2143),
    [anon_sym_while] = ACTIONS(2143),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2143),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_implements] = ACTIONS(2143),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2143),
  },
  [1426] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BQUOTE] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_GT_GT_GT] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2191),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2191),
    [anon_sym_as] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2191),
    [anon_sym_instanceof] = ACTIONS(2191),
    [anon_sym_COLON] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_PLUS_PLUS] = ACTIONS(2191),
    [anon_sym_in] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2191),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(2191),
    [anon_sym_RBRACK] = ACTIONS(2191),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2193),
    [anon_sym_QMARK] = ACTIONS(2191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2193),
    [anon_sym_RPAREN] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2193),
    [anon_sym_implements] = ACTIONS(2191),
    [anon_sym_GT_GT] = ACTIONS(2193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2191),
  },
  [1427] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2195),
    [anon_sym_BQUOTE] = ACTIONS(2195),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2195),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_GT_GT_GT] = ACTIONS(2195),
    [anon_sym_BANG_EQ] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [anon_sym_PERCENT] = ACTIONS(2195),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2195),
    [anon_sym_as] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_instanceof] = ACTIONS(2195),
    [anon_sym_COLON] = ACTIONS(2195),
    [anon_sym_DOT] = ACTIONS(2195),
    [anon_sym_STAR_STAR] = ACTIONS(2195),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_LT_LT] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2195),
    [anon_sym_LT_EQ] = ACTIONS(2195),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_RBRACK] = ACTIONS(2195),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2195),
    [anon_sym_PIPE_PIPE] = ACTIONS(2195),
    [anon_sym_EQ_EQ] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(2195),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_implements] = ACTIONS(2195),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2195),
  },
  [1428] = {
    [sym__automatic_semicolon] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
  },
  [1429] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2217),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_STAR] = ACTIONS(2219),
    [anon_sym_GT_GT_GT] = ACTIONS(2217),
    [anon_sym_EQ] = ACTIONS(2219),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_GT_EQ] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_PERCENT] = ACTIONS(2217),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2217),
    [anon_sym_as] = ACTIONS(2217),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_instanceof] = ACTIONS(2217),
    [anon_sym_COLON] = ACTIONS(2217),
    [anon_sym_DOT] = ACTIONS(2217),
    [anon_sym_STAR_STAR] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_in] = ACTIONS(2219),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [anon_sym_LT_LT] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_of] = ACTIONS(2217),
    [anon_sym_LT_EQ] = ACTIONS(2217),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [anon_sym_RBRACK] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2217),
    [anon_sym_PIPE_PIPE] = ACTIONS(2217),
    [anon_sym_EQ_EQ] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_implements] = ACTIONS(2217),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2217),
  },
  [1430] = {
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(3887),
    [sym_comment] = ACTIONS(3),
  },
  [1431] = {
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(3887),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
  },
  [1432] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2249),
    [sym__automatic_semicolon] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2249),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_as] = ACTIONS(2249),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_instanceof] = ACTIONS(2249),
    [anon_sym_DOT] = ACTIONS(2249),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2249),
    [anon_sym_STAR_STAR] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_LT_LT] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2249),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2249),
  },
  [1433] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2255),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_GT_GT_GT] = ACTIONS(2255),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [anon_sym_instanceof] = ACTIONS(2255),
    [anon_sym_COLON] = ACTIONS(2255),
    [anon_sym_DOT] = ACTIONS(2255),
    [anon_sym_STAR_STAR] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_in] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LT_LT] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2255),
    [anon_sym_of] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_RBRACK] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_QMARK] = ACTIONS(2255),
    [anon_sym_PIPE_PIPE] = ACTIONS(2255),
    [anon_sym_EQ_EQ] = ACTIONS(2257),
    [anon_sym_RPAREN] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2257),
    [anon_sym_SLASH] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2257),
    [anon_sym_implements] = ACTIONS(2255),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2255),
  },
  [1434] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2249),
    [sym__automatic_semicolon] = ACTIONS(4533),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2249),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_as] = ACTIONS(2249),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_instanceof] = ACTIONS(2249),
    [anon_sym_DOT] = ACTIONS(2249),
    [anon_sym_STAR_STAR] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_LT_LT] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2249),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2249),
  },
  [1435] = {
    [anon_sym_COLON] = ACTIONS(2302),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2302),
    [anon_sym_COMMA] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2302),
  },
  [1436] = {
    [sym_identifier] = ACTIONS(2314),
    [anon_sym_BQUOTE] = ACTIONS(2312),
    [anon_sym_debugger] = ACTIONS(2314),
    [anon_sym_symbol] = ACTIONS(2314),
    [anon_sym_AT] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_void] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [sym_super] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_private] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_get] = ACTIONS(2314),
    [anon_sym_interface] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_delete] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2314),
    [sym_this] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2314),
    [sym_true] = ACTIONS(2314),
    [anon_sym_throw] = ACTIONS(2314),
    [anon_sym_protected] = ACTIONS(2314),
    [anon_sym_abstract] = ACTIONS(2314),
    [anon_sym_set] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2314),
    [anon_sym_import] = ACTIONS(2314),
    [anon_sym_namespace] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [sym_false] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2314),
    [anon_sym_number] = ACTIONS(2314),
    [anon_sym_class] = ACTIONS(2314),
    [anon_sym_declare] = ACTIONS(2314),
    [anon_sym_typeof] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [sym_null] = ACTIONS(2314),
    [anon_sym_any] = ACTIONS(2314),
    [anon_sym_boolean] = ACTIONS(2314),
    [anon_sym_async] = ACTIONS(2314),
    [anon_sym_public] = ACTIONS(2314),
    [anon_sym_var] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2312),
    [sym_number] = ACTIONS(2312),
    [anon_sym_SLASH] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2314),
    [sym_undefined] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2314),
    [anon_sym_let] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_export] = ACTIONS(2314),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2314),
    [anon_sym_await] = ACTIONS(2314),
  },
  [1437] = {
    [sym_await_expression] = STATE(1519),
    [sym_statement_block] = STATE(1518),
    [sym_update_expression] = STATE(1519),
    [sym_meta_property] = STATE(1519),
    [sym__expression] = STATE(1519),
    [sym_jsx_element] = STATE(1519),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1519),
    [sym_call_expression] = STATE(1519),
    [sym_ternary_expression] = STATE(1519),
    [sym_template_string] = STATE(1519),
    [sym_yield_expression] = STATE(1519),
    [sym_jsx_fragment] = STATE(1519),
    [sym_new_expression] = STATE(1519),
    [sym_assignment_expression] = STATE(1519),
    [sym_binary_expression] = STATE(1519),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1519),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1519),
    [sym_jsx_self_closing_element] = STATE(1519),
    [sym_arrow_function] = STATE(1519),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1519),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1519),
    [sym_augmented_assignment_expression] = STATE(1519),
    [sym_unary_expression] = STATE(1519),
    [sym_regex] = STATE(1519),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1519),
    [sym_class] = STATE(1519),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4535),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4535),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4535),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4535),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4537),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4535),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1438] = {
    [sym_await_expression] = STATE(1521),
    [sym_statement_block] = STATE(1520),
    [sym_update_expression] = STATE(1521),
    [sym_meta_property] = STATE(1521),
    [sym__expression] = STATE(1521),
    [sym_jsx_element] = STATE(1521),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1521),
    [sym_call_expression] = STATE(1521),
    [sym_ternary_expression] = STATE(1521),
    [sym_template_string] = STATE(1521),
    [sym_yield_expression] = STATE(1521),
    [sym_jsx_fragment] = STATE(1521),
    [sym_new_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1521),
    [sym_binary_expression] = STATE(1521),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1521),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1521),
    [sym_jsx_self_closing_element] = STATE(1521),
    [sym_arrow_function] = STATE(1521),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1521),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1521),
    [sym_augmented_assignment_expression] = STATE(1521),
    [sym_unary_expression] = STATE(1521),
    [sym_regex] = STATE(1521),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1521),
    [sym_class] = STATE(1521),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4539),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4539),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4539),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4539),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4541),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4539),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1439] = {
    [sym_await_expression] = STATE(1524),
    [sym_statement_block] = STATE(1523),
    [sym_update_expression] = STATE(1524),
    [sym_meta_property] = STATE(1524),
    [sym__expression] = STATE(1524),
    [sym_jsx_element] = STATE(1524),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1524),
    [sym_call_expression] = STATE(1524),
    [sym_ternary_expression] = STATE(1524),
    [sym_template_string] = STATE(1524),
    [sym_yield_expression] = STATE(1524),
    [sym_jsx_fragment] = STATE(1524),
    [sym_new_expression] = STATE(1524),
    [sym_assignment_expression] = STATE(1524),
    [sym_binary_expression] = STATE(1524),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1524),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1524),
    [sym_jsx_self_closing_element] = STATE(1524),
    [sym_arrow_function] = STATE(1524),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1524),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1524),
    [sym_augmented_assignment_expression] = STATE(1524),
    [sym_unary_expression] = STATE(1524),
    [sym_regex] = STATE(1524),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1524),
    [sym_class] = STATE(1524),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4543),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4543),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4543),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4543),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4543),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1440] = {
    [sym__automatic_semicolon] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(2344),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
  },
  [1441] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(4547),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_interface] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [sym_true] = ACTIONS(1083),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(1083),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [sym_null] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_var] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_debugger] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [sym_super] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_this] = ACTIONS(1083),
    [anon_sym_throw] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_else] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_false] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1083),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1083),
    [sym_number] = ACTIONS(1081),
    [ts_builtin_sym_end] = ACTIONS(1081),
    [anon_sym_function] = ACTIONS(1083),
    [sym_undefined] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1083),
  },
  [1442] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2418),
    [sym_regex_flags] = ACTIONS(4549),
    [anon_sym_COLON] = ACTIONS(2416),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
  },
  [1443] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2424),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_implements] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
  },
  [1444] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_implements] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
  },
  [1445] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_COLON] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_implements] = ACTIONS(2432),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
  },
  [1446] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_RBRACK] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_implements] = ACTIONS(2436),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
  },
  [1447] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_implements] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
  },
  [1448] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(4551),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(4551),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1449] = {
    [sym__automatic_semicolon] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
  },
  [1450] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
  },
  [1451] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1452] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
  },
  [1453] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
  },
  [1454] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1455] = {
    [anon_sym_COLON] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_RPAREN] = ACTIONS(2495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(2495),
  },
  [1456] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(2495),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2495),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2495),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1457] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2499),
    [anon_sym_BQUOTE] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_COMMA] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2501),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_GT_GT_GT] = ACTIONS(2499),
    [anon_sym_BANG_EQ] = ACTIONS(2501),
    [anon_sym_GT_EQ] = ACTIONS(2499),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2499),
    [anon_sym_as] = ACTIONS(2499),
    [anon_sym_DASH_DASH] = ACTIONS(2499),
    [anon_sym_instanceof] = ACTIONS(2499),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_DOT] = ACTIONS(2499),
    [anon_sym_STAR_STAR] = ACTIONS(2499),
    [anon_sym_PLUS_PLUS] = ACTIONS(2499),
    [anon_sym_in] = ACTIONS(2501),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_LBRACK] = ACTIONS(2499),
    [anon_sym_LT_LT] = ACTIONS(2499),
    [anon_sym_LBRACE] = ACTIONS(2501),
    [anon_sym_AMP_AMP] = ACTIONS(2499),
    [anon_sym_LT_EQ] = ACTIONS(2499),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_RBRACK] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2501),
    [anon_sym_QMARK] = ACTIONS(2499),
    [anon_sym_PIPE_PIPE] = ACTIONS(2499),
    [anon_sym_EQ_EQ] = ACTIONS(2501),
    [anon_sym_RPAREN] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2499),
    [anon_sym_PLUS] = ACTIONS(2501),
    [anon_sym_implements] = ACTIONS(2499),
    [anon_sym_GT_GT] = ACTIONS(2501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2499),
  },
  [1458] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2499),
    [anon_sym_BQUOTE] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_COMMA] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2501),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_GT_GT_GT] = ACTIONS(2499),
    [anon_sym_BANG_EQ] = ACTIONS(2501),
    [anon_sym_GT_EQ] = ACTIONS(2499),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [anon_sym_PERCENT] = ACTIONS(2499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2499),
    [anon_sym_as] = ACTIONS(2499),
    [anon_sym_DASH_DASH] = ACTIONS(2499),
    [anon_sym_instanceof] = ACTIONS(2499),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_DOT] = ACTIONS(2499),
    [anon_sym_STAR_STAR] = ACTIONS(2499),
    [anon_sym_PLUS_PLUS] = ACTIONS(2499),
    [anon_sym_in] = ACTIONS(2501),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_LBRACK] = ACTIONS(2499),
    [anon_sym_LT_LT] = ACTIONS(2499),
    [anon_sym_LBRACE] = ACTIONS(2501),
    [anon_sym_AMP_AMP] = ACTIONS(2499),
    [anon_sym_LT_EQ] = ACTIONS(2499),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_RBRACK] = ACTIONS(2499),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_AMP] = ACTIONS(2501),
    [anon_sym_QMARK] = ACTIONS(2499),
    [anon_sym_PIPE_PIPE] = ACTIONS(2499),
    [anon_sym_EQ_EQ] = ACTIONS(2501),
    [anon_sym_RPAREN] = ACTIONS(2499),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2499),
    [anon_sym_PLUS] = ACTIONS(2501),
    [anon_sym_implements] = ACTIONS(2499),
    [anon_sym_GT_GT] = ACTIONS(2501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2499),
  },
  [1459] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2503),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1460] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1461] = {
    [sym_await_expression] = STATE(1883),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(1883),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(1883),
    [sym_function_type] = STATE(627),
    [sym__expression] = STATE(1883),
    [sym_jsx_element] = STATE(1883),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1883),
    [sym_call_expression] = STATE(1883),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(1883),
    [sym_template_string] = STATE(1883),
    [sym_yield_expression] = STATE(1883),
    [sym_jsx_fragment] = STATE(1883),
    [sym_new_expression] = STATE(1883),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(1883),
    [sym_binary_expression] = STATE(1883),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(627),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1883),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1883),
    [sym_jsx_self_closing_element] = STATE(1883),
    [sym_arrow_function] = STATE(1883),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(627),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(627),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_spread_element] = STATE(1884),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1749),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1883),
    [sym_constructor_type] = STATE(627),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(1883),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(1883),
    [sym_regex] = STATE(1883),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(1885),
    [sym_non_null_expression] = STATE(1883),
    [sym_class] = STATE(1883),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(2526),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(2532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [sym_null] = ACTIONS(4558),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2538),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4558),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1462] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1463] = {
    [sym_await_expression] = STATE(1322),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_ternary_expression] = STATE(1322),
    [sym_template_string] = STATE(1322),
    [sym_yield_expression] = STATE(1322),
    [sym_jsx_fragment] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1322),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1322),
    [sym_class] = STATE(1322),
    [sym_identifier] = ACTIONS(4560),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1464] = {
    [sym_class] = STATE(1321),
    [sym_arrow_function] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_jsx_element] = STATE(1321),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1321),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_regex] = STATE(1321),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1321),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1321),
    [sym_internal_module] = STATE(1321),
    [sym_jsx_self_closing_element] = STATE(1321),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4562),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4562),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4562),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4564),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1465] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1466] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1467] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(848),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [sym_identifier] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4568),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(4570),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(4568),
    [anon_sym_static] = ACTIONS(4568),
    [anon_sym_get] = ACTIONS(4568),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(4572),
    [anon_sym_protected] = ACTIONS(4568),
    [anon_sym_DOT] = ACTIONS(4574),
    [anon_sym_set] = ACTIONS(4568),
    [anon_sym_type] = ACTIONS(4568),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(4576),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4572),
    [anon_sym_module] = ACTIONS(4568),
    [anon_sym_number] = ACTIONS(4568),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4568),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [anon_sym_any] = ACTIONS(4568),
    [anon_sym_boolean] = ACTIONS(4568),
    [anon_sym_async] = ACTIONS(4578),
    [anon_sym_public] = ACTIONS(4568),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4580),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4568),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [1468] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
  },
  [1469] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(2603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2603),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1470] = {
    [sym_identifier] = ACTIONS(2611),
    [sym_jsx_identifier] = ACTIONS(4582),
    [anon_sym_GT] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4582),
  },
  [1471] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2624),
    [anon_sym_BQUOTE] = ACTIONS(2624),
    [anon_sym_PIPE] = ACTIONS(2626),
    [anon_sym_COMMA] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_GT_GT_GT] = ACTIONS(2624),
    [anon_sym_BANG_EQ] = ACTIONS(2626),
    [anon_sym_GT_EQ] = ACTIONS(2624),
    [anon_sym_RBRACE] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2624),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2624),
    [anon_sym_as] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2624),
    [anon_sym_instanceof] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_STAR_STAR] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_LT_LT] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_LT_EQ] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_RBRACK] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_EQ_EQ] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_implements] = ACTIONS(2624),
    [anon_sym_GT_GT] = ACTIONS(2626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2624),
  },
  [1472] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(2628),
    [anon_sym_PIPE] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_GT_GT_GT] = ACTIONS(2628),
    [anon_sym_BANG_EQ] = ACTIONS(2630),
    [anon_sym_GT_EQ] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(2628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2628),
    [anon_sym_as] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2628),
    [anon_sym_instanceof] = ACTIONS(2628),
    [anon_sym_COLON] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_STAR_STAR] = ACTIONS(2628),
    [anon_sym_PLUS_PLUS] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_LT_EQ] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_RBRACK] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_EQ_EQ] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_implements] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2628),
  },
  [1473] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1474] = {
    [sym__automatic_semicolon] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2632),
  },
  [1475] = {
    [sym__automatic_semicolon] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_EQ] = ACTIONS(2634),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2634),
  },
  [1476] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1477] = {
    [sym__automatic_semicolon] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
  },
  [1478] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2115),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [anon_sym_PIPE] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2123),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_GT_GT_GT] = ACTIONS(2115),
    [anon_sym_BANG_EQ] = ACTIONS(2123),
    [anon_sym_GT_EQ] = ACTIONS(2115),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_PERCENT] = ACTIONS(2115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2115),
    [anon_sym_as] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2115),
    [anon_sym_instanceof] = ACTIONS(2115),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym_DOT] = ACTIONS(2115),
    [anon_sym_STAR_STAR] = ACTIONS(2115),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_in] = ACTIONS(2123),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_AMP_AMP] = ACTIONS(2115),
    [anon_sym_LT_EQ] = ACTIONS(2115),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_RBRACK] = ACTIONS(2115),
    [anon_sym_GT] = ACTIONS(2123),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(2115),
    [anon_sym_PIPE_PIPE] = ACTIONS(2115),
    [anon_sym_EQ_EQ] = ACTIONS(2123),
    [anon_sym_RPAREN] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2123),
    [anon_sym_SLASH] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2123),
    [anon_sym_implements] = ACTIONS(2115),
    [anon_sym_GT_GT] = ACTIONS(2123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2115),
  },
  [1479] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(2672),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1480] = {
    [sym__automatic_semicolon] = ACTIONS(2678),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_COMMA] = ACTIONS(2678),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2678),
    [sym_comment] = ACTIONS(3),
  },
  [1481] = {
    [sym__automatic_semicolon] = ACTIONS(2686),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_COMMA] = ACTIONS(2686),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2686),
    [sym_comment] = ACTIONS(3),
  },
  [1482] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2693),
    [anon_sym_BQUOTE] = ACTIONS(2693),
    [anon_sym_PERCENT_EQ] = ACTIONS(2693),
    [anon_sym_AMP_EQ] = ACTIONS(2693),
    [anon_sym_PLUS_EQ] = ACTIONS(2693),
    [anon_sym_PIPE] = ACTIONS(2695),
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_GT_GT_GT] = ACTIONS(2695),
    [anon_sym_EQ] = ACTIONS(2695),
    [anon_sym_BANG_EQ] = ACTIONS(2695),
    [anon_sym_GT_EQ] = ACTIONS(2693),
    [anon_sym_CARET_EQ] = ACTIONS(2693),
    [anon_sym_PIPE_EQ] = ACTIONS(2693),
    [anon_sym_DASH_EQ] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2693),
    [anon_sym_PERCENT] = ACTIONS(2695),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2693),
    [anon_sym_LT_LT_EQ] = ACTIONS(2693),
    [anon_sym_as] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_instanceof] = ACTIONS(2693),
    [anon_sym_COLON] = ACTIONS(2693),
    [anon_sym_GT_GT_EQ] = ACTIONS(2693),
    [anon_sym_DOT] = ACTIONS(2693),
    [anon_sym_STAR_STAR] = ACTIONS(2695),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2693),
    [anon_sym_LT_LT] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_of] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(2693),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_RBRACK] = ACTIONS(2693),
    [anon_sym_GT] = ACTIONS(2695),
    [anon_sym_STAR_EQ] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_QMARK] = ACTIONS(2693),
    [anon_sym_PIPE_PIPE] = ACTIONS(2693),
    [anon_sym_EQ_EQ] = ACTIONS(2695),
    [anon_sym_RPAREN] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(2695),
    [anon_sym_SLASH] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2693),
    [anon_sym_CARET] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_implements] = ACTIONS(2693),
    [anon_sym_GT_GT] = ACTIONS(2695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2693),
  },
  [1483] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1547),
    [sym_function_type] = STATE(1547),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1547),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1547),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1547),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1484] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [sym__automatic_semicolon] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_BQUOTE] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_COMMA] = ACTIONS(2699),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_GT_GT_GT] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_BANG_EQ] = ACTIONS(2701),
    [anon_sym_LT_EQ] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2699),
    [anon_sym_GT_EQ] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2699),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_as] = ACTIONS(2699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_EQ_EQ] = ACTIONS(2701),
    [anon_sym_instanceof] = ACTIONS(2699),
    [anon_sym_LT] = ACTIONS(2701),
    [anon_sym_SLASH] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2699),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_STAR_STAR] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_GT_GT] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_in] = ACTIONS(2701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
  },
  [1485] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [sym__automatic_semicolon] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_BQUOTE] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2705),
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_LT_LT] = ACTIONS(2703),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_GT_GT_GT] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2705),
    [anon_sym_LT_EQ] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_GT_EQ] = ACTIONS(2703),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_PERCENT] = ACTIONS(2703),
    [anon_sym_QMARK] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_as] = ACTIONS(2703),
    [anon_sym_PIPE_PIPE] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_instanceof] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_SLASH] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2703),
    [anon_sym_CARET] = ACTIONS(2703),
    [anon_sym_STAR_STAR] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_GT_GT] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_in] = ACTIONS(2705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2705),
  },
  [1486] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [sym__automatic_semicolon] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_STAR] = ACTIONS(2723),
    [anon_sym_GT_GT_GT] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [anon_sym_QMARK] = ACTIONS(2721),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_as] = ACTIONS(2721),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2723),
    [anon_sym_instanceof] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2723),
    [anon_sym_SLASH] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2723),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_in] = ACTIONS(2723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2723),
  },
  [1487] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [sym__automatic_semicolon] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2775),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2777),
    [anon_sym_LT_EQ] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_GT_EQ] = ACTIONS(2775),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_as] = ACTIONS(2775),
    [anon_sym_PIPE_PIPE] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_instanceof] = ACTIONS(2775),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2775),
    [anon_sym_CARET] = ACTIONS(2775),
    [anon_sym_STAR_STAR] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_in] = ACTIONS(2777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2777),
  },
  [1488] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [sym__automatic_semicolon] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(2779),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_LT_LT] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_GT_GT_GT] = ACTIONS(2779),
    [anon_sym_AMP_AMP] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2781),
    [anon_sym_BANG_EQ] = ACTIONS(2781),
    [anon_sym_LT_EQ] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_GT_EQ] = ACTIONS(2779),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PERCENT] = ACTIONS(2779),
    [anon_sym_QMARK] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_as] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2779),
    [anon_sym_EQ_EQ] = ACTIONS(2781),
    [anon_sym_instanceof] = ACTIONS(2779),
    [anon_sym_LT] = ACTIONS(2781),
    [anon_sym_SLASH] = ACTIONS(2781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4586),
    [anon_sym_CARET] = ACTIONS(2779),
    [anon_sym_STAR_STAR] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2781),
    [anon_sym_GT_GT] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2779),
    [anon_sym_in] = ACTIONS(2781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2779),
    [anon_sym_BANG] = ACTIONS(2781),
  },
  [1489] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2785),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [sym__automatic_semicolon] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_LT_LT] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_GT_GT_GT] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_LT_EQ] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_GT_EQ] = ACTIONS(2785),
    [anon_sym_GT] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_QMARK] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_as] = ACTIONS(2785),
    [anon_sym_PIPE_PIPE] = ACTIONS(2785),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_instanceof] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2787),
    [anon_sym_SLASH] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_CARET] = ACTIONS(2785),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_GT_GT] = ACTIONS(2787),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2787),
  },
  [1490] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [sym__automatic_semicolon] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_BQUOTE] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_LT_LT] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_GT_GT_GT] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_LT_EQ] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_GT_EQ] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_EQ_EQ] = ACTIONS(2791),
    [anon_sym_instanceof] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_SLASH] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4517),
    [anon_sym_CARET] = ACTIONS(2789),
    [anon_sym_STAR_STAR] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2791),
  },
  [1491] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [sym__automatic_semicolon] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [anon_sym_PIPE] = ACTIONS(2797),
    [anon_sym_COMMA] = ACTIONS(2795),
    [anon_sym_LT_LT] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_GT_GT_GT] = ACTIONS(2795),
    [anon_sym_AMP_AMP] = ACTIONS(2795),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_BANG_EQ] = ACTIONS(2797),
    [anon_sym_LT_EQ] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_GT_EQ] = ACTIONS(2795),
    [anon_sym_GT] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_PERCENT] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_as] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2795),
    [anon_sym_EQ_EQ] = ACTIONS(2797),
    [anon_sym_instanceof] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_CARET] = ACTIONS(2795),
    [anon_sym_STAR_STAR] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_GT_GT] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2795),
    [anon_sym_in] = ACTIONS(2797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2797),
  },
  [1492] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2814),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [sym__automatic_semicolon] = ACTIONS(2814),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_LT_LT] = ACTIONS(2814),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_GT_GT_GT] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG_EQ] = ACTIONS(2816),
    [anon_sym_LT_EQ] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_EQ] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
    [anon_sym_PERCENT] = ACTIONS(2814),
    [anon_sym_QMARK] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_as] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_EQ_EQ] = ACTIONS(2816),
    [anon_sym_instanceof] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2816),
    [anon_sym_SLASH] = ACTIONS(2816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2814),
    [anon_sym_CARET] = ACTIONS(2814),
    [anon_sym_STAR_STAR] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_in] = ACTIONS(2816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2814),
    [anon_sym_BANG] = ACTIONS(2816),
  },
  [1493] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1553),
    [sym_function_type] = STATE(1553),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1553),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1553),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1553),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1494] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [sym__automatic_semicolon] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [anon_sym_PIPE] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(2820),
    [anon_sym_LT_LT] = ACTIONS(2820),
    [anon_sym_STAR] = ACTIONS(2822),
    [anon_sym_GT_GT_GT] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_BANG_EQ] = ACTIONS(2822),
    [anon_sym_LT_EQ] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2820),
    [anon_sym_GT_EQ] = ACTIONS(2820),
    [anon_sym_GT] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_PERCENT] = ACTIONS(2820),
    [anon_sym_QMARK] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_as] = ACTIONS(2820),
    [anon_sym_PIPE_PIPE] = ACTIONS(2820),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [anon_sym_EQ_EQ] = ACTIONS(2822),
    [anon_sym_instanceof] = ACTIONS(2820),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2820),
    [anon_sym_CARET] = ACTIONS(2820),
    [anon_sym_STAR_STAR] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_GT_GT] = ACTIONS(2822),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_in] = ACTIONS(2822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2822),
  },
  [1495] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [sym__automatic_semicolon] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_GT_GT_GT] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_BANG_EQ] = ACTIONS(2826),
    [anon_sym_LT_EQ] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2824),
    [anon_sym_QMARK] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_as] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2826),
    [anon_sym_instanceof] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2824),
    [anon_sym_CARET] = ACTIONS(2824),
    [anon_sym_STAR_STAR] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_in] = ACTIONS(2826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2826),
  },
  [1496] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1555),
    [sym_function_type] = STATE(1555),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1555),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1555),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1555),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1497] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1556),
    [sym_function_type] = STATE(1556),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1556),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1556),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1556),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1498] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_PIPE] = ACTIONS(2836),
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_GT_GT_GT] = ACTIONS(2834),
    [anon_sym_BANG_EQ] = ACTIONS(2836),
    [anon_sym_GT_EQ] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_PERCENT] = ACTIONS(2834),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2834),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_COLON] = ACTIONS(2834),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_STAR_STAR] = ACTIONS(2834),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_LT_LT] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2834),
    [anon_sym_LT_EQ] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_RBRACK] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_PIPE_PIPE] = ACTIONS(2834),
    [anon_sym_EQ_EQ] = ACTIONS(2836),
    [anon_sym_RPAREN] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2836),
    [anon_sym_SLASH] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2834),
    [anon_sym_GT_GT] = ACTIONS(2836),
    [anon_sym_implements] = ACTIONS(2834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2834),
  },
  [1499] = {
    [sym__automatic_semicolon] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_COMMA] = ACTIONS(2842),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
  },
  [1500] = {
    [sym__automatic_semicolon] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_COMMA] = ACTIONS(2846),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
  },
  [1501] = {
    [sym__automatic_semicolon] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
  },
  [1502] = {
    [sym__automatic_semicolon] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_COMMA] = ACTIONS(2858),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
  },
  [1503] = {
    [anon_sym_BQUOTE] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2902),
    [anon_sym_PIPE] = ACTIONS(2900),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_yield] = ACTIONS(2902),
    [sym_true] = ACTIONS(2902),
    [anon_sym_protected] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_set] = ACTIONS(2902),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2902),
    [anon_sym_typeof] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_RBRACK] = ACTIONS(2900),
    [sym_null] = ACTIONS(2902),
    [anon_sym_any] = ACTIONS(2902),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_public] = ACTIONS(2902),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_RPAREN] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_export] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_debugger] = ACTIONS(2902),
    [anon_sym_AT] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2902),
    [anon_sym_void] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [anon_sym_private] = ACTIONS(2902),
    [anon_sym_get] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [sym_this] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_abstract] = ACTIONS(2902),
    [anon_sym_type] = ACTIONS(2902),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [sym_false] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_module] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_declare] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2900),
    [sym_number] = ACTIONS(2900),
    [ts_builtin_sym_end] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2902),
    [sym_undefined] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_await] = ACTIONS(2902),
  },
  [1504] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2970),
    [anon_sym_BQUOTE] = ACTIONS(2970),
    [anon_sym_PIPE] = ACTIONS(2972),
    [anon_sym_COMMA] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_GT_GT_GT] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2970),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_instanceof] = ACTIONS(2970),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_STAR_STAR] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(2972),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LT_LT] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_of] = ACTIONS(2970),
    [anon_sym_LT_EQ] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RBRACK] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_EQ_EQ] = ACTIONS(2972),
    [anon_sym_RPAREN] = ACTIONS(2970),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_implements] = ACTIONS(2970),
    [anon_sym_GT_GT] = ACTIONS(2972),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2970),
  },
  [1505] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2992),
    [sym__automatic_semicolon] = ACTIONS(2994),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_GT_GT_GT] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(3000),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_instanceof] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_STAR_STAR] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_else] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2992),
  },
  [1506] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3002),
    [sym__automatic_semicolon] = ACTIONS(3004),
    [anon_sym_BQUOTE] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_GT_GT_GT] = ACTIONS(3002),
    [anon_sym_BANG_EQ] = ACTIONS(3010),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [anon_sym_as] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_instanceof] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_else] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_GT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_EQ_EQ] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_GT_GT] = ACTIONS(3010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
  },
  [1507] = {
    [sym_string] = STATE(975),
    [sym__property_name] = STATE(975),
    [sym_computed_property_name] = STATE(975),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1508] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3052),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_GT_GT_GT] = ACTIONS(3052),
    [anon_sym_BANG_EQ] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3052),
    [anon_sym_as] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_instanceof] = ACTIONS(3052),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_DOT] = ACTIONS(3052),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_RBRACK] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_EQ_EQ] = ACTIONS(3054),
    [anon_sym_RPAREN] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_implements] = ACTIONS(3052),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3052),
  },
  [1509] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3115),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_GT_GT_GT] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3115),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3115),
    [anon_sym_as] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3115),
    [anon_sym_instanceof] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_STAR_STAR] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3115),
    [anon_sym_in] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_LT_EQ] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_EQ_EQ] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_SLASH] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_implements] = ACTIONS(3115),
    [anon_sym_GT_GT] = ACTIONS(3117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3115),
  },
  [1510] = {
    [sym__automatic_semicolon] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
  },
  [1511] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3132),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [anon_sym_PIPE] = ACTIONS(3134),
    [anon_sym_COMMA] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_GT_GT_GT] = ACTIONS(3132),
    [anon_sym_EQ] = ACTIONS(3134),
    [anon_sym_BANG_EQ] = ACTIONS(3134),
    [anon_sym_GT_EQ] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3132),
    [anon_sym_as] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_instanceof] = ACTIONS(3132),
    [anon_sym_COLON] = ACTIONS(3132),
    [anon_sym_DOT] = ACTIONS(3132),
    [anon_sym_STAR_STAR] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_in] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_LT_LT] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3132),
    [anon_sym_of] = ACTIONS(3132),
    [anon_sym_LT_EQ] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_RBRACK] = ACTIONS(3132),
    [anon_sym_GT] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_PIPE_PIPE] = ACTIONS(3132),
    [anon_sym_EQ_EQ] = ACTIONS(3134),
    [anon_sym_RPAREN] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_implements] = ACTIONS(3132),
    [anon_sym_GT_GT] = ACTIONS(3134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3132),
  },
  [1512] = {
    [anon_sym_EQ] = ACTIONS(2059),
    [anon_sym_COLON] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(3153),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [sym_comment] = ACTIONS(3),
  },
  [1513] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3155),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [anon_sym_PIPE] = ACTIONS(3157),
    [anon_sym_COMMA] = ACTIONS(3155),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_GT_GT_GT] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(3157),
    [anon_sym_BANG_EQ] = ACTIONS(3157),
    [anon_sym_GT_EQ] = ACTIONS(3155),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_PERCENT] = ACTIONS(3155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3155),
    [anon_sym_as] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3155),
    [anon_sym_instanceof] = ACTIONS(3155),
    [anon_sym_COLON] = ACTIONS(3155),
    [anon_sym_DOT] = ACTIONS(3155),
    [anon_sym_STAR_STAR] = ACTIONS(3155),
    [anon_sym_PLUS_PLUS] = ACTIONS(3155),
    [anon_sym_in] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [anon_sym_LT_LT] = ACTIONS(3155),
    [anon_sym_LBRACE] = ACTIONS(3157),
    [anon_sym_AMP_AMP] = ACTIONS(3155),
    [anon_sym_of] = ACTIONS(3155),
    [anon_sym_LT_EQ] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_RBRACK] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3157),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_QMARK] = ACTIONS(3155),
    [anon_sym_PIPE_PIPE] = ACTIONS(3155),
    [anon_sym_EQ_EQ] = ACTIONS(3157),
    [anon_sym_RPAREN] = ACTIONS(3155),
    [anon_sym_LT] = ACTIONS(3157),
    [anon_sym_SLASH] = ACTIONS(3157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_implements] = ACTIONS(3155),
    [anon_sym_GT_GT] = ACTIONS(3157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3155),
  },
  [1514] = {
    [sym__automatic_semicolon] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [sym_identifier] = ACTIONS(4588),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_module] = ACTIONS(4588),
    [anon_sym_symbol] = ACTIONS(4588),
    [anon_sym_number] = ACTIONS(4588),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_declare] = ACTIONS(4588),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_void] = ACTIONS(4588),
    [anon_sym_any] = ACTIONS(4588),
    [anon_sym_private] = ACTIONS(4588),
    [anon_sym_boolean] = ACTIONS(4588),
    [anon_sym_async] = ACTIONS(4588),
    [anon_sym_public] = ACTIONS(4588),
    [anon_sym_get] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(4588),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4588),
    [anon_sym_string] = ACTIONS(4588),
    [anon_sym_abstract] = ACTIONS(4588),
    [anon_sym_set] = ACTIONS(4588),
    [anon_sym_type] = ACTIONS(4588),
    [anon_sym_export] = ACTIONS(4588),
    [anon_sym_namespace] = ACTIONS(4588),
    [sym_readonly] = ACTIONS(4588),
    [anon_sym_DQUOTE] = ACTIONS(3166),
  },
  [1515] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3168),
    [sym__automatic_semicolon] = ACTIONS(3168),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_GT_GT_GT] = ACTIONS(3168),
    [anon_sym_BANG_EQ] = ACTIONS(3170),
    [anon_sym_GT_EQ] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_PERCENT] = ACTIONS(3168),
    [anon_sym_as] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_instanceof] = ACTIONS(3168),
    [anon_sym_DOT] = ACTIONS(3168),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3168),
    [anon_sym_STAR_STAR] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_in] = ACTIONS(3170),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3168),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_EQ_EQ] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
  },
  [1516] = {
    [anon_sym_COLON] = ACTIONS(3193),
    [sym__automatic_semicolon] = ACTIONS(3193),
    [anon_sym_RBRACE] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3193),
  },
  [1517] = {
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [anon_sym_debugger] = ACTIONS(3212),
    [anon_sym_symbol] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_const] = ACTIONS(3212),
    [sym_super] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_private] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3212),
    [sym_this] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(3212),
    [sym_true] = ACTIONS(3212),
    [anon_sym_throw] = ACTIONS(3212),
    [anon_sym_protected] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [sym_false] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_number] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_declare] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [sym_null] = ACTIONS(3212),
    [anon_sym_any] = ACTIONS(3212),
    [anon_sym_boolean] = ACTIONS(3212),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_public] = ACTIONS(3212),
    [anon_sym_var] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3210),
    [sym_number] = ACTIONS(3210),
    [anon_sym_SLASH] = ACTIONS(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3212),
    [anon_sym_function] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_export] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3210),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3212),
  },
  [1518] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3224),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [anon_sym_PIPE] = ACTIONS(3226),
    [anon_sym_COMMA] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_GT_GT_GT] = ACTIONS(3224),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_GT_EQ] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_PERCENT] = ACTIONS(3224),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3224),
    [anon_sym_as] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_instanceof] = ACTIONS(3224),
    [anon_sym_COLON] = ACTIONS(3224),
    [anon_sym_DOT] = ACTIONS(3224),
    [anon_sym_STAR_STAR] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_LT_EQ] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_RBRACK] = ACTIONS(3224),
    [anon_sym_GT] = ACTIONS(3226),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_QMARK] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3224),
    [anon_sym_EQ_EQ] = ACTIONS(3226),
    [anon_sym_RPAREN] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_implements] = ACTIONS(3224),
    [anon_sym_GT_GT] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3224),
  },
  [1519] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(3224),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(3224),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1520] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3228),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [anon_sym_PIPE] = ACTIONS(3230),
    [anon_sym_COMMA] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3230),
    [anon_sym_GT_GT_GT] = ACTIONS(3228),
    [anon_sym_BANG_EQ] = ACTIONS(3230),
    [anon_sym_GT_EQ] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_PERCENT] = ACTIONS(3228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3228),
    [anon_sym_as] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_instanceof] = ACTIONS(3228),
    [anon_sym_COLON] = ACTIONS(3228),
    [anon_sym_DOT] = ACTIONS(3228),
    [anon_sym_STAR_STAR] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_in] = ACTIONS(3230),
    [anon_sym_BANG] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_LT_EQ] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_RBRACK] = ACTIONS(3228),
    [anon_sym_GT] = ACTIONS(3230),
    [anon_sym_AMP] = ACTIONS(3230),
    [anon_sym_QMARK] = ACTIONS(3228),
    [anon_sym_PIPE_PIPE] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_RPAREN] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_implements] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3230),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3228),
  },
  [1521] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(3228),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(3228),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1522] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_COMMA] = ACTIONS(3234),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_GT_GT_GT] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3236),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_PERCENT] = ACTIONS(3234),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3234),
    [anon_sym_as] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_instanceof] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(3234),
    [anon_sym_DOT] = ACTIONS(3234),
    [anon_sym_STAR_STAR] = ACTIONS(3234),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LT_LT] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_RBRACK] = ACTIONS(3234),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_QMARK] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_EQ_EQ] = ACTIONS(3236),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_implements] = ACTIONS(3234),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3234),
  },
  [1523] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3238),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_GT_EQ] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_PERCENT] = ACTIONS(3238),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3238),
    [anon_sym_as] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_instanceof] = ACTIONS(3238),
    [anon_sym_COLON] = ACTIONS(3238),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_STAR_STAR] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_LT_EQ] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_RBRACK] = ACTIONS(3238),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_RPAREN] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_implements] = ACTIONS(3238),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3238),
  },
  [1524] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(3238),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(3238),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1525] = {
    [sym__automatic_semicolon] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym_COMMA] = ACTIONS(3244),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3244),
    [sym_comment] = ACTIONS(3),
  },
  [1526] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3283),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_instanceof] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_in] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_RBRACK] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_EQ_EQ] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_implements] = ACTIONS(3283),
    [anon_sym_GT_GT] = ACTIONS(3285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3283),
  },
  [1527] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3321),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [anon_sym_PIPE] = ACTIONS(3323),
    [anon_sym_COMMA] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_GT_GT_GT] = ACTIONS(3321),
    [anon_sym_BANG_EQ] = ACTIONS(3323),
    [anon_sym_GT_EQ] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_PERCENT] = ACTIONS(3321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3321),
    [anon_sym_as] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [anon_sym_instanceof] = ACTIONS(3321),
    [anon_sym_COLON] = ACTIONS(3321),
    [anon_sym_DOT] = ACTIONS(3321),
    [anon_sym_STAR_STAR] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_in] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LT_LT] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_AMP_AMP] = ACTIONS(3321),
    [anon_sym_LT_EQ] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_RBRACK] = ACTIONS(3321),
    [anon_sym_GT] = ACTIONS(3323),
    [anon_sym_AMP] = ACTIONS(3323),
    [anon_sym_QMARK] = ACTIONS(3321),
    [anon_sym_PIPE_PIPE] = ACTIONS(3321),
    [anon_sym_EQ_EQ] = ACTIONS(3323),
    [anon_sym_RPAREN] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_implements] = ACTIONS(3321),
    [anon_sym_GT_GT] = ACTIONS(3323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3321),
  },
  [1528] = {
    [sym__automatic_semicolon] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_COMMA] = ACTIONS(3327),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
  },
  [1529] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3329),
    [sym__automatic_semicolon] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [anon_sym_PIPE] = ACTIONS(3337),
    [anon_sym_COMMA] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_GT_GT_GT] = ACTIONS(3329),
    [anon_sym_BANG_EQ] = ACTIONS(3337),
    [anon_sym_GT_EQ] = ACTIONS(3329),
    [anon_sym_PERCENT] = ACTIONS(3329),
    [anon_sym_as] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_instanceof] = ACTIONS(3329),
    [anon_sym_DOT] = ACTIONS(3329),
    [anon_sym_STAR_STAR] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_in] = ACTIONS(3337),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_LT_LT] = ACTIONS(3329),
    [anon_sym_AMP_AMP] = ACTIONS(3329),
    [anon_sym_LT_EQ] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_GT] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(3329),
    [anon_sym_PIPE_PIPE] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_EQ_EQ] = ACTIONS(3337),
    [anon_sym_LT] = ACTIONS(3337),
    [anon_sym_SLASH] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_GT_GT] = ACTIONS(3337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3329),
  },
  [1530] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3339),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [anon_sym_PIPE] = ACTIONS(3341),
    [anon_sym_COMMA] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_STAR] = ACTIONS(3341),
    [anon_sym_GT_GT_GT] = ACTIONS(3339),
    [anon_sym_BANG_EQ] = ACTIONS(3341),
    [anon_sym_GT_EQ] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_PERCENT] = ACTIONS(3339),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3339),
    [anon_sym_as] = ACTIONS(3339),
    [anon_sym_DASH_DASH] = ACTIONS(3339),
    [anon_sym_instanceof] = ACTIONS(3339),
    [anon_sym_COLON] = ACTIONS(3339),
    [anon_sym_DOT] = ACTIONS(3339),
    [anon_sym_STAR_STAR] = ACTIONS(3339),
    [anon_sym_PLUS_PLUS] = ACTIONS(3339),
    [anon_sym_in] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3339),
    [anon_sym_LT_LT] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3341),
    [anon_sym_AMP_AMP] = ACTIONS(3339),
    [anon_sym_LT_EQ] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3339),
    [anon_sym_RBRACK] = ACTIONS(3339),
    [anon_sym_GT] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3341),
    [anon_sym_QMARK] = ACTIONS(3339),
    [anon_sym_PIPE_PIPE] = ACTIONS(3339),
    [anon_sym_EQ_EQ] = ACTIONS(3341),
    [anon_sym_RPAREN] = ACTIONS(3339),
    [anon_sym_LT] = ACTIONS(3341),
    [anon_sym_SLASH] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3341),
    [anon_sym_implements] = ACTIONS(3339),
    [anon_sym_GT_GT] = ACTIONS(3341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3339),
  },
  [1531] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BQUOTE] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1879),
    [anon_sym_STAR] = ACTIONS(1879),
    [anon_sym_GT_GT_GT] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_PERCENT] = ACTIONS(1877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1877),
    [anon_sym_as] = ACTIONS(1877),
    [anon_sym_DASH_DASH] = ACTIONS(1877),
    [anon_sym_instanceof] = ACTIONS(1877),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_STAR_STAR] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1877),
    [anon_sym_in] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1879),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_RBRACK] = ACTIONS(1877),
    [anon_sym_GT] = ACTIONS(1879),
    [anon_sym_EQ_GT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_QMARK] = ACTIONS(1877),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_EQ_EQ] = ACTIONS(1879),
    [anon_sym_RPAREN] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1879),
    [anon_sym_implements] = ACTIONS(1877),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
  },
  [1532] = {
    [sym__automatic_semicolon] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_COMMA] = ACTIONS(3351),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3351),
    [sym_comment] = ACTIONS(3),
  },
  [1533] = {
    [sym__automatic_semicolon] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_COMMA] = ACTIONS(3363),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3363),
    [sym_comment] = ACTIONS(3),
  },
  [1534] = {
    [sym_class] = STATE(1586),
    [sym_arrow_function] = STATE(1586),
    [sym_await_expression] = STATE(1586),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1586),
    [sym_meta_property] = STATE(1586),
    [sym__expression] = STATE(1586),
    [sym_jsx_element] = STATE(1586),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1586),
    [sym_call_expression] = STATE(1586),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1586),
    [sym_string] = STATE(1586),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1586),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1586),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1586),
    [sym_generator_function] = STATE(1586),
    [sym_new_expression] = STATE(1586),
    [sym_assignment_expression] = STATE(1586),
    [sym_augmented_assignment_expression] = STATE(1586),
    [sym_binary_expression] = STATE(1586),
    [sym_unary_expression] = STATE(1586),
    [sym_regex] = STATE(1586),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1586),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1586),
    [sym_internal_module] = STATE(1586),
    [sym_jsx_self_closing_element] = STATE(1586),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4590),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4590),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4590),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4590),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4592),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4590),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1535] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4594),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1536] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1537] = {
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_COMMA] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(3449),
    [sym_jsx_identifier] = ACTIONS(4596),
    [anon_sym_GT] = ACTIONS(4596),
    [anon_sym_SLASH] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4596),
  },
  [1539] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3453),
    [sym__automatic_semicolon] = ACTIONS(3455),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3453),
    [anon_sym_BANG_EQ] = ACTIONS(3461),
    [anon_sym_GT_EQ] = ACTIONS(3453),
    [anon_sym_PERCENT] = ACTIONS(3453),
    [anon_sym_as] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_instanceof] = ACTIONS(3453),
    [anon_sym_DOT] = ACTIONS(3453),
    [anon_sym_STAR_STAR] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_else] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_LT_LT] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_LT_EQ] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_PIPE_PIPE] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3457),
    [anon_sym_EQ_EQ] = ACTIONS(3461),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3453),
  },
  [1540] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3463),
    [anon_sym_BQUOTE] = ACTIONS(3463),
    [anon_sym_PIPE] = ACTIONS(3465),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3465),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_GT_GT_GT] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3465),
    [anon_sym_GT_EQ] = ACTIONS(3463),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3463),
    [anon_sym_as] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3463),
    [anon_sym_instanceof] = ACTIONS(3463),
    [anon_sym_COLON] = ACTIONS(3463),
    [anon_sym_DOT] = ACTIONS(3463),
    [anon_sym_STAR_STAR] = ACTIONS(3463),
    [anon_sym_PLUS_PLUS] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LT_LT] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_LT_EQ] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_RBRACK] = ACTIONS(3463),
    [anon_sym_GT] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3465),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3465),
    [anon_sym_RPAREN] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_SLASH] = ACTIONS(3465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3465),
    [anon_sym_implements] = ACTIONS(3463),
    [anon_sym_GT_GT] = ACTIONS(3465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3463),
  },
  [1541] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3467),
    [anon_sym_BQUOTE] = ACTIONS(3467),
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_COMMA] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_GT_GT_GT] = ACTIONS(3467),
    [anon_sym_BANG_EQ] = ACTIONS(3469),
    [anon_sym_GT_EQ] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3467),
    [anon_sym_PERCENT] = ACTIONS(3467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3467),
    [anon_sym_as] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3467),
    [anon_sym_instanceof] = ACTIONS(3467),
    [anon_sym_COLON] = ACTIONS(3467),
    [anon_sym_DOT] = ACTIONS(3467),
    [anon_sym_STAR_STAR] = ACTIONS(3467),
    [anon_sym_PLUS_PLUS] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_LT_LT] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3467),
    [anon_sym_LT_EQ] = ACTIONS(3467),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_RBRACK] = ACTIONS(3467),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [anon_sym_QMARK] = ACTIONS(3467),
    [anon_sym_PIPE_PIPE] = ACTIONS(3467),
    [anon_sym_EQ_EQ] = ACTIONS(3469),
    [anon_sym_RPAREN] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_SLASH] = ACTIONS(3469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_implements] = ACTIONS(3467),
    [anon_sym_GT_GT] = ACTIONS(3469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3467),
  },
  [1542] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(3000),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_GT_GT_GT] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(3000),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_instanceof] = ACTIONS(2992),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_STAR_STAR] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_in] = ACTIONS(3000),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(3000),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_EQ_EQ] = ACTIONS(3000),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(3000),
    [anon_sym_SLASH] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_implements] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(3000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2992),
  },
  [1543] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3002),
    [anon_sym_BQUOTE] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_GT_GT_GT] = ACTIONS(3002),
    [anon_sym_BANG_EQ] = ACTIONS(3010),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3002),
    [anon_sym_as] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_instanceof] = ACTIONS(3002),
    [anon_sym_COLON] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_RBRACK] = ACTIONS(3002),
    [anon_sym_GT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3010),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_implements] = ACTIONS(3002),
    [anon_sym_GT_GT] = ACTIONS(3010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
  },
  [1544] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3329),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [anon_sym_PIPE] = ACTIONS(3337),
    [anon_sym_COMMA] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(3337),
    [anon_sym_GT_GT_GT] = ACTIONS(3329),
    [anon_sym_BANG_EQ] = ACTIONS(3337),
    [anon_sym_GT_EQ] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_PERCENT] = ACTIONS(3329),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3329),
    [anon_sym_as] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_instanceof] = ACTIONS(3329),
    [anon_sym_COLON] = ACTIONS(3329),
    [anon_sym_DOT] = ACTIONS(3329),
    [anon_sym_STAR_STAR] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_in] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LT_LT] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3337),
    [anon_sym_AMP_AMP] = ACTIONS(3329),
    [anon_sym_LT_EQ] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_RBRACK] = ACTIONS(3329),
    [anon_sym_GT] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3337),
    [anon_sym_QMARK] = ACTIONS(3329),
    [anon_sym_PIPE_PIPE] = ACTIONS(3329),
    [anon_sym_EQ_EQ] = ACTIONS(3337),
    [anon_sym_RPAREN] = ACTIONS(3329),
    [anon_sym_LT] = ACTIONS(3337),
    [anon_sym_SLASH] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_implements] = ACTIONS(3329),
    [anon_sym_GT_GT] = ACTIONS(3337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3329),
  },
  [1545] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3453),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3453),
    [anon_sym_BANG_EQ] = ACTIONS(3461),
    [anon_sym_GT_EQ] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_PERCENT] = ACTIONS(3453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3453),
    [anon_sym_as] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_instanceof] = ACTIONS(3453),
    [anon_sym_COLON] = ACTIONS(3453),
    [anon_sym_DOT] = ACTIONS(3453),
    [anon_sym_STAR_STAR] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LT_LT] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3453),
    [anon_sym_LT_EQ] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_RBRACK] = ACTIONS(3453),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_PIPE_PIPE] = ACTIONS(3453),
    [anon_sym_EQ_EQ] = ACTIONS(3461),
    [anon_sym_RPAREN] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_implements] = ACTIONS(3453),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3453),
  },
  [1546] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [sym__automatic_semicolon] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_BQUOTE] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3473),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_LT_LT] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_GT_GT_GT] = ACTIONS(3471),
    [anon_sym_AMP_AMP] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_BANG_EQ] = ACTIONS(3473),
    [anon_sym_LT_EQ] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_GT_EQ] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3473),
    [anon_sym_PERCENT] = ACTIONS(3471),
    [anon_sym_QMARK] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_as] = ACTIONS(3471),
    [anon_sym_PIPE_PIPE] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3471),
    [anon_sym_EQ_EQ] = ACTIONS(3473),
    [anon_sym_instanceof] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3473),
    [anon_sym_SLASH] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4598),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_STAR_STAR] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_GT_GT] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3471),
    [anon_sym_BANG] = ACTIONS(3473),
  },
  [1547] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [sym__automatic_semicolon] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3475),
    [anon_sym_BQUOTE] = ACTIONS(3475),
    [anon_sym_PIPE] = ACTIONS(4601),
    [anon_sym_COMMA] = ACTIONS(3475),
    [anon_sym_LT_LT] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_GT_GT_GT] = ACTIONS(3475),
    [anon_sym_AMP_AMP] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(3477),
    [anon_sym_BANG_EQ] = ACTIONS(3477),
    [anon_sym_LT_EQ] = ACTIONS(3475),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_GT_EQ] = ACTIONS(3475),
    [anon_sym_GT] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(4603),
    [anon_sym_PERCENT] = ACTIONS(3475),
    [anon_sym_QMARK] = ACTIONS(3475),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_as] = ACTIONS(3475),
    [anon_sym_PIPE_PIPE] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3475),
    [anon_sym_EQ_EQ] = ACTIONS(3477),
    [anon_sym_instanceof] = ACTIONS(3475),
    [anon_sym_LT] = ACTIONS(3477),
    [anon_sym_SLASH] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3475),
    [anon_sym_CARET] = ACTIONS(3475),
    [anon_sym_STAR_STAR] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3477),
    [anon_sym_GT_GT] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3475),
    [anon_sym_BANG] = ACTIONS(3477),
  },
  [1548] = {
    [sym_string] = STATE(1079),
    [sym__property_name] = STATE(1079),
    [sym_computed_property_name] = STATE(1079),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1549] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [sym__automatic_semicolon] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3505),
    [anon_sym_LT_LT] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_GT_GT_GT] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_LT_EQ] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_GT_EQ] = ACTIONS(3505),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_as] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_EQ_EQ] = ACTIONS(3507),
    [anon_sym_instanceof] = ACTIONS(3505),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(3507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_CARET] = ACTIONS(3505),
    [anon_sym_STAR_STAR] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3505),
    [anon_sym_GT_GT] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3507),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3507),
  },
  [1550] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [sym__automatic_semicolon] = ACTIONS(3515),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_BQUOTE] = ACTIONS(3515),
    [anon_sym_PIPE] = ACTIONS(3517),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_LT_LT] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_GT_GT_GT] = ACTIONS(3515),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_BANG_EQ] = ACTIONS(3517),
    [anon_sym_LT_EQ] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_GT_EQ] = ACTIONS(3515),
    [anon_sym_GT] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_as] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_EQ_EQ] = ACTIONS(3517),
    [anon_sym_instanceof] = ACTIONS(3515),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_SLASH] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_CARET] = ACTIONS(3515),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_GT_GT] = ACTIONS(3517),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3517),
  },
  [1551] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1600),
    [sym_function_type] = STATE(1600),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1600),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1600),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1600),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1552] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [sym__automatic_semicolon] = ACTIONS(3523),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_GT_GT_GT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_BANG_EQ] = ACTIONS(3525),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3525),
    [anon_sym_instanceof] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_STAR_STAR] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3525),
  },
  [1553] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [sym__automatic_semicolon] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(4601),
    [anon_sym_COMMA] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(4603),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_instanceof] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_STAR_STAR] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3529),
  },
  [1554] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_EQ_EQ] = ACTIONS(3533),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_SLASH] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_GT_GT] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(3533),
  },
  [1555] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_BQUOTE] = ACTIONS(3537),
    [anon_sym_PIPE] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_LT_EQ] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_GT_EQ] = ACTIONS(3537),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_as] = ACTIONS(3537),
    [anon_sym_PIPE_PIPE] = ACTIONS(3537),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_EQ_EQ] = ACTIONS(3539),
    [anon_sym_instanceof] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3539),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3537),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_STAR_STAR] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3539),
  },
  [1556] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [sym__automatic_semicolon] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_BQUOTE] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_LT_LT] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_GT_GT_GT] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_LT_EQ] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3541),
    [anon_sym_GT_EQ] = ACTIONS(3541),
    [anon_sym_GT] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_as] = ACTIONS(3541),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_EQ_EQ] = ACTIONS(3543),
    [anon_sym_instanceof] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3543),
    [anon_sym_SLASH] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3541),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_STAR_STAR] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_GT_GT] = ACTIONS(3543),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_in] = ACTIONS(3543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3543),
  },
  [1557] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [sym__automatic_semicolon] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_BQUOTE] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_LT_LT] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_GT_GT_GT] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_LT_EQ] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_GT_EQ] = ACTIONS(3545),
    [anon_sym_GT] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3545),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_EQ_EQ] = ACTIONS(3547),
    [anon_sym_instanceof] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3547),
    [anon_sym_SLASH] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3545),
    [anon_sym_CARET] = ACTIONS(3545),
    [anon_sym_STAR_STAR] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_GT_GT] = ACTIONS(3547),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3547),
  },
  [1558] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1604),
    [sym_function_type] = STATE(1604),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1604),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1604),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1604),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1559] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3556),
    [anon_sym_BQUOTE] = ACTIONS(3556),
    [anon_sym_AT] = ACTIONS(3556),
    [anon_sym_PIPE] = ACTIONS(3558),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_DASH] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(3558),
    [anon_sym_GT_GT_GT] = ACTIONS(3556),
    [anon_sym_BANG_EQ] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_PERCENT] = ACTIONS(3556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3556),
    [anon_sym_as] = ACTIONS(3556),
    [anon_sym_DASH_DASH] = ACTIONS(3556),
    [anon_sym_instanceof] = ACTIONS(3556),
    [anon_sym_COLON] = ACTIONS(3556),
    [anon_sym_DOT] = ACTIONS(3556),
    [anon_sym_STAR_STAR] = ACTIONS(3556),
    [anon_sym_PLUS_PLUS] = ACTIONS(3556),
    [anon_sym_in] = ACTIONS(3558),
    [anon_sym_BANG] = ACTIONS(3558),
    [anon_sym_LBRACK] = ACTIONS(3556),
    [anon_sym_class] = ACTIONS(3556),
    [anon_sym_LT_LT] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3558),
    [anon_sym_AMP_AMP] = ACTIONS(3556),
    [anon_sym_LT_EQ] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3556),
    [anon_sym_RBRACK] = ACTIONS(3556),
    [anon_sym_GT] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(3558),
    [anon_sym_QMARK] = ACTIONS(3556),
    [anon_sym_PIPE_PIPE] = ACTIONS(3556),
    [anon_sym_EQ_EQ] = ACTIONS(3558),
    [anon_sym_RPAREN] = ACTIONS(3556),
    [anon_sym_LT] = ACTIONS(3558),
    [anon_sym_SLASH] = ACTIONS(3558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_export] = ACTIONS(3556),
    [anon_sym_GT_GT] = ACTIONS(3558),
    [anon_sym_implements] = ACTIONS(3556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3556),
  },
  [1560] = {
    [sym__automatic_semicolon] = ACTIONS(3562),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3562),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
  },
  [1561] = {
    [sym__automatic_semicolon] = ACTIONS(3570),
    [anon_sym_RBRACE] = ACTIONS(3570),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym_COMMA] = ACTIONS(3570),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3570),
    [sym_comment] = ACTIONS(3),
  },
  [1562] = {
    [sym__automatic_semicolon] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3582),
    [anon_sym_SEMI] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3582),
    [sym_comment] = ACTIONS(3),
  },
  [1563] = {
    [sym__automatic_semicolon] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(3586),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_COMMA] = ACTIONS(3586),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3586),
    [sym_comment] = ACTIONS(3),
  },
  [1564] = {
    [sym__automatic_semicolon] = ACTIONS(3590),
    [anon_sym_RBRACE] = ACTIONS(3590),
    [anon_sym_SEMI] = ACTIONS(3590),
    [anon_sym_COMMA] = ACTIONS(3590),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3590),
    [sym_comment] = ACTIONS(3),
  },
  [1565] = {
    [sym__automatic_semicolon] = ACTIONS(3596),
    [anon_sym_RBRACE] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3596),
    [sym_comment] = ACTIONS(3),
  },
  [1566] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [sym__automatic_semicolon] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(3667),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1567] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3681),
    [sym__automatic_semicolon] = ACTIONS(3683),
    [anon_sym_BQUOTE] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_STAR] = ACTIONS(3689),
    [anon_sym_GT_GT_GT] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_PERCENT] = ACTIONS(3681),
    [anon_sym_as] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_instanceof] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3681),
    [anon_sym_STAR_STAR] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3689),
    [anon_sym_else] = ACTIONS(3685),
    [anon_sym_BANG] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_LT_EQ] = ACTIONS(3681),
    [anon_sym_LPAREN] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_while] = ACTIONS(3685),
    [anon_sym_EQ_EQ] = ACTIONS(3689),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_SLASH] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_GT_GT] = ACTIONS(3689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3681),
  },
  [1568] = {
    [anon_sym_EQ] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(3153),
  },
  [1569] = {
    [sym_string] = STATE(1144),
    [sym__property_name] = STATE(1144),
    [sym_computed_property_name] = STATE(1144),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3711),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [1570] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1609),
    [sym_function_type] = STATE(1609),
    [sym_constructor_type] = STATE(1609),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(344),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1609),
    [sym__type] = STATE(1609),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [1571] = {
    [sym__automatic_semicolon] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
  },
  [1572] = {
    [sym__automatic_semicolon] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [1573] = {
    [sym__automatic_semicolon] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym_COMMA] = ACTIONS(3457),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3457),
    [sym_comment] = ACTIONS(3),
  },
  [1574] = {
    [sym__automatic_semicolon] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [sym_identifier] = ACTIONS(4605),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_module] = ACTIONS(4605),
    [anon_sym_symbol] = ACTIONS(4605),
    [anon_sym_number] = ACTIONS(4605),
    [anon_sym_AT] = ACTIONS(3749),
    [anon_sym_declare] = ACTIONS(4605),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_void] = ACTIONS(4605),
    [anon_sym_any] = ACTIONS(4605),
    [anon_sym_private] = ACTIONS(4605),
    [anon_sym_boolean] = ACTIONS(4605),
    [anon_sym_async] = ACTIONS(4605),
    [anon_sym_public] = ACTIONS(4605),
    [anon_sym_get] = ACTIONS(4605),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_static] = ACTIONS(4605),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [sym_number] = ACTIONS(3749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4605),
    [anon_sym_string] = ACTIONS(4605),
    [anon_sym_abstract] = ACTIONS(4605),
    [anon_sym_set] = ACTIONS(4605),
    [anon_sym_type] = ACTIONS(4605),
    [anon_sym_export] = ACTIONS(4605),
    [anon_sym_namespace] = ACTIONS(4605),
    [sym_readonly] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(3749),
  },
  [1575] = {
    [sym__automatic_semicolon] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3755),
    [sym_identifier] = ACTIONS(4607),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_module] = ACTIONS(4607),
    [anon_sym_symbol] = ACTIONS(4607),
    [anon_sym_number] = ACTIONS(4607),
    [anon_sym_AT] = ACTIONS(3755),
    [anon_sym_declare] = ACTIONS(4607),
    [anon_sym_STAR] = ACTIONS(3755),
    [anon_sym_void] = ACTIONS(4607),
    [anon_sym_any] = ACTIONS(4607),
    [anon_sym_private] = ACTIONS(4607),
    [anon_sym_boolean] = ACTIONS(4607),
    [anon_sym_async] = ACTIONS(4607),
    [anon_sym_public] = ACTIONS(4607),
    [anon_sym_get] = ACTIONS(4607),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(4607),
    [anon_sym_SQUOTE] = ACTIONS(3755),
    [sym_number] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4607),
    [anon_sym_string] = ACTIONS(4607),
    [anon_sym_abstract] = ACTIONS(4607),
    [anon_sym_set] = ACTIONS(4607),
    [anon_sym_type] = ACTIONS(4607),
    [anon_sym_export] = ACTIONS(4607),
    [anon_sym_namespace] = ACTIONS(4607),
    [sym_readonly] = ACTIONS(4607),
    [anon_sym_DQUOTE] = ACTIONS(3755),
  },
  [1576] = {
    [anon_sym_COLON] = ACTIONS(3781),
    [sym__automatic_semicolon] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3781),
  },
  [1577] = {
    [sym__automatic_semicolon] = ACTIONS(3789),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_COMMA] = ACTIONS(3789),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3789),
    [sym_comment] = ACTIONS(3),
  },
  [1578] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [sym__automatic_semicolon] = ACTIONS(3793),
    [anon_sym_BQUOTE] = ACTIONS(3791),
    [anon_sym_PIPE] = ACTIONS(3799),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3799),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3791),
    [anon_sym_instanceof] = ACTIONS(3791),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_PLUS_PLUS] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_else] = ACTIONS(3795),
    [anon_sym_BANG] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3791),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_SLASH] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_GT_GT] = ACTIONS(3799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
  },
  [1579] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3801),
    [anon_sym_BQUOTE] = ACTIONS(3801),
    [anon_sym_PIPE] = ACTIONS(3803),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3803),
    [anon_sym_GT_GT_GT] = ACTIONS(3801),
    [anon_sym_BANG_EQ] = ACTIONS(3803),
    [anon_sym_GT_EQ] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_PERCENT] = ACTIONS(3801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3801),
    [anon_sym_as] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_instanceof] = ACTIONS(3801),
    [anon_sym_COLON] = ACTIONS(3801),
    [anon_sym_DOT] = ACTIONS(3801),
    [anon_sym_STAR_STAR] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_in] = ACTIONS(3803),
    [anon_sym_BANG] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [anon_sym_LT_LT] = ACTIONS(3801),
    [anon_sym_LBRACE] = ACTIONS(3803),
    [anon_sym_AMP_AMP] = ACTIONS(3801),
    [anon_sym_LT_EQ] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3801),
    [anon_sym_RBRACK] = ACTIONS(3801),
    [anon_sym_GT] = ACTIONS(3803),
    [anon_sym_AMP] = ACTIONS(3803),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_PIPE_PIPE] = ACTIONS(3801),
    [anon_sym_EQ_EQ] = ACTIONS(3803),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym_LT] = ACTIONS(3803),
    [anon_sym_SLASH] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3801),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_implements] = ACTIONS(3801),
    [anon_sym_GT_GT] = ACTIONS(3803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3801),
  },
  [1580] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3811),
    [anon_sym_BQUOTE] = ACTIONS(3811),
    [anon_sym_PIPE] = ACTIONS(3813),
    [anon_sym_COMMA] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_GT_GT_GT] = ACTIONS(3811),
    [anon_sym_BANG_EQ] = ACTIONS(3813),
    [anon_sym_GT_EQ] = ACTIONS(3811),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_PERCENT] = ACTIONS(3811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3811),
    [anon_sym_as] = ACTIONS(3811),
    [anon_sym_DASH_DASH] = ACTIONS(3811),
    [anon_sym_instanceof] = ACTIONS(3811),
    [anon_sym_COLON] = ACTIONS(3811),
    [anon_sym_DOT] = ACTIONS(3811),
    [anon_sym_STAR_STAR] = ACTIONS(3811),
    [anon_sym_PLUS_PLUS] = ACTIONS(3811),
    [anon_sym_in] = ACTIONS(3813),
    [anon_sym_BANG] = ACTIONS(3813),
    [anon_sym_LBRACK] = ACTIONS(3811),
    [anon_sym_LT_LT] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_AMP_AMP] = ACTIONS(3811),
    [anon_sym_LT_EQ] = ACTIONS(3811),
    [anon_sym_LPAREN] = ACTIONS(3811),
    [anon_sym_RBRACK] = ACTIONS(3811),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_QMARK] = ACTIONS(3811),
    [anon_sym_PIPE_PIPE] = ACTIONS(3811),
    [anon_sym_EQ_EQ] = ACTIONS(3813),
    [anon_sym_RPAREN] = ACTIONS(3811),
    [anon_sym_LT] = ACTIONS(3813),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3813),
    [anon_sym_implements] = ACTIONS(3811),
    [anon_sym_GT_GT] = ACTIONS(3813),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3811),
  },
  [1581] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3827),
    [anon_sym_BQUOTE] = ACTIONS(3827),
    [anon_sym_PIPE] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3829),
    [anon_sym_STAR] = ACTIONS(3829),
    [anon_sym_GT_GT_GT] = ACTIONS(3827),
    [anon_sym_BANG_EQ] = ACTIONS(3829),
    [anon_sym_GT_EQ] = ACTIONS(3827),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3827),
    [anon_sym_as] = ACTIONS(3827),
    [anon_sym_DASH_DASH] = ACTIONS(3827),
    [anon_sym_instanceof] = ACTIONS(3827),
    [anon_sym_COLON] = ACTIONS(3827),
    [anon_sym_DOT] = ACTIONS(3827),
    [anon_sym_STAR_STAR] = ACTIONS(3827),
    [anon_sym_PLUS_PLUS] = ACTIONS(3827),
    [anon_sym_in] = ACTIONS(3829),
    [anon_sym_BANG] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3827),
    [anon_sym_LT_LT] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_AMP_AMP] = ACTIONS(3827),
    [anon_sym_LT_EQ] = ACTIONS(3827),
    [anon_sym_LPAREN] = ACTIONS(3827),
    [anon_sym_RBRACK] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_QMARK] = ACTIONS(3827),
    [anon_sym_PIPE_PIPE] = ACTIONS(3827),
    [anon_sym_EQ_EQ] = ACTIONS(3829),
    [anon_sym_RPAREN] = ACTIONS(3827),
    [anon_sym_LT] = ACTIONS(3829),
    [anon_sym_SLASH] = ACTIONS(3829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3829),
    [anon_sym_implements] = ACTIONS(3827),
    [anon_sym_GT_GT] = ACTIONS(3829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3827),
  },
  [1582] = {
    [sym__automatic_semicolon] = ACTIONS(3843),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_SEMI] = ACTIONS(3843),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3843),
    [sym_comment] = ACTIONS(3),
  },
  [1583] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3845),
    [sym__automatic_semicolon] = ACTIONS(3847),
    [anon_sym_BQUOTE] = ACTIONS(3845),
    [anon_sym_PIPE] = ACTIONS(3853),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_GT_GT_GT] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3853),
    [anon_sym_GT_EQ] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_as] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3845),
    [anon_sym_instanceof] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_STAR_STAR] = ACTIONS(3845),
    [anon_sym_PLUS_PLUS] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_else] = ACTIONS(3849),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_LT_LT] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_while] = ACTIONS(3849),
    [anon_sym_EQ_EQ] = ACTIONS(3853),
    [anon_sym_LT] = ACTIONS(3853),
    [anon_sym_SLASH] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_GT_GT] = ACTIONS(3853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3845),
  },
  [1584] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [anon_sym_PERCENT_EQ] = ACTIONS(2312),
    [anon_sym_AMP_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2836),
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_GT_GT_GT] = ACTIONS(2836),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2836),
    [anon_sym_GT_EQ] = ACTIONS(2834),
    [anon_sym_CARET_EQ] = ACTIONS(2312),
    [anon_sym_PIPE_EQ] = ACTIONS(2312),
    [anon_sym_DASH_EQ] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_PERCENT] = ACTIONS(2836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2834),
    [anon_sym_LT_LT_EQ] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_COLON] = ACTIONS(2834),
    [anon_sym_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_STAR_STAR] = ACTIONS(2836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_in] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2834),
    [anon_sym_LT_EQ] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_RBRACK] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2836),
    [anon_sym_STAR_EQ] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2836),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_PIPE_PIPE] = ACTIONS(2834),
    [anon_sym_EQ_EQ] = ACTIONS(2836),
    [anon_sym_RPAREN] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2836),
    [anon_sym_SLASH] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_implements] = ACTIONS(2834),
    [anon_sym_GT_GT] = ACTIONS(2836),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2834),
  },
  [1585] = {
    [sym__automatic_semicolon] = ACTIONS(3877),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_SEMI] = ACTIONS(3877),
    [anon_sym_COMMA] = ACTIONS(3877),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
  },
  [1586] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_COLON] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_RPAREN] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
  },
  [1587] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3931),
    [anon_sym_BQUOTE] = ACTIONS(3931),
    [anon_sym_PIPE] = ACTIONS(3933),
    [anon_sym_COMMA] = ACTIONS(3931),
    [anon_sym_DASH] = ACTIONS(3933),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_GT_GT_GT] = ACTIONS(3931),
    [anon_sym_BANG_EQ] = ACTIONS(3933),
    [anon_sym_GT_EQ] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(3931),
    [anon_sym_PERCENT] = ACTIONS(3931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [anon_sym_as] = ACTIONS(3931),
    [anon_sym_DASH_DASH] = ACTIONS(3931),
    [anon_sym_instanceof] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3931),
    [anon_sym_DOT] = ACTIONS(3931),
    [anon_sym_STAR_STAR] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3931),
    [anon_sym_in] = ACTIONS(3933),
    [anon_sym_BANG] = ACTIONS(3933),
    [anon_sym_LBRACK] = ACTIONS(3931),
    [anon_sym_LT_LT] = ACTIONS(3931),
    [anon_sym_LBRACE] = ACTIONS(3933),
    [anon_sym_AMP_AMP] = ACTIONS(3931),
    [anon_sym_LT_EQ] = ACTIONS(3931),
    [anon_sym_LPAREN] = ACTIONS(3931),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3931),
    [anon_sym_PIPE_PIPE] = ACTIONS(3931),
    [anon_sym_EQ_EQ] = ACTIONS(3933),
    [anon_sym_RPAREN] = ACTIONS(3931),
    [anon_sym_LT] = ACTIONS(3933),
    [anon_sym_SLASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3931),
    [anon_sym_PLUS] = ACTIONS(3933),
    [anon_sym_implements] = ACTIONS(3931),
    [anon_sym_GT_GT] = ACTIONS(3933),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3931),
  },
  [1588] = {
    [sym__automatic_semicolon] = ACTIONS(3937),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_SEMI] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3937),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3937),
    [sym_comment] = ACTIONS(3),
  },
  [1589] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3943),
    [sym__automatic_semicolon] = ACTIONS(3945),
    [anon_sym_BQUOTE] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3951),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_GT_GT_GT] = ACTIONS(3943),
    [anon_sym_BANG_EQ] = ACTIONS(3951),
    [anon_sym_GT_EQ] = ACTIONS(3943),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_DASH_DASH] = ACTIONS(3943),
    [anon_sym_instanceof] = ACTIONS(3943),
    [anon_sym_DOT] = ACTIONS(3943),
    [anon_sym_STAR_STAR] = ACTIONS(3943),
    [anon_sym_PLUS_PLUS] = ACTIONS(3943),
    [anon_sym_in] = ACTIONS(3951),
    [anon_sym_else] = ACTIONS(3947),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(3943),
    [anon_sym_SEMI] = ACTIONS(3943),
    [anon_sym_LT_LT] = ACTIONS(3943),
    [anon_sym_AMP_AMP] = ACTIONS(3943),
    [anon_sym_LT_EQ] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_QMARK] = ACTIONS(3943),
    [anon_sym_PIPE_PIPE] = ACTIONS(3943),
    [anon_sym_while] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3951),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_SLASH] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3943),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_GT_GT] = ACTIONS(3951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3943),
  },
  [1590] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3953),
    [sym__automatic_semicolon] = ACTIONS(3955),
    [anon_sym_BQUOTE] = ACTIONS(3953),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_GT_EQ] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_as] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_instanceof] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_STAR_STAR] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_else] = ACTIONS(3957),
    [anon_sym_BANG] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3953),
    [anon_sym_LT_LT] = ACTIONS(3953),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_LT_EQ] = ACTIONS(3953),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_LT] = ACTIONS(3961),
    [anon_sym_SLASH] = ACTIONS(3961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3953),
  },
  [1591] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3963),
    [anon_sym_BQUOTE] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_STAR] = ACTIONS(3965),
    [anon_sym_GT_GT_GT] = ACTIONS(3963),
    [anon_sym_BANG_EQ] = ACTIONS(3965),
    [anon_sym_GT_EQ] = ACTIONS(3963),
    [anon_sym_RBRACE] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3963),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [anon_sym_instanceof] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3963),
    [anon_sym_STAR_STAR] = ACTIONS(3963),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_in] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_LT_LT] = ACTIONS(3963),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3963),
    [anon_sym_LT_EQ] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_RBRACK] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3963),
    [anon_sym_PIPE_PIPE] = ACTIONS(3963),
    [anon_sym_EQ_EQ] = ACTIONS(3965),
    [anon_sym_RPAREN] = ACTIONS(3963),
    [anon_sym_LT] = ACTIONS(3965),
    [anon_sym_SLASH] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_implements] = ACTIONS(3963),
    [anon_sym_GT_GT] = ACTIONS(3965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3963),
  },
  [1592] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3681),
    [anon_sym_BQUOTE] = ACTIONS(3681),
    [anon_sym_PIPE] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_DASH] = ACTIONS(3689),
    [anon_sym_STAR] = ACTIONS(3689),
    [anon_sym_GT_GT_GT] = ACTIONS(3681),
    [anon_sym_BANG_EQ] = ACTIONS(3689),
    [anon_sym_GT_EQ] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_PERCENT] = ACTIONS(3681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3681),
    [anon_sym_as] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_instanceof] = ACTIONS(3681),
    [anon_sym_COLON] = ACTIONS(3681),
    [anon_sym_DOT] = ACTIONS(3681),
    [anon_sym_STAR_STAR] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_in] = ACTIONS(3689),
    [anon_sym_BANG] = ACTIONS(3689),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_LT_LT] = ACTIONS(3681),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_AMP_AMP] = ACTIONS(3681),
    [anon_sym_LT_EQ] = ACTIONS(3681),
    [anon_sym_LPAREN] = ACTIONS(3681),
    [anon_sym_RBRACK] = ACTIONS(3681),
    [anon_sym_GT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_QMARK] = ACTIONS(3681),
    [anon_sym_PIPE_PIPE] = ACTIONS(3681),
    [anon_sym_EQ_EQ] = ACTIONS(3689),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [anon_sym_LT] = ACTIONS(3689),
    [anon_sym_SLASH] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_PLUS] = ACTIONS(3689),
    [anon_sym_implements] = ACTIONS(3681),
    [anon_sym_GT_GT] = ACTIONS(3689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3681),
  },
  [1593] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [anon_sym_BQUOTE] = ACTIONS(3791),
    [anon_sym_PIPE] = ACTIONS(3799),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3799),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_BANG_EQ] = ACTIONS(3799),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3791),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3791),
    [anon_sym_instanceof] = ACTIONS(3791),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_PLUS_PLUS] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3799),
    [anon_sym_BANG] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3799),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3791),
    [anon_sym_RBRACK] = ACTIONS(3791),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_AMP] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(3799),
    [anon_sym_RPAREN] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3799),
    [anon_sym_SLASH] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_implements] = ACTIONS(3791),
    [anon_sym_GT_GT] = ACTIONS(3799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
  },
  [1594] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3845),
    [anon_sym_BQUOTE] = ACTIONS(3845),
    [anon_sym_PIPE] = ACTIONS(3853),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_GT_GT_GT] = ACTIONS(3845),
    [anon_sym_BANG_EQ] = ACTIONS(3853),
    [anon_sym_GT_EQ] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3845),
    [anon_sym_as] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3845),
    [anon_sym_instanceof] = ACTIONS(3845),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_DOT] = ACTIONS(3845),
    [anon_sym_STAR_STAR] = ACTIONS(3845),
    [anon_sym_PLUS_PLUS] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LT_LT] = ACTIONS(3845),
    [anon_sym_LBRACE] = ACTIONS(3853),
    [anon_sym_AMP_AMP] = ACTIONS(3845),
    [anon_sym_LT_EQ] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_RBRACK] = ACTIONS(3845),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_PIPE_PIPE] = ACTIONS(3845),
    [anon_sym_EQ_EQ] = ACTIONS(3853),
    [anon_sym_RPAREN] = ACTIONS(3845),
    [anon_sym_LT] = ACTIONS(3853),
    [anon_sym_SLASH] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3845),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_implements] = ACTIONS(3845),
    [anon_sym_GT_GT] = ACTIONS(3853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3845),
  },
  [1595] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3943),
    [anon_sym_BQUOTE] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3951),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3951),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_GT_GT_GT] = ACTIONS(3943),
    [anon_sym_BANG_EQ] = ACTIONS(3951),
    [anon_sym_GT_EQ] = ACTIONS(3943),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3943),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_DASH_DASH] = ACTIONS(3943),
    [anon_sym_instanceof] = ACTIONS(3943),
    [anon_sym_COLON] = ACTIONS(3943),
    [anon_sym_DOT] = ACTIONS(3943),
    [anon_sym_STAR_STAR] = ACTIONS(3943),
    [anon_sym_PLUS_PLUS] = ACTIONS(3943),
    [anon_sym_in] = ACTIONS(3951),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(3943),
    [anon_sym_LT_LT] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3943),
    [anon_sym_LT_EQ] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3943),
    [anon_sym_RBRACK] = ACTIONS(3943),
    [anon_sym_GT] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_QMARK] = ACTIONS(3943),
    [anon_sym_PIPE_PIPE] = ACTIONS(3943),
    [anon_sym_EQ_EQ] = ACTIONS(3951),
    [anon_sym_RPAREN] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3951),
    [anon_sym_SLASH] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3943),
    [anon_sym_PLUS] = ACTIONS(3951),
    [anon_sym_implements] = ACTIONS(3943),
    [anon_sym_GT_GT] = ACTIONS(3951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3943),
  },
  [1596] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3953),
    [anon_sym_BQUOTE] = ACTIONS(3953),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_COMMA] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_STAR] = ACTIONS(3961),
    [anon_sym_GT_GT_GT] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3961),
    [anon_sym_GT_EQ] = ACTIONS(3953),
    [anon_sym_RBRACE] = ACTIONS(3953),
    [anon_sym_PERCENT] = ACTIONS(3953),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3953),
    [anon_sym_as] = ACTIONS(3953),
    [anon_sym_DASH_DASH] = ACTIONS(3953),
    [anon_sym_instanceof] = ACTIONS(3953),
    [anon_sym_COLON] = ACTIONS(3953),
    [anon_sym_DOT] = ACTIONS(3953),
    [anon_sym_STAR_STAR] = ACTIONS(3953),
    [anon_sym_PLUS_PLUS] = ACTIONS(3953),
    [anon_sym_in] = ACTIONS(3961),
    [anon_sym_BANG] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3953),
    [anon_sym_LT_LT] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3961),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_LT_EQ] = ACTIONS(3953),
    [anon_sym_LPAREN] = ACTIONS(3953),
    [anon_sym_RBRACK] = ACTIONS(3953),
    [anon_sym_GT] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3961),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3953),
    [anon_sym_EQ_EQ] = ACTIONS(3961),
    [anon_sym_RPAREN] = ACTIONS(3953),
    [anon_sym_LT] = ACTIONS(3961),
    [anon_sym_SLASH] = ACTIONS(3961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_implements] = ACTIONS(3953),
    [anon_sym_GT_GT] = ACTIONS(3961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3953),
  },
  [1597] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [sym__automatic_semicolon] = ACTIONS(3969),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3971),
  },
  [1598] = {
    [sym_string] = STATE(1197),
    [sym__property_name] = STATE(1197),
    [sym_computed_property_name] = STATE(1197),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1599] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [sym__automatic_semicolon] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_LT_LT] = ACTIONS(4008),
    [anon_sym_STAR] = ACTIONS(4010),
    [anon_sym_GT_GT_GT] = ACTIONS(4008),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_BANG_EQ] = ACTIONS(4010),
    [anon_sym_LT_EQ] = ACTIONS(4008),
    [anon_sym_LPAREN] = ACTIONS(4008),
    [anon_sym_GT_EQ] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_PERCENT] = ACTIONS(4008),
    [anon_sym_QMARK] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_as] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_EQ_EQ] = ACTIONS(4010),
    [anon_sym_instanceof] = ACTIONS(4008),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_SLASH] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4008),
    [anon_sym_CARET] = ACTIONS(4008),
    [anon_sym_STAR_STAR] = ACTIONS(4008),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_in] = ACTIONS(4010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4008),
    [anon_sym_BANG] = ACTIONS(4010),
  },
  [1600] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4012),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [sym__automatic_semicolon] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym_BQUOTE] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(4601),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_LT_LT] = ACTIONS(4012),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_GT_GT_GT] = ACTIONS(4012),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_BANG_EQ] = ACTIONS(4014),
    [anon_sym_LT_EQ] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_GT_EQ] = ACTIONS(4012),
    [anon_sym_GT] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4603),
    [anon_sym_PERCENT] = ACTIONS(4012),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_as] = ACTIONS(4012),
    [anon_sym_PIPE_PIPE] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_EQ_EQ] = ACTIONS(4014),
    [anon_sym_instanceof] = ACTIONS(4012),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_SLASH] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4012),
    [anon_sym_CARET] = ACTIONS(4012),
    [anon_sym_STAR_STAR] = ACTIONS(4012),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_GT_GT] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4012),
    [anon_sym_BANG] = ACTIONS(4014),
  },
  [1601] = {
    [sym_generic_type] = STATE(1405),
    [sym_type_predicate] = STATE(1405),
    [sym_literal_type] = STATE(1405),
    [sym__number] = STATE(1399),
    [sym_object_type] = STATE(1405),
    [sym_intersection_type] = STATE(1626),
    [sym_function_type] = STATE(1626),
    [sym_nested_identifier] = STATE(2402),
    [sym_nested_type_identifier] = STATE(1406),
    [sym__type] = STATE(1626),
    [sym_type_query] = STATE(1405),
    [sym_index_type_query] = STATE(1405),
    [sym_existential_type] = STATE(1405),
    [sym_flow_maybe_type] = STATE(1405),
    [sym_string] = STATE(1399),
    [sym_type_parameters] = STATE(2404),
    [sym_array_type] = STATE(1405),
    [sym_formal_parameters] = STATE(1950),
    [sym_constructor_type] = STATE(1626),
    [sym__primary_type] = STATE(1405),
    [sym_lookup_type] = STATE(1405),
    [sym_parenthesized_type] = STATE(1405),
    [sym_predefined_type] = STATE(1405),
    [sym_tuple_type] = STATE(1405),
    [sym_union_type] = STATE(1626),
    [sym_identifier] = ACTIONS(1430),
    [sym_false] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_keyof] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1458),
    [sym_number] = ACTIONS(1460),
    [sym_true] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1602] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4016),
    [anon_sym_LBRACK] = ACTIONS(4016),
    [sym__automatic_semicolon] = ACTIONS(4016),
    [anon_sym_SEMI] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_LT_LT] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4016),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_LT_EQ] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4016),
    [anon_sym_GT_EQ] = ACTIONS(4016),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4016),
    [anon_sym_QMARK] = ACTIONS(4016),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_as] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4016),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_instanceof] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_SLASH] = ACTIONS(4018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4016),
    [anon_sym_CARET] = ACTIONS(4016),
    [anon_sym_STAR_STAR] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4016),
    [anon_sym_in] = ACTIONS(4018),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4016),
    [anon_sym_BANG] = ACTIONS(4018),
  },
  [1603] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [sym__automatic_semicolon] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_STAR] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4022),
    [anon_sym_instanceof] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_SLASH] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4020),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_STAR_STAR] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4022),
  },
  [1604] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [sym__automatic_semicolon] = ACTIONS(4024),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4601),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_BANG_EQ] = ACTIONS(4026),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4603),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_QMARK] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_instanceof] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4024),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_STAR_STAR] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BANG] = ACTIONS(4026),
  },
  [1605] = {
    [sym__automatic_semicolon] = ACTIONS(4030),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(4030),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4030),
    [sym_comment] = ACTIONS(3),
  },
  [1606] = {
    [sym__automatic_semicolon] = ACTIONS(4041),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_SEMI] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4041),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
  },
  [1607] = {
    [sym__automatic_semicolon] = ACTIONS(4045),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_SEMI] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
  },
  [1608] = {
    [sym_string] = STATE(1226),
    [sym__property_name] = STATE(1226),
    [sym_computed_property_name] = STATE(1226),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(1753),
  },
  [1609] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_while] = ACTIONS(4131),
    [sym_comment] = ACTIONS(3),
  },
  [1610] = {
    [sym__automatic_semicolon] = ACTIONS(3685),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_COMMA] = ACTIONS(3685),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
  },
  [1611] = {
    [sym__automatic_semicolon] = ACTIONS(3947),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_SEMI] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3947),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3947),
    [sym_comment] = ACTIONS(3),
  },
  [1612] = {
    [sym__automatic_semicolon] = ACTIONS(3957),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_SEMI] = ACTIONS(3957),
    [anon_sym_COMMA] = ACTIONS(3957),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3957),
    [sym_comment] = ACTIONS(3),
  },
  [1613] = {
    [sym__automatic_semicolon] = ACTIONS(4139),
    [anon_sym_LBRACK] = ACTIONS(4139),
    [sym_identifier] = ACTIONS(4609),
    [anon_sym_SEMI] = ACTIONS(4139),
    [anon_sym_module] = ACTIONS(4609),
    [anon_sym_symbol] = ACTIONS(4609),
    [anon_sym_number] = ACTIONS(4609),
    [anon_sym_AT] = ACTIONS(4139),
    [anon_sym_declare] = ACTIONS(4609),
    [anon_sym_STAR] = ACTIONS(4139),
    [anon_sym_void] = ACTIONS(4609),
    [anon_sym_any] = ACTIONS(4609),
    [anon_sym_private] = ACTIONS(4609),
    [anon_sym_boolean] = ACTIONS(4609),
    [anon_sym_async] = ACTIONS(4609),
    [anon_sym_public] = ACTIONS(4609),
    [anon_sym_get] = ACTIONS(4609),
    [anon_sym_RBRACE] = ACTIONS(4139),
    [anon_sym_static] = ACTIONS(4609),
    [anon_sym_SQUOTE] = ACTIONS(4139),
    [sym_number] = ACTIONS(4139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4609),
    [anon_sym_string] = ACTIONS(4609),
    [anon_sym_abstract] = ACTIONS(4609),
    [anon_sym_set] = ACTIONS(4609),
    [anon_sym_type] = ACTIONS(4609),
    [anon_sym_export] = ACTIONS(4609),
    [anon_sym_namespace] = ACTIONS(4609),
    [sym_readonly] = ACTIONS(4609),
    [anon_sym_DQUOTE] = ACTIONS(4139),
  },
  [1614] = {
    [sym__automatic_semicolon] = ACTIONS(4141),
    [anon_sym_LBRACK] = ACTIONS(4141),
    [sym_identifier] = ACTIONS(4611),
    [anon_sym_SEMI] = ACTIONS(4141),
    [anon_sym_module] = ACTIONS(4611),
    [anon_sym_symbol] = ACTIONS(4611),
    [anon_sym_number] = ACTIONS(4611),
    [anon_sym_AT] = ACTIONS(4141),
    [anon_sym_declare] = ACTIONS(4611),
    [anon_sym_STAR] = ACTIONS(4141),
    [anon_sym_void] = ACTIONS(4611),
    [anon_sym_any] = ACTIONS(4611),
    [anon_sym_private] = ACTIONS(4611),
    [anon_sym_boolean] = ACTIONS(4611),
    [anon_sym_async] = ACTIONS(4611),
    [anon_sym_public] = ACTIONS(4611),
    [anon_sym_get] = ACTIONS(4611),
    [anon_sym_RBRACE] = ACTIONS(4141),
    [anon_sym_static] = ACTIONS(4611),
    [anon_sym_SQUOTE] = ACTIONS(4141),
    [sym_number] = ACTIONS(4141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4611),
    [anon_sym_string] = ACTIONS(4611),
    [anon_sym_abstract] = ACTIONS(4611),
    [anon_sym_set] = ACTIONS(4611),
    [anon_sym_type] = ACTIONS(4611),
    [anon_sym_export] = ACTIONS(4611),
    [anon_sym_namespace] = ACTIONS(4611),
    [sym_readonly] = ACTIONS(4611),
    [anon_sym_DQUOTE] = ACTIONS(4141),
  },
  [1615] = {
    [anon_sym_COLON] = ACTIONS(4155),
    [sym__automatic_semicolon] = ACTIONS(4155),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4155),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4155),
    [anon_sym_COMMA] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4155),
  },
  [1616] = {
    [sym__automatic_semicolon] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4159),
    [sym_comment] = ACTIONS(3),
  },
  [1617] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4161),
    [sym__automatic_semicolon] = ACTIONS(4163),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4161),
    [anon_sym_as] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [anon_sym_instanceof] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4161),
    [anon_sym_STAR_STAR] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_else] = ACTIONS(4165),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_while] = ACTIONS(4165),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_SLASH] = ACTIONS(4169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4161),
  },
  [1618] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BQUOTE] = ACTIONS(4171),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_instanceof] = ACTIONS(4171),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4171),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_QMARK] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_implements] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4171),
  },
  [1619] = {
    [sym__automatic_semicolon] = ACTIONS(4177),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_SEMI] = ACTIONS(4177),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4177),
    [sym_comment] = ACTIONS(3),
  },
  [1620] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(4181),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_implements] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1621] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4202),
    [sym__automatic_semicolon] = ACTIONS(4204),
    [anon_sym_BQUOTE] = ACTIONS(4202),
    [anon_sym_PIPE] = ACTIONS(4210),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_DASH] = ACTIONS(4210),
    [anon_sym_STAR] = ACTIONS(4210),
    [anon_sym_GT_GT_GT] = ACTIONS(4202),
    [anon_sym_BANG_EQ] = ACTIONS(4210),
    [anon_sym_GT_EQ] = ACTIONS(4202),
    [anon_sym_PERCENT] = ACTIONS(4202),
    [anon_sym_as] = ACTIONS(4202),
    [anon_sym_DASH_DASH] = ACTIONS(4202),
    [anon_sym_instanceof] = ACTIONS(4202),
    [anon_sym_DOT] = ACTIONS(4202),
    [anon_sym_STAR_STAR] = ACTIONS(4202),
    [anon_sym_PLUS_PLUS] = ACTIONS(4202),
    [anon_sym_in] = ACTIONS(4210),
    [anon_sym_else] = ACTIONS(4206),
    [anon_sym_BANG] = ACTIONS(4210),
    [anon_sym_LBRACK] = ACTIONS(4202),
    [anon_sym_SEMI] = ACTIONS(4202),
    [anon_sym_LT_LT] = ACTIONS(4202),
    [anon_sym_AMP_AMP] = ACTIONS(4202),
    [anon_sym_LT_EQ] = ACTIONS(4202),
    [anon_sym_LPAREN] = ACTIONS(4202),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_PIPE_PIPE] = ACTIONS(4202),
    [anon_sym_while] = ACTIONS(4206),
    [anon_sym_EQ_EQ] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4202),
    [anon_sym_PLUS] = ACTIONS(4210),
    [anon_sym_GT_GT] = ACTIONS(4210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4202),
  },
  [1622] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4161),
    [anon_sym_as] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [anon_sym_instanceof] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4161),
    [anon_sym_STAR_STAR] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RBRACK] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_SLASH] = ACTIONS(4169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_implements] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4161),
  },
  [1623] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4202),
    [anon_sym_BQUOTE] = ACTIONS(4202),
    [anon_sym_PIPE] = ACTIONS(4210),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_DASH] = ACTIONS(4210),
    [anon_sym_STAR] = ACTIONS(4210),
    [anon_sym_GT_GT_GT] = ACTIONS(4202),
    [anon_sym_BANG_EQ] = ACTIONS(4210),
    [anon_sym_GT_EQ] = ACTIONS(4202),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_PERCENT] = ACTIONS(4202),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4202),
    [anon_sym_as] = ACTIONS(4202),
    [anon_sym_DASH_DASH] = ACTIONS(4202),
    [anon_sym_instanceof] = ACTIONS(4202),
    [anon_sym_COLON] = ACTIONS(4202),
    [anon_sym_DOT] = ACTIONS(4202),
    [anon_sym_STAR_STAR] = ACTIONS(4202),
    [anon_sym_PLUS_PLUS] = ACTIONS(4202),
    [anon_sym_in] = ACTIONS(4210),
    [anon_sym_BANG] = ACTIONS(4210),
    [anon_sym_LBRACK] = ACTIONS(4202),
    [anon_sym_LT_LT] = ACTIONS(4202),
    [anon_sym_LBRACE] = ACTIONS(4210),
    [anon_sym_AMP_AMP] = ACTIONS(4202),
    [anon_sym_LT_EQ] = ACTIONS(4202),
    [anon_sym_LPAREN] = ACTIONS(4202),
    [anon_sym_RBRACK] = ACTIONS(4202),
    [anon_sym_GT] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_PIPE_PIPE] = ACTIONS(4202),
    [anon_sym_EQ_EQ] = ACTIONS(4210),
    [anon_sym_RPAREN] = ACTIONS(4202),
    [anon_sym_LT] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(4210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4202),
    [anon_sym_PLUS] = ACTIONS(4210),
    [anon_sym_implements] = ACTIONS(4202),
    [anon_sym_GT_GT] = ACTIONS(4210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4202),
  },
  [1624] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [sym__automatic_semicolon] = ACTIONS(4212),
    [anon_sym_SEMI] = ACTIONS(4212),
    [anon_sym_BQUOTE] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4212),
    [anon_sym_LT_LT] = ACTIONS(4212),
    [anon_sym_STAR] = ACTIONS(4214),
    [anon_sym_GT_GT_GT] = ACTIONS(4212),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4214),
    [anon_sym_BANG_EQ] = ACTIONS(4214),
    [anon_sym_LT_EQ] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_GT_EQ] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4214),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_RBRACE] = ACTIONS(4212),
    [anon_sym_as] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_DASH_DASH] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4214),
    [anon_sym_instanceof] = ACTIONS(4212),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_CARET] = ACTIONS(4212),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4212),
    [anon_sym_GT_GT] = ACTIONS(4214),
    [anon_sym_PLUS_PLUS] = ACTIONS(4212),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4212),
    [anon_sym_BANG] = ACTIONS(4214),
  },
  [1625] = {
    [sym_string] = STATE(1255),
    [sym__property_name] = STATE(1255),
    [sym_computed_property_name] = STATE(1255),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1626] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4238),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [sym__automatic_semicolon] = ACTIONS(4238),
    [anon_sym_SEMI] = ACTIONS(4238),
    [anon_sym_BQUOTE] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(4601),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_LT_LT] = ACTIONS(4238),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_GT_GT_GT] = ACTIONS(4238),
    [anon_sym_AMP_AMP] = ACTIONS(4238),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_LT_EQ] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4238),
    [anon_sym_GT_EQ] = ACTIONS(4238),
    [anon_sym_GT] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4603),
    [anon_sym_PERCENT] = ACTIONS(4238),
    [anon_sym_QMARK] = ACTIONS(4238),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_as] = ACTIONS(4238),
    [anon_sym_PIPE_PIPE] = ACTIONS(4238),
    [anon_sym_DASH_DASH] = ACTIONS(4238),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_instanceof] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4240),
    [anon_sym_SLASH] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_CARET] = ACTIONS(4238),
    [anon_sym_STAR_STAR] = ACTIONS(4238),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_GT_GT] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4238),
    [anon_sym_in] = ACTIONS(4240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4238),
    [anon_sym_BANG] = ACTIONS(4240),
  },
  [1627] = {
    [sym__automatic_semicolon] = ACTIONS(4244),
    [anon_sym_RBRACE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4244),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
  },
  [1628] = {
    [sym__automatic_semicolon] = ACTIONS(4206),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_SEMI] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4206),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4206),
    [sym_comment] = ACTIONS(3),
  },
  [1629] = {
    [sym__automatic_semicolon] = ACTIONS(4294),
    [anon_sym_LBRACK] = ACTIONS(4294),
    [sym_identifier] = ACTIONS(4613),
    [anon_sym_SEMI] = ACTIONS(4294),
    [anon_sym_module] = ACTIONS(4613),
    [anon_sym_symbol] = ACTIONS(4613),
    [anon_sym_number] = ACTIONS(4613),
    [anon_sym_AT] = ACTIONS(4294),
    [anon_sym_declare] = ACTIONS(4613),
    [anon_sym_STAR] = ACTIONS(4294),
    [anon_sym_void] = ACTIONS(4613),
    [anon_sym_any] = ACTIONS(4613),
    [anon_sym_private] = ACTIONS(4613),
    [anon_sym_boolean] = ACTIONS(4613),
    [anon_sym_async] = ACTIONS(4613),
    [anon_sym_public] = ACTIONS(4613),
    [anon_sym_get] = ACTIONS(4613),
    [anon_sym_RBRACE] = ACTIONS(4294),
    [anon_sym_static] = ACTIONS(4613),
    [anon_sym_SQUOTE] = ACTIONS(4294),
    [sym_number] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4613),
    [anon_sym_string] = ACTIONS(4613),
    [anon_sym_abstract] = ACTIONS(4613),
    [anon_sym_set] = ACTIONS(4613),
    [anon_sym_type] = ACTIONS(4613),
    [anon_sym_export] = ACTIONS(4613),
    [anon_sym_namespace] = ACTIONS(4613),
    [sym_readonly] = ACTIONS(4613),
    [anon_sym_DQUOTE] = ACTIONS(4294),
  },
  [1630] = {
    [sym__automatic_semicolon] = ACTIONS(4296),
    [anon_sym_LBRACK] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4615),
    [anon_sym_SEMI] = ACTIONS(4296),
    [anon_sym_module] = ACTIONS(4615),
    [anon_sym_symbol] = ACTIONS(4615),
    [anon_sym_number] = ACTIONS(4615),
    [anon_sym_AT] = ACTIONS(4296),
    [anon_sym_declare] = ACTIONS(4615),
    [anon_sym_STAR] = ACTIONS(4296),
    [anon_sym_void] = ACTIONS(4615),
    [anon_sym_any] = ACTIONS(4615),
    [anon_sym_private] = ACTIONS(4615),
    [anon_sym_boolean] = ACTIONS(4615),
    [anon_sym_async] = ACTIONS(4615),
    [anon_sym_public] = ACTIONS(4615),
    [anon_sym_get] = ACTIONS(4615),
    [anon_sym_RBRACE] = ACTIONS(4296),
    [anon_sym_static] = ACTIONS(4615),
    [anon_sym_SQUOTE] = ACTIONS(4296),
    [sym_number] = ACTIONS(4296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4615),
    [anon_sym_string] = ACTIONS(4615),
    [anon_sym_abstract] = ACTIONS(4615),
    [anon_sym_set] = ACTIONS(4615),
    [anon_sym_type] = ACTIONS(4615),
    [anon_sym_export] = ACTIONS(4615),
    [anon_sym_namespace] = ACTIONS(4615),
    [sym_readonly] = ACTIONS(4615),
    [anon_sym_DQUOTE] = ACTIONS(4296),
  },
  [1631] = {
    [sym__automatic_semicolon] = ACTIONS(4306),
    [anon_sym_RBRACE] = ACTIONS(4306),
    [anon_sym_SEMI] = ACTIONS(4306),
    [anon_sym_COMMA] = ACTIONS(4306),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4306),
    [sym_comment] = ACTIONS(3),
  },
  [1632] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4326),
    [anon_sym_LBRACK] = ACTIONS(4326),
    [sym__automatic_semicolon] = ACTIONS(4326),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_BQUOTE] = ACTIONS(4326),
    [anon_sym_PIPE] = ACTIONS(4328),
    [anon_sym_COMMA] = ACTIONS(4326),
    [anon_sym_LT_LT] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_GT_GT_GT] = ACTIONS(4326),
    [anon_sym_AMP_AMP] = ACTIONS(4326),
    [anon_sym_DASH] = ACTIONS(4328),
    [anon_sym_BANG_EQ] = ACTIONS(4328),
    [anon_sym_LT_EQ] = ACTIONS(4326),
    [anon_sym_LPAREN] = ACTIONS(4326),
    [anon_sym_GT_EQ] = ACTIONS(4326),
    [anon_sym_GT] = ACTIONS(4328),
    [anon_sym_AMP] = ACTIONS(4328),
    [anon_sym_PERCENT] = ACTIONS(4326),
    [anon_sym_QMARK] = ACTIONS(4326),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [anon_sym_as] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4326),
    [anon_sym_EQ_EQ] = ACTIONS(4328),
    [anon_sym_instanceof] = ACTIONS(4326),
    [anon_sym_LT] = ACTIONS(4328),
    [anon_sym_SLASH] = ACTIONS(4328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4326),
    [anon_sym_CARET] = ACTIONS(4326),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4328),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4326),
    [anon_sym_GT_GT] = ACTIONS(4328),
    [anon_sym_PLUS_PLUS] = ACTIONS(4326),
    [anon_sym_in] = ACTIONS(4328),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4326),
    [anon_sym_BANG] = ACTIONS(4328),
  },
  [1633] = {
    [sym__automatic_semicolon] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4617),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_module] = ACTIONS(4617),
    [anon_sym_symbol] = ACTIONS(4617),
    [anon_sym_number] = ACTIONS(4617),
    [anon_sym_AT] = ACTIONS(4360),
    [anon_sym_declare] = ACTIONS(4617),
    [anon_sym_STAR] = ACTIONS(4360),
    [anon_sym_void] = ACTIONS(4617),
    [anon_sym_any] = ACTIONS(4617),
    [anon_sym_private] = ACTIONS(4617),
    [anon_sym_boolean] = ACTIONS(4617),
    [anon_sym_async] = ACTIONS(4617),
    [anon_sym_public] = ACTIONS(4617),
    [anon_sym_get] = ACTIONS(4617),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_static] = ACTIONS(4617),
    [anon_sym_SQUOTE] = ACTIONS(4360),
    [sym_number] = ACTIONS(4360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4617),
    [anon_sym_string] = ACTIONS(4617),
    [anon_sym_abstract] = ACTIONS(4617),
    [anon_sym_set] = ACTIONS(4617),
    [anon_sym_type] = ACTIONS(4617),
    [anon_sym_export] = ACTIONS(4617),
    [anon_sym_namespace] = ACTIONS(4617),
    [sym_readonly] = ACTIONS(4617),
    [anon_sym_DQUOTE] = ACTIONS(4360),
  },
  [1634] = {
    [sym__automatic_semicolon] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(4362),
    [sym_identifier] = ACTIONS(4619),
    [anon_sym_SEMI] = ACTIONS(4362),
    [anon_sym_module] = ACTIONS(4619),
    [anon_sym_symbol] = ACTIONS(4619),
    [anon_sym_number] = ACTIONS(4619),
    [anon_sym_AT] = ACTIONS(4362),
    [anon_sym_declare] = ACTIONS(4619),
    [anon_sym_STAR] = ACTIONS(4362),
    [anon_sym_void] = ACTIONS(4619),
    [anon_sym_any] = ACTIONS(4619),
    [anon_sym_private] = ACTIONS(4619),
    [anon_sym_boolean] = ACTIONS(4619),
    [anon_sym_async] = ACTIONS(4619),
    [anon_sym_public] = ACTIONS(4619),
    [anon_sym_get] = ACTIONS(4619),
    [anon_sym_RBRACE] = ACTIONS(4362),
    [anon_sym_static] = ACTIONS(4619),
    [anon_sym_SQUOTE] = ACTIONS(4362),
    [sym_number] = ACTIONS(4362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4619),
    [anon_sym_string] = ACTIONS(4619),
    [anon_sym_abstract] = ACTIONS(4619),
    [anon_sym_set] = ACTIONS(4619),
    [anon_sym_type] = ACTIONS(4619),
    [anon_sym_export] = ACTIONS(4619),
    [anon_sym_namespace] = ACTIONS(4619),
    [sym_readonly] = ACTIONS(4619),
    [anon_sym_DQUOTE] = ACTIONS(4362),
  },
  [1635] = {
    [sym__automatic_semicolon] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [sym_identifier] = ACTIONS(4621),
    [anon_sym_SEMI] = ACTIONS(4374),
    [anon_sym_module] = ACTIONS(4621),
    [anon_sym_symbol] = ACTIONS(4621),
    [anon_sym_number] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(4374),
    [anon_sym_declare] = ACTIONS(4621),
    [anon_sym_STAR] = ACTIONS(4374),
    [anon_sym_void] = ACTIONS(4621),
    [anon_sym_any] = ACTIONS(4621),
    [anon_sym_private] = ACTIONS(4621),
    [anon_sym_boolean] = ACTIONS(4621),
    [anon_sym_async] = ACTIONS(4621),
    [anon_sym_public] = ACTIONS(4621),
    [anon_sym_get] = ACTIONS(4621),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_static] = ACTIONS(4621),
    [anon_sym_SQUOTE] = ACTIONS(4374),
    [sym_number] = ACTIONS(4374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4621),
    [anon_sym_string] = ACTIONS(4621),
    [anon_sym_abstract] = ACTIONS(4621),
    [anon_sym_set] = ACTIONS(4621),
    [anon_sym_type] = ACTIONS(4621),
    [anon_sym_export] = ACTIONS(4621),
    [anon_sym_namespace] = ACTIONS(4621),
    [sym_readonly] = ACTIONS(4621),
    [anon_sym_DQUOTE] = ACTIONS(4374),
  },
  [1636] = {
    [sym__automatic_semicolon] = ACTIONS(4376),
    [anon_sym_LBRACK] = ACTIONS(4376),
    [sym_identifier] = ACTIONS(4623),
    [anon_sym_SEMI] = ACTIONS(4376),
    [anon_sym_module] = ACTIONS(4623),
    [anon_sym_symbol] = ACTIONS(4623),
    [anon_sym_number] = ACTIONS(4623),
    [anon_sym_AT] = ACTIONS(4376),
    [anon_sym_declare] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4376),
    [anon_sym_void] = ACTIONS(4623),
    [anon_sym_any] = ACTIONS(4623),
    [anon_sym_private] = ACTIONS(4623),
    [anon_sym_boolean] = ACTIONS(4623),
    [anon_sym_async] = ACTIONS(4623),
    [anon_sym_public] = ACTIONS(4623),
    [anon_sym_get] = ACTIONS(4623),
    [anon_sym_RBRACE] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(4623),
    [anon_sym_SQUOTE] = ACTIONS(4376),
    [sym_number] = ACTIONS(4376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4623),
    [anon_sym_string] = ACTIONS(4623),
    [anon_sym_abstract] = ACTIONS(4623),
    [anon_sym_set] = ACTIONS(4623),
    [anon_sym_type] = ACTIONS(4623),
    [anon_sym_export] = ACTIONS(4623),
    [anon_sym_namespace] = ACTIONS(4623),
    [sym_readonly] = ACTIONS(4623),
    [anon_sym_DQUOTE] = ACTIONS(4376),
  },
  [1637] = {
    [sym__automatic_semicolon] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(4380),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym_SEMI] = ACTIONS(4380),
    [anon_sym_module] = ACTIONS(4625),
    [anon_sym_symbol] = ACTIONS(4625),
    [anon_sym_number] = ACTIONS(4625),
    [anon_sym_AT] = ACTIONS(4380),
    [anon_sym_declare] = ACTIONS(4625),
    [anon_sym_STAR] = ACTIONS(4380),
    [anon_sym_void] = ACTIONS(4625),
    [anon_sym_any] = ACTIONS(4625),
    [anon_sym_private] = ACTIONS(4625),
    [anon_sym_boolean] = ACTIONS(4625),
    [anon_sym_async] = ACTIONS(4625),
    [anon_sym_public] = ACTIONS(4625),
    [anon_sym_get] = ACTIONS(4625),
    [anon_sym_RBRACE] = ACTIONS(4380),
    [anon_sym_static] = ACTIONS(4625),
    [anon_sym_SQUOTE] = ACTIONS(4380),
    [sym_number] = ACTIONS(4380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4625),
    [anon_sym_string] = ACTIONS(4625),
    [anon_sym_abstract] = ACTIONS(4625),
    [anon_sym_set] = ACTIONS(4625),
    [anon_sym_type] = ACTIONS(4625),
    [anon_sym_export] = ACTIONS(4625),
    [anon_sym_namespace] = ACTIONS(4625),
    [sym_readonly] = ACTIONS(4625),
    [anon_sym_DQUOTE] = ACTIONS(4380),
  },
  [1638] = {
    [sym_statement_block] = STATE(1655),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_instanceof] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(4586),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
  },
  [1639] = {
    [sym_statement_block] = STATE(1655),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_instanceof] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
  },
  [1640] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(846),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_GT_GT_GT] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(848),
    [anon_sym_GT_EQ] = ACTIONS(846),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_PERCENT] = ACTIONS(846),
    [anon_sym_LBRACE_PIPE] = ACTIONS(846),
    [anon_sym_as] = ACTIONS(846),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_instanceof] = ACTIONS(846),
    [anon_sym_COLON] = ACTIONS(846),
    [anon_sym_DOT] = ACTIONS(846),
    [anon_sym_STAR_STAR] = ACTIONS(846),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_in] = ACTIONS(848),
    [anon_sym_else] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(846),
    [anon_sym_LT_LT] = ACTIONS(846),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_AMP_AMP] = ACTIONS(846),
    [anon_sym_LT_EQ] = ACTIONS(846),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_AMP] = ACTIONS(848),
    [anon_sym_QMARK] = ACTIONS(846),
    [anon_sym_PIPE_PIPE] = ACTIONS(846),
    [anon_sym_while] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_SLASH] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_implements] = ACTIONS(846),
    [anon_sym_GT_GT] = ACTIONS(848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(846),
  },
  [1641] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(850),
    [anon_sym_BQUOTE] = ACTIONS(850),
    [anon_sym_PIPE] = ACTIONS(852),
    [anon_sym_COMMA] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_STAR] = ACTIONS(852),
    [anon_sym_GT_GT_GT] = ACTIONS(850),
    [anon_sym_EQ] = ACTIONS(852),
    [anon_sym_BANG_EQ] = ACTIONS(852),
    [anon_sym_GT_EQ] = ACTIONS(850),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_PERCENT] = ACTIONS(850),
    [anon_sym_LBRACE_PIPE] = ACTIONS(850),
    [anon_sym_as] = ACTIONS(850),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [anon_sym_instanceof] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(850),
    [anon_sym_DOT] = ACTIONS(850),
    [anon_sym_STAR_STAR] = ACTIONS(850),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_in] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(850),
    [anon_sym_BANG] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_LT_LT] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(852),
    [anon_sym_AMP_AMP] = ACTIONS(850),
    [anon_sym_LT_EQ] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_RBRACK] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(852),
    [anon_sym_AMP] = ACTIONS(852),
    [anon_sym_QMARK] = ACTIONS(850),
    [anon_sym_PIPE_PIPE] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(850),
    [anon_sym_EQ_EQ] = ACTIONS(852),
    [anon_sym_RPAREN] = ACTIONS(850),
    [anon_sym_LT] = ACTIONS(852),
    [anon_sym_SLASH] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(850),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_implements] = ACTIONS(850),
    [anon_sym_GT_GT] = ACTIONS(852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(850),
  },
  [1642] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(4627),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
  },
  [1643] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym_arguments] = STATE(1446),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [sym_null] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_implements] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_await] = ACTIONS(499),
  },
  [1644] = {
    [sym_jsx_text] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1522),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(1522),
  },
  [1645] = {
    [sym_type_arguments] = STATE(1671),
    [sym__automatic_semicolon] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(4631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4633),
    [anon_sym_EQ] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(4635),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1797),
  },
  [1646] = {
    [sym__automatic_semicolon] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_PIPE] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1805),
    [anon_sym_EQ] = ACTIONS(1805),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1805),
  },
  [1647] = {
    [sym_array_type] = STATE(1672),
    [sym_generic_type] = STATE(1672),
    [sym_type_predicate] = STATE(1672),
    [sym_literal_type] = STATE(1672),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1672),
    [sym__primary_type] = STATE(1672),
    [sym_lookup_type] = STATE(1672),
    [sym_parenthesized_type] = STATE(1672),
    [sym_nested_identifier] = STATE(2551),
    [sym_predefined_type] = STATE(1672),
    [sym_nested_type_identifier] = STATE(1653),
    [sym_tuple_type] = STATE(1672),
    [sym_type_query] = STATE(1672),
    [sym_index_type_query] = STATE(1672),
    [sym_existential_type] = STATE(1672),
    [sym_flow_maybe_type] = STATE(1672),
    [sym_string] = STATE(1646),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(4637),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(4639),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1648] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1674),
    [sym_function_type] = STATE(1674),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1674),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1674),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1674),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1649] = {
    [sym__automatic_semicolon] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1833),
    [anon_sym_AMP] = ACTIONS(1833),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_RBRACE] = ACTIONS(1833),
    [anon_sym_PIPE] = ACTIONS(1835),
    [anon_sym_COMMA] = ACTIONS(1833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1833),
    [anon_sym_EQ] = ACTIONS(1833),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1833),
  },
  [1650] = {
    [sym__automatic_semicolon] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_AMP] = ACTIONS(1841),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_PIPE] = ACTIONS(1843),
    [anon_sym_COMMA] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_EQ] = ACTIONS(1841),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1841),
  },
  [1651] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1679),
    [sym_function_type] = STATE(1679),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1679),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1679),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1679),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1652] = {
    [sym__automatic_semicolon] = ACTIONS(1859),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(4641),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_EQ] = ACTIONS(1859),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1859),
  },
  [1653] = {
    [sym_type_arguments] = STATE(1681),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1865),
  },
  [1654] = {
    [anon_sym_LBRACK] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [anon_sym_module] = ACTIONS(1879),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_class] = ACTIONS(1879),
    [anon_sym_AT] = ACTIONS(1877),
    [anon_sym_declare] = ACTIONS(1879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_private] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_static] = ACTIONS(1879),
    [anon_sym_public] = ACTIONS(1879),
    [anon_sym_get] = ACTIONS(1879),
    [anon_sym_async] = ACTIONS(1879),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_SQUOTE] = ACTIONS(1877),
    [sym_this] = ACTIONS(1879),
    [sym_number] = ACTIONS(1877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1879),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_abstract] = ACTIONS(1879),
    [anon_sym_set] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1879),
    [anon_sym_export] = ACTIONS(1879),
    [sym_readonly] = ACTIONS(1879),
    [anon_sym_namespace] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(1877),
  },
  [1655] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1987),
    [sym__automatic_semicolon] = ACTIONS(1987),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_GT_GT_GT] = ACTIONS(1987),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1987),
    [anon_sym_RBRACE] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_as] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1987),
    [anon_sym_instanceof] = ACTIONS(1987),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_STAR_STAR] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_SLASH] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1989),
    [anon_sym_GT_GT] = ACTIONS(1989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1987),
  },
  [1656] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_GT_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1991),
    [anon_sym_as] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [anon_sym_instanceof] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_STAR_STAR] = ACTIONS(1991),
    [anon_sym_PLUS_PLUS] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1993),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_SLASH] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1993),
    [anon_sym_implements] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1991),
  },
  [1657] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2143),
    [sym__automatic_semicolon] = ACTIONS(2143),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2143),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_PERCENT] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(2143),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2143),
    [sym_null] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2143),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2143),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_COMMA] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2143),
    [sym_super] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [sym_this] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2143),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [sym_false] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [sym_number] = ACTIONS(2143),
    [ts_builtin_sym_end] = ACTIONS(2143),
    [anon_sym_function] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_await] = ACTIONS(2145),
  },
  [1658] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2249),
    [sym__automatic_semicolon] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2249),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_instanceof] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_LT_LT] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [sym_null] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_CARET] = ACTIONS(2249),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2249),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [sym_super] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [sym_this] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_STAR_STAR] = ACTIONS(2249),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_false] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [sym_number] = ACTIONS(2249),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_await] = ACTIONS(2251),
  },
  [1659] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2249),
    [sym__automatic_semicolon] = ACTIONS(4643),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2249),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_instanceof] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_LT_LT] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [sym_null] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_CARET] = ACTIONS(2249),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2249),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [sym_super] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [sym_this] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_STAR_STAR] = ACTIONS(2249),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_false] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [sym_number] = ACTIONS(2249),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_function] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_await] = ACTIONS(2251),
  },
  [1660] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2312),
    [anon_sym_BQUOTE] = ACTIONS(2312),
    [anon_sym_PERCENT_EQ] = ACTIONS(2312),
    [anon_sym_AMP_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(2312),
    [anon_sym_PIPE] = ACTIONS(2314),
    [anon_sym_COMMA] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_GT_GT_GT] = ACTIONS(2314),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_BANG_EQ] = ACTIONS(2314),
    [anon_sym_GT_EQ] = ACTIONS(2312),
    [anon_sym_CARET_EQ] = ACTIONS(2312),
    [anon_sym_PIPE_EQ] = ACTIONS(2312),
    [anon_sym_DASH_EQ] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2312),
    [anon_sym_LT_LT_EQ] = ACTIONS(2312),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_instanceof] = ACTIONS(2312),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2312),
    [anon_sym_STAR_STAR] = ACTIONS(2314),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2312),
    [anon_sym_LT_LT] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_of] = ACTIONS(2312),
    [anon_sym_LT_EQ] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_RBRACK] = ACTIONS(2312),
    [anon_sym_GT] = ACTIONS(2314),
    [anon_sym_STAR_EQ] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_EQ_EQ] = ACTIONS(2314),
    [anon_sym_RPAREN] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2312),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_implements] = ACTIONS(2312),
    [anon_sym_GT_GT] = ACTIONS(2314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2312),
  },
  [1661] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(4627),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
  },
  [1662] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_instanceof] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4549),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_implements] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
  },
  [1663] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(4645),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2503),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1664] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1665] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1666] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1322),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [1667] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1668] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(848),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(4647),
    [sym_false] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(4649),
    [anon_sym_symbol] = ACTIONS(4649),
    [anon_sym_number] = ACTIONS(4649),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4649),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4651),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(4649),
    [anon_sym_private] = ACTIONS(4649),
    [anon_sym_boolean] = ACTIONS(4649),
    [anon_sym_static] = ACTIONS(4649),
    [anon_sym_public] = ACTIONS(4649),
    [anon_sym_get] = ACTIONS(4649),
    [anon_sym_async] = ACTIONS(4653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [sym_number] = ACTIONS(4580),
    [sym_true] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(4649),
    [anon_sym_string] = ACTIONS(4649),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_DOT] = ACTIONS(4574),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_set] = ACTIONS(4649),
    [anon_sym_type] = ACTIONS(4649),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(4649),
    [anon_sym_namespace] = ACTIONS(4655),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [1669] = {
    [sym_jsx_text] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2626),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(2626),
  },
  [1670] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1697),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1697),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1697),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1697),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1671] = {
    [sym__automatic_semicolon] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_COMMA] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_EQ] = ACTIONS(2699),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2699),
  },
  [1672] = {
    [sym__automatic_semicolon] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(4641),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2705),
    [anon_sym_COMMA] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(2703),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2703),
  },
  [1673] = {
    [sym__automatic_semicolon] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2721),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2721),
  },
  [1674] = {
    [sym__automatic_semicolon] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2775),
  },
  [1675] = {
    [sym__automatic_semicolon] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_EQ] = ACTIONS(2779),
    [anon_sym_DOT] = ACTIONS(4657),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2779),
  },
  [1676] = {
    [sym__automatic_semicolon] = ACTIONS(2785),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2785),
  },
  [1677] = {
    [sym__automatic_semicolon] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_DOT] = ACTIONS(4635),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2789),
  },
  [1678] = {
    [sym__automatic_semicolon] = ACTIONS(2795),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_PIPE] = ACTIONS(2797),
    [anon_sym_COMMA] = ACTIONS(2795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2795),
    [anon_sym_EQ] = ACTIONS(2795),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2795),
  },
  [1679] = {
    [sym__automatic_semicolon] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_COMMA] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2814),
  },
  [1680] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1702),
    [sym_function_type] = STATE(1702),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1702),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1702),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1702),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1681] = {
    [sym__automatic_semicolon] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_PIPE] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(2820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_EQ] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2820),
  },
  [1682] = {
    [sym__automatic_semicolon] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_COMMA] = ACTIONS(2824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2824),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2824),
  },
  [1683] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1704),
    [sym_function_type] = STATE(1704),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1704),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1704),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1704),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1684] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1705),
    [sym_function_type] = STATE(1705),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1705),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1705),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1705),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1685] = {
    [anon_sym_LBRACK] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_number] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [sym_readonly] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2834),
  },
  [1686] = {
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2900),
    [sym_jsx_identifier] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(2900),
    [anon_sym_LT] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2900),
  },
  [1687] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3052),
    [sym__automatic_semicolon] = ACTIONS(3052),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3054),
    [anon_sym_PIPE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_GT_GT_GT] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_BANG_EQ] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_PERCENT] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_as] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_instanceof] = ACTIONS(3054),
    [anon_sym_yield] = ACTIONS(3054),
    [sym_true] = ACTIONS(3054),
    [anon_sym_protected] = ACTIONS(3054),
    [anon_sym_DOT] = ACTIONS(3054),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
    [anon_sym_in] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3054),
    [anon_sym_typeof] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_LT_EQ] = ACTIONS(3052),
    [sym_null] = ACTIONS(3054),
    [anon_sym_any] = ACTIONS(3054),
    [anon_sym_async] = ACTIONS(3054),
    [anon_sym_public] = ACTIONS(3054),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_CARET] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3054),
    [anon_sym_GT_GT] = ACTIONS(3054),
    [anon_sym_with] = ACTIONS(3054),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_debugger] = ACTIONS(3054),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_void] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_GT_EQ] = ACTIONS(3052),
    [sym_super] = ACTIONS(3054),
    [anon_sym_private] = ACTIONS(3054),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [sym_this] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_abstract] = ACTIONS(3054),
    [anon_sym_type] = ACTIONS(3054),
    [anon_sym_STAR_STAR] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [sym_false] = ACTIONS(3054),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_module] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_declare] = ACTIONS(3054),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_GT] = ACTIONS(3054),
    [anon_sym_boolean] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_EQ_EQ] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3054),
    [sym_number] = ACTIONS(3052),
    [ts_builtin_sym_end] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3054),
    [sym_undefined] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_await] = ACTIONS(3054),
  },
  [1688] = {
    [anon_sym_EQ] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_COLON] = ACTIONS(3153),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(3153),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3153),
    [sym__automatic_semicolon] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_COMMA] = ACTIONS(3153),
    [sym_comment] = ACTIONS(3),
  },
  [1689] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3168),
    [sym__automatic_semicolon] = ACTIONS(3168),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_GT_GT_GT] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_BANG_EQ] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_PERCENT] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_as] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_instanceof] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_in] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_LT_LT] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_LT_EQ] = ACTIONS(3168),
    [sym_null] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_CARET] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_with] = ACTIONS(3170),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_COMMA] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_GT_EQ] = ACTIONS(3168),
    [sym_super] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [sym_this] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_STAR_STAR] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [sym_false] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3170),
    [sym_number] = ACTIONS(3168),
    [ts_builtin_sym_end] = ACTIONS(3168),
    [anon_sym_function] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_await] = ACTIONS(3170),
  },
  [1690] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3210),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [anon_sym_PERCENT_EQ] = ACTIONS(3210),
    [anon_sym_AMP_EQ] = ACTIONS(3210),
    [anon_sym_PLUS_EQ] = ACTIONS(3210),
    [anon_sym_PIPE] = ACTIONS(3212),
    [anon_sym_COMMA] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(3212),
    [anon_sym_GT_GT_GT] = ACTIONS(3212),
    [anon_sym_EQ] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3212),
    [anon_sym_GT_EQ] = ACTIONS(3210),
    [anon_sym_CARET_EQ] = ACTIONS(3210),
    [anon_sym_PIPE_EQ] = ACTIONS(3210),
    [anon_sym_DASH_EQ] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3210),
    [anon_sym_LT_LT_EQ] = ACTIONS(3210),
    [anon_sym_as] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [anon_sym_instanceof] = ACTIONS(3210),
    [anon_sym_COLON] = ACTIONS(3210),
    [anon_sym_GT_GT_EQ] = ACTIONS(3210),
    [anon_sym_DOT] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_in] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3210),
    [anon_sym_LT_LT] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_AMP_AMP] = ACTIONS(3210),
    [anon_sym_of] = ACTIONS(3210),
    [anon_sym_LT_EQ] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_RBRACK] = ACTIONS(3210),
    [anon_sym_GT] = ACTIONS(3212),
    [anon_sym_STAR_EQ] = ACTIONS(3210),
    [anon_sym_AMP] = ACTIONS(3212),
    [anon_sym_QMARK] = ACTIONS(3210),
    [anon_sym_PIPE_PIPE] = ACTIONS(3210),
    [anon_sym_EQ_EQ] = ACTIONS(3212),
    [anon_sym_RPAREN] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3210),
    [anon_sym_CARET] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_implements] = ACTIONS(3210),
    [anon_sym_GT_GT] = ACTIONS(3212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3210),
  },
  [1691] = {
    [sym_jsx_text] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3285),
  },
  [1692] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1877),
    [anon_sym_BQUOTE] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1879),
    [anon_sym_STAR] = ACTIONS(1879),
    [anon_sym_GT_GT_GT] = ACTIONS(1877),
    [anon_sym_BANG_EQ] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(1877),
    [anon_sym_PERCENT] = ACTIONS(1877),
    [anon_sym_as] = ACTIONS(1877),
    [anon_sym_DASH_DASH] = ACTIONS(1877),
    [anon_sym_instanceof] = ACTIONS(1877),
    [anon_sym_COLON] = ACTIONS(1877),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_STAR_STAR] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1877),
    [anon_sym_in] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_GT] = ACTIONS(1879),
    [anon_sym_EQ_GT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_QMARK] = ACTIONS(1877),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_EQ_EQ] = ACTIONS(1879),
    [anon_sym_RPAREN] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
  },
  [1693] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2779),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4659),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1694] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1695] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_implements] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
  },
  [1696] = {
    [sym__automatic_semicolon] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3471),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3471),
    [anon_sym_EQ] = ACTIONS(3471),
    [anon_sym_DOT] = ACTIONS(2900),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3471),
  },
  [1697] = {
    [sym__automatic_semicolon] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(3475),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym_EQ] = ACTIONS(3475),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3475),
  },
  [1698] = {
    [sym__automatic_semicolon] = ACTIONS(3505),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_EQ] = ACTIONS(3505),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3505),
  },
  [1699] = {
    [sym__automatic_semicolon] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3515),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_PIPE] = ACTIONS(3517),
    [anon_sym_COMMA] = ACTIONS(3515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_EQ] = ACTIONS(3515),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3515),
  },
  [1700] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1716),
    [sym_function_type] = STATE(1716),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1716),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1716),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1716),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1701] = {
    [sym__automatic_semicolon] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3523),
  },
  [1702] = {
    [sym__automatic_semicolon] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3527),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3527),
  },
  [1703] = {
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3531),
  },
  [1704] = {
    [sym__automatic_semicolon] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_PIPE] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
  },
  [1705] = {
    [sym__automatic_semicolon] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_EQ] = ACTIONS(3541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3541),
  },
  [1706] = {
    [sym__automatic_semicolon] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_EQ] = ACTIONS(3545),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3545),
  },
  [1707] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1720),
    [sym_function_type] = STATE(1720),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1720),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1720),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1720),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1708] = {
    [anon_sym_LBRACK] = ACTIONS(3556),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_module] = ACTIONS(3558),
    [anon_sym_symbol] = ACTIONS(3558),
    [anon_sym_number] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3558),
    [anon_sym_AT] = ACTIONS(3556),
    [anon_sym_declare] = ACTIONS(3558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3556),
    [anon_sym_void] = ACTIONS(3558),
    [anon_sym_any] = ACTIONS(3558),
    [anon_sym_private] = ACTIONS(3558),
    [anon_sym_boolean] = ACTIONS(3558),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_public] = ACTIONS(3558),
    [anon_sym_get] = ACTIONS(3558),
    [anon_sym_async] = ACTIONS(3558),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(3556),
    [sym_this] = ACTIONS(3558),
    [sym_number] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3558),
    [anon_sym_string] = ACTIONS(3558),
    [anon_sym_abstract] = ACTIONS(3558),
    [anon_sym_set] = ACTIONS(3558),
    [anon_sym_type] = ACTIONS(3558),
    [anon_sym_export] = ACTIONS(3558),
    [sym_readonly] = ACTIONS(3558),
    [anon_sym_namespace] = ACTIONS(3558),
    [anon_sym_DQUOTE] = ACTIONS(3556),
  },
  [1709] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(3667),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_implements] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1710] = {
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1721),
    [sym_function_type] = STATE(1721),
    [sym_constructor_type] = STATE(1721),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_nested_identifier] = STATE(2551),
    [sym_predefined_type] = STATE(1652),
    [sym_nested_type_identifier] = STATE(1653),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1721),
    [sym__type] = STATE(1721),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_symbol] = ACTIONS(1927),
    [sym_this] = ACTIONS(1949),
    [anon_sym_typeof] = ACTIONS(1929),
    [sym_true] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_keyof] = ACTIONS(1931),
    [sym_number] = ACTIONS(1951),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_PIPE] = ACTIONS(1939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_boolean] = ACTIONS(1927),
  },
  [1711] = {
    [sym_identifier] = ACTIONS(3813),
    [sym_jsx_identifier] = ACTIONS(3811),
    [anon_sym_GT] = ACTIONS(3811),
    [anon_sym_SLASH] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3811),
  },
  [1712] = {
    [sym_jsx_text] = ACTIONS(3829),
    [anon_sym_LT] = ACTIONS(3829),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3829),
  },
  [1713] = {
    [sym_jsx_text] = ACTIONS(3933),
    [anon_sym_LT] = ACTIONS(3933),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(3933),
  },
  [1714] = {
    [sym__automatic_semicolon] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3969),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_COMMA] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3969),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3969),
  },
  [1715] = {
    [sym__automatic_semicolon] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_COMMA] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4008),
    [anon_sym_EQ] = ACTIONS(4008),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4008),
  },
  [1716] = {
    [sym__automatic_semicolon] = ACTIONS(4012),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(4012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_EQ] = ACTIONS(4012),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4012),
  },
  [1717] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1725),
    [sym_function_type] = STATE(1725),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1725),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1725),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1725),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1718] = {
    [sym__automatic_semicolon] = ACTIONS(4016),
    [anon_sym_LBRACK] = ACTIONS(4016),
    [anon_sym_AMP] = ACTIONS(4016),
    [anon_sym_SEMI] = ACTIONS(4016),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4016),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4016),
  },
  [1719] = {
    [sym__automatic_semicolon] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_AMP] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4020),
  },
  [1720] = {
    [sym__automatic_semicolon] = ACTIONS(4024),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(4024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_EQ] = ACTIONS(4024),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4024),
  },
  [1721] = {
    [sym__automatic_semicolon] = ACTIONS(4131),
    [anon_sym_RBRACE] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(4131),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4131),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(4131),
    [sym_comment] = ACTIONS(3),
  },
  [1722] = {
    [sym_identifier] = ACTIONS(4173),
    [sym_jsx_identifier] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_SLASH] = ACTIONS(4173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4171),
  },
  [1723] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(4181),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1724] = {
    [sym__automatic_semicolon] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_AMP] = ACTIONS(4212),
    [anon_sym_SEMI] = ACTIONS(4212),
    [anon_sym_RBRACE] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(4212),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4212),
  },
  [1725] = {
    [sym__automatic_semicolon] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [anon_sym_SEMI] = ACTIONS(4238),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_COMMA] = ACTIONS(4238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4238),
    [anon_sym_EQ] = ACTIONS(4238),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4238),
  },
  [1726] = {
    [sym__automatic_semicolon] = ACTIONS(4326),
    [anon_sym_LBRACK] = ACTIONS(4326),
    [anon_sym_AMP] = ACTIONS(4326),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [anon_sym_PIPE] = ACTIONS(4328),
    [anon_sym_COMMA] = ACTIONS(4326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4326),
    [anon_sym_EQ] = ACTIONS(4326),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4326),
  },
  [1727] = {
    [sym_statement_block] = STATE(1742),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_instanceof] = ACTIONS(838),
    [anon_sym_COLON] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(4661),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(4663),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_RBRACK] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_implements] = ACTIONS(838),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
  },
  [1728] = {
    [sym_statement_block] = STATE(1742),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_instanceof] = ACTIONS(838),
    [anon_sym_COLON] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(4663),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_RBRACK] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_implements] = ACTIONS(838),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
  },
  [1729] = {
    [sym_identifier] = ACTIONS(848),
    [anon_sym_BQUOTE] = ACTIONS(846),
    [anon_sym_debugger] = ACTIONS(848),
    [anon_sym_symbol] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(848),
    [anon_sym_void] = ACTIONS(848),
    [anon_sym_break] = ACTIONS(848),
    [anon_sym_const] = ACTIONS(848),
    [sym_super] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(848),
    [anon_sym_private] = ACTIONS(848),
    [anon_sym_static] = ACTIONS(848),
    [anon_sym_get] = ACTIONS(848),
    [anon_sym_RBRACE] = ACTIONS(846),
    [anon_sym_interface] = ACTIONS(848),
    [anon_sym_default] = ACTIONS(848),
    [anon_sym_enum] = ACTIONS(848),
    [anon_sym_delete] = ACTIONS(848),
    [anon_sym_continue] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(846),
    [anon_sym_if] = ACTIONS(848),
    [sym_this] = ACTIONS(848),
    [anon_sym_yield] = ACTIONS(848),
    [sym_true] = ACTIONS(848),
    [anon_sym_throw] = ACTIONS(848),
    [anon_sym_protected] = ACTIONS(848),
    [anon_sym_abstract] = ACTIONS(848),
    [anon_sym_set] = ACTIONS(848),
    [anon_sym_type] = ACTIONS(848),
    [anon_sym_import] = ACTIONS(848),
    [anon_sym_namespace] = ACTIONS(848),
    [anon_sym_PLUS_PLUS] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(846),
    [anon_sym_else] = ACTIONS(848),
    [anon_sym_BANG] = ACTIONS(846),
    [anon_sym_for] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym_false] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym_case] = ACTIONS(848),
    [anon_sym_module] = ACTIONS(848),
    [anon_sym_number] = ACTIONS(848),
    [anon_sym_class] = ACTIONS(848),
    [anon_sym_declare] = ACTIONS(848),
    [anon_sym_typeof] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_LPAREN] = ACTIONS(846),
    [sym_null] = ACTIONS(848),
    [anon_sym_any] = ACTIONS(848),
    [anon_sym_boolean] = ACTIONS(848),
    [anon_sym_async] = ACTIONS(848),
    [anon_sym_public] = ACTIONS(848),
    [anon_sym_var] = ACTIONS(848),
    [anon_sym_while] = ACTIONS(848),
    [anon_sym_SQUOTE] = ACTIONS(846),
    [anon_sym_try] = ACTIONS(848),
    [anon_sym_LT] = ACTIONS(846),
    [sym_number] = ACTIONS(846),
    [anon_sym_SLASH] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(848),
    [anon_sym_function] = ACTIONS(848),
    [sym_undefined] = ACTIONS(848),
    [anon_sym_new] = ACTIONS(848),
    [ts_builtin_sym_end] = ACTIONS(846),
    [anon_sym_let] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(848),
    [anon_sym_export] = ACTIONS(848),
    [anon_sym_do] = ACTIONS(848),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_with] = ACTIONS(848),
    [anon_sym_await] = ACTIONS(848),
  },
  [1730] = {
    [anon_sym_BQUOTE] = ACTIONS(850),
    [anon_sym_symbol] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(850),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(852),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_interface] = ACTIONS(852),
    [anon_sym_delete] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_yield] = ACTIONS(852),
    [sym_true] = ACTIONS(852),
    [anon_sym_COLON] = ACTIONS(850),
    [anon_sym_protected] = ACTIONS(852),
    [anon_sym_set] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_DQUOTE] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(852),
    [anon_sym_typeof] = ACTIONS(852),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_switch] = ACTIONS(852),
    [anon_sym_RBRACK] = ACTIONS(850),
    [sym_null] = ACTIONS(852),
    [anon_sym_any] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(852),
    [anon_sym_public] = ACTIONS(852),
    [anon_sym_var] = ACTIONS(852),
    [anon_sym_QMARK] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(850),
    [anon_sym_RPAREN] = ACTIONS(850),
    [anon_sym_SLASH] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(852),
    [anon_sym_new] = ACTIONS(852),
    [anon_sym_export] = ACTIONS(852),
    [anon_sym_with] = ACTIONS(852),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_debugger] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(850),
    [anon_sym_COMMA] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_EQ] = ACTIONS(852),
    [anon_sym_void] = ACTIONS(852),
    [anon_sym_const] = ACTIONS(852),
    [sym_super] = ACTIONS(852),
    [anon_sym_private] = ACTIONS(852),
    [anon_sym_get] = ACTIONS(852),
    [anon_sym_default] = ACTIONS(852),
    [anon_sym_enum] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_DASH_DASH] = ACTIONS(850),
    [sym_this] = ACTIONS(852),
    [anon_sym_throw] = ACTIONS(852),
    [anon_sym_abstract] = ACTIONS(852),
    [anon_sym_type] = ACTIONS(852),
    [anon_sym_namespace] = ACTIONS(852),
    [anon_sym_PLUS_PLUS] = ACTIONS(850),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_BANG] = ACTIONS(850),
    [anon_sym_LBRACK] = ACTIONS(850),
    [sym_false] = ACTIONS(852),
    [anon_sym_case] = ACTIONS(852),
    [anon_sym_module] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_declare] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(850),
    [anon_sym_boolean] = ACTIONS(852),
    [anon_sym_EQ_GT] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_LT] = ACTIONS(850),
    [sym_number] = ACTIONS(850),
    [ts_builtin_sym_end] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_let] = ACTIONS(852),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(852),
    [anon_sym_TILDE] = ACTIONS(850),
    [anon_sym_await] = ACTIONS(852),
  },
  [1731] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(4665),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_implements] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
  },
  [1732] = {
    [sym_identifier] = ACTIONS(1522),
    [sym_jsx_identifier] = ACTIONS(1520),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_SLASH] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1520),
  },
  [1733] = {
    [sym_type_arguments] = STATE(1755),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(1797),
    [anon_sym_PIPE] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_GT_GT_GT] = ACTIONS(1797),
    [anon_sym_BANG_EQ] = ACTIONS(1801),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [anon_sym_PERCENT] = ACTIONS(1797),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1797),
    [anon_sym_as] = ACTIONS(1797),
    [anon_sym_DASH_DASH] = ACTIONS(1797),
    [anon_sym_instanceof] = ACTIONS(1797),
    [anon_sym_COLON] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(4667),
    [anon_sym_STAR_STAR] = ACTIONS(1797),
    [anon_sym_PLUS_PLUS] = ACTIONS(1797),
    [anon_sym_in] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_LT_LT] = ACTIONS(1797),
    [anon_sym_is] = ACTIONS(4669),
    [anon_sym_AMP_AMP] = ACTIONS(1797),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_RBRACK] = ACTIONS(1797),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1801),
    [anon_sym_QMARK] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1797),
    [anon_sym_EQ_EQ] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(4671),
    [anon_sym_SLASH] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1797),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_implements] = ACTIONS(1797),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1797),
  },
  [1734] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1805),
    [anon_sym_BQUOTE] = ACTIONS(1805),
    [anon_sym_PIPE] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1807),
    [anon_sym_GT_GT_GT] = ACTIONS(1805),
    [anon_sym_BANG_EQ] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_PERCENT] = ACTIONS(1805),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1805),
    [anon_sym_as] = ACTIONS(1805),
    [anon_sym_DASH_DASH] = ACTIONS(1805),
    [anon_sym_instanceof] = ACTIONS(1805),
    [anon_sym_COLON] = ACTIONS(1805),
    [anon_sym_DOT] = ACTIONS(1805),
    [anon_sym_STAR_STAR] = ACTIONS(1805),
    [anon_sym_PLUS_PLUS] = ACTIONS(1805),
    [anon_sym_in] = ACTIONS(1807),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [anon_sym_LT_LT] = ACTIONS(1805),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_AMP_AMP] = ACTIONS(1805),
    [anon_sym_LT_EQ] = ACTIONS(1805),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [anon_sym_RBRACK] = ACTIONS(1805),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1805),
    [anon_sym_PIPE_PIPE] = ACTIONS(1805),
    [anon_sym_EQ_EQ] = ACTIONS(1807),
    [anon_sym_RPAREN] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_SLASH] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_implements] = ACTIONS(1805),
    [anon_sym_GT_GT] = ACTIONS(1807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1805),
  },
  [1735] = {
    [sym_array_type] = STATE(1756),
    [sym_generic_type] = STATE(1756),
    [sym_type_predicate] = STATE(1756),
    [sym_literal_type] = STATE(1756),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1756),
    [sym__primary_type] = STATE(1756),
    [sym_lookup_type] = STATE(1756),
    [sym_parenthesized_type] = STATE(1756),
    [sym_nested_identifier] = STATE(2623),
    [sym_predefined_type] = STATE(1756),
    [sym_nested_type_identifier] = STATE(1741),
    [sym_tuple_type] = STATE(1756),
    [sym_type_query] = STATE(1756),
    [sym_index_type_query] = STATE(1756),
    [sym_existential_type] = STATE(1756),
    [sym_flow_maybe_type] = STATE(1756),
    [sym_string] = STATE(1734),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4692),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4698),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1736] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1758),
    [sym_function_type] = STATE(1758),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1758),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1758),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1758),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1737] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1833),
    [anon_sym_BQUOTE] = ACTIONS(1833),
    [anon_sym_PIPE] = ACTIONS(1835),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1835),
    [anon_sym_GT_GT_GT] = ACTIONS(1833),
    [anon_sym_BANG_EQ] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(1833),
    [anon_sym_RBRACE] = ACTIONS(1833),
    [anon_sym_PERCENT] = ACTIONS(1833),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1833),
    [anon_sym_as] = ACTIONS(1833),
    [anon_sym_DASH_DASH] = ACTIONS(1833),
    [anon_sym_instanceof] = ACTIONS(1833),
    [anon_sym_COLON] = ACTIONS(1833),
    [anon_sym_DOT] = ACTIONS(1833),
    [anon_sym_STAR_STAR] = ACTIONS(1833),
    [anon_sym_PLUS_PLUS] = ACTIONS(1833),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1833),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1833),
    [anon_sym_LT_EQ] = ACTIONS(1833),
    [anon_sym_LPAREN] = ACTIONS(1833),
    [anon_sym_RBRACK] = ACTIONS(1833),
    [anon_sym_GT] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1833),
    [anon_sym_PIPE_PIPE] = ACTIONS(1833),
    [anon_sym_EQ_EQ] = ACTIONS(1835),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_SLASH] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1833),
    [anon_sym_PLUS] = ACTIONS(1835),
    [anon_sym_implements] = ACTIONS(1833),
    [anon_sym_GT_GT] = ACTIONS(1835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1833),
  },
  [1738] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1841),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [anon_sym_PIPE] = ACTIONS(1843),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_STAR] = ACTIONS(1843),
    [anon_sym_GT_GT_GT] = ACTIONS(1841),
    [anon_sym_BANG_EQ] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(1841),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_PERCENT] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1841),
    [anon_sym_as] = ACTIONS(1841),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_instanceof] = ACTIONS(1841),
    [anon_sym_COLON] = ACTIONS(1841),
    [anon_sym_DOT] = ACTIONS(1841),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_in] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_LT_LT] = ACTIONS(1841),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_AMP_AMP] = ACTIONS(1841),
    [anon_sym_LT_EQ] = ACTIONS(1841),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_RBRACK] = ACTIONS(1841),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_PIPE_PIPE] = ACTIONS(1841),
    [anon_sym_EQ_EQ] = ACTIONS(1843),
    [anon_sym_RPAREN] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_SLASH] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_implements] = ACTIONS(1841),
    [anon_sym_GT_GT] = ACTIONS(1843),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1841),
  },
  [1739] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1763),
    [sym_function_type] = STATE(1763),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1763),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1763),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1763),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1740] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1859),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1861),
    [anon_sym_GT_GT_GT] = ACTIONS(1859),
    [anon_sym_BANG_EQ] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_PERCENT] = ACTIONS(1859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1859),
    [anon_sym_as] = ACTIONS(1859),
    [anon_sym_DASH_DASH] = ACTIONS(1859),
    [anon_sym_instanceof] = ACTIONS(1859),
    [anon_sym_COLON] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(1859),
    [anon_sym_STAR_STAR] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(4712),
    [anon_sym_LT_LT] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_RBRACK] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_QMARK] = ACTIONS(1859),
    [anon_sym_PIPE_PIPE] = ACTIONS(1859),
    [anon_sym_EQ_EQ] = ACTIONS(1861),
    [anon_sym_RPAREN] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1861),
    [anon_sym_implements] = ACTIONS(1859),
    [anon_sym_GT_GT] = ACTIONS(1861),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1859),
  },
  [1741] = {
    [sym_type_arguments] = STATE(1765),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_GT_GT_GT] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_PERCENT] = ACTIONS(1865),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1865),
    [anon_sym_as] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_instanceof] = ACTIONS(1865),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_STAR_STAR] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_in] = ACTIONS(1867),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1867),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_EQ_EQ] = ACTIONS(1867),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(4714),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_implements] = ACTIONS(1865),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1865),
  },
  [1742] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1987),
    [anon_sym_BQUOTE] = ACTIONS(1987),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_GT_GT_GT] = ACTIONS(1987),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1987),
    [anon_sym_RBRACE] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1987),
    [anon_sym_as] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1987),
    [anon_sym_instanceof] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_STAR_STAR] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_RBRACK] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_SLASH] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1989),
    [anon_sym_implements] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1989),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1987),
  },
  [1743] = {
    [anon_sym_BQUOTE] = ACTIONS(1991),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1993),
    [anon_sym_return] = ACTIONS(1993),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_interface] = ACTIONS(1993),
    [anon_sym_delete] = ACTIONS(1993),
    [anon_sym_if] = ACTIONS(1993),
    [anon_sym_yield] = ACTIONS(1993),
    [sym_true] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_import] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1993),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_typeof] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1993),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [sym_null] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_var] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1991),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1993),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_with] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_debugger] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(1991),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_void] = ACTIONS(1993),
    [anon_sym_const] = ACTIONS(1993),
    [sym_super] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_default] = ACTIONS(1993),
    [anon_sym_enum] = ACTIONS(1993),
    [anon_sym_continue] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1991),
    [sym_this] = ACTIONS(1993),
    [anon_sym_throw] = ACTIONS(1993),
    [anon_sym_abstract] = ACTIONS(1993),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [sym_false] = ACTIONS(1993),
    [anon_sym_case] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_EQ_GT] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1991),
    [sym_number] = ACTIONS(1991),
    [ts_builtin_sym_end] = ACTIONS(1991),
    [anon_sym_function] = ACTIONS(1993),
    [sym_undefined] = ACTIONS(1993),
    [anon_sym_let] = ACTIONS(1993),
    [anon_sym_PLUS] = ACTIONS(1993),
    [anon_sym_do] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1991),
    [anon_sym_await] = ACTIONS(1993),
  },
  [1744] = {
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_if] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [sym_false] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [sym_null] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2143),
    [sym_number] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [ts_builtin_sym_end] = ACTIONS(2143),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
  },
  [1745] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2249),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2249),
    [anon_sym_as] = ACTIONS(2249),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_instanceof] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2249),
    [anon_sym_DOT] = ACTIONS(2249),
    [anon_sym_STAR_STAR] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [anon_sym_LT_LT] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_RBRACK] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_implements] = ACTIONS(2249),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2249),
  },
  [1746] = {
    [sym__automatic_semicolon] = ACTIONS(4717),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [sym_number] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [sym_readonly] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2249),
  },
  [1747] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [sym__automatic_semicolon] = ACTIONS(4665),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_STAR_STAR] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(1081),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_implements] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
  },
  [1748] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4719),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1749] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2514),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1750] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(2545),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1751] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(2545),
    [sym_null] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(321),
  },
  [1752] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2594),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1753] = {
    [sym_identifier] = ACTIONS(2626),
    [sym_jsx_identifier] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2624),
  },
  [1754] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1777),
    [sym_function_type] = STATE(1777),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1777),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1777),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1777),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1755] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2699),
    [anon_sym_BQUOTE] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_COMMA] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_GT_GT_GT] = ACTIONS(2699),
    [anon_sym_BANG_EQ] = ACTIONS(2701),
    [anon_sym_GT_EQ] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_PERCENT] = ACTIONS(2699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2699),
    [anon_sym_as] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_instanceof] = ACTIONS(2699),
    [anon_sym_COLON] = ACTIONS(2699),
    [anon_sym_DOT] = ACTIONS(2699),
    [anon_sym_STAR_STAR] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_in] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(2701),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_LT_EQ] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2699),
    [anon_sym_RBRACK] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2699),
    [anon_sym_EQ_EQ] = ACTIONS(2701),
    [anon_sym_RPAREN] = ACTIONS(2699),
    [anon_sym_LT] = ACTIONS(2701),
    [anon_sym_SLASH] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_implements] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2699),
  },
  [1756] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2703),
    [anon_sym_BQUOTE] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2705),
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_GT_GT_GT] = ACTIONS(2703),
    [anon_sym_BANG_EQ] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_PERCENT] = ACTIONS(2703),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2703),
    [anon_sym_as] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_instanceof] = ACTIONS(2703),
    [anon_sym_COLON] = ACTIONS(2703),
    [anon_sym_DOT] = ACTIONS(2703),
    [anon_sym_STAR_STAR] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_in] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(4712),
    [anon_sym_LT_LT] = ACTIONS(2703),
    [anon_sym_LBRACE] = ACTIONS(2705),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_LT_EQ] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_RBRACK] = ACTIONS(2703),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_QMARK] = ACTIONS(2703),
    [anon_sym_PIPE_PIPE] = ACTIONS(2703),
    [anon_sym_EQ_EQ] = ACTIONS(2705),
    [anon_sym_RPAREN] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_SLASH] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2703),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_implements] = ACTIONS(2703),
    [anon_sym_GT_GT] = ACTIONS(2705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2703),
  },
  [1757] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2721),
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2723),
    [anon_sym_GT_GT_GT] = ACTIONS(2721),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_GT_EQ] = ACTIONS(2721),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2721),
    [anon_sym_as] = ACTIONS(2721),
    [anon_sym_DASH_DASH] = ACTIONS(2721),
    [anon_sym_instanceof] = ACTIONS(2721),
    [anon_sym_COLON] = ACTIONS(2721),
    [anon_sym_DOT] = ACTIONS(2721),
    [anon_sym_STAR_STAR] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2721),
    [anon_sym_in] = ACTIONS(2723),
    [anon_sym_BANG] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_LT_EQ] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_RBRACK] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2721),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_EQ_EQ] = ACTIONS(2723),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2723),
    [anon_sym_SLASH] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_implements] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2721),
  },
  [1758] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2777),
    [anon_sym_STAR] = ACTIONS(2777),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_BANG_EQ] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2775),
    [anon_sym_as] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_instanceof] = ACTIONS(2775),
    [anon_sym_COLON] = ACTIONS(2775),
    [anon_sym_DOT] = ACTIONS(2775),
    [anon_sym_STAR_STAR] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_in] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2777),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_LBRACE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_RBRACK] = ACTIONS(2775),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_QMARK] = ACTIONS(2775),
    [anon_sym_PIPE_PIPE] = ACTIONS(2775),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2775),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_implements] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2775),
  },
  [1759] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(2779),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2781),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_GT_GT_GT] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2781),
    [anon_sym_GT_EQ] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_PERCENT] = ACTIONS(2779),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2779),
    [anon_sym_as] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2779),
    [anon_sym_instanceof] = ACTIONS(2779),
    [anon_sym_COLON] = ACTIONS(2779),
    [anon_sym_DOT] = ACTIONS(4661),
    [anon_sym_STAR_STAR] = ACTIONS(2779),
    [anon_sym_PLUS_PLUS] = ACTIONS(2779),
    [anon_sym_in] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_LT_LT] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2779),
    [anon_sym_LT_EQ] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_RBRACK] = ACTIONS(2779),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2779),
    [anon_sym_EQ_EQ] = ACTIONS(2781),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_LT] = ACTIONS(2781),
    [anon_sym_SLASH] = ACTIONS(2781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2781),
    [anon_sym_implements] = ACTIONS(2779),
    [anon_sym_GT_GT] = ACTIONS(2781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2779),
  },
  [1760] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_GT_GT_GT] = ACTIONS(2785),
    [anon_sym_BANG_EQ] = ACTIONS(2787),
    [anon_sym_GT_EQ] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_PERCENT] = ACTIONS(2785),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_as] = ACTIONS(2785),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_instanceof] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2785),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_STAR_STAR] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_LT_LT] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_LT_EQ] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_GT] = ACTIONS(2787),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(2785),
    [anon_sym_PIPE_PIPE] = ACTIONS(2785),
    [anon_sym_EQ_EQ] = ACTIONS(2787),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2787),
    [anon_sym_SLASH] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_implements] = ACTIONS(2785),
    [anon_sym_GT_GT] = ACTIONS(2787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2785),
  },
  [1761] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2789),
    [anon_sym_BQUOTE] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_GT_GT_GT] = ACTIONS(2789),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_GT_EQ] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_PERCENT] = ACTIONS(2789),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2789),
    [anon_sym_DASH_DASH] = ACTIONS(2789),
    [anon_sym_instanceof] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2789),
    [anon_sym_DOT] = ACTIONS(4667),
    [anon_sym_STAR_STAR] = ACTIONS(2789),
    [anon_sym_PLUS_PLUS] = ACTIONS(2789),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_BANG] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_LT_LT] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_RBRACK] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_EQ_EQ] = ACTIONS(2791),
    [anon_sym_RPAREN] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_SLASH] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_implements] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2789),
  },
  [1762] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [anon_sym_PIPE] = ACTIONS(2797),
    [anon_sym_COMMA] = ACTIONS(2795),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_GT_GT_GT] = ACTIONS(2795),
    [anon_sym_BANG_EQ] = ACTIONS(2797),
    [anon_sym_GT_EQ] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_PERCENT] = ACTIONS(2795),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2795),
    [anon_sym_as] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2795),
    [anon_sym_instanceof] = ACTIONS(2795),
    [anon_sym_COLON] = ACTIONS(2795),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_STAR_STAR] = ACTIONS(2795),
    [anon_sym_PLUS_PLUS] = ACTIONS(2795),
    [anon_sym_in] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_LT_LT] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(2797),
    [anon_sym_AMP_AMP] = ACTIONS(2795),
    [anon_sym_LT_EQ] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_RBRACK] = ACTIONS(2795),
    [anon_sym_GT] = ACTIONS(2797),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2795),
    [anon_sym_EQ_EQ] = ACTIONS(2797),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_implements] = ACTIONS(2795),
    [anon_sym_GT_GT] = ACTIONS(2797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2795),
  },
  [1763] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_STAR] = ACTIONS(2816),
    [anon_sym_GT_GT_GT] = ACTIONS(2814),
    [anon_sym_BANG_EQ] = ACTIONS(2816),
    [anon_sym_GT_EQ] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_PERCENT] = ACTIONS(2814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_as] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_instanceof] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2814),
    [anon_sym_DOT] = ACTIONS(2814),
    [anon_sym_STAR_STAR] = ACTIONS(2814),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_in] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT_LT] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_LT_EQ] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
    [anon_sym_QMARK] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2814),
    [anon_sym_EQ_EQ] = ACTIONS(2816),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2816),
    [anon_sym_SLASH] = ACTIONS(2816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_implements] = ACTIONS(2814),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2814),
  },
  [1764] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1782),
    [sym_function_type] = STATE(1782),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1782),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1782),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1782),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1765] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2820),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [anon_sym_PIPE] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_STAR] = ACTIONS(2822),
    [anon_sym_GT_GT_GT] = ACTIONS(2820),
    [anon_sym_BANG_EQ] = ACTIONS(2822),
    [anon_sym_GT_EQ] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_PERCENT] = ACTIONS(2820),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2820),
    [anon_sym_as] = ACTIONS(2820),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [anon_sym_instanceof] = ACTIONS(2820),
    [anon_sym_COLON] = ACTIONS(2820),
    [anon_sym_DOT] = ACTIONS(2820),
    [anon_sym_STAR_STAR] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_in] = ACTIONS(2822),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2820),
    [anon_sym_LT_LT] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_LT_EQ] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2820),
    [anon_sym_RBRACK] = ACTIONS(2820),
    [anon_sym_GT] = ACTIONS(2822),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_QMARK] = ACTIONS(2820),
    [anon_sym_PIPE_PIPE] = ACTIONS(2820),
    [anon_sym_EQ_EQ] = ACTIONS(2822),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_implements] = ACTIONS(2820),
    [anon_sym_GT_GT] = ACTIONS(2822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2820),
  },
  [1766] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_GT_GT_GT] = ACTIONS(2824),
    [anon_sym_BANG_EQ] = ACTIONS(2826),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_PERCENT] = ACTIONS(2824),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2824),
    [anon_sym_as] = ACTIONS(2824),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_instanceof] = ACTIONS(2824),
    [anon_sym_COLON] = ACTIONS(2824),
    [anon_sym_DOT] = ACTIONS(2824),
    [anon_sym_STAR_STAR] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_in] = ACTIONS(2826),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_LT_EQ] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_QMARK] = ACTIONS(2824),
    [anon_sym_PIPE_PIPE] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2826),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_implements] = ACTIONS(2824),
    [anon_sym_GT_GT] = ACTIONS(2826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2824),
  },
  [1767] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1784),
    [sym_function_type] = STATE(1784),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1784),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1784),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1784),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1768] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1785),
    [sym_function_type] = STATE(1785),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1785),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1785),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1785),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1769] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2900),
    [sym__automatic_semicolon] = ACTIONS(2900),
    [anon_sym_BQUOTE] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2900),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_GT_EQ] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_PERCENT] = ACTIONS(2900),
    [anon_sym_as] = ACTIONS(2900),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_instanceof] = ACTIONS(2900),
    [anon_sym_DOT] = ACTIONS(2900),
    [anon_sym_STAR_STAR] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_LT_LT] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_LT_EQ] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2900),
  },
  [1770] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3054),
    [anon_sym_symbol] = ACTIONS(3054),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_void] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [sym_super] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_private] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_yield] = ACTIONS(3054),
    [sym_true] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_protected] = ACTIONS(3054),
    [anon_sym_abstract] = ACTIONS(3054),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_type] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [sym_false] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_module] = ACTIONS(3054),
    [anon_sym_number] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_declare] = ACTIONS(3054),
    [anon_sym_typeof] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [sym_null] = ACTIONS(3054),
    [anon_sym_any] = ACTIONS(3054),
    [anon_sym_boolean] = ACTIONS(3054),
    [anon_sym_async] = ACTIONS(3054),
    [anon_sym_public] = ACTIONS(3054),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3054),
    [anon_sym_function] = ACTIONS(3054),
    [sym_undefined] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [ts_builtin_sym_end] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_export] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3054),
    [anon_sym_await] = ACTIONS(3054),
  },
  [1771] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3168),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_GT_GT_GT] = ACTIONS(3168),
    [anon_sym_BANG_EQ] = ACTIONS(3170),
    [anon_sym_GT_EQ] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_PERCENT] = ACTIONS(3168),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3168),
    [anon_sym_as] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_instanceof] = ACTIONS(3168),
    [anon_sym_COLON] = ACTIONS(3168),
    [anon_sym_DOT] = ACTIONS(3168),
    [anon_sym_STAR_STAR] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_in] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_RBRACK] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3168),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_EQ_EQ] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_implements] = ACTIONS(3168),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
  },
  [1772] = {
    [sym_identifier] = ACTIONS(3285),
    [sym_jsx_identifier] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3283),
  },
  [1773] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4721),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1774] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1775] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_RBRACK] = ACTIONS(2721),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1085),
  },
  [1776] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3471),
    [anon_sym_BQUOTE] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3473),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_GT_GT_GT] = ACTIONS(3471),
    [anon_sym_BANG_EQ] = ACTIONS(3473),
    [anon_sym_GT_EQ] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_PERCENT] = ACTIONS(3471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3471),
    [anon_sym_as] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3471),
    [anon_sym_instanceof] = ACTIONS(3471),
    [anon_sym_COLON] = ACTIONS(3471),
    [anon_sym_DOT] = ACTIONS(4598),
    [anon_sym_STAR_STAR] = ACTIONS(3471),
    [anon_sym_PLUS_PLUS] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_LT_LT] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3471),
    [anon_sym_LT_EQ] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_RBRACK] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3473),
    [anon_sym_QMARK] = ACTIONS(3471),
    [anon_sym_PIPE_PIPE] = ACTIONS(3471),
    [anon_sym_EQ_EQ] = ACTIONS(3473),
    [anon_sym_RPAREN] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3473),
    [anon_sym_SLASH] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_implements] = ACTIONS(3471),
    [anon_sym_GT_GT] = ACTIONS(3473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3471),
  },
  [1777] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3475),
    [anon_sym_BQUOTE] = ACTIONS(3475),
    [anon_sym_PIPE] = ACTIONS(4723),
    [anon_sym_COMMA] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_GT_GT_GT] = ACTIONS(3475),
    [anon_sym_BANG_EQ] = ACTIONS(3477),
    [anon_sym_GT_EQ] = ACTIONS(3475),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_PERCENT] = ACTIONS(3475),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3475),
    [anon_sym_as] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3475),
    [anon_sym_instanceof] = ACTIONS(3475),
    [anon_sym_COLON] = ACTIONS(3475),
    [anon_sym_DOT] = ACTIONS(3475),
    [anon_sym_STAR_STAR] = ACTIONS(3475),
    [anon_sym_PLUS_PLUS] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_LT_LT] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3475),
    [anon_sym_LT_EQ] = ACTIONS(3475),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_RBRACK] = ACTIONS(3475),
    [anon_sym_GT] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_QMARK] = ACTIONS(3475),
    [anon_sym_PIPE_PIPE] = ACTIONS(3475),
    [anon_sym_EQ_EQ] = ACTIONS(3477),
    [anon_sym_RPAREN] = ACTIONS(3475),
    [anon_sym_LT] = ACTIONS(3477),
    [anon_sym_SLASH] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3477),
    [anon_sym_implements] = ACTIONS(3475),
    [anon_sym_GT_GT] = ACTIONS(3477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3475),
  },
  [1778] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3505),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_GT_GT_GT] = ACTIONS(3505),
    [anon_sym_BANG_EQ] = ACTIONS(3507),
    [anon_sym_GT_EQ] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3505),
    [anon_sym_as] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_instanceof] = ACTIONS(3505),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_STAR_STAR] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_in] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LT_LT] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_LT_EQ] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_RBRACK] = ACTIONS(3505),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_PIPE_PIPE] = ACTIONS(3505),
    [anon_sym_EQ_EQ] = ACTIONS(3507),
    [anon_sym_RPAREN] = ACTIONS(3505),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(3507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_implements] = ACTIONS(3505),
    [anon_sym_GT_GT] = ACTIONS(3507),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3505),
  },
  [1779] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3515),
    [anon_sym_BQUOTE] = ACTIONS(3515),
    [anon_sym_PIPE] = ACTIONS(3517),
    [anon_sym_COMMA] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_GT_GT_GT] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3517),
    [anon_sym_GT_EQ] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3515),
    [anon_sym_as] = ACTIONS(3515),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_instanceof] = ACTIONS(3515),
    [anon_sym_COLON] = ACTIONS(3515),
    [anon_sym_DOT] = ACTIONS(3515),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LT_LT] = ACTIONS(3515),
    [anon_sym_LBRACE] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_LT_EQ] = ACTIONS(3515),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_RBRACK] = ACTIONS(3515),
    [anon_sym_GT] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_EQ_EQ] = ACTIONS(3517),
    [anon_sym_RPAREN] = ACTIONS(3515),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_SLASH] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_implements] = ACTIONS(3515),
    [anon_sym_GT_GT] = ACTIONS(3517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3515),
  },
  [1780] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1793),
    [sym_function_type] = STATE(1793),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1793),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1793),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1793),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1781] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_GT_GT_GT] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3525),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3523),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_instanceof] = ACTIONS(3523),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_STAR_STAR] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3523),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_RBRACK] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3525),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_implements] = ACTIONS(3523),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3523),
  },
  [1782] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(4723),
    [anon_sym_COMMA] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_instanceof] = ACTIONS(3527),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_STAR_STAR] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_implements] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3527),
  },
  [1783] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_RBRACK] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_EQ_EQ] = ACTIONS(3533),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_SLASH] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_implements] = ACTIONS(3531),
    [anon_sym_GT_GT] = ACTIONS(3533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
  },
  [1784] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3537),
    [anon_sym_BQUOTE] = ACTIONS(3537),
    [anon_sym_PIPE] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3537),
    [anon_sym_BANG_EQ] = ACTIONS(3539),
    [anon_sym_GT_EQ] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3537),
    [anon_sym_as] = ACTIONS(3537),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_instanceof] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3537),
    [anon_sym_STAR_STAR] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_in] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [anon_sym_LT_LT] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3537),
    [anon_sym_LT_EQ] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_RBRACK] = ACTIONS(3537),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3539),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_PIPE_PIPE] = ACTIONS(3537),
    [anon_sym_EQ_EQ] = ACTIONS(3539),
    [anon_sym_RPAREN] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3539),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_implements] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3537),
  },
  [1785] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3541),
    [anon_sym_BQUOTE] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3543),
    [anon_sym_GT_GT_GT] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3543),
    [anon_sym_GT_EQ] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_PERCENT] = ACTIONS(3541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3541),
    [anon_sym_as] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_instanceof] = ACTIONS(3541),
    [anon_sym_COLON] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3541),
    [anon_sym_STAR_STAR] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_in] = ACTIONS(3543),
    [anon_sym_BANG] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [anon_sym_LT_LT] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3543),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_LT_EQ] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3541),
    [anon_sym_RBRACK] = ACTIONS(3541),
    [anon_sym_GT] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_QMARK] = ACTIONS(3541),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_EQ_EQ] = ACTIONS(3543),
    [anon_sym_RPAREN] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3543),
    [anon_sym_SLASH] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_implements] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3541),
  },
  [1786] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3545),
    [anon_sym_BQUOTE] = ACTIONS(3545),
    [anon_sym_PIPE] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3547),
    [anon_sym_GT_GT_GT] = ACTIONS(3545),
    [anon_sym_BANG_EQ] = ACTIONS(3547),
    [anon_sym_GT_EQ] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3545),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_instanceof] = ACTIONS(3545),
    [anon_sym_COLON] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3545),
    [anon_sym_STAR_STAR] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_in] = ACTIONS(3547),
    [anon_sym_BANG] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [anon_sym_LT_LT] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3547),
    [anon_sym_AMP_AMP] = ACTIONS(3545),
    [anon_sym_LT_EQ] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_RBRACK] = ACTIONS(3545),
    [anon_sym_GT] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3545),
    [anon_sym_EQ_EQ] = ACTIONS(3547),
    [anon_sym_RPAREN] = ACTIONS(3545),
    [anon_sym_LT] = ACTIONS(3547),
    [anon_sym_SLASH] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_implements] = ACTIONS(3545),
    [anon_sym_GT_GT] = ACTIONS(3547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3545),
  },
  [1787] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1797),
    [sym_function_type] = STATE(1797),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1797),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1797),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1797),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1788] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(3667),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
  },
  [1789] = {
    [sym_identifier] = ACTIONS(3829),
    [sym_jsx_identifier] = ACTIONS(3827),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_SLASH] = ACTIONS(3829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3827),
  },
  [1790] = {
    [sym_identifier] = ACTIONS(3933),
    [sym_jsx_identifier] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3931),
    [anon_sym_SLASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3931),
  },
  [1791] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3971),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3971),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3969),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3971),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3971),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [anon_sym_GT] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3971),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_SLASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3971),
    [anon_sym_implements] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
  },
  [1792] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4008),
    [anon_sym_BQUOTE] = ACTIONS(4008),
    [anon_sym_PIPE] = ACTIONS(4010),
    [anon_sym_COMMA] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(4010),
    [anon_sym_STAR] = ACTIONS(4010),
    [anon_sym_GT_GT_GT] = ACTIONS(4008),
    [anon_sym_BANG_EQ] = ACTIONS(4010),
    [anon_sym_GT_EQ] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_PERCENT] = ACTIONS(4008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4008),
    [anon_sym_as] = ACTIONS(4008),
    [anon_sym_DASH_DASH] = ACTIONS(4008),
    [anon_sym_instanceof] = ACTIONS(4008),
    [anon_sym_COLON] = ACTIONS(4008),
    [anon_sym_DOT] = ACTIONS(4008),
    [anon_sym_STAR_STAR] = ACTIONS(4008),
    [anon_sym_PLUS_PLUS] = ACTIONS(4008),
    [anon_sym_in] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4010),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_LT_LT] = ACTIONS(4008),
    [anon_sym_LBRACE] = ACTIONS(4010),
    [anon_sym_AMP_AMP] = ACTIONS(4008),
    [anon_sym_LT_EQ] = ACTIONS(4008),
    [anon_sym_LPAREN] = ACTIONS(4008),
    [anon_sym_RBRACK] = ACTIONS(4008),
    [anon_sym_GT] = ACTIONS(4010),
    [anon_sym_AMP] = ACTIONS(4010),
    [anon_sym_QMARK] = ACTIONS(4008),
    [anon_sym_PIPE_PIPE] = ACTIONS(4008),
    [anon_sym_EQ_EQ] = ACTIONS(4010),
    [anon_sym_RPAREN] = ACTIONS(4008),
    [anon_sym_LT] = ACTIONS(4010),
    [anon_sym_SLASH] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4008),
    [anon_sym_PLUS] = ACTIONS(4010),
    [anon_sym_implements] = ACTIONS(4008),
    [anon_sym_GT_GT] = ACTIONS(4010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4008),
  },
  [1793] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4012),
    [anon_sym_BQUOTE] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(4723),
    [anon_sym_COMMA] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_GT_GT_GT] = ACTIONS(4012),
    [anon_sym_BANG_EQ] = ACTIONS(4014),
    [anon_sym_GT_EQ] = ACTIONS(4012),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_PERCENT] = ACTIONS(4012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4012),
    [anon_sym_as] = ACTIONS(4012),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [anon_sym_instanceof] = ACTIONS(4012),
    [anon_sym_COLON] = ACTIONS(4012),
    [anon_sym_DOT] = ACTIONS(4012),
    [anon_sym_STAR_STAR] = ACTIONS(4012),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_in] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_LT_LT] = ACTIONS(4012),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_AMP_AMP] = ACTIONS(4012),
    [anon_sym_LT_EQ] = ACTIONS(4012),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_RBRACK] = ACTIONS(4012),
    [anon_sym_GT] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_QMARK] = ACTIONS(4012),
    [anon_sym_PIPE_PIPE] = ACTIONS(4012),
    [anon_sym_EQ_EQ] = ACTIONS(4014),
    [anon_sym_RPAREN] = ACTIONS(4012),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_SLASH] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4012),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_implements] = ACTIONS(4012),
    [anon_sym_GT_GT] = ACTIONS(4014),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4012),
  },
  [1794] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1800),
    [sym_function_type] = STATE(1800),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1800),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1800),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1800),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1795] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4016),
    [anon_sym_PIPE] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4016),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_STAR] = ACTIONS(4018),
    [anon_sym_GT_GT_GT] = ACTIONS(4016),
    [anon_sym_BANG_EQ] = ACTIONS(4018),
    [anon_sym_GT_EQ] = ACTIONS(4016),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_PERCENT] = ACTIONS(4016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4016),
    [anon_sym_as] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4016),
    [anon_sym_instanceof] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4016),
    [anon_sym_DOT] = ACTIONS(4016),
    [anon_sym_STAR_STAR] = ACTIONS(4016),
    [anon_sym_PLUS_PLUS] = ACTIONS(4016),
    [anon_sym_in] = ACTIONS(4018),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_LBRACK] = ACTIONS(4016),
    [anon_sym_LT_LT] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_AMP_AMP] = ACTIONS(4016),
    [anon_sym_LT_EQ] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4016),
    [anon_sym_RBRACK] = ACTIONS(4016),
    [anon_sym_GT] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4016),
    [anon_sym_PIPE_PIPE] = ACTIONS(4016),
    [anon_sym_EQ_EQ] = ACTIONS(4018),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4018),
    [anon_sym_SLASH] = ACTIONS(4018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4018),
    [anon_sym_implements] = ACTIONS(4016),
    [anon_sym_GT_GT] = ACTIONS(4018),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4016),
  },
  [1796] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4020),
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_PIPE] = ACTIONS(4022),
    [anon_sym_COMMA] = ACTIONS(4020),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(4022),
    [anon_sym_GT_GT_GT] = ACTIONS(4020),
    [anon_sym_BANG_EQ] = ACTIONS(4022),
    [anon_sym_GT_EQ] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4020),
    [anon_sym_as] = ACTIONS(4020),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [anon_sym_instanceof] = ACTIONS(4020),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_DOT] = ACTIONS(4020),
    [anon_sym_STAR_STAR] = ACTIONS(4020),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_in] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [anon_sym_LT_LT] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_AMP_AMP] = ACTIONS(4020),
    [anon_sym_LT_EQ] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_GT] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_PIPE_PIPE] = ACTIONS(4020),
    [anon_sym_EQ_EQ] = ACTIONS(4022),
    [anon_sym_RPAREN] = ACTIONS(4020),
    [anon_sym_LT] = ACTIONS(4022),
    [anon_sym_SLASH] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_implements] = ACTIONS(4020),
    [anon_sym_GT_GT] = ACTIONS(4022),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4020),
  },
  [1797] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4024),
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(4723),
    [anon_sym_COMMA] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_STAR] = ACTIONS(4026),
    [anon_sym_GT_GT_GT] = ACTIONS(4024),
    [anon_sym_BANG_EQ] = ACTIONS(4026),
    [anon_sym_GT_EQ] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4024),
    [anon_sym_as] = ACTIONS(4024),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [anon_sym_instanceof] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_DOT] = ACTIONS(4024),
    [anon_sym_STAR_STAR] = ACTIONS(4024),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_in] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LT_LT] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4026),
    [anon_sym_AMP_AMP] = ACTIONS(4024),
    [anon_sym_LT_EQ] = ACTIONS(4024),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_RBRACK] = ACTIONS(4024),
    [anon_sym_GT] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_QMARK] = ACTIONS(4024),
    [anon_sym_PIPE_PIPE] = ACTIONS(4024),
    [anon_sym_EQ_EQ] = ACTIONS(4026),
    [anon_sym_RPAREN] = ACTIONS(4024),
    [anon_sym_LT] = ACTIONS(4026),
    [anon_sym_SLASH] = ACTIONS(4026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_implements] = ACTIONS(4024),
    [anon_sym_GT_GT] = ACTIONS(4026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4024),
  },
  [1798] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1799] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4212),
    [anon_sym_BQUOTE] = ACTIONS(4212),
    [anon_sym_PIPE] = ACTIONS(4214),
    [anon_sym_COMMA] = ACTIONS(4212),
    [anon_sym_DASH] = ACTIONS(4214),
    [anon_sym_STAR] = ACTIONS(4214),
    [anon_sym_GT_GT_GT] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(4214),
    [anon_sym_GT_EQ] = ACTIONS(4212),
    [anon_sym_RBRACE] = ACTIONS(4212),
    [anon_sym_PERCENT] = ACTIONS(4212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4212),
    [anon_sym_as] = ACTIONS(4212),
    [anon_sym_DASH_DASH] = ACTIONS(4212),
    [anon_sym_instanceof] = ACTIONS(4212),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_DOT] = ACTIONS(4212),
    [anon_sym_STAR_STAR] = ACTIONS(4212),
    [anon_sym_PLUS_PLUS] = ACTIONS(4212),
    [anon_sym_in] = ACTIONS(4214),
    [anon_sym_BANG] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4212),
    [anon_sym_LT_LT] = ACTIONS(4212),
    [anon_sym_LBRACE] = ACTIONS(4214),
    [anon_sym_AMP_AMP] = ACTIONS(4212),
    [anon_sym_LT_EQ] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(4212),
    [anon_sym_RBRACK] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4214),
    [anon_sym_AMP] = ACTIONS(4214),
    [anon_sym_QMARK] = ACTIONS(4212),
    [anon_sym_PIPE_PIPE] = ACTIONS(4212),
    [anon_sym_EQ_EQ] = ACTIONS(4214),
    [anon_sym_RPAREN] = ACTIONS(4212),
    [anon_sym_LT] = ACTIONS(4214),
    [anon_sym_SLASH] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4214),
    [anon_sym_implements] = ACTIONS(4212),
    [anon_sym_GT_GT] = ACTIONS(4214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4212),
  },
  [1800] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4238),
    [anon_sym_BQUOTE] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(4723),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_STAR] = ACTIONS(4240),
    [anon_sym_GT_GT_GT] = ACTIONS(4238),
    [anon_sym_BANG_EQ] = ACTIONS(4240),
    [anon_sym_GT_EQ] = ACTIONS(4238),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_PERCENT] = ACTIONS(4238),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4238),
    [anon_sym_as] = ACTIONS(4238),
    [anon_sym_DASH_DASH] = ACTIONS(4238),
    [anon_sym_instanceof] = ACTIONS(4238),
    [anon_sym_COLON] = ACTIONS(4238),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_STAR_STAR] = ACTIONS(4238),
    [anon_sym_PLUS_PLUS] = ACTIONS(4238),
    [anon_sym_in] = ACTIONS(4240),
    [anon_sym_BANG] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [anon_sym_LT_LT] = ACTIONS(4238),
    [anon_sym_LBRACE] = ACTIONS(4240),
    [anon_sym_AMP_AMP] = ACTIONS(4238),
    [anon_sym_LT_EQ] = ACTIONS(4238),
    [anon_sym_LPAREN] = ACTIONS(4238),
    [anon_sym_RBRACK] = ACTIONS(4238),
    [anon_sym_GT] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_QMARK] = ACTIONS(4238),
    [anon_sym_PIPE_PIPE] = ACTIONS(4238),
    [anon_sym_EQ_EQ] = ACTIONS(4240),
    [anon_sym_RPAREN] = ACTIONS(4238),
    [anon_sym_LT] = ACTIONS(4240),
    [anon_sym_SLASH] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4238),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_implements] = ACTIONS(4238),
    [anon_sym_GT_GT] = ACTIONS(4240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4238),
  },
  [1801] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4326),
    [anon_sym_BQUOTE] = ACTIONS(4326),
    [anon_sym_PIPE] = ACTIONS(4328),
    [anon_sym_COMMA] = ACTIONS(4326),
    [anon_sym_DASH] = ACTIONS(4328),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_GT_GT_GT] = ACTIONS(4326),
    [anon_sym_BANG_EQ] = ACTIONS(4328),
    [anon_sym_GT_EQ] = ACTIONS(4326),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [anon_sym_PERCENT] = ACTIONS(4326),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4326),
    [anon_sym_as] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4326),
    [anon_sym_instanceof] = ACTIONS(4326),
    [anon_sym_COLON] = ACTIONS(4326),
    [anon_sym_DOT] = ACTIONS(4326),
    [anon_sym_STAR_STAR] = ACTIONS(4326),
    [anon_sym_PLUS_PLUS] = ACTIONS(4326),
    [anon_sym_in] = ACTIONS(4328),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(4326),
    [anon_sym_LT_LT] = ACTIONS(4326),
    [anon_sym_LBRACE] = ACTIONS(4328),
    [anon_sym_AMP_AMP] = ACTIONS(4326),
    [anon_sym_LT_EQ] = ACTIONS(4326),
    [anon_sym_LPAREN] = ACTIONS(4326),
    [anon_sym_RBRACK] = ACTIONS(4326),
    [anon_sym_GT] = ACTIONS(4328),
    [anon_sym_AMP] = ACTIONS(4328),
    [anon_sym_QMARK] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE] = ACTIONS(4326),
    [anon_sym_EQ_EQ] = ACTIONS(4328),
    [anon_sym_RPAREN] = ACTIONS(4326),
    [anon_sym_LT] = ACTIONS(4328),
    [anon_sym_SLASH] = ACTIONS(4328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4328),
    [anon_sym_implements] = ACTIONS(4326),
    [anon_sym_GT_GT] = ACTIONS(4328),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4326),
  },
  [1802] = {
    [sym__automatic_semicolon] = ACTIONS(850),
    [anon_sym_LBRACK] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_SEMI] = ACTIONS(850),
    [anon_sym_QMARK] = ACTIONS(850),
    [anon_sym_RBRACE] = ACTIONS(850),
    [anon_sym_LT] = ACTIONS(850),
    [anon_sym_COMMA] = ACTIONS(850),
    [anon_sym_PIPE] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(850),
    [anon_sym_EQ] = ACTIONS(850),
    [anon_sym_COLON] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_PIPE_RBRACE] = ACTIONS(850),
    [anon_sym_BANG] = ACTIONS(850),
  },
  [1803] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BQUOTE] = ACTIONS(1797),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1801),
    [anon_sym_return] = ACTIONS(1801),
    [anon_sym_static] = ACTIONS(1801),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [anon_sym_interface] = ACTIONS(1801),
    [anon_sym_delete] = ACTIONS(1801),
    [anon_sym_if] = ACTIONS(1801),
    [anon_sym_yield] = ACTIONS(1801),
    [sym_true] = ACTIONS(1801),
    [anon_sym_protected] = ACTIONS(1801),
    [anon_sym_DOT] = ACTIONS(2793),
    [anon_sym_set] = ACTIONS(1801),
    [anon_sym_import] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(1801),
    [sym_null] = ACTIONS(1801),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_async] = ACTIONS(1801),
    [anon_sym_public] = ACTIONS(1801),
    [anon_sym_var] = ACTIONS(1801),
    [anon_sym_while] = ACTIONS(1801),
    [anon_sym_SQUOTE] = ACTIONS(1797),
    [anon_sym_SLASH] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1801),
    [anon_sym_export] = ACTIONS(1801),
    [anon_sym_with] = ACTIONS(1801),
    [sym_identifier] = ACTIONS(1801),
    [anon_sym_debugger] = ACTIONS(1801),
    [anon_sym_AT] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_const] = ACTIONS(1801),
    [sym_super] = ACTIONS(1801),
    [anon_sym_private] = ACTIONS(1801),
    [anon_sym_get] = ACTIONS(1801),
    [anon_sym_default] = ACTIONS(1801),
    [anon_sym_enum] = ACTIONS(1801),
    [anon_sym_continue] = ACTIONS(1801),
    [anon_sym_DASH_DASH] = ACTIONS(1797),
    [sym_this] = ACTIONS(1801),
    [anon_sym_throw] = ACTIONS(1801),
    [anon_sym_abstract] = ACTIONS(1801),
    [anon_sym_type] = ACTIONS(1801),
    [anon_sym_namespace] = ACTIONS(1801),
    [anon_sym_PLUS_PLUS] = ACTIONS(1797),
    [anon_sym_else] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [sym_false] = ACTIONS(1801),
    [anon_sym_case] = ACTIONS(1801),
    [anon_sym_module] = ACTIONS(1801),
    [anon_sym_class] = ACTIONS(1801),
    [anon_sym_declare] = ACTIONS(1801),
    [anon_sym_is] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_try] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(4729),
    [sym_number] = ACTIONS(1797),
    [ts_builtin_sym_end] = ACTIONS(1797),
    [anon_sym_function] = ACTIONS(1801),
    [sym_undefined] = ACTIONS(1801),
    [anon_sym_let] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1801),
    [anon_sym_do] = ACTIONS(1801),
    [anon_sym_TILDE] = ACTIONS(1797),
    [anon_sym_await] = ACTIONS(1801),
  },
  [1804] = {
    [sym_array_type] = STATE(613),
    [sym_generic_type] = STATE(613),
    [sym_type_predicate] = STATE(613),
    [sym_literal_type] = STATE(613),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(613),
    [sym__primary_type] = STATE(613),
    [sym_lookup_type] = STATE(613),
    [sym_parenthesized_type] = STATE(613),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(613),
    [sym_nested_type_identifier] = STATE(1807),
    [sym_tuple_type] = STATE(613),
    [sym_type_query] = STATE(613),
    [sym_index_type_query] = STATE(613),
    [sym_existential_type] = STATE(613),
    [sym_flow_maybe_type] = STATE(613),
    [sym_string] = STATE(328),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(1811),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1805] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(628),
    [sym_function_type] = STATE(628),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(628),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(628),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(628),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1806] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(639),
    [sym_function_type] = STATE(639),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(639),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(639),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(639),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1807] = {
    [sym_type_arguments] = STATE(642),
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1867),
    [anon_sym_return] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_delete] = ACTIONS(1867),
    [anon_sym_if] = ACTIONS(1867),
    [anon_sym_yield] = ACTIONS(1867),
    [sym_true] = ACTIONS(1867),
    [anon_sym_protected] = ACTIONS(1867),
    [anon_sym_set] = ACTIONS(1867),
    [anon_sym_import] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_number] = ACTIONS(1867),
    [anon_sym_typeof] = ACTIONS(1867),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1867),
    [sym_null] = ACTIONS(1867),
    [anon_sym_any] = ACTIONS(1867),
    [anon_sym_async] = ACTIONS(1867),
    [anon_sym_public] = ACTIONS(1867),
    [anon_sym_var] = ACTIONS(1867),
    [anon_sym_while] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1865),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1867),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_export] = ACTIONS(1867),
    [anon_sym_with] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_debugger] = ACTIONS(1867),
    [anon_sym_AT] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(1867),
    [sym_super] = ACTIONS(1867),
    [anon_sym_private] = ACTIONS(1867),
    [anon_sym_get] = ACTIONS(1867),
    [anon_sym_default] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1867),
    [anon_sym_continue] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [sym_this] = ACTIONS(1867),
    [anon_sym_throw] = ACTIONS(1867),
    [anon_sym_abstract] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1867),
    [anon_sym_namespace] = ACTIONS(1867),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_else] = ACTIONS(1867),
    [anon_sym_BANG] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [sym_false] = ACTIONS(1867),
    [anon_sym_case] = ACTIONS(1867),
    [anon_sym_module] = ACTIONS(1867),
    [anon_sym_class] = ACTIONS(1867),
    [anon_sym_declare] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_boolean] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_try] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(4732),
    [sym_number] = ACTIONS(1865),
    [ts_builtin_sym_end] = ACTIONS(1865),
    [anon_sym_function] = ACTIONS(1867),
    [sym_undefined] = ACTIONS(1867),
    [anon_sym_let] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1865),
    [anon_sym_await] = ACTIONS(1867),
  },
  [1808] = {
    [sym__automatic_semicolon] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1991),
  },
  [1809] = {
    [sym__automatic_semicolon] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_if] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [sym_false] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [sym_null] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2143),
    [sym_number] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [ts_builtin_sym_end] = ACTIONS(2143),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
  },
  [1810] = {
    [sym__automatic_semicolon] = ACTIONS(2249),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [sym_number] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [sym_readonly] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2249),
  },
  [1811] = {
    [sym__automatic_semicolon] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [sym_number] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_namespace] = ACTIONS(1083),
    [sym_readonly] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1081),
  },
  [1812] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_AMP_EQ] = ACTIONS(4737),
    [anon_sym_PLUS_EQ] = ACTIONS(4737),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4739),
    [anon_sym_GT] = ACTIONS(2503),
    [anon_sym_CARET_EQ] = ACTIONS(4737),
    [anon_sym_STAR_EQ] = ACTIONS(4737),
    [anon_sym_PIPE_EQ] = ACTIONS(4737),
    [anon_sym_DASH_EQ] = ACTIONS(4737),
    [anon_sym_EQ_GT] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4737),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1813] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1814] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_AMP_EQ] = ACTIONS(4745),
    [anon_sym_PLUS_EQ] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_CARET_EQ] = ACTIONS(4745),
    [anon_sym_STAR_EQ] = ACTIONS(4745),
    [anon_sym_PIPE_EQ] = ACTIONS(4745),
    [anon_sym_DASH_EQ] = ACTIONS(4745),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(4745),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1815] = {
    [sym_class] = STATE(2351),
    [sym_arrow_function] = STATE(2351),
    [sym_await_expression] = STATE(2351),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2351),
    [sym_meta_property] = STATE(2351),
    [sym__expression] = STATE(2351),
    [sym_jsx_element] = STATE(2351),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2351),
    [sym_call_expression] = STATE(2351),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2351),
    [sym_string] = STATE(2351),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2351),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2351),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2351),
    [sym_generator_function] = STATE(2351),
    [sym_new_expression] = STATE(2351),
    [sym_assignment_expression] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(2351),
    [sym_binary_expression] = STATE(2351),
    [sym_unary_expression] = STATE(2351),
    [sym_regex] = STATE(2351),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2351),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2351),
    [sym_internal_module] = STATE(2351),
    [sym_jsx_self_closing_element] = STATE(2351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4745),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(4745),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(1833),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4745),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(4745),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(4745),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4745),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(4751),
    [anon_sym_yield] = ACTIONS(1372),
    [sym_true] = ACTIONS(4751),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4745),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(4745),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(4755),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4745),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4751),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(1384),
  },
  [1816] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1817] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1828),
    [sym_function_type] = STATE(1828),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(1828),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(1828),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1828),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1818] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1830),
    [sym_function_type] = STATE(1830),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(1830),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(1830),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1830),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1819] = {
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2826),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_yield] = ACTIONS(2826),
    [sym_true] = ACTIONS(2826),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_set] = ACTIONS(2826),
    [anon_sym_import] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2826),
    [anon_sym_typeof] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2826),
    [sym_null] = ACTIONS(2826),
    [anon_sym_any] = ACTIONS(2826),
    [anon_sym_async] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_var] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_SLASH] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_with] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_debugger] = ACTIONS(2826),
    [anon_sym_AT] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [sym_super] = ACTIONS(2826),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_get] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [sym_this] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_abstract] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2826),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [sym_false] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_module] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_declare] = ACTIONS(2826),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2824),
    [sym_number] = ACTIONS(2824),
    [ts_builtin_sym_end] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2826),
    [sym_undefined] = ACTIONS(2826),
    [anon_sym_let] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_await] = ACTIONS(2826),
  },
  [1820] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(903),
    [sym_function_type] = STATE(903),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(903),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(903),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(903),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1821] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(904),
    [sym_function_type] = STATE(904),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(904),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(904),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(904),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1822] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2900),
    [anon_sym_BQUOTE] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2900),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_GT_EQ] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_PERCENT] = ACTIONS(2900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2900),
    [anon_sym_as] = ACTIONS(2900),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_instanceof] = ACTIONS(2900),
    [anon_sym_COLON] = ACTIONS(2900),
    [anon_sym_DOT] = ACTIONS(2900),
    [anon_sym_STAR_STAR] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [anon_sym_LT_LT] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_LT_EQ] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_RBRACK] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2900),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_RPAREN] = ACTIONS(2900),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_implements] = ACTIONS(2900),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2900),
  },
  [1823] = {
    [sym__automatic_semicolon] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3054),
    [anon_sym_symbol] = ACTIONS(3054),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_void] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [sym_super] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_private] = ACTIONS(3054),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3054),
    [sym_this] = ACTIONS(3054),
    [anon_sym_yield] = ACTIONS(3054),
    [sym_true] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_protected] = ACTIONS(3054),
    [anon_sym_abstract] = ACTIONS(3054),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_type] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [sym_false] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_module] = ACTIONS(3054),
    [anon_sym_number] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_declare] = ACTIONS(3054),
    [anon_sym_typeof] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [sym_null] = ACTIONS(3054),
    [anon_sym_any] = ACTIONS(3054),
    [anon_sym_boolean] = ACTIONS(3054),
    [anon_sym_async] = ACTIONS(3054),
    [anon_sym_public] = ACTIONS(3054),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_LT] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3054),
    [anon_sym_function] = ACTIONS(3054),
    [sym_undefined] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [ts_builtin_sym_end] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_export] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3054),
    [anon_sym_await] = ACTIONS(3054),
  },
  [1824] = {
    [sym__automatic_semicolon] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3168),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [sym_readonly] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3168),
  },
  [1825] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [sym__automatic_semicolon] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2779),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1826] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [sym__automatic_semicolon] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_PIPE] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2785),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1827] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1085),
  },
  [1828] = {
    [anon_sym_BQUOTE] = ACTIONS(3475),
    [anon_sym_symbol] = ACTIONS(3477),
    [anon_sym_PIPE] = ACTIONS(4135),
    [anon_sym_break] = ACTIONS(3477),
    [anon_sym_return] = ACTIONS(3477),
    [anon_sym_static] = ACTIONS(3477),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_interface] = ACTIONS(3477),
    [anon_sym_delete] = ACTIONS(3477),
    [anon_sym_if] = ACTIONS(3477),
    [anon_sym_yield] = ACTIONS(3477),
    [sym_true] = ACTIONS(3477),
    [anon_sym_protected] = ACTIONS(3477),
    [anon_sym_set] = ACTIONS(3477),
    [anon_sym_import] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3477),
    [anon_sym_SEMI] = ACTIONS(3475),
    [anon_sym_number] = ACTIONS(3477),
    [anon_sym_typeof] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3477),
    [sym_null] = ACTIONS(3477),
    [anon_sym_any] = ACTIONS(3477),
    [anon_sym_async] = ACTIONS(3477),
    [anon_sym_public] = ACTIONS(3477),
    [anon_sym_var] = ACTIONS(3477),
    [anon_sym_while] = ACTIONS(3477),
    [anon_sym_SQUOTE] = ACTIONS(3475),
    [anon_sym_SLASH] = ACTIONS(3477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3477),
    [anon_sym_export] = ACTIONS(3477),
    [anon_sym_with] = ACTIONS(3477),
    [sym_identifier] = ACTIONS(3477),
    [anon_sym_debugger] = ACTIONS(3477),
    [anon_sym_AT] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(3477),
    [anon_sym_void] = ACTIONS(3477),
    [anon_sym_const] = ACTIONS(3477),
    [sym_super] = ACTIONS(3477),
    [anon_sym_private] = ACTIONS(3477),
    [anon_sym_get] = ACTIONS(3477),
    [anon_sym_default] = ACTIONS(3477),
    [anon_sym_enum] = ACTIONS(3477),
    [anon_sym_continue] = ACTIONS(3477),
    [anon_sym_DASH_DASH] = ACTIONS(3475),
    [sym_this] = ACTIONS(3477),
    [anon_sym_throw] = ACTIONS(3477),
    [anon_sym_abstract] = ACTIONS(3477),
    [anon_sym_type] = ACTIONS(3477),
    [anon_sym_namespace] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3475),
    [anon_sym_else] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [sym_false] = ACTIONS(3477),
    [anon_sym_case] = ACTIONS(3477),
    [anon_sym_module] = ACTIONS(3477),
    [anon_sym_class] = ACTIONS(3477),
    [anon_sym_declare] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_boolean] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(3477),
    [anon_sym_LT] = ACTIONS(3475),
    [sym_number] = ACTIONS(3475),
    [ts_builtin_sym_end] = ACTIONS(3475),
    [anon_sym_function] = ACTIONS(3477),
    [sym_undefined] = ACTIONS(3477),
    [anon_sym_let] = ACTIONS(3477),
    [anon_sym_PLUS] = ACTIONS(3477),
    [anon_sym_do] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3475),
    [anon_sym_await] = ACTIONS(3477),
  },
  [1829] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1834),
    [sym_function_type] = STATE(1834),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(1834),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(1834),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1834),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1830] = {
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [anon_sym_symbol] = ACTIONS(3529),
    [anon_sym_PIPE] = ACTIONS(4135),
    [anon_sym_break] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3529),
    [anon_sym_static] = ACTIONS(3529),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3529),
    [anon_sym_delete] = ACTIONS(3529),
    [anon_sym_if] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3529),
    [sym_true] = ACTIONS(3529),
    [anon_sym_protected] = ACTIONS(3529),
    [anon_sym_set] = ACTIONS(3529),
    [anon_sym_import] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_number] = ACTIONS(3529),
    [anon_sym_typeof] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_switch] = ACTIONS(3529),
    [sym_null] = ACTIONS(3529),
    [anon_sym_any] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_public] = ACTIONS(3529),
    [anon_sym_var] = ACTIONS(3529),
    [anon_sym_while] = ACTIONS(3529),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3529),
    [anon_sym_export] = ACTIONS(3529),
    [anon_sym_with] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3529),
    [anon_sym_debugger] = ACTIONS(3529),
    [anon_sym_AT] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_void] = ACTIONS(3529),
    [anon_sym_const] = ACTIONS(3529),
    [sym_super] = ACTIONS(3529),
    [anon_sym_private] = ACTIONS(3529),
    [anon_sym_get] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3529),
    [anon_sym_continue] = ACTIONS(3529),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [sym_this] = ACTIONS(3529),
    [anon_sym_throw] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_type] = ACTIONS(3529),
    [anon_sym_namespace] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_else] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [sym_false] = ACTIONS(3529),
    [anon_sym_case] = ACTIONS(3529),
    [anon_sym_module] = ACTIONS(3529),
    [anon_sym_class] = ACTIONS(3529),
    [anon_sym_declare] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_boolean] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3527),
    [sym_number] = ACTIONS(3527),
    [ts_builtin_sym_end] = ACTIONS(3527),
    [anon_sym_function] = ACTIONS(3529),
    [sym_undefined] = ACTIONS(3529),
    [anon_sym_let] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_do] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_await] = ACTIONS(3529),
  },
  [1831] = {
    [anon_sym_BQUOTE] = ACTIONS(3545),
    [anon_sym_symbol] = ACTIONS(3547),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_delete] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_yield] = ACTIONS(3547),
    [sym_true] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_set] = ACTIONS(3547),
    [anon_sym_import] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_number] = ACTIONS(3547),
    [anon_sym_typeof] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_switch] = ACTIONS(3547),
    [sym_null] = ACTIONS(3547),
    [anon_sym_any] = ACTIONS(3547),
    [anon_sym_async] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_var] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [anon_sym_SLASH] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_export] = ACTIONS(3547),
    [anon_sym_with] = ACTIONS(3547),
    [sym_identifier] = ACTIONS(3547),
    [anon_sym_debugger] = ACTIONS(3547),
    [anon_sym_AT] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_void] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [sym_super] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_get] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [sym_this] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_type] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_else] = ACTIONS(3547),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [sym_false] = ACTIONS(3547),
    [anon_sym_case] = ACTIONS(3547),
    [anon_sym_module] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_declare] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_boolean] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3545),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_LT] = ACTIONS(3545),
    [sym_number] = ACTIONS(3545),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [anon_sym_function] = ACTIONS(3547),
    [sym_undefined] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_await] = ACTIONS(3547),
  },
  [1832] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1837),
    [sym_function_type] = STATE(1837),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(1837),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(1837),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1837),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1833] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3661),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RBRACK] = ACTIONS(3661),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1834] = {
    [anon_sym_BQUOTE] = ACTIONS(4012),
    [anon_sym_symbol] = ACTIONS(4014),
    [anon_sym_PIPE] = ACTIONS(4135),
    [anon_sym_break] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4014),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_interface] = ACTIONS(4014),
    [anon_sym_delete] = ACTIONS(4014),
    [anon_sym_if] = ACTIONS(4014),
    [anon_sym_yield] = ACTIONS(4014),
    [sym_true] = ACTIONS(4014),
    [anon_sym_protected] = ACTIONS(4014),
    [anon_sym_set] = ACTIONS(4014),
    [anon_sym_import] = ACTIONS(4014),
    [anon_sym_DQUOTE] = ACTIONS(4012),
    [anon_sym_for] = ACTIONS(4014),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym_number] = ACTIONS(4014),
    [anon_sym_typeof] = ACTIONS(4014),
    [anon_sym_LBRACE] = ACTIONS(4012),
    [anon_sym_switch] = ACTIONS(4014),
    [sym_null] = ACTIONS(4014),
    [anon_sym_any] = ACTIONS(4014),
    [anon_sym_async] = ACTIONS(4014),
    [anon_sym_public] = ACTIONS(4014),
    [anon_sym_var] = ACTIONS(4014),
    [anon_sym_while] = ACTIONS(4014),
    [anon_sym_SQUOTE] = ACTIONS(4012),
    [anon_sym_SLASH] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4014),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_export] = ACTIONS(4014),
    [anon_sym_with] = ACTIONS(4014),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_debugger] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_void] = ACTIONS(4014),
    [anon_sym_const] = ACTIONS(4014),
    [sym_super] = ACTIONS(4014),
    [anon_sym_private] = ACTIONS(4014),
    [anon_sym_get] = ACTIONS(4014),
    [anon_sym_default] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(4014),
    [anon_sym_DASH_DASH] = ACTIONS(4012),
    [sym_this] = ACTIONS(4014),
    [anon_sym_throw] = ACTIONS(4014),
    [anon_sym_abstract] = ACTIONS(4014),
    [anon_sym_type] = ACTIONS(4014),
    [anon_sym_namespace] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4012),
    [anon_sym_else] = ACTIONS(4014),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [sym_false] = ACTIONS(4014),
    [anon_sym_case] = ACTIONS(4014),
    [anon_sym_module] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_declare] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_boolean] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4014),
    [anon_sym_LT] = ACTIONS(4012),
    [sym_number] = ACTIONS(4012),
    [ts_builtin_sym_end] = ACTIONS(4012),
    [anon_sym_function] = ACTIONS(4014),
    [sym_undefined] = ACTIONS(4014),
    [anon_sym_let] = ACTIONS(4014),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_do] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_await] = ACTIONS(4014),
  },
  [1835] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1839),
    [sym_function_type] = STATE(1839),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(1807),
    [sym__type] = STATE(1839),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2672),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2288),
    [sym_constructor_type] = STATE(1839),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1839),
    [sym_identifier] = ACTIONS(3739),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3745),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1836] = {
    [anon_sym_BQUOTE] = ACTIONS(4020),
    [anon_sym_symbol] = ACTIONS(4022),
    [anon_sym_PIPE] = ACTIONS(4020),
    [anon_sym_break] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4022),
    [anon_sym_static] = ACTIONS(4022),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [anon_sym_interface] = ACTIONS(4022),
    [anon_sym_delete] = ACTIONS(4022),
    [anon_sym_if] = ACTIONS(4022),
    [anon_sym_yield] = ACTIONS(4022),
    [sym_true] = ACTIONS(4022),
    [anon_sym_protected] = ACTIONS(4022),
    [anon_sym_set] = ACTIONS(4022),
    [anon_sym_import] = ACTIONS(4022),
    [anon_sym_DQUOTE] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4022),
    [anon_sym_SEMI] = ACTIONS(4020),
    [anon_sym_number] = ACTIONS(4022),
    [anon_sym_typeof] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4022),
    [sym_null] = ACTIONS(4022),
    [anon_sym_any] = ACTIONS(4022),
    [anon_sym_async] = ACTIONS(4022),
    [anon_sym_public] = ACTIONS(4022),
    [anon_sym_var] = ACTIONS(4022),
    [anon_sym_while] = ACTIONS(4022),
    [anon_sym_SQUOTE] = ACTIONS(4020),
    [anon_sym_SLASH] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4022),
    [anon_sym_new] = ACTIONS(4022),
    [anon_sym_export] = ACTIONS(4022),
    [anon_sym_with] = ACTIONS(4022),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_debugger] = ACTIONS(4022),
    [anon_sym_AT] = ACTIONS(4020),
    [anon_sym_DASH] = ACTIONS(4022),
    [anon_sym_void] = ACTIONS(4022),
    [anon_sym_const] = ACTIONS(4022),
    [sym_super] = ACTIONS(4022),
    [anon_sym_private] = ACTIONS(4022),
    [anon_sym_get] = ACTIONS(4022),
    [anon_sym_default] = ACTIONS(4022),
    [anon_sym_enum] = ACTIONS(4022),
    [anon_sym_continue] = ACTIONS(4022),
    [anon_sym_DASH_DASH] = ACTIONS(4020),
    [sym_this] = ACTIONS(4022),
    [anon_sym_throw] = ACTIONS(4022),
    [anon_sym_abstract] = ACTIONS(4022),
    [anon_sym_type] = ACTIONS(4022),
    [anon_sym_namespace] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4020),
    [anon_sym_else] = ACTIONS(4022),
    [anon_sym_BANG] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4020),
    [sym_false] = ACTIONS(4022),
    [anon_sym_case] = ACTIONS(4022),
    [anon_sym_module] = ACTIONS(4022),
    [anon_sym_class] = ACTIONS(4022),
    [anon_sym_declare] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(4020),
    [anon_sym_boolean] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4020),
    [anon_sym_try] = ACTIONS(4022),
    [anon_sym_LT] = ACTIONS(4020),
    [sym_number] = ACTIONS(4020),
    [ts_builtin_sym_end] = ACTIONS(4020),
    [anon_sym_function] = ACTIONS(4022),
    [sym_undefined] = ACTIONS(4022),
    [anon_sym_let] = ACTIONS(4022),
    [anon_sym_PLUS] = ACTIONS(4022),
    [anon_sym_do] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4020),
    [anon_sym_await] = ACTIONS(4022),
  },
  [1837] = {
    [anon_sym_BQUOTE] = ACTIONS(4024),
    [anon_sym_symbol] = ACTIONS(4026),
    [anon_sym_PIPE] = ACTIONS(4135),
    [anon_sym_break] = ACTIONS(4026),
    [anon_sym_return] = ACTIONS(4026),
    [anon_sym_static] = ACTIONS(4026),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_interface] = ACTIONS(4026),
    [anon_sym_delete] = ACTIONS(4026),
    [anon_sym_if] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [sym_true] = ACTIONS(4026),
    [anon_sym_protected] = ACTIONS(4026),
    [anon_sym_set] = ACTIONS(4026),
    [anon_sym_import] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_for] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_number] = ACTIONS(4026),
    [anon_sym_typeof] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4026),
    [sym_null] = ACTIONS(4026),
    [anon_sym_any] = ACTIONS(4026),
    [anon_sym_async] = ACTIONS(4026),
    [anon_sym_public] = ACTIONS(4026),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_while] = ACTIONS(4026),
    [anon_sym_SQUOTE] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(4026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4026),
    [anon_sym_new] = ACTIONS(4026),
    [anon_sym_export] = ACTIONS(4026),
    [anon_sym_with] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [anon_sym_debugger] = ACTIONS(4026),
    [anon_sym_AT] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_void] = ACTIONS(4026),
    [anon_sym_const] = ACTIONS(4026),
    [sym_super] = ACTIONS(4026),
    [anon_sym_private] = ACTIONS(4026),
    [anon_sym_get] = ACTIONS(4026),
    [anon_sym_default] = ACTIONS(4026),
    [anon_sym_enum] = ACTIONS(4026),
    [anon_sym_continue] = ACTIONS(4026),
    [anon_sym_DASH_DASH] = ACTIONS(4024),
    [sym_this] = ACTIONS(4026),
    [anon_sym_throw] = ACTIONS(4026),
    [anon_sym_abstract] = ACTIONS(4026),
    [anon_sym_type] = ACTIONS(4026),
    [anon_sym_namespace] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4024),
    [anon_sym_else] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [sym_false] = ACTIONS(4026),
    [anon_sym_case] = ACTIONS(4026),
    [anon_sym_module] = ACTIONS(4026),
    [anon_sym_class] = ACTIONS(4026),
    [anon_sym_declare] = ACTIONS(4026),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_boolean] = ACTIONS(4026),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4024),
    [sym_number] = ACTIONS(4024),
    [ts_builtin_sym_end] = ACTIONS(4024),
    [anon_sym_function] = ACTIONS(4026),
    [sym_undefined] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_TILDE] = ACTIONS(4024),
    [anon_sym_await] = ACTIONS(4026),
  },
  [1838] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1839] = {
    [anon_sym_BQUOTE] = ACTIONS(4238),
    [anon_sym_symbol] = ACTIONS(4240),
    [anon_sym_PIPE] = ACTIONS(4135),
    [anon_sym_break] = ACTIONS(4240),
    [anon_sym_return] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_delete] = ACTIONS(4240),
    [anon_sym_if] = ACTIONS(4240),
    [anon_sym_yield] = ACTIONS(4240),
    [sym_true] = ACTIONS(4240),
    [anon_sym_protected] = ACTIONS(4240),
    [anon_sym_set] = ACTIONS(4240),
    [anon_sym_import] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_for] = ACTIONS(4240),
    [anon_sym_SEMI] = ACTIONS(4238),
    [anon_sym_number] = ACTIONS(4240),
    [anon_sym_typeof] = ACTIONS(4240),
    [anon_sym_LBRACE] = ACTIONS(4238),
    [anon_sym_switch] = ACTIONS(4240),
    [sym_null] = ACTIONS(4240),
    [anon_sym_any] = ACTIONS(4240),
    [anon_sym_async] = ACTIONS(4240),
    [anon_sym_public] = ACTIONS(4240),
    [anon_sym_var] = ACTIONS(4240),
    [anon_sym_while] = ACTIONS(4240),
    [anon_sym_SQUOTE] = ACTIONS(4238),
    [anon_sym_SLASH] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4240),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_export] = ACTIONS(4240),
    [anon_sym_with] = ACTIONS(4240),
    [sym_identifier] = ACTIONS(4240),
    [anon_sym_debugger] = ACTIONS(4240),
    [anon_sym_AT] = ACTIONS(4238),
    [anon_sym_DASH] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(4240),
    [anon_sym_const] = ACTIONS(4240),
    [sym_super] = ACTIONS(4240),
    [anon_sym_private] = ACTIONS(4240),
    [anon_sym_get] = ACTIONS(4240),
    [anon_sym_default] = ACTIONS(4240),
    [anon_sym_enum] = ACTIONS(4240),
    [anon_sym_continue] = ACTIONS(4240),
    [anon_sym_DASH_DASH] = ACTIONS(4238),
    [sym_this] = ACTIONS(4240),
    [anon_sym_throw] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_type] = ACTIONS(4240),
    [anon_sym_namespace] = ACTIONS(4240),
    [anon_sym_PLUS_PLUS] = ACTIONS(4238),
    [anon_sym_else] = ACTIONS(4240),
    [anon_sym_BANG] = ACTIONS(4238),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [sym_false] = ACTIONS(4240),
    [anon_sym_case] = ACTIONS(4240),
    [anon_sym_module] = ACTIONS(4240),
    [anon_sym_class] = ACTIONS(4240),
    [anon_sym_declare] = ACTIONS(4240),
    [anon_sym_LPAREN] = ACTIONS(4238),
    [anon_sym_boolean] = ACTIONS(4240),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_try] = ACTIONS(4240),
    [anon_sym_LT] = ACTIONS(4238),
    [sym_number] = ACTIONS(4238),
    [ts_builtin_sym_end] = ACTIONS(4238),
    [anon_sym_function] = ACTIONS(4240),
    [sym_undefined] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_PLUS] = ACTIONS(4240),
    [anon_sym_do] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4238),
    [anon_sym_await] = ACTIONS(4240),
  },
  [1840] = {
    [sym_identifier] = ACTIONS(852),
    [sym_jsx_identifier] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(850),
    [anon_sym_SLASH] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(850),
  },
  [1841] = {
    [sym_identifier] = ACTIONS(1993),
    [sym_jsx_identifier] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1991),
  },
  [1842] = {
    [sym__automatic_semicolon] = ACTIONS(2249),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_if] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_false] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [sym_null] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2249),
    [sym_number] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
  },
  [1843] = {
    [sym__automatic_semicolon] = ACTIONS(4759),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [anon_sym_debugger] = ACTIONS(1083),
    [anon_sym_symbol] = ACTIONS(1083),
    [anon_sym_AT] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_const] = ACTIONS(1083),
    [sym_super] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_private] = ACTIONS(1083),
    [anon_sym_static] = ACTIONS(1083),
    [anon_sym_get] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_interface] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1083),
    [sym_this] = ACTIONS(1083),
    [anon_sym_yield] = ACTIONS(1083),
    [sym_true] = ACTIONS(1083),
    [anon_sym_throw] = ACTIONS(1083),
    [anon_sym_protected] = ACTIONS(1083),
    [anon_sym_abstract] = ACTIONS(1083),
    [anon_sym_set] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1083),
    [anon_sym_import] = ACTIONS(1083),
    [anon_sym_namespace] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_else] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [sym_false] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_case] = ACTIONS(1083),
    [anon_sym_module] = ACTIONS(1083),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_class] = ACTIONS(1083),
    [anon_sym_declare] = ACTIONS(1083),
    [anon_sym_typeof] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [sym_null] = ACTIONS(1083),
    [anon_sym_any] = ACTIONS(1083),
    [anon_sym_boolean] = ACTIONS(1083),
    [anon_sym_async] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1083),
    [anon_sym_var] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [anon_sym_try] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1081),
    [sym_number] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1083),
    [anon_sym_function] = ACTIONS(1083),
    [sym_undefined] = ACTIONS(1083),
    [anon_sym_new] = ACTIONS(1083),
    [ts_builtin_sym_end] = ACTIONS(1081),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_with] = ACTIONS(1083),
    [anon_sym_await] = ACTIONS(1083),
  },
  [1844] = {
    [sym_type_arguments] = STATE(1671),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [sym__automatic_semicolon] = ACTIONS(1797),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(4633),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(4761),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(4764),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1797),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1845] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1846] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [sym__automatic_semicolon] = ACTIONS(1833),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1833),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1847] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(1833),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1833),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(321),
  },
  [1848] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1865),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1849] = {
    [sym__automatic_semicolon] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_DOT] = ACTIONS(2900),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2900),
  },
  [1850] = {
    [sym__automatic_semicolon] = ACTIONS(3168),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [sym_super] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [sym_false] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [sym_null] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_function] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [ts_builtin_sym_end] = ACTIONS(3168),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_with] = ACTIONS(3170),
    [anon_sym_await] = ACTIONS(3170),
  },
  [1851] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [sym__automatic_semicolon] = ACTIONS(2721),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_BANG_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_GT] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1085),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1085),
  },
  [1852] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1711),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(3661),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1711),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1853] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [sym__automatic_semicolon] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(4181),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1854] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [sym__automatic_semicolon] = ACTIONS(1805),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1805),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1855] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [sym__automatic_semicolon] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(3667),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1856] = {
    [sym__automatic_semicolon] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(3664),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(3664),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2900),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1857] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [sym__automatic_semicolon] = ACTIONS(3471),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_PERCENT_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_AMP_EQ] = ACTIONS(1711),
    [anon_sym_PLUS_EQ] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3661),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1711),
    [anon_sym_STAR_EQ] = ACTIONS(1711),
    [anon_sym_PIPE_EQ] = ACTIONS(1711),
    [anon_sym_DASH_EQ] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(3661),
    [anon_sym_AMP] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(1711),
    [anon_sym_LT_LT_EQ] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(3667),
    [anon_sym_SLASH] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT_EQ] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(3664),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1711),
    [anon_sym_GT_GT] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_in] = ACTIONS(1713),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1713),
  },
  [1858] = {
    [aux_sym_template_string_repeat1] = STATE(1871),
    [sym_template_substitution] = STATE(1871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(4766),
    [sym__template_chars] = ACTIONS(4768),
    [sym_escape_sequence] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
  },
  [1859] = {
    [sym_class] = STATE(1321),
    [sym_arrow_function] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_jsx_element] = STATE(1321),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1321),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_regex] = STATE(1321),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1321),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1321),
    [sym_internal_module] = STATE(1321),
    [sym_jsx_self_closing_element] = STATE(1321),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4562),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4562),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4562),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4770),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1860] = {
    [sym_string] = STATE(1639),
    [sym_nested_identifier] = STATE(1638),
    [sym__module] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(697),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1861] = {
    [aux_sym_string_repeat1] = STATE(1881),
    [sym_escape_sequence] = ACTIONS(4774),
    [aux_sym_string_token1] = ACTIONS(4776),
    [anon_sym_DQUOTE] = ACTIONS(4778),
    [sym_comment] = ACTIONS(255),
  },
  [1862] = {
    [sym_await_expression] = STATE(1883),
    [sym_update_expression] = STATE(1883),
    [sym_meta_property] = STATE(1883),
    [sym__expression] = STATE(1883),
    [sym_jsx_element] = STATE(1883),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1883),
    [sym_call_expression] = STATE(1883),
    [sym_ternary_expression] = STATE(1883),
    [sym_template_string] = STATE(1883),
    [sym_yield_expression] = STATE(1883),
    [sym_jsx_fragment] = STATE(1883),
    [sym_new_expression] = STATE(1883),
    [sym_assignment_expression] = STATE(1883),
    [sym_binary_expression] = STATE(1883),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1883),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1883),
    [sym_jsx_self_closing_element] = STATE(1883),
    [sym_arrow_function] = STATE(1883),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(1884),
    [sym_string] = STATE(1883),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1883),
    [sym_augmented_assignment_expression] = STATE(1883),
    [sym_unary_expression] = STATE(1883),
    [sym_regex] = STATE(1883),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(1885),
    [sym_non_null_expression] = STATE(1883),
    [sym_class] = STATE(1883),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4558),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4558),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4558),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [sym_null] = ACTIONS(4558),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4780),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4558),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1863] = {
    [sym_generator_function_declaration] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(184),
    [sym_jsx_element] = STATE(51),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(187),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(187),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(187),
    [sym_arrow_function] = STATE(51),
    [sym_continue_statement] = STATE(187),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(187),
    [sym_type_alias_declaration] = STATE(187),
    [sym_import_statement] = STATE(187),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(187),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(187),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(187),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_export_statement] = STATE(187),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(187),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(187),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(184),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(187),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(187),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(187),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(187),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(187),
    [sym_template_string] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(187),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(187),
    [sym_parenthesized_expression] = STATE(53),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_class_declaration] = STATE(187),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(187),
    [sym_spread_element] = STATE(184),
    [sym_try_statement] = STATE(187),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_abstract_class_declaration] = STATE(187),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(187),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(187),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(184),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_static] = ACTIONS(385),
    [anon_sym_get] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(4782),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(391),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(393),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(397),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(399),
    [anon_sym_number] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(375),
    [anon_sym_boolean] = ACTIONS(375),
    [anon_sym_async] = ACTIONS(403),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1864] = {
    [aux_sym_string_repeat2] = STATE(1915),
    [sym_escape_sequence] = ACTIONS(4784),
    [aux_sym_string_token2] = ACTIONS(4786),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(4778),
  },
  [1865] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [sym_identifier] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4568),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(4570),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(4568),
    [anon_sym_static] = ACTIONS(4568),
    [anon_sym_get] = ACTIONS(4568),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(4572),
    [anon_sym_protected] = ACTIONS(4568),
    [anon_sym_DOT] = ACTIONS(4574),
    [anon_sym_set] = ACTIONS(4568),
    [anon_sym_type] = ACTIONS(4568),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(4576),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4572),
    [anon_sym_module] = ACTIONS(4568),
    [anon_sym_number] = ACTIONS(4568),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4568),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [anon_sym_any] = ACTIONS(4568),
    [anon_sym_boolean] = ACTIONS(4568),
    [anon_sym_async] = ACTIONS(4578),
    [anon_sym_public] = ACTIONS(4568),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4580),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4568),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [1866] = {
    [sym_jsx_element] = STATE(1926),
    [sym_jsx_expression] = STATE(1926),
    [aux_sym_jsx_element_repeat1] = STATE(1926),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(1376),
    [sym_jsx_self_closing_element] = STATE(1926),
    [sym_jsx_text] = ACTIONS(4788),
    [anon_sym_LT] = ACTIONS(4790),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [1867] = {
    [anon_sym_EQ_GT] = ACTIONS(4792),
    [sym_comment] = ACTIONS(3),
  },
  [1868] = {
    [sym_formal_parameters] = STATE(1378),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [1869] = {
    [sym_generator_function_declaration] = STATE(284),
    [sym__declaration] = STATE(284),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(284),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(284),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(284),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(284),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(284),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(284),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(284),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(284),
    [sym_function_declaration] = STATE(284),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(284),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(284),
    [sym_break_statement] = STATE(284),
    [sym_labeled_statement] = STATE(284),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(284),
    [sym_class_declaration] = STATE(284),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(284),
    [sym_ambient_declaration] = STATE(284),
    [sym_type_alias_declaration] = STATE(284),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(284),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(284),
    [sym_switch_statement] = STATE(284),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(284),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(284),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(284),
    [sym_abstract_class_declaration] = STATE(284),
    [sym_interface_declaration] = STATE(284),
    [sym_export_statement] = STATE(284),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(284),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(284),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(284),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [1870] = {
    [sym_identifier] = ACTIONS(4794),
    [sym_comment] = ACTIONS(3),
  },
  [1871] = {
    [aux_sym_template_string_repeat1] = STATE(290),
    [sym_template_substitution] = STATE(290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(4796),
    [sym__template_chars] = ACTIONS(641),
    [sym_escape_sequence] = ACTIONS(641),
    [sym_comment] = ACTIONS(3),
  },
  [1872] = {
    [sym_identifier] = ACTIONS(4798),
    [sym_comment] = ACTIONS(3),
  },
  [1873] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1888),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1334),
    [sym_type_parameters] = STATE(1889),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(4800),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [1874] = {
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_object] = STATE(307),
    [sym_accessibility_modifier] = STATE(190),
    [sym_pair] = STATE(1904),
    [sym__property_name] = STATE(186),
    [sym_method_definition] = STATE(1904),
    [sym_assignment_pattern] = STATE(1904),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(1904),
    [sym_string] = STATE(186),
    [sym_identifier] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_module] = ACTIONS(4804),
    [anon_sym_symbol] = ACTIONS(4804),
    [anon_sym_number] = ACTIONS(4804),
    [anon_sym_declare] = ACTIONS(4804),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4804),
    [anon_sym_any] = ACTIONS(4804),
    [anon_sym_private] = ACTIONS(4806),
    [anon_sym_boolean] = ACTIONS(4804),
    [anon_sym_async] = ACTIONS(4808),
    [anon_sym_public] = ACTIONS(4806),
    [anon_sym_get] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_number] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4806),
    [anon_sym_string] = ACTIONS(4804),
    [anon_sym_set] = ACTIONS(4810),
    [anon_sym_type] = ACTIONS(4804),
    [anon_sym_export] = ACTIONS(4804),
    [anon_sym_namespace] = ACTIONS(4804),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1875] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1943),
    [sym__automatic_semicolon] = ACTIONS(4816),
    [anon_sym_SEMI] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [1876] = {
    [sym_await_expression] = STATE(1952),
    [sym_update_expression] = STATE(1952),
    [sym_meta_property] = STATE(1952),
    [sym__expression] = STATE(1952),
    [sym_jsx_element] = STATE(1952),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1952),
    [sym_call_expression] = STATE(1952),
    [sym_ternary_expression] = STATE(1952),
    [sym_template_string] = STATE(1952),
    [sym_yield_expression] = STATE(1952),
    [sym_jsx_fragment] = STATE(1952),
    [sym_new_expression] = STATE(1952),
    [sym_assignment_expression] = STATE(1952),
    [sym_binary_expression] = STATE(1952),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1952),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1952),
    [sym_jsx_self_closing_element] = STATE(1952),
    [sym_arrow_function] = STATE(1952),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(1953),
    [sym_string] = STATE(1952),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1952),
    [sym_augmented_assignment_expression] = STATE(1952),
    [sym_unary_expression] = STATE(1952),
    [sym_regex] = STATE(1952),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(1954),
    [sym_non_null_expression] = STATE(1952),
    [sym_class] = STATE(1952),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4818),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4818),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4818),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4818),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4818),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1877] = {
    [sym_template_string] = STATE(1408),
    [sym_arguments] = STATE(1408),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
  },
  [1878] = {
    [sym_object_type] = STATE(1409),
    [sym_extends_clause] = STATE(1955),
    [sym_type_parameters] = STATE(1956),
    [anon_sym_extends] = ACTIONS(784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1446),
  },
  [1879] = {
    [sym_enum_body] = STATE(1410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4824),
  },
  [1880] = {
    [sym_generator_function_declaration] = STATE(2405),
    [sym__declaration] = STATE(2405),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2405),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2405),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2405),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2405),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2405),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2405),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2405),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2405),
    [sym_function_declaration] = STATE(2405),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2405),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2405),
    [sym_break_statement] = STATE(2405),
    [sym_labeled_statement] = STATE(2405),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2405),
    [sym_class_declaration] = STATE(2405),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2405),
    [sym_ambient_declaration] = STATE(2405),
    [sym_type_alias_declaration] = STATE(2405),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2405),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2405),
    [sym_switch_statement] = STATE(2405),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(2405),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(2405),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2405),
    [sym_abstract_class_declaration] = STATE(2405),
    [sym_interface_declaration] = STATE(2405),
    [sym_export_statement] = STATE(2405),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2405),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2405),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2405),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2405),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [1881] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(854),
    [aux_sym_string_token1] = ACTIONS(856),
    [anon_sym_DQUOTE] = ACTIONS(4852),
    [sym_comment] = ACTIONS(255),
  },
  [1882] = {
    [sym_generator_function_declaration] = STATE(395),
    [sym__declaration] = STATE(395),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(395),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(395),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(395),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(395),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(395),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(395),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(395),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(395),
    [sym_function_declaration] = STATE(395),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(395),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(395),
    [sym_break_statement] = STATE(395),
    [sym_labeled_statement] = STATE(395),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(395),
    [sym_class_declaration] = STATE(395),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(395),
    [sym_ambient_declaration] = STATE(395),
    [sym_type_alias_declaration] = STATE(395),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(395),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(395),
    [sym_switch_statement] = STATE(395),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(395),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(395),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(395),
    [sym_abstract_class_declaration] = STATE(395),
    [sym_interface_declaration] = STATE(395),
    [sym_export_statement] = STATE(395),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(395),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(395),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(395),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(395),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [1883] = {
    [aux_sym_array_repeat1] = STATE(1962),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1884] = {
    [aux_sym_array_repeat1] = STATE(1962),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(4854),
    [sym_comment] = ACTIONS(3),
  },
  [1885] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(4854),
    [sym_comment] = ACTIONS(3),
  },
  [1886] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1963),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1423),
    [sym_type_parameters] = STATE(1964),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [1887] = {
    [sym_decorator] = STATE(1965),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(1965),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(4856),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1888] = {
    [sym_class_body] = STATE(1426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [1889] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1427),
    [sym_class_heritage] = STATE(1966),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [1890] = {
    [sym_statement_block] = STATE(1428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [1891] = {
    [sym_nested_identifier] = STATE(1327),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(1640),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [1892] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1893] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1894] = {
    [sym_await_expression] = STATE(93),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_ternary_expression] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_yield_expression] = STATE(93),
    [sym_jsx_fragment] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(93),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_generator_function] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [1895] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [sym_number] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1896] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1070),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [sym_number] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1897] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [sym_number] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1898] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1899] = {
    [sym_nested_identifier] = STATE(129),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(130),
    [sym__module] = STATE(131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1900] = {
    [sym_nested_identifier] = STATE(1327),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1901] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(343),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(365),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1902] = {
    [sym_formal_parameters] = STATE(61),
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym__call_signature] = STATE(214),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_type_parameters] = STATE(60),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_public] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1093),
    [anon_sym_declare] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1093),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1103),
    [sym_number] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1903] = {
    [sym_class_declaration] = STATE(249),
    [sym_generator_function_declaration] = STATE(249),
    [sym__declaration] = STATE(249),
    [sym_ambient_declaration] = STATE(249),
    [sym_import_alias] = STATE(249),
    [sym_type_alias_declaration] = STATE(249),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_function_signature] = STATE(249),
    [sym_abstract_class_declaration] = STATE(249),
    [sym_module] = STATE(249),
    [sym_interface_declaration] = STATE(249),
    [sym_function_declaration] = STATE(249),
    [sym_export_clause] = STATE(250),
    [sym_variable_declaration] = STATE(249),
    [sym_lexical_declaration] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(249),
    [sym_enum_declaration] = STATE(249),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_as] = ACTIONS(507),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1026),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(351),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(357),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(365),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(369),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1904] = {
    [aux_sym_object_repeat1] = STATE(1970),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [1905] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4864),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1906] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [1907] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1973),
    [anon_sym_RPAREN] = ACTIONS(4866),
    [anon_sym_COMMA] = ACTIONS(4868),
    [sym_comment] = ACTIONS(3),
  },
  [1908] = {
    [anon_sym_RPAREN] = ACTIONS(4870),
    [sym_comment] = ACTIONS(3),
  },
  [1909] = {
    [sym_type_arguments] = STATE(1877),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_annotation] = STATE(1974),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(4870),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1910] = {
    [anon_sym_EQ_GT] = ACTIONS(4872),
    [sym_comment] = ACTIONS(3),
  },
  [1911] = {
    [anon_sym_EQ_GT] = ACTIONS(4874),
    [sym_comment] = ACTIONS(3),
  },
  [1912] = {
    [anon_sym_EQ_GT] = ACTIONS(4876),
    [sym_comment] = ACTIONS(3),
  },
  [1913] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1978),
    [sym__automatic_semicolon] = ACTIONS(4878),
    [anon_sym_SEMI] = ACTIONS(4878),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [sym_generator_function_declaration] = STATE(500),
    [sym__declaration] = STATE(500),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(500),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(500),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(500),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(500),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(500),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(500),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(500),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(500),
    [sym_function_declaration] = STATE(500),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(500),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_labeled_statement] = STATE(500),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(500),
    [sym_class_declaration] = STATE(500),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(500),
    [sym_ambient_declaration] = STATE(500),
    [sym_type_alias_declaration] = STATE(500),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(500),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(500),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(500),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(500),
    [sym_abstract_class_declaration] = STATE(500),
    [sym_interface_declaration] = STATE(500),
    [sym_export_statement] = STATE(500),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(500),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(500),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(500),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(500),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [1915] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(1233),
    [aux_sym_string_token2] = ACTIONS(1235),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(4852),
  },
  [1916] = {
    [sym_generator_function_declaration] = STATE(2148),
    [sym__declaration] = STATE(2148),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2148),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2148),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2148),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2148),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2148),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2148),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2148),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2148),
    [sym_function_declaration] = STATE(2148),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2148),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2148),
    [sym_break_statement] = STATE(2148),
    [sym_labeled_statement] = STATE(2148),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2148),
    [sym_class_declaration] = STATE(2148),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2148),
    [sym_ambient_declaration] = STATE(2148),
    [sym_type_alias_declaration] = STATE(2148),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2148),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2148),
    [sym_switch_statement] = STATE(2148),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2148),
    [sym_throw_statement] = STATE(2148),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2148),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2148),
    [sym_abstract_class_declaration] = STATE(2148),
    [sym_interface_declaration] = STATE(2148),
    [sym_export_statement] = STATE(2148),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2148),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2148),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2148),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2148),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1917] = {
    [anon_sym_SLASH2] = ACTIONS(4882),
    [sym_comment] = ACTIONS(3),
  },
  [1918] = {
    [sym_statement_block] = STATE(1443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [1919] = {
    [anon_sym_target] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
  },
  [1920] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1921] = {
    [sym__from_clause] = STATE(1982),
    [sym__automatic_semicolon] = ACTIONS(4888),
    [anon_sym_SEMI] = ACTIONS(4888),
    [anon_sym_from] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
  },
  [1922] = {
    [sym_generator_function_declaration] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(543),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(543),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(543),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(543),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(543),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(543),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(543),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(543),
    [sym_function_declaration] = STATE(543),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(543),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(543),
    [sym_class_declaration] = STATE(543),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(543),
    [sym_ambient_declaration] = STATE(543),
    [sym_type_alias_declaration] = STATE(543),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(543),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(543),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(543),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(543),
    [sym_abstract_class_declaration] = STATE(543),
    [sym_interface_declaration] = STATE(543),
    [sym_export_statement] = STATE(543),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(543),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(543),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(543),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(543),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [1923] = {
    [sym_generic_type] = STATE(1740),
    [sym_type_predicate] = STATE(1740),
    [sym_literal_type] = STATE(1740),
    [sym__number] = STATE(1734),
    [sym_object_type] = STATE(1740),
    [sym_intersection_type] = STATE(1457),
    [sym_function_type] = STATE(1457),
    [sym_nested_identifier] = STATE(2623),
    [sym_nested_type_identifier] = STATE(1741),
    [sym__type] = STATE(1457),
    [sym_type_query] = STATE(1740),
    [sym_index_type_query] = STATE(1740),
    [sym_existential_type] = STATE(1740),
    [sym_flow_maybe_type] = STATE(1740),
    [sym_string] = STATE(1734),
    [sym_type_parameters] = STATE(2624),
    [sym_template_string] = STATE(1458),
    [sym_array_type] = STATE(1740),
    [sym_formal_parameters] = STATE(2247),
    [sym_constructor_type] = STATE(1457),
    [sym__primary_type] = STATE(1740),
    [sym_lookup_type] = STATE(1740),
    [sym_parenthesized_type] = STATE(1740),
    [sym_predefined_type] = STATE(1740),
    [sym_tuple_type] = STATE(1740),
    [sym_union_type] = STATE(1457),
    [sym_identifier] = ACTIONS(4674),
    [sym_false] = ACTIONS(4676),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(4678),
    [anon_sym_symbol] = ACTIONS(4680),
    [anon_sym_number] = ACTIONS(4680),
    [anon_sym_typeof] = ACTIONS(4682),
    [anon_sym_keyof] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4686),
    [anon_sym_STAR] = ACTIONS(4688),
    [anon_sym_LBRACE] = ACTIONS(4690),
    [anon_sym_PIPE] = ACTIONS(4702),
    [anon_sym_void] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_any] = ACTIONS(4680),
    [anon_sym_boolean] = ACTIONS(4680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4706),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4708),
    [sym_number] = ACTIONS(4700),
    [sym_true] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4680),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_PLUS] = ACTIONS(4686),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1924] = {
    [sym_await_expression] = STATE(1984),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(1984),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(1984),
    [sym_function_type] = STATE(345),
    [sym__expression] = STATE(1984),
    [sym_jsx_element] = STATE(1984),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1984),
    [sym_call_expression] = STATE(1984),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(1984),
    [sym_template_string] = STATE(1984),
    [sym_yield_expression] = STATE(1984),
    [sym_jsx_fragment] = STATE(1984),
    [sym_new_expression] = STATE(1984),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(1984),
    [sym_binary_expression] = STATE(1984),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_array] = STATE(2686),
    [sym_as_expression] = STATE(1984),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1984),
    [sym_jsx_self_closing_element] = STATE(1984),
    [sym_arrow_function] = STATE(1984),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(2685),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(2687),
    [sym__type] = STATE(345),
    [sym_subscript_expression] = STATE(2685),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1845),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(2688),
    [sym_generator_function] = STATE(1984),
    [sym_constructor_type] = STATE(345),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(1984),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(1984),
    [sym_regex] = STATE(1984),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(1984),
    [sym_class] = STATE(1984),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(4890),
    [sym_false] = ACTIONS(4892),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(4894),
    [anon_sym_number] = ACTIONS(4894),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(4896),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4898),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(4900),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [sym_null] = ACTIONS(4902),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4894),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(4894),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(4904),
    [sym_number] = ACTIONS(4906),
    [sym_true] = ACTIONS(4892),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(4894),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4902),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(4908),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(4898),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [1925] = {
    [sym_await_expression] = STATE(1996),
    [sym_update_expression] = STATE(1996),
    [sym_meta_property] = STATE(1996),
    [sym__expression] = STATE(1996),
    [sym_jsx_element] = STATE(1996),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1996),
    [sym_call_expression] = STATE(1996),
    [sym_ternary_expression] = STATE(1996),
    [sym_template_string] = STATE(1996),
    [sym_yield_expression] = STATE(1996),
    [sym_jsx_fragment] = STATE(1996),
    [sym_new_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(1996),
    [sym_binary_expression] = STATE(1996),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1996),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1996),
    [sym_jsx_self_closing_element] = STATE(1996),
    [sym_arrow_function] = STATE(1996),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(1995),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(1995),
    [sym_string] = STATE(1996),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1996),
    [sym_augmented_assignment_expression] = STATE(1996),
    [sym_unary_expression] = STATE(1996),
    [sym_regex] = STATE(1996),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1996),
    [sym_class] = STATE(1996),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(4910),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4912),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4912),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4912),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4912),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4914),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4912),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1926] = {
    [sym_jsx_element] = STATE(574),
    [sym_jsx_expression] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(1471),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(4790),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [1927] = {
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(1475),
    [sym_function_type] = STATE(1475),
    [sym_nested_identifier] = STATE(2551),
    [sym_nested_type_identifier] = STATE(1653),
    [sym__type] = STATE(1475),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_constructor_type] = STATE(1475),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_predefined_type] = STATE(1652),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(1475),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1929),
    [anon_sym_keyof] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1939),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_this] = ACTIONS(1949),
    [sym_number] = ACTIONS(1951),
    [sym_true] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1928] = {
    [sym_class_declaration] = STATE(582),
    [sym_generator_function_declaration] = STATE(582),
    [sym__declaration] = STATE(582),
    [sym_enum_declaration] = STATE(582),
    [sym_function_signature] = STATE(582),
    [sym_abstract_class_declaration] = STATE(582),
    [sym_module] = STATE(582),
    [sym_interface_declaration] = STATE(582),
    [sym_function_declaration] = STATE(582),
    [sym_variable_declaration] = STATE(582),
    [sym_lexical_declaration] = STATE(582),
    [sym_ambient_declaration] = STATE(582),
    [sym_import_alias] = STATE(582),
    [sym_type_alias_declaration] = STATE(582),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(582),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(1690),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(4916),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_async] = ACTIONS(4928),
  },
  [1929] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1930] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1931] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1709),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1932] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1933] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1934] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1935] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2002),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1478),
    [sym_type_parameters] = STATE(2003),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [1936] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [1937] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
  },
  [1938] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1939] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(1070),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1940] = {
    [sym_computed_property_name] = STATE(449),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(449),
    [sym__property_name] = STATE(449),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [1941] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2000),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1426),
    [sym_type_parameters] = STATE(2001),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(4930),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [1942] = {
    [sym_enum_body] = STATE(1480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4824),
  },
  [1943] = {
    [aux_sym_variable_declaration_repeat1] = STATE(606),
    [sym__automatic_semicolon] = ACTIONS(4932),
    [anon_sym_SEMI] = ACTIONS(4932),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [1944] = {
    [anon_sym_RBRACK] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
  },
  [1945] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1946] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(2007),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(2007),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(2007),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(2007),
    [sym_property_signature] = STATE(2007),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(2007),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(4936),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(4938),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4938),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1947] = {
    [sym_nested_identifier] = STATE(1488),
    [sym_identifier] = ACTIONS(4940),
    [sym_comment] = ACTIONS(3),
  },
  [1948] = {
    [sym_number] = ACTIONS(4942),
    [sym_comment] = ACTIONS(3),
  },
  [1949] = {
    [sym_nested_type_identifier] = STATE(1491),
    [sym_nested_identifier] = STATE(2402),
    [sym_identifier] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
  },
  [1950] = {
    [anon_sym_EQ_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
  },
  [1951] = {
    [aux_sym_implements_clause_repeat1] = STATE(2013),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(4950),
    [sym_comment] = ACTIONS(3),
  },
  [1952] = {
    [aux_sym_array_repeat1] = STATE(2015),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1953] = {
    [aux_sym_array_repeat1] = STATE(2015),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [1954] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [1955] = {
    [sym_object_type] = STATE(1499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1446),
  },
  [1956] = {
    [sym_object_type] = STATE(1500),
    [sym_extends_clause] = STATE(2016),
    [anon_sym_extends] = ACTIONS(784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1446),
  },
  [1957] = {
    [sym_computed_property_name] = STATE(2017),
    [sym_string] = STATE(2017),
    [sym__property_name] = STATE(2017),
    [sym_enum_assignment] = STATE(2018),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(4954),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1958] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1913),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1959] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1502),
    [sym_class_heritage] = STATE(2020),
    [sym_type_parameters] = STATE(2021),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(4958),
    [sym_comment] = ACTIONS(3),
  },
  [1961] = {
    [sym_generator_function_declaration] = STATE(692),
    [sym__declaration] = STATE(692),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(692),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(692),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(692),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(692),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(692),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(692),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(692),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(692),
    [sym_function_declaration] = STATE(692),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(692),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(692),
    [sym_break_statement] = STATE(692),
    [sym_labeled_statement] = STATE(692),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(692),
    [sym_class_declaration] = STATE(692),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(692),
    [sym_ambient_declaration] = STATE(692),
    [sym_type_alias_declaration] = STATE(692),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(692),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(692),
    [sym_switch_statement] = STATE(692),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(692),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(692),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(692),
    [sym_abstract_class_declaration] = STATE(692),
    [sym_interface_declaration] = STATE(692),
    [sym_export_statement] = STATE(692),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(692),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(692),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(692),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(692),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [1962] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
  },
  [1963] = {
    [sym_class_body] = STATE(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [1964] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1506),
    [sym_class_heritage] = STATE(2025),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [1965] = {
    [sym_decorator] = STATE(723),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(723),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(4962),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1966] = {
    [sym_class_body] = STATE(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [1967] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2029),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(734),
    [sym_type_parameters] = STATE(2030),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [1968] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [1969] = {
    [aux_sym_array_repeat1] = STATE(1962),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(4966),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1970] = {
    [aux_sym_object_repeat1] = STATE(468),
    [anon_sym_RBRACE] = ACTIONS(4968),
    [anon_sym_COMMA] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
  },
  [1971] = {
    [sym__automatic_semicolon] = ACTIONS(4970),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_if] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [sym_false] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [sym_null] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2249),
    [sym_number] = ACTIONS(2249),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
  },
  [1972] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(4972),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [1973] = {
    [aux_sym_formal_parameters_repeat1] = STATE(770),
    [anon_sym_RPAREN] = ACTIONS(4972),
    [anon_sym_COMMA] = ACTIONS(4974),
    [sym_comment] = ACTIONS(3),
  },
  [1974] = {
    [anon_sym_RPAREN] = ACTIONS(4976),
    [sym_comment] = ACTIONS(3),
  },
  [1975] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2035),
    [anon_sym_RPAREN] = ACTIONS(4972),
    [anon_sym_COMMA] = ACTIONS(4974),
    [sym_comment] = ACTIONS(3),
  },
  [1976] = {
    [sym_optional_parameter] = STATE(1975),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(1975),
    [aux_sym_export_statement_repeat1] = STATE(2705),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(1975),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [1977] = {
    [sym_statement_block] = STATE(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [1978] = {
    [aux_sym_variable_declaration_repeat1] = STATE(606),
    [sym__automatic_semicolon] = ACTIONS(4978),
    [anon_sym_SEMI] = ACTIONS(4978),
    [anon_sym_COMMA] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [1979] = {
    [anon_sym_GT] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [1980] = {
    [sym_statement_block] = STATE(1529),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [1981] = {
    [sym_statement_block] = STATE(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [1982] = {
    [sym__automatic_semicolon] = ACTIONS(4551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4551),
  },
  [1983] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(4982),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1984] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1985] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1986] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1987] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1988] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1989] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4987),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1990] = {
    [sym_type_parameters] = STATE(1868),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_construct_signature] = STATE(623),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(623),
    [sym_pair] = STATE(1904),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(623),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(1904),
    [sym_assignment_pattern] = STATE(1904),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(1904),
    [sym__call_signature] = STATE(623),
    [sym_property_signature] = STATE(623),
    [sym_string] = STATE(842),
    [sym_index_signature] = STATE(623),
    [sym_identifier] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_module] = ACTIONS(4989),
    [anon_sym_symbol] = ACTIONS(4989),
    [anon_sym_number] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4989),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4991),
    [anon_sym_boolean] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4991),
    [anon_sym_get] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_static] = ACTIONS(4999),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4991),
    [anon_sym_string] = ACTIONS(4989),
    [anon_sym_set] = ACTIONS(4995),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(5001),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [1991] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(2150),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(2150),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(2150),
    [sym_function_type] = STATE(638),
    [sym__expression] = STATE(2150),
    [sym_jsx_element] = STATE(2150),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2150),
    [sym_call_expression] = STATE(2150),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(2150),
    [sym_template_string] = STATE(2150),
    [sym_yield_expression] = STATE(2150),
    [sym_jsx_fragment] = STATE(2150),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(2150),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(2150),
    [sym_binary_expression] = STATE(2150),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(638),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(2150),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(2150),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(2150),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_sequence_expression] = STATE(2149),
    [sym_intersection_type] = STATE(638),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(638),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1813),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(2150),
    [sym_constructor_type] = STATE(638),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(2150),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(2150),
    [sym_regex] = STATE(2150),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(2150),
    [sym_class] = STATE(2150),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(2582),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2584),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(411),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(411),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(5003),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5003),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [1992] = {
    [sym_type_annotation] = STATE(275),
    [anon_sym_EQ_GT] = ACTIONS(5005),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [1993] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1994] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1995] = {
    [anon_sym_RBRACE] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
  },
  [1996] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [1997] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1998] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [1999] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2057),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1539),
    [sym_type_parameters] = STATE(2058),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2000] = {
    [sym_class_body] = STATE(1540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2001] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1541),
    [sym_class_heritage] = STATE(2059),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2002] = {
    [sym_class_body] = STATE(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2003] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1543),
    [sym_class_heritage] = STATE(2060),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2004] = {
    [sym_statement_block] = STATE(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [2005] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2063),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1545),
    [sym_type_parameters] = STATE(2064),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
  },
  [2007] = {
    [aux_sym_object_type_repeat1] = STATE(2067),
    [sym__automatic_semicolon] = ACTIONS(5012),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_SEMI] = ACTIONS(5012),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5014),
    [anon_sym_COMMA] = ACTIONS(5012),
    [sym_comment] = ACTIONS(3),
  },
  [2008] = {
    [aux_sym_implements_clause_repeat1] = STATE(2068),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RBRACK] = ACTIONS(5016),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
  },
  [2009] = {
    [anon_sym_EQ_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
  },
  [2010] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RPAREN] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
  },
  [2011] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2070),
    [sym_function_type] = STATE(2070),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2070),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2070),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2070),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_RBRACK] = ACTIONS(5022),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2012] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2013] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_COMMA] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
  },
  [2014] = {
    [anon_sym_EQ_GT] = ACTIONS(5028),
    [sym_comment] = ACTIONS(3),
  },
  [2015] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2016] = {
    [sym_object_type] = STATE(1560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1446),
  },
  [2017] = {
    [sym__initializer] = STATE(914),
    [aux_sym_enum_body_repeat1] = STATE(2073),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(5032),
    [anon_sym_COMMA] = ACTIONS(5034),
    [sym_comment] = ACTIONS(3),
  },
  [2018] = {
    [aux_sym_enum_body_repeat1] = STATE(2073),
    [anon_sym_COMMA] = ACTIONS(5034),
    [anon_sym_RBRACE] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
  },
  [2019] = {
    [sym_generator_function_declaration] = STATE(916),
    [sym__declaration] = STATE(916),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(916),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(916),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(916),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(916),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(916),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(916),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(916),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(916),
    [sym_function_declaration] = STATE(916),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(916),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(916),
    [sym_break_statement] = STATE(916),
    [sym_labeled_statement] = STATE(916),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(916),
    [sym_class_declaration] = STATE(916),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(916),
    [sym_ambient_declaration] = STATE(916),
    [sym_type_alias_declaration] = STATE(916),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(916),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(916),
    [sym_switch_statement] = STATE(916),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(916),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(916),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(916),
    [sym_abstract_class_declaration] = STATE(916),
    [sym_interface_declaration] = STATE(916),
    [sym_export_statement] = STATE(916),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(916),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(916),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(916),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(916),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [2020] = {
    [sym_class_body] = STATE(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2021] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1563),
    [sym_class_heritage] = STATE(2074),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2022] = {
    [sym__automatic_semicolon] = ACTIONS(5036),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
  },
  [2023] = {
    [sym__automatic_semicolon] = ACTIONS(5038),
    [anon_sym_SEMI] = ACTIONS(5038),
    [anon_sym_DOT] = ACTIONS(2872),
    [sym_comment] = ACTIONS(3),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
  },
  [2025] = {
    [sym_class_body] = STATE(1567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2026] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(5042),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2027] = {
    [sym_statement_block] = STATE(757),
    [sym__automatic_semicolon] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2028] = {
    [anon_sym_COLON] = ACTIONS(5044),
    [sym_comment] = ACTIONS(3),
  },
  [2029] = {
    [sym_class_body] = STATE(991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2030] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(992),
    [sym_class_heritage] = STATE(2079),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2031] = {
    [sym_statement_block] = STATE(2081),
    [sym__automatic_semicolon] = ACTIONS(5046),
    [anon_sym_SEMI] = ACTIONS(5046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2032] = {
    [sym_nested_identifier] = STATE(2023),
    [sym_identifier] = ACTIONS(5048),
    [sym_comment] = ACTIONS(3),
  },
  [2033] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2082),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(998),
    [sym_type_parameters] = STATE(2083),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2034] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(5050),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [2035] = {
    [aux_sym_formal_parameters_repeat1] = STATE(770),
    [anon_sym_RPAREN] = ACTIONS(5050),
    [anon_sym_COMMA] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
  },
  [2036] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2037] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2038] = {
    [sym_statement_block] = STATE(1578),
    [sym__automatic_semicolon] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [2039] = {
    [sym_statement_block] = STATE(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [2040] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2041] = {
    [anon_sym_GT] = ACTIONS(5054),
    [sym_comment] = ACTIONS(3),
  },
  [2042] = {
    [anon_sym_GT] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
  },
  [2043] = {
    [sym_statement_block] = STATE(1583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [2044] = {
    [sym_type_arguments] = STATE(1877),
    [sym_type_annotation] = STATE(2169),
    [aux_sym_array_repeat1] = STATE(2015),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(5058),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2045] = {
    [sym__automatic_semicolon] = ACTIONS(5060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(5060),
  },
  [2046] = {
    [sym_computed_property_name] = STATE(2445),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2047] = {
    [sym_computed_property_name] = STATE(1054),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3403),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_get] = ACTIONS(3411),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(3411),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2048] = {
    [sym_computed_property_name] = STATE(2445),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2049] = {
    [sym_class_declaration] = STATE(1363),
    [sym_generator_function_declaration] = STATE(1363),
    [sym__declaration] = STATE(1363),
    [sym_ambient_declaration] = STATE(1363),
    [sym_import_alias] = STATE(1363),
    [sym_type_alias_declaration] = STATE(1363),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(1968),
    [sym_function_signature] = STATE(1363),
    [sym_abstract_class_declaration] = STATE(1363),
    [sym_module] = STATE(1363),
    [sym_interface_declaration] = STATE(1363),
    [sym_function_declaration] = STATE(1363),
    [sym_export_clause] = STATE(1921),
    [sym_variable_declaration] = STATE(1363),
    [sym_lexical_declaration] = STATE(1363),
    [aux_sym_export_statement_repeat1] = STATE(2782),
    [sym_internal_module] = STATE(1363),
    [sym_enum_declaration] = STATE(1363),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(2725),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_var] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2745),
    [anon_sym_as] = ACTIONS(2747),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_abstract] = ACTIONS(2751),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2755),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2759),
  },
  [2050] = {
    [sym_type_annotation] = STATE(275),
    [anon_sym_EQ_GT] = ACTIONS(5062),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [2051] = {
    [sym_type_annotation] = STATE(578),
    [anon_sym_EQ_GT] = ACTIONS(5065),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [2052] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(5068),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [2053] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
  },
  [2054] = {
    [anon_sym_GT] = ACTIONS(5068),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [2055] = {
    [anon_sym_GT] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
  },
  [2056] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(5070),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5070),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2057] = {
    [sym_class_body] = STATE(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2058] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1590),
    [sym_class_heritage] = STATE(2090),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2059] = {
    [sym_class_body] = STATE(1591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2060] = {
    [sym_class_body] = STATE(1592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2061] = {
    [sym_statement_block] = STATE(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [2062] = {
    [sym_statement_block] = STATE(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [2063] = {
    [sym_class_body] = STATE(1595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2064] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1596),
    [sym_class_heritage] = STATE(2092),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2065] = {
    [aux_sym_object_type_repeat1] = STATE(2094),
    [sym__automatic_semicolon] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5074),
    [anon_sym_COMMA] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
  },
  [2066] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5074),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2067] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5074),
    [anon_sym_COMMA] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
  },
  [2068] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACK] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
  },
  [2069] = {
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
  },
  [2070] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
  },
  [2071] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5082),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2072] = {
    [sym_computed_property_name] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_enum_assignment] = STATE(1101),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(5084),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [2073] = {
    [aux_sym_enum_body_repeat1] = STATE(1103),
    [anon_sym_COMMA] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5084),
    [sym_comment] = ACTIONS(3),
  },
  [2074] = {
    [sym_class_body] = STATE(1606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2075] = {
    [sym__automatic_semicolon] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
  },
  [2076] = {
    [sym_generator_function_declaration] = STATE(1123),
    [sym__declaration] = STATE(1123),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1123),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1123),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1123),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1123),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1123),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1123),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1123),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1123),
    [sym_function_declaration] = STATE(1123),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1123),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1123),
    [sym_break_statement] = STATE(1123),
    [sym_labeled_statement] = STATE(1123),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1123),
    [sym_class_declaration] = STATE(1123),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1123),
    [sym_ambient_declaration] = STATE(1123),
    [sym_type_alias_declaration] = STATE(1123),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1123),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1123),
    [sym_switch_statement] = STATE(1123),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1123),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1123),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1123),
    [sym_abstract_class_declaration] = STATE(1123),
    [sym_interface_declaration] = STATE(1123),
    [sym_export_statement] = STATE(1123),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1123),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1123),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1123),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1123),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [2077] = {
    [sym_statement_block] = STATE(1002),
    [sym__automatic_semicolon] = ACTIONS(3691),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3691),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2078] = {
    [sym_statement_block] = STATE(1008),
    [sym__automatic_semicolon] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2079] = {
    [sym_class_body] = STATE(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2080] = {
    [sym_statement_block] = STATE(2099),
    [sym__automatic_semicolon] = ACTIONS(5090),
    [anon_sym_SEMI] = ACTIONS(5090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2081] = {
    [sym__automatic_semicolon] = ACTIONS(5092),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
  },
  [2082] = {
    [sym_class_body] = STATE(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2083] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1160),
    [sym_class_heritage] = STATE(2101),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2084] = {
    [sym_optional_parameter] = STATE(767),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(489),
    [sym_rest_parameter] = STATE(767),
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_array] = STATE(490),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(767),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(5094),
    [sym_this] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
  },
  [2085] = {
    [sym_statement_block] = STATE(1617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1288),
  },
  [2086] = {
    [anon_sym_GT] = ACTIONS(5096),
    [sym_comment] = ACTIONS(3),
  },
  [2087] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3883),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(5098),
    [sym_comment] = ACTIONS(3),
  },
  [2089] = {
    [sym_type_annotation] = STATE(578),
    [anon_sym_EQ_GT] = ACTIONS(5100),
    [anon_sym_COLON] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [2090] = {
    [sym_class_body] = STATE(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2091] = {
    [sym_statement_block] = STATE(1622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4884),
  },
  [2092] = {
    [sym_class_body] = STATE(1623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2093] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5103),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2094] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(5105),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_SEMI] = ACTIONS(5105),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5103),
    [anon_sym_COMMA] = ACTIONS(5105),
    [sym_comment] = ACTIONS(3),
  },
  [2095] = {
    [sym_computed_property_name] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_enum_assignment] = STATE(1101),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(5107),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [2096] = {
    [sym_generator_function_declaration] = STATE(1215),
    [sym__declaration] = STATE(1215),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1215),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1215),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1215),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1215),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1215),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1215),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1215),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1215),
    [sym_function_declaration] = STATE(1215),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1215),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1215),
    [sym_break_statement] = STATE(1215),
    [sym_labeled_statement] = STATE(1215),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1215),
    [sym_class_declaration] = STATE(1215),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1215),
    [sym_ambient_declaration] = STATE(1215),
    [sym_type_alias_declaration] = STATE(1215),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1215),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1215),
    [sym_switch_statement] = STATE(1215),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1215),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1215),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1215),
    [sym_abstract_class_declaration] = STATE(1215),
    [sym_interface_declaration] = STATE(1215),
    [sym_export_statement] = STATE(1215),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1215),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1215),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1215),
    [aux_sym_export_statement_repeat1] = STATE(2334),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(515),
    [anon_sym_get] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(519),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(523),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(515),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(515),
    [anon_sym_boolean] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_await] = ACTIONS(107),
  },
  [2097] = {
    [sym_statement_block] = STATE(1162),
    [sym__automatic_semicolon] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4085),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2098] = {
    [sym_statement_block] = STATE(1164),
    [sym__automatic_semicolon] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(4111),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4111),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2099] = {
    [sym__automatic_semicolon] = ACTIONS(5109),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3795),
    [anon_sym_COMMA] = ACTIONS(3795),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
  },
  [2100] = {
    [sym__automatic_semicolon] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_SEMI] = ACTIONS(3849),
    [anon_sym_COMMA] = ACTIONS(3849),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
  },
  [2101] = {
    [sym_class_body] = STATE(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2102] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5113),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2103] = {
    [sym_statement_block] = STATE(1237),
    [sym__automatic_semicolon] = ACTIONS(4278),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4278),
    [anon_sym_COMMA] = ACTIONS(4278),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4278),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2104] = {
    [sym_statement_block] = STATE(1239),
    [sym__automatic_semicolon] = ACTIONS(4280),
    [anon_sym_RBRACE] = ACTIONS(4280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_COMMA] = ACTIONS(4280),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2105] = {
    [sym__automatic_semicolon] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(4165),
    [anon_sym_SEMI] = ACTIONS(4165),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4165),
    [sym_comment] = ACTIONS(3),
  },
  [2106] = {
    [sym_statement_block] = STATE(1272),
    [sym__automatic_semicolon] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2107] = {
    [sym_statement_block] = STATE(1274),
    [sym__automatic_semicolon] = ACTIONS(4348),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4348),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4348),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2108] = {
    [sym_statement_block] = STATE(1287),
    [sym__automatic_semicolon] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_COMMA] = ACTIONS(4368),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2109] = {
    [sym_statement_block] = STATE(1289),
    [sym__automatic_semicolon] = ACTIONS(4370),
    [anon_sym_RBRACE] = ACTIONS(4370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4370),
    [anon_sym_COMMA] = ACTIONS(4370),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4370),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2110] = {
    [sym_statement_block] = STATE(1294),
    [sym__automatic_semicolon] = ACTIONS(4378),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4378),
    [anon_sym_COMMA] = ACTIONS(4378),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4378),
    [anon_sym_LBRACE] = ACTIONS(455),
  },
  [2111] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2112] = {
    [sym_await_expression] = STATE(2123),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(2123),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(2123),
    [sym_function_type] = STATE(345),
    [sym__expression] = STATE(2123),
    [sym_jsx_element] = STATE(2123),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2123),
    [sym_call_expression] = STATE(2123),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(2123),
    [sym_template_string] = STATE(2123),
    [sym_yield_expression] = STATE(2123),
    [sym_jsx_fragment] = STATE(2123),
    [sym_new_expression] = STATE(2123),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2123),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2123),
    [sym_jsx_self_closing_element] = STATE(2123),
    [sym_arrow_function] = STATE(2123),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(2788),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(2610),
    [sym__type] = STATE(345),
    [sym_subscript_expression] = STATE(2788),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1664),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2123),
    [sym_constructor_type] = STATE(345),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(2123),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(2123),
    [sym_regex] = STATE(2123),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2123),
    [sym_class] = STATE(2123),
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5119),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(5123),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5125),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5127),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(5127),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(4491),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(5131),
    [anon_sym_any] = ACTIONS(5119),
    [anon_sym_boolean] = ACTIONS(5119),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5133),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5119),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5131),
    [anon_sym_new] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2113] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2114] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2115] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1709),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2116] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2117] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2118] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1735),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2119] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_COMMA] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
  },
  [2120] = {
    [aux_sym_object_repeat1] = STATE(1968),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
  },
  [2121] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1913),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1913),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2122] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2249),
    [sym__automatic_semicolon] = ACTIONS(5137),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2249),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2249),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2249),
    [anon_sym_as] = ACTIONS(2249),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_instanceof] = ACTIONS(2249),
    [anon_sym_COLON] = ACTIONS(2249),
    [anon_sym_DOT] = ACTIONS(2249),
    [anon_sym_STAR_STAR] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2249),
    [anon_sym_LT_LT] = ACTIONS(2249),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_LPAREN] = ACTIONS(2249),
    [anon_sym_RBRACK] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_QMARK] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_implements] = ACTIONS(2249),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2249),
  },
  [2123] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2124] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2125] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2126] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2127] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2128] = {
    [sym_await_expression] = STATE(1883),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(1883),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(1883),
    [sym_function_type] = STATE(2175),
    [sym__expression] = STATE(1883),
    [sym_jsx_element] = STATE(1883),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1883),
    [sym_call_expression] = STATE(1883),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(1883),
    [sym_template_string] = STATE(1883),
    [sym_yield_expression] = STATE(1883),
    [sym_jsx_fragment] = STATE(1883),
    [sym_new_expression] = STATE(1883),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(1883),
    [sym_binary_expression] = STATE(1883),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(2175),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1883),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1883),
    [sym_jsx_self_closing_element] = STATE(1883),
    [sym_arrow_function] = STATE(1883),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(2175),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(2175),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_spread_element] = STATE(1884),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1749),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1883),
    [sym_constructor_type] = STATE(2175),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(1883),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(1883),
    [sym_regex] = STATE(1883),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(1885),
    [sym_non_null_expression] = STATE(1883),
    [sym_class] = STATE(1883),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(2526),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(2532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(3383),
    [sym_null] = ACTIONS(4558),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2538),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4558),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [2129] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(5142),
    [sym_false] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [sym_number] = ACTIONS(1169),
    [sym_true] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2130] = {
    [sym_class] = STATE(1321),
    [sym_arrow_function] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_jsx_element] = STATE(1321),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1321),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_regex] = STATE(1321),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1321),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1321),
    [sym_internal_module] = STATE(1321),
    [sym_jsx_self_closing_element] = STATE(1321),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4562),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4562),
    [sym_number] = ACTIONS(5144),
    [sym_true] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2131] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(2453),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(2050),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(4566),
    [sym_false] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(4568),
    [anon_sym_symbol] = ACTIONS(4568),
    [anon_sym_number] = ACTIONS(4568),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4568),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(4568),
    [anon_sym_private] = ACTIONS(4568),
    [anon_sym_boolean] = ACTIONS(4568),
    [anon_sym_static] = ACTIONS(4568),
    [anon_sym_public] = ACTIONS(4568),
    [anon_sym_get] = ACTIONS(4568),
    [anon_sym_async] = ACTIONS(4578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [sym_number] = ACTIONS(4580),
    [sym_true] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(4568),
    [anon_sym_string] = ACTIONS(4568),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_DOT] = ACTIONS(4574),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_set] = ACTIONS(4568),
    [anon_sym_type] = ACTIONS(4568),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(4568),
    [anon_sym_namespace] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2132] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2133] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(2603),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2134] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2628),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2135] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2136] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(3224),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2137] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2138] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(3238),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2139] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(3883),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3883),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2140] = {
    [aux_sym_string_repeat1] = STATE(2146),
    [sym_escape_sequence] = ACTIONS(5146),
    [aux_sym_string_token1] = ACTIONS(5148),
    [anon_sym_DQUOTE] = ACTIONS(5150),
    [sym_comment] = ACTIONS(255),
  },
  [2141] = {
    [sym_generator_function_declaration] = STATE(1905),
    [sym_while_statement] = STATE(1905),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(184),
    [sym_jsx_element] = STATE(51),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1905),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(1905),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(1905),
    [sym_function_declaration] = STATE(1905),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1905),
    [sym_labeled_statement] = STATE(1905),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1905),
    [sym_arrow_function] = STATE(51),
    [sym_continue_statement] = STATE(1905),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(1905),
    [sym_type_alias_declaration] = STATE(1905),
    [sym_import_statement] = STATE(1905),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(1905),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(1905),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1905),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(1905),
    [sym_interface_declaration] = STATE(1905),
    [sym_export_statement] = STATE(1905),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1905),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(1905),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(184),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(1905),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1905),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(1905),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1905),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(1905),
    [sym_template_string] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1905),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(1905),
    [sym_parenthesized_expression] = STATE(53),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_class_declaration] = STATE(1905),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(1905),
    [sym_spread_element] = STATE(184),
    [sym_try_statement] = STATE(1905),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_abstract_class_declaration] = STATE(1905),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(1905),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(1905),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(184),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_static] = ACTIONS(385),
    [anon_sym_get] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(391),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(393),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(397),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(399),
    [anon_sym_number] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(375),
    [anon_sym_boolean] = ACTIONS(375),
    [anon_sym_async] = ACTIONS(403),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2142] = {
    [aux_sym_string_repeat2] = STATE(2151),
    [sym_escape_sequence] = ACTIONS(5154),
    [aux_sym_string_token2] = ACTIONS(5156),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5150),
  },
  [2143] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(4647),
    [sym_false] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(4649),
    [anon_sym_symbol] = ACTIONS(4649),
    [anon_sym_number] = ACTIONS(4649),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4649),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4651),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(4649),
    [anon_sym_private] = ACTIONS(4649),
    [anon_sym_boolean] = ACTIONS(4649),
    [anon_sym_static] = ACTIONS(4649),
    [anon_sym_public] = ACTIONS(4649),
    [anon_sym_get] = ACTIONS(4649),
    [anon_sym_async] = ACTIONS(4653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [sym_number] = ACTIONS(4580),
    [sym_true] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(4649),
    [anon_sym_string] = ACTIONS(4649),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_DOT] = ACTIONS(4574),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_set] = ACTIONS(4649),
    [anon_sym_type] = ACTIONS(4649),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(4649),
    [anon_sym_namespace] = ACTIONS(4655),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2144] = {
    [sym_jsx_element] = STATE(2154),
    [aux_sym_jsx_element_repeat1] = STATE(2154),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(1644),
    [sym_jsx_expression] = STATE(2154),
    [sym_jsx_self_closing_element] = STATE(2154),
    [sym_jsx_text] = ACTIONS(5158),
    [anon_sym_LT] = ACTIONS(5160),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2145] = {
    [sym_await_expression] = STATE(2161),
    [sym_update_expression] = STATE(2161),
    [sym_meta_property] = STATE(2161),
    [sym__expression] = STATE(2161),
    [sym_jsx_element] = STATE(2161),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2161),
    [sym_call_expression] = STATE(2161),
    [sym_ternary_expression] = STATE(2161),
    [sym_template_string] = STATE(2161),
    [sym_yield_expression] = STATE(2161),
    [sym_jsx_fragment] = STATE(2161),
    [sym_new_expression] = STATE(2161),
    [sym_assignment_expression] = STATE(2161),
    [sym_binary_expression] = STATE(2161),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(2161),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2161),
    [sym_jsx_self_closing_element] = STATE(2161),
    [sym_arrow_function] = STATE(2161),
    [sym_member_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_spread_element] = STATE(2162),
    [sym_string] = STATE(2161),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(2161),
    [sym_augmented_assignment_expression] = STATE(2161),
    [sym_unary_expression] = STATE(2161),
    [sym_regex] = STATE(2161),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [aux_sym_array_repeat1] = STATE(2163),
    [sym_non_null_expression] = STATE(2161),
    [sym_class] = STATE(2161),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(5162),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5162),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5162),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5166),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5162),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [2146] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(854),
    [aux_sym_string_token1] = ACTIONS(856),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [sym_comment] = ACTIONS(255),
  },
  [2147] = {
    [sym_decorator] = STATE(2165),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(2165),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2148] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5172),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2149] = {
    [anon_sym_RPAREN] = ACTIONS(5174),
    [sym_comment] = ACTIONS(3),
  },
  [2150] = {
    [sym_type_arguments] = STATE(1877),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_annotation] = STATE(2169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(5174),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(603),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2151] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(1233),
    [aux_sym_string_token2] = ACTIONS(1235),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5168),
  },
  [2152] = {
    [sym_generator_function_declaration] = STATE(1905),
    [sym__declaration] = STATE(1905),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1905),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1905),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1905),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1905),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1905),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1905),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1905),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1905),
    [sym_function_declaration] = STATE(1905),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1905),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1905),
    [sym_break_statement] = STATE(1905),
    [sym_labeled_statement] = STATE(1905),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1905),
    [sym_class_declaration] = STATE(1905),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1905),
    [sym_ambient_declaration] = STATE(1905),
    [sym_type_alias_declaration] = STATE(1905),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1905),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1905),
    [sym_switch_statement] = STATE(1905),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(1905),
    [sym_throw_statement] = STATE(1905),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1905),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1905),
    [sym_abstract_class_declaration] = STATE(1905),
    [sym_interface_declaration] = STATE(1905),
    [sym_export_statement] = STATE(1905),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1905),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1905),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1905),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1905),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2153] = {
    [anon_sym_SLASH2] = ACTIONS(5178),
    [sym_comment] = ACTIONS(3),
  },
  [2154] = {
    [sym_jsx_element] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(1669),
    [sym_jsx_expression] = STATE(574),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(5160),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2155] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(2174),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(2174),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(2174),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(2174),
    [sym_property_signature] = STATE(2174),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(2174),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(5180),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(5180),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5182),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5182),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2156] = {
    [sym_nested_identifier] = STATE(1675),
    [sym_identifier] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
  },
  [2157] = {
    [sym_number] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
  },
  [2158] = {
    [sym_nested_type_identifier] = STATE(1678),
    [sym_nested_identifier] = STATE(2551),
    [sym_identifier] = ACTIONS(5188),
    [sym_comment] = ACTIONS(3),
  },
  [2159] = {
    [anon_sym_EQ_GT] = ACTIONS(5190),
    [sym_comment] = ACTIONS(3),
  },
  [2160] = {
    [aux_sym_implements_clause_repeat1] = STATE(2180),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
  },
  [2161] = {
    [aux_sym_array_repeat1] = STATE(2182),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2162] = {
    [aux_sym_array_repeat1] = STATE(2182),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2163] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(5196),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2164] = {
    [sym_identifier] = ACTIONS(5198),
    [sym_comment] = ACTIONS(3),
  },
  [2165] = {
    [sym_decorator] = STATE(723),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(723),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2166] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1510),
    [sym_class_heritage] = STATE(2185),
    [sym_type_parameters] = STATE(2186),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2167] = {
    [aux_sym_array_repeat1] = STATE(1962),
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_RBRACK] = ACTIONS(5202),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2168] = {
    [sym__automatic_semicolon] = ACTIONS(4533),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2249),
    [anon_sym_while] = ACTIONS(2249),
    [anon_sym_COMMA] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(2249),
  },
  [2169] = {
    [anon_sym_RPAREN] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [2170] = {
    [anon_sym_GT] = ACTIONS(5206),
    [sym_comment] = ACTIONS(3),
  },
  [2171] = {
    [sym_construct_signature] = STATE(623),
    [sym_pair] = STATE(1904),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(623),
    [sym__call_signature] = STATE(623),
    [sym_spread_element] = STATE(1904),
    [sym_property_signature] = STATE(623),
    [sym_type_parameters] = STATE(1868),
    [sym_decorator] = STATE(63),
    [sym_string] = STATE(842),
    [sym_formal_parameters] = STATE(1306),
    [sym_index_signature] = STATE(623),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(623),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(1904),
    [sym_assignment_pattern] = STATE(1904),
    [sym_array] = STATE(308),
    [sym_identifier] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_module] = ACTIONS(4989),
    [anon_sym_symbol] = ACTIONS(4989),
    [anon_sym_number] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4989),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4991),
    [anon_sym_boolean] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4991),
    [anon_sym_get] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_static] = ACTIONS(4999),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4991),
    [anon_sym_string] = ACTIONS(4989),
    [anon_sym_set] = ACTIONS(4995),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(5001),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2172] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(2150),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(2150),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(2150),
    [sym_function_type] = STATE(2177),
    [sym__expression] = STATE(2150),
    [sym_jsx_element] = STATE(2150),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2150),
    [sym_call_expression] = STATE(2150),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(2150),
    [sym_template_string] = STATE(2150),
    [sym_yield_expression] = STATE(2150),
    [sym_jsx_fragment] = STATE(2150),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(2150),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(2150),
    [sym_binary_expression] = STATE(2150),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(2177),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(2150),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(2150),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(2150),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(1303),
    [sym_literal_type] = STATE(342),
    [sym_sequence_expression] = STATE(2149),
    [sym_intersection_type] = STATE(2177),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(1867),
    [sym__type] = STATE(2177),
    [sym_subscript_expression] = STATE(1303),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1813),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(2150),
    [sym_constructor_type] = STATE(2177),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(2150),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(2150),
    [sym_regex] = STATE(2150),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(2150),
    [sym_class] = STATE(2150),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(2582),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2584),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(411),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(411),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(5003),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5003),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [2173] = {
    [sym_identifier] = ACTIONS(5210),
    [sym_comment] = ACTIONS(3),
  },
  [2174] = {
    [aux_sym_object_type_repeat1] = STATE(2196),
    [sym__automatic_semicolon] = ACTIONS(5212),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [anon_sym_SEMI] = ACTIONS(5212),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5214),
    [anon_sym_COMMA] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
  },
  [2175] = {
    [aux_sym_implements_clause_repeat1] = STATE(2197),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RBRACK] = ACTIONS(5216),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
  },
  [2176] = {
    [anon_sym_EQ_GT] = ACTIONS(5218),
    [sym_comment] = ACTIONS(3),
  },
  [2177] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RPAREN] = ACTIONS(5220),
    [anon_sym_PIPE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
  },
  [2178] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2199),
    [sym_function_type] = STATE(2199),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2199),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2199),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2199),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2179] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2180] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_GT] = ACTIONS(5224),
    [anon_sym_COMMA] = ACTIONS(5226),
    [sym_comment] = ACTIONS(3),
  },
  [2181] = {
    [anon_sym_EQ_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
  },
  [2182] = {
    [aux_sym_array_repeat1] = STATE(401),
    [anon_sym_RPAREN] = ACTIONS(5230),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
  },
  [2184] = {
    [anon_sym_COLON] = ACTIONS(5234),
    [sym_comment] = ACTIONS(3),
  },
  [2185] = {
    [sym_class_body] = STATE(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2186] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1572),
    [sym_class_heritage] = STATE(2201),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2187] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1573),
    [sym_class_heritage] = STATE(2202),
    [sym_type_parameters] = STATE(2203),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2188] = {
    [anon_sym_GT] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
  },
  [2189] = {
    [anon_sym_GT] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
  },
  [2190] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [2191] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(5240),
    [sym_comment] = ACTIONS(3),
  },
  [2192] = {
    [anon_sym_DOT] = ACTIONS(3447),
    [anon_sym_GT] = ACTIONS(5240),
    [sym_comment] = ACTIONS(3),
  },
  [2193] = {
    [anon_sym_GT] = ACTIONS(5240),
    [sym_comment] = ACTIONS(3),
  },
  [2194] = {
    [aux_sym_object_type_repeat1] = STATE(2207),
    [sym__automatic_semicolon] = ACTIONS(5242),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
  },
  [2195] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5244),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2196] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(5242),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5242),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
  },
  [2197] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACK] = ACTIONS(5246),
    [sym_comment] = ACTIONS(3),
  },
  [2198] = {
    [anon_sym_EQ_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
  },
  [2199] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_RBRACK] = ACTIONS(5250),
    [sym_comment] = ACTIONS(3),
  },
  [2200] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5252),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2201] = {
    [sym_class_body] = STATE(1610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2202] = {
    [sym_class_body] = STATE(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2203] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1612),
    [sym_class_heritage] = STATE(2208),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2204] = {
    [anon_sym_GT] = ACTIONS(5254),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym_identifier] = ACTIONS(5256),
    [sym_comment] = ACTIONS(3),
  },
  [2206] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5258),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5258),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2207] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(5260),
    [anon_sym_RBRACE] = ACTIONS(5258),
    [anon_sym_SEMI] = ACTIONS(5260),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
  },
  [2208] = {
    [sym_class_body] = STATE(1628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2209] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5262),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2210] = {
    [sym_await_expression] = STATE(2218),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(2218),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(2218),
    [sym_function_type] = STATE(345),
    [sym__expression] = STATE(2218),
    [sym_jsx_element] = STATE(2218),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2218),
    [sym_call_expression] = STATE(2218),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(2218),
    [sym_template_string] = STATE(2218),
    [sym_yield_expression] = STATE(2218),
    [sym_jsx_fragment] = STATE(2218),
    [sym_new_expression] = STATE(2218),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(2218),
    [sym_binary_expression] = STATE(2218),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_array] = STATE(2749),
    [sym_as_expression] = STATE(2218),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2218),
    [sym_jsx_self_closing_element] = STATE(2218),
    [sym_arrow_function] = STATE(2218),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(2748),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(2534),
    [sym__type] = STATE(345),
    [sym_subscript_expression] = STATE(2748),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1460),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(2750),
    [sym_generator_function] = STATE(2218),
    [sym_constructor_type] = STATE(345),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(2218),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(2218),
    [sym_regex] = STATE(2218),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2218),
    [sym_class] = STATE(2218),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5264),
    [sym_false] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(5266),
    [anon_sym_number] = ACTIONS(5266),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(5268),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5270),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(4491),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(5274),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5266),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(5266),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(4485),
    [sym_number] = ACTIONS(4493),
    [sym_true] = ACTIONS(4487),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(5266),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5274),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(5276),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(5270),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2211] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2212] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2213] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1709),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2214] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1729),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2215] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2216] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1735),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1735),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2217] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1913),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1913),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2218] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2219] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2220] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(5278),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_implements] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2221] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(5278),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_implements] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2222] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2223] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(5281),
    [sym_false] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [sym_number] = ACTIONS(1169),
    [sym_true] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2224] = {
    [sym_class] = STATE(1321),
    [sym_arrow_function] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_jsx_element] = STATE(1321),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1321),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_regex] = STATE(1321),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1321),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1321),
    [sym_internal_module] = STATE(1321),
    [sym_jsx_self_closing_element] = STATE(1321),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4562),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4562),
    [sym_number] = ACTIONS(5283),
    [sym_true] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2225] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(5278),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_implements] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2226] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(2603),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2603),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2227] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2228] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2229] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(3224),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3224),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2230] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(3228),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3228),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2231] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(3238),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3238),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2232] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(3883),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2233] = {
    [aux_sym_string_repeat1] = STATE(2237),
    [sym_escape_sequence] = ACTIONS(5285),
    [aux_sym_string_token1] = ACTIONS(5287),
    [anon_sym_DQUOTE] = ACTIONS(5289),
    [sym_comment] = ACTIONS(255),
  },
  [2234] = {
    [sym_generator_function_declaration] = STATE(2239),
    [sym_while_statement] = STATE(2239),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(1904),
    [sym_jsx_element] = STATE(51),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2239),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(2239),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(2239),
    [sym_function_declaration] = STATE(2239),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2239),
    [sym_labeled_statement] = STATE(2239),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2239),
    [sym_arrow_function] = STATE(51),
    [sym_continue_statement] = STATE(2239),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(2239),
    [sym_type_alias_declaration] = STATE(2239),
    [sym_import_statement] = STATE(2239),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(2239),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(2239),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2239),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(2239),
    [sym_interface_declaration] = STATE(2239),
    [sym_export_statement] = STATE(2239),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2239),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(2239),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(1904),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(2239),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2239),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(2239),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2239),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(2239),
    [sym_template_string] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2239),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(2239),
    [sym_parenthesized_expression] = STATE(53),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_class_declaration] = STATE(2239),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(2239),
    [sym_spread_element] = STATE(1904),
    [sym_try_statement] = STATE(2239),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_abstract_class_declaration] = STATE(2239),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(2239),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(2239),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(1904),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(5291),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(5293),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(5295),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(5297),
    [anon_sym_static] = ACTIONS(5299),
    [anon_sym_get] = ACTIONS(5301),
    [anon_sym_RBRACE] = ACTIONS(5303),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(5297),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(5301),
    [anon_sym_type] = ACTIONS(5305),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(397),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(5309),
    [anon_sym_number] = ACTIONS(5293),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(5311),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(5293),
    [anon_sym_boolean] = ACTIONS(5293),
    [anon_sym_async] = ACTIONS(5313),
    [anon_sym_public] = ACTIONS(5297),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(405),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5293),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(5315),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2235] = {
    [aux_sym_string_repeat2] = STATE(2240),
    [sym_escape_sequence] = ACTIONS(5317),
    [aux_sym_string_token2] = ACTIONS(5319),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5289),
  },
  [2236] = {
    [sym_jsx_element] = STATE(2242),
    [sym_jsx_expression] = STATE(2242),
    [aux_sym_jsx_element_repeat1] = STATE(2242),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(1732),
    [sym_jsx_self_closing_element] = STATE(2242),
    [sym_jsx_text] = ACTIONS(5321),
    [anon_sym_LT] = ACTIONS(5323),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2237] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(854),
    [aux_sym_string_token1] = ACTIONS(856),
    [anon_sym_DQUOTE] = ACTIONS(5325),
    [sym_comment] = ACTIONS(255),
  },
  [2238] = {
    [sym_decorator] = STATE(2250),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(2250),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(5327),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2239] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2240] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(1233),
    [aux_sym_string_token2] = ACTIONS(1235),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5325),
  },
  [2241] = {
    [sym_generator_function_declaration] = STATE(2239),
    [sym__declaration] = STATE(2239),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2239),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2239),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2239),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2239),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2239),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2239),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2239),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2239),
    [sym_function_declaration] = STATE(2239),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2239),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2239),
    [sym_break_statement] = STATE(2239),
    [sym_labeled_statement] = STATE(2239),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2239),
    [sym_class_declaration] = STATE(2239),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2239),
    [sym_ambient_declaration] = STATE(2239),
    [sym_type_alias_declaration] = STATE(2239),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2239),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2239),
    [sym_switch_statement] = STATE(2239),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2239),
    [sym_throw_statement] = STATE(2239),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2239),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2239),
    [sym_abstract_class_declaration] = STATE(2239),
    [sym_interface_declaration] = STATE(2239),
    [sym_export_statement] = STATE(2239),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2239),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2239),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2239),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2239),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5331),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2242] = {
    [sym_jsx_element] = STATE(574),
    [sym_jsx_expression] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_closing_element] = STATE(1753),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(5323),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2243] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(2254),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(2254),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(2254),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(2254),
    [sym_property_signature] = STATE(2254),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(2254),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(5333),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_COMMA] = ACTIONS(5333),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5335),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5335),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2244] = {
    [sym_nested_identifier] = STATE(1759),
    [sym_identifier] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
  },
  [2245] = {
    [sym_number] = ACTIONS(5339),
    [sym_comment] = ACTIONS(3),
  },
  [2246] = {
    [sym_nested_type_identifier] = STATE(1762),
    [sym_nested_identifier] = STATE(2623),
    [sym_identifier] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
  },
  [2247] = {
    [anon_sym_EQ_GT] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
  },
  [2248] = {
    [aux_sym_implements_clause_repeat1] = STATE(2260),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(5345),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(5347),
    [sym_comment] = ACTIONS(3),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2250] = {
    [sym_decorator] = STATE(723),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(723),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2251] = {
    [anon_sym_GT] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
  },
  [2252] = {
    [sym_type_parameters] = STATE(1868),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_construct_signature] = STATE(623),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(623),
    [sym_pair] = STATE(1904),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(623),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(1904),
    [sym_assignment_pattern] = STATE(1904),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(1904),
    [sym__call_signature] = STATE(623),
    [sym_property_signature] = STATE(623),
    [sym_string] = STATE(842),
    [sym_index_signature] = STATE(623),
    [sym_identifier] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_module] = ACTIONS(4989),
    [anon_sym_symbol] = ACTIONS(4989),
    [anon_sym_number] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4989),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4991),
    [anon_sym_boolean] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4991),
    [anon_sym_get] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(5355),
    [anon_sym_static] = ACTIONS(4999),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4991),
    [anon_sym_string] = ACTIONS(4989),
    [anon_sym_set] = ACTIONS(4995),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(5001),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
  },
  [2254] = {
    [aux_sym_object_type_repeat1] = STATE(2270),
    [sym__automatic_semicolon] = ACTIONS(5359),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5359),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5361),
    [anon_sym_COMMA] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
  },
  [2255] = {
    [aux_sym_implements_clause_repeat1] = STATE(2271),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
  },
  [2256] = {
    [anon_sym_EQ_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
  },
  [2257] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_RPAREN] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
  },
  [2258] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2273),
    [sym_function_type] = STATE(2273),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2273),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2273),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2273),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_RBRACK] = ACTIONS(5369),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2259] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5371),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2260] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_GT] = ACTIONS(5371),
    [anon_sym_COMMA] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
  },
  [2261] = {
    [anon_sym_EQ_GT] = ACTIONS(5375),
    [sym_comment] = ACTIONS(3),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
  },
  [2263] = {
    [anon_sym_GT] = ACTIONS(5379),
    [sym_comment] = ACTIONS(3),
  },
  [2264] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [2265] = {
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
  },
  [2266] = {
    [anon_sym_GT] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [2267] = {
    [anon_sym_GT] = ACTIONS(5381),
    [sym_comment] = ACTIONS(3),
  },
  [2268] = {
    [aux_sym_object_type_repeat1] = STATE(2277),
    [sym__automatic_semicolon] = ACTIONS(5383),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_SEMI] = ACTIONS(5383),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5385),
    [anon_sym_COMMA] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
  },
  [2269] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5385),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2270] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(5383),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_SEMI] = ACTIONS(5383),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5385),
    [anon_sym_COMMA] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
  },
  [2271] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACK] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
  },
  [2272] = {
    [anon_sym_EQ_GT] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
  },
  [2273] = {
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_RBRACK] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
  },
  [2274] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5393),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2275] = {
    [sym_identifier] = ACTIONS(5395),
    [sym_comment] = ACTIONS(3),
  },
  [2276] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5397),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2277] = {
    [aux_sym_object_type_repeat1] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(5399),
    [anon_sym_RBRACE] = ACTIONS(5397),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5397),
    [anon_sym_COMMA] = ACTIONS(5399),
    [sym_comment] = ACTIONS(3),
  },
  [2278] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(1088),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(1088),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(1088),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(1088),
    [sym_property_signature] = STATE(1088),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(1088),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5401),
    [anon_sym_export] = ACTIONS(1829),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2279] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_nested_identifier] = STATE(1675),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(5403),
    [sym_false] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1161),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1161),
    [sym_number] = ACTIONS(1169),
    [sym_true] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2280] = {
    [sym_class] = STATE(1321),
    [sym_arrow_function] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_jsx_element] = STATE(1321),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1321),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_regex] = STATE(1321),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1321),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1321),
    [sym_internal_module] = STATE(1321),
    [sym_jsx_self_closing_element] = STATE(1321),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4562),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4562),
    [sym_number] = ACTIONS(5405),
    [sym_true] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2281] = {
    [aux_sym_string_repeat1] = STATE(2283),
    [sym_escape_sequence] = ACTIONS(5407),
    [aux_sym_string_token1] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(5411),
    [sym_comment] = ACTIONS(255),
  },
  [2282] = {
    [aux_sym_string_repeat2] = STATE(2286),
    [sym_escape_sequence] = ACTIONS(5413),
    [aux_sym_string_token2] = ACTIONS(5415),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5411),
  },
  [2283] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(854),
    [aux_sym_string_token1] = ACTIONS(856),
    [anon_sym_DQUOTE] = ACTIONS(5417),
    [sym_comment] = ACTIONS(255),
  },
  [2284] = {
    [sym_decorator] = STATE(2291),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(2291),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2285] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2286] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(1233),
    [aux_sym_string_token2] = ACTIONS(1235),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5417),
  },
  [2287] = {
    [sym_generator_function_declaration] = STATE(2285),
    [sym__declaration] = STATE(2285),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2285),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2285),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2285),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2285),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2285),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2285),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2285),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2285),
    [sym_function_declaration] = STATE(2285),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2285),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2285),
    [sym_break_statement] = STATE(2285),
    [sym_labeled_statement] = STATE(2285),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2285),
    [sym_class_declaration] = STATE(2285),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2285),
    [sym_ambient_declaration] = STATE(2285),
    [sym_type_alias_declaration] = STATE(2285),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2285),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2285),
    [sym_switch_statement] = STATE(2285),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2285),
    [sym_throw_statement] = STATE(2285),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2285),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2285),
    [sym_abstract_class_declaration] = STATE(2285),
    [sym_interface_declaration] = STATE(2285),
    [sym_export_statement] = STATE(2285),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2285),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2285),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2285),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2285),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2288] = {
    [anon_sym_EQ_GT] = ACTIONS(5425),
    [sym_comment] = ACTIONS(3),
  },
  [2289] = {
    [aux_sym_implements_clause_repeat1] = STATE(2295),
    [anon_sym_AMP] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(5427),
    [anon_sym_PIPE] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(5429),
    [sym_comment] = ACTIONS(3),
  },
  [2290] = {
    [sym_identifier] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
  },
  [2291] = {
    [sym_decorator] = STATE(723),
    [sym_computed_property_name] = STATE(425),
    [sym_accessibility_modifier] = STATE(424),
    [sym_public_field_definition] = STATE(421),
    [sym__property_name] = STATE(425),
    [sym_method_signature] = STATE(421),
    [sym_abstract_method_signature] = STATE(421),
    [sym_method_definition] = STATE(423),
    [aux_sym_class_body_repeat1] = STATE(723),
    [sym_string] = STATE(425),
    [sym_index_signature] = STATE(421),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_async] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_number] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(968),
    [sym_readonly] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2292] = {
    [sym_type_parameters] = STATE(1868),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_construct_signature] = STATE(623),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(623),
    [sym_pair] = STATE(1904),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(623),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(1904),
    [sym_assignment_pattern] = STATE(1904),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(1904),
    [sym__call_signature] = STATE(623),
    [sym_property_signature] = STATE(623),
    [sym_string] = STATE(842),
    [sym_index_signature] = STATE(623),
    [sym_identifier] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_module] = ACTIONS(4989),
    [anon_sym_symbol] = ACTIONS(4989),
    [anon_sym_number] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4989),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4991),
    [anon_sym_boolean] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4991),
    [anon_sym_get] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(4999),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4991),
    [anon_sym_string] = ACTIONS(4989),
    [anon_sym_set] = ACTIONS(4995),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1823),
    [anon_sym_export] = ACTIONS(5001),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2293] = {
    [anon_sym_EQ_GT] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
  },
  [2294] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2295] = {
    [aux_sym_implements_clause_repeat1] = STATE(908),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_COMMA] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
  },
  [2296] = {
    [anon_sym_EQ_GT] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
  },
  [2298] = {
    [anon_sym_EQ_GT] = ACTIONS(5447),
    [sym_comment] = ACTIONS(3),
  },
  [2299] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(906),
    [sym_function_type] = STATE(906),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(906),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(906),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(906),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(5449),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2300] = {
    [sym_identifier] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
  },
  [2301] = {
    [aux_sym_string_repeat1] = STATE(2303),
    [sym_escape_sequence] = ACTIONS(5453),
    [aux_sym_string_token1] = ACTIONS(5455),
    [anon_sym_DQUOTE] = ACTIONS(5457),
    [sym_comment] = ACTIONS(255),
  },
  [2302] = {
    [aux_sym_string_repeat2] = STATE(2304),
    [sym_escape_sequence] = ACTIONS(5459),
    [aux_sym_string_token2] = ACTIONS(5461),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5457),
  },
  [2303] = {
    [aux_sym_string_repeat1] = STATE(381),
    [sym_escape_sequence] = ACTIONS(854),
    [aux_sym_string_token1] = ACTIONS(856),
    [anon_sym_DQUOTE] = ACTIONS(5463),
    [sym_comment] = ACTIONS(255),
  },
  [2304] = {
    [aux_sym_string_repeat2] = STATE(501),
    [sym_escape_sequence] = ACTIONS(1233),
    [aux_sym_string_token2] = ACTIONS(1235),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5463),
  },
  [2305] = {
    [sym_generator_function_declaration] = STATE(2366),
    [sym__declaration] = STATE(2366),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2366),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2366),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2366),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2366),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2366),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2366),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2366),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2366),
    [sym_function_declaration] = STATE(2366),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2366),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2366),
    [sym_break_statement] = STATE(2366),
    [sym_labeled_statement] = STATE(2366),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2366),
    [sym_class_declaration] = STATE(2366),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2366),
    [sym_ambient_declaration] = STATE(2366),
    [sym_type_alias_declaration] = STATE(2366),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2366),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2366),
    [sym_switch_statement] = STATE(2366),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2366),
    [sym_throw_statement] = STATE(2366),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2366),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2366),
    [sym_abstract_class_declaration] = STATE(2366),
    [sym_interface_declaration] = STATE(2366),
    [sym_export_statement] = STATE(2366),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2366),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2366),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2366),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2366),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5465),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(5467),
    [sym_comment] = ACTIONS(3),
  },
  [2307] = {
    [sym_type_parameters] = STATE(1868),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [aux_sym_object_repeat1] = STATE(1906),
    [sym_construct_signature] = STATE(2174),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(2174),
    [sym_pair] = STATE(1904),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(2174),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(1904),
    [sym_assignment_pattern] = STATE(1904),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(1904),
    [sym__call_signature] = STATE(2174),
    [sym_property_signature] = STATE(2174),
    [sym_string] = STATE(842),
    [sym_index_signature] = STATE(2174),
    [sym_identifier] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(5180),
    [anon_sym_module] = ACTIONS(4989),
    [anon_sym_symbol] = ACTIONS(4989),
    [anon_sym_number] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4989),
    [anon_sym_COMMA] = ACTIONS(5469),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4991),
    [anon_sym_boolean] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4991),
    [anon_sym_get] = ACTIONS(4995),
    [anon_sym_RBRACE] = ACTIONS(5471),
    [anon_sym_static] = ACTIONS(4999),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4991),
    [anon_sym_string] = ACTIONS(4989),
    [anon_sym_set] = ACTIONS(4995),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5182),
    [anon_sym_export] = ACTIONS(5001),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
  },
  [2309] = {
    [sym_identifier] = ACTIONS(5475),
    [sym_comment] = ACTIONS(3),
  },
  [2310] = {
    [sym_generator_function_declaration] = STATE(2543),
    [sym__declaration] = STATE(2543),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2543),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2543),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2543),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2543),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2543),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2543),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2543),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2543),
    [sym_function_declaration] = STATE(2543),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2543),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2543),
    [sym_break_statement] = STATE(2543),
    [sym_labeled_statement] = STATE(2543),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2543),
    [sym_class_declaration] = STATE(2543),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2543),
    [sym_ambient_declaration] = STATE(2543),
    [sym_type_alias_declaration] = STATE(2543),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2543),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2543),
    [sym_switch_statement] = STATE(2543),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2543),
    [sym_throw_statement] = STATE(2543),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2543),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2543),
    [sym_abstract_class_declaration] = STATE(2543),
    [sym_interface_declaration] = STATE(2543),
    [sym_export_statement] = STATE(2543),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2543),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2543),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2543),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2543),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2311] = {
    [sym_identifier] = ACTIONS(5477),
    [sym_comment] = ACTIONS(3),
  },
  [2312] = {
    [sym_identifier] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
  },
  [2313] = {
    [sym_identifier] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
  },
  [2314] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2315] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2316] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(107),
  },
  [2317] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(1875),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [2318] = {
    [sym_identifier] = ACTIONS(5485),
    [sym_comment] = ACTIONS(3),
  },
  [2319] = {
    [sym_identifier] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
  },
  [2320] = {
    [sym_parenthesized_expression] = STATE(1880),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2321] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2322] = {
    [sym__for_header] = STATE(1882),
    [anon_sym_LPAREN] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(5491),
  },
  [2323] = {
    [sym_string] = STATE(1328),
    [sym_nested_identifier] = STATE(1327),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2324] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(153),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(152),
    [sym_type_parameters] = STATE(154),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(5493),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2325] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(343),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5495),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_declare] = ACTIONS(4920),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(4928),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2326] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(2150),
    [sym_update_expression] = STATE(2150),
    [sym_meta_property] = STATE(2150),
    [sym__expression] = STATE(2150),
    [sym_jsx_element] = STATE(2150),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2150),
    [sym_call_expression] = STATE(2150),
    [sym_ternary_expression] = STATE(2150),
    [sym_template_string] = STATE(2150),
    [sym_yield_expression] = STATE(2150),
    [sym_jsx_fragment] = STATE(2150),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(2150),
    [sym_assignment_expression] = STATE(2150),
    [sym_binary_expression] = STATE(2150),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(2150),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(2150),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(2150),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(2149),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(2150),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(2150),
    [sym_augmented_assignment_expression] = STATE(2150),
    [sym_unary_expression] = STATE(2150),
    [sym_regex] = STATE(2150),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(2150),
    [sym_class] = STATE(2150),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(411),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(415),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(5003),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(411),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5003),
    [anon_sym_module] = ACTIONS(411),
    [anon_sym_number] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5003),
    [anon_sym_any] = ACTIONS(411),
    [anon_sym_boolean] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5497),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5003),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [2327] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(437),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(437),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(437),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_protected] = ACTIONS(437),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(437),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(437),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(437),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(5499),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2328] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(1913),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [2329] = {
    [sym_parenthesized_expression] = STATE(1914),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2330] = {
    [sym_regex_pattern] = ACTIONS(5501),
    [sym_comment] = ACTIONS(255),
  },
  [2331] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(1875),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [2332] = {
    [sym_class_declaration] = STATE(249),
    [sym_generator_function_declaration] = STATE(249),
    [sym__declaration] = STATE(249),
    [sym_enum_declaration] = STATE(249),
    [sym_function_signature] = STATE(249),
    [sym_abstract_class_declaration] = STATE(249),
    [sym_module] = STATE(249),
    [sym_interface_declaration] = STATE(249),
    [sym_function_declaration] = STATE(249),
    [sym_export_clause] = STATE(250),
    [sym_variable_declaration] = STATE(249),
    [sym_lexical_declaration] = STATE(249),
    [sym_ambient_declaration] = STATE(249),
    [sym_import_alias] = STATE(249),
    [sym_type_alias_declaration] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(249),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_as] = ACTIONS(507),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(4916),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_declare] = ACTIONS(4920),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(4928),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2333] = {
    [sym_parenthesized_expression] = STATE(1922),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2334] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5503),
    [anon_sym_class] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
  },
  [2335] = {
    [sym_class] = STATE(1929),
    [sym_arrow_function] = STATE(1929),
    [sym_await_expression] = STATE(1929),
    [sym_member_expression] = STATE(2685),
    [sym_statement_block] = STATE(281),
    [sym_update_expression] = STATE(1929),
    [sym_meta_property] = STATE(1929),
    [sym__expression] = STATE(1929),
    [sym_jsx_element] = STATE(1929),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1929),
    [sym_call_expression] = STATE(1929),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1929),
    [sym_string] = STATE(1929),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1929),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1929),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1929),
    [sym_generator_function] = STATE(1929),
    [sym_new_expression] = STATE(1929),
    [sym_assignment_expression] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1929),
    [sym_binary_expression] = STATE(1929),
    [sym_unary_expression] = STATE(1929),
    [sym_regex] = STATE(1929),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1929),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1929),
    [sym_internal_module] = STATE(1929),
    [sym_jsx_self_closing_element] = STATE(1929),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5507),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5507),
    [sym_number] = ACTIONS(5509),
    [sym_true] = ACTIONS(5507),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5507),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2336] = {
    [sym_class] = STATE(1930),
    [sym_arrow_function] = STATE(1930),
    [sym_await_expression] = STATE(1930),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1930),
    [sym_meta_property] = STATE(1930),
    [sym__expression] = STATE(1930),
    [sym_jsx_element] = STATE(1930),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1930),
    [sym_call_expression] = STATE(1930),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1930),
    [sym_string] = STATE(1930),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1930),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1930),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1930),
    [sym_generator_function] = STATE(1930),
    [sym_new_expression] = STATE(1930),
    [sym_assignment_expression] = STATE(1930),
    [sym_augmented_assignment_expression] = STATE(1930),
    [sym_binary_expression] = STATE(1930),
    [sym_unary_expression] = STATE(1930),
    [sym_regex] = STATE(1930),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1930),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1930),
    [sym_internal_module] = STATE(1930),
    [sym_jsx_self_closing_element] = STATE(1930),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5511),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5511),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5511),
    [sym_number] = ACTIONS(5513),
    [sym_true] = ACTIONS(5511),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5511),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2337] = {
    [sym_class] = STATE(1931),
    [sym_arrow_function] = STATE(1931),
    [sym_await_expression] = STATE(1931),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1931),
    [sym_meta_property] = STATE(1931),
    [sym__expression] = STATE(1931),
    [sym_jsx_element] = STATE(1931),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1931),
    [sym_call_expression] = STATE(1931),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1931),
    [sym_string] = STATE(1931),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1931),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1931),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1931),
    [sym_generator_function] = STATE(1931),
    [sym_new_expression] = STATE(1931),
    [sym_assignment_expression] = STATE(1931),
    [sym_augmented_assignment_expression] = STATE(1931),
    [sym_binary_expression] = STATE(1931),
    [sym_unary_expression] = STATE(1931),
    [sym_regex] = STATE(1931),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1931),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1931),
    [sym_internal_module] = STATE(1931),
    [sym_jsx_self_closing_element] = STATE(1931),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5515),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5515),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5515),
    [sym_number] = ACTIONS(5517),
    [sym_true] = ACTIONS(5515),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5515),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2338] = {
    [sym_class] = STATE(1932),
    [sym_arrow_function] = STATE(1932),
    [sym_await_expression] = STATE(1932),
    [sym_member_expression] = STATE(2685),
    [sym_statement_block] = STATE(291),
    [sym_update_expression] = STATE(1932),
    [sym_meta_property] = STATE(1932),
    [sym__expression] = STATE(1932),
    [sym_jsx_element] = STATE(1932),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1932),
    [sym_call_expression] = STATE(1932),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1932),
    [sym_string] = STATE(1932),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1932),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1932),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1932),
    [sym_generator_function] = STATE(1932),
    [sym_new_expression] = STATE(1932),
    [sym_assignment_expression] = STATE(1932),
    [sym_augmented_assignment_expression] = STATE(1932),
    [sym_binary_expression] = STATE(1932),
    [sym_unary_expression] = STATE(1932),
    [sym_regex] = STATE(1932),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1932),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1932),
    [sym_internal_module] = STATE(1932),
    [sym_jsx_self_closing_element] = STATE(1932),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5519),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5519),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5519),
    [sym_number] = ACTIONS(5521),
    [sym_true] = ACTIONS(5519),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5519),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2339] = {
    [sym_class] = STATE(1933),
    [sym_arrow_function] = STATE(1933),
    [sym_await_expression] = STATE(1933),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1933),
    [sym_meta_property] = STATE(1933),
    [sym__expression] = STATE(1933),
    [sym_jsx_element] = STATE(1933),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1933),
    [sym_call_expression] = STATE(1933),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1933),
    [sym_string] = STATE(1933),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1933),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1933),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1933),
    [sym_generator_function] = STATE(1933),
    [sym_new_expression] = STATE(1933),
    [sym_assignment_expression] = STATE(1933),
    [sym_augmented_assignment_expression] = STATE(1933),
    [sym_binary_expression] = STATE(1933),
    [sym_unary_expression] = STATE(1933),
    [sym_regex] = STATE(1933),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1933),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1933),
    [sym_internal_module] = STATE(1933),
    [sym_jsx_self_closing_element] = STATE(1933),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5523),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5523),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5523),
    [sym_number] = ACTIONS(5525),
    [sym_true] = ACTIONS(5523),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5523),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2340] = {
    [sym_class] = STATE(1934),
    [sym_arrow_function] = STATE(1934),
    [sym_await_expression] = STATE(1934),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1934),
    [sym_meta_property] = STATE(1934),
    [sym__expression] = STATE(1934),
    [sym_jsx_element] = STATE(1934),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1934),
    [sym_call_expression] = STATE(1934),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1934),
    [sym_string] = STATE(1934),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1934),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1934),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1934),
    [sym_generator_function] = STATE(1934),
    [sym_new_expression] = STATE(1934),
    [sym_assignment_expression] = STATE(1934),
    [sym_augmented_assignment_expression] = STATE(1934),
    [sym_binary_expression] = STATE(1934),
    [sym_unary_expression] = STATE(1934),
    [sym_regex] = STATE(1934),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1934),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1934),
    [sym_internal_module] = STATE(1934),
    [sym_jsx_self_closing_element] = STATE(1934),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5527),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5527),
    [sym_number] = ACTIONS(5529),
    [sym_true] = ACTIONS(5527),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5527),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2341] = {
    [sym_arguments] = STATE(297),
    [anon_sym_LBRACK] = ACTIONS(665),
    [sym_identifier] = ACTIONS(5531),
    [anon_sym_module] = ACTIONS(5531),
    [anon_sym_symbol] = ACTIONS(5531),
    [anon_sym_number] = ACTIONS(5531),
    [anon_sym_class] = ACTIONS(5531),
    [anon_sym_AT] = ACTIONS(665),
    [anon_sym_declare] = ACTIONS(5531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(665),
    [anon_sym_void] = ACTIONS(5531),
    [anon_sym_LPAREN] = ACTIONS(5533),
    [anon_sym_any] = ACTIONS(5531),
    [anon_sym_private] = ACTIONS(5531),
    [anon_sym_boolean] = ACTIONS(5531),
    [anon_sym_static] = ACTIONS(5531),
    [anon_sym_public] = ACTIONS(5531),
    [anon_sym_get] = ACTIONS(5531),
    [anon_sym_async] = ACTIONS(5531),
    [anon_sym_RBRACE] = ACTIONS(665),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [sym_this] = ACTIONS(5531),
    [sym_number] = ACTIONS(665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5531),
    [anon_sym_string] = ACTIONS(5531),
    [anon_sym_abstract] = ACTIONS(5531),
    [anon_sym_DOT] = ACTIONS(5535),
    [anon_sym_set] = ACTIONS(5531),
    [anon_sym_type] = ACTIONS(5531),
    [anon_sym_export] = ACTIONS(5531),
    [sym_readonly] = ACTIONS(5531),
    [anon_sym_namespace] = ACTIONS(5531),
    [anon_sym_DQUOTE] = ACTIONS(665),
  },
  [2342] = {
    [sym_arguments] = STATE(299),
    [anon_sym_LBRACK] = ACTIONS(669),
    [sym_identifier] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_class] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(669),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_void] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(5533),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_async] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_SQUOTE] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_number] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_abstract] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(5537),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_export] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(671),
    [anon_sym_DQUOTE] = ACTIONS(669),
  },
  [2343] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_AMP_EQ] = ACTIONS(4737),
    [anon_sym_PLUS_EQ] = ACTIONS(4737),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4739),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4737),
    [anon_sym_STAR_EQ] = ACTIONS(4737),
    [anon_sym_PIPE_EQ] = ACTIONS(4737),
    [anon_sym_DASH_EQ] = ACTIONS(4737),
    [anon_sym_EQ_GT] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4737),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2344] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_AMP_EQ] = ACTIONS(4745),
    [anon_sym_PLUS_EQ] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4745),
    [anon_sym_STAR_EQ] = ACTIONS(4745),
    [anon_sym_PIPE_EQ] = ACTIONS(4745),
    [anon_sym_DASH_EQ] = ACTIONS(4745),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(4745),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2345] = {
    [sym_class] = STATE(2351),
    [sym_arrow_function] = STATE(2351),
    [sym_await_expression] = STATE(2351),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2351),
    [sym_meta_property] = STATE(2351),
    [sym__expression] = STATE(2351),
    [sym_jsx_element] = STATE(2351),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2351),
    [sym_call_expression] = STATE(2351),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2351),
    [sym_string] = STATE(2351),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2351),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2351),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2351),
    [sym_generator_function] = STATE(2351),
    [sym_new_expression] = STATE(2351),
    [sym_assignment_expression] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(2351),
    [sym_binary_expression] = STATE(2351),
    [sym_unary_expression] = STATE(2351),
    [sym_regex] = STATE(2351),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2351),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2351),
    [sym_internal_module] = STATE(2351),
    [sym_jsx_self_closing_element] = STATE(2351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4745),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(4745),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4745),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(4745),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(4745),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4745),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(4751),
    [anon_sym_yield] = ACTIONS(1372),
    [sym_true] = ACTIONS(4751),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4745),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(4751),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4751),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(4745),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(4755),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4745),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4751),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(1384),
  },
  [2346] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2700),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5539),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(4745),
    [anon_sym_symbol] = ACTIONS(5541),
    [anon_sym_AMP_EQ] = ACTIONS(4745),
    [anon_sym_PLUS_EQ] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_void] = ACTIONS(5541),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(4745),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_PIPE_EQ] = ACTIONS(4745),
    [anon_sym_static] = ACTIONS(5541),
    [anon_sym_DASH_EQ] = ACTIONS(4745),
    [anon_sym_get] = ACTIONS(5541),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4745),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(5541),
    [anon_sym_type] = ACTIONS(5541),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4745),
    [anon_sym_namespace] = ACTIONS(5541),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5541),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_number] = ACTIONS(5541),
    [anon_sym_declare] = ACTIONS(5541),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5541),
    [anon_sym_STAR_EQ] = ACTIONS(4745),
    [anon_sym_boolean] = ACTIONS(5541),
    [anon_sym_async] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4745),
    [anon_sym_string] = ACTIONS(5541),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(5541),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2347] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1918),
    [sym_identifier] = ACTIONS(5543),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
  },
  [2348] = {
    [sym_string] = STATE(1639),
    [sym_nested_identifier] = STATE(1638),
    [sym__module] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(697),
    [anon_sym_PERCENT_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_AMP_EQ] = ACTIONS(4745),
    [anon_sym_PLUS_EQ] = ACTIONS(4745),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4745),
    [anon_sym_STAR_EQ] = ACTIONS(4745),
    [anon_sym_PIPE_EQ] = ACTIONS(4745),
    [anon_sym_DASH_EQ] = ACTIONS(4745),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(4745),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT_EQ] = ACTIONS(4745),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4745),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2349] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(701),
  },
  [2350] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(5550),
    [sym_comment] = ACTIONS(3),
  },
  [2351] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(5552),
    [sym_comment] = ACTIONS(3),
  },
  [2353] = {
    [sym_await_expression] = STATE(1945),
    [sym_update_expression] = STATE(1945),
    [sym_meta_property] = STATE(1945),
    [sym__expression] = STATE(1945),
    [sym_jsx_element] = STATE(1945),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1945),
    [sym_call_expression] = STATE(1945),
    [sym_ternary_expression] = STATE(1945),
    [sym_template_string] = STATE(1945),
    [sym_yield_expression] = STATE(1945),
    [sym_jsx_fragment] = STATE(1945),
    [sym_new_expression] = STATE(1945),
    [sym_assignment_expression] = STATE(1945),
    [sym_binary_expression] = STATE(1945),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_array] = STATE(1304),
    [sym_as_expression] = STATE(1945),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(1945),
    [sym_jsx_self_closing_element] = STATE(1945),
    [sym_arrow_function] = STATE(1945),
    [sym_member_expression] = STATE(1303),
    [sym_sequence_expression] = STATE(1944),
    [sym__call_signature] = STATE(1867),
    [sym_subscript_expression] = STATE(1303),
    [sym_string] = STATE(1945),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(1307),
    [sym_generator_function] = STATE(1945),
    [sym_augmented_assignment_expression] = STATE(1945),
    [sym_unary_expression] = STATE(1945),
    [sym_regex] = STATE(1945),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(1945),
    [sym_class] = STATE(1945),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(5554),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(5554),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5554),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5554),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5556),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5554),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(321),
  },
  [2354] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(1951),
    [sym_function_type] = STATE(1951),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(1951),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(1951),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(1951),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2355] = {
    [sym_class] = STATE(205),
    [sym_arrow_function] = STATE(205),
    [sym_await_expression] = STATE(205),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(205),
    [sym_sequence_expression] = STATE(204),
    [sym_meta_property] = STATE(205),
    [sym__expression] = STATE(205),
    [sym_jsx_element] = STATE(205),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(205),
    [sym_call_expression] = STATE(205),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(205),
    [sym_string] = STATE(205),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(205),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(205),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(205),
    [sym_generator_function] = STATE(205),
    [sym_new_expression] = STATE(205),
    [sym_assignment_expression] = STATE(205),
    [sym_augmented_assignment_expression] = STATE(205),
    [sym_binary_expression] = STATE(205),
    [sym_unary_expression] = STATE(205),
    [sym_regex] = STATE(205),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(205),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(205),
    [sym_internal_module] = STATE(205),
    [sym_jsx_self_closing_element] = STATE(205),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(421),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(421),
    [sym_number] = ACTIONS(433),
    [sym_true] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(421),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2356] = {
    [sym_class] = STATE(1958),
    [sym_arrow_function] = STATE(1958),
    [sym_await_expression] = STATE(1958),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1958),
    [sym_meta_property] = STATE(1958),
    [sym__expression] = STATE(1958),
    [sym_jsx_element] = STATE(1958),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1958),
    [sym_call_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1958),
    [sym_string] = STATE(1958),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1958),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1958),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1958),
    [sym_generator_function] = STATE(1958),
    [sym_new_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(1958),
    [sym_augmented_assignment_expression] = STATE(1958),
    [sym_binary_expression] = STATE(1958),
    [sym_unary_expression] = STATE(1958),
    [sym_regex] = STATE(1958),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1958),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1958),
    [sym_internal_module] = STATE(1958),
    [sym_jsx_self_closing_element] = STATE(1958),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5558),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5558),
    [sym_number] = ACTIONS(5560),
    [sym_true] = ACTIONS(5558),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5558),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2357] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(806),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(5562),
    [sym_comment] = ACTIONS(3),
  },
  [2359] = {
    [sym_statement_block] = STATE(379),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(2872),
    [anon_sym_PIPE_RBRACE] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2360] = {
    [sym_statement_block] = STATE(379),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_PIPE_RBRACE] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2361] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(699),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2362] = {
    [sym__for_header] = STATE(1961),
    [anon_sym_LPAREN] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
  },
  [2363] = {
    [sym_string] = STATE(1328),
    [sym_nested_identifier] = STATE(1327),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [2364] = {
    [sym_identifier] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
  },
  [2365] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(5495),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4920),
    [anon_sym_global] = ACTIONS(343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_async] = ACTIONS(4928),
  },
  [2366] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5568),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2367] = {
    [sym_default_type] = STATE(519),
    [sym_jsx_expression] = STATE(516),
    [sym_type_arguments] = STATE(518),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_constraint] = STATE(517),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_extends] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1271),
  },
  [2368] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2421),
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2369] = {
    [sym_jsx_expression] = STATE(516),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_type_arguments] = STATE(518),
    [sym_jsx_attribute] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2370] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2371] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(1980),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2372] = {
    [sym_arguments] = STATE(530),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1294),
  },
  [2373] = {
    [sym_arguments] = STATE(532),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
  },
  [2374] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym_arguments] = STATE(532),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_false] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [sym_null] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_await] = ACTIONS(499),
  },
  [2375] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(532),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2700),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(5539),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(5541),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(5541),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(5541),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(5541),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(5541),
    [anon_sym_type] = ACTIONS(5541),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(5541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(5541),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(5541),
    [anon_sym_declare] = ACTIONS(5541),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(5541),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(5541),
    [anon_sym_async] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(5541),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(5541),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [2376] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_arguments] = STATE(532),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym__automatic_semicolon] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
  },
  [2377] = {
    [sym_nested_identifier] = STATE(1327),
    [sym_string] = STATE(1328),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [2378] = {
    [sym__from_clause] = STATE(1982),
    [anon_sym_from] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
  },
  [2379] = {
    [sym_class] = STATE(1983),
    [sym_arrow_function] = STATE(1983),
    [sym_await_expression] = STATE(1983),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1983),
    [sym_meta_property] = STATE(1983),
    [sym__expression] = STATE(1983),
    [sym_jsx_element] = STATE(1983),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1983),
    [sym_call_expression] = STATE(1983),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1983),
    [sym_string] = STATE(1983),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1983),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1983),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1983),
    [sym_generator_function] = STATE(1983),
    [sym_new_expression] = STATE(1983),
    [sym_assignment_expression] = STATE(1983),
    [sym_augmented_assignment_expression] = STATE(1983),
    [sym_binary_expression] = STATE(1983),
    [sym_unary_expression] = STATE(1983),
    [sym_regex] = STATE(1983),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1983),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1983),
    [sym_internal_module] = STATE(1983),
    [sym_jsx_self_closing_element] = STATE(1983),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5572),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5572),
    [sym_number] = ACTIONS(5574),
    [sym_true] = ACTIONS(5572),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5572),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2380] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(583),
  },
  [2381] = {
    [sym_class] = STATE(1984),
    [sym_arrow_function] = STATE(1984),
    [sym_await_expression] = STATE(1984),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1984),
    [sym_meta_property] = STATE(1984),
    [sym__expression] = STATE(1984),
    [sym_jsx_element] = STATE(1984),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1984),
    [sym_call_expression] = STATE(1984),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1984),
    [sym_string] = STATE(1984),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1984),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1984),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1984),
    [sym_generator_function] = STATE(1984),
    [sym_new_expression] = STATE(1984),
    [sym_assignment_expression] = STATE(1984),
    [sym_augmented_assignment_expression] = STATE(1984),
    [sym_binary_expression] = STATE(1984),
    [sym_unary_expression] = STATE(1984),
    [sym_regex] = STATE(1984),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1984),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1984),
    [sym_internal_module] = STATE(1984),
    [sym_jsx_self_closing_element] = STATE(1984),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(4902),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4902),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(4902),
    [sym_number] = ACTIONS(5576),
    [sym_true] = ACTIONS(4902),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4902),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2382] = {
    [sym_class] = STATE(1985),
    [sym_arrow_function] = STATE(1985),
    [sym_await_expression] = STATE(1985),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1985),
    [sym_meta_property] = STATE(1985),
    [sym__expression] = STATE(1985),
    [sym_jsx_element] = STATE(1985),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1985),
    [sym_call_expression] = STATE(1985),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1985),
    [sym_string] = STATE(1985),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1985),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1985),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1985),
    [sym_generator_function] = STATE(1985),
    [sym_new_expression] = STATE(1985),
    [sym_assignment_expression] = STATE(1985),
    [sym_augmented_assignment_expression] = STATE(1985),
    [sym_binary_expression] = STATE(1985),
    [sym_unary_expression] = STATE(1985),
    [sym_regex] = STATE(1985),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1985),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1985),
    [sym_internal_module] = STATE(1985),
    [sym_jsx_self_closing_element] = STATE(1985),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5578),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5578),
    [sym_number] = ACTIONS(5580),
    [sym_true] = ACTIONS(5578),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5578),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2383] = {
    [sym_class] = STATE(1986),
    [sym_arrow_function] = STATE(1986),
    [sym_await_expression] = STATE(1986),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1986),
    [sym_meta_property] = STATE(1986),
    [sym__expression] = STATE(1986),
    [sym_jsx_element] = STATE(1986),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1986),
    [sym_call_expression] = STATE(1986),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1986),
    [sym_string] = STATE(1986),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1986),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1986),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1986),
    [sym_generator_function] = STATE(1986),
    [sym_new_expression] = STATE(1986),
    [sym_assignment_expression] = STATE(1986),
    [sym_augmented_assignment_expression] = STATE(1986),
    [sym_binary_expression] = STATE(1986),
    [sym_unary_expression] = STATE(1986),
    [sym_regex] = STATE(1986),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1986),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1986),
    [sym_internal_module] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1986),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5582),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5582),
    [sym_number] = ACTIONS(5584),
    [sym_true] = ACTIONS(5582),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5582),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2384] = {
    [sym_class] = STATE(1987),
    [sym_arrow_function] = STATE(1987),
    [sym_await_expression] = STATE(1987),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1987),
    [sym_meta_property] = STATE(1987),
    [sym__expression] = STATE(1987),
    [sym_jsx_element] = STATE(1987),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1987),
    [sym_call_expression] = STATE(1987),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1987),
    [sym_string] = STATE(1987),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1987),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1987),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1987),
    [sym_generator_function] = STATE(1987),
    [sym_new_expression] = STATE(1987),
    [sym_assignment_expression] = STATE(1987),
    [sym_augmented_assignment_expression] = STATE(1987),
    [sym_binary_expression] = STATE(1987),
    [sym_unary_expression] = STATE(1987),
    [sym_regex] = STATE(1987),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1987),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1987),
    [sym_internal_module] = STATE(1987),
    [sym_jsx_self_closing_element] = STATE(1987),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5586),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5586),
    [sym_number] = ACTIONS(5588),
    [sym_true] = ACTIONS(5586),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5586),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2385] = {
    [sym_class] = STATE(1988),
    [sym_arrow_function] = STATE(1988),
    [sym_await_expression] = STATE(1988),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1988),
    [sym_meta_property] = STATE(1988),
    [sym__expression] = STATE(1988),
    [sym_jsx_element] = STATE(1988),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1988),
    [sym_call_expression] = STATE(1988),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1988),
    [sym_string] = STATE(1988),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1988),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1988),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1988),
    [sym_generator_function] = STATE(1988),
    [sym_new_expression] = STATE(1988),
    [sym_assignment_expression] = STATE(1988),
    [sym_augmented_assignment_expression] = STATE(1988),
    [sym_binary_expression] = STATE(1988),
    [sym_unary_expression] = STATE(1988),
    [sym_regex] = STATE(1988),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1988),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1988),
    [sym_internal_module] = STATE(1988),
    [sym_jsx_self_closing_element] = STATE(1988),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5590),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5590),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5590),
    [sym_number] = ACTIONS(5592),
    [sym_true] = ACTIONS(5590),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5590),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2386] = {
    [sym_class] = STATE(1989),
    [sym_arrow_function] = STATE(1989),
    [sym_await_expression] = STATE(1989),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(1989),
    [sym_meta_property] = STATE(1989),
    [sym__expression] = STATE(1989),
    [sym_jsx_element] = STATE(1989),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1989),
    [sym_call_expression] = STATE(1989),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1989),
    [sym_string] = STATE(1989),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1989),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1989),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(1989),
    [sym_generator_function] = STATE(1989),
    [sym_new_expression] = STATE(1989),
    [sym_assignment_expression] = STATE(1989),
    [sym_augmented_assignment_expression] = STATE(1989),
    [sym_binary_expression] = STATE(1989),
    [sym_unary_expression] = STATE(1989),
    [sym_regex] = STATE(1989),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(1989),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1989),
    [sym_internal_module] = STATE(1989),
    [sym_jsx_self_closing_element] = STATE(1989),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5594),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5594),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5594),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5594),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5594),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2387] = {
    [sym_class] = STATE(1993),
    [sym_arrow_function] = STATE(1993),
    [sym_await_expression] = STATE(1993),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1993),
    [sym_meta_property] = STATE(1993),
    [sym__expression] = STATE(1993),
    [sym_jsx_element] = STATE(1993),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1993),
    [sym_call_expression] = STATE(1993),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1993),
    [sym_string] = STATE(1993),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1993),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1993),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1993),
    [sym_generator_function] = STATE(1993),
    [sym_new_expression] = STATE(1993),
    [sym_assignment_expression] = STATE(1993),
    [sym_augmented_assignment_expression] = STATE(1993),
    [sym_binary_expression] = STATE(1993),
    [sym_unary_expression] = STATE(1993),
    [sym_regex] = STATE(1993),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1993),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1993),
    [sym_internal_module] = STATE(1993),
    [sym_jsx_self_closing_element] = STATE(1993),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5598),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5598),
    [sym_number] = ACTIONS(5600),
    [sym_true] = ACTIONS(5598),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5598),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2388] = {
    [sym_class] = STATE(1994),
    [sym_arrow_function] = STATE(1994),
    [sym_await_expression] = STATE(1994),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1994),
    [sym_meta_property] = STATE(1994),
    [sym__expression] = STATE(1994),
    [sym_jsx_element] = STATE(1994),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1994),
    [sym_call_expression] = STATE(1994),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1994),
    [sym_string] = STATE(1994),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1994),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1994),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1994),
    [sym_generator_function] = STATE(1994),
    [sym_new_expression] = STATE(1994),
    [sym_assignment_expression] = STATE(1994),
    [sym_augmented_assignment_expression] = STATE(1994),
    [sym_binary_expression] = STATE(1994),
    [sym_unary_expression] = STATE(1994),
    [sym_regex] = STATE(1994),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1994),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1994),
    [sym_internal_module] = STATE(1994),
    [sym_jsx_self_closing_element] = STATE(1994),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5602),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5602),
    [sym_number] = ACTIONS(5604),
    [sym_true] = ACTIONS(5602),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5602),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2389] = {
    [sym_class] = STATE(1997),
    [sym_arrow_function] = STATE(1997),
    [sym_await_expression] = STATE(1997),
    [sym_member_expression] = STATE(2685),
    [sym_statement_block] = STATE(576),
    [sym_update_expression] = STATE(1997),
    [sym_meta_property] = STATE(1997),
    [sym__expression] = STATE(1997),
    [sym_jsx_element] = STATE(1997),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1997),
    [sym_call_expression] = STATE(1997),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1997),
    [sym_string] = STATE(1997),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1997),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1997),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1997),
    [sym_generator_function] = STATE(1997),
    [sym_new_expression] = STATE(1997),
    [sym_assignment_expression] = STATE(1997),
    [sym_augmented_assignment_expression] = STATE(1997),
    [sym_binary_expression] = STATE(1997),
    [sym_unary_expression] = STATE(1997),
    [sym_regex] = STATE(1997),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1997),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1997),
    [sym_internal_module] = STATE(1997),
    [sym_jsx_self_closing_element] = STATE(1997),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5606),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5606),
    [sym_number] = ACTIONS(5608),
    [sym_true] = ACTIONS(5606),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5606),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2390] = {
    [sym_class] = STATE(1998),
    [sym_arrow_function] = STATE(1998),
    [sym_await_expression] = STATE(1998),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(1998),
    [sym_meta_property] = STATE(1998),
    [sym__expression] = STATE(1998),
    [sym_jsx_element] = STATE(1998),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1998),
    [sym_call_expression] = STATE(1998),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(1998),
    [sym_string] = STATE(1998),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1998),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1998),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(1998),
    [sym_generator_function] = STATE(1998),
    [sym_new_expression] = STATE(1998),
    [sym_assignment_expression] = STATE(1998),
    [sym_augmented_assignment_expression] = STATE(1998),
    [sym_binary_expression] = STATE(1998),
    [sym_unary_expression] = STATE(1998),
    [sym_regex] = STATE(1998),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(1998),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(1998),
    [sym_internal_module] = STATE(1998),
    [sym_jsx_self_closing_element] = STATE(1998),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5610),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5610),
    [sym_number] = ACTIONS(5612),
    [sym_true] = ACTIONS(5610),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5610),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2391] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(584),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(427),
    [sym_type_parameters] = STATE(585),
    [anon_sym_extends] = ACTIONS(333),
    [sym_identifier] = ACTIONS(5614),
    [anon_sym_implements] = ACTIONS(337),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(341),
  },
  [2392] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1977),
    [sym_identifier] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(5618),
    [sym_comment] = ACTIONS(3),
  },
  [2393] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2004),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2394] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1981),
    [sym_identifier] = ACTIONS(5620),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2395] = {
    [sym_type_arguments] = STATE(611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_AMP] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(1803),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_PIPE] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_else] = ACTIONS(1797),
    [anon_sym_is] = ACTIONS(5624),
  },
  [2396] = {
    [sym_array_type] = STATE(613),
    [sym_generic_type] = STATE(613),
    [sym_type_predicate] = STATE(613),
    [sym_literal_type] = STATE(613),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(613),
    [sym__primary_type] = STATE(613),
    [sym_lookup_type] = STATE(613),
    [sym_parenthesized_type] = STATE(613),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(613),
    [sym_nested_type_identifier] = STATE(2403),
    [sym_tuple_type] = STATE(613),
    [sym_type_query] = STATE(613),
    [sym_index_type_query] = STATE(613),
    [sym_existential_type] = STATE(613),
    [sym_flow_maybe_type] = STATE(613),
    [sym_string] = STATE(328),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_this] = ACTIONS(1811),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [2397] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2008),
    [sym_function_type] = STATE(2008),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2008),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2008),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2008),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2398] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(628),
    [sym_function_type] = STATE(628),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(628),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(628),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(628),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2399] = {
    [sym_formal_parameters] = STATE(2009),
    [sym_type_parameters] = STATE(2437),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2400] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2010),
    [sym_function_type] = STATE(2010),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2010),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_object] = STATE(489),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(2010),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2010),
    [aux_sym_export_statement_repeat1] = STATE(493),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(490),
    [sym_identifier] = ACTIONS(1847),
    [anon_sym_symbol] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_this] = ACTIONS(1851),
    [sym_true] = ACTIONS(736),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(736),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_export] = ACTIONS(1207),
  },
  [2401] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(639),
    [sym_function_type] = STATE(639),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(639),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(639),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(639),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2402] = {
    [anon_sym_DOT] = ACTIONS(4517),
    [sym_comment] = ACTIONS(3),
  },
  [2403] = {
    [sym_type_arguments] = STATE(642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_else] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
  },
  [2404] = {
    [sym_formal_parameters] = STATE(2014),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(5636),
  },
  [2406] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2441),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(658),
    [sym_type_parameters] = STATE(2442),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2407] = {
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2022),
    [sym_constructor_type] = STATE(2022),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_nested_identifier] = STATE(2551),
    [sym_predefined_type] = STATE(1652),
    [sym_nested_type_identifier] = STATE(1653),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(2022),
    [sym__type] = STATE(2022),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_symbol] = ACTIONS(1927),
    [sym_this] = ACTIONS(1949),
    [anon_sym_typeof] = ACTIONS(1929),
    [sym_true] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_keyof] = ACTIONS(1931),
    [sym_number] = ACTIONS(1951),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_PIPE] = ACTIONS(1939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_boolean] = ACTIONS(1927),
  },
  [2408] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2409] = {
    [aux_sym_extends_clause_repeat1] = STATE(2719),
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_AMP_EQ] = ACTIONS(5638),
    [anon_sym_PLUS_EQ] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(5642),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5638),
    [anon_sym_STAR_EQ] = ACTIONS(5638),
    [anon_sym_PIPE_EQ] = ACTIONS(5638),
    [anon_sym_DASH_EQ] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2072),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2410] = {
    [aux_sym_extends_clause_repeat1] = STATE(2720),
    [sym_type_arguments] = STATE(642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5648),
  },
  [2411] = {
    [sym_identifier] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
  },
  [2412] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2031),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2413] = {
    [anon_sym_EQ] = ACTIONS(5652),
    [sym_comment] = ACTIONS(3),
  },
  [2414] = {
    [sym_identifier] = ACTIONS(5654),
    [sym_comment] = ACTIONS(3),
  },
  [2415] = {
    [sym_class] = STATE(710),
    [sym_arrow_function] = STATE(710),
    [sym_await_expression] = STATE(710),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(710),
    [sym_meta_property] = STATE(710),
    [sym__expression] = STATE(710),
    [sym_jsx_element] = STATE(710),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(710),
    [sym_call_expression] = STATE(710),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(710),
    [sym_string] = STATE(710),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(710),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(710),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(710),
    [sym_generator_function] = STATE(710),
    [sym_new_expression] = STATE(710),
    [sym_assignment_expression] = STATE(710),
    [sym_augmented_assignment_expression] = STATE(710),
    [sym_binary_expression] = STATE(710),
    [sym_unary_expression] = STATE(710),
    [sym_regex] = STATE(710),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(710),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(710),
    [sym_internal_module] = STATE(710),
    [sym_jsx_self_closing_element] = STATE(710),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(2135),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(2135),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2135),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2135),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(2141),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(2135),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2416] = {
    [sym_class] = STATE(2036),
    [sym_arrow_function] = STATE(2036),
    [sym_await_expression] = STATE(2036),
    [sym_member_expression] = STATE(2685),
    [sym_statement_block] = STATE(780),
    [sym_update_expression] = STATE(2036),
    [sym_meta_property] = STATE(2036),
    [sym__expression] = STATE(2036),
    [sym_jsx_element] = STATE(2036),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2036),
    [sym_call_expression] = STATE(2036),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2036),
    [sym_string] = STATE(2036),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2036),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2036),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2036),
    [sym_generator_function] = STATE(2036),
    [sym_new_expression] = STATE(2036),
    [sym_assignment_expression] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(2036),
    [sym_binary_expression] = STATE(2036),
    [sym_unary_expression] = STATE(2036),
    [sym_regex] = STATE(2036),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2036),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2036),
    [sym_internal_module] = STATE(2036),
    [sym_jsx_self_closing_element] = STATE(2036),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5656),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5656),
    [sym_number] = ACTIONS(5658),
    [sym_true] = ACTIONS(5656),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5656),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2417] = {
    [sym_class] = STATE(2037),
    [sym_arrow_function] = STATE(2037),
    [sym_await_expression] = STATE(2037),
    [sym_member_expression] = STATE(2685),
    [sym_statement_block] = STATE(782),
    [sym_update_expression] = STATE(2037),
    [sym_meta_property] = STATE(2037),
    [sym__expression] = STATE(2037),
    [sym_jsx_element] = STATE(2037),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2037),
    [sym_call_expression] = STATE(2037),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2037),
    [sym_string] = STATE(2037),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2037),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2037),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2037),
    [sym_generator_function] = STATE(2037),
    [sym_new_expression] = STATE(2037),
    [sym_assignment_expression] = STATE(2037),
    [sym_augmented_assignment_expression] = STATE(2037),
    [sym_binary_expression] = STATE(2037),
    [sym_unary_expression] = STATE(2037),
    [sym_regex] = STATE(2037),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2037),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2037),
    [sym_internal_module] = STATE(2037),
    [sym_jsx_self_closing_element] = STATE(2037),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5660),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5660),
    [sym_number] = ACTIONS(5662),
    [sym_true] = ACTIONS(5660),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5660),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2418] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2038),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2419] = {
    [sym_class] = STATE(2040),
    [sym_arrow_function] = STATE(2040),
    [sym_await_expression] = STATE(2040),
    [sym_member_expression] = STATE(2685),
    [sym_statement_block] = STATE(788),
    [sym_update_expression] = STATE(2040),
    [sym_meta_property] = STATE(2040),
    [sym__expression] = STATE(2040),
    [sym_jsx_element] = STATE(2040),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2040),
    [sym_call_expression] = STATE(2040),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2040),
    [sym_string] = STATE(2040),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2040),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2040),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2040),
    [sym_generator_function] = STATE(2040),
    [sym_new_expression] = STATE(2040),
    [sym_assignment_expression] = STATE(2040),
    [sym_augmented_assignment_expression] = STATE(2040),
    [sym_binary_expression] = STATE(2040),
    [sym_unary_expression] = STATE(2040),
    [sym_regex] = STATE(2040),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2040),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2040),
    [sym_internal_module] = STATE(2040),
    [sym_jsx_self_closing_element] = STATE(2040),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5664),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5664),
    [sym_number] = ACTIONS(5666),
    [sym_true] = ACTIONS(5664),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5664),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2420] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(5668),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2421] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(805),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2422] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2043),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2423] = {
    [sym_identifier] = ACTIONS(5672),
    [sym_comment] = ACTIONS(3),
  },
  [2424] = {
    [sym_class] = STATE(2351),
    [sym_arrow_function] = STATE(2351),
    [sym_await_expression] = STATE(2351),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2351),
    [sym_meta_property] = STATE(2351),
    [sym__expression] = STATE(2351),
    [sym_jsx_element] = STATE(2351),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2351),
    [sym_call_expression] = STATE(2351),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2351),
    [sym_string] = STATE(2351),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2351),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2351),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2351),
    [sym_generator_function] = STATE(2351),
    [sym_new_expression] = STATE(2351),
    [sym_assignment_expression] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(2351),
    [sym_binary_expression] = STATE(2351),
    [sym_unary_expression] = STATE(2351),
    [sym_regex] = STATE(2351),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2351),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2351),
    [sym_internal_module] = STATE(2351),
    [sym_jsx_self_closing_element] = STATE(2351),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(5674),
    [sym_false] = ACTIONS(4751),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4751),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(4751),
    [sym_number] = ACTIONS(4755),
    [sym_true] = ACTIONS(4751),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4751),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2425] = {
    [sym_class] = STATE(2349),
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym__expression] = STATE(2349),
    [sym_jsx_element] = STATE(2349),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2349),
    [sym_string] = STATE(2349),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2349),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2349),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_new_expression] = STATE(2349),
    [sym_assignment_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2349),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2349),
    [sym_internal_module] = STATE(2349),
    [sym_jsx_self_closing_element] = STATE(2349),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5676),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5676),
    [sym_number] = ACTIONS(2550),
    [sym_true] = ACTIONS(5676),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5676),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2426] = {
    [sym_class] = STATE(232),
    [sym_arrow_function] = STATE(232),
    [sym_await_expression] = STATE(239),
    [sym_member_expression] = STATE(238),
    [sym_update_expression] = STATE(239),
    [sym_meta_property] = STATE(232),
    [sym__expression] = STATE(239),
    [sym_jsx_element] = STATE(239),
    [sym_function] = STATE(240),
    [sym_import] = STATE(232),
    [sym_call_expression] = STATE(239),
    [sym_subscript_expression] = STATE(238),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(239),
    [sym_string] = STATE(232),
    [sym_type_parameters] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(232),
    [sym_formal_parameters] = STATE(848),
    [sym_yield_expression] = STATE(239),
    [sym_object] = STATE(241),
    [sym_jsx_fragment] = STATE(239),
    [sym_generator_function] = STATE(232),
    [sym_new_expression] = STATE(232),
    [sym_assignment_expression] = STATE(239),
    [sym_augmented_assignment_expression] = STATE(239),
    [sym_binary_expression] = STATE(239),
    [sym_unary_expression] = STATE(239),
    [sym_regex] = STATE(232),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(238),
    [sym_non_null_expression] = STATE(239),
    [sym_array] = STATE(242),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(239),
    [sym_internal_module] = STATE(239),
    [sym_jsx_self_closing_element] = STATE(239),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_identifier] = ACTIONS(5678),
    [sym_false] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(5680),
    [anon_sym_symbol] = ACTIONS(5680),
    [anon_sym_number] = ACTIONS(5680),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(5680),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(485),
    [sym_super] = ACTIONS(479),
    [anon_sym_any] = ACTIONS(5680),
    [anon_sym_private] = ACTIONS(5680),
    [anon_sym_boolean] = ACTIONS(5680),
    [anon_sym_static] = ACTIONS(5680),
    [anon_sym_public] = ACTIONS(5680),
    [anon_sym_get] = ACTIONS(5680),
    [anon_sym_async] = ACTIONS(5684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_number] = ACTIONS(497),
    [sym_true] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5680),
    [anon_sym_string] = ACTIONS(5680),
    [anon_sym_function] = ACTIONS(167),
    [anon_sym_DOT] = ACTIONS(489),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_set] = ACTIONS(5680),
    [anon_sym_type] = ACTIONS(5680),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(5680),
    [anon_sym_namespace] = ACTIONS(5686),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2427] = {
    [sym_formal_parameters] = STATE(2051),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2428] = {
    [sym_jsx_expression] = STATE(516),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_type_arguments] = STATE(518),
    [sym_jsx_attribute] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2626),
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2429] = {
    [sym_nested_identifier] = STATE(2054),
    [sym_jsx_namespace_name] = STATE(2055),
    [sym_identifier] = ACTIONS(5690),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(5692),
  },
  [2430] = {
    [sym_class] = STATE(2056),
    [sym_arrow_function] = STATE(2056),
    [sym_await_expression] = STATE(2056),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2056),
    [sym_meta_property] = STATE(2056),
    [sym__expression] = STATE(2056),
    [sym_jsx_element] = STATE(2056),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2056),
    [sym_call_expression] = STATE(2056),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2056),
    [sym_string] = STATE(2056),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2056),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2056),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2056),
    [sym_generator_function] = STATE(2056),
    [sym_new_expression] = STATE(2056),
    [sym_assignment_expression] = STATE(2056),
    [sym_augmented_assignment_expression] = STATE(2056),
    [sym_binary_expression] = STATE(2056),
    [sym_unary_expression] = STATE(2056),
    [sym_regex] = STATE(2056),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2056),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2056),
    [sym_internal_module] = STATE(2056),
    [sym_jsx_self_closing_element] = STATE(2056),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5694),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5694),
    [sym_number] = ACTIONS(5696),
    [sym_true] = ACTIONS(5694),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5694),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2431] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2061),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2432] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2039),
    [sym_identifier] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2433] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2062),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2434] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2455),
    [sym_function_type] = STATE(2455),
    [sym_constructor_type] = STATE(2455),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(2403),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2455),
    [sym__type] = STATE(2455),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [2435] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2010),
    [sym_function_type] = STATE(2010),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2010),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2010),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2010),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2436] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(2065),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(2065),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(2065),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(2065),
    [sym_property_signature] = STATE(2065),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(2065),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_namespace] = ACTIONS(968),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2437] = {
    [sym_formal_parameters] = STATE(2069),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2438] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2457),
    [sym_function_type] = STATE(2457),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(2457),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(2457),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2457),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2439] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(903),
    [sym_function_type] = STATE(903),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(903),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(903),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(903),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2440] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(904),
    [sym_function_type] = STATE(904),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(904),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(904),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(904),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2441] = {
    [sym_class_body] = STATE(917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2442] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(918),
    [sym_class_heritage] = STATE(2459),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2443] = {
    [sym_array_type] = STATE(1652),
    [sym_formal_parameters] = STATE(2159),
    [sym_generic_type] = STATE(1652),
    [sym_type_predicate] = STATE(1652),
    [sym_literal_type] = STATE(1652),
    [sym__number] = STATE(1646),
    [sym_object_type] = STATE(1652),
    [sym_intersection_type] = STATE(2075),
    [sym_function_type] = STATE(2075),
    [sym_constructor_type] = STATE(2075),
    [sym__primary_type] = STATE(1652),
    [sym_lookup_type] = STATE(1652),
    [sym_parenthesized_type] = STATE(1652),
    [sym_nested_identifier] = STATE(2551),
    [sym_predefined_type] = STATE(1652),
    [sym_nested_type_identifier] = STATE(1653),
    [sym_tuple_type] = STATE(1652),
    [sym_union_type] = STATE(2075),
    [sym__type] = STATE(2075),
    [sym_type_query] = STATE(1652),
    [sym_index_type_query] = STATE(1652),
    [sym_existential_type] = STATE(1652),
    [sym_flow_maybe_type] = STATE(1652),
    [sym_string] = STATE(1646),
    [sym_type_parameters] = STATE(2552),
    [sym_identifier] = ACTIONS(1921),
    [sym_false] = ACTIONS(1923),
    [anon_sym_QMARK] = ACTIONS(1947),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_symbol] = ACTIONS(1927),
    [sym_this] = ACTIONS(1949),
    [anon_sym_typeof] = ACTIONS(1929),
    [sym_true] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_keyof] = ACTIONS(1931),
    [sym_number] = ACTIONS(1951),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_PIPE] = ACTIONS(1939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_boolean] = ACTIONS(1927),
  },
  [2444] = {
    [sym_class] = STATE(2461),
    [sym_arrow_function] = STATE(2461),
    [sym_await_expression] = STATE(2461),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(2461),
    [sym_sequence_expression] = STATE(2460),
    [sym_meta_property] = STATE(2461),
    [sym__expression] = STATE(2461),
    [sym_jsx_element] = STATE(2461),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2461),
    [sym_call_expression] = STATE(2461),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(2461),
    [sym_string] = STATE(2461),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2461),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2461),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(2461),
    [sym_generator_function] = STATE(2461),
    [sym_new_expression] = STATE(2461),
    [sym_assignment_expression] = STATE(2461),
    [sym_augmented_assignment_expression] = STATE(2461),
    [sym_binary_expression] = STATE(2461),
    [sym_unary_expression] = STATE(2461),
    [sym_regex] = STATE(2461),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(2461),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2461),
    [sym_internal_module] = STATE(2461),
    [sym_jsx_self_closing_element] = STATE(2461),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(5700),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5700),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_RPAREN] = ACTIONS(5702),
    [sym_this] = ACTIONS(5700),
    [sym_number] = ACTIONS(5704),
    [sym_true] = ACTIONS(5700),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5700),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2445] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2077),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(5706),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2446] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2080),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2447] = {
    [sym_statement_block] = STATE(996),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2448] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2085),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2449] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(5708),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2450] = {
    [sym_class] = STATE(2087),
    [sym_arrow_function] = STATE(2087),
    [sym_await_expression] = STATE(2087),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2087),
    [sym_meta_property] = STATE(2087),
    [sym__expression] = STATE(2087),
    [sym_jsx_element] = STATE(2087),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2087),
    [sym_call_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2087),
    [sym_string] = STATE(2087),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2087),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2087),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2087),
    [sym_generator_function] = STATE(2087),
    [sym_new_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2087),
    [sym_augmented_assignment_expression] = STATE(2087),
    [sym_binary_expression] = STATE(2087),
    [sym_unary_expression] = STATE(2087),
    [sym_regex] = STATE(2087),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2087),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2087),
    [sym_internal_module] = STATE(2087),
    [sym_jsx_self_closing_element] = STATE(2087),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5710),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5710),
    [sym_number] = ACTIONS(5712),
    [sym_true] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5710),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2451] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_AMP_EQ] = ACTIONS(4737),
    [anon_sym_PLUS_EQ] = ACTIONS(4737),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_EQ] = ACTIONS(4739),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_CARET_EQ] = ACTIONS(4737),
    [anon_sym_STAR_EQ] = ACTIONS(4737),
    [anon_sym_PIPE_EQ] = ACTIONS(4737),
    [anon_sym_DASH_EQ] = ACTIONS(4737),
    [anon_sym_EQ_GT] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4737),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2452] = {
    [sym_type_parameters] = STATE(1868),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(842),
    [sym_object] = STATE(307),
    [sym_construct_signature] = STATE(2194),
    [sym_accessibility_modifier] = STATE(841),
    [sym_export_statement] = STATE(2194),
    [sym_pair] = STATE(447),
    [sym__property_name] = STATE(842),
    [sym_method_signature] = STATE(2194),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym_method_definition] = STATE(447),
    [sym_assignment_pattern] = STATE(447),
    [sym_array] = STATE(308),
    [sym_spread_element] = STATE(447),
    [sym__call_signature] = STATE(2194),
    [sym_property_signature] = STATE(2194),
    [sym_string] = STATE(842),
    [sym_index_signature] = STATE(2194),
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3397),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3397),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(3401),
    [sym_readonly] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2453] = {
    [sym_formal_parameters] = STATE(2089),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2454] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2091),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_PIPE] = ACTIONS(5718),
    [anon_sym_else] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
  },
  [2456] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2468),
    [sym_function_type] = STATE(2468),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(2468),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(2468),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2468),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2457] = {
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3527),
  },
  [2458] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2470),
    [sym_function_type] = STATE(2470),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(2470),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(2470),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2470),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2459] = {
    [sym_class_body] = STATE(1104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4802),
  },
  [2460] = {
    [anon_sym_RPAREN] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
  },
  [2461] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(5720),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2462] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_AMP_EQ] = ACTIONS(5638),
    [anon_sym_PLUS_EQ] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(5722),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5638),
    [anon_sym_STAR_EQ] = ACTIONS(5638),
    [anon_sym_PIPE_EQ] = ACTIONS(5638),
    [anon_sym_DASH_EQ] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3655),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2463] = {
    [sym_type_arguments] = STATE(642),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3659),
  },
  [2464] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2097),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2465] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2098),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(5724),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2466] = {
    [sym_statement_block] = STATE(1156),
    [sym__automatic_semicolon] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2467] = {
    [sym_statement_block] = STATE(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2468] = {
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(4012),
    [anon_sym_PIPE] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(4012),
  },
  [2469] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2474),
    [sym_function_type] = STATE(2474),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2403),
    [sym__type] = STATE(2474),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_constructor_type] = STATE(2474),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2474),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2470] = {
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_PIPE] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(4024),
  },
  [2471] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2103),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2472] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2104),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(5726),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2473] = {
    [sym_statement_block] = STATE(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2474] = {
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [anon_sym_while] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(4238),
  },
  [2475] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2106),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2476] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2107),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(5728),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2477] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2108),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2478] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2109),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2479] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2110),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2480] = {
    [sym_class] = STATE(2581),
    [sym_arrow_function] = STATE(2581),
    [sym_await_expression] = STATE(2581),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2581),
    [sym_meta_property] = STATE(2581),
    [sym__expression] = STATE(2581),
    [sym_jsx_element] = STATE(2581),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2581),
    [sym_call_expression] = STATE(2581),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2581),
    [sym_string] = STATE(2581),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2581),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2581),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2581),
    [sym_generator_function] = STATE(2581),
    [sym_new_expression] = STATE(2581),
    [sym_assignment_expression] = STATE(2581),
    [sym_augmented_assignment_expression] = STATE(2581),
    [sym_binary_expression] = STATE(2581),
    [sym_unary_expression] = STATE(2581),
    [sym_regex] = STATE(2581),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2581),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2581),
    [sym_internal_module] = STATE(2581),
    [sym_jsx_self_closing_element] = STATE(2581),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5734),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5734),
    [sym_number] = ACTIONS(5736),
    [sym_true] = ACTIONS(5734),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5734),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2481] = {
    [sym_class] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym__expression] = STATE(1324),
    [sym_jsx_element] = STATE(1324),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1324),
    [sym_call_expression] = STATE(1324),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1324),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(1324),
    [sym_generator_function] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_regex] = STATE(1324),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(1324),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_jsx_self_closing_element] = STATE(1324),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4382),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(4382),
    [sym_number] = ACTIONS(4384),
    [sym_true] = ACTIONS(4382),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4382),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2482] = {
    [sym_class] = STATE(2583),
    [sym_arrow_function] = STATE(2583),
    [sym_await_expression] = STATE(2583),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2583),
    [sym_meta_property] = STATE(2583),
    [sym__expression] = STATE(2583),
    [sym_jsx_element] = STATE(2583),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2583),
    [sym_call_expression] = STATE(2583),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2583),
    [sym_string] = STATE(2583),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2583),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2583),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2583),
    [sym_generator_function] = STATE(2583),
    [sym_new_expression] = STATE(2583),
    [sym_assignment_expression] = STATE(2583),
    [sym_augmented_assignment_expression] = STATE(2583),
    [sym_binary_expression] = STATE(2583),
    [sym_unary_expression] = STATE(2583),
    [sym_regex] = STATE(2583),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2583),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2583),
    [sym_internal_module] = STATE(2583),
    [sym_jsx_self_closing_element] = STATE(2583),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(5738),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(5740),
    [anon_sym_yield] = ACTIONS(950),
    [sym_true] = ACTIONS(5740),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5740),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5740),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_implements] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(930),
  },
  [2483] = {
    [sym_class] = STATE(2584),
    [sym_arrow_function] = STATE(2584),
    [sym_await_expression] = STATE(2584),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2584),
    [sym_meta_property] = STATE(2584),
    [sym__expression] = STATE(2584),
    [sym_jsx_element] = STATE(2584),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2584),
    [sym_call_expression] = STATE(2584),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2584),
    [sym_string] = STATE(2584),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2584),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2584),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2584),
    [sym_generator_function] = STATE(2584),
    [sym_new_expression] = STATE(2584),
    [sym_assignment_expression] = STATE(2584),
    [sym_augmented_assignment_expression] = STATE(2584),
    [sym_binary_expression] = STATE(2584),
    [sym_unary_expression] = STATE(2584),
    [sym_regex] = STATE(2584),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2584),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2584),
    [sym_internal_module] = STATE(2584),
    [sym_jsx_self_closing_element] = STATE(2584),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5746),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5746),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5746),
    [sym_number] = ACTIONS(5748),
    [sym_true] = ACTIONS(5746),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5746),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2484] = {
    [sym_class] = STATE(2589),
    [sym_arrow_function] = STATE(2589),
    [sym_await_expression] = STATE(2589),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2589),
    [sym_meta_property] = STATE(2589),
    [sym__expression] = STATE(2589),
    [sym_jsx_element] = STATE(2589),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2589),
    [sym_call_expression] = STATE(2589),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2589),
    [sym_string] = STATE(2589),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2589),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2589),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2589),
    [sym_generator_function] = STATE(2589),
    [sym_new_expression] = STATE(2589),
    [sym_assignment_expression] = STATE(2589),
    [sym_augmented_assignment_expression] = STATE(2589),
    [sym_binary_expression] = STATE(2589),
    [sym_unary_expression] = STATE(2589),
    [sym_regex] = STATE(2589),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2589),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2589),
    [sym_internal_module] = STATE(2589),
    [sym_jsx_self_closing_element] = STATE(2589),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5750),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5750),
    [sym_number] = ACTIONS(5752),
    [sym_true] = ACTIONS(5750),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5750),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2485] = {
    [sym_class] = STATE(2113),
    [sym_arrow_function] = STATE(2113),
    [sym_await_expression] = STATE(2113),
    [sym_member_expression] = STATE(2748),
    [sym_statement_block] = STATE(1382),
    [sym_update_expression] = STATE(2113),
    [sym_meta_property] = STATE(2113),
    [sym__expression] = STATE(2113),
    [sym_jsx_element] = STATE(2113),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2113),
    [sym_call_expression] = STATE(2113),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2113),
    [sym_string] = STATE(2113),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2113),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2113),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2113),
    [sym_generator_function] = STATE(2113),
    [sym_new_expression] = STATE(2113),
    [sym_assignment_expression] = STATE(2113),
    [sym_augmented_assignment_expression] = STATE(2113),
    [sym_binary_expression] = STATE(2113),
    [sym_unary_expression] = STATE(2113),
    [sym_regex] = STATE(2113),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2113),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2113),
    [sym_internal_module] = STATE(2113),
    [sym_jsx_self_closing_element] = STATE(2113),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5754),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5754),
    [sym_number] = ACTIONS(5756),
    [sym_true] = ACTIONS(5754),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5754),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2486] = {
    [sym_class] = STATE(2114),
    [sym_arrow_function] = STATE(2114),
    [sym_await_expression] = STATE(2114),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2114),
    [sym_meta_property] = STATE(2114),
    [sym__expression] = STATE(2114),
    [sym_jsx_element] = STATE(2114),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2114),
    [sym_call_expression] = STATE(2114),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2114),
    [sym_string] = STATE(2114),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2114),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2114),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2114),
    [sym_generator_function] = STATE(2114),
    [sym_new_expression] = STATE(2114),
    [sym_assignment_expression] = STATE(2114),
    [sym_augmented_assignment_expression] = STATE(2114),
    [sym_binary_expression] = STATE(2114),
    [sym_unary_expression] = STATE(2114),
    [sym_regex] = STATE(2114),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2114),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2114),
    [sym_internal_module] = STATE(2114),
    [sym_jsx_self_closing_element] = STATE(2114),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5758),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5758),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5758),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5758),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5760),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5758),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2487] = {
    [sym_class] = STATE(2115),
    [sym_arrow_function] = STATE(2115),
    [sym_await_expression] = STATE(2115),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2115),
    [sym_meta_property] = STATE(2115),
    [sym__expression] = STATE(2115),
    [sym_jsx_element] = STATE(2115),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2115),
    [sym_call_expression] = STATE(2115),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2115),
    [sym_string] = STATE(2115),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2115),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2115),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2115),
    [sym_generator_function] = STATE(2115),
    [sym_new_expression] = STATE(2115),
    [sym_assignment_expression] = STATE(2115),
    [sym_augmented_assignment_expression] = STATE(2115),
    [sym_binary_expression] = STATE(2115),
    [sym_unary_expression] = STATE(2115),
    [sym_regex] = STATE(2115),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2115),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2115),
    [sym_internal_module] = STATE(2115),
    [sym_jsx_self_closing_element] = STATE(2115),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5762),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5762),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5762),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5764),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5762),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2488] = {
    [sym_class] = STATE(2116),
    [sym_arrow_function] = STATE(2116),
    [sym_await_expression] = STATE(2116),
    [sym_member_expression] = STATE(2748),
    [sym_statement_block] = STATE(1388),
    [sym_update_expression] = STATE(2116),
    [sym_meta_property] = STATE(2116),
    [sym__expression] = STATE(2116),
    [sym_jsx_element] = STATE(2116),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2116),
    [sym_call_expression] = STATE(2116),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2116),
    [sym_string] = STATE(2116),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2116),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2116),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2116),
    [sym_generator_function] = STATE(2116),
    [sym_new_expression] = STATE(2116),
    [sym_assignment_expression] = STATE(2116),
    [sym_augmented_assignment_expression] = STATE(2116),
    [sym_binary_expression] = STATE(2116),
    [sym_unary_expression] = STATE(2116),
    [sym_regex] = STATE(2116),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2116),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2116),
    [sym_internal_module] = STATE(2116),
    [sym_jsx_self_closing_element] = STATE(2116),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5766),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5766),
    [sym_number] = ACTIONS(5768),
    [sym_true] = ACTIONS(5766),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5766),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2489] = {
    [sym_class] = STATE(2117),
    [sym_arrow_function] = STATE(2117),
    [sym_await_expression] = STATE(2117),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2117),
    [sym_meta_property] = STATE(2117),
    [sym__expression] = STATE(2117),
    [sym_jsx_element] = STATE(2117),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2117),
    [sym_call_expression] = STATE(2117),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2117),
    [sym_string] = STATE(2117),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2117),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2117),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2117),
    [sym_generator_function] = STATE(2117),
    [sym_new_expression] = STATE(2117),
    [sym_assignment_expression] = STATE(2117),
    [sym_augmented_assignment_expression] = STATE(2117),
    [sym_binary_expression] = STATE(2117),
    [sym_unary_expression] = STATE(2117),
    [sym_regex] = STATE(2117),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2117),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2117),
    [sym_internal_module] = STATE(2117),
    [sym_jsx_self_closing_element] = STATE(2117),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5770),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5770),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5770),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5772),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5770),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2490] = {
    [sym_class] = STATE(2118),
    [sym_arrow_function] = STATE(2118),
    [sym_await_expression] = STATE(2118),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2118),
    [sym_meta_property] = STATE(2118),
    [sym__expression] = STATE(2118),
    [sym_jsx_element] = STATE(2118),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2118),
    [sym_call_expression] = STATE(2118),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2118),
    [sym_string] = STATE(2118),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2118),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2118),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2118),
    [sym_generator_function] = STATE(2118),
    [sym_new_expression] = STATE(2118),
    [sym_assignment_expression] = STATE(2118),
    [sym_augmented_assignment_expression] = STATE(2118),
    [sym_binary_expression] = STATE(2118),
    [sym_unary_expression] = STATE(2118),
    [sym_regex] = STATE(2118),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2118),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2118),
    [sym_internal_module] = STATE(2118),
    [sym_jsx_self_closing_element] = STATE(2118),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5774),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5774),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5774),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5774),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5776),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5774),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2491] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2492] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5778),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2493] = {
    [sym_class] = STATE(2581),
    [sym_arrow_function] = STATE(2581),
    [sym_await_expression] = STATE(2581),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2581),
    [sym_meta_property] = STATE(2581),
    [sym__expression] = STATE(2581),
    [sym_jsx_element] = STATE(2581),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2581),
    [sym_call_expression] = STATE(2581),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2581),
    [sym_string] = STATE(2581),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2581),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2581),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2581),
    [sym_generator_function] = STATE(2581),
    [sym_new_expression] = STATE(2581),
    [sym_assignment_expression] = STATE(2581),
    [sym_augmented_assignment_expression] = STATE(2581),
    [sym_binary_expression] = STATE(2581),
    [sym_unary_expression] = STATE(2581),
    [sym_regex] = STATE(2581),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2581),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2581),
    [sym_internal_module] = STATE(2581),
    [sym_jsx_self_closing_element] = STATE(2581),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5734),
    [anon_sym_yield] = ACTIONS(950),
    [sym_true] = ACTIONS(5734),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5778),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5734),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5734),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(5736),
    [anon_sym_SLASH] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5734),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(930),
  },
  [2494] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5782),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_symbol] = ACTIONS(5784),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_void] = ACTIONS(5784),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_private] = ACTIONS(5784),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_static] = ACTIONS(5784),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_get] = ACTIONS(5784),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5784),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(5784),
    [anon_sym_type] = ACTIONS(5784),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5778),
    [anon_sym_namespace] = ACTIONS(5784),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5784),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_number] = ACTIONS(5784),
    [anon_sym_declare] = ACTIONS(5784),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5784),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_boolean] = ACTIONS(5784),
    [anon_sym_async] = ACTIONS(5784),
    [anon_sym_public] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_string] = ACTIONS(5784),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(5784),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2495] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5778),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2496] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(701),
  },
  [2497] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2498] = {
    [sym_class] = STATE(2121),
    [sym_arrow_function] = STATE(2121),
    [sym_await_expression] = STATE(2121),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2121),
    [sym_meta_property] = STATE(2121),
    [sym__expression] = STATE(2121),
    [sym_jsx_element] = STATE(2121),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2121),
    [sym_call_expression] = STATE(2121),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2121),
    [sym_string] = STATE(2121),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2121),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2121),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2121),
    [sym_generator_function] = STATE(2121),
    [sym_new_expression] = STATE(2121),
    [sym_assignment_expression] = STATE(2121),
    [sym_augmented_assignment_expression] = STATE(2121),
    [sym_binary_expression] = STATE(2121),
    [sym_unary_expression] = STATE(2121),
    [sym_regex] = STATE(2121),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2121),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2121),
    [sym_internal_module] = STATE(2121),
    [sym_jsx_self_closing_element] = STATE(2121),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5789),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5789),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5789),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5789),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5791),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5789),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2499] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(806),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2500] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2501] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1294),
  },
  [2502] = {
    [sym_arguments] = STATE(1446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_implements] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
  },
  [2503] = {
    [sym_await_expression] = STATE(2497),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_ternary_expression] = STATE(2497),
    [sym_template_string] = STATE(2497),
    [sym_yield_expression] = STATE(2497),
    [sym_jsx_fragment] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2497),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_arguments] = STATE(1446),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2497),
    [sym_class] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [sym_this] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [sym_number] = ACTIONS(1322),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2504] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1446),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(5782),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(5784),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(5784),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(5784),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(5784),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(5784),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_protected] = ACTIONS(5784),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(5784),
    [anon_sym_type] = ACTIONS(5784),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(5784),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(5784),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(5784),
    [anon_sym_declare] = ACTIONS(5784),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(5784),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(5784),
    [anon_sym_async] = ACTIONS(5784),
    [anon_sym_public] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(5784),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_implements] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(5784),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [2505] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_arguments] = STATE(1446),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_implements] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
  },
  [2506] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1396),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2507] = {
    [sym_class] = STATE(2123),
    [sym_arrow_function] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2123),
    [sym_meta_property] = STATE(2123),
    [sym__expression] = STATE(2123),
    [sym_jsx_element] = STATE(2123),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2123),
    [sym_call_expression] = STATE(2123),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2123),
    [sym_string] = STATE(2123),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2123),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2123),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2123),
    [sym_generator_function] = STATE(2123),
    [sym_new_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_augmented_assignment_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_regex] = STATE(2123),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2123),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2123),
    [sym_internal_module] = STATE(2123),
    [sym_jsx_self_closing_element] = STATE(2123),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5131),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5131),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5131),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5793),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5131),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2508] = {
    [sym_class] = STATE(2124),
    [sym_arrow_function] = STATE(2124),
    [sym_await_expression] = STATE(2124),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2124),
    [sym_meta_property] = STATE(2124),
    [sym__expression] = STATE(2124),
    [sym_jsx_element] = STATE(2124),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2124),
    [sym_call_expression] = STATE(2124),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2124),
    [sym_string] = STATE(2124),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2124),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2124),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2124),
    [sym_generator_function] = STATE(2124),
    [sym_new_expression] = STATE(2124),
    [sym_assignment_expression] = STATE(2124),
    [sym_augmented_assignment_expression] = STATE(2124),
    [sym_binary_expression] = STATE(2124),
    [sym_unary_expression] = STATE(2124),
    [sym_regex] = STATE(2124),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2124),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2124),
    [sym_internal_module] = STATE(2124),
    [sym_jsx_self_closing_element] = STATE(2124),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5795),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5795),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5795),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5795),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5795),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2509] = {
    [sym_class] = STATE(2125),
    [sym_arrow_function] = STATE(2125),
    [sym_await_expression] = STATE(2125),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2125),
    [sym_meta_property] = STATE(2125),
    [sym__expression] = STATE(2125),
    [sym_jsx_element] = STATE(2125),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2125),
    [sym_call_expression] = STATE(2125),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2125),
    [sym_string] = STATE(2125),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2125),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2125),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2125),
    [sym_generator_function] = STATE(2125),
    [sym_new_expression] = STATE(2125),
    [sym_assignment_expression] = STATE(2125),
    [sym_augmented_assignment_expression] = STATE(2125),
    [sym_binary_expression] = STATE(2125),
    [sym_unary_expression] = STATE(2125),
    [sym_regex] = STATE(2125),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2125),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2125),
    [sym_internal_module] = STATE(2125),
    [sym_jsx_self_closing_element] = STATE(2125),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5799),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5799),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5799),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5799),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5801),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5799),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2510] = {
    [sym_class] = STATE(2126),
    [sym_arrow_function] = STATE(2126),
    [sym_await_expression] = STATE(2126),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2126),
    [sym_meta_property] = STATE(2126),
    [sym__expression] = STATE(2126),
    [sym_jsx_element] = STATE(2126),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2126),
    [sym_string] = STATE(2126),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2126),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2126),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2126),
    [sym_generator_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_augmented_assignment_expression] = STATE(2126),
    [sym_binary_expression] = STATE(2126),
    [sym_unary_expression] = STATE(2126),
    [sym_regex] = STATE(2126),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2126),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2126),
    [sym_internal_module] = STATE(2126),
    [sym_jsx_self_closing_element] = STATE(2126),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5803),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5803),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5803),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5803),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5805),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5803),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2511] = {
    [sym_class] = STATE(2127),
    [sym_arrow_function] = STATE(2127),
    [sym_await_expression] = STATE(2127),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2127),
    [sym_meta_property] = STATE(2127),
    [sym__expression] = STATE(2127),
    [sym_jsx_element] = STATE(2127),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2127),
    [sym_call_expression] = STATE(2127),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2127),
    [sym_string] = STATE(2127),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2127),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2127),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2127),
    [sym_generator_function] = STATE(2127),
    [sym_new_expression] = STATE(2127),
    [sym_assignment_expression] = STATE(2127),
    [sym_augmented_assignment_expression] = STATE(2127),
    [sym_binary_expression] = STATE(2127),
    [sym_unary_expression] = STATE(2127),
    [sym_regex] = STATE(2127),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2127),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2127),
    [sym_internal_module] = STATE(2127),
    [sym_jsx_self_closing_element] = STATE(2127),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5807),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5807),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5807),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5807),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5809),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5807),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2512] = {
    [sym_class] = STATE(2132),
    [sym_arrow_function] = STATE(2132),
    [sym_await_expression] = STATE(2132),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2132),
    [sym_meta_property] = STATE(2132),
    [sym__expression] = STATE(2132),
    [sym_jsx_element] = STATE(2132),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2132),
    [sym_call_expression] = STATE(2132),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2132),
    [sym_string] = STATE(2132),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2132),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2132),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2132),
    [sym_generator_function] = STATE(2132),
    [sym_new_expression] = STATE(2132),
    [sym_assignment_expression] = STATE(2132),
    [sym_augmented_assignment_expression] = STATE(2132),
    [sym_binary_expression] = STATE(2132),
    [sym_unary_expression] = STATE(2132),
    [sym_regex] = STATE(2132),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2132),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2132),
    [sym_internal_module] = STATE(2132),
    [sym_jsx_self_closing_element] = STATE(2132),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5811),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5811),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5811),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5811),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5813),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5811),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2513] = {
    [sym_class] = STATE(2133),
    [sym_arrow_function] = STATE(2133),
    [sym_await_expression] = STATE(2133),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2133),
    [sym_meta_property] = STATE(2133),
    [sym__expression] = STATE(2133),
    [sym_jsx_element] = STATE(2133),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2133),
    [sym_call_expression] = STATE(2133),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2133),
    [sym_string] = STATE(2133),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2133),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2133),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2133),
    [sym_generator_function] = STATE(2133),
    [sym_new_expression] = STATE(2133),
    [sym_assignment_expression] = STATE(2133),
    [sym_augmented_assignment_expression] = STATE(2133),
    [sym_binary_expression] = STATE(2133),
    [sym_unary_expression] = STATE(2133),
    [sym_regex] = STATE(2133),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2133),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2133),
    [sym_internal_module] = STATE(2133),
    [sym_jsx_self_closing_element] = STATE(2133),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5815),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5815),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5815),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5815),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5817),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5815),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2514] = {
    [sym_class] = STATE(2134),
    [sym_arrow_function] = STATE(2134),
    [sym_await_expression] = STATE(2134),
    [sym_member_expression] = STATE(2748),
    [sym_statement_block] = STATE(1472),
    [sym_update_expression] = STATE(2134),
    [sym_meta_property] = STATE(2134),
    [sym__expression] = STATE(2134),
    [sym_jsx_element] = STATE(2134),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2134),
    [sym_call_expression] = STATE(2134),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2134),
    [sym_string] = STATE(2134),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2134),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2134),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2134),
    [sym_generator_function] = STATE(2134),
    [sym_new_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2134),
    [sym_augmented_assignment_expression] = STATE(2134),
    [sym_binary_expression] = STATE(2134),
    [sym_unary_expression] = STATE(2134),
    [sym_regex] = STATE(2134),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2134),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2134),
    [sym_internal_module] = STATE(2134),
    [sym_jsx_self_closing_element] = STATE(2134),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5819),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5819),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5819),
    [sym_number] = ACTIONS(5821),
    [sym_true] = ACTIONS(5819),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5819),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2515] = {
    [sym_class] = STATE(2135),
    [sym_arrow_function] = STATE(2135),
    [sym_await_expression] = STATE(2135),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2135),
    [sym_meta_property] = STATE(2135),
    [sym__expression] = STATE(2135),
    [sym_jsx_element] = STATE(2135),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2135),
    [sym_call_expression] = STATE(2135),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2135),
    [sym_string] = STATE(2135),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2135),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2135),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2135),
    [sym_generator_function] = STATE(2135),
    [sym_new_expression] = STATE(2135),
    [sym_assignment_expression] = STATE(2135),
    [sym_augmented_assignment_expression] = STATE(2135),
    [sym_binary_expression] = STATE(2135),
    [sym_unary_expression] = STATE(2135),
    [sym_regex] = STATE(2135),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2135),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2135),
    [sym_internal_module] = STATE(2135),
    [sym_jsx_self_closing_element] = STATE(2135),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5823),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5823),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5823),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5823),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5825),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5823),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2516] = {
    [sym_class] = STATE(2136),
    [sym_arrow_function] = STATE(2136),
    [sym_await_expression] = STATE(2136),
    [sym_member_expression] = STATE(2748),
    [sym_statement_block] = STATE(1518),
    [sym_update_expression] = STATE(2136),
    [sym_meta_property] = STATE(2136),
    [sym__expression] = STATE(2136),
    [sym_jsx_element] = STATE(2136),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2136),
    [sym_call_expression] = STATE(2136),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2136),
    [sym_string] = STATE(2136),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2136),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2136),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2136),
    [sym_generator_function] = STATE(2136),
    [sym_new_expression] = STATE(2136),
    [sym_assignment_expression] = STATE(2136),
    [sym_augmented_assignment_expression] = STATE(2136),
    [sym_binary_expression] = STATE(2136),
    [sym_unary_expression] = STATE(2136),
    [sym_regex] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2136),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2136),
    [sym_internal_module] = STATE(2136),
    [sym_jsx_self_closing_element] = STATE(2136),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5827),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5827),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5827),
    [sym_number] = ACTIONS(5829),
    [sym_true] = ACTIONS(5827),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5827),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2517] = {
    [sym_class] = STATE(2137),
    [sym_arrow_function] = STATE(2137),
    [sym_await_expression] = STATE(2137),
    [sym_member_expression] = STATE(2748),
    [sym_statement_block] = STATE(1520),
    [sym_update_expression] = STATE(2137),
    [sym_meta_property] = STATE(2137),
    [sym__expression] = STATE(2137),
    [sym_jsx_element] = STATE(2137),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2137),
    [sym_call_expression] = STATE(2137),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2137),
    [sym_string] = STATE(2137),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2137),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2137),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2137),
    [sym_generator_function] = STATE(2137),
    [sym_new_expression] = STATE(2137),
    [sym_assignment_expression] = STATE(2137),
    [sym_augmented_assignment_expression] = STATE(2137),
    [sym_binary_expression] = STATE(2137),
    [sym_unary_expression] = STATE(2137),
    [sym_regex] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2137),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_jsx_self_closing_element] = STATE(2137),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5831),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5831),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5831),
    [sym_number] = ACTIONS(5833),
    [sym_true] = ACTIONS(5831),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5831),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2518] = {
    [sym_class] = STATE(2138),
    [sym_arrow_function] = STATE(2138),
    [sym_await_expression] = STATE(2138),
    [sym_member_expression] = STATE(2748),
    [sym_statement_block] = STATE(1523),
    [sym_update_expression] = STATE(2138),
    [sym_meta_property] = STATE(2138),
    [sym__expression] = STATE(2138),
    [sym_jsx_element] = STATE(2138),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2138),
    [sym_call_expression] = STATE(2138),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2138),
    [sym_string] = STATE(2138),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2138),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2138),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2138),
    [sym_generator_function] = STATE(2138),
    [sym_new_expression] = STATE(2138),
    [sym_assignment_expression] = STATE(2138),
    [sym_augmented_assignment_expression] = STATE(2138),
    [sym_binary_expression] = STATE(2138),
    [sym_unary_expression] = STATE(2138),
    [sym_regex] = STATE(2138),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2138),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2138),
    [sym_internal_module] = STATE(2138),
    [sym_jsx_self_closing_element] = STATE(2138),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5835),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5835),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5835),
    [sym_number] = ACTIONS(5837),
    [sym_true] = ACTIONS(5835),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5835),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2519] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_AMP_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_GT] = ACTIONS(2503),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_CARET_EQ] = ACTIONS(2068),
    [anon_sym_STAR_EQ] = ACTIONS(2068),
    [anon_sym_PIPE_EQ] = ACTIONS(2068),
    [anon_sym_DASH_EQ] = ACTIONS(2068),
    [anon_sym_EQ_GT] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2068),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2520] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5778),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2521] = {
    [sym_await_expression] = STATE(2497),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_ternary_expression] = STATE(2497),
    [sym_template_string] = STATE(2497),
    [sym_yield_expression] = STATE(2497),
    [sym_jsx_fragment] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2497),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2497),
    [sym_class] = STATE(2497),
    [sym_identifier] = ACTIONS(5839),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2522] = {
    [sym_class] = STATE(2496),
    [sym_arrow_function] = STATE(2496),
    [sym_await_expression] = STATE(2496),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2496),
    [sym_meta_property] = STATE(2496),
    [sym__expression] = STATE(2496),
    [sym_jsx_element] = STATE(2496),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2496),
    [sym_call_expression] = STATE(2496),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2496),
    [sym_string] = STATE(2496),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2496),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2496),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2496),
    [sym_generator_function] = STATE(2496),
    [sym_new_expression] = STATE(2496),
    [sym_assignment_expression] = STATE(2496),
    [sym_augmented_assignment_expression] = STATE(2496),
    [sym_binary_expression] = STATE(2496),
    [sym_unary_expression] = STATE(2496),
    [sym_regex] = STATE(2496),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2496),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2496),
    [sym_internal_module] = STATE(2496),
    [sym_jsx_self_closing_element] = STATE(2496),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5841),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5841),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5841),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5841),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4564),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5841),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2523] = {
    [sym_class] = STATE(2581),
    [sym_arrow_function] = STATE(2581),
    [sym_await_expression] = STATE(2581),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2581),
    [sym_meta_property] = STATE(2581),
    [sym__expression] = STATE(2581),
    [sym_jsx_element] = STATE(2581),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2581),
    [sym_call_expression] = STATE(2581),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2581),
    [sym_string] = STATE(2581),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2581),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2581),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2581),
    [sym_generator_function] = STATE(2581),
    [sym_new_expression] = STATE(2581),
    [sym_assignment_expression] = STATE(2581),
    [sym_augmented_assignment_expression] = STATE(2581),
    [sym_binary_expression] = STATE(2581),
    [sym_unary_expression] = STATE(2581),
    [sym_regex] = STATE(2581),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2581),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2581),
    [sym_internal_module] = STATE(2581),
    [sym_jsx_self_closing_element] = STATE(2581),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5732),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5734),
    [anon_sym_yield] = ACTIONS(950),
    [sym_true] = ACTIONS(5734),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5778),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5734),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5734),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_EQ_GT] = ACTIONS(4629),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(5736),
    [anon_sym_SLASH] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5734),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(930),
  },
  [2524] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(848),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [sym_identifier] = ACTIONS(5843),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5845),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(5847),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(5845),
    [anon_sym_static] = ACTIONS(5845),
    [anon_sym_get] = ACTIONS(5845),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(4572),
    [anon_sym_protected] = ACTIONS(5845),
    [anon_sym_DOT] = ACTIONS(4574),
    [anon_sym_set] = ACTIONS(5845),
    [anon_sym_type] = ACTIONS(5845),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(5849),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4572),
    [anon_sym_module] = ACTIONS(5845),
    [anon_sym_number] = ACTIONS(5845),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5845),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [anon_sym_any] = ACTIONS(5845),
    [anon_sym_boolean] = ACTIONS(5845),
    [anon_sym_async] = ACTIONS(5851),
    [anon_sym_public] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4580),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5845),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(5845),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2525] = {
    [sym_string] = STATE(2465),
    [sym__property_name] = STATE(2465),
    [sym_computed_property_name] = STATE(2465),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2526] = {
    [sym_class] = STATE(2139),
    [sym_arrow_function] = STATE(2139),
    [sym_await_expression] = STATE(2139),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2139),
    [sym_meta_property] = STATE(2139),
    [sym__expression] = STATE(2139),
    [sym_jsx_element] = STATE(2139),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2139),
    [sym_call_expression] = STATE(2139),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2139),
    [sym_string] = STATE(2139),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2139),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2139),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2139),
    [sym_generator_function] = STATE(2139),
    [sym_new_expression] = STATE(2139),
    [sym_assignment_expression] = STATE(2139),
    [sym_augmented_assignment_expression] = STATE(2139),
    [sym_binary_expression] = STATE(2139),
    [sym_unary_expression] = STATE(2139),
    [sym_regex] = STATE(2139),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2139),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2139),
    [sym_internal_module] = STATE(2139),
    [sym_jsx_self_closing_element] = STATE(2139),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5855),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5855),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5855),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5855),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5857),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5855),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2527] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(5859),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2528] = {
    [sym_string] = STATE(2472),
    [sym__property_name] = STATE(2472),
    [sym_computed_property_name] = STATE(2472),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2529] = {
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(2706),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2531),
    [sym_function_type] = STATE(2531),
    [sym_constructor_type] = STATE(2531),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_nested_identifier] = STATE(343),
    [sym_predefined_type] = STATE(342),
    [sym_nested_type_identifier] = STATE(2403),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2531),
    [sym__type] = STATE(2531),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(2801),
    [sym_identifier] = ACTIONS(5626),
    [sym_false] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_symbol] = ACTIONS(740),
    [sym_this] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(742),
    [sym_true] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_keyof] = ACTIONS(744),
    [sym_number] = ACTIONS(764),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_new] = ACTIONS(5634),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_PIPE] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(740),
  },
  [2530] = {
    [sym_string] = STATE(2476),
    [sym__property_name] = STATE(2476),
    [sym_computed_property_name] = STATE(2476),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2531] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_PIPE] = ACTIONS(5718),
    [anon_sym_else] = ACTIONS(4131),
    [anon_sym_while] = ACTIONS(4131),
  },
  [2532] = {
    [sym_class] = STATE(2496),
    [sym_arrow_function] = STATE(2496),
    [sym_await_expression] = STATE(2496),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2496),
    [sym_meta_property] = STATE(2496),
    [sym__expression] = STATE(2496),
    [sym_jsx_element] = STATE(2496),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2496),
    [sym_call_expression] = STATE(2496),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2496),
    [sym_string] = STATE(2496),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2496),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2496),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2496),
    [sym_generator_function] = STATE(2496),
    [sym_new_expression] = STATE(2496),
    [sym_assignment_expression] = STATE(2496),
    [sym_augmented_assignment_expression] = STATE(2496),
    [sym_binary_expression] = STATE(2496),
    [sym_unary_expression] = STATE(2496),
    [sym_regex] = STATE(2496),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2496),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2496),
    [sym_internal_module] = STATE(2496),
    [sym_jsx_self_closing_element] = STATE(2496),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5841),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5841),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5841),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5841),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5865),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5841),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2533] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [sym_identifier] = ACTIONS(5843),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5845),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(5847),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(5845),
    [anon_sym_static] = ACTIONS(5845),
    [anon_sym_get] = ACTIONS(5845),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(4572),
    [anon_sym_protected] = ACTIONS(5845),
    [anon_sym_DOT] = ACTIONS(4574),
    [anon_sym_set] = ACTIONS(5845),
    [anon_sym_type] = ACTIONS(5845),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(5849),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4572),
    [anon_sym_module] = ACTIONS(5845),
    [anon_sym_number] = ACTIONS(5845),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5845),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [anon_sym_any] = ACTIONS(5845),
    [anon_sym_boolean] = ACTIONS(5845),
    [anon_sym_async] = ACTIONS(5851),
    [anon_sym_public] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4580),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5845),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(5845),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2534] = {
    [anon_sym_EQ_GT] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
  },
  [2535] = {
    [anon_sym_EQ_GT] = ACTIONS(5869),
    [sym_comment] = ACTIONS(3),
  },
  [2536] = {
    [anon_sym_EQ_GT] = ACTIONS(5871),
    [sym_comment] = ACTIONS(3),
  },
  [2537] = {
    [anon_sym_EQ_GT] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
  },
  [2538] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2539] = {
    [anon_sym_COLON] = ACTIONS(5877),
    [sym_comment] = ACTIONS(3),
  },
  [2540] = {
    [sym_regex_pattern] = ACTIONS(5879),
    [sym_comment] = ACTIONS(255),
  },
  [2541] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2160),
    [sym_function_type] = STATE(2160),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2160),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2160),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2160),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2542] = {
    [sym_identifier] = ACTIONS(5881),
    [sym_comment] = ACTIONS(3),
  },
  [2543] = {
    [sym_generator_function_declaration] = STATE(276),
    [sym__declaration] = STATE(276),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(276),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(276),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(276),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(276),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(276),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(276),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(276),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(276),
    [sym_function_declaration] = STATE(276),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(276),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(276),
    [sym_break_statement] = STATE(276),
    [sym_labeled_statement] = STATE(276),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(56),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(276),
    [sym_class_declaration] = STATE(276),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(276),
    [sym_ambient_declaration] = STATE(276),
    [sym_type_alias_declaration] = STATE(276),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(276),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(276),
    [sym_switch_statement] = STATE(276),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(276),
    [sym_throw_statement] = STATE(276),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(276),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(276),
    [sym_abstract_class_declaration] = STATE(276),
    [sym_interface_declaration] = STATE(276),
    [sym_export_statement] = STATE(276),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(276),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(276),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(276),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(276),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5883),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2544] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2556),
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1276),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2545] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(2556),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_expression] = STATE(516),
    [sym_type_arguments] = STATE(518),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2546] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2556),
    [anon_sym_GT] = ACTIONS(1276),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2547] = {
    [sym_class] = STATE(2538),
    [sym_arrow_function] = STATE(2538),
    [sym_await_expression] = STATE(2538),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2538),
    [sym_meta_property] = STATE(2538),
    [sym__expression] = STATE(2538),
    [sym_jsx_element] = STATE(2538),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2538),
    [sym_call_expression] = STATE(2538),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2538),
    [sym_string] = STATE(2538),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2538),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2538),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2538),
    [sym_generator_function] = STATE(2538),
    [sym_new_expression] = STATE(2538),
    [sym_assignment_expression] = STATE(2538),
    [sym_augmented_assignment_expression] = STATE(2538),
    [sym_binary_expression] = STATE(2538),
    [sym_unary_expression] = STATE(2538),
    [sym_regex] = STATE(2538),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2538),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2538),
    [sym_internal_module] = STATE(2538),
    [sym_jsx_self_closing_element] = STATE(2538),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5885),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5885),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5885),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5885),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5885),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2548] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2175),
    [sym_function_type] = STATE(2175),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2175),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2175),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2175),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2549] = {
    [sym_formal_parameters] = STATE(2176),
    [sym_type_parameters] = STATE(2560),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2550] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2177),
    [sym_function_type] = STATE(2177),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2177),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_object] = STATE(489),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(2177),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2177),
    [aux_sym_export_statement_repeat1] = STATE(493),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(490),
    [sym_identifier] = ACTIONS(1847),
    [anon_sym_symbol] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_this] = ACTIONS(1851),
    [sym_true] = ACTIONS(736),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(736),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_export] = ACTIONS(1207),
  },
  [2551] = {
    [anon_sym_DOT] = ACTIONS(4635),
    [sym_comment] = ACTIONS(3),
  },
  [2552] = {
    [sym_formal_parameters] = STATE(2181),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2553] = {
    [sym_identifier] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
  },
  [2554] = {
    [sym_identifier] = ACTIONS(5891),
    [sym_comment] = ACTIONS(3),
  },
  [2555] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2556] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(805),
    [anon_sym_GT] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(5895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2557] = {
    [sym_nested_identifier] = STATE(2192),
    [sym_jsx_namespace_name] = STATE(2193),
    [sym_identifier] = ACTIONS(5897),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(5899),
  },
  [2558] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2177),
    [sym_function_type] = STATE(2177),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2177),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2177),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2177),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2559] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(2194),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(2194),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(2194),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(2194),
    [sym_property_signature] = STATE(2194),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(2194),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_namespace] = ACTIONS(968),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2560] = {
    [sym_formal_parameters] = STATE(2198),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2561] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(5901),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2562] = {
    [sym_statement_block] = STATE(2100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2563] = {
    [sym_statement_block] = STATE(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4858),
  },
  [2564] = {
    [sym_class] = STATE(2778),
    [sym_arrow_function] = STATE(2778),
    [sym_await_expression] = STATE(2778),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2778),
    [sym_meta_property] = STATE(2778),
    [sym__expression] = STATE(2778),
    [sym_jsx_element] = STATE(2778),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2778),
    [sym_call_expression] = STATE(2778),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2778),
    [sym_string] = STATE(2778),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2778),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2778),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2778),
    [sym_generator_function] = STATE(2778),
    [sym_new_expression] = STATE(2778),
    [sym_assignment_expression] = STATE(2778),
    [sym_augmented_assignment_expression] = STATE(2778),
    [sym_binary_expression] = STATE(2778),
    [sym_unary_expression] = STATE(2778),
    [sym_regex] = STATE(2778),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2778),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2778),
    [sym_internal_module] = STATE(2778),
    [sym_jsx_self_closing_element] = STATE(2778),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5907),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(5907),
    [sym_number] = ACTIONS(5921),
    [sym_true] = ACTIONS(5907),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5907),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2565] = {
    [sym_class] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym__expression] = STATE(1324),
    [sym_jsx_element] = STATE(1324),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1324),
    [sym_call_expression] = STATE(1324),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1324),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(1324),
    [sym_generator_function] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_regex] = STATE(1324),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(1324),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_jsx_self_closing_element] = STATE(1324),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4382),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(4382),
    [sym_number] = ACTIONS(4384),
    [sym_true] = ACTIONS(4382),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4382),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2566] = {
    [sym_class] = STATE(2779),
    [sym_arrow_function] = STATE(2779),
    [sym_await_expression] = STATE(2779),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2779),
    [sym_meta_property] = STATE(2779),
    [sym__expression] = STATE(2779),
    [sym_jsx_element] = STATE(2779),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2779),
    [sym_call_expression] = STATE(2779),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2779),
    [sym_string] = STATE(2779),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2779),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2779),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2779),
    [sym_generator_function] = STATE(2779),
    [sym_new_expression] = STATE(2779),
    [sym_assignment_expression] = STATE(2779),
    [sym_augmented_assignment_expression] = STATE(2779),
    [sym_binary_expression] = STATE(2779),
    [sym_unary_expression] = STATE(2779),
    [sym_regex] = STATE(2779),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2779),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2779),
    [sym_internal_module] = STATE(2779),
    [sym_jsx_self_closing_element] = STATE(2779),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5931),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_LBRACE_PIPE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(5933),
    [anon_sym_yield] = ACTIONS(5923),
    [sym_true] = ACTIONS(5933),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5933),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5933),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(5939),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5933),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(5903),
  },
  [2567] = {
    [sym_class] = STATE(2780),
    [sym_arrow_function] = STATE(2780),
    [sym_await_expression] = STATE(2780),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2780),
    [sym_meta_property] = STATE(2780),
    [sym__expression] = STATE(2780),
    [sym_jsx_element] = STATE(2780),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2780),
    [sym_call_expression] = STATE(2780),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2780),
    [sym_string] = STATE(2780),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2780),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2780),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2780),
    [sym_generator_function] = STATE(2780),
    [sym_new_expression] = STATE(2780),
    [sym_assignment_expression] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(2780),
    [sym_binary_expression] = STATE(2780),
    [sym_unary_expression] = STATE(2780),
    [sym_regex] = STATE(2780),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2780),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2780),
    [sym_internal_module] = STATE(2780),
    [sym_jsx_self_closing_element] = STATE(2780),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(5941),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5941),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(5941),
    [sym_number] = ACTIONS(5943),
    [sym_true] = ACTIONS(5941),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5941),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2568] = {
    [sym_class] = STATE(2781),
    [sym_arrow_function] = STATE(2781),
    [sym_await_expression] = STATE(2781),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2781),
    [sym_meta_property] = STATE(2781),
    [sym__expression] = STATE(2781),
    [sym_jsx_element] = STATE(2781),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2781),
    [sym_call_expression] = STATE(2781),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2781),
    [sym_string] = STATE(2781),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2781),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2781),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2781),
    [sym_generator_function] = STATE(2781),
    [sym_new_expression] = STATE(2781),
    [sym_assignment_expression] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(2781),
    [sym_binary_expression] = STATE(2781),
    [sym_unary_expression] = STATE(2781),
    [sym_regex] = STATE(2781),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2781),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2781),
    [sym_internal_module] = STATE(2781),
    [sym_jsx_self_closing_element] = STATE(2781),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5945),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(5945),
    [sym_number] = ACTIONS(5947),
    [sym_true] = ACTIONS(5945),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5945),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2569] = {
    [sym_await_expression] = STATE(2211),
    [sym_statement_block] = STATE(1382),
    [sym_update_expression] = STATE(2211),
    [sym_meta_property] = STATE(2211),
    [sym__expression] = STATE(2211),
    [sym_jsx_element] = STATE(2211),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2211),
    [sym_call_expression] = STATE(2211),
    [sym_ternary_expression] = STATE(2211),
    [sym_template_string] = STATE(2211),
    [sym_yield_expression] = STATE(2211),
    [sym_jsx_fragment] = STATE(2211),
    [sym_new_expression] = STATE(2211),
    [sym_assignment_expression] = STATE(2211),
    [sym_binary_expression] = STATE(2211),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2211),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2211),
    [sym_jsx_self_closing_element] = STATE(2211),
    [sym_arrow_function] = STATE(2211),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2211),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2211),
    [sym_augmented_assignment_expression] = STATE(2211),
    [sym_unary_expression] = STATE(2211),
    [sym_regex] = STATE(2211),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2211),
    [sym_class] = STATE(2211),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5949),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5949),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5949),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5949),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5949),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2570] = {
    [sym_class] = STATE(2212),
    [sym_arrow_function] = STATE(2212),
    [sym_await_expression] = STATE(2212),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2212),
    [sym_meta_property] = STATE(2212),
    [sym__expression] = STATE(2212),
    [sym_jsx_element] = STATE(2212),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2212),
    [sym_call_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2212),
    [sym_string] = STATE(2212),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2212),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2212),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2212),
    [sym_generator_function] = STATE(2212),
    [sym_new_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2212),
    [sym_augmented_assignment_expression] = STATE(2212),
    [sym_binary_expression] = STATE(2212),
    [sym_unary_expression] = STATE(2212),
    [sym_regex] = STATE(2212),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2212),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2212),
    [sym_internal_module] = STATE(2212),
    [sym_jsx_self_closing_element] = STATE(2212),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5953),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5953),
    [sym_number] = ACTIONS(5955),
    [sym_true] = ACTIONS(5953),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5953),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2571] = {
    [sym_class] = STATE(2213),
    [sym_arrow_function] = STATE(2213),
    [sym_await_expression] = STATE(2213),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2213),
    [sym_meta_property] = STATE(2213),
    [sym__expression] = STATE(2213),
    [sym_jsx_element] = STATE(2213),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2213),
    [sym_call_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2213),
    [sym_string] = STATE(2213),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2213),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2213),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2213),
    [sym_generator_function] = STATE(2213),
    [sym_new_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2213),
    [sym_augmented_assignment_expression] = STATE(2213),
    [sym_binary_expression] = STATE(2213),
    [sym_unary_expression] = STATE(2213),
    [sym_regex] = STATE(2213),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2213),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2213),
    [sym_internal_module] = STATE(2213),
    [sym_jsx_self_closing_element] = STATE(2213),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5957),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5957),
    [sym_number] = ACTIONS(5959),
    [sym_true] = ACTIONS(5957),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5957),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2572] = {
    [sym_await_expression] = STATE(2214),
    [sym_statement_block] = STATE(1388),
    [sym_update_expression] = STATE(2214),
    [sym_meta_property] = STATE(2214),
    [sym__expression] = STATE(2214),
    [sym_jsx_element] = STATE(2214),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2214),
    [sym_call_expression] = STATE(2214),
    [sym_ternary_expression] = STATE(2214),
    [sym_template_string] = STATE(2214),
    [sym_yield_expression] = STATE(2214),
    [sym_jsx_fragment] = STATE(2214),
    [sym_new_expression] = STATE(2214),
    [sym_assignment_expression] = STATE(2214),
    [sym_binary_expression] = STATE(2214),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2214),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2214),
    [sym_jsx_self_closing_element] = STATE(2214),
    [sym_arrow_function] = STATE(2214),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2214),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2214),
    [sym_augmented_assignment_expression] = STATE(2214),
    [sym_unary_expression] = STATE(2214),
    [sym_regex] = STATE(2214),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2214),
    [sym_class] = STATE(2214),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(5961),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(5961),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5961),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5961),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(5963),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5961),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2573] = {
    [sym_class] = STATE(2215),
    [sym_arrow_function] = STATE(2215),
    [sym_await_expression] = STATE(2215),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2215),
    [sym_meta_property] = STATE(2215),
    [sym__expression] = STATE(2215),
    [sym_jsx_element] = STATE(2215),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2215),
    [sym_call_expression] = STATE(2215),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2215),
    [sym_string] = STATE(2215),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2215),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2215),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2215),
    [sym_generator_function] = STATE(2215),
    [sym_new_expression] = STATE(2215),
    [sym_assignment_expression] = STATE(2215),
    [sym_augmented_assignment_expression] = STATE(2215),
    [sym_binary_expression] = STATE(2215),
    [sym_unary_expression] = STATE(2215),
    [sym_regex] = STATE(2215),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2215),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2215),
    [sym_internal_module] = STATE(2215),
    [sym_jsx_self_closing_element] = STATE(2215),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5965),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5965),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5965),
    [sym_number] = ACTIONS(5967),
    [sym_true] = ACTIONS(5965),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5965),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2574] = {
    [sym_class] = STATE(2216),
    [sym_arrow_function] = STATE(2216),
    [sym_await_expression] = STATE(2216),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2216),
    [sym_meta_property] = STATE(2216),
    [sym__expression] = STATE(2216),
    [sym_jsx_element] = STATE(2216),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2216),
    [sym_call_expression] = STATE(2216),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2216),
    [sym_string] = STATE(2216),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2216),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2216),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2216),
    [sym_generator_function] = STATE(2216),
    [sym_new_expression] = STATE(2216),
    [sym_assignment_expression] = STATE(2216),
    [sym_augmented_assignment_expression] = STATE(2216),
    [sym_binary_expression] = STATE(2216),
    [sym_unary_expression] = STATE(2216),
    [sym_regex] = STATE(2216),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2216),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2216),
    [sym_internal_module] = STATE(2216),
    [sym_jsx_self_closing_element] = STATE(2216),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5969),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5969),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5969),
    [sym_number] = ACTIONS(5971),
    [sym_true] = ACTIONS(5969),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5969),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2575] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_AMP_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2068),
    [anon_sym_STAR_EQ] = ACTIONS(2068),
    [anon_sym_PIPE_EQ] = ACTIONS(2068),
    [anon_sym_DASH_EQ] = ACTIONS(2068),
    [anon_sym_EQ_GT] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2068),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2576] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2577] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(1310),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1322),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2578] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2579] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2580] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_implements] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(701),
  },
  [2581] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_implements] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2582] = {
    [sym_class] = STATE(2217),
    [sym_arrow_function] = STATE(2217),
    [sym_await_expression] = STATE(2217),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2217),
    [sym_meta_property] = STATE(2217),
    [sym__expression] = STATE(2217),
    [sym_jsx_element] = STATE(2217),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2217),
    [sym_call_expression] = STATE(2217),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2217),
    [sym_string] = STATE(2217),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2217),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2217),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2217),
    [sym_generator_function] = STATE(2217),
    [sym_new_expression] = STATE(2217),
    [sym_assignment_expression] = STATE(2217),
    [sym_augmented_assignment_expression] = STATE(2217),
    [sym_binary_expression] = STATE(2217),
    [sym_unary_expression] = STATE(2217),
    [sym_regex] = STATE(2217),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2217),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2217),
    [sym_internal_module] = STATE(2217),
    [sym_jsx_self_closing_element] = STATE(2217),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5976),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5976),
    [sym_number] = ACTIONS(5978),
    [sym_true] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5976),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2583] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(806),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2584] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(699),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_implements] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2585] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [2586] = {
    [sym_arguments] = STATE(1446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1300),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [2587] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1446),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(2932),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [2588] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_arguments] = STATE(1446),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [2589] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2097),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_GT] = ACTIONS(2097),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2097),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2103),
    [anon_sym_STAR_STAR] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(1396),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2590] = {
    [sym_class] = STATE(2218),
    [sym_arrow_function] = STATE(2218),
    [sym_await_expression] = STATE(2218),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2218),
    [sym_meta_property] = STATE(2218),
    [sym__expression] = STATE(2218),
    [sym_jsx_element] = STATE(2218),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2218),
    [sym_call_expression] = STATE(2218),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2218),
    [sym_string] = STATE(2218),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2218),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2218),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2218),
    [sym_generator_function] = STATE(2218),
    [sym_new_expression] = STATE(2218),
    [sym_assignment_expression] = STATE(2218),
    [sym_augmented_assignment_expression] = STATE(2218),
    [sym_binary_expression] = STATE(2218),
    [sym_unary_expression] = STATE(2218),
    [sym_regex] = STATE(2218),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2218),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2218),
    [sym_internal_module] = STATE(2218),
    [sym_jsx_self_closing_element] = STATE(2218),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5274),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5274),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5274),
    [sym_number] = ACTIONS(5980),
    [sym_true] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5274),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2591] = {
    [sym_class] = STATE(2219),
    [sym_arrow_function] = STATE(2219),
    [sym_await_expression] = STATE(2219),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2219),
    [sym_meta_property] = STATE(2219),
    [sym__expression] = STATE(2219),
    [sym_jsx_element] = STATE(2219),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2219),
    [sym_call_expression] = STATE(2219),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2219),
    [sym_string] = STATE(2219),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2219),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2219),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2219),
    [sym_generator_function] = STATE(2219),
    [sym_new_expression] = STATE(2219),
    [sym_assignment_expression] = STATE(2219),
    [sym_augmented_assignment_expression] = STATE(2219),
    [sym_binary_expression] = STATE(2219),
    [sym_unary_expression] = STATE(2219),
    [sym_regex] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2219),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_jsx_self_closing_element] = STATE(2219),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5982),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5982),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5982),
    [sym_number] = ACTIONS(5984),
    [sym_true] = ACTIONS(5982),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5982),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2592] = {
    [sym_class] = STATE(2220),
    [sym_arrow_function] = STATE(2220),
    [sym_await_expression] = STATE(2220),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2220),
    [sym_meta_property] = STATE(2220),
    [sym__expression] = STATE(2220),
    [sym_jsx_element] = STATE(2220),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2220),
    [sym_call_expression] = STATE(2220),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2220),
    [sym_string] = STATE(2220),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2220),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2220),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2220),
    [sym_generator_function] = STATE(2220),
    [sym_new_expression] = STATE(2220),
    [sym_assignment_expression] = STATE(2220),
    [sym_augmented_assignment_expression] = STATE(2220),
    [sym_binary_expression] = STATE(2220),
    [sym_unary_expression] = STATE(2220),
    [sym_regex] = STATE(2220),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2220),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2220),
    [sym_internal_module] = STATE(2220),
    [sym_jsx_self_closing_element] = STATE(2220),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5986),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5986),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5986),
    [sym_number] = ACTIONS(5988),
    [sym_true] = ACTIONS(5986),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5986),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2593] = {
    [sym_class] = STATE(2221),
    [sym_arrow_function] = STATE(2221),
    [sym_await_expression] = STATE(2221),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2221),
    [sym_meta_property] = STATE(2221),
    [sym__expression] = STATE(2221),
    [sym_jsx_element] = STATE(2221),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2221),
    [sym_call_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2221),
    [sym_string] = STATE(2221),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2221),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2221),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2221),
    [sym_generator_function] = STATE(2221),
    [sym_new_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2221),
    [sym_augmented_assignment_expression] = STATE(2221),
    [sym_binary_expression] = STATE(2221),
    [sym_unary_expression] = STATE(2221),
    [sym_regex] = STATE(2221),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2221),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2221),
    [sym_internal_module] = STATE(2221),
    [sym_jsx_self_closing_element] = STATE(2221),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5990),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5990),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5990),
    [sym_number] = ACTIONS(5992),
    [sym_true] = ACTIONS(5990),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5990),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2594] = {
    [sym_class] = STATE(2222),
    [sym_arrow_function] = STATE(2222),
    [sym_await_expression] = STATE(2222),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2222),
    [sym_meta_property] = STATE(2222),
    [sym__expression] = STATE(2222),
    [sym_jsx_element] = STATE(2222),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2222),
    [sym_call_expression] = STATE(2222),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2222),
    [sym_string] = STATE(2222),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2222),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2222),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2222),
    [sym_generator_function] = STATE(2222),
    [sym_new_expression] = STATE(2222),
    [sym_assignment_expression] = STATE(2222),
    [sym_augmented_assignment_expression] = STATE(2222),
    [sym_binary_expression] = STATE(2222),
    [sym_unary_expression] = STATE(2222),
    [sym_regex] = STATE(2222),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2222),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2222),
    [sym_internal_module] = STATE(2222),
    [sym_jsx_self_closing_element] = STATE(2222),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5994),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5994),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5994),
    [sym_number] = ACTIONS(5996),
    [sym_true] = ACTIONS(5994),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5994),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2595] = {
    [sym_class] = STATE(2225),
    [sym_arrow_function] = STATE(2225),
    [sym_await_expression] = STATE(2225),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2225),
    [sym_meta_property] = STATE(2225),
    [sym__expression] = STATE(2225),
    [sym_jsx_element] = STATE(2225),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2225),
    [sym_call_expression] = STATE(2225),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2225),
    [sym_string] = STATE(2225),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2225),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2225),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2225),
    [sym_generator_function] = STATE(2225),
    [sym_new_expression] = STATE(2225),
    [sym_assignment_expression] = STATE(2225),
    [sym_augmented_assignment_expression] = STATE(2225),
    [sym_binary_expression] = STATE(2225),
    [sym_unary_expression] = STATE(2225),
    [sym_regex] = STATE(2225),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2225),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2225),
    [sym_internal_module] = STATE(2225),
    [sym_jsx_self_closing_element] = STATE(2225),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5998),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5998),
    [sym_number] = ACTIONS(6000),
    [sym_true] = ACTIONS(5998),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5998),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2596] = {
    [sym_class] = STATE(2226),
    [sym_arrow_function] = STATE(2226),
    [sym_await_expression] = STATE(2226),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2226),
    [sym_meta_property] = STATE(2226),
    [sym__expression] = STATE(2226),
    [sym_jsx_element] = STATE(2226),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2226),
    [sym_call_expression] = STATE(2226),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2226),
    [sym_string] = STATE(2226),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2226),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2226),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2226),
    [sym_generator_function] = STATE(2226),
    [sym_new_expression] = STATE(2226),
    [sym_assignment_expression] = STATE(2226),
    [sym_augmented_assignment_expression] = STATE(2226),
    [sym_binary_expression] = STATE(2226),
    [sym_unary_expression] = STATE(2226),
    [sym_regex] = STATE(2226),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2226),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2226),
    [sym_internal_module] = STATE(2226),
    [sym_jsx_self_closing_element] = STATE(2226),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(6002),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6002),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(6002),
    [sym_number] = ACTIONS(6004),
    [sym_true] = ACTIONS(6002),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6002),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2597] = {
    [sym_await_expression] = STATE(2227),
    [sym_statement_block] = STATE(1472),
    [sym_update_expression] = STATE(2227),
    [sym_meta_property] = STATE(2227),
    [sym__expression] = STATE(2227),
    [sym_jsx_element] = STATE(2227),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_template_string] = STATE(2227),
    [sym_yield_expression] = STATE(2227),
    [sym_jsx_fragment] = STATE(2227),
    [sym_new_expression] = STATE(2227),
    [sym_assignment_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2227),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2227),
    [sym_jsx_self_closing_element] = STATE(2227),
    [sym_arrow_function] = STATE(2227),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2227),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2227),
    [sym_augmented_assignment_expression] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_regex] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2227),
    [sym_class] = STATE(2227),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6006),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6006),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6006),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6006),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6006),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2598] = {
    [sym_class] = STATE(2228),
    [sym_arrow_function] = STATE(2228),
    [sym_await_expression] = STATE(2228),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2228),
    [sym_meta_property] = STATE(2228),
    [sym__expression] = STATE(2228),
    [sym_jsx_element] = STATE(2228),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2228),
    [sym_call_expression] = STATE(2228),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2228),
    [sym_string] = STATE(2228),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2228),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2228),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2228),
    [sym_generator_function] = STATE(2228),
    [sym_new_expression] = STATE(2228),
    [sym_assignment_expression] = STATE(2228),
    [sym_augmented_assignment_expression] = STATE(2228),
    [sym_binary_expression] = STATE(2228),
    [sym_unary_expression] = STATE(2228),
    [sym_regex] = STATE(2228),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2228),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2228),
    [sym_internal_module] = STATE(2228),
    [sym_jsx_self_closing_element] = STATE(2228),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6010),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(6010),
    [sym_number] = ACTIONS(6012),
    [sym_true] = ACTIONS(6010),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6010),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2599] = {
    [sym_await_expression] = STATE(2229),
    [sym_statement_block] = STATE(1518),
    [sym_update_expression] = STATE(2229),
    [sym_meta_property] = STATE(2229),
    [sym__expression] = STATE(2229),
    [sym_jsx_element] = STATE(2229),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2229),
    [sym_call_expression] = STATE(2229),
    [sym_ternary_expression] = STATE(2229),
    [sym_template_string] = STATE(2229),
    [sym_yield_expression] = STATE(2229),
    [sym_jsx_fragment] = STATE(2229),
    [sym_new_expression] = STATE(2229),
    [sym_assignment_expression] = STATE(2229),
    [sym_binary_expression] = STATE(2229),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2229),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2229),
    [sym_jsx_self_closing_element] = STATE(2229),
    [sym_arrow_function] = STATE(2229),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2229),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2229),
    [sym_augmented_assignment_expression] = STATE(2229),
    [sym_unary_expression] = STATE(2229),
    [sym_regex] = STATE(2229),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2229),
    [sym_class] = STATE(2229),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6014),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6014),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6014),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6014),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(6016),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6014),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2600] = {
    [sym_await_expression] = STATE(2230),
    [sym_statement_block] = STATE(1520),
    [sym_update_expression] = STATE(2230),
    [sym_meta_property] = STATE(2230),
    [sym__expression] = STATE(2230),
    [sym_jsx_element] = STATE(2230),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2230),
    [sym_call_expression] = STATE(2230),
    [sym_ternary_expression] = STATE(2230),
    [sym_template_string] = STATE(2230),
    [sym_yield_expression] = STATE(2230),
    [sym_jsx_fragment] = STATE(2230),
    [sym_new_expression] = STATE(2230),
    [sym_assignment_expression] = STATE(2230),
    [sym_binary_expression] = STATE(2230),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2230),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2230),
    [sym_jsx_self_closing_element] = STATE(2230),
    [sym_arrow_function] = STATE(2230),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2230),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2230),
    [sym_augmented_assignment_expression] = STATE(2230),
    [sym_unary_expression] = STATE(2230),
    [sym_regex] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2230),
    [sym_class] = STATE(2230),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6018),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6018),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6018),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6018),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(6020),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6018),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2601] = {
    [sym_await_expression] = STATE(2231),
    [sym_statement_block] = STATE(1523),
    [sym_update_expression] = STATE(2231),
    [sym_meta_property] = STATE(2231),
    [sym__expression] = STATE(2231),
    [sym_jsx_element] = STATE(2231),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2231),
    [sym_call_expression] = STATE(2231),
    [sym_ternary_expression] = STATE(2231),
    [sym_template_string] = STATE(2231),
    [sym_yield_expression] = STATE(2231),
    [sym_jsx_fragment] = STATE(2231),
    [sym_new_expression] = STATE(2231),
    [sym_assignment_expression] = STATE(2231),
    [sym_binary_expression] = STATE(2231),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_array] = STATE(2789),
    [sym_as_expression] = STATE(2231),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2231),
    [sym_jsx_self_closing_element] = STATE(2231),
    [sym_arrow_function] = STATE(2231),
    [sym_member_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_subscript_expression] = STATE(2788),
    [sym_string] = STATE(2231),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(2790),
    [sym_generator_function] = STATE(2231),
    [sym_augmented_assignment_expression] = STATE(2231),
    [sym_unary_expression] = STATE(2231),
    [sym_regex] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2231),
    [sym_class] = STATE(2231),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6022),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6022),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6022),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6022),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(6024),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6022),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2602] = {
    [sym_type_arguments] = STATE(611),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_AMP_EQ] = ACTIONS(5638),
    [anon_sym_PLUS_EQ] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(2503),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(1799),
    [anon_sym_GT] = ACTIONS(2503),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_CARET_EQ] = ACTIONS(5638),
    [anon_sym_STAR_EQ] = ACTIONS(5638),
    [anon_sym_PIPE_EQ] = ACTIONS(5638),
    [anon_sym_DASH_EQ] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2511),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2603] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2604] = {
    [sym_class] = STATE(2581),
    [sym_arrow_function] = STATE(2581),
    [sym_await_expression] = STATE(2581),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2581),
    [sym_meta_property] = STATE(2581),
    [sym__expression] = STATE(2581),
    [sym_jsx_element] = STATE(2581),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2581),
    [sym_call_expression] = STATE(2581),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2581),
    [sym_string] = STATE(2581),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2581),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2581),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2581),
    [sym_generator_function] = STATE(2581),
    [sym_new_expression] = STATE(2581),
    [sym_assignment_expression] = STATE(2581),
    [sym_augmented_assignment_expression] = STATE(2581),
    [sym_binary_expression] = STATE(2581),
    [sym_unary_expression] = STATE(2581),
    [sym_regex] = STATE(2581),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2581),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2581),
    [sym_internal_module] = STATE(2581),
    [sym_jsx_self_closing_element] = STATE(2581),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(6032),
    [sym_false] = ACTIONS(5734),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5734),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(5734),
    [sym_number] = ACTIONS(5736),
    [sym_true] = ACTIONS(5734),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5734),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2605] = {
    [sym_class] = STATE(2580),
    [sym_arrow_function] = STATE(2580),
    [sym_await_expression] = STATE(2580),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2580),
    [sym_meta_property] = STATE(2580),
    [sym__expression] = STATE(2580),
    [sym_jsx_element] = STATE(2580),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2580),
    [sym_call_expression] = STATE(2580),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2580),
    [sym_string] = STATE(2580),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2580),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2580),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2580),
    [sym_generator_function] = STATE(2580),
    [sym_new_expression] = STATE(2580),
    [sym_assignment_expression] = STATE(2580),
    [sym_augmented_assignment_expression] = STATE(2580),
    [sym_binary_expression] = STATE(2580),
    [sym_unary_expression] = STATE(2580),
    [sym_regex] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2580),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2580),
    [sym_internal_module] = STATE(2580),
    [sym_jsx_self_closing_element] = STATE(2580),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6034),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(6034),
    [sym_number] = ACTIONS(4564),
    [sym_true] = ACTIONS(6034),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6034),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2606] = {
    [sym_class] = STATE(2778),
    [sym_arrow_function] = STATE(2778),
    [sym_await_expression] = STATE(2778),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2778),
    [sym_meta_property] = STATE(2778),
    [sym__expression] = STATE(2778),
    [sym_jsx_element] = STATE(2778),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2778),
    [sym_call_expression] = STATE(2778),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2778),
    [sym_string] = STATE(2778),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2778),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2778),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2778),
    [sym_generator_function] = STATE(2778),
    [sym_new_expression] = STATE(2778),
    [sym_assignment_expression] = STATE(2778),
    [sym_augmented_assignment_expression] = STATE(2778),
    [sym_binary_expression] = STATE(2778),
    [sym_unary_expression] = STATE(2778),
    [sym_regex] = STATE(2778),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2778),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2778),
    [sym_internal_module] = STATE(2778),
    [sym_jsx_self_closing_element] = STATE(2778),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5907),
    [anon_sym_yield] = ACTIONS(5923),
    [sym_true] = ACTIONS(5907),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6026),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5907),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5907),
    [anon_sym_GT] = ACTIONS(2542),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(5921),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5907),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(5903),
  },
  [2607] = {
    [sym_class] = STATE(2232),
    [sym_arrow_function] = STATE(2232),
    [sym_await_expression] = STATE(2232),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2232),
    [sym_meta_property] = STATE(2232),
    [sym__expression] = STATE(2232),
    [sym_jsx_element] = STATE(2232),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2232),
    [sym_call_expression] = STATE(2232),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2232),
    [sym_string] = STATE(2232),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2232),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2232),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2232),
    [sym_generator_function] = STATE(2232),
    [sym_new_expression] = STATE(2232),
    [sym_assignment_expression] = STATE(2232),
    [sym_augmented_assignment_expression] = STATE(2232),
    [sym_binary_expression] = STATE(2232),
    [sym_unary_expression] = STATE(2232),
    [sym_regex] = STATE(2232),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2232),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2232),
    [sym_internal_module] = STATE(2232),
    [sym_jsx_self_closing_element] = STATE(2232),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6036),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(6036),
    [sym_number] = ACTIONS(6038),
    [sym_true] = ACTIONS(6036),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6036),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2608] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_AMP_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_CARET_EQ] = ACTIONS(2068),
    [anon_sym_STAR_EQ] = ACTIONS(2068),
    [anon_sym_PIPE_EQ] = ACTIONS(2068),
    [anon_sym_DASH_EQ] = ACTIONS(2068),
    [anon_sym_EQ_GT] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2068),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_DOT] = ACTIONS(4594),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2609] = {
    [sym_class] = STATE(2580),
    [sym_arrow_function] = STATE(2580),
    [sym_await_expression] = STATE(2580),
    [sym_member_expression] = STATE(2748),
    [sym_update_expression] = STATE(2580),
    [sym_meta_property] = STATE(2580),
    [sym__expression] = STATE(2580),
    [sym_jsx_element] = STATE(2580),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2580),
    [sym_call_expression] = STATE(2580),
    [sym_subscript_expression] = STATE(2748),
    [sym__call_signature] = STATE(2534),
    [sym_ternary_expression] = STATE(2580),
    [sym_string] = STATE(2580),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2580),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2580),
    [sym_object] = STATE(2750),
    [sym_jsx_fragment] = STATE(2580),
    [sym_generator_function] = STATE(2580),
    [sym_new_expression] = STATE(2580),
    [sym_assignment_expression] = STATE(2580),
    [sym_augmented_assignment_expression] = STATE(2580),
    [sym_binary_expression] = STATE(2580),
    [sym_unary_expression] = STATE(2580),
    [sym_regex] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2748),
    [sym_non_null_expression] = STATE(2580),
    [sym_array] = STATE(2749),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2580),
    [sym_internal_module] = STATE(2580),
    [sym_jsx_self_closing_element] = STATE(2580),
    [anon_sym_await] = ACTIONS(930),
    [sym_identifier] = ACTIONS(5732),
    [sym_false] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(936),
    [anon_sym_symbol] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(936),
    [anon_sym_typeof] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6034),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(936),
    [anon_sym_private] = ACTIONS(936),
    [anon_sym_boolean] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(936),
    [anon_sym_get] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(944),
    [anon_sym_delete] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [sym_this] = ACTIONS(6034),
    [sym_number] = ACTIONS(6040),
    [sym_true] = ACTIONS(6034),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(936),
    [anon_sym_string] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6034),
    [anon_sym_set] = ACTIONS(936),
    [anon_sym_type] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(954),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(936),
    [anon_sym_namespace] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(958),
  },
  [2610] = {
    [anon_sym_EQ_GT] = ACTIONS(6042),
    [sym_comment] = ACTIONS(3),
  },
  [2611] = {
    [anon_sym_EQ_GT] = ACTIONS(6044),
    [sym_comment] = ACTIONS(3),
  },
  [2612] = {
    [anon_sym_EQ_GT] = ACTIONS(6046),
    [sym_comment] = ACTIONS(3),
  },
  [2613] = {
    [anon_sym_EQ_GT] = ACTIONS(6048),
    [sym_comment] = ACTIONS(3),
  },
  [2614] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6050),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2615] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2248),
    [sym_function_type] = STATE(2248),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2248),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2248),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2248),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2616] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2626),
    [anon_sym_COLON] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2617] = {
    [sym_jsx_expression] = STATE(516),
    [sym_jsx_namespace_name] = STATE(520),
    [sym_type_arguments] = STATE(518),
    [sym_jsx_attribute] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2626),
    [sym_identifier] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1267),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2618] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2626),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2619] = {
    [sym_class] = STATE(2614),
    [sym_arrow_function] = STATE(2614),
    [sym_await_expression] = STATE(2614),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2614),
    [sym_meta_property] = STATE(2614),
    [sym__expression] = STATE(2614),
    [sym_jsx_element] = STATE(2614),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2614),
    [sym_call_expression] = STATE(2614),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2614),
    [sym_string] = STATE(2614),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2614),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2614),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2614),
    [sym_generator_function] = STATE(2614),
    [sym_new_expression] = STATE(2614),
    [sym_assignment_expression] = STATE(2614),
    [sym_augmented_assignment_expression] = STATE(2614),
    [sym_binary_expression] = STATE(2614),
    [sym_unary_expression] = STATE(2614),
    [sym_regex] = STATE(2614),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2614),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2614),
    [sym_internal_module] = STATE(2614),
    [sym_jsx_self_closing_element] = STATE(2614),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(1316),
    [sym_false] = ACTIONS(6052),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6052),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6052),
    [sym_number] = ACTIONS(6054),
    [sym_true] = ACTIONS(6052),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6052),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2620] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2255),
    [sym_function_type] = STATE(2255),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2255),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2255),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2255),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2621] = {
    [sym_formal_parameters] = STATE(2256),
    [sym_type_parameters] = STATE(2630),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2622] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2257),
    [sym_function_type] = STATE(2257),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2257),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_object] = STATE(489),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(2257),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2257),
    [aux_sym_export_statement_repeat1] = STATE(493),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(490),
    [sym_identifier] = ACTIONS(1847),
    [anon_sym_symbol] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [sym_this] = ACTIONS(1851),
    [sym_true] = ACTIONS(736),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_type] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(423),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(736),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_export] = ACTIONS(1207),
  },
  [2623] = {
    [anon_sym_DOT] = ACTIONS(4667),
    [sym_comment] = ACTIONS(3),
  },
  [2624] = {
    [sym_formal_parameters] = STATE(2261),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2625] = {
    [sym_identifier] = ACTIONS(6056),
    [sym_comment] = ACTIONS(3),
  },
  [2626] = {
    [sym_jsx_namespace_name] = STATE(520),
    [sym_jsx_attribute] = STATE(516),
    [sym_jsx_expression] = STATE(516),
    [aux_sym_jsx_opening_element_repeat1] = STATE(805),
    [sym_identifier] = ACTIONS(1251),
    [sym_jsx_identifier] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(6058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1259),
  },
  [2627] = {
    [sym_nested_identifier] = STATE(2266),
    [sym_jsx_namespace_name] = STATE(2267),
    [sym_identifier] = ACTIONS(6060),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(6062),
  },
  [2628] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2257),
    [sym_function_type] = STATE(2257),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2257),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2257),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2257),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2629] = {
    [sym_string] = STATE(626),
    [sym_formal_parameters] = STATE(1306),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(626),
    [sym_construct_signature] = STATE(2268),
    [sym_accessibility_modifier] = STATE(625),
    [sym_export_statement] = STATE(2268),
    [sym__property_name] = STATE(626),
    [sym_method_signature] = STATE(2268),
    [aux_sym_export_statement_repeat1] = STATE(624),
    [sym__call_signature] = STATE(2268),
    [sym_property_signature] = STATE(2268),
    [sym_type_parameters] = STATE(1868),
    [sym_index_signature] = STATE(2268),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(1821),
    [anon_sym_public] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(339),
    [sym_number] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_namespace] = ACTIONS(968),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(992),
  },
  [2630] = {
    [sym_formal_parameters] = STATE(2272),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2631] = {
    [sym_class] = STATE(2753),
    [sym_arrow_function] = STATE(2753),
    [sym_await_expression] = STATE(2753),
    [sym_member_expression] = STATE(2792),
    [sym_statement_block] = STATE(1382),
    [sym_update_expression] = STATE(2753),
    [sym_meta_property] = STATE(2753),
    [sym__expression] = STATE(2753),
    [sym_jsx_element] = STATE(2753),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2753),
    [sym_call_expression] = STATE(2753),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2753),
    [sym_string] = STATE(2753),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2753),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2753),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2753),
    [sym_generator_function] = STATE(2753),
    [sym_new_expression] = STATE(2753),
    [sym_assignment_expression] = STATE(2753),
    [sym_augmented_assignment_expression] = STATE(2753),
    [sym_binary_expression] = STATE(2753),
    [sym_unary_expression] = STATE(2753),
    [sym_regex] = STATE(2753),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2753),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2753),
    [sym_internal_module] = STATE(2753),
    [sym_jsx_self_closing_element] = STATE(2753),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6064),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6064),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6064),
    [sym_number] = ACTIONS(6066),
    [sym_true] = ACTIONS(6064),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6064),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2632] = {
    [sym_class] = STATE(2761),
    [sym_arrow_function] = STATE(2761),
    [sym_await_expression] = STATE(2761),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2761),
    [sym_meta_property] = STATE(2761),
    [sym__expression] = STATE(2761),
    [sym_jsx_element] = STATE(2761),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2761),
    [sym_call_expression] = STATE(2761),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2761),
    [sym_string] = STATE(2761),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2761),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2761),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2761),
    [sym_generator_function] = STATE(2761),
    [sym_new_expression] = STATE(2761),
    [sym_assignment_expression] = STATE(2761),
    [sym_augmented_assignment_expression] = STATE(2761),
    [sym_binary_expression] = STATE(2761),
    [sym_unary_expression] = STATE(2761),
    [sym_regex] = STATE(2761),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2761),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2761),
    [sym_internal_module] = STATE(2761),
    [sym_jsx_self_closing_element] = STATE(2761),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6068),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6068),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6068),
    [sym_number] = ACTIONS(6070),
    [sym_true] = ACTIONS(6068),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6068),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2633] = {
    [sym_class] = STATE(2762),
    [sym_arrow_function] = STATE(2762),
    [sym_await_expression] = STATE(2762),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2762),
    [sym_meta_property] = STATE(2762),
    [sym__expression] = STATE(2762),
    [sym_jsx_element] = STATE(2762),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2762),
    [sym_call_expression] = STATE(2762),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2762),
    [sym_string] = STATE(2762),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2762),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2762),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2762),
    [sym_generator_function] = STATE(2762),
    [sym_new_expression] = STATE(2762),
    [sym_assignment_expression] = STATE(2762),
    [sym_augmented_assignment_expression] = STATE(2762),
    [sym_binary_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2762),
    [sym_regex] = STATE(2762),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2762),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2762),
    [sym_internal_module] = STATE(2762),
    [sym_jsx_self_closing_element] = STATE(2762),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6072),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6072),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6072),
    [sym_number] = ACTIONS(6074),
    [sym_true] = ACTIONS(6072),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6072),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2634] = {
    [sym_class] = STATE(2754),
    [sym_arrow_function] = STATE(2754),
    [sym_await_expression] = STATE(2754),
    [sym_member_expression] = STATE(2792),
    [sym_statement_block] = STATE(1388),
    [sym_update_expression] = STATE(2754),
    [sym_meta_property] = STATE(2754),
    [sym__expression] = STATE(2754),
    [sym_jsx_element] = STATE(2754),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2754),
    [sym_call_expression] = STATE(2754),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2754),
    [sym_string] = STATE(2754),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2754),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2754),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2754),
    [sym_generator_function] = STATE(2754),
    [sym_new_expression] = STATE(2754),
    [sym_assignment_expression] = STATE(2754),
    [sym_augmented_assignment_expression] = STATE(2754),
    [sym_binary_expression] = STATE(2754),
    [sym_unary_expression] = STATE(2754),
    [sym_regex] = STATE(2754),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2754),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2754),
    [sym_internal_module] = STATE(2754),
    [sym_jsx_self_closing_element] = STATE(2754),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6076),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6076),
    [sym_number] = ACTIONS(6078),
    [sym_true] = ACTIONS(6076),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6076),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2635] = {
    [sym_class] = STATE(2763),
    [sym_arrow_function] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2763),
    [sym_meta_property] = STATE(2763),
    [sym__expression] = STATE(2763),
    [sym_jsx_element] = STATE(2763),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2763),
    [sym_call_expression] = STATE(2763),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2763),
    [sym_string] = STATE(2763),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2763),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2763),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2763),
    [sym_generator_function] = STATE(2763),
    [sym_new_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_augmented_assignment_expression] = STATE(2763),
    [sym_binary_expression] = STATE(2763),
    [sym_unary_expression] = STATE(2763),
    [sym_regex] = STATE(2763),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2763),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2763),
    [sym_internal_module] = STATE(2763),
    [sym_jsx_self_closing_element] = STATE(2763),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6080),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6080),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6080),
    [sym_number] = ACTIONS(6082),
    [sym_true] = ACTIONS(6080),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6080),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2636] = {
    [sym_class] = STATE(2764),
    [sym_arrow_function] = STATE(2764),
    [sym_await_expression] = STATE(2764),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2764),
    [sym_meta_property] = STATE(2764),
    [sym__expression] = STATE(2764),
    [sym_jsx_element] = STATE(2764),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2764),
    [sym_call_expression] = STATE(2764),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2764),
    [sym_string] = STATE(2764),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2764),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2764),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2764),
    [sym_generator_function] = STATE(2764),
    [sym_new_expression] = STATE(2764),
    [sym_assignment_expression] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(2764),
    [sym_binary_expression] = STATE(2764),
    [sym_unary_expression] = STATE(2764),
    [sym_regex] = STATE(2764),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2764),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2764),
    [sym_internal_module] = STATE(2764),
    [sym_jsx_self_closing_element] = STATE(2764),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6084),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6084),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6084),
    [sym_number] = ACTIONS(6086),
    [sym_true] = ACTIONS(6084),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6084),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2637] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_AMP_EQ] = ACTIONS(5638),
    [anon_sym_PLUS_EQ] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5638),
    [anon_sym_STAR_EQ] = ACTIONS(5638),
    [anon_sym_PIPE_EQ] = ACTIONS(5638),
    [anon_sym_DASH_EQ] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2638] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2639] = {
    [sym_class] = STATE(2778),
    [sym_arrow_function] = STATE(2778),
    [sym_await_expression] = STATE(2778),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2778),
    [sym_meta_property] = STATE(2778),
    [sym__expression] = STATE(2778),
    [sym_jsx_element] = STATE(2778),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2778),
    [sym_call_expression] = STATE(2778),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2778),
    [sym_string] = STATE(2778),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2778),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2778),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2778),
    [sym_generator_function] = STATE(2778),
    [sym_new_expression] = STATE(2778),
    [sym_assignment_expression] = STATE(2778),
    [sym_augmented_assignment_expression] = STATE(2778),
    [sym_binary_expression] = STATE(2778),
    [sym_unary_expression] = STATE(2778),
    [sym_regex] = STATE(2778),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2778),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2778),
    [sym_internal_module] = STATE(2778),
    [sym_jsx_self_closing_element] = STATE(2778),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5907),
    [anon_sym_yield] = ACTIONS(5923),
    [sym_true] = ACTIONS(5907),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6026),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5907),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5907),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(5921),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5907),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(5903),
  },
  [2640] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2667),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(6088),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_symbol] = ACTIONS(6090),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_void] = ACTIONS(6090),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_private] = ACTIONS(6090),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_static] = ACTIONS(6090),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_get] = ACTIONS(6090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(6090),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(6090),
    [anon_sym_type] = ACTIONS(6090),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6026),
    [anon_sym_namespace] = ACTIONS(6090),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(6090),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_number] = ACTIONS(6090),
    [anon_sym_declare] = ACTIONS(6090),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(6090),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_boolean] = ACTIONS(6090),
    [anon_sym_async] = ACTIONS(6090),
    [anon_sym_public] = ACTIONS(6090),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_string] = ACTIONS(6090),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(6090),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2641] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2642] = {
    [sym_class] = STATE(2765),
    [sym_arrow_function] = STATE(2765),
    [sym_await_expression] = STATE(2765),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2765),
    [sym_meta_property] = STATE(2765),
    [sym__expression] = STATE(2765),
    [sym_jsx_element] = STATE(2765),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2765),
    [sym_call_expression] = STATE(2765),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2765),
    [sym_string] = STATE(2765),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2765),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2765),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2765),
    [sym_generator_function] = STATE(2765),
    [sym_new_expression] = STATE(2765),
    [sym_assignment_expression] = STATE(2765),
    [sym_augmented_assignment_expression] = STATE(2765),
    [sym_binary_expression] = STATE(2765),
    [sym_unary_expression] = STATE(2765),
    [sym_regex] = STATE(2765),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2765),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2765),
    [sym_internal_module] = STATE(2765),
    [sym_jsx_self_closing_element] = STATE(2765),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6092),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6092),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6092),
    [sym_number] = ACTIONS(6094),
    [sym_true] = ACTIONS(6092),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6092),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2643] = {
    [sym_arguments] = STATE(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_STAR_STAR] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1294),
  },
  [2644] = {
    [sym_arguments] = STATE(1446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1300),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
  },
  [2645] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1446),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2667),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(6088),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(6090),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(6090),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(6090),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(6090),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(6090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_protected] = ACTIONS(6090),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(6090),
    [anon_sym_type] = ACTIONS(6090),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(6090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(6090),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(6090),
    [anon_sym_declare] = ACTIONS(6090),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(6090),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(6090),
    [anon_sym_async] = ACTIONS(6090),
    [anon_sym_public] = ACTIONS(6090),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(6090),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(6090),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
  },
  [2646] = {
    [sym_nested_identifier] = STATE(1727),
    [sym_arguments] = STATE(1446),
    [sym_string] = STATE(1728),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1300),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1304),
  },
  [2647] = {
    [sym_class] = STATE(2766),
    [sym_arrow_function] = STATE(2766),
    [sym_await_expression] = STATE(2766),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2766),
    [sym_meta_property] = STATE(2766),
    [sym__expression] = STATE(2766),
    [sym_jsx_element] = STATE(2766),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2766),
    [sym_call_expression] = STATE(2766),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2766),
    [sym_string] = STATE(2766),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2766),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2766),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2766),
    [sym_generator_function] = STATE(2766),
    [sym_new_expression] = STATE(2766),
    [sym_assignment_expression] = STATE(2766),
    [sym_augmented_assignment_expression] = STATE(2766),
    [sym_binary_expression] = STATE(2766),
    [sym_unary_expression] = STATE(2766),
    [sym_regex] = STATE(2766),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2766),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2766),
    [sym_internal_module] = STATE(2766),
    [sym_jsx_self_closing_element] = STATE(2766),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6096),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6096),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6096),
    [sym_number] = ACTIONS(6098),
    [sym_true] = ACTIONS(6096),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6096),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2648] = {
    [sym_class] = STATE(2767),
    [sym_arrow_function] = STATE(2767),
    [sym_await_expression] = STATE(2767),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2767),
    [sym_meta_property] = STATE(2767),
    [sym__expression] = STATE(2767),
    [sym_jsx_element] = STATE(2767),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2767),
    [sym_call_expression] = STATE(2767),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2767),
    [sym_string] = STATE(2767),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2767),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2767),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2767),
    [sym_generator_function] = STATE(2767),
    [sym_new_expression] = STATE(2767),
    [sym_assignment_expression] = STATE(2767),
    [sym_augmented_assignment_expression] = STATE(2767),
    [sym_binary_expression] = STATE(2767),
    [sym_unary_expression] = STATE(2767),
    [sym_regex] = STATE(2767),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2767),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2767),
    [sym_internal_module] = STATE(2767),
    [sym_jsx_self_closing_element] = STATE(2767),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6100),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6100),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6100),
    [sym_number] = ACTIONS(6102),
    [sym_true] = ACTIONS(6100),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6100),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2649] = {
    [sym_class] = STATE(2768),
    [sym_arrow_function] = STATE(2768),
    [sym_await_expression] = STATE(2768),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2768),
    [sym_meta_property] = STATE(2768),
    [sym__expression] = STATE(2768),
    [sym_jsx_element] = STATE(2768),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2768),
    [sym_call_expression] = STATE(2768),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2768),
    [sym_string] = STATE(2768),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2768),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2768),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2768),
    [sym_generator_function] = STATE(2768),
    [sym_new_expression] = STATE(2768),
    [sym_assignment_expression] = STATE(2768),
    [sym_augmented_assignment_expression] = STATE(2768),
    [sym_binary_expression] = STATE(2768),
    [sym_unary_expression] = STATE(2768),
    [sym_regex] = STATE(2768),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2768),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2768),
    [sym_internal_module] = STATE(2768),
    [sym_jsx_self_closing_element] = STATE(2768),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6104),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6104),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6104),
    [sym_number] = ACTIONS(6106),
    [sym_true] = ACTIONS(6104),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6104),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2650] = {
    [sym_class] = STATE(2769),
    [sym_arrow_function] = STATE(2769),
    [sym_await_expression] = STATE(2769),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2769),
    [sym_meta_property] = STATE(2769),
    [sym__expression] = STATE(2769),
    [sym_jsx_element] = STATE(2769),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2769),
    [sym_call_expression] = STATE(2769),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2769),
    [sym_string] = STATE(2769),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2769),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2769),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2769),
    [sym_generator_function] = STATE(2769),
    [sym_new_expression] = STATE(2769),
    [sym_assignment_expression] = STATE(2769),
    [sym_augmented_assignment_expression] = STATE(2769),
    [sym_binary_expression] = STATE(2769),
    [sym_unary_expression] = STATE(2769),
    [sym_regex] = STATE(2769),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2769),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2769),
    [sym_internal_module] = STATE(2769),
    [sym_jsx_self_closing_element] = STATE(2769),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6108),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6108),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6108),
    [sym_number] = ACTIONS(6110),
    [sym_true] = ACTIONS(6108),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6108),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2651] = {
    [sym_class] = STATE(2770),
    [sym_arrow_function] = STATE(2770),
    [sym_await_expression] = STATE(2770),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2770),
    [sym_meta_property] = STATE(2770),
    [sym__expression] = STATE(2770),
    [sym_jsx_element] = STATE(2770),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2770),
    [sym_call_expression] = STATE(2770),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2770),
    [sym_string] = STATE(2770),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2770),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2770),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2770),
    [sym_generator_function] = STATE(2770),
    [sym_new_expression] = STATE(2770),
    [sym_assignment_expression] = STATE(2770),
    [sym_augmented_assignment_expression] = STATE(2770),
    [sym_binary_expression] = STATE(2770),
    [sym_unary_expression] = STATE(2770),
    [sym_regex] = STATE(2770),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2770),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2770),
    [sym_internal_module] = STATE(2770),
    [sym_jsx_self_closing_element] = STATE(2770),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6112),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6112),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6112),
    [sym_number] = ACTIONS(6114),
    [sym_true] = ACTIONS(6112),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6112),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2652] = {
    [sym_class] = STATE(2771),
    [sym_arrow_function] = STATE(2771),
    [sym_await_expression] = STATE(2771),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2771),
    [sym_meta_property] = STATE(2771),
    [sym__expression] = STATE(2771),
    [sym_jsx_element] = STATE(2771),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2771),
    [sym_call_expression] = STATE(2771),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2771),
    [sym_string] = STATE(2771),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2771),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2771),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2771),
    [sym_generator_function] = STATE(2771),
    [sym_new_expression] = STATE(2771),
    [sym_assignment_expression] = STATE(2771),
    [sym_augmented_assignment_expression] = STATE(2771),
    [sym_binary_expression] = STATE(2771),
    [sym_unary_expression] = STATE(2771),
    [sym_regex] = STATE(2771),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2771),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2771),
    [sym_internal_module] = STATE(2771),
    [sym_jsx_self_closing_element] = STATE(2771),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6116),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6116),
    [sym_number] = ACTIONS(6118),
    [sym_true] = ACTIONS(6116),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6116),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2653] = {
    [sym_class] = STATE(2772),
    [sym_arrow_function] = STATE(2772),
    [sym_await_expression] = STATE(2772),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2772),
    [sym_meta_property] = STATE(2772),
    [sym__expression] = STATE(2772),
    [sym_jsx_element] = STATE(2772),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2772),
    [sym_call_expression] = STATE(2772),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2772),
    [sym_string] = STATE(2772),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2772),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2772),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2772),
    [sym_generator_function] = STATE(2772),
    [sym_new_expression] = STATE(2772),
    [sym_assignment_expression] = STATE(2772),
    [sym_augmented_assignment_expression] = STATE(2772),
    [sym_binary_expression] = STATE(2772),
    [sym_unary_expression] = STATE(2772),
    [sym_regex] = STATE(2772),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2772),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2772),
    [sym_internal_module] = STATE(2772),
    [sym_jsx_self_closing_element] = STATE(2772),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6120),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6120),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6120),
    [sym_number] = ACTIONS(6122),
    [sym_true] = ACTIONS(6120),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6120),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2654] = {
    [sym_class] = STATE(2755),
    [sym_arrow_function] = STATE(2755),
    [sym_await_expression] = STATE(2755),
    [sym_member_expression] = STATE(2792),
    [sym_statement_block] = STATE(1472),
    [sym_update_expression] = STATE(2755),
    [sym_meta_property] = STATE(2755),
    [sym__expression] = STATE(2755),
    [sym_jsx_element] = STATE(2755),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2755),
    [sym_call_expression] = STATE(2755),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2755),
    [sym_string] = STATE(2755),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2755),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2755),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2755),
    [sym_generator_function] = STATE(2755),
    [sym_new_expression] = STATE(2755),
    [sym_assignment_expression] = STATE(2755),
    [sym_augmented_assignment_expression] = STATE(2755),
    [sym_binary_expression] = STATE(2755),
    [sym_unary_expression] = STATE(2755),
    [sym_regex] = STATE(2755),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2755),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2755),
    [sym_internal_module] = STATE(2755),
    [sym_jsx_self_closing_element] = STATE(2755),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6124),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6124),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6124),
    [sym_number] = ACTIONS(6126),
    [sym_true] = ACTIONS(6124),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6124),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2655] = {
    [sym_class] = STATE(2773),
    [sym_arrow_function] = STATE(2773),
    [sym_await_expression] = STATE(2773),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2773),
    [sym_meta_property] = STATE(2773),
    [sym__expression] = STATE(2773),
    [sym_jsx_element] = STATE(2773),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2773),
    [sym_call_expression] = STATE(2773),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2773),
    [sym_string] = STATE(2773),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2773),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2773),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2773),
    [sym_generator_function] = STATE(2773),
    [sym_new_expression] = STATE(2773),
    [sym_assignment_expression] = STATE(2773),
    [sym_augmented_assignment_expression] = STATE(2773),
    [sym_binary_expression] = STATE(2773),
    [sym_unary_expression] = STATE(2773),
    [sym_regex] = STATE(2773),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2773),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2773),
    [sym_internal_module] = STATE(2773),
    [sym_jsx_self_closing_element] = STATE(2773),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6128),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6128),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6128),
    [sym_number] = ACTIONS(6130),
    [sym_true] = ACTIONS(6128),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6128),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2656] = {
    [sym_class] = STATE(2756),
    [sym_arrow_function] = STATE(2756),
    [sym_await_expression] = STATE(2756),
    [sym_member_expression] = STATE(2792),
    [sym_statement_block] = STATE(1518),
    [sym_update_expression] = STATE(2756),
    [sym_meta_property] = STATE(2756),
    [sym__expression] = STATE(2756),
    [sym_jsx_element] = STATE(2756),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2756),
    [sym_call_expression] = STATE(2756),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2756),
    [sym_string] = STATE(2756),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2756),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2756),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2756),
    [sym_generator_function] = STATE(2756),
    [sym_new_expression] = STATE(2756),
    [sym_assignment_expression] = STATE(2756),
    [sym_augmented_assignment_expression] = STATE(2756),
    [sym_binary_expression] = STATE(2756),
    [sym_unary_expression] = STATE(2756),
    [sym_regex] = STATE(2756),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2756),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2756),
    [sym_internal_module] = STATE(2756),
    [sym_jsx_self_closing_element] = STATE(2756),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6132),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6132),
    [sym_number] = ACTIONS(6134),
    [sym_true] = ACTIONS(6132),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6132),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2657] = {
    [sym_class] = STATE(2757),
    [sym_arrow_function] = STATE(2757),
    [sym_await_expression] = STATE(2757),
    [sym_member_expression] = STATE(2792),
    [sym_statement_block] = STATE(1520),
    [sym_update_expression] = STATE(2757),
    [sym_meta_property] = STATE(2757),
    [sym__expression] = STATE(2757),
    [sym_jsx_element] = STATE(2757),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2757),
    [sym_call_expression] = STATE(2757),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2757),
    [sym_string] = STATE(2757),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2757),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2757),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2757),
    [sym_generator_function] = STATE(2757),
    [sym_new_expression] = STATE(2757),
    [sym_assignment_expression] = STATE(2757),
    [sym_augmented_assignment_expression] = STATE(2757),
    [sym_binary_expression] = STATE(2757),
    [sym_unary_expression] = STATE(2757),
    [sym_regex] = STATE(2757),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2757),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2757),
    [sym_internal_module] = STATE(2757),
    [sym_jsx_self_closing_element] = STATE(2757),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6136),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6136),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6136),
    [sym_number] = ACTIONS(6138),
    [sym_true] = ACTIONS(6136),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6136),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2658] = {
    [sym_class] = STATE(2758),
    [sym_arrow_function] = STATE(2758),
    [sym_await_expression] = STATE(2758),
    [sym_member_expression] = STATE(2792),
    [sym_statement_block] = STATE(1523),
    [sym_update_expression] = STATE(2758),
    [sym_meta_property] = STATE(2758),
    [sym__expression] = STATE(2758),
    [sym_jsx_element] = STATE(2758),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2758),
    [sym_call_expression] = STATE(2758),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2758),
    [sym_string] = STATE(2758),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2758),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2758),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2758),
    [sym_generator_function] = STATE(2758),
    [sym_new_expression] = STATE(2758),
    [sym_assignment_expression] = STATE(2758),
    [sym_augmented_assignment_expression] = STATE(2758),
    [sym_binary_expression] = STATE(2758),
    [sym_unary_expression] = STATE(2758),
    [sym_regex] = STATE(2758),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2758),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2758),
    [sym_internal_module] = STATE(2758),
    [sym_jsx_self_closing_element] = STATE(2758),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6140),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6140),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6140),
    [sym_number] = ACTIONS(6142),
    [sym_true] = ACTIONS(6140),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6140),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2659] = {
    [sym_class] = STATE(2778),
    [sym_arrow_function] = STATE(2778),
    [sym_await_expression] = STATE(2778),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2778),
    [sym_meta_property] = STATE(2778),
    [sym__expression] = STATE(2778),
    [sym_jsx_element] = STATE(2778),
    [sym_nested_identifier] = STATE(629),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2778),
    [sym_call_expression] = STATE(2778),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2778),
    [sym_string] = STATE(2778),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2778),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2778),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2778),
    [sym_generator_function] = STATE(2778),
    [sym_new_expression] = STATE(2778),
    [sym_assignment_expression] = STATE(2778),
    [sym_augmented_assignment_expression] = STATE(2778),
    [sym_binary_expression] = STATE(2778),
    [sym_unary_expression] = STATE(2778),
    [sym_regex] = STATE(2778),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2778),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2778),
    [sym_internal_module] = STATE(2778),
    [sym_jsx_self_closing_element] = STATE(2778),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(6144),
    [sym_false] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5907),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(5907),
    [sym_number] = ACTIONS(5921),
    [sym_true] = ACTIONS(5907),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(5907),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2660] = {
    [sym_class] = STATE(2777),
    [sym_arrow_function] = STATE(2777),
    [sym_await_expression] = STATE(2777),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2777),
    [sym_meta_property] = STATE(2777),
    [sym__expression] = STATE(2777),
    [sym_jsx_element] = STATE(2777),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2777),
    [sym_string] = STATE(2777),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2777),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2777),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2777),
    [sym_generator_function] = STATE(2777),
    [sym_new_expression] = STATE(2777),
    [sym_assignment_expression] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_regex] = STATE(2777),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2777),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2777),
    [sym_internal_module] = STATE(2777),
    [sym_jsx_self_closing_element] = STATE(2777),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6146),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6146),
    [sym_number] = ACTIONS(4564),
    [sym_true] = ACTIONS(6146),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6146),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2661] = {
    [sym_class] = STATE(2774),
    [sym_arrow_function] = STATE(2774),
    [sym_await_expression] = STATE(2774),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2774),
    [sym_meta_property] = STATE(2774),
    [sym__expression] = STATE(2774),
    [sym_jsx_element] = STATE(2774),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2774),
    [sym_call_expression] = STATE(2774),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2774),
    [sym_string] = STATE(2774),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2774),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2774),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2774),
    [sym_generator_function] = STATE(2774),
    [sym_new_expression] = STATE(2774),
    [sym_assignment_expression] = STATE(2774),
    [sym_augmented_assignment_expression] = STATE(2774),
    [sym_binary_expression] = STATE(2774),
    [sym_unary_expression] = STATE(2774),
    [sym_regex] = STATE(2774),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2774),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2774),
    [sym_internal_module] = STATE(2774),
    [sym_jsx_self_closing_element] = STATE(2774),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6148),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6148),
    [sym_number] = ACTIONS(6150),
    [sym_true] = ACTIONS(6148),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6148),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2662] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_AMP_EQ] = ACTIONS(5638),
    [anon_sym_PLUS_EQ] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(2781),
    [anon_sym_CARET_EQ] = ACTIONS(5638),
    [anon_sym_STAR_EQ] = ACTIONS(5638),
    [anon_sym_PIPE_EQ] = ACTIONS(5638),
    [anon_sym_DASH_EQ] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(4594),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2663] = {
    [sym_class] = STATE(2777),
    [sym_arrow_function] = STATE(2777),
    [sym_await_expression] = STATE(2777),
    [sym_member_expression] = STATE(2792),
    [sym_update_expression] = STATE(2777),
    [sym_meta_property] = STATE(2777),
    [sym__expression] = STATE(2777),
    [sym_jsx_element] = STATE(2777),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2777),
    [sym_string] = STATE(2777),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2777),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2777),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2777),
    [sym_generator_function] = STATE(2777),
    [sym_new_expression] = STATE(2777),
    [sym_assignment_expression] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_regex] = STATE(2777),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2777),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2777),
    [sym_internal_module] = STATE(2777),
    [sym_jsx_self_closing_element] = STATE(2777),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(5905),
    [sym_false] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6146),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6146),
    [sym_number] = ACTIONS(6152),
    [sym_true] = ACTIONS(6146),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6146),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2664] = {
    [anon_sym_EQ_GT] = ACTIONS(6154),
    [sym_comment] = ACTIONS(3),
  },
  [2665] = {
    [anon_sym_EQ_GT] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
  },
  [2666] = {
    [anon_sym_EQ_GT] = ACTIONS(6158),
    [sym_comment] = ACTIONS(3),
  },
  [2667] = {
    [anon_sym_EQ_GT] = ACTIONS(6160),
    [sym_comment] = ACTIONS(3),
  },
  [2668] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2669] = {
    [sym_generic_type] = STATE(342),
    [sym_type_predicate] = STATE(342),
    [sym_literal_type] = STATE(342),
    [sym__number] = STATE(328),
    [sym_object_type] = STATE(342),
    [sym_intersection_type] = STATE(2289),
    [sym_function_type] = STATE(2289),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(344),
    [sym__type] = STATE(2289),
    [sym_type_query] = STATE(342),
    [sym_index_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(328),
    [sym_type_parameters] = STATE(346),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(341),
    [sym_constructor_type] = STATE(2289),
    [sym__primary_type] = STATE(342),
    [sym_lookup_type] = STATE(342),
    [sym_parenthesized_type] = STATE(342),
    [sym_predefined_type] = STATE(342),
    [sym_tuple_type] = STATE(342),
    [sym_union_type] = STATE(2289),
    [sym_identifier] = ACTIONS(734),
    [sym_false] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(740),
    [anon_sym_number] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(742),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_void] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(740),
    [anon_sym_boolean] = ACTIONS(740),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [sym_this] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_true] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2670] = {
    [sym_class] = STATE(2668),
    [sym_arrow_function] = STATE(2668),
    [sym_await_expression] = STATE(2668),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2668),
    [sym_meta_property] = STATE(2668),
    [sym__expression] = STATE(2668),
    [sym_jsx_element] = STATE(2668),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2668),
    [sym_call_expression] = STATE(2668),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2668),
    [sym_string] = STATE(2668),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2668),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2668),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2668),
    [sym_generator_function] = STATE(2668),
    [sym_new_expression] = STATE(2668),
    [sym_assignment_expression] = STATE(2668),
    [sym_augmented_assignment_expression] = STATE(2668),
    [sym_binary_expression] = STATE(2668),
    [sym_unary_expression] = STATE(2668),
    [sym_regex] = STATE(2668),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2668),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2668),
    [sym_internal_module] = STATE(2668),
    [sym_jsx_self_closing_element] = STATE(2668),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(1316),
    [sym_false] = ACTIONS(6164),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6164),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6164),
    [sym_number] = ACTIONS(6166),
    [sym_true] = ACTIONS(6164),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6164),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2671] = {
    [sym_formal_parameters] = STATE(2293),
    [sym_type_parameters] = STATE(2673),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2672] = {
    [sym_formal_parameters] = STATE(2296),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2673] = {
    [sym_formal_parameters] = STATE(2298),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2674] = {
    [sym_decorator_member_expression] = STATE(2342),
    [sym_decorator_call_expression] = STATE(81),
    [sym_identifier] = ACTIONS(6168),
    [anon_sym_module] = ACTIONS(6170),
    [anon_sym_symbol] = ACTIONS(6170),
    [anon_sym_number] = ACTIONS(6170),
    [anon_sym_declare] = ACTIONS(6170),
    [anon_sym_void] = ACTIONS(6170),
    [anon_sym_any] = ACTIONS(6170),
    [anon_sym_private] = ACTIONS(6170),
    [anon_sym_boolean] = ACTIONS(6170),
    [anon_sym_async] = ACTIONS(6170),
    [anon_sym_public] = ACTIONS(6170),
    [anon_sym_get] = ACTIONS(6170),
    [anon_sym_static] = ACTIONS(6170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(6170),
    [anon_sym_string] = ACTIONS(6170),
    [anon_sym_set] = ACTIONS(6170),
    [anon_sym_type] = ACTIONS(6170),
    [anon_sym_export] = ACTIONS(6170),
    [anon_sym_namespace] = ACTIONS(6170),
  },
  [2675] = {
    [sym_class] = STATE(2349),
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym__expression] = STATE(2349),
    [sym_jsx_element] = STATE(2349),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2349),
    [sym_string] = STATE(2349),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2349),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2349),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_new_expression] = STATE(2349),
    [sym_assignment_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2349),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2349),
    [sym_internal_module] = STATE(2349),
    [sym_jsx_self_closing_element] = STATE(2349),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5676),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(5676),
    [sym_number] = ACTIONS(6172),
    [sym_true] = ACTIONS(5676),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5676),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2676] = {
    [sym_class] = STATE(2351),
    [sym_arrow_function] = STATE(2351),
    [sym_await_expression] = STATE(2351),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2351),
    [sym_meta_property] = STATE(2351),
    [sym__expression] = STATE(2351),
    [sym_jsx_element] = STATE(2351),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2351),
    [sym_call_expression] = STATE(2351),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2351),
    [sym_string] = STATE(2351),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2351),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2351),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2351),
    [sym_generator_function] = STATE(2351),
    [sym_new_expression] = STATE(2351),
    [sym_assignment_expression] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(2351),
    [sym_binary_expression] = STATE(2351),
    [sym_unary_expression] = STATE(2351),
    [sym_regex] = STATE(2351),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2351),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2351),
    [sym_internal_module] = STATE(2351),
    [sym_jsx_self_closing_element] = STATE(2351),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(4751),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4751),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(4751),
    [sym_number] = ACTIONS(4755),
    [sym_true] = ACTIONS(4751),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4751),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2677] = {
    [sym_class] = STATE(113),
    [sym_arrow_function] = STATE(113),
    [sym_await_expression] = STATE(113),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(113),
    [sym_meta_property] = STATE(113),
    [sym__expression] = STATE(113),
    [sym_jsx_element] = STATE(113),
    [sym_function] = STATE(52),
    [sym_import] = STATE(113),
    [sym_call_expression] = STATE(113),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(113),
    [sym_string] = STATE(113),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(113),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(113),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(113),
    [sym_generator_function] = STATE(113),
    [sym_new_expression] = STATE(113),
    [sym_assignment_expression] = STATE(113),
    [sym_augmented_assignment_expression] = STATE(113),
    [sym_binary_expression] = STATE(113),
    [sym_unary_expression] = STATE(113),
    [sym_regex] = STATE(113),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(113),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(113),
    [sym_internal_module] = STATE(113),
    [sym_jsx_self_closing_element] = STATE(113),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(207),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_true] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(207),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2678] = {
    [sym_class] = STATE(2357),
    [sym_arrow_function] = STATE(2357),
    [sym_await_expression] = STATE(2357),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2357),
    [sym_meta_property] = STATE(2357),
    [sym__expression] = STATE(2357),
    [sym_jsx_element] = STATE(2357),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2357),
    [sym_call_expression] = STATE(2357),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2357),
    [sym_string] = STATE(2357),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2357),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2357),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2357),
    [sym_generator_function] = STATE(2357),
    [sym_new_expression] = STATE(2357),
    [sym_assignment_expression] = STATE(2357),
    [sym_augmented_assignment_expression] = STATE(2357),
    [sym_binary_expression] = STATE(2357),
    [sym_unary_expression] = STATE(2357),
    [sym_regex] = STATE(2357),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2357),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2357),
    [sym_internal_module] = STATE(2357),
    [sym_jsx_self_closing_element] = STATE(2357),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(6174),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(6176),
    [anon_sym_yield] = ACTIONS(1372),
    [sym_true] = ACTIONS(6176),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(6176),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(6176),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(6178),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(6176),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(1384),
  },
  [2679] = {
    [anon_sym_class] = ACTIONS(6180),
    [sym_comment] = ACTIONS(3),
  },
  [2680] = {
    [sym_class] = STATE(2361),
    [sym_arrow_function] = STATE(2361),
    [sym_await_expression] = STATE(2361),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2361),
    [sym_meta_property] = STATE(2361),
    [sym__expression] = STATE(2361),
    [sym_jsx_element] = STATE(2361),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2361),
    [sym_call_expression] = STATE(2361),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2361),
    [sym_string] = STATE(2361),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2361),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2361),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2361),
    [sym_generator_function] = STATE(2361),
    [sym_new_expression] = STATE(2361),
    [sym_assignment_expression] = STATE(2361),
    [sym_augmented_assignment_expression] = STATE(2361),
    [sym_binary_expression] = STATE(2361),
    [sym_unary_expression] = STATE(2361),
    [sym_regex] = STATE(2361),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2361),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2361),
    [sym_internal_module] = STATE(2361),
    [sym_jsx_self_closing_element] = STATE(2361),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(6182),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(6182),
    [sym_number] = ACTIONS(6184),
    [sym_true] = ACTIONS(6182),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(6182),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2681] = {
    [sym_nested_identifier] = STATE(2369),
    [sym_type_parameter] = STATE(224),
    [sym_jsx_namespace_name] = STATE(2370),
    [anon_sym_GT] = ACTIONS(6186),
    [sym_identifier] = ACTIONS(6188),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(6190),
  },
  [2682] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(230),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
  },
  [2683] = {
    [sym_class] = STATE(232),
    [sym_arrow_function] = STATE(232),
    [sym_await_expression] = STATE(239),
    [sym_member_expression] = STATE(238),
    [sym_update_expression] = STATE(239),
    [sym_meta_property] = STATE(232),
    [sym__expression] = STATE(239),
    [sym_jsx_element] = STATE(239),
    [sym_function] = STATE(240),
    [sym_import] = STATE(232),
    [sym_call_expression] = STATE(239),
    [sym_subscript_expression] = STATE(238),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(239),
    [sym_string] = STATE(232),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(232),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(239),
    [sym_object] = STATE(241),
    [sym_jsx_fragment] = STATE(239),
    [sym_generator_function] = STATE(232),
    [sym_new_expression] = STATE(232),
    [sym_assignment_expression] = STATE(239),
    [sym_augmented_assignment_expression] = STATE(239),
    [sym_binary_expression] = STATE(239),
    [sym_unary_expression] = STATE(239),
    [sym_regex] = STATE(232),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(238),
    [sym_non_null_expression] = STATE(239),
    [sym_array] = STATE(242),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(239),
    [sym_internal_module] = STATE(239),
    [sym_jsx_self_closing_element] = STATE(239),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_identifier] = ACTIONS(5678),
    [sym_false] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(5680),
    [anon_sym_symbol] = ACTIONS(5680),
    [anon_sym_number] = ACTIONS(5680),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(5680),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(485),
    [sym_super] = ACTIONS(479),
    [anon_sym_any] = ACTIONS(5680),
    [anon_sym_private] = ACTIONS(5680),
    [anon_sym_boolean] = ACTIONS(5680),
    [anon_sym_static] = ACTIONS(5680),
    [anon_sym_public] = ACTIONS(5680),
    [anon_sym_get] = ACTIONS(5680),
    [anon_sym_async] = ACTIONS(5684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_number] = ACTIONS(497),
    [sym_true] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5680),
    [anon_sym_string] = ACTIONS(5680),
    [anon_sym_function] = ACTIONS(167),
    [anon_sym_DOT] = ACTIONS(489),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_set] = ACTIONS(5680),
    [anon_sym_type] = ACTIONS(5680),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(5680),
    [anon_sym_namespace] = ACTIONS(5686),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2684] = {
    [sym_class] = STATE(2380),
    [sym_arrow_function] = STATE(2380),
    [sym_await_expression] = STATE(2380),
    [sym_member_expression] = STATE(2685),
    [sym_update_expression] = STATE(2380),
    [sym_meta_property] = STATE(2380),
    [sym__expression] = STATE(2380),
    [sym_jsx_element] = STATE(2380),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2380),
    [sym_call_expression] = STATE(2380),
    [sym_subscript_expression] = STATE(2685),
    [sym__call_signature] = STATE(2687),
    [sym_ternary_expression] = STATE(2380),
    [sym_string] = STATE(2380),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2380),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2380),
    [sym_object] = STATE(2688),
    [sym_jsx_fragment] = STATE(2380),
    [sym_generator_function] = STATE(2380),
    [sym_new_expression] = STATE(2380),
    [sym_assignment_expression] = STATE(2380),
    [sym_augmented_assignment_expression] = STATE(2380),
    [sym_binary_expression] = STATE(2380),
    [sym_unary_expression] = STATE(2380),
    [sym_regex] = STATE(2380),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2685),
    [sym_non_null_expression] = STATE(2380),
    [sym_array] = STATE(2686),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(2380),
    [sym_internal_module] = STATE(2380),
    [sym_jsx_self_closing_element] = STATE(2380),
    [anon_sym_await] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1358),
    [sym_false] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(6196),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [sym_this] = ACTIONS(6196),
    [sym_number] = ACTIONS(6198),
    [sym_true] = ACTIONS(6196),
    [anon_sym_yield] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(6196),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1376),
  },
  [2685] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_AMP_EQ] = ACTIONS(4737),
    [anon_sym_PLUS_EQ] = ACTIONS(4737),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4739),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4737),
    [anon_sym_STAR_EQ] = ACTIONS(4737),
    [anon_sym_PIPE_EQ] = ACTIONS(4737),
    [anon_sym_DASH_EQ] = ACTIONS(4737),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4737),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT_EQ] = ACTIONS(4737),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4737),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2686] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2687] = {
    [anon_sym_EQ_GT] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
  },
  [2688] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2689] = {
    [sym_identifier] = ACTIONS(6206),
    [sym_comment] = ACTIONS(3),
  },
  [2690] = {
    [sym_type_parameters] = STATE(2707),
    [anon_sym_EQ] = ACTIONS(6208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2691] = {
    [sym_class] = STATE(2408),
    [sym_arrow_function] = STATE(2408),
    [sym_await_expression] = STATE(2408),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2408),
    [sym_meta_property] = STATE(2408),
    [sym__expression] = STATE(2408),
    [sym_jsx_element] = STATE(2408),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2408),
    [sym_call_expression] = STATE(2408),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2408),
    [sym_string] = STATE(2408),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2408),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2408),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2408),
    [sym_generator_function] = STATE(2408),
    [sym_new_expression] = STATE(2408),
    [sym_assignment_expression] = STATE(2408),
    [sym_augmented_assignment_expression] = STATE(2408),
    [sym_binary_expression] = STATE(2408),
    [sym_unary_expression] = STATE(2408),
    [sym_regex] = STATE(2408),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2408),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2408),
    [sym_internal_module] = STATE(2408),
    [sym_jsx_self_closing_element] = STATE(2408),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(1316),
    [sym_false] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6210),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6210),
    [sym_number] = ACTIONS(6212),
    [sym_true] = ACTIONS(6210),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6210),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2692] = {
    [sym_class] = STATE(2709),
    [sym_arrow_function] = STATE(2709),
    [sym_await_expression] = STATE(2709),
    [sym_member_expression] = STATE(2792),
    [sym_generic_type] = STATE(2802),
    [sym_update_expression] = STATE(2709),
    [sym_meta_property] = STATE(2709),
    [sym__expression] = STATE(2709),
    [sym_jsx_element] = STATE(2709),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2410),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2709),
    [sym_call_expression] = STATE(2709),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2709),
    [sym_string] = STATE(2709),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2709),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2709),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2709),
    [sym_generator_function] = STATE(2709),
    [sym_new_expression] = STATE(2709),
    [sym_assignment_expression] = STATE(2709),
    [sym_augmented_assignment_expression] = STATE(2709),
    [sym_binary_expression] = STATE(2709),
    [sym_unary_expression] = STATE(2709),
    [sym_regex] = STATE(2709),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2709),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2709),
    [sym_internal_module] = STATE(2709),
    [sym_jsx_self_closing_element] = STATE(2709),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(6214),
    [sym_false] = ACTIONS(6216),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6216),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6216),
    [sym_number] = ACTIONS(6218),
    [sym_true] = ACTIONS(6216),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6216),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2693] = {
    [sym_identifier] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6222),
    [sym_comment] = ACTIONS(3),
  },
  [2694] = {
    [sym_identifier] = ACTIONS(6224),
    [sym_comment] = ACTIONS(3),
  },
  [2695] = {
    [sym_identifier] = ACTIONS(6226),
    [sym_comment] = ACTIONS(3),
  },
  [2696] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(6228),
    [sym_comment] = ACTIONS(3),
  },
  [2697] = {
    [anon_sym_EQ_GT] = ACTIONS(6230),
    [sym_comment] = ACTIONS(3),
  },
  [2698] = {
    [anon_sym_EQ_GT] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
  },
  [2699] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(496),
    [sym_identifier] = ACTIONS(6234),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_STAR] = ACTIONS(6236),
    [sym_comment] = ACTIONS(3),
  },
  [2700] = {
    [anon_sym_EQ_GT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(3),
  },
  [2701] = {
    [sym_jsx_element] = STATE(2714),
    [sym_jsx_expression] = STATE(2714),
    [aux_sym_jsx_element_repeat1] = STATE(2714),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_self_closing_element] = STATE(2714),
    [sym_jsx_text] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6242),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2702] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(528),
    [sym_identifier] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2703] = {
    [anon_sym_namespace] = ACTIONS(6246),
    [sym_comment] = ACTIONS(3),
  },
  [2704] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(6248),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2705] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(2705),
    [anon_sym_LBRACK] = ACTIONS(1694),
    [sym_identifier] = ACTIONS(6250),
    [anon_sym_module] = ACTIONS(6250),
    [anon_sym_symbol] = ACTIONS(6250),
    [anon_sym_number] = ACTIONS(6250),
    [anon_sym_class] = ACTIONS(6250),
    [anon_sym_AT] = ACTIONS(6252),
    [anon_sym_declare] = ACTIONS(6250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1694),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_void] = ACTIONS(6250),
    [anon_sym_any] = ACTIONS(6250),
    [anon_sym_private] = ACTIONS(6250),
    [anon_sym_boolean] = ACTIONS(6250),
    [anon_sym_static] = ACTIONS(6250),
    [anon_sym_public] = ACTIONS(6250),
    [anon_sym_get] = ACTIONS(6250),
    [anon_sym_async] = ACTIONS(6250),
    [sym_this] = ACTIONS(6250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(6250),
    [anon_sym_string] = ACTIONS(6250),
    [anon_sym_set] = ACTIONS(6250),
    [anon_sym_type] = ACTIONS(6250),
    [anon_sym_export] = ACTIONS(6250),
    [sym_readonly] = ACTIONS(6250),
    [anon_sym_namespace] = ACTIONS(6250),
  },
  [2706] = {
    [anon_sym_EQ_GT] = ACTIONS(6255),
    [sym_comment] = ACTIONS(3),
  },
  [2707] = {
    [anon_sym_EQ] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
  },
  [2708] = {
    [sym_class] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_await_expression] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(51),
    [sym_sequence_expression] = STATE(57),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(2444),
    [sym_ternary_expression] = STATE(51),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(51),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(51),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(51),
    [sym_generator_function] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2444),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_non_null_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(89),
    [sym_true] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [2709] = {
    [sym_arguments] = STATE(1323),
    [aux_sym_extends_clause_repeat1] = STATE(2720),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2710] = {
    [sym_string] = STATE(2445),
    [sym__property_name] = STATE(2445),
    [sym_computed_property_name] = STATE(2445),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2711] = {
    [sym_identifier] = ACTIONS(6283),
    [anon_sym_STAR] = ACTIONS(6285),
    [sym_comment] = ACTIONS(3),
  },
  [2712] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2447),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2713] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(786),
    [sym_identifier] = ACTIONS(6287),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2714] = {
    [sym_jsx_element] = STATE(574),
    [sym_jsx_expression] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(6289),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2715] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1328),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1328),
    [anon_sym_QMARK] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6291),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2716] = {
    [anon_sym_EQ_GT] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
  },
  [2717] = {
    [anon_sym_EQ_GT] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
  },
  [2718] = {
    [sym_class] = STATE(2732),
    [sym_arrow_function] = STATE(2732),
    [sym_await_expression] = STATE(2732),
    [sym_member_expression] = STATE(2792),
    [sym_generic_type] = STATE(953),
    [sym_update_expression] = STATE(2732),
    [sym_meta_property] = STATE(2732),
    [sym__expression] = STATE(2732),
    [sym_jsx_element] = STATE(2732),
    [sym_nested_identifier] = STATE(343),
    [sym_nested_type_identifier] = STATE(2463),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2732),
    [sym_call_expression] = STATE(2732),
    [sym_subscript_expression] = STATE(2792),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(2732),
    [sym_string] = STATE(2732),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2732),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2732),
    [sym_object] = STATE(2794),
    [sym_jsx_fragment] = STATE(2732),
    [sym_generator_function] = STATE(2732),
    [sym_new_expression] = STATE(2732),
    [sym_assignment_expression] = STATE(2732),
    [sym_augmented_assignment_expression] = STATE(2732),
    [sym_binary_expression] = STATE(2732),
    [sym_unary_expression] = STATE(2732),
    [sym_regex] = STATE(2732),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_non_null_expression] = STATE(2732),
    [sym_array] = STATE(2793),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2732),
    [sym_internal_module] = STATE(2732),
    [sym_jsx_self_closing_element] = STATE(2732),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(6297),
    [sym_false] = ACTIONS(6299),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(5909),
    [anon_sym_number] = ACTIONS(5909),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6299),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5909),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(5909),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(6299),
    [sym_number] = ACTIONS(6301),
    [sym_true] = ACTIONS(6299),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(5909),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6299),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2719] = {
    [aux_sym_extends_clause_repeat1] = STATE(2733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2982),
    [anon_sym_COMMA] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6303),
  },
  [2720] = {
    [aux_sym_extends_clause_repeat1] = STATE(2733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6305),
  },
  [2721] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_AMP_EQ] = ACTIONS(1133),
    [anon_sym_PLUS_EQ] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3858),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1133),
    [anon_sym_STAR_EQ] = ACTIONS(1133),
    [anon_sym_PIPE_EQ] = ACTIONS(1133),
    [anon_sym_DASH_EQ] = ACTIONS(1133),
    [anon_sym_EQ_GT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1133),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3014),
    [anon_sym_SLASH_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT_EQ] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(3016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2722] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2723] = {
    [sym_class] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_jsx_element] = STATE(1322),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1322),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_regex] = STATE(1322),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(1322),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_jsx_self_closing_element] = STATE(1322),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1161),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(321),
  },
  [2724] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2725] = {
    [sym_string] = STATE(1728),
    [sym_nested_identifier] = STATE(1727),
    [sym__module] = STATE(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_AMP_EQ] = ACTIONS(1147),
    [anon_sym_PLUS_EQ] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1147),
    [anon_sym_STAR_EQ] = ACTIONS(1147),
    [anon_sym_PIPE_EQ] = ACTIONS(1147),
    [anon_sym_DASH_EQ] = ACTIONS(1147),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_SLASH_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT_EQ] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2726] = {
    [sym_string] = STATE(2465),
    [sym__property_name] = STATE(2465),
    [sym_computed_property_name] = STATE(2465),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2727] = {
    [sym_string] = STATE(2465),
    [sym__property_name] = STATE(2465),
    [sym_computed_property_name] = STATE(2465),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2728] = {
    [sym_string] = STATE(2465),
    [sym__property_name] = STATE(2465),
    [sym_computed_property_name] = STATE(2465),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(3896),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(6307),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(6307),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2729] = {
    [sym_formal_parameters] = STATE(1306),
    [sym_type_parameters] = STATE(1868),
    [sym__call_signature] = STATE(2466),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [2730] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2467),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2731] = {
    [anon_sym_EQ_GT] = ACTIONS(6309),
    [sym_comment] = ACTIONS(3),
  },
  [2732] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(3657),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_LBRACE] = ACTIONS(3659),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3657),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2733] = {
    [aux_sym_extends_clause_repeat1] = STATE(2733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3657),
    [anon_sym_COMMA] = ACTIONS(6311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3659),
  },
  [2734] = {
    [sym_string] = STATE(2472),
    [sym__property_name] = STATE(2472),
    [sym_computed_property_name] = STATE(2472),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2735] = {
    [sym_string] = STATE(2472),
    [sym__property_name] = STATE(2472),
    [sym_computed_property_name] = STATE(2472),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2736] = {
    [sym_string] = STATE(2472),
    [sym__property_name] = STATE(2472),
    [sym_computed_property_name] = STATE(2472),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(6314),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(6314),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2737] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2473),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2738] = {
    [sym_string] = STATE(2476),
    [sym__property_name] = STATE(2476),
    [sym_computed_property_name] = STATE(2476),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2739] = {
    [sym_string] = STATE(2476),
    [sym__property_name] = STATE(2476),
    [sym_computed_property_name] = STATE(2476),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2740] = {
    [sym_string] = STATE(2476),
    [sym__property_name] = STATE(2476),
    [sym_computed_property_name] = STATE(2476),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_get] = ACTIONS(6318),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(6318),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2741] = {
    [sym_string] = STATE(2478),
    [sym__property_name] = STATE(2478),
    [sym_computed_property_name] = STATE(2478),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1753),
    [sym_number] = ACTIONS(6320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2742] = {
    [sym_string] = STATE(2478),
    [sym__property_name] = STATE(2478),
    [sym_computed_property_name] = STATE(2478),
    [anon_sym_get] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_public] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1055),
    [anon_sym_SQUOTE] = ACTIONS(331),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_symbol] = ACTIONS(1055),
    [anon_sym_declare] = ACTIONS(1055),
    [sym_number] = ACTIONS(6320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_protected] = ACTIONS(1055),
    [anon_sym_string] = ACTIONS(1055),
    [anon_sym_set] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(1055),
    [anon_sym_any] = ACTIONS(1055),
    [anon_sym_private] = ACTIONS(1055),
    [anon_sym_boolean] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(329),
  },
  [2743] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2744] = {
    [sym_class] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym__expression] = STATE(1324),
    [sym_jsx_element] = STATE(1324),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(1324),
    [sym_call_expression] = STATE(1324),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1324),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(1324),
    [sym_generator_function] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_regex] = STATE(1324),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(1324),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_jsx_self_closing_element] = STATE(1324),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4382),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(4382),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4382),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4382),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(4382),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2745] = {
    [sym_class] = STATE(2499),
    [sym_arrow_function] = STATE(2499),
    [sym_await_expression] = STATE(2499),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2499),
    [sym_meta_property] = STATE(2499),
    [sym__expression] = STATE(2499),
    [sym_jsx_element] = STATE(2499),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2499),
    [sym_call_expression] = STATE(2499),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2499),
    [sym_string] = STATE(2499),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2499),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2499),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2499),
    [sym_generator_function] = STATE(2499),
    [sym_new_expression] = STATE(2499),
    [sym_assignment_expression] = STATE(2499),
    [sym_augmented_assignment_expression] = STATE(2499),
    [sym_binary_expression] = STATE(2499),
    [sym_unary_expression] = STATE(2499),
    [sym_regex] = STATE(2499),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2499),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2499),
    [sym_internal_module] = STATE(2499),
    [sym_jsx_self_closing_element] = STATE(2499),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(6322),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(6324),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6324),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6324),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(213),
    [sym_null] = ACTIONS(6324),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(1167),
    [sym_number] = ACTIONS(6326),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6324),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(499),
  },
  [2746] = {
    [sym_class] = STATE(2500),
    [sym_arrow_function] = STATE(2500),
    [sym_await_expression] = STATE(2500),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2500),
    [sym_meta_property] = STATE(2500),
    [sym__expression] = STATE(2500),
    [sym_jsx_element] = STATE(2500),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2500),
    [sym_call_expression] = STATE(2500),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2500),
    [sym_string] = STATE(2500),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2500),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2500),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2500),
    [sym_generator_function] = STATE(2500),
    [sym_new_expression] = STATE(2500),
    [sym_assignment_expression] = STATE(2500),
    [sym_augmented_assignment_expression] = STATE(2500),
    [sym_binary_expression] = STATE(2500),
    [sym_unary_expression] = STATE(2500),
    [sym_regex] = STATE(2500),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2500),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2500),
    [sym_internal_module] = STATE(2500),
    [sym_jsx_self_closing_element] = STATE(2500),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6328),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6328),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6328),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6328),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(6330),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6328),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2747] = {
    [sym_class] = STATE(2506),
    [sym_arrow_function] = STATE(2506),
    [sym_await_expression] = STATE(2506),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2506),
    [sym_meta_property] = STATE(2506),
    [sym__expression] = STATE(2506),
    [sym_jsx_element] = STATE(2506),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2506),
    [sym_call_expression] = STATE(2506),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2506),
    [sym_string] = STATE(2506),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2506),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2506),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2506),
    [sym_generator_function] = STATE(2506),
    [sym_new_expression] = STATE(2506),
    [sym_assignment_expression] = STATE(2506),
    [sym_augmented_assignment_expression] = STATE(2506),
    [sym_binary_expression] = STATE(2506),
    [sym_unary_expression] = STATE(2506),
    [sym_regex] = STATE(2506),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2506),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2506),
    [sym_internal_module] = STATE(2506),
    [sym_jsx_self_closing_element] = STATE(2506),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1318),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6332),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(6332),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(6332),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6332),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(311),
    [sym_number] = ACTIONS(6334),
    [anon_sym_SLASH] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6332),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_await] = ACTIONS(499),
  },
  [2748] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_AMP_EQ] = ACTIONS(2068),
    [anon_sym_PLUS_EQ] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2074),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2068),
    [anon_sym_STAR_EQ] = ACTIONS(2068),
    [anon_sym_PIPE_EQ] = ACTIONS(2068),
    [anon_sym_DASH_EQ] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2068),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2068),
    [anon_sym_GT_GT_EQ] = ACTIONS(2068),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2749] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2750] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2751] = {
    [sym_class] = STATE(2497),
    [sym_arrow_function] = STATE(2497),
    [sym_await_expression] = STATE(2497),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2497),
    [sym_meta_property] = STATE(2497),
    [sym_arguments] = STATE(1446),
    [sym__expression] = STATE(2497),
    [sym_jsx_element] = STATE(2497),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2497),
    [sym_string] = STATE(2497),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2497),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2497),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2497),
    [sym_generator_function] = STATE(2497),
    [sym_new_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(2497),
    [sym_augmented_assignment_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_regex] = STATE(2497),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2497),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2497),
    [sym_internal_module] = STATE(2497),
    [sym_jsx_self_closing_element] = STATE(2497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1302),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_AMP_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1302),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_PIPE_EQ] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1302),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1304),
    [sym_this] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(487),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1302),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [sym_false] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1302),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [sym_null] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1302),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(6030),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [sym_number] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1302),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_await] = ACTIONS(499),
  },
  [2752] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(848),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(6340),
    [sym_false] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(6342),
    [anon_sym_symbol] = ACTIONS(6342),
    [anon_sym_number] = ACTIONS(6342),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(6342),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(6342),
    [anon_sym_private] = ACTIONS(6342),
    [anon_sym_boolean] = ACTIONS(6342),
    [anon_sym_static] = ACTIONS(6342),
    [anon_sym_public] = ACTIONS(6342),
    [anon_sym_get] = ACTIONS(6342),
    [anon_sym_async] = ACTIONS(6346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [sym_number] = ACTIONS(4580),
    [sym_true] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(6342),
    [anon_sym_string] = ACTIONS(6342),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_DOT] = ACTIONS(4574),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_set] = ACTIONS(6342),
    [anon_sym_type] = ACTIONS(6342),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(6342),
    [anon_sym_namespace] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2753] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2754] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2755] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2628),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2756] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3224),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2757] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3228),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2758] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3238),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2759] = {
    [sym_class] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(1358),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1353),
    [sym__expression] = STATE(1920),
    [sym_jsx_element] = STATE(1920),
    [sym_function] = STATE(1359),
    [sym_import] = STATE(1353),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(1358),
    [sym__call_signature] = STATE(2664),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1353),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(1353),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(1360),
    [sym_jsx_fragment] = STATE(1920),
    [sym_generator_function] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1353),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1358),
    [sym_non_null_expression] = STATE(1920),
    [sym_array] = STATE(1361),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(1920),
    [sym_internal_module] = STATE(1920),
    [sym_jsx_self_closing_element] = STATE(1920),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(6340),
    [sym_false] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(499),
    [anon_sym_module] = ACTIONS(6342),
    [anon_sym_symbol] = ACTIONS(6342),
    [anon_sym_number] = ACTIONS(6342),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(6342),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4572),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(6342),
    [anon_sym_private] = ACTIONS(6342),
    [anon_sym_boolean] = ACTIONS(6342),
    [anon_sym_static] = ACTIONS(6342),
    [anon_sym_public] = ACTIONS(6342),
    [anon_sym_get] = ACTIONS(6342),
    [anon_sym_async] = ACTIONS(6346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(4572),
    [sym_number] = ACTIONS(4580),
    [sym_true] = ACTIONS(4572),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(6342),
    [anon_sym_string] = ACTIONS(6342),
    [anon_sym_function] = ACTIONS(317),
    [anon_sym_DOT] = ACTIONS(4574),
    [sym_undefined] = ACTIONS(4572),
    [anon_sym_set] = ACTIONS(6342),
    [anon_sym_type] = ACTIONS(6342),
    [anon_sym_new] = ACTIONS(5925),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(6342),
    [anon_sym_namespace] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2760] = {
    [sym_await_expression] = STATE(2766),
    [sym_type_predicate] = STATE(342),
    [sym__number] = STATE(328),
    [sym_update_expression] = STATE(2766),
    [sym_object_type] = STATE(342),
    [sym_meta_property] = STATE(2766),
    [sym_function_type] = STATE(345),
    [sym__expression] = STATE(2766),
    [sym_jsx_element] = STATE(2766),
    [sym_nested_identifier] = STATE(343),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2766),
    [sym_call_expression] = STATE(2766),
    [sym_type_query] = STATE(342),
    [sym_existential_type] = STATE(342),
    [sym_ternary_expression] = STATE(2766),
    [sym_template_string] = STATE(2766),
    [sym_yield_expression] = STATE(2766),
    [sym_jsx_fragment] = STATE(2766),
    [sym_new_expression] = STATE(2766),
    [sym__primary_type] = STATE(342),
    [sym_assignment_expression] = STATE(2766),
    [sym_binary_expression] = STATE(2766),
    [sym_predefined_type] = STATE(342),
    [sym_union_type] = STATE(345),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_array] = STATE(2793),
    [sym_as_expression] = STATE(2766),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_internal_module] = STATE(2766),
    [sym_jsx_self_closing_element] = STATE(2766),
    [sym_arrow_function] = STATE(2766),
    [sym_generic_type] = STATE(342),
    [sym_member_expression] = STATE(2792),
    [sym_literal_type] = STATE(342),
    [sym_intersection_type] = STATE(345),
    [sym_nested_type_identifier] = STATE(344),
    [sym__call_signature] = STATE(2664),
    [sym__type] = STATE(345),
    [sym_subscript_expression] = STATE(2792),
    [sym_index_type_query] = STATE(342),
    [sym_flow_maybe_type] = STATE(342),
    [sym_string] = STATE(1460),
    [sym_type_parameters] = STATE(565),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(342),
    [sym_formal_parameters] = STATE(566),
    [sym_object] = STATE(2794),
    [sym_generator_function] = STATE(2766),
    [sym_constructor_type] = STATE(345),
    [sym_lookup_type] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(2766),
    [sym_parenthesized_type] = STATE(342),
    [sym_unary_expression] = STATE(2766),
    [sym_regex] = STATE(2766),
    [sym_tuple_type] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_non_null_expression] = STATE(2766),
    [sym_class] = STATE(2766),
    [anon_sym_await] = ACTIONS(5903),
    [sym_identifier] = ACTIONS(6350),
    [sym_false] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5909),
    [anon_sym_symbol] = ACTIONS(6352),
    [anon_sym_number] = ACTIONS(6352),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5909),
    [anon_sym_typeof] = ACTIONS(6354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_keyof] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(4491),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [sym_null] = ACTIONS(6096),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(6352),
    [anon_sym_private] = ACTIONS(5909),
    [anon_sym_boolean] = ACTIONS(6352),
    [anon_sym_static] = ACTIONS(5909),
    [anon_sym_public] = ACTIONS(5909),
    [anon_sym_get] = ACTIONS(5909),
    [anon_sym_async] = ACTIONS(5917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(756),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(758),
    [anon_sym_delete] = ACTIONS(5911),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [sym_this] = ACTIONS(4485),
    [sym_number] = ACTIONS(4493),
    [sym_true] = ACTIONS(4487),
    [anon_sym_yield] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(5909),
    [anon_sym_string] = ACTIONS(6352),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6096),
    [anon_sym_set] = ACTIONS(5909),
    [anon_sym_type] = ACTIONS(5909),
    [anon_sym_new] = ACTIONS(6360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5909),
    [anon_sym_namespace] = ACTIONS(5927),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_TILDE] = ACTIONS(5929),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5929),
  },
  [2761] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1703),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2762] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1709),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2763] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6366),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2764] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1735),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1735),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2765] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1913),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1913),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2766] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2767] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2768] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2769] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2770] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2771] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_STAR_STAR] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2772] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(2603),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6375),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2603),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2773] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6377),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2638),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2774] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(3883),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6379),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3883),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2775] = {
    [sym_string] = STATE(1328),
    [sym_nested_identifier] = STATE(1327),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(6381),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [2776] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(6383),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(6385),
    [anon_sym_global] = ACTIONS(343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_async] = ACTIONS(4928),
  },
  [2777] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(701),
  },
  [2778] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2779] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6390),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2780] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(699),
    [anon_sym_LT_LT] = ACTIONS(699),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(699),
    [anon_sym_GT_GT_GT] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_LT_EQ] = ACTIONS(699),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_LBRACE_PIPE] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_instanceof] = ACTIONS(699),
    [anon_sym_LT] = ACTIONS(6387),
    [anon_sym_SLASH] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(699),
    [anon_sym_STAR_STAR] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(699),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2781] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6259),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(6261),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6269),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [anon_sym_AMP_AMP] = ACTIONS(6267),
    [anon_sym_GT_GT_GT] = ACTIONS(6263),
    [anon_sym_DASH] = ACTIONS(6265),
    [anon_sym_BANG_EQ] = ACTIONS(6271),
    [anon_sym_LT_EQ] = ACTIONS(6259),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(6259),
    [anon_sym_GT] = ACTIONS(6271),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_PERCENT] = ACTIONS(6263),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1396),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_PIPE_PIPE] = ACTIONS(6277),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(6271),
    [anon_sym_instanceof] = ACTIONS(6259),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_SLASH] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6265),
    [anon_sym_GT_GT] = ACTIONS(6269),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(6271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6259),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2782] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
  },
  [2783] = {
    [sym_jsx_element] = STATE(2785),
    [sym_jsx_expression] = STATE(2785),
    [aux_sym_jsx_element_repeat1] = STATE(2785),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_self_closing_element] = STATE(2785),
    [sym_jsx_text] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6398),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2784] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(6400),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2785] = {
    [sym_jsx_element] = STATE(574),
    [sym_jsx_expression] = STATE(574),
    [aux_sym_jsx_element_repeat1] = STATE(574),
    [sym_jsx_opening_element] = STATE(2144),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_jsx_text] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(6402),
    [sym_comment] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(591),
  },
  [2786] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2562),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2787] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2563),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(339),
  },
  [2788] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2789] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2790] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2791] = {
    [sym_nested_identifier] = STATE(2545),
    [sym_jsx_namespace_name] = STATE(2546),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(6404),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1508),
  },
  [2792] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_AMP_EQ] = ACTIONS(5638),
    [anon_sym_PLUS_EQ] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5638),
    [anon_sym_STAR_EQ] = ACTIONS(5638),
    [anon_sym_PIPE_EQ] = ACTIONS(5638),
    [anon_sym_DASH_EQ] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5638),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT_EQ] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5638),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2793] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2794] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2795] = {
    [anon_sym_class] = ACTIONS(6410),
    [sym_comment] = ACTIONS(3),
  },
  [2796] = {
    [sym_class] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_await_expression] = STATE(51),
    [sym_member_expression] = STATE(389),
    [sym_update_expression] = STATE(51),
    [sym_sequence_expression] = STATE(57),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_subscript_expression] = STATE(389),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(2708),
    [sym_ternary_expression] = STATE(51),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(51),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(51),
    [sym_object] = STATE(391),
    [sym_jsx_fragment] = STATE(51),
    [sym_generator_function] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_variable_declaration] = STATE(2708),
    [sym_regex] = STATE(51),
    [sym_lexical_declaration] = STATE(2708),
    [sym_empty_statement] = STATE(2708),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(389),
    [sym_array] = STATE(392),
    [sym_non_null_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_identifier] = ACTIONS(860),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(862),
    [anon_sym_symbol] = ACTIONS(862),
    [anon_sym_number] = ACTIONS(862),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(862),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(864),
    [anon_sym_const] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(862),
    [anon_sym_private] = ACTIONS(862),
    [anon_sym_boolean] = ACTIONS(862),
    [anon_sym_async] = ACTIONS(870),
    [anon_sym_public] = ACTIONS(862),
    [anon_sym_get] = ACTIONS(862),
    [anon_sym_static] = ACTIONS(862),
    [anon_sym_var] = ACTIONS(872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(89),
    [sym_true] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(862),
    [anon_sym_string] = ACTIONS(862),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_set] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(862),
    [anon_sym_let] = ACTIONS(866),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(862),
    [anon_sym_namespace] = ACTIONS(868),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [2797] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(6412),
  },
  [2798] = {
    [sym_identifier] = ACTIONS(6414),
    [anon_sym_STAR] = ACTIONS(6416),
    [sym_comment] = ACTIONS(3),
  },
  [2799] = {
    [sym_class] = STATE(2715),
    [sym_arrow_function] = STATE(2715),
    [sym_await_expression] = STATE(2715),
    [sym_member_expression] = STATE(2788),
    [sym_update_expression] = STATE(2715),
    [sym_meta_property] = STATE(2715),
    [sym__expression] = STATE(2715),
    [sym_jsx_element] = STATE(2715),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2715),
    [sym_call_expression] = STATE(2715),
    [sym_subscript_expression] = STATE(2788),
    [sym__call_signature] = STATE(2610),
    [sym_ternary_expression] = STATE(2715),
    [sym_string] = STATE(2715),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2715),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2715),
    [sym_object] = STATE(2790),
    [sym_jsx_fragment] = STATE(2715),
    [sym_generator_function] = STATE(2715),
    [sym_new_expression] = STATE(2715),
    [sym_assignment_expression] = STATE(2715),
    [sym_augmented_assignment_expression] = STATE(2715),
    [sym_binary_expression] = STATE(2715),
    [sym_unary_expression] = STATE(2715),
    [sym_regex] = STATE(2715),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(2788),
    [sym_non_null_expression] = STATE(2715),
    [sym_array] = STATE(2789),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2715),
    [sym_internal_module] = STATE(2715),
    [sym_jsx_self_closing_element] = STATE(2715),
    [anon_sym_await] = ACTIONS(499),
    [sym_identifier] = ACTIONS(1316),
    [sym_false] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1308),
    [anon_sym_symbol] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6418),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1308),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_delete] = ACTIONS(481),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(483),
    [sym_this] = ACTIONS(6418),
    [sym_number] = ACTIONS(6420),
    [sym_true] = ACTIONS(6418),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(1308),
    [anon_sym_string] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6418),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_TILDE] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(493),
  },
  [2800] = {
    [sym_formal_parameters] = STATE(2716),
    [sym_type_parameters] = STATE(2805),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2801] = {
    [sym_formal_parameters] = STATE(2717),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2802] = {
    [aux_sym_extends_clause_repeat1] = STATE(2720),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5648),
  },
  [2803] = {
    [sym_identifier] = ACTIONS(6422),
    [anon_sym_STAR] = ACTIONS(6424),
    [sym_comment] = ACTIONS(3),
  },
  [2804] = {
    [sym_identifier] = ACTIONS(6426),
    [sym_comment] = ACTIONS(3),
  },
  [2805] = {
    [sym_formal_parameters] = STATE(2731),
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [2806] = {
    [sym_identifier] = ACTIONS(6428),
    [sym_comment] = ACTIONS(3),
  },
  [2807] = {
    [sym_class_declaration] = STATE(582),
    [sym_generator_function_declaration] = STATE(582),
    [sym__declaration] = STATE(582),
    [sym_enum_declaration] = STATE(582),
    [sym_function_signature] = STATE(582),
    [sym_abstract_class_declaration] = STATE(582),
    [sym_module] = STATE(582),
    [sym_interface_declaration] = STATE(582),
    [sym_function_declaration] = STATE(582),
    [sym_variable_declaration] = STATE(582),
    [sym_lexical_declaration] = STATE(582),
    [sym_ambient_declaration] = STATE(582),
    [sym_import_alias] = STATE(582),
    [sym_type_alias_declaration] = STATE(582),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(582),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(1690),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(4916),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(6385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_async] = ACTIONS(4928),
  },
  [2808] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(343),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(6383),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_declare] = ACTIONS(6385),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(4928),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2809] = {
    [sym_class_declaration] = STATE(249),
    [sym_generator_function_declaration] = STATE(249),
    [sym__declaration] = STATE(249),
    [sym_enum_declaration] = STATE(249),
    [sym_function_signature] = STATE(249),
    [sym_abstract_class_declaration] = STATE(249),
    [sym_module] = STATE(249),
    [sym_interface_declaration] = STATE(249),
    [sym_function_declaration] = STATE(249),
    [sym_export_clause] = STATE(250),
    [sym_variable_declaration] = STATE(249),
    [sym_lexical_declaration] = STATE(249),
    [sym_ambient_declaration] = STATE(249),
    [sym_import_alias] = STATE(249),
    [sym_type_alias_declaration] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(2696),
    [sym_internal_module] = STATE(249),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_as] = ACTIONS(507),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(4924),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(353),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(4916),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_declare] = ACTIONS(6385),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(4928),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(4922),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2810] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(6432),
    [anon_sym_class] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
  },
  [2811] = {
    [sym_identifier] = ACTIONS(6434),
    [sym_comment] = ACTIONS(3),
  },
  [2812] = {
    [sym_identifier] = ACTIONS(6436),
    [sym_comment] = ACTIONS(3),
  },
  [2813] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(6438),
  },
  [2814] = {
    [sym_generator_function_declaration] = STATE(284),
    [sym__declaration] = STATE(284),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(284),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(284),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(284),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(284),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(284),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(284),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(284),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(284),
    [sym_function_declaration] = STATE(284),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(284),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(284),
    [sym_break_statement] = STATE(284),
    [sym_labeled_statement] = STATE(284),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(284),
    [sym_class_declaration] = STATE(284),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(284),
    [sym_ambient_declaration] = STATE(284),
    [sym_type_alias_declaration] = STATE(284),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(284),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(284),
    [sym_switch_statement] = STATE(284),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(284),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(284),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(284),
    [sym_abstract_class_declaration] = STATE(284),
    [sym_interface_declaration] = STATE(284),
    [sym_export_statement] = STATE(284),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(284),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(284),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(284),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(284),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2815] = {
    [sym_generator_function_declaration] = STATE(395),
    [sym__declaration] = STATE(395),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(395),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(395),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(395),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(395),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(395),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(395),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(395),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(395),
    [sym_function_declaration] = STATE(395),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(395),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(395),
    [sym_break_statement] = STATE(395),
    [sym_labeled_statement] = STATE(395),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(395),
    [sym_class_declaration] = STATE(395),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(395),
    [sym_ambient_declaration] = STATE(395),
    [sym_type_alias_declaration] = STATE(395),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(395),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(395),
    [sym_switch_statement] = STATE(395),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(395),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(395),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(395),
    [sym_abstract_class_declaration] = STATE(395),
    [sym_interface_declaration] = STATE(395),
    [sym_export_statement] = STATE(395),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(395),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(395),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(395),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(395),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2816] = {
    [sym_generator_function_declaration] = STATE(500),
    [sym__declaration] = STATE(500),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(500),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(500),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(500),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(500),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(500),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(500),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(500),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(500),
    [sym_function_declaration] = STATE(500),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(500),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_labeled_statement] = STATE(500),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(500),
    [sym_class_declaration] = STATE(500),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(500),
    [sym_ambient_declaration] = STATE(500),
    [sym_type_alias_declaration] = STATE(500),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(500),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(500),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(500),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(500),
    [sym_abstract_class_declaration] = STATE(500),
    [sym_interface_declaration] = STATE(500),
    [sym_export_statement] = STATE(500),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(500),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(500),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(500),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(500),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2817] = {
    [sym_generator_function_declaration] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(543),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(543),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(543),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(543),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(543),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(543),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(543),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(543),
    [sym_function_declaration] = STATE(543),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(543),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(543),
    [sym_class_declaration] = STATE(543),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(543),
    [sym_ambient_declaration] = STATE(543),
    [sym_type_alias_declaration] = STATE(543),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(543),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(543),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(543),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(543),
    [sym_abstract_class_declaration] = STATE(543),
    [sym_interface_declaration] = STATE(543),
    [sym_export_statement] = STATE(543),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(543),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(543),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(543),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(543),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2818] = {
    [sym_generator_function_declaration] = STATE(692),
    [sym__declaration] = STATE(692),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(692),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(692),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(692),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(692),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(692),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(692),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(692),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(692),
    [sym_function_declaration] = STATE(692),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(692),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(692),
    [sym_break_statement] = STATE(692),
    [sym_labeled_statement] = STATE(692),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(692),
    [sym_class_declaration] = STATE(692),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(692),
    [sym_ambient_declaration] = STATE(692),
    [sym_type_alias_declaration] = STATE(692),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(692),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(692),
    [sym_switch_statement] = STATE(692),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(692),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(692),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(692),
    [sym_abstract_class_declaration] = STATE(692),
    [sym_interface_declaration] = STATE(692),
    [sym_export_statement] = STATE(692),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(692),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(692),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(692),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(692),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2819] = {
    [sym_generator_function_declaration] = STATE(916),
    [sym__declaration] = STATE(916),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(916),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(916),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(916),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(916),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(916),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(916),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(916),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(916),
    [sym_function_declaration] = STATE(916),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(916),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(916),
    [sym_break_statement] = STATE(916),
    [sym_labeled_statement] = STATE(916),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(916),
    [sym_class_declaration] = STATE(916),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(916),
    [sym_ambient_declaration] = STATE(916),
    [sym_type_alias_declaration] = STATE(916),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(916),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(916),
    [sym_switch_statement] = STATE(916),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(916),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(916),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(916),
    [sym_abstract_class_declaration] = STATE(916),
    [sym_interface_declaration] = STATE(916),
    [sym_export_statement] = STATE(916),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(916),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(916),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(916),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(916),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2820] = {
    [sym_generator_function_declaration] = STATE(1123),
    [sym__declaration] = STATE(1123),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1123),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1123),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1123),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1123),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1123),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1123),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1123),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1123),
    [sym_function_declaration] = STATE(1123),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1123),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1123),
    [sym_break_statement] = STATE(1123),
    [sym_labeled_statement] = STATE(1123),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1123),
    [sym_class_declaration] = STATE(1123),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1123),
    [sym_ambient_declaration] = STATE(1123),
    [sym_type_alias_declaration] = STATE(1123),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1123),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1123),
    [sym_switch_statement] = STATE(1123),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1123),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1123),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1123),
    [sym_abstract_class_declaration] = STATE(1123),
    [sym_interface_declaration] = STATE(1123),
    [sym_export_statement] = STATE(1123),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1123),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1123),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1123),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1123),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2821] = {
    [sym_generator_function_declaration] = STATE(1215),
    [sym__declaration] = STATE(1215),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1215),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1215),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1215),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(1215),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1215),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1215),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1215),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(1215),
    [sym_function_declaration] = STATE(1215),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1215),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1215),
    [sym_break_statement] = STATE(1215),
    [sym_labeled_statement] = STATE(1215),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(1215),
    [sym_class_declaration] = STATE(1215),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1215),
    [sym_ambient_declaration] = STATE(1215),
    [sym_type_alias_declaration] = STATE(1215),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1215),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1215),
    [sym_switch_statement] = STATE(1215),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1215),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1215),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1215),
    [sym_abstract_class_declaration] = STATE(1215),
    [sym_interface_declaration] = STATE(1215),
    [sym_export_statement] = STATE(1215),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1215),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1215),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1215),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2822] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2823] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2824] = {
    [sym_class] = STATE(93),
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_jsx_element] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(93),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(93),
    [sym_internal_module] = STATE(93),
    [sym_jsx_self_closing_element] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(107),
  },
  [2825] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2826] = {
    [sym__for_header] = STATE(2815),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(6442),
  },
  [2827] = {
    [sym_string] = STATE(1328),
    [sym_nested_identifier] = STATE(1327),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2828] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(437),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(437),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(437),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_protected] = ACTIONS(437),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(437),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(437),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(437),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(437),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(5499),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2829] = {
    [sym_parenthesized_expression] = STATE(2816),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2830] = {
    [sym_parenthesized_expression] = STATE(2817),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2831] = {
    [sym__for_header] = STATE(2818),
    [anon_sym_LPAREN] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
  },
  [2832] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(6444),
    [anon_sym_while] = ACTIONS(1909),
  },
  [2833] = {
    [sym_class] = STATE(2835),
    [sym_arrow_function] = STATE(2835),
    [sym_await_expression] = STATE(2835),
    [sym_member_expression] = STATE(1303),
    [sym_update_expression] = STATE(2835),
    [sym_sequence_expression] = STATE(2834),
    [sym_meta_property] = STATE(2835),
    [sym__expression] = STATE(2835),
    [sym_jsx_element] = STATE(2835),
    [sym_function] = STATE(1302),
    [sym_import] = STATE(2835),
    [sym_call_expression] = STATE(2835),
    [sym_subscript_expression] = STATE(1303),
    [sym__call_signature] = STATE(1867),
    [sym_ternary_expression] = STATE(2835),
    [sym_string] = STATE(2835),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(2835),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2835),
    [sym_object] = STATE(1307),
    [sym_jsx_fragment] = STATE(2835),
    [sym_generator_function] = STATE(2835),
    [sym_new_expression] = STATE(2835),
    [sym_assignment_expression] = STATE(2835),
    [sym_augmented_assignment_expression] = STATE(2835),
    [sym_binary_expression] = STATE(2835),
    [sym_unary_expression] = STATE(2835),
    [sym_regex] = STATE(2835),
    [aux_sym_export_statement_repeat1] = STATE(2350),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_non_null_expression] = STATE(2835),
    [sym_array] = STATE(1304),
    [sym_jsx_opening_element] = STATE(1866),
    [sym_as_expression] = STATE(2835),
    [sym_internal_module] = STATE(2835),
    [sym_jsx_self_closing_element] = STATE(2835),
    [anon_sym_await] = ACTIONS(321),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6446),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [sym_this] = ACTIONS(6446),
    [sym_number] = ACTIONS(6450),
    [sym_true] = ACTIONS(6446),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(317),
    [sym_undefined] = ACTIONS(6446),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2834] = {
    [anon_sym_RPAREN] = ACTIONS(6452),
    [sym_comment] = ACTIONS(3),
  },
  [2835] = {
    [sym_arguments] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_type_arguments] = STATE(1877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(896),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(896),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_LT_EQ] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(904),
    [anon_sym_AMP] = ACTIONS(908),
    [anon_sym_PERCENT] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_instanceof] = ACTIONS(890),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(900),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_in] = ACTIONS(904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(924),
  },
  [2836] = {
    [sym_class] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_await_expression] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_update_expression] = STATE(51),
    [sym_sequence_expression] = STATE(57),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(2833),
    [sym_ternary_expression] = STATE(51),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(51),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(51),
    [sym_object] = STATE(64),
    [sym_jsx_fragment] = STATE(51),
    [sym_generator_function] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2833),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_non_null_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(89),
    [sym_true] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [2837] = {
    [sym_class] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_await_expression] = STATE(51),
    [sym_member_expression] = STATE(389),
    [sym_update_expression] = STATE(51),
    [sym_sequence_expression] = STATE(57),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_subscript_expression] = STATE(389),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(2836),
    [sym_ternary_expression] = STATE(51),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_template_string] = STATE(51),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(51),
    [sym_object] = STATE(391),
    [sym_jsx_fragment] = STATE(51),
    [sym_generator_function] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_variable_declaration] = STATE(2836),
    [sym_regex] = STATE(51),
    [sym_lexical_declaration] = STATE(2836),
    [sym_empty_statement] = STATE(2836),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(389),
    [sym_array] = STATE(392),
    [sym_non_null_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_jsx_self_closing_element] = STATE(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_identifier] = ACTIONS(860),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(862),
    [anon_sym_symbol] = ACTIONS(862),
    [anon_sym_number] = ACTIONS(862),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(862),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(864),
    [anon_sym_const] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(862),
    [anon_sym_private] = ACTIONS(862),
    [anon_sym_boolean] = ACTIONS(862),
    [anon_sym_async] = ACTIONS(870),
    [anon_sym_public] = ACTIONS(862),
    [anon_sym_get] = ACTIONS(862),
    [anon_sym_static] = ACTIONS(862),
    [anon_sym_var] = ACTIONS(872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(89),
    [sym_true] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(862),
    [anon_sym_string] = ACTIONS(862),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_set] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(862),
    [anon_sym_let] = ACTIONS(866),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(862),
    [anon_sym_namespace] = ACTIONS(868),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [2838] = {
    [sym_string] = STATE(1639),
    [sym_nested_identifier] = STATE(1638),
    [sym__module] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(697),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2839] = {
    [sym_generator_function_declaration] = STATE(2832),
    [sym__declaration] = STATE(2832),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2832),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2832),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2832),
    [sym__expression] = STATE(51),
    [sym_jsx_element] = STATE(51),
    [sym_import_alias] = STATE(2832),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2832),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2832),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2832),
    [sym_yield_expression] = STATE(51),
    [sym_jsx_fragment] = STATE(51),
    [sym_module] = STATE(2832),
    [sym_function_declaration] = STATE(2832),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2832),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2832),
    [sym_break_statement] = STATE(2832),
    [sym_labeled_statement] = STATE(2832),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_jsx_opening_element] = STATE(55),
    [sym_internal_module] = STATE(1305),
    [sym_jsx_self_closing_element] = STATE(51),
    [sym_enum_declaration] = STATE(2832),
    [sym_class_declaration] = STATE(2832),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2832),
    [sym_ambient_declaration] = STATE(2832),
    [sym_type_alias_declaration] = STATE(2832),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2832),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2832),
    [sym_switch_statement] = STATE(2832),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(2832),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(2832),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2832),
    [sym_abstract_class_declaration] = STATE(2832),
    [sym_interface_declaration] = STATE(2832),
    [sym_export_statement] = STATE(2832),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2832),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2832),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2832),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2832),
    [aux_sym_export_statement_repeat1] = STATE(2810),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(4830),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(4832),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_type] = ACTIONS(4834),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_declare] = ACTIONS(4842),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_function] = ACTIONS(541),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(4850),
    [anon_sym_await] = ACTIONS(107),
  },
  [2840] = {
    [sym_parenthesized_expression] = STATE(2839),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = false}, SHIFT(7),
  [17] = {.count = 1, .reusable = false}, SHIFT(8),
  [19] = {.count = 1, .reusable = false}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = false}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(13),
  [29] = {.count = 1, .reusable = false}, SHIFT(14),
  [31] = {.count = 1, .reusable = false}, SHIFT(15),
  [33] = {.count = 1, .reusable = false}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(18),
  [39] = {.count = 1, .reusable = false}, SHIFT(51),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = false}, SHIFT(20),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = true}, SHIFT(25),
  [55] = {.count = 1, .reusable = true}, SHIFT(26),
  [57] = {.count = 1, .reusable = false}, SHIFT(27),
  [59] = {.count = 1, .reusable = true}, SHIFT(28),
  [61] = {.count = 1, .reusable = true}, SHIFT(29),
  [63] = {.count = 1, .reusable = false}, SHIFT(30),
  [65] = {.count = 1, .reusable = false}, SHIFT(31),
  [67] = {.count = 1, .reusable = false}, SHIFT(32),
  [69] = {.count = 1, .reusable = true}, SHIFT(33),
  [71] = {.count = 1, .reusable = false}, SHIFT(34),
  [73] = {.count = 1, .reusable = true}, SHIFT(35),
  [75] = {.count = 1, .reusable = false}, SHIFT(36),
  [77] = {.count = 1, .reusable = false}, SHIFT(37),
  [79] = {.count = 1, .reusable = true}, SHIFT(38),
  [81] = {.count = 1, .reusable = false}, SHIFT(39),
  [83] = {.count = 1, .reusable = true}, SHIFT(40),
  [85] = {.count = 1, .reusable = false}, SHIFT(41),
  [87] = {.count = 1, .reusable = true}, SHIFT(42),
  [89] = {.count = 1, .reusable = true}, SHIFT(51),
  [91] = {.count = 1, .reusable = false}, SHIFT(43),
  [93] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [95] = {.count = 1, .reusable = false}, SHIFT(44),
  [97] = {.count = 1, .reusable = false}, SHIFT(45),
  [99] = {.count = 1, .reusable = false}, SHIFT(46),
  [101] = {.count = 1, .reusable = false}, SHIFT(47),
  [103] = {.count = 1, .reusable = false}, SHIFT(48),
  [105] = {.count = 1, .reusable = false}, SHIFT(49),
  [107] = {.count = 1, .reusable = false}, SHIFT(50),
  [109] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [111] = {.count = 1, .reusable = true}, SHIFT(67),
  [113] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [115] = {.count = 1, .reusable = false}, SHIFT(69),
  [117] = {.count = 1, .reusable = true}, SHIFT(68),
  [119] = {.count = 1, .reusable = true}, SHIFT(70),
  [121] = {.count = 1, .reusable = true}, SHIFT(66),
  [123] = {.count = 1, .reusable = true}, SHIFT(71),
  [125] = {.count = 1, .reusable = true}, SHIFT(72),
  [127] = {.count = 1, .reusable = true}, SHIFT(73),
  [129] = {.count = 1, .reusable = true}, SHIFT(74),
  [131] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [133] = {.count = 1, .reusable = true}, SHIFT(76),
  [135] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [137] = {.count = 1, .reusable = false}, SHIFT(77),
  [139] = {.count = 1, .reusable = true}, SHIFT(78),
  [141] = {.count = 1, .reusable = true}, SHIFT(75),
  [143] = {.count = 1, .reusable = false}, SHIFT(80),
  [145] = {.count = 1, .reusable = false}, SHIFT(79),
  [147] = {.count = 1, .reusable = false}, SHIFT(82),
  [149] = {.count = 1, .reusable = false}, SHIFT(83),
  [151] = {.count = 1, .reusable = false}, SHIFT(86),
  [153] = {.count = 1, .reusable = false}, SHIFT(91),
  [155] = {.count = 1, .reusable = false}, SHIFT(89),
  [157] = {.count = 1, .reusable = false}, SHIFT(90),
  [159] = {.count = 1, .reusable = false}, SHIFT(84),
  [161] = {.count = 1, .reusable = true}, SHIFT(85),
  [163] = {.count = 1, .reusable = false}, SHIFT(87),
  [165] = {.count = 1, .reusable = true}, SHIFT(91),
  [167] = {.count = 1, .reusable = false}, SHIFT(88),
  [169] = {.count = 1, .reusable = false}, SHIFT(93),
  [171] = {.count = 1, .reusable = false}, SHIFT(78),
  [173] = {.count = 1, .reusable = false}, SHIFT(26),
  [175] = {.count = 1, .reusable = false}, SHIFT(42),
  [177] = {.count = 1, .reusable = true}, SHIFT(93),
  [179] = {.count = 1, .reusable = true}, SHIFT(94),
  [181] = {.count = 1, .reusable = true}, SHIFT(95),
  [183] = {.count = 1, .reusable = false}, SHIFT(96),
  [185] = {.count = 1, .reusable = false}, SHIFT(97),
  [187] = {.count = 1, .reusable = true}, SHIFT(101),
  [189] = {.count = 1, .reusable = true}, SHIFT(103),
  [191] = {.count = 1, .reusable = false}, SHIFT(102),
  [193] = {.count = 1, .reusable = true}, SHIFT(106),
  [195] = {.count = 1, .reusable = false}, SHIFT(108),
  [197] = {.count = 1, .reusable = true}, SHIFT(108),
  [199] = {.count = 1, .reusable = true}, SHIFT(109),
  [201] = {.count = 1, .reusable = true}, SHIFT(110),
  [203] = {.count = 1, .reusable = true}, SHIFT(111),
  [205] = {.count = 1, .reusable = true}, SHIFT(112),
  [207] = {.count = 1, .reusable = false}, SHIFT(113),
  [209] = {.count = 1, .reusable = true}, SHIFT(113),
  [211] = {.count = 1, .reusable = true}, SHIFT(114),
  [213] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [215] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [217] = {.count = 1, .reusable = false}, SHIFT(116),
  [219] = {.count = 1, .reusable = false}, SHIFT(117),
  [221] = {.count = 1, .reusable = true}, SHIFT(117),
  [223] = {.count = 1, .reusable = false}, SHIFT(119),
  [225] = {.count = 1, .reusable = true}, SHIFT(119),
  [227] = {.count = 1, .reusable = true}, SHIFT(120),
  [229] = {.count = 1, .reusable = false}, SHIFT(121),
  [231] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [233] = {.count = 1, .reusable = false}, SHIFT(122),
  [235] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [237] = {.count = 1, .reusable = false}, SHIFT(124),
  [239] = {.count = 1, .reusable = false}, SHIFT(123),
  [241] = {.count = 1, .reusable = true}, SHIFT(125),
  [243] = {.count = 1, .reusable = false}, SHIFT(129),
  [245] = {.count = 1, .reusable = true}, SHIFT(1861),
  [247] = {.count = 1, .reusable = true}, SHIFT(1864),
  [249] = {.count = 1, .reusable = false}, SHIFT(133),
  [251] = {.count = 1, .reusable = true}, SHIFT(133),
  [253] = {.count = 1, .reusable = false}, SHIFT(132),
  [255] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [257] = {.count = 1, .reusable = false}, SHIFT(134),
  [259] = {.count = 1, .reusable = true}, SHIFT(134),
  [261] = {.count = 1, .reusable = true}, SHIFT(135),
  [263] = {.count = 1, .reusable = true}, SHIFT(136),
  [265] = {.count = 1, .reusable = false}, SHIFT(1315),
  [267] = {.count = 1, .reusable = true}, SHIFT(1858),
  [269] = {.count = 1, .reusable = false}, SHIFT(1316),
  [271] = {.count = 1, .reusable = true}, SHIFT(139),
  [273] = {.count = 1, .reusable = false}, SHIFT(1859),
  [275] = {.count = 1, .reusable = false}, SHIFT(1317),
  [277] = {.count = 1, .reusable = false}, SHIFT(1296),
  [279] = {.count = 1, .reusable = false}, SHIFT(1297),
  [281] = {.count = 1, .reusable = true}, SHIFT(1298),
  [283] = {.count = 1, .reusable = false}, SHIFT(141),
  [285] = {.count = 1, .reusable = false}, SHIFT(1299),
  [287] = {.count = 1, .reusable = false}, SHIFT(1319),
  [289] = {.count = 1, .reusable = false}, SHIFT(1320),
  [291] = {.count = 1, .reusable = true}, SHIFT(2140),
  [293] = {.count = 1, .reusable = true}, SHIFT(1300),
  [295] = {.count = 1, .reusable = true}, SHIFT(1862),
  [297] = {.count = 1, .reusable = false}, SHIFT(1873),
  [299] = {.count = 1, .reusable = true}, SHIFT(138),
  [301] = {.count = 1, .reusable = true}, SHIFT(1874),
  [303] = {.count = 1, .reusable = true}, SHIFT(2326),
  [305] = {.count = 1, .reusable = true}, SHIFT(140),
  [307] = {.count = 1, .reusable = false}, SHIFT(1318),
  [309] = {.count = 1, .reusable = true}, SHIFT(2142),
  [311] = {.count = 1, .reusable = true}, SHIFT(2681),
  [313] = {.count = 1, .reusable = true}, SHIFT(141),
  [315] = {.count = 1, .reusable = false}, SHIFT(2330),
  [317] = {.count = 1, .reusable = false}, SHIFT(2347),
  [319] = {.count = 1, .reusable = false}, SHIFT(1865),
  [321] = {.count = 1, .reusable = false}, SHIFT(1301),
  [323] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [325] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [327] = {.count = 1, .reusable = false}, SHIFT(1327),
  [329] = {.count = 1, .reusable = true}, SHIFT(2233),
  [331] = {.count = 1, .reusable = true}, SHIFT(2235),
  [333] = {.count = 1, .reusable = false}, SHIFT(145),
  [335] = {.count = 1, .reusable = false}, SHIFT(147),
  [337] = {.count = 1, .reusable = false}, SHIFT(146),
  [339] = {.count = 1, .reusable = true}, SHIFT(148),
  [341] = {.count = 1, .reusable = true}, SHIFT(149),
  [343] = {.count = 1, .reusable = true}, SHIFT(158),
  [345] = {.count = 1, .reusable = true}, SHIFT(10),
  [347] = {.count = 1, .reusable = true}, SHIFT(13),
  [349] = {.count = 1, .reusable = true}, SHIFT(14),
  [351] = {.count = 1, .reusable = true}, SHIFT(21),
  [353] = {.count = 1, .reusable = true}, SHIFT(161),
  [355] = {.count = 1, .reusable = true}, SHIFT(162),
  [357] = {.count = 1, .reusable = true}, SHIFT(163),
  [359] = {.count = 1, .reusable = true}, SHIFT(155),
  [361] = {.count = 1, .reusable = true}, SHIFT(156),
  [363] = {.count = 1, .reusable = true}, SHIFT(157),
  [365] = {.count = 1, .reusable = true}, SHIFT(159),
  [367] = {.count = 1, .reusable = true}, SHIFT(37),
  [369] = {.count = 1, .reusable = true}, SHIFT(160),
  [371] = {.count = 1, .reusable = true}, SHIFT(46),
  [373] = {.count = 1, .reusable = false}, SHIFT(166),
  [375] = {.count = 1, .reusable = false}, SHIFT(167),
  [377] = {.count = 1, .reusable = true}, SHIFT(168),
  [379] = {.count = 1, .reusable = true}, SHIFT(169),
  [381] = {.count = 1, .reusable = false}, SHIFT(170),
  [383] = {.count = 1, .reusable = false}, SHIFT(171),
  [385] = {.count = 1, .reusable = false}, SHIFT(172),
  [387] = {.count = 1, .reusable = false}, SHIFT(173),
  [389] = {.count = 1, .reusable = true}, SHIFT(174),
  [391] = {.count = 1, .reusable = false}, SHIFT(175),
  [393] = {.count = 1, .reusable = false}, SHIFT(176),
  [395] = {.count = 1, .reusable = false}, SHIFT(177),
  [397] = {.count = 1, .reusable = true}, SHIFT(178),
  [399] = {.count = 1, .reusable = false}, SHIFT(179),
  [401] = {.count = 1, .reusable = false}, SHIFT(180),
  [403] = {.count = 1, .reusable = false}, SHIFT(181),
  [405] = {.count = 1, .reusable = true}, SHIFT(182),
  [407] = {.count = 1, .reusable = false}, SHIFT(183),
  [409] = {.count = 1, .reusable = false}, SHIFT(192),
  [411] = {.count = 1, .reusable = false}, SHIFT(194),
  [413] = {.count = 1, .reusable = true}, SHIFT(2674),
  [415] = {.count = 1, .reusable = false}, SHIFT(196),
  [417] = {.count = 1, .reusable = false}, SHIFT(197),
  [419] = {.count = 1, .reusable = false}, SHIFT(200),
  [421] = {.count = 1, .reusable = false}, SHIFT(205),
  [423] = {.count = 1, .reusable = false}, SHIFT(193),
  [425] = {.count = 1, .reusable = false}, SHIFT(201),
  [427] = {.count = 1, .reusable = true}, SHIFT(195),
  [429] = {.count = 1, .reusable = false}, SHIFT(198),
  [431] = {.count = 1, .reusable = true}, SHIFT(199),
  [433] = {.count = 1, .reusable = true}, SHIFT(205),
  [435] = {.count = 1, .reusable = false}, SHIFT(210),
  [437] = {.count = 1, .reusable = false}, SHIFT(211),
  [439] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(212),
  [442] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(148),
  [445] = {.count = 1, .reusable = false}, SHIFT(213),
  [447] = {.count = 1, .reusable = true}, SHIFT(96),
  [449] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [451] = {.count = 1, .reusable = false}, SHIFT(218),
  [453] = {.count = 1, .reusable = true}, SHIFT(218),
  [455] = {.count = 1, .reusable = true}, SHIFT(219),
  [457] = {.count = 1, .reusable = true}, SHIFT(221),
  [459] = {.count = 1, .reusable = false}, SHIFT(222),
  [461] = {.count = 1, .reusable = true}, SHIFT(223),
  [463] = {.count = 1, .reusable = false}, SHIFT(227),
  [465] = {.count = 1, .reusable = true}, SHIFT(228),
  [467] = {.count = 1, .reusable = true}, SHIFT(212),
  [469] = {.count = 1, .reusable = true}, SHIFT(229),
  [471] = {.count = 1, .reusable = false}, SHIFT(231),
  [473] = {.count = 1, .reusable = false}, SHIFT(234),
  [475] = {.count = 1, .reusable = false}, SHIFT(2532),
  [477] = {.count = 1, .reusable = false}, SHIFT(235),
  [479] = {.count = 1, .reusable = false}, SHIFT(2111),
  [481] = {.count = 1, .reusable = false}, SHIFT(2743),
  [483] = {.count = 1, .reusable = true}, SHIFT(2744),
  [485] = {.count = 1, .reusable = false}, SHIFT(232),
  [487] = {.count = 1, .reusable = false}, SHIFT(2745),
  [489] = {.count = 1, .reusable = false}, SHIFT(233),
  [491] = {.count = 1, .reusable = false}, SHIFT(237),
  [493] = {.count = 1, .reusable = true}, SHIFT(2746),
  [495] = {.count = 1, .reusable = false}, SHIFT(236),
  [497] = {.count = 1, .reusable = true}, SHIFT(232),
  [499] = {.count = 1, .reusable = false}, SHIFT(2747),
  [501] = {.count = 1, .reusable = false}, SHIFT(244),
  [503] = {.count = 1, .reusable = false}, SHIFT(246),
  [505] = {.count = 1, .reusable = true}, SHIFT(247),
  [507] = {.count = 1, .reusable = false}, SHIFT(248),
  [509] = {.count = 1, .reusable = true}, SHIFT(243),
  [511] = {.count = 1, .reusable = true}, SHIFT(245),
  [513] = {.count = 1, .reusable = false}, SHIFT(2314),
  [515] = {.count = 1, .reusable = false}, SHIFT(2315),
  [517] = {.count = 1, .reusable = false}, SHIFT(2316),
  [519] = {.count = 1, .reusable = false}, SHIFT(2320),
  [521] = {.count = 1, .reusable = false}, SHIFT(2795),
  [523] = {.count = 1, .reusable = false}, SHIFT(2321),
  [525] = {.count = 1, .reusable = false}, SHIFT(1860),
  [527] = {.count = 1, .reusable = false}, SHIFT(2322),
  [529] = {.count = 1, .reusable = false}, SHIFT(2323),
  [531] = {.count = 1, .reusable = false}, SHIFT(2324),
  [533] = {.count = 1, .reusable = false}, SHIFT(2325),
  [535] = {.count = 1, .reusable = true}, SHIFT(1863),
  [537] = {.count = 1, .reusable = false}, SHIFT(2327),
  [539] = {.count = 1, .reusable = false}, SHIFT(2329),
  [541] = {.count = 1, .reusable = false}, SHIFT(2682),
  [543] = {.count = 1, .reusable = false}, SHIFT(2332),
  [545] = {.count = 1, .reusable = false}, SHIFT(2333),
  [547] = {.count = 1, .reusable = false}, SHIFT(253),
  [549] = {.count = 1, .reusable = true}, SHIFT(253),
  [551] = {.count = 1, .reusable = true}, SHIFT(254),
  [553] = {.count = 1, .reusable = true}, SHIFT(255),
  [555] = {.count = 1, .reusable = false}, SHIFT(256),
  [557] = {.count = 1, .reusable = true}, SHIFT(260),
  [559] = {.count = 1, .reusable = true}, SHIFT(257),
  [561] = {.count = 1, .reusable = false}, SHIFT(258),
  [563] = {.count = 1, .reusable = false}, SHIFT(257),
  [565] = {.count = 1, .reusable = true}, SHIFT(259),
  [567] = {.count = 1, .reusable = false}, SHIFT(255),
  [569] = {.count = 1, .reusable = false}, SHIFT(259),
  [571] = {.count = 1, .reusable = true}, SHIFT(261),
  [573] = {.count = 1, .reusable = true}, SHIFT(256),
  [575] = {.count = 1, .reusable = true}, SHIFT(262),
  [577] = {.count = 1, .reusable = true}, SHIFT(263),
  [579] = {.count = 1, .reusable = false}, SHIFT(264),
  [581] = {.count = 1, .reusable = true}, SHIFT(265),
  [583] = {.count = 1, .reusable = false}, SHIFT(266),
  [585] = {.count = 1, .reusable = false}, SHIFT(267),
  [587] = {.count = 1, .reusable = false}, SHIFT(270),
  [589] = {.count = 1, .reusable = false}, SHIFT(268),
  [591] = {.count = 1, .reusable = false}, SHIFT(269),
  [593] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [595] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [597] = {.count = 1, .reusable = true}, SHIFT(272),
  [599] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [601] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2),
  [603] = {.count = 1, .reusable = true}, SHIFT(274),
  [605] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 3),
  [607] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 3),
  [609] = {.count = 1, .reusable = false}, SHIFT(277),
  [611] = {.count = 1, .reusable = true}, SHIFT(278),
  [613] = {.count = 1, .reusable = true}, SHIFT(279),
  [615] = {.count = 1, .reusable = false}, SHIFT(282),
  [617] = {.count = 1, .reusable = true}, SHIFT(2141),
  [619] = {.count = 1, .reusable = true}, SHIFT(282),
  [621] = {.count = 1, .reusable = false}, SHIFT(283),
  [623] = {.count = 1, .reusable = true}, SHIFT(283),
  [625] = {.count = 1, .reusable = false}, SHIFT(285),
  [627] = {.count = 1, .reusable = true}, SHIFT(285),
  [629] = {.count = 1, .reusable = true}, SHIFT(286),
  [631] = {.count = 1, .reusable = false}, SHIFT(288),
  [633] = {.count = 1, .reusable = true}, SHIFT(288),
  [635] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [637] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [639] = {.count = 1, .reusable = true}, SHIFT(289),
  [641] = {.count = 1, .reusable = true}, SHIFT(290),
  [643] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [647] = {.count = 1, .reusable = false}, SHIFT(292),
  [649] = {.count = 1, .reusable = true}, SHIFT(292),
  [651] = {.count = 1, .reusable = false}, SHIFT(293),
  [653] = {.count = 1, .reusable = true}, SHIFT(293),
  [655] = {.count = 1, .reusable = false}, SHIFT(294),
  [657] = {.count = 1, .reusable = true}, SHIFT(294),
  [659] = {.count = 1, .reusable = true}, SHIFT(295),
  [661] = {.count = 1, .reusable = true}, SHIFT(296),
  [663] = {.count = 1, .reusable = true}, SHIFT(1876),
  [665] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 4),
  [667] = {.count = 1, .reusable = true}, SHIFT(298),
  [669] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [671] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [673] = {.count = 1, .reusable = false}, SHIFT(300),
  [675] = {.count = 1, .reusable = false}, SHIFT(301),
  [677] = {.count = 1, .reusable = true}, SHIFT(1340),
  [679] = {.count = 1, .reusable = false}, SHIFT(302),
  [681] = {.count = 1, .reusable = false}, SHIFT(303),
  [683] = {.count = 1, .reusable = false}, SHIFT(305),
  [685] = {.count = 1, .reusable = true}, SHIFT(306),
  [687] = {.count = 1, .reusable = false}, SHIFT(304),
  [689] = {.count = 1, .reusable = true}, SHIFT(186),
  [691] = {.count = 1, .reusable = false}, SHIFT(309),
  [693] = {.count = 1, .reusable = true}, SHIFT(310),
  [695] = {.count = 1, .reusable = true}, SHIFT(311),
  [697] = {.count = 1, .reusable = false}, SHIFT(1638),
  [699] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [701] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [703] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(264),
  [706] = {.count = 1, .reusable = true}, SHIFT(312),
  [708] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [710] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [712] = {.count = 1, .reusable = true}, SHIFT(313),
  [714] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 6),
  [716] = {.count = 1, .reusable = true}, SHIFT(314),
  [718] = {.count = 1, .reusable = true}, SHIFT(1927),
  [720] = {.count = 1, .reusable = true}, SHIFT(317),
  [722] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 7),
  [724] = {.count = 1, .reusable = true}, SHIFT(321),
  [726] = {.count = 1, .reusable = true}, SHIFT(320),
  [728] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 8),
  [730] = {.count = 1, .reusable = false}, SHIFT(326),
  [732] = {.count = 1, .reusable = true}, SHIFT(326),
  [734] = {.count = 1, .reusable = false}, SHIFT(327),
  [736] = {.count = 1, .reusable = false}, SHIFT(328),
  [738] = {.count = 1, .reusable = true}, SHIFT(331),
  [740] = {.count = 1, .reusable = false}, SHIFT(333),
  [742] = {.count = 1, .reusable = false}, SHIFT(334),
  [744] = {.count = 1, .reusable = false}, SHIFT(337),
  [746] = {.count = 1, .reusable = true}, SHIFT(335),
  [748] = {.count = 1, .reusable = true}, SHIFT(336),
  [750] = {.count = 1, .reusable = false}, SHIFT(330),
  [752] = {.count = 1, .reusable = true}, SHIFT(340),
  [754] = {.count = 1, .reusable = true}, SHIFT(339),
  [756] = {.count = 1, .reusable = true}, SHIFT(330),
  [758] = {.count = 1, .reusable = true}, SHIFT(332),
  [760] = {.count = 1, .reusable = true}, SHIFT(329),
  [762] = {.count = 1, .reusable = false}, SHIFT(342),
  [764] = {.count = 1, .reusable = true}, SHIFT(328),
  [766] = {.count = 1, .reusable = false}, SHIFT(338),
  [768] = {.count = 1, .reusable = false}, SHIFT(348),
  [770] = {.count = 1, .reusable = true}, SHIFT(347),
  [772] = {.count = 1, .reusable = true}, SHIFT(348),
  [774] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 9),
  [776] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 9),
  [778] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [780] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [782] = {.count = 1, .reusable = true}, SHIFT(352),
  [784] = {.count = 1, .reusable = true}, SHIFT(2692),
  [786] = {.count = 1, .reusable = true}, SHIFT(356),
  [788] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [790] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [792] = {.count = 1, .reusable = true}, SHIFT(358),
  [794] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [796] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [798] = {.count = 1, .reusable = false}, SHIFT(1909),
  [800] = {.count = 1, .reusable = true}, SHIFT(1909),
  [802] = {.count = 1, .reusable = false}, SHIFT(360),
  [804] = {.count = 1, .reusable = true}, SHIFT(360),
  [806] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [808] = {.count = 1, .reusable = true}, SHIFT(361),
  [810] = {.count = 1, .reusable = true}, SHIFT(362),
  [812] = {.count = 1, .reusable = true}, SHIFT(363),
  [814] = {.count = 1, .reusable = true}, SHIFT(366),
  [816] = {.count = 1, .reusable = true}, SHIFT(365),
  [818] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [820] = {.count = 1, .reusable = true}, SHIFT(124),
  [822] = {.count = 1, .reusable = true}, SHIFT(367),
  [824] = {.count = 1, .reusable = true}, SHIFT(370),
  [826] = {.count = 1, .reusable = false}, SHIFT(371),
  [828] = {.count = 1, .reusable = true}, SHIFT(372),
  [830] = {.count = 1, .reusable = false}, SHIFT(373),
  [832] = {.count = 1, .reusable = true}, SHIFT(374),
  [834] = {.count = 1, .reusable = true}, SHIFT(376),
  [836] = {.count = 1, .reusable = true}, SHIFT(377),
  [838] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 6),
  [840] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 6),
  [842] = {.count = 1, .reusable = false}, SHIFT(378),
  [844] = {.count = 1, .reusable = true}, SHIFT(1916),
  [846] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 10),
  [848] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 10),
  [850] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [852] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [854] = {.count = 1, .reusable = false}, SHIFT(381),
  [856] = {.count = 1, .reusable = true}, SHIFT(381),
  [858] = {.count = 1, .reusable = false}, SHIFT(380),
  [860] = {.count = 1, .reusable = false}, SHIFT(382),
  [862] = {.count = 1, .reusable = false}, SHIFT(383),
  [864] = {.count = 1, .reusable = false}, SHIFT(384),
  [866] = {.count = 1, .reusable = false}, SHIFT(385),
  [868] = {.count = 1, .reusable = false}, SHIFT(388),
  [870] = {.count = 1, .reusable = false}, SHIFT(386),
  [872] = {.count = 1, .reusable = false}, SHIFT(387),
  [874] = {.count = 1, .reusable = true}, SHIFT(393),
  [876] = {.count = 1, .reusable = false}, SHIFT(396),
  [878] = {.count = 1, .reusable = true}, SHIFT(396),
  [880] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [882] = {.count = 1, .reusable = false}, SHIFT(397),
  [884] = {.count = 1, .reusable = true}, SHIFT(397),
  [886] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [888] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [890] = {.count = 1, .reusable = true}, SHIFT(1365),
  [892] = {.count = 1, .reusable = true}, SHIFT(2353),
  [894] = {.count = 1, .reusable = false}, SHIFT(1366),
  [896] = {.count = 1, .reusable = true}, SHIFT(1367),
  [898] = {.count = 1, .reusable = false}, SHIFT(1368),
  [900] = {.count = 1, .reusable = false}, SHIFT(1367),
  [902] = {.count = 1, .reusable = true}, SHIFT(1369),
  [904] = {.count = 1, .reusable = false}, SHIFT(1365),
  [906] = {.count = 1, .reusable = true}, SHIFT(399),
  [908] = {.count = 1, .reusable = false}, SHIFT(1369),
  [910] = {.count = 1, .reusable = true}, SHIFT(2386),
  [912] = {.count = 1, .reusable = true}, SHIFT(1366),
  [914] = {.count = 1, .reusable = true}, SHIFT(1923),
  [916] = {.count = 1, .reusable = true}, SHIFT(1371),
  [918] = {.count = 1, .reusable = false}, SHIFT(1372),
  [920] = {.count = 1, .reusable = true}, SHIFT(1870),
  [922] = {.count = 1, .reusable = true}, SHIFT(1373),
  [924] = {.count = 1, .reusable = false}, SHIFT(1374),
  [926] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 10),
  [928] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 10),
  [930] = {.count = 1, .reusable = false}, SHIFT(2484),
  [932] = {.count = 1, .reusable = false}, SHIFT(402),
  [934] = {.count = 1, .reusable = false}, SHIFT(404),
  [936] = {.count = 1, .reusable = false}, SHIFT(2492),
  [938] = {.count = 1, .reusable = false}, SHIFT(2480),
  [940] = {.count = 1, .reusable = false}, SHIFT(2609),
  [942] = {.count = 1, .reusable = false}, SHIFT(2493),
  [944] = {.count = 1, .reusable = false}, SHIFT(2494),
  [946] = {.count = 1, .reusable = true}, SHIFT(2481),
  [948] = {.count = 1, .reusable = true}, SHIFT(404),
  [950] = {.count = 1, .reusable = false}, SHIFT(2482),
  [952] = {.count = 1, .reusable = false}, SHIFT(2540),
  [954] = {.count = 1, .reusable = false}, SHIFT(2143),
  [956] = {.count = 1, .reusable = false}, SHIFT(2495),
  [958] = {.count = 1, .reusable = true}, SHIFT(2483),
  [960] = {.count = 1, .reusable = true}, SHIFT(145),
  [962] = {.count = 1, .reusable = true}, SHIFT(146),
  [964] = {.count = 1, .reusable = true}, SHIFT(2147),
  [966] = {.count = 1, .reusable = true}, SHIFT(410),
  [968] = {.count = 1, .reusable = false}, SHIFT(412),
  [970] = {.count = 1, .reusable = true}, SHIFT(414),
  [972] = {.count = 1, .reusable = true}, SHIFT(416),
  [974] = {.count = 1, .reusable = false}, SHIFT(413),
  [976] = {.count = 1, .reusable = false}, SHIFT(419),
  [978] = {.count = 1, .reusable = false}, SHIFT(420),
  [980] = {.count = 1, .reusable = false}, SHIFT(411),
  [982] = {.count = 1, .reusable = true}, SHIFT(415),
  [984] = {.count = 1, .reusable = true}, SHIFT(2282),
  [986] = {.count = 1, .reusable = true}, SHIFT(425),
  [988] = {.count = 1, .reusable = false}, SHIFT(417),
  [990] = {.count = 1, .reusable = false}, SHIFT(418),
  [992] = {.count = 1, .reusable = true}, SHIFT(2281),
  [994] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [996] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 11),
  [998] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 11),
  [1000] = {.count = 1, .reusable = true}, SHIFT(1327),
  [1002] = {.count = 1, .reusable = true}, SHIFT(430),
  [1004] = {.count = 1, .reusable = true}, SHIFT(431),
  [1006] = {.count = 1, .reusable = true}, SHIFT(433),
  [1008] = {.count = 1, .reusable = true}, SHIFT(434),
  [1010] = {.count = 1, .reusable = true}, SHIFT(435),
  [1012] = {.count = 1, .reusable = true}, SHIFT(121),
  [1014] = {.count = 1, .reusable = true}, SHIFT(436),
  [1016] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [1018] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [1020] = {.count = 1, .reusable = true}, SHIFT(437),
  [1022] = {.count = 1, .reusable = false}, SHIFT(439),
  [1024] = {.count = 1, .reusable = true}, SHIFT(438),
  [1026] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 12), SHIFT(68),
  [1029] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1032] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1035] = {.count = 1, .reusable = false}, SHIFT(441),
  [1037] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1040] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1043] = {.count = 1, .reusable = false}, SHIFT(443),
  [1045] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [1047] = {.count = 1, .reusable = false}, SHIFT(445),
  [1049] = {.count = 1, .reusable = false}, SHIFT(446),
  [1051] = {.count = 1, .reusable = false}, SHIFT(444),
  [1053] = {.count = 1, .reusable = false}, SHIFT(442),
  [1055] = {.count = 1, .reusable = false}, SHIFT(1424),
  [1057] = {.count = 1, .reusable = true}, SHIFT(448),
  [1059] = {.count = 1, .reusable = true}, SHIFT(449),
  [1061] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [1063] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [1065] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(450),
  [1068] = {.count = 1, .reusable = false}, SHIFT(452),
  [1070] = {.count = 1, .reusable = false}, SHIFT(453),
  [1072] = {.count = 1, .reusable = false}, SHIFT(451),
  [1074] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(448),
  [1077] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1079] = {.count = 1, .reusable = true}, SHIFT(454),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1083] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1085] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1087] = {.count = 1, .reusable = true}, SHIFT(450),
  [1089] = {.count = 1, .reusable = false}, SHIFT(455),
  [1091] = {.count = 1, .reusable = true}, SHIFT(455),
  [1093] = {.count = 1, .reusable = false}, SHIFT(457),
  [1095] = {.count = 1, .reusable = false}, SHIFT(458),
  [1097] = {.count = 1, .reusable = false}, SHIFT(456),
  [1099] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12), SHIFT(212),
  [1103] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12), SHIFT(148),
  [1107] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1110] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [1115] = {.count = 1, .reusable = false}, SHIFT(459),
  [1117] = {.count = 1, .reusable = true}, SHIFT(460),
  [1119] = {.count = 1, .reusable = false}, SHIFT(462),
  [1121] = {.count = 1, .reusable = true}, SHIFT(463),
  [1123] = {.count = 1, .reusable = true}, SHIFT(464),
  [1125] = {.count = 1, .reusable = true}, SHIFT(466),
  [1127] = {.count = 1, .reusable = false}, SHIFT(467),
  [1129] = {.count = 1, .reusable = false}, SHIFT(469),
  [1131] = {.count = 1, .reusable = true}, SHIFT(470),
  [1133] = {.count = 1, .reusable = true}, SHIFT(1309),
  [1135] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [1138] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(1310),
  [1141] = {.count = 1, .reusable = true}, SHIFT(1308),
  [1143] = {.count = 1, .reusable = false}, SHIFT(472),
  [1145] = {.count = 1, .reusable = false}, SHIFT(473),
  [1147] = {.count = 1, .reusable = true}, SHIFT(1313),
  [1149] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1152] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(1314),
  [1155] = {.count = 1, .reusable = true}, SHIFT(1312),
  [1157] = {.count = 1, .reusable = true}, SHIFT(1872),
  [1159] = {.count = 1, .reusable = true}, SHIFT(476),
  [1161] = {.count = 1, .reusable = false}, SHIFT(1322),
  [1163] = {.count = 1, .reusable = false}, SHIFT(1872),
  [1165] = {.count = 1, .reusable = false}, SHIFT(1300),
  [1167] = {.count = 1, .reusable = false}, SHIFT(2681),
  [1169] = {.count = 1, .reusable = true}, SHIFT(1322),
  [1171] = {.count = 1, .reusable = false}, SHIFT(1910),
  [1173] = {.count = 1, .reusable = false}, SHIFT(1911),
  [1175] = {.count = 1, .reusable = false}, SHIFT(2392),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [1179] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [1181] = {.count = 1, .reusable = false}, SHIFT(1727),
  [1183] = {.count = 1, .reusable = true}, SHIFT(478),
  [1185] = {.count = 1, .reusable = true}, SHIFT(477),
  [1187] = {.count = 1, .reusable = true}, SHIFT(1396),
  [1189] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [1191] = {.count = 1, .reusable = true}, SHIFT(480),
  [1193] = {.count = 1, .reusable = true}, SHIFT(483),
  [1195] = {.count = 1, .reusable = true}, SHIFT(1370),
  [1197] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 13),
  [1200] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 13), SHIFT(1380),
  [1203] = {.count = 1, .reusable = false}, SHIFT(485),
  [1205] = {.count = 1, .reusable = false}, SHIFT(203),
  [1207] = {.count = 1, .reusable = false}, SHIFT(486),
  [1209] = {.count = 1, .reusable = false}, SHIFT(1941),
  [1211] = {.count = 1, .reusable = false}, SHIFT(487),
  [1213] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 14),
  [1216] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 14), SHIFT(1375),
  [1219] = {.count = 1, .reusable = true}, SHIFT(491),
  [1221] = {.count = 1, .reusable = true}, SHIFT(492),
  [1223] = {.count = 1, .reusable = true}, SHIFT(494),
  [1225] = {.count = 1, .reusable = true}, SHIFT(495),
  [1227] = {.count = 1, .reusable = true}, SHIFT(497),
  [1229] = {.count = 1, .reusable = true}, SHIFT(498),
  [1231] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [1233] = {.count = 1, .reusable = false}, SHIFT(501),
  [1235] = {.count = 1, .reusable = true}, SHIFT(501),
  [1237] = {.count = 1, .reusable = true}, SHIFT(502),
  [1239] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [1241] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [1243] = {.count = 1, .reusable = false}, SHIFT(503),
  [1245] = {.count = 1, .reusable = false}, SHIFT(504),
  [1247] = {.count = 1, .reusable = false}, SHIFT(508),
  [1249] = {.count = 1, .reusable = false}, SHIFT(507),
  [1251] = {.count = 1, .reusable = false}, SHIFT(510),
  [1253] = {.count = 1, .reusable = true}, SHIFT(102),
  [1255] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 15),
  [1257] = {.count = 1, .reusable = false}, SHIFT(514),
  [1259] = {.count = 1, .reusable = true}, SHIFT(1925),
  [1261] = {.count = 1, .reusable = true}, SHIFT(509),
  [1263] = {.count = 1, .reusable = true}, SHIFT(511),
  [1265] = {.count = 1, .reusable = false}, SHIFT(512),
  [1267] = {.count = 1, .reusable = true}, SHIFT(2164),
  [1269] = {.count = 1, .reusable = true}, SHIFT(510),
  [1271] = {.count = 2, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 15), SHIFT(513),
  [1274] = {.count = 1, .reusable = true}, SHIFT(521),
  [1276] = {.count = 1, .reusable = true}, SHIFT(513),
  [1278] = {.count = 1, .reusable = true}, SHIFT(523),
  [1280] = {.count = 1, .reusable = true}, SHIFT(522),
  [1282] = {.count = 1, .reusable = false}, SHIFT(525),
  [1284] = {.count = 1, .reusable = true}, SHIFT(1351),
  [1286] = {.count = 1, .reusable = true}, SHIFT(527),
  [1288] = {.count = 1, .reusable = true}, SHIFT(2152),
  [1290] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [1292] = {.count = 1, .reusable = true}, SHIFT(2486),
  [1294] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [1296] = {.count = 1, .reusable = false}, SHIFT(2487),
  [1298] = {.count = 1, .reusable = true}, SHIFT(531),
  [1300] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 17),
  [1302] = {.count = 1, .reusable = true}, SHIFT(2489),
  [1304] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 17),
  [1306] = {.count = 1, .reusable = false}, SHIFT(2490),
  [1308] = {.count = 1, .reusable = false}, SHIFT(2576),
  [1310] = {.count = 1, .reusable = false}, SHIFT(2497),
  [1312] = {.count = 1, .reusable = false}, SHIFT(2578),
  [1314] = {.count = 1, .reusable = false}, SHIFT(2533),
  [1316] = {.count = 1, .reusable = false}, SHIFT(2491),
  [1318] = {.count = 1, .reusable = false}, SHIFT(2577),
  [1320] = {.count = 1, .reusable = false}, SHIFT(2579),
  [1322] = {.count = 1, .reusable = true}, SHIFT(2497),
  [1324] = {.count = 1, .reusable = true}, SHIFT(2507),
  [1326] = {.count = 1, .reusable = false}, SHIFT(2508),
  [1328] = {.count = 1, .reusable = true}, SHIFT(2509),
  [1330] = {.count = 1, .reusable = false}, SHIFT(2510),
  [1332] = {.count = 1, .reusable = false}, SHIFT(2509),
  [1334] = {.count = 1, .reusable = true}, SHIFT(2511),
  [1336] = {.count = 1, .reusable = false}, SHIFT(2507),
  [1338] = {.count = 1, .reusable = false}, SHIFT(2511),
  [1340] = {.count = 1, .reusable = true}, SHIFT(2547),
  [1342] = {.count = 1, .reusable = true}, SHIFT(2508),
  [1344] = {.count = 1, .reusable = false}, SHIFT(2112),
  [1346] = {.count = 1, .reusable = true}, SHIFT(2512),
  [1348] = {.count = 1, .reusable = false}, SHIFT(2515),
  [1350] = {.count = 1, .reusable = false}, SHIFT(2513),
  [1352] = {.count = 1, .reusable = true}, SHIFT(535),
  [1354] = {.count = 1, .reusable = true}, SHIFT(536),
  [1356] = {.count = 1, .reusable = false}, SHIFT(538),
  [1358] = {.count = 1, .reusable = false}, SHIFT(2343),
  [1360] = {.count = 1, .reusable = false}, SHIFT(2344),
  [1362] = {.count = 1, .reusable = false}, SHIFT(2675),
  [1364] = {.count = 1, .reusable = false}, SHIFT(2345),
  [1366] = {.count = 1, .reusable = false}, SHIFT(2676),
  [1368] = {.count = 1, .reusable = true}, SHIFT(2677),
  [1370] = {.count = 1, .reusable = false}, SHIFT(539),
  [1372] = {.count = 1, .reusable = false}, SHIFT(2678),
  [1374] = {.count = 1, .reusable = false}, SHIFT(2348),
  [1376] = {.count = 1, .reusable = true}, SHIFT(2680),
  [1378] = {.count = 1, .reusable = false}, SHIFT(2346),
  [1380] = {.count = 1, .reusable = true}, SHIFT(539),
  [1382] = {.count = 1, .reusable = false}, SHIFT(2683),
  [1384] = {.count = 1, .reusable = false}, SHIFT(2684),
  [1386] = {.count = 1, .reusable = true}, SHIFT(540),
  [1388] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 18),
  [1390] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 18),
  [1392] = {.count = 1, .reusable = true}, SHIFT(541),
  [1394] = {.count = 1, .reusable = true}, SHIFT(542),
  [1396] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [1398] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1400] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1402] = {.count = 1, .reusable = false}, SHIFT(544),
  [1404] = {.count = 1, .reusable = true}, SHIFT(544),
  [1406] = {.count = 1, .reusable = false}, SHIFT(545),
  [1408] = {.count = 1, .reusable = true}, SHIFT(545),
  [1410] = {.count = 1, .reusable = false}, SHIFT(546),
  [1412] = {.count = 1, .reusable = true}, SHIFT(546),
  [1414] = {.count = 1, .reusable = false}, SHIFT(547),
  [1416] = {.count = 1, .reusable = true}, SHIFT(547),
  [1418] = {.count = 1, .reusable = false}, SHIFT(548),
  [1420] = {.count = 1, .reusable = true}, SHIFT(548),
  [1422] = {.count = 1, .reusable = false}, SHIFT(550),
  [1424] = {.count = 1, .reusable = true}, SHIFT(550),
  [1426] = {.count = 1, .reusable = false}, SHIFT(551),
  [1428] = {.count = 1, .reusable = true}, SHIFT(551),
  [1430] = {.count = 1, .reusable = false}, SHIFT(1398),
  [1432] = {.count = 1, .reusable = false}, SHIFT(1399),
  [1434] = {.count = 1, .reusable = true}, SHIFT(2397),
  [1436] = {.count = 1, .reusable = false}, SHIFT(1402),
  [1438] = {.count = 1, .reusable = false}, SHIFT(1947),
  [1440] = {.count = 1, .reusable = false}, SHIFT(1949),
  [1442] = {.count = 1, .reusable = true}, SHIFT(1948),
  [1444] = {.count = 1, .reusable = true}, SHIFT(1403),
  [1446] = {.count = 1, .reusable = false}, SHIFT(1946),
  [1448] = {.count = 1, .reusable = true}, SHIFT(1404),
  [1450] = {.count = 1, .reusable = true}, SHIFT(2400),
  [1452] = {.count = 1, .reusable = true}, SHIFT(1946),
  [1454] = {.count = 1, .reusable = true}, SHIFT(1401),
  [1456] = {.count = 1, .reusable = true}, SHIFT(1400),
  [1458] = {.count = 1, .reusable = false}, SHIFT(1405),
  [1460] = {.count = 1, .reusable = true}, SHIFT(1399),
  [1462] = {.count = 1, .reusable = false}, SHIFT(2399),
  [1464] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [1466] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [1468] = {.count = 1, .reusable = false}, SHIFT(554),
  [1470] = {.count = 1, .reusable = false}, SHIFT(557),
  [1472] = {.count = 1, .reusable = false}, SHIFT(559),
  [1474] = {.count = 1, .reusable = false}, SHIFT(561),
  [1476] = {.count = 1, .reusable = false}, SHIFT(563),
  [1478] = {.count = 1, .reusable = false}, SHIFT(555),
  [1480] = {.count = 1, .reusable = true}, SHIFT(556),
  [1482] = {.count = 1, .reusable = false}, SHIFT(558),
  [1484] = {.count = 1, .reusable = false}, SHIFT(560),
  [1486] = {.count = 1, .reusable = true}, SHIFT(562),
  [1488] = {.count = 1, .reusable = true}, SHIFT(555),
  [1490] = {.count = 1, .reusable = false}, SHIFT(564),
  [1492] = {.count = 1, .reusable = false}, SHIFT(567),
  [1494] = {.count = 1, .reusable = true}, SHIFT(567),
  [1496] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [1498] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [1500] = {.count = 1, .reusable = false}, SHIFT(568),
  [1502] = {.count = 1, .reusable = true}, SHIFT(568),
  [1504] = {.count = 1, .reusable = false}, SHIFT(569),
  [1506] = {.count = 1, .reusable = false}, SHIFT(570),
  [1508] = {.count = 1, .reusable = true}, SHIFT(2544),
  [1510] = {.count = 1, .reusable = false}, SHIFT(573),
  [1512] = {.count = 1, .reusable = true}, SHIFT(2691),
  [1514] = {.count = 1, .reusable = true}, SHIFT(571),
  [1516] = {.count = 1, .reusable = true}, SHIFT(573),
  [1518] = {.count = 1, .reusable = false}, SHIFT(574),
  [1520] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [1522] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [1524] = {.count = 1, .reusable = false}, SHIFT(577),
  [1526] = {.count = 1, .reusable = true}, SHIFT(577),
  [1528] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [1530] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22),
  [1532] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1535] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1538] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1541] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1547] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1550] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1553] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1556] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1559] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1562] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1565] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1567] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1570] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [1572] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1575] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1578] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1584] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1587] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(51),
  [1590] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1593] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1596] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1599] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1602] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1605] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1608] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(25),
  [1611] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(26),
  [1614] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(27),
  [1617] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(28),
  [1620] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [1623] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [1626] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [1629] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1632] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(33),
  [1635] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(34),
  [1638] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [1641] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [1644] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [1647] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(39),
  [1650] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(40),
  [1653] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(41),
  [1656] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1659] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(51),
  [1662] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(43),
  [1665] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [1668] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [1671] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(46),
  [1674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [1677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(48),
  [1680] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(49),
  [1683] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(50),
  [1686] = {.count = 1, .reusable = false}, SHIFT(580),
  [1688] = {.count = 1, .reusable = true}, SHIFT(580),
  [1690] = {.count = 1, .reusable = true}, SHIFT(581),
  [1692] = {.count = 1, .reusable = false}, SHIFT(583),
  [1694] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [1696] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(6),
  [1699] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 24),
  [1701] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 24),
  [1703] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 25),
  [1705] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 26),
  [1707] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 26),
  [1709] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [1711] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 27),
  [1713] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 27),
  [1715] = {.count = 1, .reusable = true}, SHIFT(586),
  [1717] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [1719] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [1721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(71),
  [1724] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(290),
  [1727] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [1729] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 28),
  [1731] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 28),
  [1733] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 29),
  [1735] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 29),
  [1737] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 30),
  [1739] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 30),
  [1741] = {.count = 1, .reusable = true}, SHIFT(587),
  [1743] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 31),
  [1745] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 31),
  [1747] = {.count = 1, .reusable = true}, SHIFT(588),
  [1749] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 9),
  [1751] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 9),
  [1753] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 12),
  [1755] = {.count = 1, .reusable = true}, SHIFT(592),
  [1757] = {.count = 1, .reusable = true}, SHIFT(593),
  [1759] = {.count = 1, .reusable = true}, SHIFT(594),
  [1761] = {.count = 1, .reusable = true}, SHIFT(595),
  [1763] = {.count = 1, .reusable = true}, SHIFT(596),
  [1765] = {.count = 1, .reusable = true}, SHIFT(598),
  [1767] = {.count = 1, .reusable = false}, SHIFT(599),
  [1769] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 32),
  [1771] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 32),
  [1773] = {.count = 1, .reusable = false}, SHIFT(600),
  [1775] = {.count = 1, .reusable = true}, SHIFT(600),
  [1777] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [1779] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [1781] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [1783] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 36),
  [1785] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [1787] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [1789] = {.count = 1, .reusable = true}, SHIFT(605),
  [1791] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 37),
  [1793] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 38),
  [1795] = {.count = 1, .reusable = true}, SHIFT(608),
  [1797] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 15),
  [1799] = {.count = 1, .reusable = true}, SHIFT(610),
  [1801] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 15),
  [1803] = {.count = 1, .reusable = true}, SHIFT(609),
  [1805] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [1807] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [1809] = {.count = 1, .reusable = true}, SHIFT(612),
  [1811] = {.count = 1, .reusable = false}, SHIFT(613),
  [1813] = {.count = 1, .reusable = true}, SHIFT(614),
  [1815] = {.count = 1, .reusable = true}, SHIFT(615),
  [1817] = {.count = 1, .reusable = false}, SHIFT(618),
  [1819] = {.count = 1, .reusable = false}, SHIFT(616),
  [1821] = {.count = 1, .reusable = false}, SHIFT(617),
  [1823] = {.count = 1, .reusable = true}, SHIFT(619),
  [1825] = {.count = 1, .reusable = true}, SHIFT(626),
  [1827] = {.count = 1, .reusable = false}, SHIFT(620),
  [1829] = {.count = 1, .reusable = false}, SHIFT(621),
  [1831] = {.count = 1, .reusable = false}, SHIFT(622),
  [1833] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [1835] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [1837] = {.count = 1, .reusable = true}, SHIFT(629),
  [1839] = {.count = 1, .reusable = true}, SHIFT(630),
  [1841] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [1843] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [1845] = {.count = 1, .reusable = true}, SHIFT(631),
  [1847] = {.count = 1, .reusable = false}, SHIFT(635),
  [1849] = {.count = 1, .reusable = false}, SHIFT(636),
  [1851] = {.count = 1, .reusable = false}, SHIFT(637),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1461),
  [1855] = {.count = 1, .reusable = false}, SHIFT(1990),
  [1857] = {.count = 1, .reusable = true}, SHIFT(640),
  [1859] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [1861] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [1863] = {.count = 1, .reusable = true}, SHIFT(641),
  [1865] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [1867] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [1869] = {.count = 1, .reusable = true}, SHIFT(644),
  [1871] = {.count = 1, .reusable = true}, SHIFT(643),
  [1873] = {.count = 1, .reusable = true}, SHIFT(645),
  [1875] = {.count = 1, .reusable = true}, SHIFT(646),
  [1877] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [1879] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [1881] = {.count = 1, .reusable = true}, SHIFT(649),
  [1883] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 39),
  [1885] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 39),
  [1887] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [1889] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [1891] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 40),
  [1893] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 40),
  [1895] = {.count = 1, .reusable = true}, SHIFT(654),
  [1897] = {.count = 1, .reusable = true}, SHIFT(655),
  [1899] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 41),
  [1901] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 41),
  [1903] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 32),
  [1905] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 32),
  [1907] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 42),
  [1909] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 42),
  [1911] = {.count = 1, .reusable = false}, SHIFT(657),
  [1913] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [1915] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [1917] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [1919] = {.count = 1, .reusable = true}, SHIFT(2238),
  [1921] = {.count = 1, .reusable = false}, SHIFT(1645),
  [1923] = {.count = 1, .reusable = false}, SHIFT(1646),
  [1925] = {.count = 1, .reusable = true}, SHIFT(2548),
  [1927] = {.count = 1, .reusable = false}, SHIFT(1649),
  [1929] = {.count = 1, .reusable = false}, SHIFT(2156),
  [1931] = {.count = 1, .reusable = false}, SHIFT(2158),
  [1933] = {.count = 1, .reusable = true}, SHIFT(2157),
  [1935] = {.count = 1, .reusable = true}, SHIFT(1650),
  [1937] = {.count = 1, .reusable = false}, SHIFT(2155),
  [1939] = {.count = 1, .reusable = true}, SHIFT(1651),
  [1941] = {.count = 1, .reusable = true}, SHIFT(2550),
  [1943] = {.count = 1, .reusable = true}, SHIFT(2155),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1648),
  [1947] = {.count = 1, .reusable = true}, SHIFT(1647),
  [1949] = {.count = 1, .reusable = false}, SHIFT(1652),
  [1951] = {.count = 1, .reusable = true}, SHIFT(1646),
  [1953] = {.count = 1, .reusable = false}, SHIFT(2549),
  [1955] = {.count = 1, .reusable = true}, SHIFT(662),
  [1957] = {.count = 1, .reusable = false}, SHIFT(665),
  [1959] = {.count = 1, .reusable = false}, SHIFT(664),
  [1961] = {.count = 1, .reusable = true}, SHIFT(666),
  [1963] = {.count = 1, .reusable = true}, SHIFT(667),
  [1965] = {.count = 1, .reusable = true}, SHIFT(669),
  [1967] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 6),
  [1969] = {.count = 1, .reusable = true}, SHIFT(670),
  [1971] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [1973] = {.count = 1, .reusable = true}, SHIFT(671),
  [1975] = {.count = 1, .reusable = true}, SHIFT(672),
  [1977] = {.count = 1, .reusable = true}, SHIFT(673),
  [1979] = {.count = 1, .reusable = true}, SHIFT(674),
  [1981] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [1983] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [1985] = {.count = 1, .reusable = true}, SHIFT(677),
  [1987] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 43),
  [1989] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 43),
  [1991] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1993] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1995] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(381),
  [1998] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(381),
  [2001] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2003] = {.count = 1, .reusable = true}, SHIFT(678),
  [2005] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(678),
  [2008] = {.count = 1, .reusable = true}, SHIFT(679),
  [2010] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(679),
  [2013] = {.count = 1, .reusable = false}, SHIFT(679),
  [2015] = {.count = 1, .reusable = false}, SHIFT(680),
  [2017] = {.count = 1, .reusable = false}, SHIFT(1920),
  [2019] = {.count = 1, .reusable = false}, SHIFT(681),
  [2021] = {.count = 1, .reusable = false}, SHIFT(682),
  [2023] = {.count = 1, .reusable = false}, SHIFT(683),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1920),
  [2027] = {.count = 1, .reusable = false}, SHIFT(684),
  [2029] = {.count = 1, .reusable = true}, SHIFT(689),
  [2031] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(689),
  [2034] = {.count = 1, .reusable = true}, SHIFT(690),
  [2036] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(690),
  [2039] = {.count = 1, .reusable = false}, SHIFT(1414),
  [2041] = {.count = 1, .reusable = false}, SHIFT(1415),
  [2043] = {.count = 1, .reusable = false}, SHIFT(1416),
  [2045] = {.count = 1, .reusable = false}, SHIFT(691),
  [2047] = {.count = 1, .reusable = false}, SHIFT(1417),
  [2049] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2051] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 44),
  [2053] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 44),
  [2055] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [2057] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [2059] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [2061] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [2063] = {.count = 1, .reusable = true}, SHIFT(693),
  [2065] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(139),
  [2068] = {.count = 1, .reusable = true}, SHIFT(2570),
  [2070] = {.count = 1, .reusable = true}, SHIFT(694),
  [2072] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 45),
  [2074] = {.count = 1, .reusable = false}, SHIFT(2571),
  [2076] = {.count = 1, .reusable = true}, SHIFT(2485),
  [2078] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(2354),
  [2081] = {.count = 1, .reusable = true}, SHIFT(695),
  [2083] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [2085] = {.count = 1, .reusable = true}, SHIFT(2590),
  [2087] = {.count = 1, .reusable = false}, SHIFT(2591),
  [2089] = {.count = 1, .reusable = true}, SHIFT(2592),
  [2091] = {.count = 1, .reusable = false}, SHIFT(2593),
  [2093] = {.count = 1, .reusable = true}, SHIFT(2594),
  [2095] = {.count = 1, .reusable = false}, SHIFT(2592),
  [2097] = {.count = 1, .reusable = false}, SHIFT(2590),
  [2099] = {.count = 1, .reusable = false}, SHIFT(2594),
  [2101] = {.count = 1, .reusable = true}, SHIFT(2619),
  [2103] = {.count = 1, .reusable = true}, SHIFT(2591),
  [2105] = {.count = 1, .reusable = false}, SHIFT(2210),
  [2107] = {.count = 1, .reusable = true}, SHIFT(2595),
  [2109] = {.count = 1, .reusable = true}, SHIFT(2354),
  [2111] = {.count = 1, .reusable = true}, SHIFT(698),
  [2113] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [2115] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 40),
  [2117] = {.count = 1, .reusable = true}, SHIFT(700),
  [2119] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 40),
  [2121] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 40),
  [2123] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 40),
  [2125] = {.count = 1, .reusable = true}, SHIFT(512),
  [2127] = {.count = 1, .reusable = true}, SHIFT(704),
  [2129] = {.count = 1, .reusable = false}, SHIFT(705),
  [2131] = {.count = 1, .reusable = false}, SHIFT(706),
  [2133] = {.count = 1, .reusable = false}, SHIFT(707),
  [2135] = {.count = 1, .reusable = false}, SHIFT(710),
  [2137] = {.count = 1, .reusable = false}, SHIFT(709),
  [2139] = {.count = 1, .reusable = false}, SHIFT(708),
  [2141] = {.count = 1, .reusable = true}, SHIFT(710),
  [2143] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [2145] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [2147] = {.count = 1, .reusable = false}, SHIFT(712),
  [2149] = {.count = 1, .reusable = true}, SHIFT(2415),
  [2151] = {.count = 1, .reusable = true}, SHIFT(715),
  [2153] = {.count = 1, .reusable = true}, SHIFT(714),
  [2155] = {.count = 1, .reusable = false}, SHIFT(713),
  [2157] = {.count = 1, .reusable = false}, SHIFT(716),
  [2159] = {.count = 1, .reusable = false}, SHIFT(718),
  [2161] = {.count = 1, .reusable = true}, SHIFT(719),
  [2163] = {.count = 1, .reusable = true}, SHIFT(717),
  [2165] = {.count = 1, .reusable = false}, SHIFT(1507),
  [2167] = {.count = 1, .reusable = false}, SHIFT(720),
  [2169] = {.count = 1, .reusable = true}, SHIFT(721),
  [2171] = {.count = 1, .reusable = true}, SHIFT(722),
  [2173] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2175] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2177] = {.count = 1, .reusable = false}, SHIFT(726),
  [2179] = {.count = 1, .reusable = false}, SHIFT(725),
  [2181] = {.count = 1, .reusable = false}, SHIFT(724),
  [2183] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 6),
  [2185] = {.count = 1, .reusable = true}, SHIFT(727),
  [2187] = {.count = 1, .reusable = true}, SHIFT(728),
  [2189] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [2191] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 46),
  [2193] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 46),
  [2195] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 47),
  [2197] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 47),
  [2199] = {.count = 1, .reusable = true}, SHIFT(733),
  [2201] = {.count = 1, .reusable = true}, SHIFT(2284),
  [2203] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2205] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2207] = {.count = 1, .reusable = true}, SHIFT(737),
  [2209] = {.count = 1, .reusable = true}, SHIFT(738),
  [2211] = {.count = 1, .reusable = true}, SHIFT(740),
  [2213] = {.count = 1, .reusable = true}, SHIFT(741),
  [2215] = {.count = 1, .reusable = true}, SHIFT(742),
  [2217] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 48),
  [2219] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 48),
  [2221] = {.count = 1, .reusable = false}, SHIFT(743),
  [2223] = {.count = 1, .reusable = true}, SHIFT(743),
  [2225] = {.count = 1, .reusable = true}, SHIFT(744),
  [2227] = {.count = 1, .reusable = false}, SHIFT(745),
  [2229] = {.count = 1, .reusable = true}, SHIFT(745),
  [2231] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 48),
  [2233] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [2235] = {.count = 1, .reusable = false}, SHIFT(2026),
  [2237] = {.count = 1, .reusable = true}, SHIFT(2026),
  [2239] = {.count = 1, .reusable = true}, SHIFT(746),
  [2241] = {.count = 1, .reusable = true}, SHIFT(748),
  [2243] = {.count = 1, .reusable = false}, SHIFT(749),
  [2245] = {.count = 1, .reusable = true}, SHIFT(750),
  [2247] = {.count = 1, .reusable = false}, SHIFT(751),
  [2249] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [2251] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [2253] = {.count = 1, .reusable = true}, SHIFT(752),
  [2255] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [2257] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [2259] = {.count = 1, .reusable = true}, SHIFT(753),
  [2261] = {.count = 1, .reusable = false}, SHIFT(754),
  [2263] = {.count = 1, .reusable = true}, SHIFT(754),
  [2265] = {.count = 1, .reusable = false}, SHIFT(755),
  [2267] = {.count = 1, .reusable = true}, SHIFT(755),
  [2269] = {.count = 1, .reusable = true}, SHIFT(758),
  [2271] = {.count = 1, .reusable = false}, SHIFT(759),
  [2273] = {.count = 1, .reusable = true}, SHIFT(759),
  [2275] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(168),
  [2278] = {.count = 1, .reusable = false}, SHIFT(760),
  [2280] = {.count = 1, .reusable = true}, SHIFT(762),
  [2282] = {.count = 1, .reusable = true}, SHIFT(763),
  [2284] = {.count = 1, .reusable = true}, SHIFT(761),
  [2286] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 49),
  [2288] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 49),
  [2290] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 4),
  [2292] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [2294] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 50),
  [2296] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 51),
  [2298] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [2300] = {.count = 1, .reusable = true}, SHIFT(766),
  [2302] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [2304] = {.count = 1, .reusable = true}, SHIFT(769),
  [2306] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [2308] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 52),
  [2310] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [2312] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2314] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2316] = {.count = 1, .reusable = true}, SHIFT(774),
  [2318] = {.count = 1, .reusable = false}, SHIFT(775),
  [2320] = {.count = 1, .reusable = false}, SHIFT(776),
  [2322] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [2324] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 13),
  [2326] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 14),
  [2328] = {.count = 1, .reusable = false}, SHIFT(781),
  [2330] = {.count = 1, .reusable = true}, SHIFT(781),
  [2332] = {.count = 1, .reusable = false}, SHIFT(783),
  [2334] = {.count = 1, .reusable = true}, SHIFT(783),
  [2336] = {.count = 1, .reusable = true}, SHIFT(785),
  [2338] = {.count = 1, .reusable = false}, SHIFT(789),
  [2340] = {.count = 1, .reusable = true}, SHIFT(789),
  [2342] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2344] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2346] = {.count = 1, .reusable = true}, SHIFT(790),
  [2348] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 53),
  [2350] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 53),
  [2352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(501),
  [2355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(501),
  [2358] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [2360] = {.count = 1, .reusable = true}, SHIFT(791),
  [2362] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 54),
  [2364] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 54),
  [2366] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 55),
  [2368] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 55),
  [2370] = {.count = 1, .reusable = false}, SHIFT(795),
  [2372] = {.count = 1, .reusable = false}, SHIFT(796),
  [2374] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1, .production_id = 12),
  [2376] = {.count = 1, .reusable = true}, SHIFT(798),
  [2378] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1, .production_id = 12),
  [2380] = {.count = 1, .reusable = false}, SHIFT(799),
  [2382] = {.count = 1, .reusable = true}, SHIFT(800),
  [2384] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 56),
  [2386] = {.count = 1, .reusable = true}, SHIFT(802),
  [2388] = {.count = 1, .reusable = true}, SHIFT(803),
  [2390] = {.count = 1, .reusable = false}, SHIFT(804),
  [2392] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 57),
  [2394] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 57),
  [2396] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 15),
  [2398] = {.count = 1, .reusable = true}, SHIFT(807),
  [2400] = {.count = 1, .reusable = true}, SHIFT(809),
  [2402] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1),
  [2404] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1),
  [2406] = {.count = 1, .reusable = false}, SHIFT(800),
  [2408] = {.count = 1, .reusable = true}, SHIFT(810),
  [2410] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [2412] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [2414] = {.count = 1, .reusable = true}, SHIFT(812),
  [2416] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 58),
  [2418] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 58),
  [2420] = {.count = 1, .reusable = false}, SHIFT(814),
  [2422] = {.count = 1, .reusable = true}, SHIFT(815),
  [2424] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 59),
  [2426] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 59),
  [2428] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 60),
  [2430] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 60),
  [2432] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [2434] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [2436] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [2438] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [2440] = {.count = 1, .reusable = true}, SHIFT(822),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [2444] = {.count = 1, .reusable = true}, SHIFT(823),
  [2446] = {.count = 1, .reusable = true}, SHIFT(824),
  [2448] = {.count = 1, .reusable = true}, SHIFT(825),
  [2450] = {.count = 1, .reusable = true}, SHIFT(2381),
  [2452] = {.count = 1, .reusable = true}, SHIFT(827),
  [2454] = {.count = 1, .reusable = false}, SHIFT(2382),
  [2456] = {.count = 1, .reusable = true}, SHIFT(2383),
  [2458] = {.count = 1, .reusable = false}, SHIFT(2384),
  [2460] = {.count = 1, .reusable = false}, SHIFT(2383),
  [2462] = {.count = 1, .reusable = true}, SHIFT(2385),
  [2464] = {.count = 1, .reusable = false}, SHIFT(2381),
  [2466] = {.count = 1, .reusable = false}, SHIFT(2385),
  [2468] = {.count = 1, .reusable = true}, SHIFT(2799),
  [2470] = {.count = 1, .reusable = true}, SHIFT(2382),
  [2472] = {.count = 1, .reusable = false}, SHIFT(1924),
  [2474] = {.count = 1, .reusable = true}, SHIFT(2387),
  [2476] = {.count = 1, .reusable = true}, SHIFT(828),
  [2478] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2480] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2482] = {.count = 1, .reusable = true}, SHIFT(2355),
  [2484] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 62),
  [2486] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 62),
  [2488] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [2490] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [2492] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(264),
  [2495] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 25),
  [2497] = {.count = 1, .reusable = true}, SHIFT(830),
  [2499] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [2501] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [2503] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [2506] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [2509] = {.count = 1, .reusable = true}, SHIFT(2024),
  [2511] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(102),
  [2514] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [2517] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [2520] = {.count = 1, .reusable = false}, SHIFT(1748),
  [2522] = {.count = 1, .reusable = false}, SHIFT(1750),
  [2524] = {.count = 1, .reusable = false}, SHIFT(2130),
  [2526] = {.count = 1, .reusable = false}, SHIFT(1751),
  [2528] = {.count = 1, .reusable = false}, SHIFT(1752),
  [2530] = {.count = 1, .reusable = false}, SHIFT(1749),
  [2532] = {.count = 1, .reusable = false}, SHIFT(2129),
  [2534] = {.count = 1, .reusable = false}, SHIFT(2252),
  [2536] = {.count = 1, .reusable = true}, SHIFT(1991),
  [2538] = {.count = 1, .reusable = true}, SHIFT(1749),
  [2540] = {.count = 1, .reusable = false}, SHIFT(1467),
  [2542] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2545] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2548] = {.count = 1, .reusable = false}, SHIFT(831),
  [2550] = {.count = 1, .reusable = true}, SHIFT(832),
  [2552] = {.count = 1, .reusable = false}, SHIFT(1393),
  [2554] = {.count = 1, .reusable = true}, SHIFT(833),
  [2556] = {.count = 1, .reusable = true}, SHIFT(834),
  [2558] = {.count = 1, .reusable = true}, SHIFT(2710),
  [2560] = {.count = 1, .reusable = false}, SHIFT(1394),
  [2562] = {.count = 1, .reusable = false}, SHIFT(835),
  [2564] = {.count = 1, .reusable = false}, SHIFT(837),
  [2566] = {.count = 1, .reusable = true}, SHIFT(838),
  [2568] = {.count = 1, .reusable = false}, SHIFT(836),
  [2570] = {.count = 1, .reusable = true}, SHIFT(842),
  [2572] = {.count = 1, .reusable = false}, SHIFT(839),
  [2574] = {.count = 1, .reusable = false}, SHIFT(840),
  [2576] = {.count = 1, .reusable = false}, SHIFT(843),
  [2578] = {.count = 1, .reusable = false}, SHIFT(844),
  [2580] = {.count = 1, .reusable = false}, SHIFT(2224),
  [2582] = {.count = 1, .reusable = false}, SHIFT(845),
  [2584] = {.count = 1, .reusable = false}, SHIFT(846),
  [2586] = {.count = 1, .reusable = false}, SHIFT(1813),
  [2588] = {.count = 1, .reusable = false}, SHIFT(2223),
  [2590] = {.count = 1, .reusable = false}, SHIFT(2292),
  [2592] = {.count = 1, .reusable = true}, SHIFT(1813),
  [2594] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [2597] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [2600] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(640),
  [2603] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [2605] = {.count = 1, .reusable = false}, SHIFT(2170),
  [2607] = {.count = 1, .reusable = false}, SHIFT(850),
  [2609] = {.count = 1, .reusable = true}, SHIFT(851),
  [2611] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 2),
  [2613] = {.count = 1, .reusable = true}, SHIFT(854),
  [2615] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(574),
  [2618] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(855),
  [2621] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(269),
  [2624] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 3, .production_id = 65),
  [2626] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 3, .production_id = 65),
  [2628] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 66),
  [2630] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 66),
  [2632] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 67),
  [2634] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [2636] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [2638] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [2640] = {.count = 1, .reusable = false}, SHIFT(856),
  [2642] = {.count = 1, .reusable = true}, SHIFT(856),
  [2644] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2646] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2648] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [2650] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 30),
  [2652] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 30),
  [2654] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 27),
  [2656] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 27),
  [2658] = {.count = 1, .reusable = false}, SHIFT(866),
  [2660] = {.count = 1, .reusable = true}, SHIFT(866),
  [2662] = {.count = 1, .reusable = false}, SHIFT(867),
  [2664] = {.count = 1, .reusable = true}, SHIFT(867),
  [2666] = {.count = 1, .reusable = false}, SHIFT(868),
  [2668] = {.count = 1, .reusable = true}, SHIFT(868),
  [2670] = {.count = 1, .reusable = true}, SHIFT(870),
  [2672] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 70),
  [2674] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 71),
  [2676] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 72),
  [2678] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 72),
  [2680] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 73),
  [2682] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2684] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2686] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2688] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(320),
  [2691] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 74),
  [2693] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 75),
  [2695] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 75),
  [2697] = {.count = 1, .reusable = true}, SHIFT(876),
  [2699] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 15),
  [2701] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 15),
  [2703] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2705] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2707] = {.count = 1, .reusable = true}, SHIFT(879),
  [2709] = {.count = 1, .reusable = true}, SHIFT(881),
  [2711] = {.count = 1, .reusable = false}, SHIFT(880),
  [2713] = {.count = 1, .reusable = false}, SHIFT(883),
  [2715] = {.count = 1, .reusable = false}, SHIFT(1548),
  [2717] = {.count = 1, .reusable = true}, SHIFT(884),
  [2719] = {.count = 1, .reusable = false}, SHIFT(882),
  [2721] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2723] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2727] = {.count = 1, .reusable = true}, SHIFT(2542),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2731] = {.count = 1, .reusable = true}, SHIFT(2378),
  [2733] = {.count = 1, .reusable = true}, SHIFT(887),
  [2735] = {.count = 1, .reusable = true}, SHIFT(2317),
  [2737] = {.count = 1, .reusable = true}, SHIFT(2797),
  [2739] = {.count = 1, .reusable = true}, SHIFT(2328),
  [2741] = {.count = 1, .reusable = true}, SHIFT(2318),
  [2743] = {.count = 1, .reusable = true}, SHIFT(2379),
  [2745] = {.count = 1, .reusable = true}, SHIFT(2319),
  [2747] = {.count = 1, .reusable = false}, SHIFT(2703),
  [2749] = {.count = 1, .reusable = true}, SHIFT(2693),
  [2751] = {.count = 1, .reusable = true}, SHIFT(2679),
  [2753] = {.count = 1, .reusable = true}, SHIFT(2694),
  [2755] = {.count = 1, .reusable = true}, SHIFT(2331),
  [2757] = {.count = 1, .reusable = true}, SHIFT(2695),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2761] = {.count = 1, .reusable = true}, SHIFT(888),
  [2763] = {.count = 1, .reusable = true}, SHIFT(889),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2767] = {.count = 1, .reusable = false}, SHIFT(891),
  [2769] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 6),
  [2771] = {.count = 1, .reusable = true}, SHIFT(892),
  [2773] = {.count = 1, .reusable = true}, SHIFT(895),
  [2775] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2777] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2779] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2781] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2783] = {.count = 1, .reusable = false}, SHIFT(1960),
  [2785] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2787] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2789] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 45),
  [2791] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 45),
  [2793] = {.count = 1, .reusable = false}, SHIFT(609),
  [2795] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2797] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2799] = {.count = 1, .reusable = true}, SHIFT(897),
  [2801] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [2803] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [2806] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2809] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [2812] = {.count = 1, .reusable = true}, SHIFT(899),
  [2814] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2816] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2818] = {.count = 1, .reusable = true}, SHIFT(901),
  [2820] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2822] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2824] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2826] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2828] = {.count = 1, .reusable = true}, SHIFT(905),
  [2830] = {.count = 1, .reusable = true}, SHIFT(907),
  [2832] = {.count = 1, .reusable = true}, SHIFT(909),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [2836] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [2838] = {.count = 1, .reusable = true}, SHIFT(910),
  [2840] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 76),
  [2842] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 76),
  [2844] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 77),
  [2846] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 77),
  [2848] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2850] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2852] = {.count = 1, .reusable = true}, SHIFT(913),
  [2854] = {.count = 1, .reusable = true}, SHIFT(912),
  [2856] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 78),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 78),
  [2860] = {.count = 1, .reusable = true}, SHIFT(920),
  [2862] = {.count = 1, .reusable = true}, SHIFT(1683),
  [2864] = {.count = 1, .reusable = true}, SHIFT(1684),
  [2866] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [2868] = {.count = 1, .reusable = true}, SHIFT(922),
  [2870] = {.count = 1, .reusable = true}, SHIFT(923),
  [2872] = {.count = 1, .reusable = true}, SHIFT(378),
  [2874] = {.count = 1, .reusable = true}, SHIFT(664),
  [2876] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2878] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2880] = {.count = 1, .reusable = true}, SHIFT(924),
  [2882] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [2884] = {.count = 1, .reusable = true}, SHIFT(925),
  [2886] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 56),
  [2888] = {.count = 1, .reusable = true}, SHIFT(926),
  [2890] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [2892] = {.count = 1, .reusable = true}, SHIFT(927),
  [2894] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 79),
  [2896] = {.count = 1, .reusable = true}, SHIFT(929),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 80),
  [2900] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [2902] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [2904] = {.count = 1, .reusable = false}, SHIFT(932),
  [2906] = {.count = 1, .reusable = true}, SHIFT(932),
  [2908] = {.count = 1, .reusable = false}, SHIFT(934),
  [2910] = {.count = 1, .reusable = true}, SHIFT(934),
  [2912] = {.count = 1, .reusable = false}, SHIFT(935),
  [2914] = {.count = 1, .reusable = true}, SHIFT(936),
  [2916] = {.count = 1, .reusable = true}, SHIFT(2569),
  [2918] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(936),
  [2921] = {.count = 1, .reusable = true}, SHIFT(937),
  [2923] = {.count = 1, .reusable = true}, SHIFT(2572),
  [2925] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(937),
  [2928] = {.count = 1, .reusable = false}, SHIFT(2746),
  [2930] = {.count = 1, .reusable = false}, SHIFT(937),
  [2932] = {.count = 1, .reusable = false}, SHIFT(2611),
  [2934] = {.count = 1, .reusable = false}, SHIFT(2612),
  [2936] = {.count = 1, .reusable = false}, SHIFT(938),
  [2938] = {.count = 1, .reusable = true}, SHIFT(939),
  [2940] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(939),
  [2943] = {.count = 1, .reusable = false}, SHIFT(940),
  [2945] = {.count = 1, .reusable = true}, SHIFT(941),
  [2947] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(941),
  [2950] = {.count = 1, .reusable = false}, SHIFT(944),
  [2952] = {.count = 1, .reusable = true}, SHIFT(942),
  [2954] = {.count = 1, .reusable = true}, SHIFT(944),
  [2956] = {.count = 1, .reusable = false}, SHIFT(946),
  [2958] = {.count = 1, .reusable = true}, SHIFT(946),
  [2960] = {.count = 1, .reusable = false}, SHIFT(948),
  [2962] = {.count = 1, .reusable = true}, SHIFT(948),
  [2964] = {.count = 1, .reusable = false}, SHIFT(949),
  [2966] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2968] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2970] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [2972] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [2974] = {.count = 1, .reusable = false}, SHIFT(952),
  [2976] = {.count = 1, .reusable = false}, SHIFT(954),
  [2978] = {.count = 1, .reusable = true}, SHIFT(954),
  [2980] = {.count = 1, .reusable = true}, SHIFT(956),
  [2982] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 45),
  [2984] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [2986] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [2988] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 40),
  [2990] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 40),
  [2992] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 76),
  [2994] = {.count = 1, .reusable = true}, SHIFT(958),
  [2996] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 76),
  [2998] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 76),
  [3000] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 76),
  [3002] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 77),
  [3004] = {.count = 1, .reusable = true}, SHIFT(959),
  [3006] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 77),
  [3008] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 77),
  [3010] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 77),
  [3012] = {.count = 1, .reusable = true}, SHIFT(961),
  [3014] = {.count = 1, .reusable = true}, SHIFT(963),
  [3016] = {.count = 1, .reusable = false}, SHIFT(964),
  [3018] = {.count = 1, .reusable = true}, SHIFT(965),
  [3020] = {.count = 1, .reusable = true}, SHIFT(966),
  [3022] = {.count = 1, .reusable = true}, SHIFT(967),
  [3024] = {.count = 1, .reusable = true}, SHIFT(968),
  [3026] = {.count = 1, .reusable = true}, SHIFT(969),
  [3028] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 56),
  [3030] = {.count = 1, .reusable = true}, SHIFT(970),
  [3032] = {.count = 1, .reusable = true}, SHIFT(971),
  [3034] = {.count = 1, .reusable = true}, SHIFT(975),
  [3036] = {.count = 1, .reusable = true}, SHIFT(977),
  [3038] = {.count = 1, .reusable = false}, SHIFT(976),
  [3040] = {.count = 1, .reusable = true}, SHIFT(978),
  [3042] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3044] = {.count = 1, .reusable = false}, SHIFT(979),
  [3046] = {.count = 1, .reusable = true}, SHIFT(980),
  [3048] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3050] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3052] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [3054] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [3056] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(414),
  [3059] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(412),
  [3062] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2674),
  [3065] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(416),
  [3068] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(413),
  [3071] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(420),
  [3074] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(411),
  [3077] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(419),
  [3080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2282),
  [3083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(425),
  [3086] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(417),
  [3089] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(418),
  [3092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2281),
  [3095] = {.count = 1, .reusable = false}, SHIFT(981),
  [3097] = {.count = 1, .reusable = false}, SHIFT(982),
  [3099] = {.count = 1, .reusable = false}, SHIFT(983),
  [3101] = {.count = 1, .reusable = true}, SHIFT(985),
  [3103] = {.count = 1, .reusable = true}, SHIFT(984),
  [3105] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 6),
  [3107] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 82),
  [3109] = {.count = 1, .reusable = true}, SHIFT(2287),
  [3111] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 33),
  [3113] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 34),
  [3115] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 83),
  [3117] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 83),
  [3119] = {.count = 1, .reusable = true}, SHIFT(990),
  [3121] = {.count = 1, .reusable = true}, SHIFT(995),
  [3123] = {.count = 1, .reusable = true}, SHIFT(2305),
  [3125] = {.count = 1, .reusable = true}, SHIFT(665),
  [3127] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 84), REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [3130] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 84),
  [3132] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 48),
  [3134] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 48),
  [3136] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 84), REDUCE(sym_assignment_expression, 3, .production_id = 29),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1003),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1005),
  [3143] = {.count = 1, .reusable = false}, SHIFT(1006),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1007),
  [3147] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3150] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3153] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [3155] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3157] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3159] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [3162] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [3164] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 85),
  [3166] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 86),
  [3168] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [3170] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [3172] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 68), REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3175] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 68),
  [3177] = {.count = 1, .reusable = false}, SHIFT(1009),
  [3179] = {.count = 1, .reusable = false}, SHIFT(1011),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1011),
  [3183] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [3185] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1012),
  [3189] = {.count = 1, .reusable = true}, SHIFT(1013),
  [3191] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [3193] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [3195] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1016),
  [3199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1017),
  [3202] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23),
  [3204] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [3206] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [3208] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 87),
  [3210] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [3212] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [3214] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 88),
  [3216] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [3218] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 89),
  [3220] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [3222] = {.count = 1, .reusable = true}, SHIFT(1019),
  [3224] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 91),
  [3226] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 91),
  [3228] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 92),
  [3230] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 92),
  [3232] = {.count = 1, .reusable = true}, SHIFT(1020),
  [3234] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 93),
  [3236] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 93),
  [3238] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 94),
  [3240] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 94),
  [3242] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [3244] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1024),
  [3248] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [3250] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [3252] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [3254] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [3256] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [3258] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1027),
  [3262] = {.count = 1, .reusable = false}, SHIFT(1028),
  [3264] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [3266] = {.count = 1, .reusable = true}, SHIFT(2302),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1029),
  [3270] = {.count = 1, .reusable = true}, SHIFT(2301),
  [3272] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_namespace_name, 3),
  [3274] = {.count = 1, .reusable = false}, SHIFT(610),
  [3276] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_namespace_name, 3),
  [3278] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 15), REDUCE(sym_jsx_namespace_name, 3),
  [3281] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [3283] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 56),
  [3285] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 56),
  [3287] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 96),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1031),
  [3291] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 97), SHIFT_REPEAT(510),
  [3294] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 97), SHIFT_REPEAT(510),
  [3297] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 97),
  [3299] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 97),
  [3301] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 97), SHIFT_REPEAT(1925),
  [3304] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 15),
  [3306] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 98),
  [3308] = {.count = 1, .reusable = true}, SHIFT(1032),
  [3310] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [3312] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [3314] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1034),
  [3318] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(1035),
  [3321] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 99),
  [3323] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 99),
  [3325] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 100),
  [3327] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 100),
  [3329] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 101),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1036),
  [3333] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 101),
  [3335] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 101),
  [3337] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 101),
  [3339] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 93),
  [3341] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 93),
  [3343] = {.count = 1, .reusable = false}, SHIFT(1038),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1039),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1040),
  [3349] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 102),
  [3351] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 102),
  [3353] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1041),
  [3357] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 103),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1043),
  [3361] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 104),
  [3363] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 104),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1045),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1046),
  [3369] = {.count = 1, .reusable = false}, SHIFT(1047),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1047),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1048),
  [3375] = {.count = 1, .reusable = false}, SHIFT(2721),
  [3377] = {.count = 1, .reusable = false}, SHIFT(2167),
  [3379] = {.count = 1, .reusable = false}, SHIFT(2722),
  [3381] = {.count = 1, .reusable = false}, SHIFT(2723),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1332),
  [3385] = {.count = 1, .reusable = false}, SHIFT(2724),
  [3387] = {.count = 1, .reusable = true}, SHIFT(2167),
  [3389] = {.count = 1, .reusable = false}, SHIFT(2725),
  [3391] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3393] = {.count = 1, .reusable = false}, SHIFT(1431),
  [3395] = {.count = 1, .reusable = false}, SHIFT(1049),
  [3397] = {.count = 1, .reusable = false}, SHIFT(1051),
  [3399] = {.count = 1, .reusable = false}, SHIFT(1050),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1052),
  [3403] = {.count = 1, .reusable = true}, SHIFT(2727),
  [3405] = {.count = 1, .reusable = false}, SHIFT(2525),
  [3407] = {.count = 1, .reusable = true}, SHIFT(2445),
  [3409] = {.count = 1, .reusable = false}, SHIFT(2728),
  [3411] = {.count = 1, .reusable = false}, SHIFT(2726),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1054),
  [3415] = {.count = 1, .reusable = false}, SHIFT(1053),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1055),
  [3419] = {.count = 1, .reusable = false}, SHIFT(1056),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1057),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1058),
  [3425] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [3429] = {.count = 1, .reusable = true}, SHIFT(2308),
  [3431] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3435] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [3439] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(897),
  [3442] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(909),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1060),
  [3447] = {.count = 1, .reusable = true}, SHIFT(1960),
  [3449] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 3),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1061),
  [3453] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 105),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1062),
  [3457] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [3459] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [3461] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 105),
  [3463] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 106),
  [3465] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 106),
  [3467] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 107),
  [3469] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 107),
  [3471] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 108),
  [3473] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 108),
  [3475] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [3477] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [3479] = {.count = 1, .reusable = true}, SHIFT(1074),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1075),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1077),
  [3485] = {.count = 1, .reusable = true}, SHIFT(1079),
  [3487] = {.count = 1, .reusable = false}, SHIFT(1080),
  [3489] = {.count = 1, .reusable = false}, SHIFT(1082),
  [3491] = {.count = 1, .reusable = true}, SHIFT(1083),
  [3493] = {.count = 1, .reusable = true}, SHIFT(1081),
  [3495] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3497] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 56),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1084),
  [3501] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1982),
  [3505] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [3507] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1090),
  [3511] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 6),
  [3513] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 34),
  [3515] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [3517] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1093),
  [3521] = {.count = 1, .reusable = true}, SHIFT(1095),
  [3523] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [3525] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [3527] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [3529] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [3531] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [3533] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1096),
  [3537] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [3539] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [3541] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [3543] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [3545] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [3547] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [3549] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1097),
  [3553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(698),
  [3556] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3558] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3560] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 109),
  [3562] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 109),
  [3564] = {.count = 1, .reusable = true}, SHIFT(1099),
  [3566] = {.count = 1, .reusable = true}, SHIFT(1100),
  [3568] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [3570] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [3572] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 52),
  [3574] = {.count = 1, .reusable = true}, SHIFT(1102),
  [3576] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 110),
  [3578] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 110),
  [3580] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 111),
  [3582] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 111),
  [3584] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 112),
  [3586] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 112),
  [3588] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 113),
  [3590] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 113),
  [3592] = {.count = 1, .reusable = true}, SHIFT(1105),
  [3594] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [3596] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [3598] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 114),
  [3600] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 114),
  [3602] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 115),
  [3604] = {.count = 1, .reusable = true}, SHIFT(1107),
  [3606] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 79),
  [3608] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 79),
  [3610] = {.count = 1, .reusable = true}, SHIFT(1108),
  [3612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(1109),
  [3615] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1110),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1111),
  [3621] = {.count = 1, .reusable = false}, SHIFT(1112),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1112),
  [3625] = {.count = 1, .reusable = false}, SHIFT(1114),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1114),
  [3629] = {.count = 1, .reusable = false}, SHIFT(1116),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1116),
  [3633] = {.count = 1, .reusable = false}, SHIFT(1117),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1117),
  [3637] = {.count = 1, .reusable = false}, SHIFT(1119),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1119),
  [3641] = {.count = 1, .reusable = false}, SHIFT(1120),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1120),
  [3645] = {.count = 1, .reusable = false}, SHIFT(1122),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1122),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1124),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1125),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1126),
  [3655] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 45),
  [3657] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3659] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3661] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 27), REDUCE(sym_nested_type_identifier, 3, .production_id = 108),
  [3664] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 27),
  [3667] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 27), REDUCE(sym_nested_type_identifier, 3, .production_id = 108),
  [3670] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(694),
  [3673] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 76),
  [3675] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 76),
  [3677] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 77),
  [3679] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 77),
  [3681] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 109),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1127),
  [3685] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 109),
  [3687] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 109),
  [3689] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 109),
  [3691] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 100),
  [3693] = {.count = 1, .reusable = true}, SHIFT(333),
  [3695] = {.count = 1, .reusable = true}, SHIFT(1133),
  [3697] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 116),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1135),
  [3701] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 56),
  [3703] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 100),
  [3705] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 117),
  [3707] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 118),
  [3709] = {.count = 1, .reusable = true}, SHIFT(1142),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1144),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1146),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1147),
  [3719] = {.count = 1, .reusable = false}, SHIFT(1608),
  [3721] = {.count = 1, .reusable = false}, SHIFT(1148),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1149),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3731] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 119),
  [3733] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 120),
  [3735] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 121),
  [3737] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 71),
  [3739] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3747] = {.count = 1, .reusable = false}, SHIFT(2671),
  [3749] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 101),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1165),
  [3753] = {.count = 1, .reusable = true}, SHIFT(1167),
  [3755] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 122),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1168),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1169),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1170),
  [3763] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [3765] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [3767] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [3769] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [3771] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [3773] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(763),
  [3776] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(761),
  [3779] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 123),
  [3781] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 124),
  [3783] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 125),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1172),
  [3787] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 126),
  [3789] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 126),
  [3791] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 127),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1173),
  [3795] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 127),
  [3797] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 127),
  [3799] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 127),
  [3801] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 128),
  [3803] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 128),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1175),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1176),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1177),
  [3811] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 5),
  [3813] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 5),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1178),
  [3817] = {.count = 1, .reusable = true}, SHIFT(2783),
  [3819] = {.count = 1, .reusable = false}, SHIFT(2428),
  [3821] = {.count = 1, .reusable = true}, SHIFT(2616),
  [3823] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3, .production_id = 12),
  [3825] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3, .production_id = 12),
  [3827] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 96),
  [3829] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 96),
  [3831] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 129),
  [3833] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3),
  [3835] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3),
  [3837] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [3839] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [3841] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 101),
  [3843] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 101),
  [3845] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1179),
  [3849] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 127),
  [3851] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 127),
  [3853] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [3855] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3858] = {.count = 1, .reusable = false}, SHIFT(1310),
  [3860] = {.count = 1, .reusable = false}, SHIFT(1180),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1180),
  [3864] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 103),
  [3866] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 103),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1181),
  [3870] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1182),
  [3873] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [3875] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [3877] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [3879] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 130),
  [3881] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 130),
  [3883] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 131),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1183),
  [3887] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 12), REDUCE(aux_sym_object_repeat1, 2, .production_id = 48),
  [3890] = {.count = 1, .reusable = false}, SHIFT(2528),
  [3892] = {.count = 1, .reusable = false}, SHIFT(2736),
  [3894] = {.count = 1, .reusable = true}, SHIFT(1184),
  [3896] = {.count = 1, .reusable = true}, SHIFT(2735),
  [3898] = {.count = 1, .reusable = true}, SHIFT(1185),
  [3900] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3902] = {.count = 1, .reusable = false}, SHIFT(1186),
  [3904] = {.count = 1, .reusable = false}, SHIFT(1844),
  [3906] = {.count = 1, .reusable = false}, SHIFT(1854),
  [3908] = {.count = 1, .reusable = true}, SHIFT(2128),
  [3910] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3912] = {.count = 1, .reusable = false}, SHIFT(2279),
  [3914] = {.count = 1, .reusable = false}, SHIFT(2280),
  [3916] = {.count = 1, .reusable = false}, SHIFT(2307),
  [3918] = {.count = 1, .reusable = false}, SHIFT(1847),
  [3920] = {.count = 1, .reusable = true}, SHIFT(2172),
  [3922] = {.count = 1, .reusable = false}, SHIFT(1848),
  [3924] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3926] = {.count = 1, .reusable = false}, SHIFT(2131),
  [3928] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(1095),
  [3931] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_closing_element, 4, .production_id = 116),
  [3933] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_closing_element, 4, .production_id = 116),
  [3935] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 132),
  [3937] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 132),
  [3939] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [3941] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [3943] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 133),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1187),
  [3947] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 133),
  [3949] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 133),
  [3951] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 133),
  [3953] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 134),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1188),
  [3957] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [3959] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [3961] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 134),
  [3963] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 135),
  [3965] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 135),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1192),
  [3969] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [3971] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1193),
  [3975] = {.count = 1, .reusable = true}, SHIFT(1195),
  [3977] = {.count = 1, .reusable = true}, SHIFT(1197),
  [3979] = {.count = 1, .reusable = true}, SHIFT(1199),
  [3981] = {.count = 1, .reusable = false}, SHIFT(1198),
  [3983] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 116),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1200),
  [3987] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 56),
  [3989] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 118),
  [3991] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [3993] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [3995] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2, .production_id = 136), SHIFT_REPEAT(1204),
  [3998] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2, .production_id = 136),
  [4000] = {.count = 1, .reusable = false}, SHIFT(1625),
  [4002] = {.count = 1, .reusable = false}, SHIFT(1205),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1206),
  [4006] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 121),
  [4008] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [4010] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [4012] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [4014] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [4016] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [4018] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [4020] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [4022] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [4024] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [4026] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [4028] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [4030] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [4032] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1208),
  [4036] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1209),
  [4039] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 137),
  [4041] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 137),
  [4043] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 138),
  [4045] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 138),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1210),
  [4049] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 139),
  [4051] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 79),
  [4053] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 140),
  [4055] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 140),
  [4057] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 141),
  [4059] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 141),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1211),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1212),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1213),
  [4067] = {.count = 1, .reusable = true}, SHIFT(1214),
  [4069] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [4071] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [4073] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 143),
  [4075] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 143),
  [4077] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 144),
  [4079] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 144),
  [4081] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 109),
  [4083] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 109),
  [4085] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 145),
  [4087] = {.count = 1, .reusable = true}, SHIFT(1216),
  [4089] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 15),
  [4091] = {.count = 1, .reusable = true}, SHIFT(1217),
  [4093] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [4095] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 126),
  [4097] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 116),
  [4099] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 146),
  [4101] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 147),
  [4103] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 145),
  [4105] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 148),
  [4107] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 149),
  [4109] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 150),
  [4111] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 126),
  [4113] = {.count = 1, .reusable = true}, SHIFT(1224),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1226),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1228),
  [4119] = {.count = 1, .reusable = false}, SHIFT(1227),
  [4121] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 151),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1229),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1230),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1233),
  [4129] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [4131] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 153),
  [4133] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 153),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4139] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 154),
  [4141] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 127),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1240),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1242),
  [4147] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 70),
  [4149] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 70),
  [4151] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [4153] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [4155] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 155),
  [4157] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 127),
  [4159] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 127),
  [4161] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 156),
  [4163] = {.count = 1, .reusable = true}, SHIFT(1244),
  [4165] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 156),
  [4167] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 156),
  [4169] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 156),
  [4171] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 6),
  [4173] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 6),
  [4175] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 127),
  [4177] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 127),
  [4179] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 103),
  [4181] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 27),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1248),
  [4186] = {.count = 1, .reusable = false}, SHIFT(2530),
  [4188] = {.count = 1, .reusable = false}, SHIFT(2740),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1249),
  [4192] = {.count = 1, .reusable = true}, SHIFT(2739),
  [4194] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 133),
  [4196] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 133),
  [4198] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [4200] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [4202] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 157),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1250),
  [4206] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [4208] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [4210] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 157),
  [4212] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [4214] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [4216] = {.count = 1, .reusable = true}, SHIFT(1251),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1253),
  [4220] = {.count = 1, .reusable = true}, SHIFT(1255),
  [4222] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 116),
  [4224] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 147),
  [4226] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 149),
  [4228] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1258),
  [4232] = {.count = 1, .reusable = false}, SHIFT(1257),
  [4234] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 151),
  [4236] = {.count = 1, .reusable = true}, SHIFT(1259),
  [4238] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [4240] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [4242] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [4244] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [4246] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [4248] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 158),
  [4250] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 158),
  [4252] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 159),
  [4254] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 159),
  [4256] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 160),
  [4258] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 160),
  [4260] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 161),
  [4262] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 161),
  [4264] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 162),
  [4266] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 162),
  [4268] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 163),
  [4270] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 164),
  [4272] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 165),
  [4274] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 166),
  [4276] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 167),
  [4278] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 163),
  [4280] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 168),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1265),
  [4284] = {.count = 1, .reusable = true}, SHIFT(1267),
  [4286] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 151),
  [4288] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 169),
  [4290] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 170),
  [4292] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 168),
  [4294] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 171),
  [4296] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 156),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1275),
  [4300] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 70),
  [4302] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 70),
  [4304] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 156),
  [4306] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 156),
  [4308] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 172),
  [4310] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 172),
  [4312] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 173),
  [4314] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 173),
  [4316] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 174),
  [4318] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 174),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1277),
  [4322] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [4324] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [4326] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6, .production_id = 175),
  [4328] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6, .production_id = 175),
  [4330] = {.count = 1, .reusable = true}, SHIFT(1279),
  [4332] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 165),
  [4334] = {.count = 1, .reusable = true}, SHIFT(1281),
  [4336] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 151),
  [4338] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 170),
  [4340] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [4342] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 4),
  [4344] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 176),
  [4346] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 177),
  [4348] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 178),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1284),
  [4352] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 179),
  [4354] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 180),
  [4356] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 181),
  [4358] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 177),
  [4360] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 182),
  [4362] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 183),
  [4364] = {.count = 1, .reusable = true}, SHIFT(1291),
  [4366] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 180),
  [4368] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 184),
  [4370] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 185),
  [4372] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 186),
  [4374] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 187),
  [4376] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 188),
  [4378] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 189),
  [4380] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 190),
  [4382] = {.count = 1, .reusable = false}, SHIFT(1324),
  [4384] = {.count = 1, .reusable = true}, SHIFT(1324),
  [4386] = {.count = 1, .reusable = false}, SHIFT(1325),
  [4388] = {.count = 1, .reusable = false}, SHIFT(1326),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1326),
  [4392] = {.count = 1, .reusable = false}, SHIFT(1331),
  [4394] = {.count = 1, .reusable = true}, SHIFT(1331),
  [4396] = {.count = 1, .reusable = false}, SHIFT(1364),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1364),
  [4400] = {.count = 1, .reusable = false}, SHIFT(1375),
  [4402] = {.count = 1, .reusable = false}, SHIFT(1380),
  [4404] = {.count = 1, .reusable = false}, SHIFT(1383),
  [4406] = {.count = 1, .reusable = true}, SHIFT(2234),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1383),
  [4410] = {.count = 1, .reusable = false}, SHIFT(1384),
  [4412] = {.count = 1, .reusable = true}, SHIFT(1384),
  [4414] = {.count = 1, .reusable = false}, SHIFT(1385),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1385),
  [4418] = {.count = 1, .reusable = false}, SHIFT(1389),
  [4420] = {.count = 1, .reusable = true}, SHIFT(1389),
  [4422] = {.count = 1, .reusable = false}, SHIFT(1390),
  [4424] = {.count = 1, .reusable = true}, SHIFT(1390),
  [4426] = {.count = 1, .reusable = false}, SHIFT(1391),
  [4428] = {.count = 1, .reusable = true}, SHIFT(1391),
  [4430] = {.count = 1, .reusable = false}, SHIFT(1314),
  [4432] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(1372),
  [4435] = {.count = 1, .reusable = false}, SHIFT(1411),
  [4437] = {.count = 1, .reusable = true}, SHIFT(1411),
  [4439] = {.count = 1, .reusable = true}, SHIFT(2359),
  [4441] = {.count = 1, .reusable = true}, SHIFT(2625),
  [4443] = {.count = 1, .reusable = true}, SHIFT(1335),
  [4445] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4447] = {.count = 1, .reusable = false}, SHIFT(1969),
  [4449] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1346),
  [4453] = {.count = 1, .reusable = false}, SHIFT(1450),
  [4455] = {.count = 1, .reusable = true}, SHIFT(1450),
  [4457] = {.count = 1, .reusable = false}, SHIFT(1451),
  [4459] = {.count = 1, .reusable = true}, SHIFT(1451),
  [4461] = {.count = 1, .reusable = false}, SHIFT(1452),
  [4463] = {.count = 1, .reusable = true}, SHIFT(1452),
  [4465] = {.count = 1, .reusable = false}, SHIFT(1453),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1453),
  [4469] = {.count = 1, .reusable = false}, SHIFT(1454),
  [4471] = {.count = 1, .reusable = true}, SHIFT(1454),
  [4473] = {.count = 1, .reusable = false}, SHIFT(1456),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1456),
  [4477] = {.count = 1, .reusable = false}, SHIFT(1459),
  [4479] = {.count = 1, .reusable = false}, SHIFT(1462),
  [4481] = {.count = 1, .reusable = false}, SHIFT(1464),
  [4483] = {.count = 1, .reusable = false}, SHIFT(1465),
  [4485] = {.count = 1, .reusable = false}, SHIFT(1466),
  [4487] = {.count = 1, .reusable = false}, SHIFT(1460),
  [4489] = {.count = 1, .reusable = false}, SHIFT(1463),
  [4491] = {.count = 1, .reusable = false}, SHIFT(2171),
  [4493] = {.count = 1, .reusable = true}, SHIFT(1460),
  [4495] = {.count = 1, .reusable = false}, SHIFT(1468),
  [4497] = {.count = 1, .reusable = true}, SHIFT(1468),
  [4499] = {.count = 1, .reusable = false}, SHIFT(1469),
  [4501] = {.count = 1, .reusable = true}, SHIFT(1469),
  [4503] = {.count = 1, .reusable = false}, SHIFT(1473),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1473),
  [4507] = {.count = 1, .reusable = false}, SHIFT(1476),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1476),
  [4511] = {.count = 1, .reusable = true}, SHIFT(2430),
  [4513] = {.count = 1, .reusable = false}, SHIFT(1479),
  [4515] = {.count = 1, .reusable = true}, SHIFT(1479),
  [4517] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4519] = {.count = 1, .reusable = true}, SHIFT(1483),
  [4521] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 15), SHIFT(2541),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2435),
  [4526] = {.count = 1, .reusable = false}, SHIFT(1485),
  [4528] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4530] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2541),
  [4533] = {.count = 1, .reusable = true}, SHIFT(1515),
  [4535] = {.count = 1, .reusable = false}, SHIFT(1519),
  [4537] = {.count = 1, .reusable = true}, SHIFT(1519),
  [4539] = {.count = 1, .reusable = false}, SHIFT(1521),
  [4541] = {.count = 1, .reusable = true}, SHIFT(1521),
  [4543] = {.count = 1, .reusable = false}, SHIFT(1524),
  [4545] = {.count = 1, .reusable = true}, SHIFT(1524),
  [4547] = {.count = 1, .reusable = true}, SHIFT(1658),
  [4549] = {.count = 1, .reusable = false}, SHIFT(1527),
  [4551] = {.count = 1, .reusable = true}, SHIFT(1532),
  [4553] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(1372),
  [4556] = {.count = 1, .reusable = true}, SHIFT(2183),
  [4558] = {.count = 1, .reusable = false}, SHIFT(1883),
  [4560] = {.count = 1, .reusable = false}, SHIFT(1535),
  [4562] = {.count = 1, .reusable = false}, SHIFT(1321),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1536),
  [4566] = {.count = 1, .reusable = false}, SHIFT(1352),
  [4568] = {.count = 1, .reusable = false}, SHIFT(1354),
  [4570] = {.count = 1, .reusable = false}, SHIFT(1355),
  [4572] = {.count = 1, .reusable = false}, SHIFT(1353),
  [4574] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4576] = {.count = 1, .reusable = false}, SHIFT(1357),
  [4578] = {.count = 1, .reusable = false}, SHIFT(1356),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1353),
  [4582] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 2),
  [4584] = {.count = 1, .reusable = false}, SHIFT(1684),
  [4586] = {.count = 1, .reusable = true}, SHIFT(2249),
  [4588] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 86),
  [4590] = {.count = 1, .reusable = false}, SHIFT(1586),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1586),
  [4594] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4596] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 3),
  [4598] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 108),
  [4601] = {.count = 1, .reusable = false}, SHIFT(1497),
  [4603] = {.count = 1, .reusable = false}, SHIFT(1496),
  [4605] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 101),
  [4607] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 122),
  [4609] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 154),
  [4611] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 127),
  [4613] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 171),
  [4615] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 156),
  [4617] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 182),
  [4619] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 183),
  [4621] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 187),
  [4623] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 188),
  [4625] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 190),
  [4627] = {.count = 1, .reusable = true}, SHIFT(1432),
  [4629] = {.count = 1, .reusable = true}, SHIFT(2488),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2615),
  [4633] = {.count = 1, .reusable = true}, SHIFT(1670),
  [4635] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4637] = {.count = 1, .reusable = true}, SHIFT(2558),
  [4639] = {.count = 1, .reusable = false}, SHIFT(1672),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2178),
  [4643] = {.count = 1, .reusable = true}, SHIFT(1689),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2262),
  [4647] = {.count = 1, .reusable = false}, SHIFT(2501),
  [4649] = {.count = 1, .reusable = false}, SHIFT(2502),
  [4651] = {.count = 1, .reusable = false}, SHIFT(1643),
  [4653] = {.count = 1, .reusable = false}, SHIFT(2504),
  [4655] = {.count = 1, .reusable = false}, SHIFT(2505),
  [4657] = {.count = 1, .reusable = true}, SHIFT(2306),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2275),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2290),
  [4663] = {.count = 1, .reusable = false}, SHIFT(2241),
  [4665] = {.count = 1, .reusable = true}, SHIFT(1745),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2253),
  [4669] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4671] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 15), SHIFT(2354),
  [4674] = {.count = 1, .reusable = false}, SHIFT(1733),
  [4676] = {.count = 1, .reusable = false}, SHIFT(1734),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2620),
  [4680] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4682] = {.count = 1, .reusable = false}, SHIFT(2244),
  [4684] = {.count = 1, .reusable = false}, SHIFT(2246),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4688] = {.count = 1, .reusable = true}, SHIFT(1738),
  [4690] = {.count = 1, .reusable = false}, SHIFT(2243),
  [4692] = {.count = 1, .reusable = true}, SHIFT(2628),
  [4694] = {.count = 1, .reusable = true}, SHIFT(2243),
  [4696] = {.count = 1, .reusable = true}, SHIFT(1735),
  [4698] = {.count = 1, .reusable = false}, SHIFT(1756),
  [4700] = {.count = 1, .reusable = true}, SHIFT(1734),
  [4702] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4704] = {.count = 1, .reusable = true}, SHIFT(2622),
  [4706] = {.count = 1, .reusable = true}, SHIFT(1736),
  [4708] = {.count = 1, .reusable = false}, SHIFT(1740),
  [4710] = {.count = 1, .reusable = false}, SHIFT(2621),
  [4712] = {.count = 1, .reusable = true}, SHIFT(2258),
  [4714] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2354),
  [4717] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2297),
  [4721] = {.count = 1, .reusable = true}, SHIFT(2300),
  [4723] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4725] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4727] = {.count = 1, .reusable = false}, SHIFT(1817),
  [4729] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 15), SHIFT(2669),
  [4732] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(2669),
  [4735] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2336),
  [4739] = {.count = 1, .reusable = false}, SHIFT(2337),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2335),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2311),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2339),
  [4747] = {.count = 1, .reusable = false}, SHIFT(2340),
  [4749] = {.count = 1, .reusable = true}, SHIFT(2338),
  [4751] = {.count = 1, .reusable = false}, SHIFT(2351),
  [4753] = {.count = 1, .reusable = false}, SHIFT(2680),
  [4755] = {.count = 1, .reusable = true}, SHIFT(2351),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2312),
  [4759] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4761] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(2615),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2313),
  [4766] = {.count = 1, .reusable = true}, SHIFT(1311),
  [4768] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4770] = {.count = 1, .reusable = true}, SHIFT(1321),
  [4772] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4774] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4776] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4778] = {.count = 1, .reusable = false}, SHIFT(1330),
  [4780] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4782] = {.count = 1, .reusable = true}, SHIFT(1339),
  [4784] = {.count = 1, .reusable = false}, SHIFT(1915),
  [4786] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4788] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4790] = {.count = 1, .reusable = false}, SHIFT(2704),
  [4792] = {.count = 1, .reusable = true}, SHIFT(1377),
  [4794] = {.count = 1, .reusable = true}, SHIFT(1386),
  [4796] = {.count = 1, .reusable = true}, SHIFT(1387),
  [4798] = {.count = 1, .reusable = true}, SHIFT(1392),
  [4800] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4802] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4804] = {.count = 1, .reusable = false}, SHIFT(1936),
  [4806] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4808] = {.count = 1, .reusable = false}, SHIFT(1938),
  [4810] = {.count = 1, .reusable = false}, SHIFT(1940),
  [4812] = {.count = 1, .reusable = true}, SHIFT(1395),
  [4814] = {.count = 1, .reusable = false}, SHIFT(1939),
  [4816] = {.count = 1, .reusable = true}, SHIFT(1397),
  [4818] = {.count = 1, .reusable = false}, SHIFT(1952),
  [4820] = {.count = 1, .reusable = true}, SHIFT(1407),
  [4822] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4824] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4826] = {.count = 1, .reusable = false}, SHIFT(2822),
  [4828] = {.count = 1, .reusable = false}, SHIFT(2823),
  [4830] = {.count = 1, .reusable = false}, SHIFT(2824),
  [4832] = {.count = 1, .reusable = false}, SHIFT(2840),
  [4834] = {.count = 1, .reusable = false}, SHIFT(2825),
  [4836] = {.count = 1, .reusable = false}, SHIFT(2838),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2826),
  [4840] = {.count = 1, .reusable = false}, SHIFT(2827),
  [4842] = {.count = 1, .reusable = false}, SHIFT(2808),
  [4844] = {.count = 1, .reusable = false}, SHIFT(2828),
  [4846] = {.count = 1, .reusable = false}, SHIFT(2829),
  [4848] = {.count = 1, .reusable = false}, SHIFT(2809),
  [4850] = {.count = 1, .reusable = false}, SHIFT(2830),
  [4852] = {.count = 1, .reusable = false}, SHIFT(1413),
  [4854] = {.count = 1, .reusable = true}, SHIFT(1422),
  [4856] = {.count = 1, .reusable = true}, SHIFT(1425),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2310),
  [4860] = {.count = 1, .reusable = true}, SHIFT(1429),
  [4862] = {.count = 1, .reusable = true}, SHIFT(1433),
  [4864] = {.count = 1, .reusable = true}, SHIFT(1434),
  [4866] = {.count = 1, .reusable = true}, SHIFT(1435),
  [4868] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4870] = {.count = 1, .reusable = true}, SHIFT(1436),
  [4872] = {.count = 1, .reusable = true}, SHIFT(1437),
  [4874] = {.count = 1, .reusable = true}, SHIFT(1438),
  [4876] = {.count = 1, .reusable = true}, SHIFT(1439),
  [4878] = {.count = 1, .reusable = true}, SHIFT(1440),
  [4880] = {.count = 1, .reusable = true}, SHIFT(1441),
  [4882] = {.count = 1, .reusable = false}, SHIFT(1442),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2241),
  [4886] = {.count = 1, .reusable = true}, SHIFT(1445),
  [4888] = {.count = 1, .reusable = true}, SHIFT(1449),
  [4890] = {.count = 1, .reusable = false}, SHIFT(1812),
  [4892] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4894] = {.count = 1, .reusable = false}, SHIFT(1814),
  [4896] = {.count = 1, .reusable = false}, SHIFT(2424),
  [4898] = {.count = 1, .reusable = false}, SHIFT(2425),
  [4900] = {.count = 1, .reusable = false}, SHIFT(1815),
  [4902] = {.count = 1, .reusable = false}, SHIFT(1984),
  [4904] = {.count = 1, .reusable = false}, SHIFT(1816),
  [4906] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4908] = {.count = 1, .reusable = false}, SHIFT(2426),
  [4910] = {.count = 1, .reusable = true}, SHIFT(1470),
  [4912] = {.count = 1, .reusable = false}, SHIFT(1996),
  [4914] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2377),
  [4918] = {.count = 1, .reusable = true}, SHIFT(2364),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2365),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2798),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2795),
  [4926] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2813),
  [4930] = {.count = 1, .reusable = false}, SHIFT(2005),
  [4932] = {.count = 1, .reusable = true}, SHIFT(1481),
  [4934] = {.count = 1, .reusable = true}, SHIFT(1482),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2436),
  [4938] = {.count = 1, .reusable = true}, SHIFT(1486),
  [4940] = {.count = 1, .reusable = true}, SHIFT(1488),
  [4942] = {.count = 1, .reusable = true}, SHIFT(1489),
  [4944] = {.count = 1, .reusable = true}, SHIFT(1490),
  [4946] = {.count = 1, .reusable = true}, SHIFT(1493),
  [4948] = {.count = 1, .reusable = true}, SHIFT(1766),
  [4950] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4952] = {.count = 1, .reusable = true}, SHIFT(1498),
  [4954] = {.count = 1, .reusable = true}, SHIFT(1501),
  [4956] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4958] = {.count = 1, .reusable = true}, SHIFT(1503),
  [4960] = {.count = 1, .reusable = true}, SHIFT(1504),
  [4962] = {.count = 1, .reusable = true}, SHIFT(1508),
  [4964] = {.count = 1, .reusable = true}, SHIFT(1511),
  [4966] = {.count = 1, .reusable = true}, SHIFT(1512),
  [4968] = {.count = 1, .reusable = true}, SHIFT(1513),
  [4970] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4972] = {.count = 1, .reusable = true}, SHIFT(1516),
  [4974] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4976] = {.count = 1, .reusable = true}, SHIFT(1517),
  [4978] = {.count = 1, .reusable = true}, SHIFT(1525),
  [4980] = {.count = 1, .reusable = true}, SHIFT(1526),
  [4982] = {.count = 1, .reusable = true}, SHIFT(1533),
  [4984] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(1924),
  [4987] = {.count = 1, .reusable = true}, SHIFT(1534),
  [4989] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4991] = {.count = 1, .reusable = false}, SHIFT(2120),
  [4993] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4995] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4997] = {.count = 1, .reusable = true}, SHIFT(1537),
  [4999] = {.count = 1, .reusable = false}, SHIFT(2047),
  [5001] = {.count = 1, .reusable = false}, SHIFT(2049),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2150),
  [5005] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(1680),
  [5008] = {.count = 1, .reusable = true}, SHIFT(1538),
  [5010] = {.count = 1, .reusable = true}, SHIFT(1546),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2066),
  [5014] = {.count = 1, .reusable = true}, SHIFT(1549),
  [5016] = {.count = 1, .reusable = true}, SHIFT(1550),
  [5018] = {.count = 1, .reusable = true}, SHIFT(1551),
  [5020] = {.count = 1, .reusable = true}, SHIFT(1552),
  [5022] = {.count = 1, .reusable = true}, SHIFT(1554),
  [5024] = {.count = 1, .reusable = true}, SHIFT(1786),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2071),
  [5028] = {.count = 1, .reusable = true}, SHIFT(1558),
  [5030] = {.count = 1, .reusable = true}, SHIFT(1559),
  [5032] = {.count = 1, .reusable = true}, SHIFT(1561),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2072),
  [5036] = {.count = 1, .reusable = true}, SHIFT(1564),
  [5038] = {.count = 1, .reusable = true}, SHIFT(1565),
  [5040] = {.count = 1, .reusable = true}, SHIFT(1566),
  [5042] = {.count = 1, .reusable = true}, SHIFT(1568),
  [5044] = {.count = 1, .reusable = true}, SHIFT(1570),
  [5046] = {.count = 1, .reusable = true}, SHIFT(1528),
  [5048] = {.count = 1, .reusable = true}, SHIFT(2023),
  [5050] = {.count = 1, .reusable = true}, SHIFT(1576),
  [5052] = {.count = 1, .reusable = true}, SHIFT(2084),
  [5054] = {.count = 1, .reusable = true}, SHIFT(1580),
  [5056] = {.count = 1, .reusable = true}, SHIFT(1581),
  [5058] = {.count = 1, .reusable = true}, SHIFT(1584),
  [5060] = {.count = 1, .reusable = true}, SHIFT(1585),
  [5062] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(1700),
  [5065] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(1707),
  [5068] = {.count = 1, .reusable = true}, SHIFT(1587),
  [5070] = {.count = 1, .reusable = true}, SHIFT(1588),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2093),
  [5074] = {.count = 1, .reusable = true}, SHIFT(1597),
  [5076] = {.count = 1, .reusable = true}, SHIFT(1599),
  [5078] = {.count = 1, .reusable = true}, SHIFT(1601),
  [5080] = {.count = 1, .reusable = true}, SHIFT(1602),
  [5082] = {.count = 1, .reusable = true}, SHIFT(1796),
  [5084] = {.count = 1, .reusable = true}, SHIFT(1605),
  [5086] = {.count = 1, .reusable = true}, SHIFT(2095),
  [5088] = {.count = 1, .reusable = true}, SHIFT(1607),
  [5090] = {.count = 1, .reusable = true}, SHIFT(1577),
  [5092] = {.count = 1, .reusable = true}, SHIFT(1582),
  [5094] = {.count = 1, .reusable = true}, SHIFT(1615),
  [5096] = {.count = 1, .reusable = true}, SHIFT(1618),
  [5098] = {.count = 1, .reusable = true}, SHIFT(1620),
  [5100] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(1717),
  [5103] = {.count = 1, .reusable = true}, SHIFT(1624),
  [5105] = {.count = 1, .reusable = true}, SHIFT(2102),
  [5107] = {.count = 1, .reusable = true}, SHIFT(1627),
  [5109] = {.count = 1, .reusable = true}, SHIFT(1616),
  [5111] = {.count = 1, .reusable = true}, SHIFT(1619),
  [5113] = {.count = 1, .reusable = true}, SHIFT(1632),
  [5115] = {.count = 1, .reusable = true}, SHIFT(1631),
  [5117] = {.count = 1, .reusable = false}, SHIFT(1663),
  [5119] = {.count = 1, .reusable = false}, SHIFT(1665),
  [5121] = {.count = 1, .reusable = false}, SHIFT(2522),
  [5123] = {.count = 1, .reusable = false}, SHIFT(1666),
  [5125] = {.count = 1, .reusable = false}, SHIFT(1667),
  [5127] = {.count = 1, .reusable = false}, SHIFT(1664),
  [5129] = {.count = 1, .reusable = false}, SHIFT(2521),
  [5131] = {.count = 1, .reusable = false}, SHIFT(2123),
  [5133] = {.count = 1, .reusable = true}, SHIFT(1664),
  [5135] = {.count = 1, .reusable = false}, SHIFT(2524),
  [5137] = {.count = 1, .reusable = true}, SHIFT(1771),
  [5139] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(2112),
  [5142] = {.count = 1, .reusable = false}, SHIFT(1693),
  [5144] = {.count = 1, .reusable = true}, SHIFT(1694),
  [5146] = {.count = 1, .reusable = false}, SHIFT(2146),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5150] = {.count = 1, .reusable = false}, SHIFT(1641),
  [5152] = {.count = 1, .reusable = true}, SHIFT(1642),
  [5154] = {.count = 1, .reusable = false}, SHIFT(2151),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5158] = {.count = 1, .reusable = false}, SHIFT(2154),
  [5160] = {.count = 1, .reusable = false}, SHIFT(2784),
  [5162] = {.count = 1, .reusable = false}, SHIFT(2161),
  [5164] = {.count = 1, .reusable = true}, SHIFT(1654),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5168] = {.count = 1, .reusable = false}, SHIFT(1656),
  [5170] = {.count = 1, .reusable = true}, SHIFT(1657),
  [5172] = {.count = 1, .reusable = true}, SHIFT(1659),
  [5174] = {.count = 1, .reusable = true}, SHIFT(1660),
  [5176] = {.count = 1, .reusable = true}, SHIFT(1661),
  [5178] = {.count = 1, .reusable = false}, SHIFT(1662),
  [5180] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5182] = {.count = 1, .reusable = true}, SHIFT(1673),
  [5184] = {.count = 1, .reusable = true}, SHIFT(1675),
  [5186] = {.count = 1, .reusable = true}, SHIFT(1676),
  [5188] = {.count = 1, .reusable = true}, SHIFT(1677),
  [5190] = {.count = 1, .reusable = true}, SHIFT(1680),
  [5192] = {.count = 1, .reusable = true}, SHIFT(1495),
  [5194] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5196] = {.count = 1, .reusable = true}, SHIFT(1685),
  [5198] = {.count = 1, .reusable = true}, SHIFT(1686),
  [5200] = {.count = 1, .reusable = true}, SHIFT(1687),
  [5202] = {.count = 1, .reusable = true}, SHIFT(1688),
  [5204] = {.count = 1, .reusable = true}, SHIFT(1690),
  [5206] = {.count = 1, .reusable = true}, SHIFT(1691),
  [5208] = {.count = 1, .reusable = true}, SHIFT(1695),
  [5210] = {.count = 1, .reusable = true}, SHIFT(1696),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5214] = {.count = 1, .reusable = true}, SHIFT(1698),
  [5216] = {.count = 1, .reusable = true}, SHIFT(1699),
  [5218] = {.count = 1, .reusable = true}, SHIFT(1700),
  [5220] = {.count = 1, .reusable = true}, SHIFT(1701),
  [5222] = {.count = 1, .reusable = true}, SHIFT(1703),
  [5224] = {.count = 1, .reusable = true}, SHIFT(1557),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5228] = {.count = 1, .reusable = true}, SHIFT(1707),
  [5230] = {.count = 1, .reusable = true}, SHIFT(1708),
  [5232] = {.count = 1, .reusable = true}, SHIFT(1709),
  [5234] = {.count = 1, .reusable = true}, SHIFT(1710),
  [5236] = {.count = 1, .reusable = true}, SHIFT(1711),
  [5238] = {.count = 1, .reusable = true}, SHIFT(1712),
  [5240] = {.count = 1, .reusable = true}, SHIFT(1713),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5244] = {.count = 1, .reusable = true}, SHIFT(1714),
  [5246] = {.count = 1, .reusable = true}, SHIFT(1715),
  [5248] = {.count = 1, .reusable = true}, SHIFT(1717),
  [5250] = {.count = 1, .reusable = true}, SHIFT(1718),
  [5252] = {.count = 1, .reusable = true}, SHIFT(1603),
  [5254] = {.count = 1, .reusable = true}, SHIFT(1722),
  [5256] = {.count = 1, .reusable = true}, SHIFT(1723),
  [5258] = {.count = 1, .reusable = true}, SHIFT(1724),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5262] = {.count = 1, .reusable = true}, SHIFT(1726),
  [5264] = {.count = 1, .reusable = false}, SHIFT(2519),
  [5266] = {.count = 1, .reusable = false}, SHIFT(2520),
  [5268] = {.count = 1, .reusable = false}, SHIFT(2604),
  [5270] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5272] = {.count = 1, .reusable = false}, SHIFT(2523),
  [5274] = {.count = 1, .reusable = false}, SHIFT(2218),
  [5276] = {.count = 1, .reusable = false}, SHIFT(1668),
  [5278] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(2210),
  [5281] = {.count = 1, .reusable = false}, SHIFT(1773),
  [5283] = {.count = 1, .reusable = true}, SHIFT(1774),
  [5285] = {.count = 1, .reusable = false}, SHIFT(2237),
  [5287] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5289] = {.count = 1, .reusable = false}, SHIFT(1730),
  [5291] = {.count = 1, .reusable = false}, SHIFT(1892),
  [5293] = {.count = 1, .reusable = false}, SHIFT(1893),
  [5295] = {.count = 1, .reusable = false}, SHIFT(1894),
  [5297] = {.count = 1, .reusable = false}, SHIFT(1895),
  [5299] = {.count = 1, .reusable = false}, SHIFT(1896),
  [5301] = {.count = 1, .reusable = false}, SHIFT(1897),
  [5303] = {.count = 1, .reusable = true}, SHIFT(1731),
  [5305] = {.count = 1, .reusable = false}, SHIFT(1898),
  [5307] = {.count = 1, .reusable = false}, SHIFT(1899),
  [5309] = {.count = 1, .reusable = false}, SHIFT(1900),
  [5311] = {.count = 1, .reusable = false}, SHIFT(1901),
  [5313] = {.count = 1, .reusable = false}, SHIFT(1902),
  [5315] = {.count = 1, .reusable = false}, SHIFT(1903),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2240),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5321] = {.count = 1, .reusable = false}, SHIFT(2242),
  [5323] = {.count = 1, .reusable = false}, SHIFT(2791),
  [5325] = {.count = 1, .reusable = false}, SHIFT(1743),
  [5327] = {.count = 1, .reusable = true}, SHIFT(1744),
  [5329] = {.count = 1, .reusable = true}, SHIFT(2122),
  [5331] = {.count = 1, .reusable = true}, SHIFT(1747),
  [5333] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5335] = {.count = 1, .reusable = true}, SHIFT(1757),
  [5337] = {.count = 1, .reusable = true}, SHIFT(1759),
  [5339] = {.count = 1, .reusable = true}, SHIFT(1760),
  [5341] = {.count = 1, .reusable = true}, SHIFT(1761),
  [5343] = {.count = 1, .reusable = true}, SHIFT(1764),
  [5345] = {.count = 1, .reusable = true}, SHIFT(1682),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5349] = {.count = 1, .reusable = true}, SHIFT(1769),
  [5351] = {.count = 1, .reusable = true}, SHIFT(1770),
  [5353] = {.count = 1, .reusable = true}, SHIFT(1772),
  [5355] = {.count = 1, .reusable = true}, SHIFT(1775),
  [5357] = {.count = 1, .reusable = true}, SHIFT(1776),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5361] = {.count = 1, .reusable = true}, SHIFT(1778),
  [5363] = {.count = 1, .reusable = true}, SHIFT(1779),
  [5365] = {.count = 1, .reusable = true}, SHIFT(1780),
  [5367] = {.count = 1, .reusable = true}, SHIFT(1781),
  [5369] = {.count = 1, .reusable = true}, SHIFT(1783),
  [5371] = {.count = 1, .reusable = true}, SHIFT(1706),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5375] = {.count = 1, .reusable = true}, SHIFT(1787),
  [5377] = {.count = 1, .reusable = true}, SHIFT(1788),
  [5379] = {.count = 1, .reusable = true}, SHIFT(1789),
  [5381] = {.count = 1, .reusable = true}, SHIFT(1790),
  [5383] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5385] = {.count = 1, .reusable = true}, SHIFT(1791),
  [5387] = {.count = 1, .reusable = true}, SHIFT(1792),
  [5389] = {.count = 1, .reusable = true}, SHIFT(1794),
  [5391] = {.count = 1, .reusable = true}, SHIFT(1795),
  [5393] = {.count = 1, .reusable = true}, SHIFT(1719),
  [5395] = {.count = 1, .reusable = true}, SHIFT(1798),
  [5397] = {.count = 1, .reusable = true}, SHIFT(1799),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5401] = {.count = 1, .reusable = true}, SHIFT(1801),
  [5403] = {.count = 1, .reusable = false}, SHIFT(1825),
  [5405] = {.count = 1, .reusable = true}, SHIFT(1826),
  [5407] = {.count = 1, .reusable = false}, SHIFT(2283),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2283),
  [5411] = {.count = 1, .reusable = false}, SHIFT(1802),
  [5413] = {.count = 1, .reusable = false}, SHIFT(2286),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5417] = {.count = 1, .reusable = false}, SHIFT(1808),
  [5419] = {.count = 1, .reusable = true}, SHIFT(1809),
  [5421] = {.count = 1, .reusable = true}, SHIFT(1746),
  [5423] = {.count = 1, .reusable = true}, SHIFT(1811),
  [5425] = {.count = 1, .reusable = true}, SHIFT(1818),
  [5427] = {.count = 1, .reusable = true}, SHIFT(1819),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5431] = {.count = 1, .reusable = true}, SHIFT(1822),
  [5433] = {.count = 1, .reusable = true}, SHIFT(1823),
  [5435] = {.count = 1, .reusable = true}, SHIFT(1827),
  [5437] = {.count = 1, .reusable = true}, SHIFT(1829),
  [5439] = {.count = 1, .reusable = true}, SHIFT(1831),
  [5441] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5443] = {.count = 1, .reusable = true}, SHIFT(1832),
  [5445] = {.count = 1, .reusable = true}, SHIFT(1833),
  [5447] = {.count = 1, .reusable = true}, SHIFT(1835),
  [5449] = {.count = 1, .reusable = true}, SHIFT(1836),
  [5451] = {.count = 1, .reusable = true}, SHIFT(1838),
  [5453] = {.count = 1, .reusable = false}, SHIFT(2303),
  [5455] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5457] = {.count = 1, .reusable = false}, SHIFT(1840),
  [5459] = {.count = 1, .reusable = false}, SHIFT(2304),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5463] = {.count = 1, .reusable = false}, SHIFT(1841),
  [5465] = {.count = 1, .reusable = true}, SHIFT(1843),
  [5467] = {.count = 1, .reusable = true}, SHIFT(1849),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5471] = {.count = 1, .reusable = true}, SHIFT(1851),
  [5473] = {.count = 1, .reusable = true}, SHIFT(1852),
  [5475] = {.count = 1, .reusable = true}, SHIFT(1853),
  [5477] = {.count = 1, .reusable = true}, SHIFT(1855),
  [5479] = {.count = 1, .reusable = true}, SHIFT(1856),
  [5481] = {.count = 1, .reusable = true}, SHIFT(1857),
  [5483] = {.count = 1, .reusable = false}, SHIFT(2352),
  [5485] = {.count = 1, .reusable = true}, SHIFT(1878),
  [5487] = {.count = 1, .reusable = true}, SHIFT(1879),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2796),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5493] = {.count = 1, .reusable = false}, SHIFT(1886),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5497] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5499] = {.count = 1, .reusable = false}, SHIFT(2699),
  [5501] = {.count = 1, .reusable = false}, SHIFT(1917),
  [5503] = {.count = 1, .reusable = true}, SHIFT(1928),
  [5505] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5507] = {.count = 1, .reusable = false}, SHIFT(1929),
  [5509] = {.count = 1, .reusable = true}, SHIFT(1929),
  [5511] = {.count = 1, .reusable = false}, SHIFT(1930),
  [5513] = {.count = 1, .reusable = true}, SHIFT(1930),
  [5515] = {.count = 1, .reusable = false}, SHIFT(1931),
  [5517] = {.count = 1, .reusable = true}, SHIFT(1931),
  [5519] = {.count = 1, .reusable = false}, SHIFT(1932),
  [5521] = {.count = 1, .reusable = true}, SHIFT(1932),
  [5523] = {.count = 1, .reusable = false}, SHIFT(1933),
  [5525] = {.count = 1, .reusable = true}, SHIFT(1933),
  [5527] = {.count = 1, .reusable = false}, SHIFT(1934),
  [5529] = {.count = 1, .reusable = true}, SHIFT(1934),
  [5531] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 4),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5535] = {.count = 1, .reusable = false}, SHIFT(296),
  [5537] = {.count = 1, .reusable = false}, SHIFT(298),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2697),
  [5541] = {.count = 1, .reusable = false}, SHIFT(2698),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5545] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5547] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(1924),
  [5550] = {.count = 1, .reusable = true}, SHIFT(1941),
  [5552] = {.count = 1, .reusable = true}, SHIFT(1942),
  [5554] = {.count = 1, .reusable = false}, SHIFT(1945),
  [5556] = {.count = 1, .reusable = true}, SHIFT(1945),
  [5558] = {.count = 1, .reusable = false}, SHIFT(1958),
  [5560] = {.count = 1, .reusable = true}, SHIFT(1958),
  [5562] = {.count = 1, .reusable = true}, SHIFT(1959),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5566] = {.count = 1, .reusable = true}, SHIFT(1967),
  [5568] = {.count = 1, .reusable = true}, SHIFT(1971),
  [5570] = {.count = 1, .reusable = false}, SHIFT(1979),
  [5572] = {.count = 1, .reusable = false}, SHIFT(1983),
  [5574] = {.count = 1, .reusable = true}, SHIFT(1983),
  [5576] = {.count = 1, .reusable = true}, SHIFT(1984),
  [5578] = {.count = 1, .reusable = false}, SHIFT(1985),
  [5580] = {.count = 1, .reusable = true}, SHIFT(1985),
  [5582] = {.count = 1, .reusable = false}, SHIFT(1986),
  [5584] = {.count = 1, .reusable = true}, SHIFT(1986),
  [5586] = {.count = 1, .reusable = false}, SHIFT(1987),
  [5588] = {.count = 1, .reusable = true}, SHIFT(1987),
  [5590] = {.count = 1, .reusable = false}, SHIFT(1988),
  [5592] = {.count = 1, .reusable = true}, SHIFT(1988),
  [5594] = {.count = 1, .reusable = false}, SHIFT(1989),
  [5596] = {.count = 1, .reusable = true}, SHIFT(1989),
  [5598] = {.count = 1, .reusable = false}, SHIFT(1993),
  [5600] = {.count = 1, .reusable = true}, SHIFT(1993),
  [5602] = {.count = 1, .reusable = false}, SHIFT(1994),
  [5604] = {.count = 1, .reusable = true}, SHIFT(1994),
  [5606] = {.count = 1, .reusable = false}, SHIFT(1997),
  [5608] = {.count = 1, .reusable = true}, SHIFT(1997),
  [5610] = {.count = 1, .reusable = false}, SHIFT(1998),
  [5612] = {.count = 1, .reusable = true}, SHIFT(1998),
  [5614] = {.count = 1, .reusable = false}, SHIFT(1999),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5618] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2669),
  [5624] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5626] = {.count = 1, .reusable = false}, SHIFT(2395),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5634] = {.count = 1, .reusable = false}, SHIFT(2800),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2019),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2718),
  [5642] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 45),
  [5644] = {.count = 1, .reusable = false}, SHIFT(2633),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2631),
  [5648] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2028),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2032),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2033),
  [5656] = {.count = 1, .reusable = false}, SHIFT(2036),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2036),
  [5660] = {.count = 1, .reusable = false}, SHIFT(2037),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2037),
  [5664] = {.count = 1, .reusable = false}, SHIFT(2040),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2040),
  [5668] = {.count = 1, .reusable = false}, SHIFT(2041),
  [5670] = {.count = 1, .reusable = false}, SHIFT(2042),
  [5672] = {.count = 1, .reusable = true}, SHIFT(2045),
  [5674] = {.count = 1, .reusable = false}, SHIFT(2451),
  [5676] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5678] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5680] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5682] = {.count = 1, .reusable = false}, SHIFT(2374),
  [5684] = {.count = 1, .reusable = false}, SHIFT(2375),
  [5686] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2251),
  [5690] = {.count = 1, .reusable = false}, SHIFT(2052),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2053),
  [5694] = {.count = 1, .reusable = false}, SHIFT(2056),
  [5696] = {.count = 1, .reusable = true}, SHIFT(2056),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5700] = {.count = 1, .reusable = false}, SHIFT(2461),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2076),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5708] = {.count = 1, .reusable = false}, SHIFT(2086),
  [5710] = {.count = 1, .reusable = false}, SHIFT(2087),
  [5712] = {.count = 1, .reusable = true}, SHIFT(2087),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5720] = {.count = 1, .reusable = true}, SHIFT(2096),
  [5722] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 45),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2575),
  [5734] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5738] = {.count = 1, .reusable = false}, SHIFT(2582),
  [5740] = {.count = 1, .reusable = false}, SHIFT(2583),
  [5742] = {.count = 1, .reusable = false}, SHIFT(2483),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2583),
  [5746] = {.count = 1, .reusable = false}, SHIFT(2584),
  [5748] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5750] = {.count = 1, .reusable = false}, SHIFT(2589),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5754] = {.count = 1, .reusable = false}, SHIFT(2113),
  [5756] = {.count = 1, .reusable = true}, SHIFT(2113),
  [5758] = {.count = 1, .reusable = false}, SHIFT(2114),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2114),
  [5762] = {.count = 1, .reusable = false}, SHIFT(2115),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2115),
  [5766] = {.count = 1, .reusable = false}, SHIFT(2116),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2116),
  [5770] = {.count = 1, .reusable = false}, SHIFT(2117),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2117),
  [5774] = {.count = 1, .reusable = false}, SHIFT(2118),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2118),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5780] = {.count = 1, .reusable = false}, SHIFT(2574),
  [5782] = {.count = 1, .reusable = false}, SHIFT(2535),
  [5784] = {.count = 1, .reusable = false}, SHIFT(2536),
  [5786] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(2112),
  [5789] = {.count = 1, .reusable = false}, SHIFT(2121),
  [5791] = {.count = 1, .reusable = true}, SHIFT(2121),
  [5793] = {.count = 1, .reusable = true}, SHIFT(2123),
  [5795] = {.count = 1, .reusable = false}, SHIFT(2124),
  [5797] = {.count = 1, .reusable = true}, SHIFT(2124),
  [5799] = {.count = 1, .reusable = false}, SHIFT(2125),
  [5801] = {.count = 1, .reusable = true}, SHIFT(2125),
  [5803] = {.count = 1, .reusable = false}, SHIFT(2126),
  [5805] = {.count = 1, .reusable = true}, SHIFT(2126),
  [5807] = {.count = 1, .reusable = false}, SHIFT(2127),
  [5809] = {.count = 1, .reusable = true}, SHIFT(2127),
  [5811] = {.count = 1, .reusable = false}, SHIFT(2132),
  [5813] = {.count = 1, .reusable = true}, SHIFT(2132),
  [5815] = {.count = 1, .reusable = false}, SHIFT(2133),
  [5817] = {.count = 1, .reusable = true}, SHIFT(2133),
  [5819] = {.count = 1, .reusable = false}, SHIFT(2134),
  [5821] = {.count = 1, .reusable = true}, SHIFT(2134),
  [5823] = {.count = 1, .reusable = false}, SHIFT(2135),
  [5825] = {.count = 1, .reusable = true}, SHIFT(2135),
  [5827] = {.count = 1, .reusable = false}, SHIFT(2136),
  [5829] = {.count = 1, .reusable = true}, SHIFT(2136),
  [5831] = {.count = 1, .reusable = false}, SHIFT(2137),
  [5833] = {.count = 1, .reusable = true}, SHIFT(2137),
  [5835] = {.count = 1, .reusable = false}, SHIFT(2138),
  [5837] = {.count = 1, .reusable = true}, SHIFT(2138),
  [5839] = {.count = 1, .reusable = false}, SHIFT(2527),
  [5841] = {.count = 1, .reusable = false}, SHIFT(2496),
  [5843] = {.count = 1, .reusable = false}, SHIFT(2585),
  [5845] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5847] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5849] = {.count = 1, .reusable = false}, SHIFT(2588),
  [5851] = {.count = 1, .reusable = false}, SHIFT(2587),
  [5853] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5855] = {.count = 1, .reusable = false}, SHIFT(2139),
  [5857] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5861] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5863] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5865] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5869] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5871] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5873] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5875] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5879] = {.count = 1, .reusable = false}, SHIFT(2153),
  [5881] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5885] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5889] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5891] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5893] = {.count = 1, .reusable = false}, SHIFT(2188),
  [5895] = {.count = 1, .reusable = false}, SHIFT(2189),
  [5897] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5901] = {.count = 1, .reusable = false}, SHIFT(2204),
  [5903] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5905] = {.count = 1, .reusable = false}, SHIFT(2637),
  [5907] = {.count = 1, .reusable = false}, SHIFT(2778),
  [5909] = {.count = 1, .reusable = false}, SHIFT(2638),
  [5911] = {.count = 1, .reusable = false}, SHIFT(2564),
  [5913] = {.count = 1, .reusable = false}, SHIFT(2663),
  [5915] = {.count = 1, .reusable = false}, SHIFT(2639),
  [5917] = {.count = 1, .reusable = false}, SHIFT(2640),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5921] = {.count = 1, .reusable = true}, SHIFT(2778),
  [5923] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5925] = {.count = 1, .reusable = false}, SHIFT(2759),
  [5927] = {.count = 1, .reusable = false}, SHIFT(2641),
  [5929] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5931] = {.count = 1, .reusable = false}, SHIFT(2642),
  [5933] = {.count = 1, .reusable = false}, SHIFT(2779),
  [5935] = {.count = 1, .reusable = false}, SHIFT(2567),
  [5937] = {.count = 1, .reusable = false}, SHIFT(1874),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2779),
  [5941] = {.count = 1, .reusable = false}, SHIFT(2780),
  [5943] = {.count = 1, .reusable = true}, SHIFT(2780),
  [5945] = {.count = 1, .reusable = false}, SHIFT(2781),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2781),
  [5949] = {.count = 1, .reusable = false}, SHIFT(2211),
  [5951] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5953] = {.count = 1, .reusable = false}, SHIFT(2212),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5957] = {.count = 1, .reusable = false}, SHIFT(2213),
  [5959] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5961] = {.count = 1, .reusable = false}, SHIFT(2214),
  [5963] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5965] = {.count = 1, .reusable = false}, SHIFT(2215),
  [5967] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5969] = {.count = 1, .reusable = false}, SHIFT(2216),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5973] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(2210),
  [5976] = {.count = 1, .reusable = false}, SHIFT(2217),
  [5978] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5980] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5982] = {.count = 1, .reusable = false}, SHIFT(2219),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2220),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2221),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5994] = {.count = 1, .reusable = false}, SHIFT(2222),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5998] = {.count = 1, .reusable = false}, SHIFT(2225),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2225),
  [6002] = {.count = 1, .reusable = false}, SHIFT(2226),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2226),
  [6006] = {.count = 1, .reusable = false}, SHIFT(2227),
  [6008] = {.count = 1, .reusable = true}, SHIFT(2227),
  [6010] = {.count = 1, .reusable = false}, SHIFT(2228),
  [6012] = {.count = 1, .reusable = true}, SHIFT(2228),
  [6014] = {.count = 1, .reusable = false}, SHIFT(2229),
  [6016] = {.count = 1, .reusable = true}, SHIFT(2229),
  [6018] = {.count = 1, .reusable = false}, SHIFT(2230),
  [6020] = {.count = 1, .reusable = true}, SHIFT(2230),
  [6022] = {.count = 1, .reusable = false}, SHIFT(2231),
  [6024] = {.count = 1, .reusable = true}, SHIFT(2231),
  [6026] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6028] = {.count = 1, .reusable = false}, SHIFT(2636),
  [6030] = {.count = 1, .reusable = true}, SHIFT(2634),
  [6032] = {.count = 1, .reusable = false}, SHIFT(2608),
  [6034] = {.count = 1, .reusable = false}, SHIFT(2580),
  [6036] = {.count = 1, .reusable = false}, SHIFT(2232),
  [6038] = {.count = 1, .reusable = true}, SHIFT(2232),
  [6040] = {.count = 1, .reusable = true}, SHIFT(2580),
  [6042] = {.count = 1, .reusable = true}, SHIFT(2597),
  [6044] = {.count = 1, .reusable = true}, SHIFT(2599),
  [6046] = {.count = 1, .reusable = true}, SHIFT(2600),
  [6048] = {.count = 1, .reusable = true}, SHIFT(2601),
  [6050] = {.count = 1, .reusable = true}, SHIFT(2607),
  [6052] = {.count = 1, .reusable = false}, SHIFT(2614),
  [6054] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6056] = {.count = 1, .reusable = true}, SHIFT(2184),
  [6058] = {.count = 1, .reusable = false}, SHIFT(2263),
  [6060] = {.count = 1, .reusable = false}, SHIFT(2264),
  [6062] = {.count = 1, .reusable = true}, SHIFT(2265),
  [6064] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6066] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6068] = {.count = 1, .reusable = false}, SHIFT(2761),
  [6070] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6072] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6074] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6076] = {.count = 1, .reusable = false}, SHIFT(2754),
  [6078] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6080] = {.count = 1, .reusable = false}, SHIFT(2763),
  [6082] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6084] = {.count = 1, .reusable = false}, SHIFT(2764),
  [6086] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6088] = {.count = 1, .reusable = false}, SHIFT(2665),
  [6090] = {.count = 1, .reusable = false}, SHIFT(2666),
  [6092] = {.count = 1, .reusable = false}, SHIFT(2765),
  [6094] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6096] = {.count = 1, .reusable = false}, SHIFT(2766),
  [6098] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6100] = {.count = 1, .reusable = false}, SHIFT(2767),
  [6102] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6104] = {.count = 1, .reusable = false}, SHIFT(2768),
  [6106] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6108] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6110] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6112] = {.count = 1, .reusable = false}, SHIFT(2770),
  [6114] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6116] = {.count = 1, .reusable = false}, SHIFT(2771),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6120] = {.count = 1, .reusable = false}, SHIFT(2772),
  [6122] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6124] = {.count = 1, .reusable = false}, SHIFT(2755),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6128] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6132] = {.count = 1, .reusable = false}, SHIFT(2756),
  [6134] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6136] = {.count = 1, .reusable = false}, SHIFT(2757),
  [6138] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6140] = {.count = 1, .reusable = false}, SHIFT(2758),
  [6142] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6144] = {.count = 1, .reusable = false}, SHIFT(2662),
  [6146] = {.count = 1, .reusable = false}, SHIFT(2777),
  [6148] = {.count = 1, .reusable = false}, SHIFT(2774),
  [6150] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6152] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6154] = {.count = 1, .reusable = true}, SHIFT(2654),
  [6156] = {.count = 1, .reusable = true}, SHIFT(2656),
  [6158] = {.count = 1, .reusable = true}, SHIFT(2657),
  [6160] = {.count = 1, .reusable = true}, SHIFT(2658),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2661),
  [6164] = {.count = 1, .reusable = false}, SHIFT(2668),
  [6166] = {.count = 1, .reusable = true}, SHIFT(2668),
  [6168] = {.count = 1, .reusable = false}, SHIFT(2342),
  [6170] = {.count = 1, .reusable = false}, SHIFT(2341),
  [6172] = {.count = 1, .reusable = true}, SHIFT(2349),
  [6174] = {.count = 1, .reusable = false}, SHIFT(2356),
  [6176] = {.count = 1, .reusable = false}, SHIFT(2357),
  [6178] = {.count = 1, .reusable = true}, SHIFT(2357),
  [6180] = {.count = 1, .reusable = true}, SHIFT(2358),
  [6182] = {.count = 1, .reusable = false}, SHIFT(2361),
  [6184] = {.count = 1, .reusable = true}, SHIFT(2361),
  [6186] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6188] = {.count = 1, .reusable = false}, SHIFT(2367),
  [6190] = {.count = 1, .reusable = true}, SHIFT(2368),
  [6192] = {.count = 1, .reusable = true}, SHIFT(2371),
  [6194] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6196] = {.count = 1, .reusable = false}, SHIFT(2380),
  [6198] = {.count = 1, .reusable = true}, SHIFT(2380),
  [6200] = {.count = 1, .reusable = false}, SHIFT(2388),
  [6202] = {.count = 1, .reusable = true}, SHIFT(2389),
  [6204] = {.count = 1, .reusable = false}, SHIFT(2390),
  [6206] = {.count = 1, .reusable = true}, SHIFT(2406),
  [6208] = {.count = 1, .reusable = true}, SHIFT(2407),
  [6210] = {.count = 1, .reusable = false}, SHIFT(2408),
  [6212] = {.count = 1, .reusable = true}, SHIFT(2408),
  [6214] = {.count = 1, .reusable = false}, SHIFT(2409),
  [6216] = {.count = 1, .reusable = false}, SHIFT(2709),
  [6218] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6220] = {.count = 1, .reusable = true}, SHIFT(2412),
  [6222] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6226] = {.count = 1, .reusable = true}, SHIFT(2413),
  [6228] = {.count = 1, .reusable = true}, SHIFT(2414),
  [6230] = {.count = 1, .reusable = true}, SHIFT(2416),
  [6232] = {.count = 1, .reusable = true}, SHIFT(2417),
  [6234] = {.count = 1, .reusable = true}, SHIFT(2418),
  [6236] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6238] = {.count = 1, .reusable = true}, SHIFT(2419),
  [6240] = {.count = 1, .reusable = false}, SHIFT(2714),
  [6242] = {.count = 1, .reusable = false}, SHIFT(2420),
  [6244] = {.count = 1, .reusable = true}, SHIFT(2422),
  [6246] = {.count = 1, .reusable = true}, SHIFT(2423),
  [6248] = {.count = 1, .reusable = false}, SHIFT(2429),
  [6250] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [6252] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(2674),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2438),
  [6257] = {.count = 1, .reusable = true}, SHIFT(2443),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6261] = {.count = 1, .reusable = false}, SHIFT(2648),
  [6263] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6265] = {.count = 1, .reusable = false}, SHIFT(2650),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6269] = {.count = 1, .reusable = false}, SHIFT(2649),
  [6271] = {.count = 1, .reusable = false}, SHIFT(2647),
  [6273] = {.count = 1, .reusable = false}, SHIFT(2651),
  [6275] = {.count = 1, .reusable = true}, SHIFT(2670),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2648),
  [6279] = {.count = 1, .reusable = false}, SHIFT(2760),
  [6281] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6283] = {.count = 1, .reusable = true}, SHIFT(2446),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2448),
  [6289] = {.count = 1, .reusable = false}, SHIFT(2449),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2450),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2456),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2458),
  [6297] = {.count = 1, .reusable = false}, SHIFT(2462),
  [6299] = {.count = 1, .reusable = false}, SHIFT(2732),
  [6301] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6303] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 45),
  [6305] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [6307] = {.count = 1, .reusable = false}, SHIFT(2734),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2469),
  [6311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(2718),
  [6314] = {.count = 1, .reusable = false}, SHIFT(2738),
  [6316] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6318] = {.count = 1, .reusable = false}, SHIFT(2741),
  [6320] = {.count = 1, .reusable = true}, SHIFT(2478),
  [6322] = {.count = 1, .reusable = false}, SHIFT(2498),
  [6324] = {.count = 1, .reusable = false}, SHIFT(2499),
  [6326] = {.count = 1, .reusable = true}, SHIFT(2499),
  [6328] = {.count = 1, .reusable = false}, SHIFT(2500),
  [6330] = {.count = 1, .reusable = true}, SHIFT(2500),
  [6332] = {.count = 1, .reusable = false}, SHIFT(2506),
  [6334] = {.count = 1, .reusable = true}, SHIFT(2506),
  [6336] = {.count = 1, .reusable = false}, SHIFT(2596),
  [6338] = {.count = 1, .reusable = false}, SHIFT(2598),
  [6340] = {.count = 1, .reusable = false}, SHIFT(2643),
  [6342] = {.count = 1, .reusable = false}, SHIFT(2644),
  [6344] = {.count = 1, .reusable = false}, SHIFT(2751),
  [6346] = {.count = 1, .reusable = false}, SHIFT(2645),
  [6348] = {.count = 1, .reusable = false}, SHIFT(2646),
  [6350] = {.count = 1, .reusable = false}, SHIFT(2602),
  [6352] = {.count = 1, .reusable = false}, SHIFT(2603),
  [6354] = {.count = 1, .reusable = false}, SHIFT(2659),
  [6356] = {.count = 1, .reusable = false}, SHIFT(2660),
  [6358] = {.count = 1, .reusable = false}, SHIFT(2606),
  [6360] = {.count = 1, .reusable = false}, SHIFT(2752),
  [6362] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 25),
  [6364] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [6366] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 29),
  [6368] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 29),
  [6370] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [6372] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(2760),
  [6375] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [6377] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [6379] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 131),
  [6381] = {.count = 1, .reusable = true}, SHIFT(2553),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6387] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(2760),
  [6390] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [6392] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [6394] = {.count = 1, .reusable = true}, SHIFT(2554),
  [6396] = {.count = 1, .reusable = false}, SHIFT(2785),
  [6398] = {.count = 1, .reusable = false}, SHIFT(2555),
  [6400] = {.count = 1, .reusable = false}, SHIFT(2557),
  [6402] = {.count = 1, .reusable = false}, SHIFT(2561),
  [6404] = {.count = 1, .reusable = false}, SHIFT(2627),
  [6406] = {.count = 1, .reusable = false}, SHIFT(2653),
  [6408] = {.count = 1, .reusable = false}, SHIFT(2655),
  [6410] = {.count = 1, .reusable = true}, SHIFT(2689),
  [6412] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6414] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6416] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6418] = {.count = 1, .reusable = false}, SHIFT(2715),
  [6420] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6422] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6424] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6426] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6428] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6430] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6432] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6434] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6436] = {.count = 1, .reusable = true}, SHIFT(2787),
  [6438] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6440] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6442] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6444] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6446] = {.count = 1, .reusable = false}, SHIFT(2835),
  [6448] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6450] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6452] = {.count = 1, .reusable = true}, SHIFT(2821),
};

void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
  };
  return &language;
}
